<?php
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : AddBankAndNominiDatail
|   MODEL USE : registration_model
|   DATE : 03/10/2016
|   AUTHOER : amit meena
|   COMMENT : this function is used to add bank detail into database
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class AddBankAndNominiDatail extends CI_Controller
{
    
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
        $this->load->model('registration/registration_model', 'registration_model');
    }
    
    /*
    ------------------------------------------------------------------------------------------------------------
    |   FUNTION NAME : index
    |   DATE : 03/10/2016
    |   COMMENT :  this function is used to load view of add bank detail view
    |   CHECK STATUS : TRUE || true
    ------------------------------------------------------------------------------------------------------------
    */
    public function index()
    {
        $data = array();
        if (isset($_SESSION['investor_id']) && !empty($_SESSION['investor_id'])) {
            $invId                       = $_SESSION["investor_id"];
            $result                      = $this->registration_model->getInvestorDetail($invId);
            $resultBank                  = $this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"]      = $this->common_model->getInvestorStatus($invId);
            $data["bankData"]            = $resultBank;
            $data["row"]                 = $result;
            $result                      = $this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]           = $result;
            $data["overseasDetails"]     = $this->registration_model->getInvestorOverseasDetail($invId);
            $resultNominee               = $this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]         = $resultNominee;
            $data["bankMasterList"]      = $this->registration_model->getbankMasterAll();
            $result                      = $this->registration_model->getInvestorDetail($invId);
            $data["invDetail"]           = $result;
            $data["bankAccountTypeList"] = $this->registration_model->getInvestorBankAccountTypeList();
        } else {
            return redirect(base_url());
        }
        
        if (isset($_SESSION['investor_id']) && !empty($_SESSION['investor_id'])) {
            $this->_loadView('amit_theme/registration/add_bank_and_nom_view', $data);
        } else {
            redirect('registration');
        }
        
    }
    /*
    ------------------------------------------------------------------------------------------
    */
    
    /*
    ------------------------------------------------------------------------------------------------------------
    |   FUNTION NAME : _loadView
    |   DATE : 03/10/2016
    |   COMMENT :  its help to load view and js of add bank detail view
    |   CHECK STATUS : TRUE || true
    ------------------------------------------------------------------------------------------------------------
    */
    
    public function _loadView($view, $data)
    {
        $data["page1"] = false;
        $data["page2"] = true;
        $data["page3"] = false;
        $this->load->view('amit_theme/common/header', $data);
        $data['jsFile'] = 'registration/bankAndNominiDetail.js';
        $this->load->view($view, $data);
        $this->load->view('amit_theme/common/footer', $data);
    }
    /*
    ------------------------------------------------------------------------------------------
    */
    
    /*
    ------------------------------------------------------------------------------------------
    |   USE : addBankDetails
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO INSERT BANK AND NOMINEE DATA INTO THE DATABASE
    ------------------------------------------------------------------------------------------
    */
    public function addBankDetails()
    {
        // encryped fields
        $smsname        = $this->input->post("investorName");
        $investorName   = $this->encrypt->encode(handleString($this->input->post("investorName"))); // encryped fields
        $accountNo      = $this->encrypt->encode($this->input->post("accountNo")); // encryped fields
        $acctHolderName = $this->encrypt->encode($this->input->post("acctHolderName")); // encryped fields
        
        $accountType  = $this->input->post("accountType");
        $bankMasterId = $this->input->post("bankMasterId");
        $branchName   = $this->input->post("branchName");
        $cityName     = $this->input->post("cityName");
        $stateName    = $this->input->post("stateName");
        $ifscCode     = $this->input->post("ifscCode");
        
        $investorId = $_SESSION["investor_id"];
        
        $bankData = array(
            "name" => $investorName,
            "account_number" => $accountNo,
            "account_holder_name" => $acctHolderName,
            "bank_master_id" => $bankMasterId,
            "account_type_id" => $accountType,
            "ifsc_code" => $ifscCode,
            "investor_id" => $investorId,
            "branch_name" => $branchName,
            "branch_city" => $cityName,
            "branch_state" => $stateName
        );
        
        $resultAddBankDetails = $this->registration_model->addInvestorBankDetails($bankData);
        
        
        if ($resultAddBankDetails) {
            $this->registration_model->update_is_inv_table($investorId);
            $this->createInvestorFormPdf($investorId);
            $_SESSION["readyforUpdate"] = true;
            echo '{"success":true}';
            log_message('info', '***** InvestorId : ' . $_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : addBankDetails, Message : add Bank Detail successfully  *****');
        } else {
            echo '{"success":false}';
            log_message('info', '***** InvestorId : ' . $_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : addBankDetails, Message : error  *****');
        }
    }
    /*
    ------------------------------------------------------------------------------------------
    */
    /*
    ------------------------------------------------------------------------------------------
    |   USE : modifyBankDetail
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO UPDATE BANK AND NOMINEE DATA INTO THE DATABASE
    ------------------------------------------------------------------------------------------
    */
    /** Modify investor details **/
    public function modifyBankDetail()
    {
        
        $investorName   = $this->encrypt->encode(handleString($this->input->post("investorName")));
        $accountNo      = $this->encrypt->encode($this->input->post("accountNo"));
        $acctHolderName = $this->encrypt->encode(handleString($this->input->post("acctHolderName")));
        
        $bankMasterId = $this->input->post("bankMasterId");
        $accountType  = $this->input->post("accountType");
        $ifscCode     = $this->input->post("ifscCode");
        $branchName   = $this->input->post("branchName");
        $cityName     = $this->input->post("cityName");
        $stateName    = $this->input->post("stateName");
        
        $investorId = $_SESSION["investor_id"];
        
        $bankData = array(
            "name" => $investorName,
            "account_number" => $accountNo,
            "account_holder_name" => $acctHolderName,
            "bank_master_id" => $bankMasterId,
            "branch_name" => $branchName,
            "branch_city" => $cityName,
            "branch_state" => $stateName,
            "account_type_id" => $accountType,
            "ifsc_code" => $ifscCode,
            "investor_id" => $investorId
        );
        
        $resultAddBankDetails = $this->registration_model->updateInvestorBankDetails($investorId, $bankData);
        
        if ($resultAddBankDetails) {
            
            $result = $this->registration_model->update_is_inv_table($investorId);
            $this->createInvestorFormPdf($investorId);
            $_SESSION["readyforUpdate"] = true;
            echo '{"success":true,"msg":"updated"}';
            log_message('info', '***** InvestorId : ' . $_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : modifyBankDetail, Message : success  *****');
            
            
        } else {
            echo '{"success":false}';
            log_message('info', '***** InvestorId : ' . $_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : modifyBankDetail, Message : error  *****');
        }
    }
    
    /*
    ------------------------------------------------------------------------------------------
    */
    
    /*
    ------------------------------------------------------------------------------------------
    |   USE : getDetailsByIfscCode
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO GET DETAIL OF IFSC CODE
    ------------------------------------------------------------------------------------------
    */
    public function getDetailsByIfscCode()
    {
        $ifscCode = $this->input->post("ifscCode");
        $result   = $this->registration_model->getDetailsByIfscCode($ifscCode);
        if ($result) {
            $bankStateName  = $result->bank_state_name;
            $bankBranchName = $result->bank_branch_name;
            $bankCityName   = $result->bank_city_name;
            $bankMasterId   = $result->bank_master_id;
            echo '{"success":true,"bankStateName":"' . $bankStateName . '","bankBranchName":"' . $bankBranchName . '","bankCityName":"' . $bankCityName . '","bankMasterId":"' . $bankMasterId . '"}';
            log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : getDetailsByIfscCode, Message : success  *****');
        } else {
            echo '{"success":false}';
            log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : getDetailsByIfscCode, Message : error  *****');
            
        }
    }
    
    /*
    ------------------------------------------------------------------------------------------
    |   USE : checkNomineePercentage
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO GET DETAIL OF IFSC CODE
    ------------------------------------------------------------------------------------------
    */
    public function checkNomineePercentage()
    {
        $percentage      = $this->input->post("percentage");
        $investorId      = $_SESSION["investor_id"];
        $totalPercentage = $this->registration_model->checkNomineeTotalPercentage($investorId);
        $total           = 0;
        if ($totalPercentage) {
            $total             = $total + $totalPercentage->total_percentage;
            $balancePercentage = (100 - $total);
            echo '{"success":true,"total":"' . $total . '","balance":"' . $balancePercentage . '"}';
            log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : checkNomineePercentage, Message : success  *****');
        } else {
            echo '{"success":false}';
            log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : checkNomineePercentage, Message : error  *****');
        }
    }
    /*
    ------------------------------------------------------------------------------------------
    |   USE : addNomineeDatails
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO ADD DETAIL OF NOMINEE
    ------------------------------------------------------------------------------------------
    */
    public function addNomineeDatails()
    {
        $nomineeName    = $this->input->post("nomineeName");
        $relation       = $this->input->post("relation");
        $percentage     = $this->input->post("percentage");
        $dob            = $this->input->post("dob");
        $guardianName   = $this->input->post("guardianName");
        $nomineeAddress = handleString($this->input->post("nomineeAddress"));
        $investorId     = $_SESSION["investor_id"];
        $nomineeData    = array(
            "name" => $nomineeName,
            "relation_with_investor" => $relation,
            "percentage" => $percentage,
            "date_of_birth" => $dob,
            "guardian_name" => $guardianName,
            "address" => $nomineeAddress,
            "investor_id" => $investorId
        );
        $noOfNominee    = $this->registration_model->checkNoOfNominee($investorId);
        if ($noOfNominee < 3) {
            $resultAddNominee = $this->registration_model->addInvestorNomineeDetails($nomineeData);
            if ($resultAddNominee) {
                $date = new DateTime($dob);
                $dob  = $date->format('d M Y');
                echo '{"success":true,"nomineeId":"' . $resultAddNominee . '","dob":"' . $dob . '"}';
                log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : addNomineeDatails, Message : success  *****');
            } else {
                echo '{"success":false","errorMsg":"Server error found"}';
                log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : addNomineeDatails, Message : failuar  *****');
            }
        } else {
            echo '{"success":false,"errorMsg":"Maximum 3 nominee(s) allowed."}';
            log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : addNomineeDatails, Message : 3 nominee allready add  *****');
        }
    }
    /*
    ------------------------------------------------------------------------------------------
    */
    
    /*
    ------------------------------------------------------------------------------------------
    |   USE : removeNominee
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO ADD DETAIL OF NOMINEE
    ------------------------------------------------------------------------------------------
    */
    
    public function removeNominee()
    {
        $nomineeId = $this->input->post("nomineeId");
        $result    = $this->registration_model->removeNominee($nomineeId);
        if ($result) {
            echo '{"success":true}';
            log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : removeNominee, Message : remove success  *****');
        } else {
            echo '{"success":false}';
            log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : removeNominee, Message : remove failuar  *****');
        }
    }
    
    /*
    -----------------------------------------------------------------------------------------------------
    */
    
    /*
    -----------------------------------------------------------------------------------------------------
    |   USE : uploadCancelChequeImage
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO ADD DETAIL OF NOMINEE
    -----------------------------------------------------------------------------------------------------
    */
    
    /*     public function uploadCancelChequeImage()
    {
    $invId=$_SESSION["investor_id"];
    if(isset($_FILES))
    {
    $info = new SplFileInfo($_FILES["myfile0"]["name"]);
    $fileExt=strtolower($info->getExtension());
    
    if($fileExt=='jpg'||$fileExt=='jpeg'||$fileExt=='png'||$fileExt=='JPG'||$fileExt=='JPEG'||$fileExt=='PNG'||$fileExt=='pdf'||$fileExt=='PDF')
    {
    $uploadFileName = $invId."_4_".date("dmyhis").".".$fileExt; // assign new name
    $type     = $_FILES["myfile0"]["type"];
    $tempName = $_FILES["myfile0"]["tmp_name"];
    $size     = $_FILES["myfile0"]["size"];
    $originalfileName = $_FILES["myfile0"]["name"];
    
    $pathAndName ="assets/uploads/cancelled_cheque/".$uploadFileName;
    if(move_uploaded_file($tempName, $pathAndName))
    {
    $docData= array(
    'url'=> base_url().'assets/uploads/cancelled_cheque/'.$uploadFileName,
    'original_name'=>$originalfileName,
    'document_type_id'=>4,
    'investor_id'=>$invId
    );
    $docTypeId=4; // Default document type for cancelled cheque or last 6 month bank statement
    $result = $this->registration_model->addInvestorDocumentType($invId,$docData,$docTypeId);
    if($result)
    {
    echo '{"success":true,"message":"file uploaded successfully"}';
    }
    else
    {
    echo '{"success":false,"message":"failed to upload"}';
    }
    }
    else
    {
    echo '{"success":false,"message":"File size is too large"}';
    }
    
    }
    else
    {
    echo '{"success":false,"message":"upload jpg,png or pdf file only!"}';
    }
    
    }
    else
    {
    echo '{"success":false}';
    }
    } */
    
    public function uploadCancelChequeImage($docTypeId = 4)
    {
        $invId = $_SESSION["investor_id"];
        if (isset($_FILES)) {
            $info    = new SplFileInfo($_FILES["myfile0"]["name"]);
            $fileExt = strtolower($info->getExtension());
            if ($docTypeId == 4) {
                $uploadFileName = $invId . "_4_" . date("dmyhis") . "." . $fileExt; // assign new name
                $pathAndName    = "assets/uploads/cancelled_cheque/" . $uploadFileName;
            } else if ($docTypeId == 24) {
                $uploadFileName = $invId . "_4_" . date("dmyhis") . "_investor_form" . "." . $fileExt; // assign new name
                $pathAndName    = "assets/uploads/cancelled_cheque/" . $uploadFileName;
            } else {
                $uploadFileName = $invId . "_4_" . date("dmyhis") . "_Pan_card" . "." . $fileExt; // assign new name
                $pathAndName    = "assets/uploads/cancelled_cheque/" . $uploadFileName;
            }
            
            
            $type             = $_FILES["myfile0"]["type"];
            $tempName         = $_FILES["myfile0"]["tmp_name"];
            $size             = $_FILES["myfile0"]["size"];
            $originalfileName = $_FILES["myfile0"]["name"];
            
            
            if (move_uploaded_file($tempName, $pathAndName)) {
                $docData = array(
                    'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                    'original_name' => $originalfileName,
                    'document_type_id' => $docTypeId,
                    'investor_id' => $invId
                );
                ; // Default document type for cancelled cheque or last 6 month bank statement
                $result = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                if ($result) {
                    echo '{"success":true,"message":"file uploaded"}';
                    log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : uploadCancelChequeImage, Message : CancelCheque upload successfully  *****');
                } else {
                    echo '{"success":false,"message":"failed to upload"}';
                    log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : uploadCancelChequeImage, Message : CancelCheque upload failuar  *****');
                }
            } else {
                echo '{"success":false,"message":"server error"}';
                log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : uploadCancelChequeImage, Message : CancelCheque upload failuar  *****');
            }
        } else {
            echo '{"success":false}';
            log_message('info', '***** InvestorId : ' . @$_SESSION["investor_id"] . ', Controller : AddBankAndNominiDatail, Function : uploadCancelChequeImage, Message : CancelCheque upload failuar  *****');
        }
    }
    
    
    /*
    -----------------------------------------------------------------------------------------------------
    */
    
    /*
    -----------------------------------------------------------------------------------------------------
    |   USE : createInvestorFormPdf
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO CREARTE PDF
    -----------------------------------------------------------------------------------------------------
    */
    
    public function testCreate($investorId)
    {
        // echo $this->createInvestorFormPdf($investorId);
        $result                   = $this->registration_model->getInvestorDetail($investorId);
        $resultNominee            = $this->registration_model->getInvestorNomineeDetail($investorId);
        $resultBank               = $this->registration_model->getInvestorBankAndPanDetail($investorId);
        $resultInvStatus          = $this->registration_model->getInvestorStatus($investorId);
        $data["addressProofList"] = $this->registration_model->getInvestorAddressProofList();
        $data["nomineeData"]      = $resultNominee;
        $data["idProofList"]      = $this->registration_model->getInvestorIdProofList();
        $data["bankData"]         = $resultBank;
        $data["row"]              = $result;
        $data["invStatus"]        = $resultInvStatus;
        $motherName               = spliteAndCheckName($result->mother_n);
        $data["mother_f_name"]    = $motherName['name_first'];
        $data["mother_m_name"]    = $motherName['name_middle'];
        $data["mother_l_name"]    = $motherName['name_last'];
        $this->load->view('investor_form_pdf_view', $data);
    }
    
    public function createInvestorFormPdf($investorId)
    {
        $result                   = $this->registration_model->getInvestorDetail($investorId);
        $resultNominee            = $this->registration_model->getInvestorNomineeDetail($investorId);
        $resultBank               = $this->registration_model->getInvestorBankAndPanDetail($investorId);
        $resultInvStatus          = $this->registration_model->getInvestorStatus($investorId);
        $data["addressProofList"] = $this->registration_model->getInvestorAddressProofList();
        $data["nomineeData"]      = $resultNominee;
        $data["idProofList"]      = $this->registration_model->getInvestorIdProofList();
        $data["bankData"]         = $resultBank;
        $data["row"]              = $result;
        $data["invStatus"]        = $resultInvStatus;
        $motherName               = spliteAndCheckName($result->mother_name);
        $data["mother_f_name"]    = $motherName['name_first'];
        $data["mother_m_name"]    = $motherName['name_middle'];
        $data["mother_l_name"]    = $motherName['name_last'];
        // echo $this->encrypt->decode($result->name);
        // echo "<pre>";
        // print_r($data);
        // exit;
        $pdfBody  = $this->load->view('investor_form_pdf_view', $data, true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try {
            $mpdf                   = new mPDF('win-1252', 'A4', '', 'DejaVuSans', 0, 0, 0, 0, 10, 10, '');
            $mpdf->useOnlyCoreFonts = true; // false is default
            $mpdf->SetProtection(array(
                'print'
            ));
            $mpdf->SetTitle("INVESTOR DETAILS");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');
            $html = $pdfBody;
            $mpdf->WriteHTML($html);
            $fileName = 'investor' . $investorId . date('YmdHis', time()) . '.pdf';
            $mpdf->Output(APPPATH . '../assets/uploads/investor_form_pdf/' . $fileName, 'F');
            $pdfPath = realpath(APPPATH . '../assets/uploads/investor_form_pdf/' . $fileName);
            $data    = array(
                "investor_pdf_form_url" => $fileName
            );
            $result  = $this->registration_model->updateInvestorInfo($investorId, $data);
            return base_url() . "assets/uploads/investor_form_pdf/" . $fileName;
        }
        catch (Exception $e) {
            echo $e;
            die;
            exit;
        }
    }

    public function backendCreateInvestorFormPdf($investorId)
    {
        $result                   = $this->registration_model->getInvestorDetail($investorId);
        $resultNominee            = $this->registration_model->getInvestorNomineeDetail($investorId);
        $resultBank               = $this->registration_model->getInvestorBankAndPanDetail($investorId);
        $resultInvStatus          = $this->registration_model->getInvestorStatus($investorId);
        $data["addressProofList"] = $this->registration_model->getInvestorAddressProofList();
        $data["nomineeData"]      = $resultNominee;
        $data["idProofList"]      = $this->registration_model->getInvestorIdProofList();
        $data["bankData"]         = $resultBank;
        $data["row"]              = $result;
        $data["invStatus"]        = $resultInvStatus;
        $motherName               = spliteAndCheckName($result->mother_n);
        $data["mother_f_name"]    = $motherName['name_first'];
        $data["mother_m_name"]    = $motherName['name_middle'];
        $data["mother_l_name"]    = $motherName['name_last'];
        $pdfBody                  = $this->load->view('investor_form_pdf_view', $data, true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try {
            $mpdf                   = new mPDF('win-1252', 'A4', '', 'DejaVuSans', 0, 0, 0, 0, 10, 10, '');
            $mpdf->useOnlyCoreFonts = true; // false is default
            $mpdf->SetProtection(array(
                'print'
            ));
            $mpdf->SetTitle("INVESTOR DETAILS");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');
            $html = $pdfBody;
            $mpdf->WriteHTML($html);
            $fileName = 'investor' . $investorId . date('YmdHis', time()) . '.pdf';
            $mpdf->Output(APPPATH . '../assets/uploads/investor_form_pdf/' . $fileName, 'F');
            $pdfPath = realpath(APPPATH . '../assets/uploads/investor_form_pdf/' . $fileName);
            $data    = array(
                "investor_pdf_form_url" => $fileName
            );
            $result  = $this->registration_model->updateInvestorInfo($investorId, $data);
             echo '{"success":true,"url":"'.base_url() . "assets/uploads/investor_form_pdf/" . $fileName.'"}';
        }
        catch (Exception $e) {
            echo $e;
            die;
            exit;
        }
    }
    
    public function testimage($investorId)
    {
        $result                   = $this->registration_model->getInvestorDetail($investorId);
        $resultNominee            = $this->registration_model->getInvestorNomineeDetail($investorId);
        $resultBank               = $this->registration_model->getInvestorBankAndPanDetail($investorId);
        $resultInvStatus          = $this->registration_model->getInvestorStatus($investorId);
        $data["addressProofList"] = $this->registration_model->getInvestorAddressProofList();
        $data["nomineeData"]      = $resultNominee;
        $data["idProofList"]      = $this->registration_model->getInvestorIdProofList();
        $data["bankData"]         = $resultBank;
        $data["row"]              = $result;
        $data["invStatus"]        = $resultInvStatus;
        $this->load->view('investor_form_pdf_view', $data);
    }
    
    public function createCKYCFormPdf($investorId)
    {
        
        $result                   = $this->registration_model->getInvestorDetail($investorId);
        $resultNominee            = $this->registration_model->getInvestorNomineeDetail($investorId);
        $resultBank               = $this->registration_model->getInvestorBankAndPanDetail($investorId);
        $resultInvStatus          = $this->registration_model->getInvestorStatus($investorId);
        $data["addressProofList"] = $this->registration_model->getInvestorAddressProofList();
        $data["nomineeData"]      = $resultNominee;
        $data["idProofList"]      = $this->registration_model->getInvestorIdProofList();
        $data["bankData"]         = $resultBank;
        $data["row"]              = $result;
       
        $panNumber         = $this->encrypt->decode($data['row']->pan);
        $data["invStatus"] = $resultInvStatus;
        $pdfBody           = $this->load->view('investor_new_ckyc_pdf', $data, true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try {
            $mpdf                   = new mPDF('win-1252', 'A4', '', 'DejaVuSans', 0, 0, 0, 0, 10, 10, '');
            $mpdf->useOnlyCoreFonts = true; // false is default
            $mpdf->SetProtection(array(
                'print'
            ));
            $mpdf->SetTitle("INVESTOR DETAILS");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');
            $html = $pdfBody;
            $mpdf->WriteHTML($html);
            $fileName = 'investor' . $investorId . date('YmdHis', time()) . '.pdf';
            $mpdf->Output(APPPATH . '../assets/uploads/investor_form_pdf/' . $fileName, 'F');
            $pdfPath = realpath(APPPATH . '../assets/uploads/investor_form_pdf/' . $fileName);
            $data    = array(
                "investor_pdf_form_url" => $fileName
            );
            echo '{"success":true,"link":'.base_url() . "assets/uploads/investor_form_pdf/" . $fileName.'}';
            $result=$this->registration_model->updateInvestorInfo($investorId,$data);
        }
        catch (Exception $e) {
            echo $e;
            die;
            exit;
        }
    }
    
    
    
    
    public function appBankAndNomineeData()
    {
        $data       = json_decode(file_get_contents("php://input"));
        $investorId = $data->investorId;
        $data       = array();
        if (isset($investorId) && !empty($investorId)) {
            $invId                       = $investorId;
            $result                      = $this->registration_model->getInvestorDetail($invId);
            //$resultBank=$this->registration_model->getInvestorBankAndPanDetail($invId);
            //$data["investorStatus"]=$this->common_model->getInvestorStatus($invId);
            // $data["bankData"]=$resultBank;
            $invName                     = $result->name;
            $data["name"]                = $this->encrypt->decode($this->registration_model->getUserNameOnServer($investorId));
            // $result=$this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["investor_type_id"]    = $this->db->select("investor_type_id")->from("investor")->where("investor_id", $invId)->get()->row()->investor_type_id;
            //$data["overseasDetails"]=$this->registration_model->getInvestorOverseasDetail($invId);
            //$resultNominee=$this->registration_model->getInvestorNomineeDetail($invId);
            //$data["nomineeData"]=$resultNominee;
            $data["bankMasterList"]      = $this->registration_model->getbankMasterAll();
            $data["bankAccountTypeList"] = $this->registration_model->getInvestorBankAccountTypeList();
        } else {
            return redirect(base_url());
        }
        
        if (isset($investorId) && !empty($investorId)) {
            $out = json_encode($data);
            echo $out;
            log_message('info', '***** InvestorId : ' . $investorId . ', Controller : AddBankAndNominiDatail, Function : appBankAndNomineeData, Message :  successfully get data *****');
        } else {
            echo '{"success":flase,"msg":"SomeThing Goes to wrong"}';
            log_message('info', '***** InvestorId : ' . $investorId . ', Controller : AddBankAndNominiDatail, Function : appBankAndNomineeData, Message :  SomeThing Goes to wrong *****');
        }
    }
    
    
    
    /*
    
    ------------------------------------------------------------------------------------------
    
    */
    
    
    
    /*
    
    ------------------------------------------------------------------------------------------
    
    |   USE : addBankDetails
    
    |   DATE : 24/09/16
    
    |   AUTHOER : AMIT MEENA
    
    |   COMMENT : THIS FUNCTION IS USED TO INSERT BANK AND NOMINEE DATA INTO THE DATABASE
    
    ------------------------------------------------------------------------------------------
    
    */
    
    public function appAddBankDetails()
    {
        $data           = json_decode(file_get_contents("php://input"));
        $investorId     = $data->investorId;
        $smsname        = $data->investorName;
        $investorName   = $this->encrypt->encode(handleString($data->investorName)); // encryped fields
        $accountNo      = $this->encrypt->encode($data->accountNo); // encryped fields
        $acctHolderName = $this->encrypt->encode($data->acctHolderName); // encryped fields
        $accountType    = $data->accountType;
        $bankMasterId   = $data->bankMasterId;
        $branchName     = $data->branchName;
        $cityName       = $data->cityName;
        $stateName      = $data->stateName;
        $ifscCode       = $data->ifscCode;
        $bankData       = array(
            
            "name" => $investorName,
            "account_number" => $accountNo,
            "account_holder_name" => $acctHolderName,
            "bank_master_id" => $bankMasterId,
            "account_type_id" => $accountType,
            "ifsc_code" => $ifscCode,
            "investor_id" => $investorId,
            "branch_name" => $branchName,
            "branch_city" => $cityName,
            "branch_state" => $stateName
        );
        
        $resultAddBankDetails = $this->registration_model->addInvestorBankDetails($bankData);
        if ($resultAddBankDetails) {
            $this->registration_model->update_is_inv_table($investorId);
            $pdfPath = $this->createInvestorFormPdf($investorId);
            $this->appSendRegistrationPdfEmail($investorId);
            echo '{"success":"true","Investor_form_PDF":"' . $pdfPath . '"}';
            log_message('info', '***** InvestorId : ' . $investorId . ', Controller : AddBankAndNominiDatail, Function : appAddBankDetails, Message :  add back data successfully *****');
        } else {
            echo '{"success":"false"}';
            log_message('info', '***** InvestorId : ' . $investorId . ', Controller : AddBankAndNominiDatail, Function : appAddBankDetails, Message :  not add *****');
        }
        
    }
    
    /*
    
    ------------------------------------------------------------------------------------------
    
    */
    
    
    
    /*
    
    ------------------------------------------------------------------------------------------
    
    |   USE : appGetDetailsByIfscCode
    
    |   DATE : 24/09/16
    
    |   AUTHOER : AMIT MEENA
    
    |   COMMENT : This function is Used to get bank Detain Using Ifsc Code
    
    ------------------------------------------------------------------------------------------
    
    */
    
    public function appGetDetailsByIfscCode()
    {
        $data     = json_decode(file_get_contents("php://input"));
        $ifscCode = $data->ifscCode;
        // echo $ifscCode;
        $result   = $this->registration_model->getDetailsByIfscCode($ifscCode);
        if ($result) {
            $bankStateName  = $result->bank_state_name;
            $bankBranchName = $result->bank_branch_name;
            $bankCityName   = $result->bank_city_name;
            $bankMasterId   = $result->bank_master_id;
            echo '{"success":"true","bankStateName":"' . $bankStateName . '","bankBranchName":"' . $bankBranchName . '","bankCityName":"' . $bankCityName . '","bankMasterId":"' . $bankMasterId . '"}';
        } else {
            echo '{"success":"false"}';
        }
    }
    
    
    /*
    
    ------------------------------------------------------------------------------------------
    
    |   USE : addNomineeDatails
    
    |   DATE : 24/09/16
    
    |   AUTHOER : AMIT MEENA
    
    |   COMMENT : THIS FUNCTION IS USED TO ADD DETAIL OF NOMINEE
    
    ------------------------------------------------------------------------------------------
    
    */
    
    public function appAddNomineeDatails()
    {
        $data                   = json_decode(file_get_contents("php://input"));
        $nomineeName            = $data->nomineeName;
        $relation               = $data->relation;
        $percentage             = $data->percentage;
        $relation_with_guardian = @$data->relation_with_guardian;
        $dob                    = $data->dob;
        $investorId             = $data->investor_id;
        $guardianName           = $data->guardianName;
        $res                    = $this->db->query("SELECT investor.address,investor.address_2,city.location_name,state.state_name FROM investor JOIN city ON investor.city_id = city.id JOIN state ON investor.state_id=state.id where investor_id = $investorId");
        $res                    = $res->row();
        $fullAddress            = $res->address . " " . $res->address_2 . " " . $res->location_name . " " . $res->state_name;
        $nomineeAddress         = handleString($fullAddress);
        $nomineeData            = array(
            "name" => $nomineeName,
            "relation_with_investor" => $relation,
            "percentage" => $percentage,
            "date_of_birth" => $dob,
            "guardian_name" => $guardianName,
            "relation_with_guardian" => $relation_with_guardian,
            "address" => $nomineeAddress,
            "investor_id" => $investorId
        );
        
        $noOfNominee = $this->registration_model->checkNoOfNominee($investorId);
        if ($noOfNominee < 3) {
            $nomPer = $this->appCheckNomineePercentage($investorId);
            if ($nomPer || $nomPer == 0) {
                if ((100 - $nomPer) >= $percentage) {
                    $resultAddNominee = $this->registration_model->addInvestorNomineeDetails($nomineeData);
                    if ($resultAddNominee) {
                        $date = new DateTime($dob);
                        $dob  = $date->format('d M Y');
                        echo '{"success":"true","nomineeId":"' . $resultAddNominee . '","dob":"' . $dob . '","nomPer":"' . (100 - $nomPer - $percentage) . '"}';
                        log_message('info', '***** InvestorId : ' . $investorId . ' , Controller : AddBankAndNominiDatail, Function : appAddNomineeDatails, Message :  success *****');
                    } else {
                        echo '{"success":"false","errorMsg":"Server error found"}';
                        log_message('info', '***** InvestorId : ' . $investorId . ' , Controller : AddBankAndNominiDatail, Function : appAddNomineeDatails, Message :  Server error found *****');
                    }
                } else {
                    echo '{"success":"false","errorMsg":"Nominee max remaining persent should be ' . (100 - $nomPer) . '%"}';
                }
            } else {
                echo '{"success":"false","errorMsg":"100% persent used"}';
            }
        } else {
            echo '{"success":"false","errorMsg":"Maximum 3 nominee(s) allowed."}';
            log_message('info', '***** InvestorId : ' . $investorId . ' , Controller : AddBankAndNominiDatail, Function : appAddNomineeDatails, Message :  Maximum 3 nominee(s) allowed *****');
        }
        
    }
    
    public function appCheckNomineePercentage($investorId)
    {
        $totalPercentage = $this->registration_model->checkNomineeTotalPercentage($investorId);
        if ($totalPercentage) {
            $total = $totalPercentage->total_percentage;
            if ($total >= 100) {
                return false;
            } else {
                if ($total) {
                    return $total;
                } else {
                    return 0;
                }
            }
        } else {
            return false;
        }
    }
    
    
    
    /*
    -----------------------------------------------------------------------------------------------------
    |   USE : uploadCancelChequeImage
    |   DATE : 24/09/16
    |   AUTHOER : AMIT MEENA
    |   COMMENT : THIS FUNCTION IS USED TO ADD DETAIL OF NOMINEE
    -----------------------------------------------------------------------------------------------------
    */
    
    
    
    public function appUploadCancelChequeImage()
    {
        $invId       = $this->input->post('investorId');
        $invId       = trim($invId);
        $base64Image = @$this->input->post('base64');
        $invId       = trim($invId);
        if (!$base64Image) {
            $info    = new SplFileInfo($_FILES["myfile0"]["name"]);
            $fileExt = strtolower($info->getExtension());
            if ($fileExt == 'jpg' || $fileExt == 'jpeg' || $fileExt == 'png' || $fileExt == 'pdf' || $fileExt == 'PDF' || $fileExt == 'JPG' || $fileExt == 'JPEG' || $fileExt == 'PNG') {
                $uploadFileName   = "" . $invId . "_4_" . date("dmyhis") . "." . $fileExt; // assign new name
                $type             = $_FILES["myfile0"]["type"];
                $tempName         = $_FILES["myfile0"]["tmp_name"];
                $size             = $_FILES["myfile0"]["size"];
                $originalfileName = $_FILES["myfile0"]["name"];
                $pathAndName      = "assets/uploads/cancelled_cheque/" . $uploadFileName;
                if (move_uploaded_file($tempName, $pathAndName)) {
                    $docData   = array(
                        'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                        'original_name' => $originalfileName,
                        'document_type_id' => 4,
                        'investor_id' => $invId
                    );
                    $docTypeId = 4; // Default document type for cancelled cheque or last 6 month bank statement
                    $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                    if ($result) {
                        echo '{"success":"true","message":"file uploaded"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadCancelChequeImage, Message : file uploaded *****');
                    } else {
                        echo '{"success":"false","message":"failed to upload"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadCancelChequeImage, Message : failed to upload *****');
                    }
                } else {
                    echo '{"success":"false","message":"server error"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadCancelChequeImage, Message : server error *****');
                }
            } else {
                echo '{"success":"false","message":"only jpg/png allowed!"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadCancelChequeImage, Message : only jpg/png allowed *****');
            }
        } else {
            define('UPLOAD_DIR', 'assets/images/');
            
            $image_parts    = explode(";base64,", $base64Image);
            $image_type_aux = explode("image/", $image_parts[0]);
            $image_type     = $image_type_aux[1];
            $image_base64   = base64_decode($image_parts[1]);
            $uploadFileName = "" . $invId . "_4_" . date("dmyhis") . "_address_proof" . "." . $image_type;
            $pathAndName    = "assets/uploads/cancelled_cheque/" . $uploadFileName;
            if (file_put_contents($pathAndName, $image_base64)) {
                $docData   = array(
                    'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                    'original_name' => "Aadhar Image",
                    'document_type_id' => 4,
                    'investor_id' => $invId
                );
                $docTypeId = 4; // Default document type for cancelled cheque or last 6 month bank statement
                $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                if ($result) {
                    echo '{"success":"true","message":"file uploaded base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : file uploaded *****');
                } else {
                    echo '{"success":"false","message":"failed to upload base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : failed to upload *****');
                }
            } else {
                echo '{"success":"false","message":"server error base"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : server error *****');
            }
        }
    }
    
    
    public function appUploadPan()
    {
        $invId   = $this->input->post('investorId');
        $base64Image = @$this->input->post('base64');
        $invId       = trim($invId);
        if (!$base64Image) {
            $info    = new SplFileInfo($_FILES["myfile0"]["name"]);
            $fileExt = strtolower($info->getExtension());
            if ($fileExt == 'jpg' || $fileExt == 'jpeg' || $fileExt == 'png' || $fileExt == 'pdf' || $fileExt == 'PDF' || $fileExt == 'JPG' || $fileExt == 'JPEG' || $fileExt == 'PNG') {
                $uploadFileName   = "" . $invId . "_4_" . date("dmyhis") . "_Pan_card" . "." . $fileExt; // assign new name
                $type             = $_FILES["myfile0"]["type"];
                $tempName         = $_FILES["myfile0"]["tmp_name"];
                $size             = $_FILES["myfile0"]["size"];
                $originalfileName = $_FILES["myfile0"]["name"];
                $pathAndName      = "assets/uploads/cancelled_cheque/" . $uploadFileName;
                if (move_uploaded_file($tempName, $pathAndName)) {
                    $docData   = array(
                        'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                        'original_name' => $originalfileName,
                        'document_type_id' => 7,
                        'investor_id' => $invId
                    );
                    $docTypeId = 7; // Default document type for cancelled cheque or last 6 month bank statement
                    $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                    if ($result) {
                        echo '{"success":"true","message":"file uploaded"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadPan, Message : file uploaded *****');
                    } else {
                        echo '{"success":"false","message":"failed to upload"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadPan, Message : file uploaded *****');
                    }
                } else {
                    echo '{"success":"false","message":"server error"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadPan, Message : server error *****');
                }
            } else {
                echo '{"success":"false","message":"only jpg/png allowed!"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadPan, Message : only jpg/png allowed! *****');
            }
        } else {
            define('UPLOAD_DIR', 'assets/images/');
            
            $image_parts    = explode(";base64,", $base64Image);
            $image_type_aux = explode("image/", $image_parts[0]);
            $image_type     = $image_type_aux[1];
            $image_base64   = base64_decode($image_parts[1]);
            $uploadFileName = "" . $invId . "_4_" . date("dmyhis") . "_address_proof" . "." . $image_type;
            $pathAndName    = "assets/uploads/cancelled_cheque/" . $uploadFileName;
            if (file_put_contents($pathAndName, $image_base64)) {
                $docData   = array(
                    'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                    'original_name' => "Aadhar Image",
                    'document_type_id' => 7,
                    'investor_id' => $invId
                );
                $docTypeId = 7; // Default document type for cancelled cheque or last 6 month bank statement
                $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                if ($result) {
                    echo '{"success":"true","message":"file uploaded base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : file uploaded *****');
                } else {
                    echo '{"success":"false","message":"failed to upload base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : failed to upload *****');
                }
            } else {
                echo '{"success":"false","message":"server error base"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : server error *****');
            }
        }
        
    }
    
    public function appUploadInvestorPDF()
    {
        $invId   = $this->input->post('investorId');
        $base64Image = @$this->input->post('base64');
        $invId       = trim($invId);
        if (!$base64Image) {
            $info    = new SplFileInfo($_FILES["myfile0"]["name"]);
            $fileExt = strtolower($info->getExtension());
            if ($fileExt == 'jpg' || $fileExt == 'jpeg' || $fileExt == 'png' || $fileExt == 'pdf' || $fileExt == 'PDF' || $fileExt == 'JPG' || $fileExt == 'JPEG' || $fileExt == 'PNG') {
                $uploadFileName   = "" . $invId . "_4_" . date("dmyhis") . "_investor_pdf" . "." . $fileExt; // assign new name
                $type             = $_FILES["myfile0"]["type"];
                $tempName         = $_FILES["myfile0"]["tmp_name"];
                $size             = $_FILES["myfile0"]["size"];
                $originalfileName = $_FILES["myfile0"]["name"];
                $pathAndName      = "assets/uploads/cancelled_cheque/" . $uploadFileName;
                if (move_uploaded_file($tempName, $pathAndName)) {
                    $docData   = array(
                        'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                        'original_name' => $originalfileName,
                        'document_type_id' => 50,
                        'investor_id' => $invId
                    );
                    $docTypeId = 50; // Default document type for cancelled cheque or last 6 month bank statement
                    $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                    if ($result) {
                        echo '{"success":"true","message":"file uploaded"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadInvestorPDF, Message : file uploaded *****');
                    } else {
                        echo '{"success":"false","message":"failed to upload"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadInvestorPDF, Message : failed to upload *****');
                    }
                } else {
                    echo '{"success":"false","message":"server error"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadInvestorPDF, Message : server error *****');
                }
            } else {
                echo '{"success":"false","message":"only jpg/png allowed!"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadInvestorPDF, Message : only jpg/png allowed! *****');
            }
        } else {
            define('UPLOAD_DIR', 'assets/images/');
            
            $image_parts    = explode(";base64,", $base64Image);
            $image_type_aux = explode("image/", $image_parts[0]);
            $image_type     = $image_type_aux[1];
            $image_base64   = base64_decode($image_parts[1]);
            $uploadFileName = "" . $invId . "_4_" . date("dmyhis") . "_address_proof" . "." . $image_type;
            $pathAndName    = "assets/uploads/cancelled_cheque/" . $uploadFileName;
            if (file_put_contents($pathAndName, $image_base64)) {
                $docData   = array(
                    'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                    'original_name' => "Aadhar Image",
                    'document_type_id' => 50,
                    'investor_id' => $invId
                );
                $docTypeId = 50; // Default document type for cancelled cheque or last 6 month bank statement
                $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                if ($result) {
                    echo '{"success":"true","message":"file uploaded base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : file uploaded *****');
                } else {
                    echo '{"success":"false","message":"failed to upload base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : failed to upload *****');
                }
            } else {
                echo '{"success":"false","message":"server error base"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : server error *****');
            }
        }
    }
    
    public function appUploadAddressProof()
    {
        $invId   = $this->input->post('investorId');
        $base64Image = @$this->input->post('base64');
        $invId       = trim($invId);
        if (!$base64Image) {
            $info    = new SplFileInfo($_FILES["myfile0"]["name"]);
            $fileExt = strtolower($info->getExtension());
            if ($fileExt == 'jpg' || $fileExt == 'jpeg' || $fileExt == 'png' || $fileExt == 'pdf' || $fileExt == 'PDF' || $fileExt == 'JPG' || $fileExt == 'JPEG' || $fileExt == 'PNG') {
                $uploadFileName   = "" . $invId . "_4_" . date("dmyhis") . "_address_proof" . "." . $fileExt; // assign new name
                $type             = $_FILES["myfile0"]["type"];
                $tempName         = $_FILES["myfile0"]["tmp_name"];
                $size             = $_FILES["myfile0"]["size"];
                $originalfileName = $_FILES["myfile0"]["name"];
                $pathAndName      = "assets/uploads/cancelled_cheque/" . $uploadFileName;
                if (move_uploaded_file($tempName, $pathAndName)) {
                    $docData   = array(
                        'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                        'original_name' => $originalfileName,
                        'document_type_id' => 6,
                        'investor_id' => $invId
                    );
                    $docTypeId = 6; // Default document type for cancelled cheque or last 6 month bank statement
                    $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                    if ($result) {
                        echo '{"success":"true","message":"file uploaded"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : file uploaded *****');
                    } else {
                        echo '{"success":"false","message":"failed to upload"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : failed to upload *****');
                    }
                } else {
                    echo '{"success":"false","message":"server error"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : server error *****');
                }
            } else {
                echo '{"success":"false","message":"only jpg/png allowed!"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : only jpg/png allowed! *****');
            }
        } else {
            define('UPLOAD_DIR', 'assets/images/');
            
            $image_parts    = explode(";base64,", $base64Image);
            $image_type_aux = explode("image/", $image_parts[0]);
            $image_type     = $image_type_aux[1];
            $image_base64   = base64_decode($image_parts[1]);
            $uploadFileName = "" . $invId . "_4_" . date("dmyhis") . "_address_proof" . "." . $image_type;
            $pathAndName    = "assets/uploads/cancelled_cheque/" . $uploadFileName;
            if (file_put_contents($pathAndName, $image_base64)) {
                $docData   = array(
                    'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                    'original_name' => "Aadhar Image",
                    'document_type_id' => 6,
                    'investor_id' => $invId
                );
                $docTypeId = 6; // Default document type for cancelled cheque or last 6 month bank statement
                $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                if ($result) {
                    echo '{"success":"true","message":"file uploaded base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : file uploaded *****');
                } else {
                    echo '{"success":"false","message":"failed to upload base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : failed to upload *****');
                }
            } else {
                echo '{"success":"false","message":"server error base"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : server error *****');
            }
        }
    }
    
    public function appUploadAadharCard()
    {
        $invId       = $this->input->post('investorId');
        $base64Image = @$this->input->post('base64');
        $invId       = trim($invId);
        if (!$base64Image) {
            $info    = new SplFileInfo($_FILES["myfile0"]["name"]);
            $fileExt = strtolower($info->getExtension());
            if ($fileExt == 'jpg' || $fileExt == 'jpeg' || $fileExt == 'png' || $fileExt == 'pdf' || $fileExt == 'PDF' || $fileExt == 'JPG' || $fileExt == 'JPEG' || $fileExt == 'PNG') {
                $uploadFileName   = "" . $invId . "_4_" . date("dmyhis") . "_address_proof" . "." . $fileExt; // assign new name
                $type             = $_FILES["myfile0"]["type"];
                $tempName         = $_FILES["myfile0"]["tmp_name"];
                $size             = $_FILES["myfile0"]["size"];
                $originalfileName = $_FILES["myfile0"]["name"];
                $pathAndName      = "assets/uploads/cancelled_cheque/" . $uploadFileName;
                if (move_uploaded_file($tempName, $pathAndName)) {
                    $docData   = array(
                        'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                        'original_name' => $originalfileName,
                        'document_type_id' => 20,
                        'investor_id' => $invId
                    );
                    $docTypeId = 20; // Default document type for cancelled cheque or last 6 month bank statement
                    $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                    if ($result) {
                        echo '{"success":"true","message":"file uploaded"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : file uploaded *****');
                    } else {
                        echo '{"success":"false","message":"failed to upload"}';
                        log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : failed to upload *****');
                    }
                } else {
                    echo '{"success":"false","message":"server error"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : server error *****');
                }
            } else {
                echo '{"success":"false","message":"only jpg/png allowed!"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : only jpg/png allowed! *****');
            }
        } else {
            define('UPLOAD_DIR', 'assets/images/');
            
            $image_parts    = explode(";base64,", $base64Image);
            $image_type_aux = explode("image/", $image_parts[0]);
            $image_type     = $image_type_aux[1];
            $image_base64   = base64_decode($image_parts[1]);
            $uploadFileName = "" . $invId . "_4_" . date("dmyhis") . "_address_proof" . "." . $image_type;
            $pathAndName    = "assets/uploads/cancelled_cheque/" . $uploadFileName;
            if (file_put_contents($pathAndName, $image_base64)) {
                $docData   = array(
                    'url' => base_url() . 'assets/uploads/cancelled_cheque/' . $uploadFileName,
                    'original_name' => "Aadhar Image",
                    'document_type_id' => 20,
                    'investor_id' => $invId
                );
                $docTypeId = 20; // Default document type for cancelled cheque or last 6 month bank statement
                $result    = $this->registration_model->addInvestorDocumentType($invId, $docData, $docTypeId);
                if ($result) {
                    echo '{"success":"true","message":"file uploaded base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : file uploaded *****');
                } else {
                    echo '{"success":"false","message":"failed to upload base"}';
                    log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : failed to upload *****');
                }
            } else {
                echo '{"success":"false","message":"server error base"}';
                log_message('info', '***** InvestorId : ' . $invId . ' , Controller : AddBankAndNominiDatail, Function : appUploadAddressProof, Message : server error *****');
            }
        }
    }
    
    function appSendRegistrationPdfEmail($invId)
    {
        if ($invId) {
            $resultInfo = $this->registration_model->getInvestorDetail($invId);
            if (isset($resultInfo) && !empty($resultInfo)) {
                $email            = $resultInfo->email;
                $name             = $this->encrypt->decode($resultInfo->name);
                $fileName         = $resultInfo->investor_pdf_form_url;
                $data             = array();
                $data['name']     = $name;
                $today            = date('d M Y h:i a', time());
                $path             = realpath('assets/uploads/investor_form_pdf/' . $fileName);
                $data['FilePath'] = base_url('assets/uploads/investor_form_pdf/' . $fileName);
                $html             = $this->load->view('registration_pdf_email_view', $data, true);
                // $this->email->set_newline("\r\n");
                // $this->email->set_mailtype("html");
                // $this->email->to($email);
                // //$this->email->bcc("amitmeena0206@gmail.com"); 
                // $this->email->from("Investocafe Assistant<help@investocafe.com>", "Investocafe");
                // $this->email->subject("Registration Confirmation");
                // $this->email->message($html);
                
                //     // echo 'assets/uploads/investor_form_pdf/'.$fileName;
                // $this->email->attach($path); 
                // $result=$this->email->send();
                // echo $this->email->print_debugger();die;
                // sendEmailWithPDF($email,"Registration Confirmation",$html,$path);
                sendEmail($email, "Registration Confirmation", $html);
                if ($result) {
                    log_message('info', '***** InvestorId : ' . $invId . ', Controller : SendMessage, Function : sendRegistrationPdfEmail, Message : Successfully sent registration pdf file to "' . $email . '" *****');
                } else {
                    log_message('info', '***** InvestorId : ' . $invId . ', Controller : SendMessage, Function : sendRegistrationPdfEmail, Message : Failed to send registration pdf file to "' . $email . '" *****');
                }
            }
        }
        
    }
    
    
    public function copyInvestorAddress()
    {
        $investor_id = $_SESSION['investor_id'];
        $result      = $this->db->query("select investor.address,investor.address_2,investor.original_city,state.state_name from investor join state ON state.id = investor.state_id WHERE investor_id = $investor_id");
        if ($result->row()) {
            $data = $result->row();
            echo '{"success":true,"address":"' . $data->address . '","address_2":"' . $data->address_2 . '","original_city":"' . $data->original_city . '","state_name":"' . $data->state_name . '"}';
            log_message('info', '***** InvestorId : ' . $investor_id . ' , Controller : AddBankAndNominiDatail, Function : copyInvestorAddress, Message : copy Investor Address successfully *****');
        } else {
            echo '{"success":true}';
            log_message('info', '***** InvestorId : ' . $investor_id . ' , Controller : AddBankAndNominiDatail, Function : copyInvestorAddress, Message : failed to copeing *****');
        }
    }
    
    
    
}
