<?php

class ConfigSIP extends CI_Controller{
	
	function __construct()
    {
       // Call the Model constructor
       parent::__construct();
       $this->load->model('dashboard/dashboard_model');
	   $this->load->model('purchase/purchase_model');
    }
	
	public function config($id)
	{
		$this->_loadView('amit_theme/dashboard/sip_config_view',$id);
	}
	
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : _loadView
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : load view function is used to load header and footer and data to load 
-----------------------------------------------------------------------------------------------------
*/
    function _loadView($view,$id)
    {
		$investorId=$_SESSION["investor_id"];
		log_message('info', '*****  Controller : ConfigSIP, Function : _loadView, Message : load view for investor id '.$investorId.' *****');
		$resultSIP = $this->dashboard_model->getMySIPbyIdModel($id);
		$getFundDetail = $this->dashboard_model->getfunddetailbyFundIdForCheck($resultSIP[0]->fund_id);
		$resultSIP[0]->SIP_min_amount = $getFundDetail->SIP_min_amount;
		$resultSIP[0]->SIP_mx_amt = $getFundDetail->SIP_mx_amt;
		if($resultSIP)
		{
			$data["investFunds"] = $resultSIP;
		}
		else
		{
			$data["investFunds"] = "";
		}

		$data['MonthlyInvestment']= $id;
		$request_date='';
		$next_investment_date='';
		foreach ($investFunds as $row)
		{
			$request_date= $row->sip_start_date;	
			$next_investment_date = $row->next_investment_date;
		}
		
		$same_month_date=date("Y-m-d",strtotime($request_date . "-2 days"));
		$not_eligible_date=date("Y-m-d",strtotime($request_date . "-1 days"));
		$today_date=date("Y-m-d");
		
		if($today_date<=$same_month_date){
			$data["request_date"]=$request_date;
			//echo 'show same month';
		}else if($today_date==$not_eligible_date){
			//echo 'show popup for can only modify/cancel before 2 days of investment';
			$data["request_date"]=$next_investment_date;
		}else if($today_date>=$request_date){
			//echo 'show next month';
			$data["request_date"]=$next_investment_date;
		}

	
		$HolliDay = $this->purchase_model->add_holliday_date();
		$data["HolliDate"]  = $HolliDay;
		$data['jsFile'] ='purchase/purchase.js';
		//$data['jsFile'] ='dashboard/dashboard.js';	
        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view , $data);
        $this->load->view('amit_theme/common/footer',$data );
    }
	
	
	function appDataForSIP()
    {
		$get = json_decode(file_get_contents('php://input'));
		$investorId=$get->investorId;
		$id=$get->monthlyInvestmentId;
		$resultSIP = $this->dashboard_model->getMySIPbyIdModel($id);
		$getFundDetail = $this->dashboard_model->getfunddetailbyFundIdForCheck($resultSIP[0]->fund_id);
		$resultSIP[0]->SIP_min_amount = $getFundDetail->SIP_min_amount;
		$resultSIP[0]->SIP_mx_amt = $getFundDetail->SIP_mx_amt;
		$resultSIP[0]->fund_type_id = $getFundDetail->fund_type_id;
		if($resultSIP)
		{
			$data["investFunds"] = $resultSIP;
		}
		else
		{
			$data["investFunds"] = "";
		}

		$data['MonthlyInvestment']= $id;
		$request_date='';
		$next_investment_date='';
		if($resultSIP)
		{
			foreach ($resultSIP as $row)
			{
				$request_date= $row->sip_start_date;	
				$next_investment_date = $row->next_investment_date;
			}
		}
		
		$same_month_date=date("Y-m-d",strtotime($request_date . "-2 days"));
		$not_eligible_date=date("Y-m-d",strtotime($request_date . "-1 days"));
		$today_date=date("Y-m-d");
		
		if($today_date<=$same_month_date){
			$data["request_date"]=$request_date;
			//echo 'show same month';
		}else if($today_date==$not_eligible_date){
			//echo 'show popup for can only modify/cancel before 2 days of investment';
			$data["request_date"]=$next_investment_date;
		}else if($today_date>=$request_date){
			//echo 'show next month';
			$data["request_date"]=$next_investment_date;
		}

	
		$HolliDay = $this->purchase_model->add_holliday_date();
		$data["HolliDate"]  = $HolliDay;
		$newdata = json_encode($data);
		log_message('info', '*****  Controller : ConfigSIP, Function : appDataForSIP, Message : get data for app data '.$newdata.' *****');
		echo '{"success":"true","data":'.$newdata.'}';
		
    }
	
	
	function modifysipPurchasedFundsOnServer()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $pageId=$_SESSION["pageId"];
            if(in_array("6", $pageId))
            {
                $requestDateOld=$this->input->post("requestDate");
                $noOfMonths=$this->input->post("noOfMonths");
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $json=$this->input->post("json");
                $fundTypeId=$this->input->post("fundTypeId");
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $investedFundList=json_decode($json,true);
				 log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, err_Msg1 : investedFundList *****');
				
                
				$result=$this->purchase_model->updateSipPurchsedFundsOnServer($investedFundList,$requestDate,$investorId,$noOfMonths);
				
			    if($result)
                {
                    $message="Successfully modified monthly SIP, effect from Nov ".$requestDateOld;
                    $this->session->set_flashdata('message', $message);
                    log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, Messege : '.$message.' *****');
                    echo '{"success":true}';
                    $message="Successfully modified monthly sip ".$fundTypeName." funds effect from ".$requestDateOld." Month ".$noOfMonths;
                    iLog($message,$investorId,'Web App','Investor',$investorId);
                }
                else
                {
                    echo '{"success":false}';
                    $message="Failed moditying invested  '.$fundTypeName.' funds";
                    log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, error_Messege :  '.$message.' *****');
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
				 
            }
        }
    }
	
	public function skeepThisMonth($monthlyInvestmentId)
	{
		$res = $this->purchase_model->selectSkipThisMonthSip($monthlyInvestmentId);
		date_default_timezone_set("Asia/Kolkata");
		$investmentDate=date("$res->next_investment_date");
		$next_investment_date = $res->next_investment_date;
	    $date = new DateTime($investmentDate);
	    $requestDate=$date->format('Y-m-d ').date("h:i:s");
	    $time = strtotime($requestDate);
	    $nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));		
		$response = $this->purchase_model->skipThisMonthSipModel($monthlyInvestmentId,$nextInvestmentDate);
		if($response)
		{
			$res = $this->db->query("SELECT users.phone, users.first_name, users.email, funds.scheme_description, monthly_investment.investor_id, monthly_investment.amount,monthly_investment.investor_id FROM monthly_investment JOIN investor ON monthly_investment.investor_id = investor.investor_id JOIN users ON users.id = investor.login_id JOIN funds ON monthly_investment.fund_id = funds.fund_id WHERE monthly_investment_id = ".$monthlyInvestmentId."");
			$res = $res->row();
			$first_name =  $this->encrypt->decode($res->first_name);
			$Phone =  $this->encrypt->decode($res->phone);
			$date=date_create("$nextInvestmentDate");
			$nextInvestmentDate = date_format($date,"d M Y");
			$msg = "Dear $first_name, your Monthly SIP Skipped Successfully for this month and your next investment date is ".$nextInvestmentDate.".%20%0A%20%0ATeam%20Investocafe ";
			$this->sendSms($Phone,$msg);
			$data['investor_name'] = $first_name;
			$data['msg'] = "Thank you for choosing Investocafe. You're on your way to growing your wealth safely with us.<br /><br />Your instruction for the execution with respect to your investments in Mutual Funds to Investocafe has been received and will be executed. The details are as under: ";
			$data['fund_name'] = $res->scheme_description;
			$data['old_date'] =  date_format(date_create($next_investment_date),"d M Y");
			$data['new_date'] = $nextInvestmentDate;
			$data['amount'] = $res->amount;
			$data['type_of_instruction'] = "Skip SIP";
			$data['investor_id'] = $res->investor_id;
			$data['subject'] = "Confirmation mail for Skip SIP";
			$this->sendMail($data,$res->email);
			notificationAlert('SIP Skipped',$first_name.' Skipped his/her Monthly SIP. email id '.$res->email.' phone number '.$Phone,$res->investor_id);
			iLog('Skipped his/her Monthly SIP next investment date is '.$nextInvestmentDate,$res->investor_id,'Web App','Investor',$res->investor_id);
			$message="Successfully Skip Monthly SIP This month Your Next Investment Date is ".$nextInvestmentDate." " ;
			 $this->session->set_flashdata('message', $message);
			 traking_data($monthlyInvestmentId,2);
			 log_message('info', '*****  Controller : ConfigSIP, Function : skeepThisMonth, Message : Skeep this month SIP for monthlyInvestmentId '.$monthlyInvestmentId.'  *****');
			return redirect('purchase/confirmationInvestedFunds');
		}
		else
		{
			$message="Sorry - There is some Problme to skip your SIP Date";
			log_message('info', '*****  Controller : ConfigSIP, Function : skeepThisMonth, Message : Sorry - There is some Problme to skip your SIP Date '.$monthlyInvestmentId.'  *****');
			$this->session->set_flashdata('message', $message);
			return redirect('purchase/confirmationInvestedFunds');
		}
	}
	
    public function appSkeepThisMonth()
	{
		$get = json_decode(file_get_contents('php://input'));
		$monthlyInvestmentId = $get->monthlyInvestmentId;
		$res = $this->purchase_model->selectSkipThisMonthSip($monthlyInvestmentId);
		date_default_timezone_set("Asia/Kolkata");
		$investmentDate=date("$res->next_investment_date");
		$next_investment_date = $res->next_investment_date;
	    $date = new DateTime($investmentDate);
	    $requestDate=$date->format('Y-m-d ').date("h:i:s");
	    $time = strtotime($requestDate);
	    $nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));		
		$response = $this->purchase_model->skipThisMonthSipModel($monthlyInvestmentId,$nextInvestmentDate);
		if($response)
		{
			$res = $this->db->query("SELECT users.phone, users.first_name, users.email, funds.scheme_description, monthly_investment.investor_id, monthly_investment.amount,monthly_investment.investor_id FROM monthly_investment JOIN investor ON monthly_investment.investor_id = investor.investor_id JOIN users ON users.id = investor.login_id JOIN funds ON monthly_investment.fund_id = funds.fund_id WHERE monthly_investment_id  = ".$monthlyInvestmentId."");
			traking_data($monthlyInvestmentId,2);
			$res = $res->row();
			$first_name =  $this->encrypt->decode($res->first_name);
			$Phone =  $this->encrypt->decode($res->phone);
			$email = $res->email;
			$date=date_create("$nextInvestmentDate");
			$nextInvestmentDate = date_format($date,"d M Y");
			$msg = "Dear $first_name, your Monthly SIP  Successfully skip for this month and your next investment date is ".$nextInvestmentDate.".%20%0A%20%0ATeam%20Investocafe ";
			$this->sendSms($Phone,$msg);
			$data['investor_name'] = $first_name;
			$data['msg'] = "Thank you for choosing Investocafe. You're on your way to growing your wealth safely with us.<br /><br />Your instruction for the execution with respect to your investments in Mutual Funds to Investocafe has been received and will be executed. The details are as under: ";
			$data['fund_name'] = $res->scheme_description;
			$data['old_date'] =  date_format(date_create($next_investment_date),"d M Y");
			$data['new_date'] = $nextInvestmentDate;
			$data['amount'] = $res->amount;
			$data['investor_id'] = $res->investor_id;
			$data['type_of_instruction'] = "Skip SIP";
			$data['subject'] = "Confirmation mail for Skip SIP";
			$this->sendMail($data,$email);
			iLog('Skipped his/her Monthly SIP next investment date is '.$nextInvestmentDate,$res->investor_id,'Mobile App','Investor',$res->investor_id);
			notificationAlert('SIP Skipped',$first_name.' Skipped his/her Monthly SIP. email id '.$email.' phone number '.$Phone,$res->investor_id);
			$message="Successfully Skip Monthly SIP This month Your Next Investment Date is ".$nextInvestmentDate." " ;
			
			log_message('info', '*****  Controller : ConfigSIP, Function : appSkeepThisMonth, Message : Successfully Skip Monthly SIP This month Your Next Investment Date is '.$nextInvestmentDate.' *****');
			echo '{"success":"true","msg":"'.$message.'"}';
		}
		else
		{
			$message="Sorry - There is some Problme to skip your SIP Date";
			log_message('info', '*****  Controller : ConfigSIP, Function : appSkeepThisMonth, Message : There is some Problme to skip your SIP Date *****');
			echo '{"success":"false","msg":"'.$message.'"}';
		}
	}
	
	public function StopSIP($monthlyInvestmentId)
	{
		$this->db->query("update monthly_investment set is_stopped_sip  = 1 where monthly_investment_id = $monthlyInvestmentId");
		
		if($this->db->affected_rows()>0)
		{
			$res = $this->db->query("SELECT users.phone, users.first_name, users.email, funds.scheme_description, monthly_investment.investor_id, monthly_investment.amount,monthly_investment.next_investment_date,monthly_investment.investor_id FROM monthly_investment JOIN investor ON monthly_investment.investor_id = investor.investor_id JOIN users ON users.id = investor.login_id JOIN funds ON monthly_investment.fund_id = funds.fund_id WHERE monthly_investment_id = ".$monthlyInvestmentId."");
			$res = $res->row();
			$first_name =  $this->encrypt->decode($res->first_name);
			$Phone =  $this->encrypt->decode($res->phone);
			$msg = "Dear $first_name, your Monthly SIP Stopped Successfully. %20%0A%20%0ATeam%20Investocafe";
			$this->sendSms($Phone,$msg);
			$data['investor_name'] = $this->encrypt->decode($_SESSION["userName"]);
			$data['msg'] = "Thank you for choosing Investocafe. You're on your way to growing your wealth safely with us.<br /><br />Your instruction for the execution with respect to your investments in Mutual Funds to Investocafe has been received and will be executed. The details are as under: ";
			$data['fund_name'] = $res->scheme_description;
			$data['old_date'] =  date_format(date_create($res->next_investment_date),"d M Y");
			$data['new_date'] = 'NIL';
			$data['amount'] = $res->amount;
			$data['investor_id'] = $res->investor_id;
			$data['type_of_instruction'] = "Stop SIP";
			$data['subject'] = "Confirmation mail for Stop SIP";
			$this->sendMail($data);
			traking_data($monthlyInvestmentId,1);
			$message="Your Monthly SIP successfully Stoped.";
			iLog('Monthly SIP of '.$res->scheme_description.' successfully Stoped ',$res->investor_id,'Mobile App','Investor',$res->investor_id);
			$this->session->set_flashdata('message', $message);
			log_message('info', '*****  Controller : ConfigSIP, Function : StopSIP, Message : Monthly SIP successfully Stoped for monthly investment id  '.$monthlyInvestmentId.' *****');
			return redirect('purchase/confirmationInvestedFunds');
		}
		else
		{
			$message="There is Some Problme to stop your SIP please Try Again Thank You" ;
			log_message('info', '*****  Controller : ConfigSIP, Function : StopSIP, Message : There is Some Problme to stop your SIP '.$monthlyInvestmentId.' *****');
			$this->session->set_flashdata('message', $message);
			return redirect('purchase/confirmationInvestedFunds');
		}
	}
	
	public function appStopSIP()
	{
		$get = json_decode(file_get_contents('php://input'));
		$monthlyInvestmentId = $get->monthlyInvestmentId;
		$sql="update monthly_investment set is_stopped_sip  = 1 where monthly_investment_id = $monthlyInvestmentId";
		$this->db->query($sql);
		if($this->db->affected_rows()>0)
		{
			
			$res = $this->db->query("SELECT users.phone, users.first_name, users.email, funds.scheme_description, monthly_investment.investor_id, monthly_investment.amount,monthly_investment.next_investment_date,monthly_investment.investor_id FROM monthly_investment JOIN investor ON monthly_investment.investor_id = investor.investor_id JOIN users ON users.id = investor.login_id JOIN funds ON monthly_investment.fund_id = funds.fund_id WHERE monthly_investment_id  = ".$monthlyInvestmentId."");
			$res = $res->row();
			$first_name =  $this->encrypt->decode($res->first_name);
			$email = $res->email;
			$Phone =  $this->encrypt->decode($res->phone);
			$msg = "Dear $first_name, your Monthly SIP Stopped Successfully. %20%0A%20%0ATeam%20Investocafe";
			$this->sendSms($Phone,$msg);
			$data['investor_name'] = $first_name;
			$data['msg'] = "Thank you for choosing Investocafe. You're on your way to growing your wealth safely with us.<br /><br />Your instruction for the execution with respect to your investments in Mutual Funds to Investocafe has been received and will be executed. The details are as under: ";
			$data['fund_name'] = $res->scheme_description;
			$data['old_date'] =  date_format(date_create($res->next_investment_date),"d M Y");
			$data['new_date'] = 'NIL';
			$data['investor_id'] = $res->investor_id;
			$data['amount'] = $res->amount;
			$data['type_of_instruction'] = "Stop SIP";
			$data['subject'] = "Confirmation mail for Stop SIP";
			iLog('Monthly SIP of '.$res->scheme_description.' successfully Stoped ',$res->investor_id,'Mobile App','Investor',$res->investor_id);
			traking_data($monthlyInvestmentId,1);
			$this->sendMail($data,$email);
			log_message('info', '*****  Controller : ConfigSIP, Function : appStopSIP, Message : successfully stop your SIP '.$monthlyInvestmentId.' *****');
			echo '{"success":"true" ,"msg":"Your Monthly SIP successfully Stoped"}';
		}
		else
		{
			log_message('info', '*****  Controller : ConfigSIP, Function : appStopSIP, Message : There is Some Problme to stop your SIP '.$monthlyInvestmentId.' *****');
			echo '{"success":"false","msg":"There is Some Problme to stop your SIP please Try Again Thank You"}';
		}
	}
	
	// stop temp
	function sendSms($Phone,$msg)
    {
        if($Phone!="" && $msg!="")
        {
            $ch = curl_init();
            $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$Phone."&message=".$msg."&sender=INCAFE&route=4&DLT_TE_ID=1207162122936120838";
            $url=str_replace(" ", "%20", $url1);
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$output = curl_exec($ch);
			$dbData = array ('phone'=>$Phone,'response'=>$output);
            $this->db->insert('msg_log',$dbData);
            curl_close($ch);
			if ( $output === FALSE)
            {
              $output=curl_error($ch); //echoes last session error
              return false;
            }
            // $this->sendSmstoadmin('9993011209',$msg);
            return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : sendPurchaseSms, Messege : Invalid user name or phone number for send Sms For purchase funds. *****");
        }
    }

    function sendSmstoadmin($Phone,$msg)
    {
        if($Phone!="" && $msg!="")
        {
            $ch = curl_init();
            $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$Phone."&message=Investor Id ".$_SESSION['investor_id']." ".$msg."&sender=INCAFE&route=4";
            $url=str_replace(" ", "%20", $url1);
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$output = curl_exec($ch);
			$dbData = array ('phone'=>$Phone,'response'=>$output);
            $this->db->insert('msg_log',$dbData);
            curl_close($ch);
			if ( $output === FALSE)
            {
              $output=curl_error($ch); //echoes last session error
              return false;
            }
            return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : sendPurchaseSms, Messege : Invalid user name or phone number for send Sms For purchase funds. *****");
        }
    }
	
	
    function sendMail($data,$email ="")
    {
		if($email == "")
		{
			$email = $_SESSION["email"];
		}
        $html = $this->load->view('skip_update_stop_sip_mail', $data, true);
        $subject=$data['subject'];
		$out = sendEmail($email,$subject,$html);
		$email = "tanish.goswami@investocafe.com";
		$out = sendEmail($email,$subject,$html);
		if(!$out)
		{
			log_message('info', '*****  Controller : ConfigSIP, Function : sendMail, Message : problem to send mail on '.$email.' *****');
		}
		$out = sendEmail('info@investocafe.com',$subject,$html);
        return $out;
    }
	
	
	public function test()
	{
		$html= $this->load->view('auth/email/monthlyStatment',$data);
	}
	
    
}