<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : AccountStatement
|   MODEL USE : registration_model
|   DATE : 08/10/2016
|   AUTHOER : amit meena
|   COMMENT : this function is used to add bank detail into database
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class AccountStatement extends CI_Controller {

  	function __construct()
  	{
  	    // Call the Model constructor
  	    parent::__construct();

        $this->load->model('dashboard/account_statement_model');
        $this->load->model('dashboard/dashboard_model');
  	}

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : index
|   DATE : 08/10/2016
|   COMMENT :  this function is used to load view of statment 
------------------------------------------------------------------------------------------------------------
*/
  	public function index()
  	{
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->data['pageTitle'] = 'Account Statement';
                    $this->_loadView('amit_theme/dashboard/account_statement_view');
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited Account Statement page");
                    addSystemLog($data); // helper function
                }
                else
                {
					log_message('info', '***** Controller : AccountStatement, Function : index, Message : Redirect to base url  *****');
                    redirect(base_url());
                }
            }
            else
            {
				log_message('info', '***** Controller : AccountStatement, Function : index, Message : Redirect to base url  *****');
                redirect(base_url());
            }
        }
        else
        {
			log_message('info', '***** Controller : AccountStatement, Function : index, Message : Redirect to base url  *****');
            redirect(base_url());
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : index
|   DATE : 08/10/2016
|   COMMENT :  _loadView function is used to load header and fooder and main view
------------------------------------------------------------------------------------------------------------
*/
    function _loadView($view)
    {
        $userId=$_SESSION["userId"];
        $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
        if($result)
        {
            $data["profileImageUrl"]=$result->profile_image_url;
            $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
            $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
            $data["is_verify"]=$result->is_verify;
        }
        else
        {
            $data["profileImageUrl"]="";
        }
        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }

        $investorId=$_SESSION["investor_id"];
        $resultInvestedFundNameList=$this->account_statement_model->getInvestedFundNameList($investorId);
        $data["investedFundNameList"]=$resultInvestedFundNameList;

        $resultInvestedTaxSavingsFundList=$this->account_statement_model->getInvestedTaxSavingsFundList($investorId);
        $data["investedTaxSavingsFundList"]=$resultInvestedTaxSavingsFundList;

        $resultInvestedFunds=$this->account_statement_model->getAllInvestedFundsList($investorId);
        $data["investedFunds"]=$resultInvestedFunds;
        $data["taxSvngInvFunds"]=$this->account_statement_model->getInvestmentHistory(5,3,$investorId);
        // get short terms and long terms capital gains
        $data["shortTermsCostValue"]=$this->account_statement_model->calShortTermsCostValue($investorId);
        $data["shortTermsCurrentValue"]=$this->account_statement_model->calShortTermsCurrentValue($investorId);


        $data["longTermsCurrentValue"]=$this->account_statement_model->calLongTermsCurrentValue($investorId);
        $data["longTermsCostValue"]=$this->account_statement_model->calLongTermsCostValue($investorId);

        $data["longTermGain"]="";
        $data['jsFile'] ='dashboard/accountStatement.js';
        $data['jsFileExtra'] ='dashboard/sipCalculation.js';
		log_message('info', '***** Controller : AccountStatement, Function : _loadView, Message : load account statment view  *****');
        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view,$data);
        $this->load->view('amit_theme/common/footer',$data );
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestmentHistory
|   DATE : 08/10/2016
|   COMMENT :  this function is get data from sold and purchased_units to get history of the user
------------------------------------------------------------------------------------------------------------
*/
    function getInvestmentHistory()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $selectDateRange=$this->input->post("selectDateRange");
            $fundType=$this->input->post("fundType");
            $investorId=$_SESSION["investor_id"];
            $result=$this->account_statement_model->getInvestmentHistory($selectDateRange,$fundType,$investorId);
            if($result)
            {
                $rowStr = "";
                foreach ($result as $row)
                {
                    $date = new DateTime($row->request_date);
                    $date= $date->format('M d,Y');
                    $rowStr .= '["'.$date.'","'.$row->name.'","'.$row->amount.'","'.$row->request_status.'"],';
                }
                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentHistory, Message : Successfully fetched investment history details  *****');
            }
            else
            {
                echo '{"success":false}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentHistory, Message : Failed to fetch investment history details  *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getInvestmentHistory, Message : Session expired while fetching investment history details  *****');
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : sendInvestmentHistory
|   DATE : 08/10/2016
|   COMMENT :  
------------------------------------------------------------------------------------------------------------
*/
    function sendInvestmentHistory()
    {
        $selectDateRange=$this->input->post("selectDateRange");
        $fundType=$this->input->post("fundType");
        $investorId=$this->input->post("investorId");
        $userId=$this->input->post("userId");
        $token=$this->input->post("token");
		
		
        if(isset($token) && !empty($token))
        {
            $matchToken = getToken($userId,$token);
		
            if($matchToken)
            {
                $result=$this->account_statement_model->getInvestmentHistory($selectDateRange,$fundType,$investorId);
				
                if($result)
                {
                    $rowStr = "";
                    echo json_encode($result);
					log_message('info', '***** Controller : AccountStatement, Function : sendInvestmentHistory, Message : send investment history to mobile  *****');
                }
                else
                {
				  log_message('info', '***** Controller : AccountStatement, Function : sendInvestmentHistory, Message : failed to load  *****');
                  echo false;
                }
            }
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestmentDetails
|   DATE : 08/10/2016
|   COMMENT :  this function is used to get all information about the user
------------------------------------------------------------------------------------------------------------
*/
    function getInvestmentDetails()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $fromDateStr=$this->input->post("fromDate");
            $fromDate=date('Y-m-d', strtotime($fromDateStr));
            $toDateStr=$this->input->post("toDate");
            $toDate=date('Y-m-d', strtotime($toDateStr));
            $fundSelected=$this->input->post("fundSelect");
            $investorId=$_SESSION["investor_id"];
            if($fundSelected=="all")
            {
                $result=$this->account_statement_model->getAllInvestmentDetails($fromDate,$toDate,$investorId);
                if($result)
                {
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentDetails, Message : Fetched all investment details from db for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                    $rowStr = "";
                    foreach ($result as $row)
                    {
                        $dateOfPurchase = new DateTime($row->date);
                        $date= $dateOfPurchase->format('M d,Y');
                        $fundType = $row->fund_type_name;
                        if($fundType=="MIP/Liquid (monthly income plan)")
                        {
                            $fundType="MIP";
                        }
                        $rowStr .= '["'.$date.'","'.$row->fund_name.'",'.$row->amount.',"'.$row->folio_number.'","'.$fundType.'","'.$row->purchased_withdrawn.'"],';
                    }
                    $pdfPath = $this->createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date);
                    if($pdfPath)
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentDetails, Message : Successfully generated pdf file for the investor_id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":true,"data":['.rtrim($rowStr, ',').'],"pdfPath":"'.$pdfPath.'"}';
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentDetails, Message : Failed to generate pdf file for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":false}';
                    }
                }
                else
                {
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentDetails, Message : Failed to fetch all investment details from db for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                    echo '{"success":false}';
                }
            }
            else
            {
                $result=$this->account_statement_model->getInvestmentDetails($fromDate,$toDate,$fundSelected,$investorId);
                // print_r("result : "+$result);die;
                if($result)
                {
                    // print("result is true ");die;
                    $rowStr = "";
                    foreach ($result as $row)
                    {
                        $dateOfPurchase = new DateTime($row->date);
                        $date= $dateOfPurchase->format('M d,Y');
                        $fundType = $row->fund_type_name;
                        // print_r($row->Purchased_Withdrawn);die;
                        if($fundType=="MIP/Liquid (monthly income plan)")
                        {
                            // print_r("true");die;
                            $fundType="MIP";
                        }
                        $rowStr .= '["'.$date.'","'.$row->fund_name.'",'.$row->amount.',"'.$row->folio_number.'","'.$fundType.'","'.$row->purchased_withdrawn.'"],';
                    }

                    $pdfPath = $this->createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date);
                    if($pdfPath)
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentDetails, Message : Successfully generated pdf file for the investor_id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":true,"data":['.rtrim($rowStr, ',').'],"pdfPath":"'.$pdfPath.'"}';
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentDetails, Message : Failed to generate pdf file for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":false}';
                    }
                }
                else
                {
                    echo '{"success":false}';
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getInvestmentDetails, Message : Failed to fetch all investment details from db for the investor id : '.$investorId.' *****');
                }
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getInvestmentDetails, Message : Session expired while fetching investment details from db for the investor id : '.$investorId.' *****');
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : createAccountStatementPdf
|   DATE : 08/10/2016
|   COMMENT :  this fucntion is used to create statment pdf file 
------------------------------------------------------------------------------------------------------------
*/
    function createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date)
    {
        $data["fromDate"]=$fromDateStr;
        $data["toDate"]=$toDateStr;
        $data["result"]=$result;
        $data["purchaseDate"]=$date;
        $result=$this->account_statement_model->getInvestorDetail($investorId);
        $data["investor"]=$result;
        $pdfBody = $this->load->view('account_statement_form_pdf_view',$data,true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try
        {
            $mpdf=new mPDF('win-1252','A4','','DejaVuSans',0,0,0,0,10,10,'');
            $mpdf->useOnlyCoreFonts = true;
            $mpdf->SetProtection(array('print'));
            $mpdf->SetTitle("Account Statement");
            $mpdf->SetAuthor("Investocafe");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');

            $html=$pdfBody;
            $mpdf->WriteHTML($html);

            $fileName = 'accountStatement'.$investorId.'_'.date('YmdHis', time()).'.pdf';
            $mpdf->Output(APPPATH.'../assets/uploads/account_statement/'.$fileName, 'F');
            $pdfPath = realpath(APPPATH.'../assets/uploads/account_statement/'.$fileName);
            return $fileName;
        }
        catch (Exception $e)
        {
            echo $e;die;
            
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getFundsInvestedDetails
|   DATE : 08/10/2016
|   COMMENT :  this  function is used to get all investment by the user
------------------------------------------------------------------------------------------------------------
*/

	function checkDatesFor(){
		$investorId=12;
		$fund_type="debtMip";
		$system_date=date('Y-m-d');
		$end_date = date('Y-m-d', strtotime('-1 year', strtotime($system_date)));
		$short_units=0;
		$long_units=0;
		$sold_short_units=0;
		$sold_long_units=0;	
		$total_units=0;
		$longShortTermResult=$this->account_statement_model->getFundsInvestedDetailsByFundTypeShortLong($investorId,$capitalGain);
		if($longShortTermResult)
		{
			$rowStr='';
				foreach($longShortTermResult as $res)
				{
					$fund_id=$res->fund_id;
					$fund_name=$res->fund_name;
					if($res->date_of_purchase<$end_date){
						$short_units=$short_units+floatval($res->unit_count);
					}else{
						$long_units=$long_units+floatval($res->unit_count);
					}
				}
			$soldUnitsResult=$this->account_statement_model->getTotalSoldUnitCountShortLong($investorId,$fund_id);
			if($soldUnitsResult){
			foreach($soldUnitsResult as $res)
			{
				$sold_unit_count=$res->unit_count;
				if($res->request_date<$end_date){
					$sold_short_units=$sold_short_units+floatval($sold_unit_count);
				}else{
					$sold_long_units=$sold_long_units+floatval($sold_unit_count);
				}
			}

			$long_units=$long_units-$sold_long_units;						
			$short_units=$short_units-$sold_short_units;
			$total_units=$long_units+$short_units;
			if($long_units==0){
				$long_units='NA';
			}
			if($short_units==0){
				$short_units='NA';
			}
			}else{
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : Successfully fetched capitalGain for equity fund type with No sold units exists *****'); 
			}
			$rowStr .= '["'.$fund_name.'",'.$total_units.',"'.$long_units.'","'.$short_units.'",'.$fund_id.'],';

			echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : Successfully fetched capitalGain for equity fund type ***** rowstr:'.$rowStr); 

		}
		else
		{

			echo '{"success":false,"response":"No Data"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : No data exists to fetch capitalGain for debt/mip fund type *****');

		}

	}


    
    function getFundsInvestedDetails()
    {
         $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $amount=0;
            $investorId=$_SESSION["investor_id"];
            // $investorId=18;
            // $getFundsInvestedResult=$this->account_statement_model->getFundsIndevisualFundsInvestedDetails($investorId,$fundTypeId);

            $getFundsInvestedResultNew = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id =  $investorId ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id =  $investorId AND request_status = 1 AND fund_history.is_latest = 1  GROUP BY purchased_units.fund_id");
            if($getFundsInvestedResultNew)
            {
                $rowStr="";
                
                   $fund_amount = $getFundsInvestedResultNew->result();
                    foreach($fund_amount as $fs)
                    {
                        
                        $current_invested_amount = $this->investmentCurrentValuenew($fs->fund_id,$investorId);
                        // @$calculted_funds['total']['all']['current_investment_amount'] += $current_invested_amount;
                        // @$calculted_funds['total']['all']['current_investment_value'] += $fs->current_amount;
                        @$calculted_funds['total'][$fs->fund_type_id]['current_investment_amount'] += $current_invested_amount;
                        @$calculted_funds['total'][$fs->fund_type_id]['current_investment_value'] += $fs->current_amount;
                        $fs->current_investment_amount = $current_invested_amount;
                        $calculted_funds['key'.$fs->fund_type_id][] = $fs;

                        


                        $rowStr .= '["'.$fs->fund_name.'",'.round($current_invested_amount,2).','.$fs->fund_id.',1,'.round($fs->current_amount,2).'],';
                       
                    }
                    // echo "<pre>";
                    //     echo($rowStr);


                    
               

                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : No data to fetch FundsInvestedDetails *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }
    }

     function getAllInvestmentStatusNew()
    {
         $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $amount=0;
            $investorId=$_SESSION["investor_id"];
            // $investorId=18;
            // $getFundsInvestedResult=$this->account_statement_model->getFundsIndevisualFundsInvestedDetails($investorId,$fundTypeId);

            $getFundsInvestedResultNew = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id =  $investorId ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id =  $investorId AND request_status = 1 AND fund_history.is_latest = 1  GROUP BY purchased_units.fund_id");
            if($getFundsInvestedResultNew)
            {
                $rowStr="";
                
                   $fund_amount = $getFundsInvestedResultNew->result();
                    foreach($fund_amount as $fs)
                    {
                        
                        $current_invested_amount = $this->investmentCurrentValuenew($fs->fund_id,$investorId);
                        @$currentAmount += $current_invested_amount;
                        @$investedAmount += $fs->current_amount;
                        // // @$calculted_funds['total'][$fs->fund_type_id]['current_investment_amount'] += $current_invested_amount;
                        // // @$calculted_funds['total'][$fs->fund_type_id]['current_investment_value'] += $fs->current_amount;
                        // // $fs->current_investment_amount = $current_invested_amount;
                        // // $calculted_funds['key'.$fs->fund_type_id][] = $fs
                       
                    }
                    // echo "<pre>";
                    //     echo($rowStr);
                    $sold_amt = $this->db->query("SELECT SUM(`sold_amount`) as sold_amount  FROM sold_units WHERE investor_id = $investorId and request_status = 1");
                    // echo $this->db->last_query();
                    if($sold_amt->num_rows() > 0){
                        $soldAmount = $sold_amt->row()->sold_amount;
                    }else{
                        $soldAmount = 0;
                    }
                    echo '{"success":true,"currentAmount":"'.round($investedAmount,2).'","soldAmount":"'.round($soldAmount,2).'","curentInv":"'.round($currentAmount,2).'"}';
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : No data to fetch FundsInvestedDetails *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }
    }

    function getFundsIndevisualInvestedDetailsTotal($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $amount=0;
            $investorId=$_SESSION["investor_id"];
            // $get = json_decode(file_get_contents("php://input"));

            // $fundTypeId=$get->fundTypeId;

            // $investorId=18;
            // $getFundsInvestedResult=$this->account_statement_model->getFundsIndevisualFundsInvestedDetails($investorId,$fundTypeId);

            $getFundsInvestedResultNew = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id =  $investorId ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id =  $investorId AND request_status = 1 AND fund_history.is_latest = 1 AND funds.fund_type_id = $fundTypeId GROUP BY purchased_units.fund_id");
            if($getFundsInvestedResultNew)
            {
                $rowStr="";
                
                   $fund_amount = $getFundsInvestedResultNew->result();
                    foreach($fund_amount as $fs)
                    {
                        
                        $current_invested_amount = $this->investmentCurrentValuenew($fs->fund_id,$investorId);
                        // @$calculted_funds['total']['all']['current_investment_amount'] += $current_invested_amount;
                        // @$calculted_funds['total']['all']['current_investment_value'] += $fs->current_amount;
                        @$totalInvestAmount += round($current_invested_amount,2);
                         @$totalAmount += round($fs->current_amount,2);
                        // // $fs->current_investment_amount = $current_invested_amount;
                        // // $calculted_funds['key'.$fs->fund_type_id][] = $fs;            
                        // $rowStr .= '["'.$fs->fund_name.'",'.$current_invested_amount.','.$fs->fund_id.',1,'.$fs->current_amount.'],';
                       
                    }
                    // echo "<pre>";
                    //     echo($rowStr);


                    
               

                // echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                echo '{"success":true,"rel_amnt":"1","currentValue":"'.$totalAmount.'","totalInvestAmount":"'.$totalInvestAmount.'"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : No data to fetch FundsInvestedDetails *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }
    }

    public function investmentCurrentValuenew($fund_id,$investor_id)
    {
        $res_purchase_fund = $this->db->query("SELECT * FROM purchased_units WHERE investor_id = $investor_id AND request_status = 1 AND fund_id = $fund_id");
        $res_unit_sum_sold_fund = $this->db->query("SELECT SUM(unit_count) as units FROM sold_units WHERE investor_id = $investor_id AND request_status = 1 AND fund_id = $fund_id");
        if($res_unit_sum_sold_fund->num_rows() > 0)
        {
            $purchase_fund = $res_purchase_fund->result();
            $total_sold_units =  $res_unit_sum_sold_fund->row()->units;
            $remaining_units =$total_sold_units;
            $current_amount = 0;
            foreach($purchase_fund as $pf)
            {
                $remaining_units = $remaining_units - $pf->unit_count;
                if($current_amount > 0)
                {
                    $current_amount = $current_amount + $pf->purchased_amount;
                }

                if($remaining_units < 0 && $current_amount ==0)
                {
                    $old_nav = $pf->purchased_amount/$pf->unit_count;
                    $current_amount = $old_nav* abs($remaining_units);
                }
            }

            return round($current_amount);
        }
    }

    function appGetFundsInvestedDetails()
    {
        $get = json_decode(file_get_contents("php://input"));
        $investorId = $get->investorId;
        if($investorId)
        {
            $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetails($investorId);
            if($getFundsInvestedResult)
            {
                $rowStr="";
                foreach($getFundsInvestedResult as $getFundsInvestedRow)
                {
                    $unitCount=$getFundsInvestedRow->unit_count;
                    $fund_id=$getFundsInvestedRow->fund_id;
                    $fund_type_id=$getFundsInvestedRow->fund_type_id;
                    $total_purchased_amount_by_fundId=$getFundsInvestedRow->total_amount;
                    $total_sold_amount_by_fundIdResult=$this->account_statement_model->getFundsSoldDetails($investorId,$fund_id);
                    if($total_sold_amount_by_fundIdResult)
                    {
                      $total_sold_amount_by_fundId=$total_sold_amount_by_fundIdResult->total_amount;
                    }
                    else
                    {
                      $total_sold_amount_by_fundId=0;
                    }
                    $presentInvestedAmount=$total_purchased_amount_by_fundId-$total_sold_amount_by_fundId;
                    $fund_name=$getFundsInvestedRow->fund_name;
                    $presentResult=$this->checkPresentValueByFundId($fund_id,$investorId);
                    if(isset($presentResult) && !empty($presentResult))
                    {
                       $amount=$presentResult;
                    }
                    $resz = $this->db->query("select SUM(unit_count) as unit_count  from sold_units where investor_id = $investorId and fund_id = $fund_id and request_status =1");
                    $sold_unit_count = $resz->row()->unit_count;

                    if($sold_unit_count != $unitCount){
                    $rowStr .= '{"fund_name" : "'.$fund_name.'","presentInvestedAmount" : "'.$presentInvestedAmount.'","fund_id" : "'.$fund_id.'","fund_type_id" : "'.$fund_type_id.'", "unitCount" : "'.$unitCount.'","amount" : "'.$amount.'"},';
                    }
                }

                echo '{"success":"true","data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
                echo '{"success":"false","response":"No Data"}';
                log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getFundsInvestedDetails, Message : No data to fetch FundsInvestedDetails *****');
            }
        }
        else
        {
            echo '{"success":"false","session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }
    }

    function appGetFundsInvestedDetails2()
    {
            $get = json_decode(file_get_contents("php://input"));
            $investorId = $get->investorId;
            $amount=0;
            $getFundsInvestedResultNew = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id =  $investorId ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id =  $investorId AND request_status = 1 AND fund_history.is_latest = 1  GROUP BY purchased_units.fund_id");
            if($getFundsInvestedResultNew)
            {
                $rowStr="";
                   $fund_amount = $getFundsInvestedResultNew->result();
                    foreach($fund_amount as $fs)
                    {
                        $current_invested_amount = $this->investmentCurrentValuenew($fs->fund_id,$investorId);
                        // @$calculted_funds['total']['all']['current_investment_amount'] += $current_invested_amount;
                        // @$calculted_funds['total']['all']['current_investment_value'] += $fs->current_amount;
                        @$calculted_funds['total'][$fs->fund_type_id]['current_investment_amount'] += $current_invested_amount;
                        @$calculted_funds['total'][$fs->fund_type_id]['current_investment_value'] += $fs->current_amount;
                        $fs->current_investment_amount = $current_invested_amount;
                        $calculted_funds['key'.$fs->fund_type_id][] = $fs;
                        $rowStr .= '["'.$fs->fund_name.'",'.round($current_invested_amount,2).','.$fs->fund_id.',1,'.round($fs->current_amount,2).'],';
                       
                    }
                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
            }
    }
	
    function getFundsIndevisualInvestedDetails($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $amount=0;
            $investorId=$_SESSION["investor_id"];
            // $investorId=18;
            // $getFundsInvestedResult=$this->account_statement_model->getFundsIndevisualFundsInvestedDetails($investorId,$fundTypeId);

            $getFundsInvestedResultNew = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id =  $investorId ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id =  $investorId AND request_status = 1 AND fund_history.is_latest = 1 AND funds.fund_type_id = $fundTypeId GROUP BY purchased_units.fund_id");
            if($getFundsInvestedResultNew)
            {
                $rowStr="";
                
                   $fund_amount = $getFundsInvestedResultNew->result();
                    foreach($fund_amount as $fs)
                    {
                        
                        $current_invested_amount = $this->investmentCurrentValuenew($fs->fund_id,$investorId);
                        // @$calculted_funds['total']['all']['current_investment_amount'] += $current_invested_amount;
                        // @$calculted_funds['total']['all']['current_investment_value'] += $fs->current_amount;
                        @$calculted_funds['total'][$fs->fund_type_id]['current_investment_amount'] += $current_invested_amount;
                        @$calculted_funds['total'][$fs->fund_type_id]['current_investment_value'] += $fs->current_amount;
                        $fs->current_investment_amount = $current_invested_amount;
                        $calculted_funds['key'.$fs->fund_type_id][] = $fs;

                        


                        $rowStr .= '["'.$fs->fund_name.'",'.round($current_invested_amount,2).','.$fs->fund_id.',1,'.round($fs->current_amount,2).'],';
                       
                    }
                    // echo "<pre>";
                    //     echo($rowStr);


                    
               

                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : No data to fetch FundsInvestedDetails *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }
    }
	
	
	
    function getFundsIndevisualInvestedDetailsTest($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
			$amount=0;
            $investorId=30;
            $getFundsInvestedResult=$this->account_statement_model->getFundsIndevisualFundsInvestedDetails($investorId,$fundTypeId);
			
			echo "<pre>";
			print_r($getFundsInvestedResult);
            if($getFundsInvestedResult)
            {
                $rowStr="";
                foreach($getFundsInvestedResult as $getFundsInvestedRow)
                {
                    $unitCount=$getFundsInvestedRow->unit_count;
                    $fund_id=$getFundsInvestedRow->fund_id;
                    $total_purchased_amount_by_fundId=$getFundsInvestedRow->total_amount;
                    $total_sold_amount_by_fundIdResult=$this->account_statement_model->getFundsSoldDetails($investorId,$fund_id);
					
                    if($total_sold_amount_by_fundIdResult)
                    {
                      $total_sold_amount_by_fundId=$total_sold_amount_by_fundIdResult->total_amount;
					  print_r($total_sold_amount_by_fundId."<br />");
                    }
                    else {
                      $total_sold_amount_by_fundId=0;
                    }
					if($total_purchased_amount_by_fundId > $total_sold_amount_by_fundId)
					{
						$presentInvestedAmount=$total_purchased_amount_by_fundId-$total_sold_amount_by_fundId;
					}
					else{
						$presentInvestedAmount= 0;
					}
                    

                    $fund_name=$getFundsInvestedRow->fund_name;

                    $presentResult=$this->checkPresentValueByFundId($fund_id,$investorId);
                    if(isset($presentResult) && !empty($presentResult))
                    {
                       $amount=$presentResult;
                    }
					if($presentInvestedAmount > 1)
					{
						$rowStr .= '["'.$fund_name.'",'.$presentInvestedAmount.','.$fund_id.','.$unitCount.','.$amount.'],';
					}
                }

                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : No data to fetch FundsInvestedDetails *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }
    }
	
	function mytestNoInvestmentFound()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetails($investorId);
            if($getFundsInvestedResult)
            {
                $rowStr="";
                foreach($getFundsInvestedResult as $getFundsInvestedRow)
                {
                    $unitCount=$getFundsInvestedRow->unit_count;
                    $fund_id=$getFundsInvestedRow->fund_id;
                    $total_purchased_amount_by_fundId=$getFundsInvestedRow->total_amount;
                    $total_sold_amount_by_fundIdResult=$this->account_statement_model->getFundsSoldDetails($investorId,$fund_id);
                    if($total_sold_amount_by_fundIdResult)
                    {
                      $total_sold_amount_by_fundId=$total_sold_amount_by_fundIdResult->total_amount;
                    }
                    else {
                      $total_sold_amount_by_fundId=0;
                    }
                    $presentInvestedAmount=$total_purchased_amount_by_fundId-$total_sold_amount_by_fundId;

                    $fund_name=$getFundsInvestedRow->fund_name;

                    $presentResult=$this->checkPresentValueByFundId($fund_id,$investorId);
                    if(isset($presentResult) && !empty($presentResult))
                    {
                       $amount=$presentResult;
                    }

                    $rowStr .= '["'.$fund_name.'",'.$presentInvestedAmount.','.$fund_id.','.$unitCount.','.$amount.'],';
                }

                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getFundsInvestedDetails, Message : No data to fetch FundsInvestedDetails *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }
    }
	
	
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : checkPresentValueByFundId
|   DATE : 08/10/2016
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
    function checkPresentValueByFundId($fund_id,$investorId)
    {
        $resultPurchaseFunds=$this->account_statement_model->getPurchaseFundsReadytoPurchase($fund_id,$investorId);
        $resultSoldFunds=$this->account_statement_model->getSoldFundsAfterSuccess($fund_id,$investorId);

        $amount="";

        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            $purchaseFundId=$resultPurchaseFunds->fund_id;
            $purchaseUnits=$resultPurchaseFunds->unit_count;
            $nav=$resultPurchaseFunds->nav;
            $soldCount=0;

            if(isset($resultSoldFunds) && !empty($resultSoldFunds))
            {
                $soldFundId=$resultSoldFunds->fund_id;
                $soldUnits=$resultSoldFunds->unit_count;
                if($soldFundId==$purchaseFundId)
                {
                  $balanceUnit=($purchaseUnits-$soldUnits);
                  $soldCount++;
                }
            }

            if($soldCount==0)
            {
                $balanceUnit=$purchaseUnits;
            }

            /** caluculate withdraw amount **/
            $withdrawalAmount=($balanceUnit*$nav);
            $amount=$withdrawalAmount;
            return round($amount,2);
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getCapitalGainList
|   DATE : 08/10/2016
|   COMMENT : this function is get getCapitalGainList of all funds
------------------------------------------------------------------------------------------------------------
*/

	function justTestCapitalGan(){
		$investorId=12;
		$capitalGain='debtMip';
		$term='<';
		$mainArr=array();
		$longTermResult=$this->account_statement_model->getFundsInvestedDetailsByFundTypeShortLong($investorId,$capitalGain,$term);
		if($longTermResult){
			$longTermArray=array();
			foreach ($longTermResult as $row)
			{
				$iArray=array($row->fund_id,$row->fund_name,$row->unit_count);
				array_push($longTermArray,$iArray);
			}
			echo '<pre>';
			print_r($longTermArray);
		}	
		$term='>';
		$shortTermResult=$this->account_statement_model->getFundsInvestedDetailsByFundTypeShortLong($investorId,$capitalGain,$term);
		if($shortTermResult){
			$shortTermArray=array(); 
			foreach ($shortTermResult as $row)
			{
				$iArray=array($row->fund_id,$row->fund_name,$row->unit_count);
				array_push($shortTermArray,$iArray);
			}
			echo '<pre>';
			print_r($shortTermArray);
		}
		$mainArray=array();
		$rowStr ='';
		if(!empty($longTermArray)){
			for($i=0;$i<count($longTermArray);$i++){
				if(!empty($shortTermArray)){				
					for($j=0;$j<count($shortTermArray);$j++){
						if($longTermArray[$i][0]==$shortTermArray[$j][0]){
							$fund_id=$longTermArray[$i][0];
							$fund_name=$longTermArray[$i][1];
							$short_units=$longTermArray[$i][2];
							$long_units=$shortTermArray[$j][2];
							$total_units=$short_units+$long_units;
							$fund_name=$longTermArray[$i][1];
							$rowStr .= '["'.$fund_name.'","'.$total_units.'","'.$short_units.'","'.$long_units.'",'.$fund_id.'],';
						}else{
							$fund_id=$longTermArray[$i][0];
							$fund_name=$longTermArray[$i][1];
							$short_units=$longTermArray[$i][2];
							$long_units=0;
							$total_units=$short_units;
							$rowStr .= '["'.$fund_name.'","'.$total_units.'","'.$short_units.'","'.$long_units.'",'.$fund_id.'],';
						}
					}

				}else{
					$fund_id=$longTermArray[$i][0];
					$fund_name=$longTermArray[$i][1];
					$short_units=$longTermArray[$i][2];
					$long_units=0;
					$total_units=$short_units;
					$rowStr .= '["'.$fund_name.'","'.$total_units.'","'.$short_units.'","'.$long_units.'",'.$fund_id.'],';
			}
			}
		}
	}
	
    function getCapitalGainList()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $capitalGain=$this->input->post("capitalGain");		
			if($capitalGain=="debtMip"||$capitalGain=="equity")
            {
				
				$getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetailsByFundType($investorId,$capitalGain);
                if($getFundsInvestedResult)
                {
					$shortArray=array();
					$longArray=array();
						$shortResult=$this->account_statement_model->getFundsInvestedDetailsByFundTypeShortLong($investorId,$capitalGain,'>');
						if($shortResult){
							foreach ($shortResult as $row)
										{
											
											if($row->fund_id){
												$fund_id=$row->fund_id;
												$unit_count=$row->unit_count;
												$soldLongTermResult=$this->account_statement_model->getTotalSoldUnitCountShortLongTerms($investorId,$row->fund_id,$capitalGain,'>');
												if($soldLongTermResult){													
													$unit_count=$unit_count-$soldLongTermResult->unit_count;
												}
												$iArray=array($fund_id,$row->fund_name,$unit_count);
												array_push($shortArray,$iArray);
											}
										}
						}				
						$longResult=$this->account_statement_model->getFundsInvestedDetailsByFundTypeShortLong($investorId,$capitalGain,'<');
						if($longResult){
							foreach ($longResult as $row)
										{
												if($row->fund_id){
												$fund_id=$row->fund_id;
												$unit_count=$row->unit_count;
												$soldShortTermResult=$this->account_statement_model->getTotalSoldUnitCountShortLongTerms($investorId,$row->fund_id,$capitalGain,'<');
												if($soldShortTermResult){
													$unit_count=$unit_count-$soldShortTermResult->unit_count;
												}
												$iArray=array($fund_id,$row->fund_name,$unit_count);
												array_push($longArray,$iArray);
												}
										}
						}
								$rowStr ='';
								$firstArray=array();
								$secondArray=array();
								if(count($shortArray)>count($longArray)){
									$firstArray=$shortArray;
									$secondArray=$longArray;
								}else{
									$firstArray=$longArray;
									$secondArray=$shortArray;
								}
					
							for($i=0;$i<count($firstArray);$i++){
									//	echo ' <br> long fund id'.$shortArray[$i][0];exit;
										$fund_id=$firstArray[$i][0];
										$fund_name=$firstArray[$i][1];
										$short_units=$firstArray[$i][2];
										$long_units=0;
										$total_units=0;
									if(!empty($secondArray)){				
										for($j=0;$j<count($secondArray);$j++){
												if($firstArray[$i][0]==$secondArray[$j][0]){												
													$long_units=$secondArray[$j][2];
												}
										}
										
									}
									$total_units=$short_units+$long_units;
									$rowStr .= '["'.$fund_name.'","'.$total_units.'","'.$short_units.'","'.$long_units.'",'.$fund_id.'],';
								}
						  echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
				}else{
					 echo '{"success":false,"response":"No Data"}';
                 	
				}
				
				
            }else  if($capitalGain=="taxSaving")
            {
                $fundType="taxSaving";
                $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetailsByFundType($investorId,$fundType);
                 if($getFundsInvestedResult)
                {
                    $rowStr="";
                    foreach($getFundsInvestedResult as $getFundsInvestedRow)
                    {
                        $totalPurchasedUnitCount=floatval($getFundsInvestedRow->unit_count);
                        $fund_id=$getFundsInvestedRow->fund_id;
                        $totalSoldUnitCountResult=$this->account_statement_model->getTotalSoldUnitCount($investorId,$fund_id);
                        if($totalSoldUnitCountResult)
                        {
                            $totalSoldUnitCount=$totalSoldUnitCountResult->unit_count;
                        }
                        else {
                            $totalSoldUnitCount=0;
                        }
                        $presentInvestedUnitCount=floatval($totalPurchasedUnitCount-$totalSoldUnitCount);
                        $fund_name=$getFundsInvestedRow->fund_name;

                        $rowStr .= '["'.$fund_name.'",'.$presentInvestedUnitCount.','.$fund_id.'],';
                    }

                    echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : Successfully fetched capitalGain for equity fund type *****');
                }
                else
                {
                    echo '{"success":false,"response":"No Data"}';
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : No data exists to fetch capitalGain for equity fund type *****');
                }
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getCapitalGainList, Message : Session expired while fetching getCapitalGainList *****');
        }
    }
	
	
	
    function testItgetCapitalGainList()
	{ 
		$capitalGain="taxSaving";
		$logged=$this->ion_auth->logged_in();
        $investorId=$_SESSION["investor_id"];
        if($capitalGain=="taxSaving")
        {
            $fundType="taxSaving";
            $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetailsByFundType($investorId,$fundType);
			echo $capitalGain;
			echo '<pre>';
			print_r($getFundsInvestedResult);
			exit;
            if($getFundsInvestedResult)
            {
                $rowStr="";
                foreach($getFundsInvestedResult as $getFundsInvestedRow)
                {
                    $totalPurchasedUnitCount=floatval($getFundsInvestedRow->unit_count);
                    $fund_id=$getFundsInvestedRow->fund_id;
                    $totalSoldUnitCountResult=$this->account_statement_model->getTotalSoldUnitCount($investorId,$fund_id);
                    if($totalSoldUnitCountResult)
                    {
                        $totalSoldUnitCount=$totalSoldUnitCountResult->unit_count;
                    }
                    else {
                        $totalSoldUnitCount=0;
                    }
                    $presentInvestedUnitCount=floatval($totalPurchasedUnitCount-$totalSoldUnitCount);
                    $fund_name=$getFundsInvestedRow->fund_name;

                    $rowStr .= '["'.$fund_name.'",'.$presentInvestedUnitCount.','.$fund_id.'],';
                }

                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : Successfully fetched capitalGain for equity fund type *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : No data exists to fetch capitalGain for equity fund type *****');
            }
        }
        else if($capitalGain=="debtMip")
        {
            $fundType="debtMip";
            $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetailsByFundType($investorId,$fundType);
            if($getFundsInvestedResult)
            {
                $rowStr="";
                foreach($getFundsInvestedResult as $getFundsInvestedRow)
                {
                    $totalPurchasedUnitCount=floatval($getFundsInvestedRow->unit_count);
                    $fund_id=$getFundsInvestedRow->fund_id;
                    $totalSoldUnitCountResult=$this->account_statement_model->getTotalSoldUnitCount($investorId,$fund_id);
                    if($totalSoldUnitCountResult)
                    {
                        $totalSoldUnitCount=$totalSoldUnitCountResult->unit_count;
                    }
                    else {
                        $totalSoldUnitCount=0;
                    }
                    $presentInvestedUnitCount=floatval($totalPurchasedUnitCount-$totalSoldUnitCount);
                    $fund_name=$getFundsInvestedRow->fund_name;

                    $rowStr .= '["'.$fund_name.'",'.$presentInvestedUnitCount.','.$fund_id.'],';
                }
                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : Successfully fetched capitalGain for debt/mip fund type *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getCapitalGainList, Message : No data exists to fetch capitalGain for debt/mip fund type *****');
            }
        }
      
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getCapitalGainList
|   DATE : 08/10/2016
|   COMMENT :this function is used to get getTaxSavingList list of all funds
------------------------------------------------------------------------------------------------------------
*/
    function getTaxSavingList()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $fundType="taxSaving";
            $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetailsByFundType($investorId,$fundType);
            if($getFundsInvestedResult)
            {
                $rowStr="";
                foreach($getFundsInvestedResult as $getFundsInvestedRow)
                {
                    $totalPurchasedUnitCount=floatval($getFundsInvestedRow->unit_count);
                    $fund_id=$getFundsInvestedRow->fund_id;
                    $totalSoldUnitCountResult=$this->account_statement_model->getTotalSoldUnitCount($investorId,$fund_id);
                    if($totalSoldUnitCountResult)
                    {
                      $totalSoldUnitCount=$totalSoldUnitCountResult->unit_count;
                    }
                    else 
                    {
                        $totalSoldUnitCount=0;
                    }
                    $presentInvestedUnitCount=floatval($totalPurchasedUnitCount-$totalSoldUnitCount);
                    $fund_name=$getFundsInvestedRow->fund_name;

                    $rowStr .= '["'.$fund_name.'",'.$presentInvestedUnitCount.','.$fund_id.'],';
                }

                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingList, Message : Successfully fetched capitalGain for tax saving fund type *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingList, Message : No data exists to fetch capitalGain for tax saving fund type *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getTaxSavingList, Message : Session expired while fetching getTaxSavingList *****');
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getTaxSavingDetails
|   DATE : 08/10/2016
|   COMMENT : this function get all getTaxSavingDetails funds Detail
------------------------------------------------------------------------------------------------------------
*/
    function getTaxSavingDetails()
    {
        if(checkuser_session())
        {
            $fromDateStr=$this->input->post("fromDate1");
            $fromDate=date('Y-m-d', strtotime($fromDateStr));
            $toDateStr=$this->input->post("toDate1");
            $toDate=date('Y-m-d', strtotime($toDateStr));
            $fundSelected=$this->input->post("selectTaxFunds");
            $investorId=$_SESSION["investor_id"];
            if($fundSelected=="all")
            {
                $result=$this->account_statement_model->getAllTaxSavingDetails($fromDate,$toDate,$investorId);
                if($result)
                {
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingDetails, Message : Fetched tax savings details from db for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                    // print("result is true ");die;
                    $rowStr = "";
                    foreach ($result as $row)
                    {
                        $dateOfPurchase = new DateTime($row->date);
                        $date= $dateOfPurchase->format('M d,Y');
                        $fundType = $row->fund_type_name;

                        $rowStr .= '["'.$date.'","'.$row->fund_name.'",'.$row->amount.',"'.$row->folio_number.'","'.$fundType.'","'.$row->purchased_withdrawn.'"],';
                    }

                    $pdfPath = $this->createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date);

                    if($pdfPath)
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingDetails, Message : pdf file generated for the investor_id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":true,"data":['.rtrim($rowStr, ',').'],"pdfPath":"'.$pdfPath.'"}';
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingDetails, Message : Failed to generate pdf file for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":false}';
                    }
                }
                else
                {
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingDetails, Message : Failed to fetch tax savings details from db for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                    echo '{"success":false}';
                }
            }
            else
            {
                $result=$this->account_statement_model->getTaxSavingDetails($fromDate,$toDate,$fundSelected,$investorId);
                if($result)
                {
                    $rowStr = "";
                    foreach ($result as $row)
                    {
                        $dateOfPurchase = new DateTime($row->date);
                        $date= $dateOfPurchase->format('M d,Y');
                        $fundType = $row->fund_type_name;
                        // print_r($row->Purchased_Withdrawn);die;

                        $rowStr .= '["'.$date.'","'.$row->fund_name.'",'.$row->amount.',"'.$row->folio_number.'","'.$fundType.'","'.$row->purchased_withdrawn.'"],';
                    }

                    $pdfPath = $this->createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date);
                    if($pdfPath)
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingDetails, Message : pdf file generated for the investor_id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":true,"data":['.rtrim($rowStr, ',').'],"pdfPath":"'.$pdfPath.'"}';
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingDetails, Message : Failed to generate pdf file for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":false}';
                    }
                }
                else
                {
                    echo '{"success":false}';
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : accountStatement, Function : getTaxSavingDetails, Message : Failed to fetch getTaxSavingDetails from db for the investor id : '.$investorId.' *****');
                }
            }
        }
        else
        {
          echo '{"success":false,"session":"out"}';
          log_message('info', '***** Controller : accountStatement, Function : getTaxSavingDetails, Message : Session expired while trying to fetch getTaxSavingDetails for the investor id : '.$investorId.' *****');
        }
    }
	
	

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : appLoadView
|   DATE : 08/10/2016
|   COMMENT :  _loadView function is used to load header and fooder and main view
------------------------------------------------------------------------------------------------------------
*/

    function appLoadView()
    {
		$get = json_decode(file_get_contents("php://input"));
		$investorId=$get->investorId;
        $userId= $get->userId;
        $resultInvestedFundNameList=$this->account_statement_model->getInvestedFundNameList($investorId);
        $data["investedFundNameList"]=$resultInvestedFundNameList;
        $resultInvestedTaxSavingsFundList=$this->account_statement_model->getInvestedTaxSavingsFundList($investorId);
        $data["investedTaxSavingsFundList"]=$resultInvestedTaxSavingsFundList;
        $resultInvestedFunds=$this->account_statement_model->getAllInvestedFundsList($investorId);
        $data["investedFunds"]=$resultInvestedFunds;
        $data["taxSvngInvFunds"]=$this->account_statement_model->getInvestmentHistory(5,3,$investorId);
        // get short terms and long terms capital gains
        $data["shortTermsCostValue"]=$this->account_statement_model->calShortTermsCostValue($investorId);
        $data["shortTermsCurrentValue"]=$this->account_statement_model->calShortTermsCurrentValue($investorId);
        $data["longTermsCurrentValue"]=$this->account_statement_model->calLongTermsCurrentValue($investorId);
        $data["longTermsCostValue"]=$this->account_statement_model->calLongTermsCostValue($investorId);
		$out = json_encode($data);
        echo $out;
    }

    public function appLoadViewIOS()
    {
        $get = json_decode(file_get_contents("php://input"));
        $investorId=$get->investorId;
        $userId= $get->userId;
        $resultInvestedFundNameList=$this->account_statement_model->getInvestedFundNameList($investorId);
        if($resultInvestedFundNameList){
            $data["investedFundNameList"]=$resultInvestedFundNameList;
        }else{
            $data["investedFundNameList"]= [];
        }
        $resultInvestedTaxSavingsFundList=$this->account_statement_model->getInvestedTaxSavingsFundList($investorId);
        $data["investedTaxSavingsFundList"]=$resultInvestedTaxSavingsFundList;
        $resultInvestedFunds=$this->account_statement_model->getAllInvestedFundsList($investorId);
        $data["investedFunds"]=$resultInvestedFunds;
        $data["taxSvngInvFunds"]=$this->account_statement_model->getInvestmentHistory(5,3,$investorId);
        // get short terms and long terms capital gains
        $data["shortTermsCostValue"]=$this->account_statement_model->calShortTermsCostValue($investorId);
        $data["shortTermsCurrentValue"]=$this->account_statement_model->calShortTermsCurrentValue($investorId);
        $data["longTermsCurrentValue"]=$this->account_statement_model->calLongTermsCurrentValue($investorId);
        $data["longTermsCostValue"]=$this->account_statement_model->calLongTermsCostValue($investorId);
        $out = json_encode($data);
        echo $out;
    }
	
	
	

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : appGetInvestmentHistory
|   DATE : 08/10/2016
|   COMMENT :  this function is get data from sold and purchased_units to get history of the user
------------------------------------------------------------------------------------------------------------
*/

    function appGetInvestmentHistory()
    {
        $get = json_decode(file_get_contents("php://input"));
		$investorId=$get->investorId;
        if($investorId)
        {
            $selectDateRange = $get->selectDateRange;
            $fundType = $get->fundType;
            $result=$this->account_statement_model->getInvestmentHistory($selectDateRange,$fundType,$investorId);
            if($result)
            {
                $rowStr = "";
                foreach ($result as $row)
                {
                    $date = new DateTime($row->request_date);
                    $date= $date->format('M d,Y');
                    $rowStr .= '["'.$date.'","'.$row->name.'","'.$row->amount.'","'.$row->request_status.'"],';
                }
                echo '{"success":"true","data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentHistory, Message : Successfully fetched investment history details  *****');
            }
            else
            {
                echo '{"success":"false"}';
                log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentHistory, Message : Failed to fetch investment history details  *****');
            }
        }
        else
        {
            echo '{"success":"false","session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getInvestmentHistory, Message : Session expired while fetching investment history details  *****');
        }
    }

	

/*

------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestmentDetails
|   DATE : 08/10/2016
|   COMMENT :  this function is used to get all information about the user
------------------------------------------------------------------------------------------------------------
*/
    function appGetInvestmentDetails()
    {
        $get = json_decode(file_get_contents("php://input"));
		$investorId = $get->investorId;
        if($investorId)
        {
            $fromDateStr=$get->fromDate;
            $fromDate=date('Y-m-d', strtotime($fromDateStr));
            $toDateStr= $get->toDate;
            $toDate=date('Y-m-d', strtotime($toDateStr));
            $fundSelected= $get->fundSelect;
			if($fundSelected=="all")
            {
                $result=$this->account_statement_model->getAllInvestmentDetails($fromDate,$toDate,$investorId);
                if($result)
                {
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentDetails, Message : Fetched all investment details from db for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                    $rowStr = "";
                    foreach ($result as $row)
                    {
                        $dateOfPurchase = new DateTime($row->date);
                        $date= $dateOfPurchase->format('M d,Y');
                        $fundType = $row->fund_type_name;
                        if($fundType=="MIP/Liquid (monthly income plan)")
                        {
                            $fundType="MIP";
                        }
                        $rowStr .= '{"Date":"'.$date.'","FundName" : "'.$row->fund_name.'","InvestedAmount" : "'.$row->amount.'","FolioNumber" : "'.$row->folio_number.'", "FundType" : "'.$fundType.'","Status" : "'.$row->purchased_withdrawn.'"},';
                    }
                    $pdfPath = $this->createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date);
                    if($pdfPath)
                    {
                       log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentDetails, Message : Successfully generated pdf file for the investor_id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                       echo '{"success":"true","data":['.rtrim($rowStr, ',').'],"pdfPath":"'.$pdfPath.'"}';
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentDetails, Message : Failed to generate pdf file for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":"false"}';
                    }
                }
                else
                {
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentDetails, Message : Failed to fetch all investment details from db for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                    echo '{"success":"false"}';
                }
            }
            else
            {
                $result=$this->account_statement_model->getInvestmentDetails($fromDate,$toDate,$fundSelected,$investorId);
                if($result)
                {
                    $rowStr = "";
                    foreach ($result as $row)
                    {
                        $dateOfPurchase = new DateTime($row->date);
                        $date= $dateOfPurchase->format('M d,Y');
                        $fundType = $row->fund_type_name;
                        if($fundType=="MIP/Liquid (monthly income plan)")
                        {
							$fundType="MIP";
                        }
						 $rowStr .= '{"Date":"'.$date.'","FundName" : "'.$row->fund_name.'","InvestedAmount" : "'.$row->amount.'","FolioNumber" : "'.$row->folio_number.'", "FundType" : "'.$fundType.'","Status" : "'.$row->purchased_withdrawn.'"},';
                    }

                    $pdfPath = $this->createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date);
                    if($pdfPath)
                    {
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentDetails, Message : Successfully generated pdf file for the investor_id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":"true","data":['.rtrim($rowStr, ',').'],"pdfPath":"'.$pdfPath.'"}';
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentDetails, Message : Failed to generate pdf file for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":"false"}';
                    }
                }
                else
                {
                    echo '{"success":"false"}';
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getInvestmentDetails, Message : Failed to fetch all investment details from db for the investor id : '.$investorId.' *****');
                }
            }
        }
        else
        {
            echo '{"success":"false","session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getInvestmentDetails, Message : Session expired while fetching investment details from db for the investor id : '.$investorId.' *****');
        }
    }

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getFundsInvestedDetails
|   DATE : 08/10/2016
|   COMMENT :  this  function is used to get all investment by the user
------------------------------------------------------------------------------------------------------------
*/



    function appGetFundsInvestedDetailsByFundTypeId()
    {
        $get = json_decode(file_get_contents("php://input"));
		$investorId = $get->investorId;
		$fundTypeId = $get->fundTypeId;
        if($investorId)
        {
            $getFundsInvestedResult=$this->account_statement_model->getFundsIndevisualFundsInvestedDetails($investorId,$fundTypeId);
            if($getFundsInvestedResult)
            {
                $rowStr="";
                foreach($getFundsInvestedResult as $getFundsInvestedRow)
                {
                    $unitCount=$getFundsInvestedRow->unit_count;
                    $fund_id=$getFundsInvestedRow->fund_id;
					$fund_type_id=$getFundsInvestedRow->fund_type_id;
                    $total_purchased_amount_by_fundId=$getFundsInvestedRow->total_amount;
                    $total_sold_amount_by_fundIdResult=$this->account_statement_model->getFundsSoldDetails($investorId,$fund_id);
                    if($total_sold_amount_by_fundIdResult)
                    {
                      $total_sold_amount_by_fundId=$total_sold_amount_by_fundIdResult->total_amount;
                    }
                    else
					{
                      $total_sold_amount_by_fundId=0;
                    }
                    $presentInvestedAmount=$total_purchased_amount_by_fundId-$total_sold_amount_by_fundId;
                    $fund_name=$getFundsInvestedRow->fund_name;
                    $presentResult=$this->checkPresentValueByFundId($fund_id,$investorId);
                    if(isset($presentResult) && !empty($presentResult))
                    {
                       $amount=$presentResult;
                    }
                    $rowStr .= '{"fund_name" : "'.$fund_name.'","presentInvestedAmount" : "'.$presentInvestedAmount.'","fund_id" : "'.$fund_id.'","fund_type_id" : "'.$fund_type_id.'", "unitCount" : "'.$unitCount.'","amount" : "'.$amount.'"},';
                }

                echo '{"success":"true","data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
                echo '{"success":"false","response":"No Data"}';
                log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getFundsInvestedDetails, Message : No data to fetch FundsInvestedDetails *****');
            }
        }
        else
        {
            echo '{"success":"false","session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }
    }
	
    function appGetFundsInvestedDetails3()
    {
            $get = json_decode(file_get_contents("php://input"));
            $investorId = $get->investorId;
            $amount=0;
            $getFundsInvestedResultNew = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id =  $investorId ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id =  $investorId AND request_status = 1 AND fund_history.is_latest = 1  GROUP BY purchased_units.fund_id");
            if($getFundsInvestedResultNew)
            {
                $rowStr="";
                   $fund_amount = $getFundsInvestedResultNew->result();
                    foreach($fund_amount as $fs)
                    {
                        $current_invested_amount = $this->investmentCurrentValuenew($fs->fund_id,$investorId);
                        // @$calculted_funds['total']['all']['current_investment_amount'] += $current_invested_amount;
                        // @$calculted_funds['total']['all']['current_investment_value'] += $fs->current_amount;
                        @$calculted_funds['total'][$fs->fund_type_id]['current_investment_amount'] += $current_invested_amount;
                        @$calculted_funds['total'][$fs->fund_type_id]['current_investment_value'] += $fs->current_amount;
                        $fs->current_investment_amount = $current_invested_amount;
                        $calculted_funds['key'.$fs->fund_type_id][] = $fs;
                        $rowStr .= '{"fund_name":"'.$fs->fund_name.'","presentInvestedAmount":'.round($current_invested_amount,2).',"fund_id":'.$fs->fund_id.',"fund_type_id":'.$fs->fund_type_id.',"amount":'.round($fs->current_amount,2).'},';
                       
                    }
                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
            }
    }
	

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getTaxSavingDetails
|   DATE : 08/10/2016
|   COMMENT : this function get all getTaxSavingDetails funds Detail
------------------------------------------------------------------------------------------------------------
*/

    function appGetTaxSavingDetails()
    {
			$get = json_decode(file_get_contents("php://input"));
			$fromDateStr = $get->fromDate;
            $fromDate=date('Y-m-d', strtotime($fromDateStr));
            $toDateStr = $get->toDate;
            $toDate=date('Y-m-d', strtotime($toDateStr));
            $fundSelected= $get->fundSelect;
            $investorId = $get->investorId;
            if($fundSelected=="all")
            {
                $result=$this->account_statement_model->getAllTaxSavingDetails($fromDate,$toDate,$investorId);
                if($result)
                {
                   log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getTaxSavingDetails, Message : Fetched tax savings details from db for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                   // print("result is true ");die;
                    $rowStr = "";
                    foreach ($result as $row)
                    {
                        $dateOfPurchase = new DateTime($row->date);
                        $date= $dateOfPurchase->format('M d,Y');
                        $fundType = $row->fund_type_name;
                        $rowStr .= '{"Date":"'.$date.'","FundName":"'.$row->fund_name.'","InvestedAmount":"'.$row->amount.'","FolioNumber":"'.$row->folio_number.'","FundType":"'.$fundType.'","Status":"'.$row->purchased_withdrawn.'"},';
                    }
					$pdfPath = $this->createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date);
                    if($pdfPath)
                    {
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getTaxSavingDetails, Message : pdf file generated for the investor_id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":"true","data":['.rtrim($rowStr, ',').'],"pdfPath":"'.$pdfPath.'"}';
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getTaxSavingDetails, Message : Failed to generate pdf file for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":"false"}';
                    }
                }
                else
                {
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getTaxSavingDetails, Message : Failed to fetch tax savings details from db for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                    echo '{"success":"false"}';
                }

            }
            else
            {
                $result=$this->account_statement_model->getTaxSavingDetails($fromDate,$toDate,$fundSelected,$investorId);
                if($result)
                {
                   $rowStr = "";
                    foreach ($result as $row)
                    {
                       $dateOfPurchase = new DateTime($row->date);
                        $date= $dateOfPurchase->format('M d,Y');
                        $fundType = $row->fund_type_name;
                        // print_r($row->Purchased_Withdrawn);die;
                        $rowStr .= '{"Date":"'.$date.'","FundName":"'.$row->fund_name.'","InvestedAmount":"'.$row->amount.'","FolioNumber":"'.$row->folio_number.'","FundType":"'.$fundType.'","Status":"'.$row->purchased_withdrawn .'"},';
                    }
                    $pdfPath = $this->createAccountStatementPdf($fromDateStr,$toDateStr,$investorId,$result,$date);
                    if($pdfPath)
                    {
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getTaxSavingDetails, Message : pdf file generated for the investor_id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":"true","data":['.rtrim($rowStr, ',').'],"pdfPath":"'.$pdfPath.'"}';
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getTaxSavingDetails, Message : Failed to generate pdf file for the investor id : '.$investorId.' from '.$fromDateStr.' to '.$toDateStr.' *****');
                        echo '{"success":"false"}';
                    }
                }
                else
                {
                    echo '{"success":"false"}';
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getTaxSavingDetails, Message : Failed to fetch getTaxSavingDetails from db for the investor id : '.$investorId.' *****');
                }
            }
    }	
	
	
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : appGetCapitalGainList
|   DATE : 16/12/16
|   COMMENT : this function is get getCapitalGainList of all funds
------------------------------------------------------------------------------------------------------------
*/
	
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : appGetCapitalGainList
|   DATE : 16/12/16
|   COMMENT : this function is get getCapitalGainList of all funds
------------------------------------------------------------------------------------------------------------
*/
  	
  function appGetCapitalGainList()
  {
		$get = json_decode(file_get_contents("php://input"));
        if(isset($get->investorId)&&($get->capitalGain))
        {   
            $investorId=$get->investorId;
            $capitalGain=$get->capitalGain;
       		if($capitalGain=="debtMip"||$capitalGain=="equity")
            {
				 $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetailsByFundType($investorId,$capitalGain);
                 if($getFundsInvestedResult)
                {
					$shortArray=array();
					$longArray=array();
						$shortResult=$this->account_statement_model->getFundsInvestedDetailsByFundTypeShortLong($investorId,$capitalGain,'<');
						if($shortResult)
						{
							foreach ($shortResult as $row)
							{
								if($row->fund_id)
								{
									$fund_id=$row->fund_id;
									$unit_count=$row->unit_count;
									$soldShortRes=$this->account_statement_model->getTotalSoldUnitCountShortLongTerms($investorId,$row->fund_id,$capitalGain,'<');
									if($soldShortRes){													
										$unit_count=$unit_count-$soldShortRes->unit_count;
									}
									$iArray=array($fund_id,$row->fund_name,$unit_count);
									array_push($shortArray,$iArray);
								}
							}
						}				
						$longResult=$this->account_statement_model->getFundsInvestedDetailsByFundTypeShortLong($investorId,$capitalGain,'>');
						if($longResult){
							foreach ($longResult as $row)
							{
								if($row->fund_id)
								{
									$fund_id=$row->fund_id;
									$unit_count=$row->unit_count;
									$soldLongRes=$this->account_statement_model->getTotalSoldUnitCountShortLongTerms($investorId,$row->fund_id,$capitalGain,'>');
									if($soldLongRes){
										$unit_count=$unit_count-$soldLongRes->unit_count;
									}
									$iArray=array($fund_id,$row->fund_name,$unit_count);
									array_push($longArray,$iArray);
								}
							}
						}
								$rowStr ='';
								/* 	$newArray=$shortTermArray;
								$shortTermArray=$shortArray;
								$shortArray=$newArray; */
								if(count($shortArray)>count($longArray))
								{
										for($i=0;$i<count($shortArray);$i++)
										{
											$fund_id=$shortArray[$i][0];
											$fund_name=$shortArray[$i][1];
											$short_units=$shortArray[$i][2];
											$long_units=0;
											$total_units=0;
											if(!empty($longArray))
											{				
												for($j=0;$j<count($longArray);$j++)
												{
													if($shortArray[$i][0]==$longArray[$j][0])
													{												
														$long_units=$longArray[$j][2];
													}
												}
											}
											$total_units=$short_units+$long_units;
											$rowStr .= '{"fund_name":"'.$fund_name.'","total_units":"'.$total_units.'","short_units":"'.$short_units.'","long_units":"'.$long_units.'","fund_id":"'.$fund_id.'"},';
										}
								 }
								 else
								 {
										for($i=0;$i<count($longArray);$i++)
										{
											$fund_id=$longArray[$i][0];
											$fund_name=$longArray[$i][1];
											$short_units=$longArray[$i][2];
											$long_units=0;
											$total_units=0;
											if(!empty($shortArray))
											{				
												for($j=0;$j<count($shortArray);$j++)
												{
													if($longArray[$i][0]==$shortArray[$j][0])
													{												
														$long_units=$shortArray[$j][2];
													}
												}
											}
											$total_units=$short_units+$long_units;
											$rowStr .= '{"fund_name":"'.$fund_name.'","total_units":"'.$total_units.'","short_units":"'.$short_units.'","long_units":"'.$long_units.'","fund_id":"'.$fund_id.'"},';
										}
								}
					
						
						  echo '{"success":"true","data":['.rtrim($rowStr, ',').']}';
						   log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getCapitalGainList, Message : Data exists to fetch capitalGain for '.$capitalGain.' fund type *****');
				}else{
					 echo '{"success":false,"response":"No Data"}';
					  log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getCapitalGainList, Message : No data exists to fetch capitalGain for '.$capitalGain.' fund type *****');
                 	
				}
				
				
            }else  if($capitalGain=="taxSaving")
            {
                $fundType="taxSaving";
                $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetailsByFundType($investorId,$fundType);
                 if($getFundsInvestedResult)
                {
                    $rowStr="";
                    foreach($getFundsInvestedResult as $getFundsInvestedRow)
                    {
                        $totalPurchasedUnitCount=floatval($getFundsInvestedRow->unit_count);
                        $fund_id=$getFundsInvestedRow->fund_id;
                        $totalSoldUnitCountResult=$this->account_statement_model->getTotalSoldUnitCount($investorId,$fund_id);
                        if($totalSoldUnitCountResult)
                        {
                            $totalSoldUnitCount=$totalSoldUnitCountResult->unit_count;
                        }
                        else {
                            $totalSoldUnitCount=0;
                        }
                        $presentInvestedUnitCount=floatval($totalPurchasedUnitCount-$totalSoldUnitCount);
                        $fund_name=$getFundsInvestedRow->fund_name;

                        $rowStr .= '{"fund_name":"'.$fund_name.'","total_units":"'.$presentInvestedUnitCount.'","fund_id":"'.$fund_id.'"},'; 
                    }

                   echo '{"success":"true","data":['.rtrim($rowStr, ',').']}';
				}
                else
                {
                    echo '{"success":"false","response":"No Data"}';
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getCapitalGainList, Message : No data exists to fetch capitalGain for '.$capitalGain.' fund type *****');
                }
            }
        }
        else
        {
            echo '{"success":"false","session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : appGetCapitalGainList, Message : Session expired while fetching getCapitalGainList *****');
        }
  }
	
	
	
	
	
}
