<?php 


class ApiAccountStatment extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		$this->load->model('api_model/api_account_statment_model');
		$this->load->model('api_model/api_dashboard_model');
	}
	
	public function index()
	{
		// echo "account statment is working";
		$this->load->view('api_view/account_statement_form_pdf_view');
	}

	public function getInvestedFund()
	{
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$userData = json_decode(decode($post->login_token));
							$funds_name = $this->api_account_statment_model->get_invested_fund_name($userData->investor_id);
							if($funds_name){
								response(['invested_funds' => $funds_name]);
							}else{
								$error[] = "There no invested funds";
	    						errorResponse($error,404);
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}


	public function createInvestmentdata()
	{
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($post)){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$error = [];

							$userData = json_decode(decode($post->login_token));
							unset($post->login_token);
							// print_r($post);
							// $this->load->model('dashboard/account_statement_model');
							if(!isset($post->fund_id)){
								$error[] = "fund_id is mandatory";
							}

							if(!isset($post->start_date)){
								$error[] = "start_date is mandatory";
							}

							if(!isset($post->end_date)){
								$error[] = "end_date is mandatory";
							}

							if(!isset($post->fund_name)){
								$error[] = "fund_name is mandatory";
							}

							if(count($error) == 0){

								$res = $this->api_account_statment_model->getFundDetail($userData->investor_id,$post->fund_id,$post->start_date,$post->end_date);
								$userDatail = $this->api_account_statment_model->getUserDetail($userData->investor_id);

								$fund_detail = $this->getPortFolio($userData->investor_id,$post->fund_id,$post->fund_name);

								if($res){
									$html = $this->load->view('api_view/account_statement_form_pdf_view',['Fund_detail'=>$fund_detail,'transections' => $res,'userDatail' => $userDatail,'start_date'=>$post->start_date,'end_date'=>$post->end_date],true);

									$pdf_path = $this->createAccountStatementPdf($html);

									response(['Fund_detail'=>$fund_detail,'transections' => $res,'pdf_path'=> base_url('assets/uploads/account_statement/')."/".$pdf_path]);
								}else{
									$error[] = "No transection found";
		    						errorResponse($error,404);
								}
							}else{
								errorResponse($error,404);
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}

	public function getPortFolio($investor_id,$fund_id,$fund_name)
	{
		$calculted_funds = [];
		$fund_amount = $this->api_account_statment_model->getInvestedFund($investor_id,$fund_id);
		if($fund_amount)
		{
			$current_invested_amount = $this->investmentCurrentValue($fund_amount->fund_id,$investor_id);
			$calculted_funds['fund_name'] = $fund_name;
			@$calculted_funds['current_investment_amount'] += $current_invested_amount[0];
			@$calculted_funds['current_investment_value'] += $fund_amount->current_amount;
			$calculted_funds['available_units'] = $current_invested_amount[1];
		}
		return ((object)$calculted_funds);
	}


	public function investmentCurrentValue($fund_id,$investor_id)
	{
		$res_purchase_fund = $this->api_dashboard_model->purchaseFund($investor_id,$fund_id);
		$res_unit_sum_sold_fund = $this->api_dashboard_model->unitSumOfSoldUnits($investor_id, $fund_id);
		if($res_unit_sum_sold_fund->num_rows() > 0)
		{
			$purchase_fund = $res_purchase_fund;
			$total_sold_units =  $res_unit_sum_sold_fund->row()->units;
			$remaining_units =$total_sold_units;
			$current_amount = 0;
			foreach($purchase_fund as $pf)
			{
				$remaining_units = $remaining_units - $pf->unit_count;
				if($current_amount > 0)
				{
					$current_amount = $current_amount + $pf->purchased_amount;
				}

				if($remaining_units < 0 && $current_amount ==0)
				{
					$old_nav = $pf->purchased_amount/$pf->unit_count;
					$current_amount = $old_nav* abs($remaining_units);
				}
			}
			return [round($current_amount),abs($remaining_units)];
		}
	}

	public function createAccountStatementPdf($html)
    {
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try
        {
            $mpdf=new mPDF('win-1252','A4','','DejaVuSans',0,0,0,0,10,10,'');
            $mpdf->useOnlyCoreFonts = true;
            $mpdf->SetProtection(array('print'));
            $mpdf->SetTitle("Account Statement");
            $mpdf->SetAuthor("Investocafe");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');
            $mpdf->SetFooter('<p style="color:#00a0e3;font-size:8px;text-align: center">Investocafe B-302 Cross Road, IDA Mall, Behind G. Sachanand Viajay Nagar, Indore - 452010  Ph. 0731-4043703 (Monday - Suturday : 10:00 AM to 7:00 PM)</p>');
            $mpdf->WriteHTML($html);
            $fileName = 'accountStatement'.$investorId.'_'.date('YmdHis', time()).'.pdf';
            $mpdf->Output(APPPATH.'../assets/uploads/account_statement/'.$fileName, 'F');
            $pdfPath = realpath(APPPATH.'../assets/uploads/account_statement/'.$fileName);
            return $fileName;
        }
        catch (Exception $e)
        {
            echo $e;die;
            
        }
    }
}