<?php 

class ApiCalculator extends CI_Controller{
	
	public function index()
	{
		echo "calculator running ....";
	}

	public function returnOnMySIP()
	{
		$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							if(isset($post->invest_every_month)){
								if(is_numeric($post->invest_every_month)){
									if($post->invest_every_month > 0){
										$monthlyInvestment = $post->invest_every_month;
									}else{
										$error[] = "invest_every_month did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for invest_every_month";
								}
							}else{
								$error[] = "Key invest_every_month not receive";
							}

							if(isset($post->number_of_investment_months)){
								if(is_numeric($post->number_of_investment_months)){
									if($post->number_of_investment_months > 0){
										$noOfYearReachGoal = $post->number_of_investment_months/12;
									}else{
										$error[] = "number_of_investment_months did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for number_of_investment_months";
								}
							}else{
								$error[] = "Key number_of_investment_months not receive";
							}

							if(isset($post->expected_annual_return )){
								if(is_numeric($post->expected_annual_return )){
									if($post->expected_annual_return   > 0){
										$expectedReturn = $post->expected_annual_return ;
									}else{
										$error[] = "expected_annual_return did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for expected_annual_return";
								}
							}else{
								$error[] = "Key expected_annual_return  not receive";
							}
							if(count($error) > 0){
								errorResponse($error,404);
							}else{
								$Y=$noOfYearReachGoal;
								$n=12;
								$c1=($expectedReturn/(100*$n));
								$c2=pow(1+$c1,$n*$Y);
								$c3=$c2-1;
								$totalCost = $monthlyInvestment * $c3/$c1;
								response(['totalReturn'=>$totalCost,"investment_amount"=>$Y*12*$monthlyInvestment]);
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}

	public function goalBasedInvestmentCalculator()
	{
		$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							if(isset($post->target)){
								if(is_numeric($post->target)){
									if($post->target > 0){
										$totalCostTodays = $post->target;
									}else{
										$error[] = "target did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for target";
								}
							}else{
								$error[] = "Key target not receive";
							}

							if(isset($post->number_of_investment_months)){
								if(is_numeric($post->number_of_investment_months)){
									if($post->number_of_investment_months > 0){
										$noOfYearReachGoal = $post->number_of_investment_months/12;
									}else{
										$error[] = "number_of_investment_months did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for number_of_investment_months";
								}
							}else{
								$error[] = "Key number_of_investment_months not receive";
							}

							if(isset($post->expected_annual_return )){
								if(is_numeric($post->expected_annual_return )){
									if($post->expected_annual_return   > 0){
										$expectedReturn =$post->expected_annual_return;
									}else{
										$error[] = "expected_annual_return did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for expected_annual_return";
								}
							}else{
								$error[] = "Key expected_annual_return  not receive";
							}
							if(count($error) > 0){
								errorResponse($error,404);
							}else{

								$expInflation=0;
								$Y=$noOfYearReachGoal;
								$n=12;
								$totalCost=round($totalCostTodays* pow(1+ ($expInflation/100),$Y));
								$c1=($expectedReturn/(100*$n));
								$c2=pow(1+$c1,$n*$Y);
								$c3=$c2-1;
								$monthlyInvestment = round(($totalCost*$c1)/$c3 );
								response(['monthlyInvestment'=>$monthlyInvestment]);
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}

	public function childEducationCalculator()
	{
		$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							if(isset($post->target)){
								if(is_numeric($post->target)){
									if($post->target > 0){
										$totalCostTodaysEducation = $post->target;
									}else{
										$error[] = "target did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for target";
								}
							}else{
								$error[] = "Key target not receive";
							}

							if(isset($post->number_of_investment_months)){
								if(is_numeric($post->number_of_investment_months)){
									if($post->number_of_investment_months > 0){
										$noOfYearReachGoalEducation = $post->number_of_investment_months/12;
									}else{
										$error[] = "number_of_investment_months did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for number_of_investment_months";
								}
							}else{
								$error[] = "Key number_of_investment_months not receive";
							}

							if(isset($post->expected_annual_return )){
								if(is_numeric($post->expected_annual_return )){
									if($post->expected_annual_return   > 0){
										$expectedReturnEducation =$post->expected_annual_return;
									}else{
										$error[] = "expected_annual_return did not zero or negative";
									}
								}else{
									$error[] = "Invalid value for expected_annual_return";
								}
							}else{
								$error[] = "Key expected_annual_return  not receive";
							}

							if(isset($post->exp_inflation_education )){
								if(is_numeric($post->exp_inflation_education )){
										$expInflationEducation =$post->exp_inflation_education;
								}else{
									$error[] = "Invalid value for exp_inflation_education";
								}
							}else{
								$error[] = "Key exp_inflation_education not receive";
							}

							if(count($error) > 0){
								errorResponse($error,404);
							}else{
								// $expInflationEducation=0;
								$Y=$noOfYearReachGoalEducation;
								$n=12;
								$totalCost=round($totalCostTodaysEducation* pow(1+ ($expInflationEducation/100),$Y));
								$c1=($expectedReturnEducation/(100*$n));
								$c2=pow(1+$c1,$n*$Y);
								$c3=$c2-1;
								$monthlyInvestment = round(($totalCost*$c1)/$c3 );
								response(['monthlyInvestment'=>$monthlyInvestment,"totalCost"=>$totalCost]);
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}


	public function calculateTaxSavings()
	{
		$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							if(isset($post->income)){
								if(is_numeric($post->income)){
									$income = $post->income;
								}else{
									$error[] = "Invalid value of income";
								}
							}else{
								$error[] = "Key income not found";
							}

							// 
							if(isset($post->epf)){
								if(is_numeric($post->epf)){
									$epf = $post->epf;
								}else{
									$error[] = "Invalid value of epf";
								}
							}else{
								$error[] = "Key epf not found";
							}

							//
							if(isset($post->ppf)){
								if(is_numeric($post->ppf)){
									$ppf = $post->ppf;
								}else{
									$error[] = "Invalid value of ppf";
								}
							}else{
								$error[] = "Key ppf not found";
							}

							//
							if(isset($post->bankFd)){
								if(is_numeric($post->bankFd)){
									$bankFd = $post->bankFd;
								}else{
									$error[] = "Invalid value of bankFd";
								}
							}else{
								$error[] = "Key bankFd not found";
							}

							//
							if(isset($post->lic)){
								if(is_numeric($post->lic)){
									$lic = $post->lic;
								}else{
									$error[] = "Invalid value of lic";
								}
							}else{
								$error[] = "Key lic not found";
							}

							// 
							if(isset($post->loanRepayment)){
								if(is_numeric($post->loanRepayment)){
									$loanRepayment = $post->loanRepayment;
								}else{
									$error[] = "Invalid value of loanRepayment";
								}
							}else{
								$error[] = "Key loanRepayment not found";
							}

							// 
							if(isset($post->tutionFee)){
								if(is_numeric($post->tutionFee)){
									$tutionFee = $post->tutionFee;
								}else{
									$error[] = "Invalid value of tutionFee";
								}
							}else{
								$error[] = "Key tutionFee not found";
							}

							// 
							if(isset($post->others)){
								if(is_numeric($post->others)){
									$others = $post->others;
								}else{
									$error[] = "Invalid value of others";
								}
							}else{
								$error[] = "Key others not found";
							}

							if(count($error)>0){
								errorResponse($error,404);
							}else{
								if ($income <= 0){ //Stop if income is nil
									$error[] = "Income cannot be blank";
						    		errorResponse($error,404);
								}
								if($epf < 0 || $ppf < 0 || $lic < 0 || $bankFd < 0 || $loanRepayment < 0 || $tutionFee < 0 || $others < 0){
									$error[] = "Investments cannot be negative";
						    		errorResponse($error,404);
								}
									$total_c = $epf + $ppf + $lic + $bankFd + $loanRepayment + $tutionFee + $others; //calculate total investments
								if ($income < $total_c){
									$error[] = "Income cannot be less than total investments";
						    		errorResponse($error,404);
								}
								if($total_c > 150000){
									$total_c = 150000; //restrict deductions to a maximum of Rs. 1,50,000
								}
								$total_inc = $income - $total_c; //calculate total income after deductio
								$tax1 = $this->tax_calc($income); //calculate tax on income
								$tax2 = $this->tax_calc($total_inc); //calculate tax on income after deductions
								$tax_saving = round(1.03*($tax1 - $tax2)); //calculate tax savings
								$tax3 = 0;
								if($total_c < 150000){
									$tax3 = $this->tax_calc(max(250000,$income-150000)); //if 80C not fully utilised, calculate further savings possible
								}
								$output_text = "";
								if($total_c < 150000 && ($tax2-$tax3) > 0){ //investment less than 1.5 lakhs and further tax saving possible
									$output_text = "You can save further Rs. ".round(($tax2 - $tax3)*1.03)." by investing Rs. ".max(min(150000 - $total_c,$income-($total_c + 270000)),0)." in ELSS Mutual funds.";
								}
								$tax4 = $this->tax_calc(max(250000,$income-200000)); //Calculate tax if investment is made in NPS
								$tax5 = 0;
								if($tax3 == 0 && ($income-150000)>270000){
									$tax5 = $tax2; //if 80C fully utilised
								} else {
									$tax5 = $tax3; //if 80C not fully utilised
								}
								if(($tax5-$tax4) > 0){
									$output_text = $output_text." You can save further Rs. ".min(round(($tax5 - $tax4)*1.03),5150)." by investing Rs. ".min(round(($tax5 - $tax4)*10),50000)." in NPS.";
								}
								response(['totalDeductions' => $total_c, 'totalIncomeAfterDed' => $total_inc, 'output_text'=>$output_text]);
							}

						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}

	public function tax_calc($i)
	{
		$tax = 0;
		if($i<=270000){
			$tax = 0;
		} else if($i<=500000){
			$tax = ($i-270000)*0.1;
		} else if($i<=1000000){
			$tax = ($i-500000)*0.2+25000;
		} else {
			$tax = ($i-1000000)*0.3+125000;
		}
		return $tax;
	}


	public function retirementCalculator()
	{
		$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							if(isset($post->currentMonthlyExpense)){
								if(is_numeric($post->currentMonthlyExpense) && $post->currentMonthlyExpense>0){
									$cme = $post->currentMonthlyExpense;
								}else{
									$error[] = "Invalid value of currentMonthlyExpense";
								}
							}else{
								$error[] = "key currentMonthlyExpense not receive";
							}

							if(isset($post->currentAge)){
								if(is_numeric($post->currentAge) && $post->currentAge>0){
									$ca = $post->currentAge;
								}else{
									$error[] = "Invalid value of currentAge";
								}
							}else{
								$error[] = "key currentAge not receive";
							}

							if(isset($post->retirementAge)){
								if(is_numeric($post->retirementAge) && $post->retirementAge>0){
									$ra = $post->retirementAge;
								}else{
									$error[] = "Invalid value of retirementAge";
								}
							}else{
								$error[] = "key retirementAge not receive";
							}

							if(isset($post->lifeSpan)){
								if(is_numeric($post->lifeSpan) && $post->lifeSpan>0){
									$lf = $post->lifeSpan;
								}else{
									$error[] = "Invalid value of lifeSpan";
								}
							}else{
								$error[] = "key lifeSpan not receive";
							}

							if(isset($post->existingInvestment)){
								if(is_numeric($post->existingInvestment)){
									$ei = $post->existingInvestment;
								}else{
									$error[] = "Invalid value of existingInvestment";
								}
							}else{
								$error[] = "key existingInvestment not receive";
							}
							
							if(isset($post->inflation)){
								if(is_numeric($post->inflation)){
									$inf = $post->inflation;
								}else{
									$error[] = "Invalid value of inflation";
								}
							}else{
								$error[] = "key inflation not receive";
							}

							if(isset($post->postRetirementReturn)){
								if(is_numeric($post->postRetirementReturn)){
									$prr = $post->postRetirementReturn;
								}else{
									$error[] = "Invalid value of postRetirementReturn";
								}
							}else{
								$error[] = "key postRetirementReturn not receive";
							}
				            
				            if(isset($post->expectedReturn)){
								if(is_numeric($post->expectedReturn)){
									$erc = $post->expectedReturn;
								}else{
									$error[] = "Invalid value of expectedReturn";
								}
							}else{
								$error[] = "key expectedReturn not receive";
							}
				            
				            if(count($error) > 0){
				            	errorResponse($error,404);
				            }else{
				            	$monthlyInflation=(((   pow(1+($inf/100),(1/12)) )-1)*100);
					            $monthlyPRR1=((( pow(1+($prr/100)*3/12,4))-1)*100);
					            $monthlyPRR=(( pow(1+($monthlyPRR1/100),(1/12))-1)*100);
					            $periodMonlyIncomeNeeded=$lf-$ra;
					            $monthlyReqFirstYearAfterRetirement=round(($cme* pow((1+($inf/100)),($ra-$ca)) ),2);
					            $monthlyPRR=$monthlyPRR/100;
					            $monthlyInflation=$monthlyInflation/100;
					            $c=   ($monthlyPRR-$monthlyInflation);
					            $a=$monthlyReqFirstYearAfterRetirement*(1+$monthlyPRR)/($monthlyPRR-$monthlyInflation);
					            $noOfMonths = ($lf-$ra)*12;
					            $b=(1-pow((1+$monthlyInflation)/(1+$monthlyPRR),$noOfMonths));
					            $totalAmount=$a*$b;
					            $totalAmount=round($totalAmount,2);
					            $periodCreateRetireCorpus=$ra-$ca;
					            $futureValueExistingInvest=round(($ei* pow((1+$erc/100),$periodCreateRetireCorpus)));
					            $corpusNeedsBuild=round(($totalAmount-$futureValueExistingInvest),2);
					            $monthlySavings=round(($corpusNeedsBuild*($erc/100)/12)/((pow((1+($erc/100)/12),($periodCreateRetireCorpus*12)))-1));
					            response(['monthlySavings'=>$monthlySavings,'periodMonlyIncomeNeeded'=>$periodMonlyIncomeNeeded,"monthlyReqFirstYearAfterRetirement" => $monthlyReqFirstYearAfterRetirement,"totalAmount" => $totalAmount,"futureValueExistingInvest"=>$futureValueExistingInvest,"corpusNeedsBuild"=>$corpusNeedsBuild,"periodCreateRetireCorpus"=>$periodCreateRetireCorpus]);
				            }

						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}
}

