<?php

class ApiDashboard extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		$this->load->model('api_model/api_dashboard_model');
	}
	
	public function index()
	{
		echo "dashboard controller";
	}


	public function userCategoryAndPortfolio()
	{
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							$res = $this->api_dashboard_model->get_fund_type();
							if($res){
								$portfolio = $this->getPortFolio($user_data->investor_id);
								$goals = $this->api_dashboard_model->getAllSetGoal($user_data->investor_id);
								$running_sip = $this->api_dashboard_model->getActiveSIP($user_data->investor_id);
								$registration_Status = $this->api_dashboard_model->registrationStatus($user_data->investor_id);
								response(['fund_type_list'=>$res,
										  'plan_option'=>[
										  	'Growth' => 'Growth',
										  	'Dividend'=>'Dividend'
										  ],
										  'purchase_through'=>[
										  	"Mandat" => [
										  		"name"=>"Setup Automated Transfers",
										  		"msg" =>"Schedule your investments on a date of your choice. Your linked Bank Account will be debited automatically on the scheduled date. The earliest day on which you can invest is ".date("d M, Y")
										  		],
										  	"Netbanking" =>  [
										  		"name"=>"Transfer Funds with Net Banking",
										  		"msg" =>"If your linked bank account is enabled for Net Banking, you can invest today. You will need to authorise the fund transfer by logging into your Bank's website."
										  		],
										  	"UPI" =>  [
										  		"name"=>"Transfer Funds with UPI",
										  		"msg" =>"If your bank account have UPI id you can transfer money by your UPI address with ease. You will need enter your UPI address and simple transfer"
										  		],
										  ],
										  'purchase_type' => [
										  	1 => 'Lumsum',
										  	2 => 'SIP'
										  ],
										  'porfolio' => $portfolio,
										  'goals' => $goals,
										  'running_sip'=> $running_sip,
										  'registration_status' => $registration_Status
										]);
							}else{
								$error[] = "No active categry found";
	    						errorResponse($error,404);
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			} else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}

	public function getAnuData()
	{
		$res = $this->db->query("SELECT users.username, users.email, purchased_units.investor_id, purchased_units.fund_id, SUM(purchased_units.purchased_amount) as amt FROM investor JOIN purchased_units ON investor.investor_id = purchased_units.investor_id JOIN users ON users.id = investor.login_id WHERE purchased_units.request_status = 1 GROUP BY investor_id ORDER BY `amt` ASC");
		$file = fopen("assets/ano_data.csv","w");
		foreach($res->result() as $r){
			if($r->amt>450000){
				$response = $this->getPortFolio($r->investor_id);
				// echo "<pre>";
				// print_r($response->total['all']['investment_current_value']);
				// exit;
				$data =  $this->encrypt->decode($r->username).",".$r->email.",".$response->total['all']['current_invested_amount'].",".round($response->total['all']['investment_current_value'],2);
					fputcsv($file,explode(',',$data));
			}
			
		}
		fclose($file);
	}

	public function getdataList()
	{
		$res = $this->db->query("SELECT users.username,users.email,purchased_units.investor_id FROM purchased_units JOIN investor ON investor.investor_id = purchased_units.investor_id JOIN users ON users.id = investor.login_id WHERE investment_plan_type = 'STP' AND `request_date` BETWEEN '2020-03-02' AND '2020-04-20' AND request_date != '2020-04-01' AND request_status = 1 GROUP BY `investor_id`");
		if($res->num_rows()){
			echo "<pre>";
			$file = fopen("assets/stp_fund_data.csv","w");
			foreach($res->result() as $r){
				$response = $this->getPortFolio($r->investor_id);
				foreach($response->key9 as $fund){
					$data =  $this->encrypt->decode($r->username).",".$r->email.",".$r->investor_id.",".$fund->fund_name.",".$fund->current_amount;
					fputcsv($file,explode(',',$data));
				} 
			}
			fclose($file);
		}
	}

	public function getPortFolio($investor_id)
	{
		$calculted_funds = [];
		$fund_amount = $this->api_dashboard_model->getInvestedFund($investor_id);
		if($fund_amount)
		{
			foreach($fund_amount as $fs)
			{
				$current_invested_amount = $this->investmentCurrentValue($fs->fund_id,$investor_id);
				@$calculted_funds['total']['all']['current_invested_amount'] += $current_invested_amount;
				@$calculted_funds['total']['all']['investment_current_value'] += $fs->current_amount;
				@$calculted_funds['total'][$fs->fund_type_id]['current_invested_amount'] += $current_invested_amount;
				@$calculted_funds['total'][$fs->fund_type_id]['investment_current_value'] += $fs->current_amount;
				$fs->current_invested_amount = $current_invested_amount;
				$calculted_funds['key'.$fs->fund_type_id][] = $fs;
			}
		}
		return $data['purchased'] = ((object)$calculted_funds);
	}


	public function investmentCurrentValue($fund_id,$investor_id)
	{
		$res_purchase_fund = $this->api_dashboard_model->purchaseFund($investor_id,$fund_id);
		$res_unit_sum_sold_fund = $this->api_dashboard_model->unitSumOfSoldUnits($investor_id, $fund_id);
		if($res_unit_sum_sold_fund->num_rows() > 0)
		{
			$purchase_fund = $res_purchase_fund;
			$total_sold_units =  $res_unit_sum_sold_fund->row()->units;
			$remaining_units =$total_sold_units;
			$current_amount = 0;
			foreach($purchase_fund as $pf)
			{
				$remaining_units = $remaining_units - $pf->unit_count;
				if($current_amount > 0)
				{
					$current_amount = $current_amount + $pf->purchased_amount;
				}

				if($remaining_units < 0 && $current_amount ==0)
				{
					$old_nav = $pf->purchased_amount/$pf->unit_count;
					$current_amount = $old_nav* abs($remaining_units);
				}
			}
			return round($current_amount);
		}
	}
}