<?php

class ApiLogin extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		$this->load->model('login/login_model');
	}

	// login api to login users and return necrypted string that having username, email, phone number, investor id and userid
	public function login()
	{
		// echo $this->uri->segment(1);
		if($partner = checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
					$error = [];
					$response = $post;
					if($response){
						$data = $response;
						if(!$data->email){
							$error[] = "email should not be blank";
						}else if(!filter_var($data->email, FILTER_VALIDATE_EMAIL)){
							$error[] = "email not valid";
						}
						else if(!$data->password){
							$error[] = "password should not be blank";
						}

						if(count($error) == 0){
							$remember = 0;
							$is_verify =  $this->db->query("SELECT investor.is_verify FROM investor JOIN users on users.id = investor.login_id WHERE users.email = '".$data->email."' and investor.is_verify = 1");
							if($is_verify->num_rows() > 0){
								if($this->ion_auth->login($data->email, $data->password, $remember))
								{
									$user = $this->ion_auth->user()->row();
									$resultInvestorId=$this->login_model->getInvestorIdByUserId($user->id);
									$userdata['username'] = $this->encrypt->decode($user->username);
									$userdata['email']	=	$user->email;
									$userdata['phone'] =  $this->encrypt->decode($user->phone);
									$userdata['investor_id'] = $resultInvestorId->investor_id;
									$userdata['user_id'] = $user->id;
									response(['login_token'=>$this->encrypt->encode(json_encode($userdata)),"investor_name"=>$userdata['username'],"sub_admin"=>$partner]);
									// echo json_encode(['success'=>true]);
								}
								else
								{
									$error[]="Incorrect email or password";
									errorResponse($error,404);
								}
							} else {
								$error[]="Email not verify";
								errorResponse($error,404);
							}
							
						}else{
							errorResponse($error,404);
						}
					}else{
						$error[]="please pass email and password";
						errorResponse($error,404);
					}
				}else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
	}

	public function app_forgotten_password()
    {
    	if($partner = checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
					$error = [];
					$response = $post;
					if($response){
						$data = $response;
						if(!$data->email){
							$error[] = "email should not be blank";
						}else if(!filter_var($data->email, FILTER_VALIDATE_EMAIL)){
							$error[] = "email not valid";
						}
						if($data)
						{
							$user = $this->db->where("email",$data->email)->from("users")->get()->row();
							if($user)
							{
								$otpNumber=$this->randomNumber(6);
								$userId=$user->id;
								$userName=ucwords($this->encrypt->decode($user->username)).",";

								$userPhone=$this->encrypt->decode($user->phone);
								$this->login_model->updateOTPNumber($userId,$otpNumber);
								// send this generated otp code to the user phone
								$resultSendOTP=$this->sendOTPNumber($userName,$userPhone,$otpNumber);
								response(["otp"=>$otpNumber]);
							}
							else
							{
								 $error[]="Please enter correct email";
								errorResponse($error,404);
							}
						}

					}else{
						$error[]="please pass email and password";
						errorResponse($error,404);
					}
				}else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
    }

    function app_reset_password()
	{
		if($partner = checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
					$error = [];
					$response = $post;
					if($response){
						$data = $response;
						if(!$data->email){
							$error[] = "email should not be blank";
						}else if(!filter_var($data->email, FILTER_VALIDATE_EMAIL)){
							$error[] = "email not valid";
						}else if(!$data->password){
							$error[] = "password should not be blank";
						}else if(strlen($data->password) < 6){
							$error[] = "password length must be greater than 5";
						}
						if(count($error) ==0)
						{
							// $user = $this->db->where("id",$investorId)->from("users")->get()->row();
							$user = $this->db->where("email",$data->email)->from("users")->get()->row();
							$identity = $user->{$this->config->item('identity', 'ion_auth')};
							$change = $this->ion_auth->reset_password($identity, $data->password);
							response(['msg'=>"password change successfully"]);
						}else{
							errorResponse($error,404);
						}

					}else{
						$error[]="please pass email and password";
						errorResponse($error,404);
					}
				}else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
	}

    function sendOTPNumber($userName,$userPhone,$otpNumber)
    {
        $ch = curl_init();

        //Like us on bit.ly/eshpind----------------
        $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear Investor,your password reset OTP is ".$otpNumber." .Team Investocafe.&sender=INCAFE&route=4&country=91&DLT_TE_ID=1207160699198640425";
		
       
		$url=str_replace(" ", "%20", $url1);

        curl_setopt($ch, CURLOPT_URL, $url);
        //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

        //return the transfer as a string
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        //$output contains the output string
        $output = curl_exec($ch);
		//echo $output;

        $dbData = array ('phone'=>$userPhone,'response'=>$output);
        $this->db->insert('msg_log',$dbData);
        //close curl resource to free up system resources
        curl_close($ch);

        if ( $output === FALSE)
        {
            $output=curl_error($ch); //echoes last session error
            return false;
        }
        return $output;
    }	

    function randomNumber($length)
    {
        $result = '';

        for($i = 0; $i < $length; $i++) {
            $result .= mt_rand(0, 9);
        }

        return $result;
    }
}

