<?php

class ApiMyProfile extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		$this->load->model('api_model/api_my_profile_model');
	}
	
	public function index()
	{
		echo "Api My Profile running";
	}

	public function getProfile()
	{
		if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        	$user_data = json_decode(decode($post->login_token));
                        	$response = $this->api_my_profile_model->getUserInfo($user_data->investor_id);
                        	if($response){
                        		$response->username = decode($response->username);
                        		$response->pan = decode($response->pan);
                        		$response->account_holder_name = decode($response->account_holder_name);
                        		$response->account_number = decode($response->account_number);
                        		$response->phone = decode($response->phone);
                        		$nominee_detail = $this->api_my_profile_model->getNomineeDetail($user_data->investor_id);
                        		response(['user_data'=>$response,'nominee_detail' => $nominee_detail]);
                        	}else{
                        		$error[] = "Please first complete your registration";
                            	errorResponse($error,404);
                        	}
                        }else{
							$error[] = "Invalid login token";
                            errorResponse($error,404);
						}
                    }else{
                        $error[] = "Key login_token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
	}

    public function editProfileOTP()
    {
        if($sender = checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                            $user_Detail = json_decode(decode($post->login_token));
                            $this->load->helper('partner_mail');
                            $this->load->helper('string');
                            $otp = random_string('numeric', 4);
                            $replace_data = [
                                'customername' => $user_Detail->username,
                                'otp' => $otp,
                                'sender'=> $sender->partner_name
                            ];
                            $this->db->where('id',$user_Detail->user_id)->update('users',[
                                    'otp_code'=>$otp
                                ]);

                            $response = sendSMSTO($user_Detail->phone,1,$sender->sms_name,$replace_data);
                            if($response){
                                response(['msg'=>"success"]);
                            }else{
                                $error[] = "OTP not send";
                                errorResponse($error,404);
                            }
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Key login_token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
    }

    public function varifyProfileOTP()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                            $user_data = json_decode(decode($post->login_token));
                            $res = $this->db->where(['id'=>$user_data->user_id,'otp_code'=>$post->OTP])->get('users');
                            if($res->num_rows() > 0){
                                response(["msg"=>"varify otp"]);
                            }else{
                                $error[] = "Invalid OTP";
                                errorResponse($error,404);
                            }
                            
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Key login_token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
    }
}

