<?php

class ApiPurchase extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		// if(!isset(apache_request_headers()['Token']) || @apache_request_headers()['Token'] != 'investocafe-token'){
		// 	errorResponse(['invalid token'],500);
		// 	exit;
		// }
		$this->load->model('api_model/api_purchase_model');
		$this->config->load('config_atom');
		$this->load->helper('partner_mail');
	}


	public function getFundDetail()
	{
		$data = file_get_contents('php://input');
    	$upload_data = [];
    	$error = [];
    	if(checkToken()){
    		if(methodCheck() == 'POST'){
    			$post = (object) $this->input->post();
    			if(!empty($post)){
			    		if(isset($post->login_token)){
			    			if(decode($post->login_token)){
			    				if(isset($post->fund_type_id)){
			    					if(isset($post->plan_option)){
			    						if($post->plan_option=="Growth" || $post->plan_option=="Dividend")
			    						{
				    						$user_data = json_decode(decode($post->login_token));
						    				$fund_data = $this->api_purchase_model->getFundsByFundId($post->fund_type_id,$post->plan_option);
						    				if($fund_data){
						    					if(isset($post->purchase_through)){
						    						// purchase type 1=mandate; 2=Net Banking 3=UPI
						    						if(in_array($post->purchase_through, [1,2,3])){
						    							$senddata['fund_type_name'] = $this->api_purchase_model->getFundTypeName($post->fund_type_id);
								    					$senddata['term_and_condition'] = $this->api_purchase_model->purchasTAndC();
								    					$senddata['confirmation'] = $this->api_purchase_model->getInvestorBankAccount($user_data->investor_id,$post->purchase_through);
														$senddata['self_declearation'] = $this->api_purchase_model->selfDeclearation();
								    					$senddata['fund_data'] = $fund_data;
						    						}else{
						    							$error[] = "invalid purchase_through";
						    						}
						    					}else{
						    						$error[] = "Key purchase_through not recieve";
						    					}
						    				}else{
						    					$error[] = "Invalid Fund type id";
						    				}
						    			}else{
						    				$error[] = "Invalid plan_option";
						    			}
			    					}else{
			    						$error[] = "key plan_option not receive";
			    					}

				    				if(count($error) > 0){
				    					errorResponse($error,500);
				    				}else{
				    					response($senddata);
				    				}
			    				}else{
			    					$error[] = "key fund_type_id not receive";
			    					errorResponse($error,404);
			    				}
			    			}else{
			    				$error[] = "Invalid login token";
			    				errorResponse($error,404);
			    			}
			    		}else{
			    			$error[] = "Login token not receive";
			    			errorResponse($error,404);
			    		}
			    }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
		    }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
    	}else{
	    	errorResponse(['invalid token'],404);
	    }
	}

	public function purchaseFund()
	{
		if($sender = checkToken()){
    		if(methodCheck() == 'POST'){
    			$post = (object) $this->input->post();
    			if(!empty($post)){
    				if(isset($post->login_token)){
			    			if(decode($post->login_token)){
								$data = file_get_contents('php://input');
						    	$upload_data = [];
						    	$error = [];
						    	$totalAmount = 0;
						    	if($post){
						    		$recieve_data = $post;
						    		if(isset($recieve_data->login_token)){
						    			if(decode($recieve_data->login_token)){

											$user_data = json_decode(decode($recieve_data->login_token));

						    				if(isset($recieve_data->fund_type_id)){
						    					$upload_data['fund_type_id'] = $recieve_data->fund_type_id;
						    				}else{
						    					$error[] = "key fund_type_id not receive";
						    					errorResponse($error,404);
						    				}
									
											// 
											if(isset($recieve_data->purchase_through)){
												// purchase type 1=mandate; 2=Net Banking 3=UPI
												if(in_array($recieve_data->purchase_through, [1,2,3])){
													$upload_data['purchase_through'] = $recieve_data->purchase_through;
												}else{
													$error[] = "invalid purchase purchase_through";
												}
											}else{
												$error[] = "Key purchase_through not recieve";
											}

											// 
											if(isset($recieve_data->purchase_type)){
												// 1=one time 2=SIP
												if(in_array($recieve_data->purchase_type, [1,2])){
													$upload_data['purchase_type'] = $recieve_data->purchase_type;
													if($recieve_data->purchase_type == 2 && isset($recieve_data->number_of_months)){
														if(is_numeric($recieve_data->number_of_months)){
															if($recieve_data->number_of_months > 11){
																$upload_data['number_of_months'] = $recieve_data->number_of_months;
															}else{
																$error[] = "Minimun SIP tenure should be 12 Months";
															}
														}else{
															$error[] = "Invalid number of months";
														}
													}else if($recieve_data->purchase_type == 1){
														$upload_data['number_of_months'] = "";
													}else{
														$error[] = "key number_of_months not receive";
													}
												}else{
													$error[] = "Invalid purchase type";
												}
											}else{
												$error[] = "key purchase type not receive";
											}

											// 
											if(isset($recieve_data->plan_option)){
												if($recieve_data->plan_option=="Growth" || $recieve_data->plan_option=="Dividend")
												{	
													$upload_data['plan_option'] = $recieve_data->plan_option;
								    			}else{
								    				$error[] = "Invalid plan_option";
								    			}
											}else{
												$error[] = "key plan_option not receive";
											}

											// 
											if(isset($recieve_data->request_date)){
												if($recieve_data->request_date != ""){
													if (preg_match("/^[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])$/",$recieve_data->request_date)) {

													    $upload_data['request_date'] = $recieve_data->request_date;
													} else {
													    $error[] = "Invalid value for request_date date formate should be yyyy-mm-dd";
													}
												}else{
													$error[] = "request_date not be blank";
												}
											}else{
												$error[] = "key request_date not receive";
											}

											// 
											if(isset($recieve_data->purchase_fund_detail)){
												// print_r($recieve_data->purchase_fund_detail);
												// exit;
												if($recieve_data->purchase_fund_detail !=""){
													$recieve_data->purchase_fund_detail = json_decode($recieve_data->purchase_fund_detail);
													if(is_array($recieve_data->purchase_fund_detail)){
														foreach($recieve_data->purchase_fund_detail as $fund){
															$fund_response = $this->checkFund($fund,$recieve_data->purchase_type,$recieve_data->plan_option);
															if($fund_response['status']){
																$upload_data['purchase_data'][] = (object) $fund_response;
															}else{
																$error[] = $fund_response['error_msg'];
															}
														}
													}else{
														$error[] = "Invalid type of purchase_fund_detail value";
													}
												}else{
													$error[] = "purchase_fund_detail is mandatory";
												}
											}else{
												$error[] = "key purchase_fund_detail not receive";
											}


						    				if(count($error) > 0){
						    					errorResponse($error,500);
						    				}else{
													$upload_data =  (object) $upload_data;
													// print_r($upload_data);
													$batch_id = $this->api_purchase_model->createNewPurchaseBatchId('purchase');
													// echo $batch_id;
													// exit;
													$upload_data->batch_id = $batch_id;
													$submit_entery = 0;
													$prodStr = '<products>';
													$cnt=1;
													$total_investment_amount = 0;
													// echo "<pre>";
													$fund_Str="";
													foreach($upload_data->purchase_data as $save_fund){
														// print_r( $save_fund);
														// exit;
														$save_fund->request_date =$upload_data->request_date;
														$save_fund->purchase_type = $upload_data->purchase_type;
														$save_fund->investor_id = $user_data->investor_id;
														$save_fund->investment_plan_type = "One Time";
														$save_fund->is_monthly_sip = 0;
														$save_fund->batch_id = $batch_id;
														if($upload_data->purchase_through==1){
															$save_fund->nb_request = 0;
														}else{
															$save_fund->nb_request = 1;
														}
														if($upload_data->purchase_type == 2){ 
															$save_fund->number_of_months = $upload_data->number_of_months;
															$save_fund->is_monthly_sip = 1;
															$save_fund->investment_plan_type = "SIP Monthly";
														} 
														// echo "<pre>";
														// print_r($save_fund);
														$fund_response = $this->db->query("SELECT `fund_name` FROM funds WHERE fund_id = $save_fund->fund_id");
														if($fund_response->num_rows() > 0){
															$fund_name = $fund_response->row()->fund_name;
															$fund_Str .= "<li>$fund_name -  $save_fund->amount</li>";
														}
														$submit_entery +=$entery_response = $this->createPurchaseEntery($save_fund);
														// print_r($submit_entery);
														// exit;
														$totalAmount = $totalAmount+$save_fund->amount;
														// $fullFundDetails = $this->api_model->getFundDetails($fundDetails[0]);
														$prodStr .= "<product><id>".$cnt."</id> <name>".$save_fund->atom_product_id."</name><amount>".$save_fund->amount."</amount></product>";
														$cnt=$cnt+1;
														$total_investment_amount += $save_fund->amount;
													}
													$prodStr .= '</products>';
						    					// echo $prodStr;
													$res = $this->db->query("SELECT `name` FROM `fund_type` WHERE fund_type_id = $recieve_data->fund_type_id");
													if($res->num_rows() > 0){
														$investment_type = $res->row()->name;
													}else{
														$investment_type = "";
													}
													$replace_data = [
														"logo_url"=> $sender->logo,
														"customername" => $user_data->username,
														"sender" => $sender->partner_name,
														"investment_type" => $investment_type,
														"amount" => $totalAmount,
														"investment_date"=>date_format(date_create("$recieve_data->request_date"),"d M,Y"),
														"phone_numer"=>$sender->phone,
														"email" => $sender->partner_email,
														"address_line_one"=>$sender->address_line_one,
														"address_line_two"=>$sender->address_line_two,
														"fund_investment_list"=>$fund_Str
													];
													// echo "<pre>";
													// print_r($email_data);
													
						    					if($submit_entery > 0){

						    						// echo "<pre>";
						    						// print_r($upload_data);
						    						// exit;
						    						if($upload_data->purchase_through==2){
						    							$upload_data->prodStr = $prodStr;
						    							$upload_data->investment_amount = $total_investment_amount;
						    							$p_response = $this->requestForNetBanking($upload_data,$user_data);
						    							
						    							// exit;
						    							if($p_response){
						    								// echo $p_response;
						    								$responseArr = ["msg"=>"successfully create purchase entery","userMsg"=>"","link"=>$p_response];
						    								// print_r($responseArr);
						    								response($responseArr);
						    								return;
						    							}else{
						    								$error[] = "Netbanking purchase failed";
						    								errorResponse($error,404);
						    								return;
						    							}
						    						}if($upload_data->purchase_through==3){
						    							$upload_data->prodStr = $prodStr;
						    							$upload_data->investment_amount = $total_investment_amount;
						    							$p_response = $this->requestForUPI($upload_data,$user_data);
						    							if($p_response){
						    								response(["msg"=>"successfully create purchase entery","userMsg"=>"","link"=>"$p_response"]);
						    								return;
						    							}else{
						    								$error[] = "Netbanking purchase failed";
						    								errorResponse($error,404);
						    								return;
						    							}
						    						}else{
						    							sendEmailTO($user_data->email,3,$sender->sms_name,$replace_data);
						    							sendSMSTO($user_data->phone,3,$sender->sms_name,$replace_data,$lang='en');
						    							response(["msg"=>"successfully create purchase entery","link"=>"","userMsg"=>"Successfully place purchase order amount of ".$total_investment_amount]);
						    						}
						    						
						    					}else{
						    						$error[] = "Server error please try again";
						    						errorResponse($error,404);
						    					}
						    				}
						    			}else{
						    				$error[] = "Invalid login token";
						    				errorResponse($error,404);
						    			}
						    		}else{
						    			$error[] = "Login token not receive";
						    			errorResponse($error,404);
						    		}
						    	}else{
						    		$error[] = "Data not recieve";
						    		errorResponse($error,404);
						    	}
		    				}else{
		    				$error[] = "Invalid login token";
		    				errorResponse($error,404);
		    			}
		    		}else{
		    			$error[] = "Login token not receive";
		    			errorResponse($error,404);
		    		}
			    }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
		    }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
    	}else{
	    	errorResponse(['invalid token'],404);
	    }
	}

	public function sendEmailAndSMSTOClient()
	{

	}


	public function checkFund($boject,$purchase_type,$plan_option)
	{
		if(isset($boject->fund_id)){
			$res = $this->api_purchase_model->getFund($boject->fund_id,$plan_option);
			if($res){
				if($purchase_type == 1){
					if($boject->invested_amount >= $res->min_purchase_amt){
						return [ "status"=>true, "fund_id"=>$boject->fund_id,"amount"=>$boject->invested_amount,"amc_code"=>$res->AMC_code,"atom_product_id"=>$res->atom_product_id];
					}else{
						return [ "status"=>false, "error_msg"=>$res->fund_name ." minimum purchase amount should be greater then or equal to ".$res->min_purchase_amt];
					}
				}else if($purchase_type == 2){
					if($boject->invested_amount >= $res->SIP_min_amount){
						return [ "status"=>true, "fund_id"=>$boject->fund_id,"amount"=>$boject->invested_amount,"amc_code"=>$res->AMC_code,"atom_product_id"=>$res->atom_product_id];
					}else{
						return [ "status"=>false, "error_msg"=>$res->fund_name ." minimum purchase amount should be greater then or equal to ".$res->SIP_min_amount];
					}
				}else{
					return [ "status"=>false, "error_msg"=>$res->fund_name ." not available for this purchase type"];
				}
			}else{
				return [ "status"=>false, "error_msg"=>"Invalid Fund detail"];
			}

		}else{
			return ["status"=>false,"error_msg"=>"fund_id is mandatory in fund array"];
		}
	}

	public function createPurchaseEntery($fund_data)
	{	
		$api_batch_id = $this->api_purchase_model->createNewApiBatchId("");
		$folio_number = $resultFolio=getLatestFolioNumber($fund_data->amc_code,$fund_data->investor_id);
        if($resultFolio){ $folioNumber=$resultFolio; }else{ $folioNumber="";}
		$PurchaseData = [
			"purchased_amount" => $fund_data->amount,
			"investor_id" => $fund_data->investor_id,
			"request_date" => $fund_data->request_date,
			"fund_id" => $fund_data->fund_id,
			"folio_number" => $folioNumber,
			"batch_id" => $fund_data->batch_id,
			"api_batch_id" => $api_batch_id,
			"is_first_purchase" => 1,
			"investment_plan_type" => $fund_data->investment_plan_type,
			"is_monthly_sip"=> $fund_data->is_monthly_sip,
			"nb_request" => $fund_data->nb_request,
			"AMC_CODE" => $fund_data->amc_code
		];
		
		$purchase_unit_id = $this->api_purchase_model->addPurchaseFunds($PurchaseData);
		// print_r($purchase_unit_id);
		// exit;
		if($fund_data->is_monthly_sip==1 && $purchase_unit_id){
			$sipEndDate = date('Y-m-d', strtotime("+".$fund_data->number_of_months." months", strtotime($fund_data->request_date)));
			$time = strtotime($fund_data->request_date);
			$nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));
			$monthlyInvestmentdata= array(
	                        "fund_id"=>$fund_data->fund_id,
	                        "investor_id"=>$fund_data->investor_id,
	                        "amount"=>$fund_data->amount,
	                        "sip_start_date"=>$fund_data->request_date,
	                        "sip_end_date"=>$sipEndDate,
	                        "next_investment_date"=>$nextInvestmentDate,
	                        "no_of_months"=>$fund_data->number_of_months,
	                        "batch_id"=>$fund_data->batch_id,
	                        "is_stopped_sip"=>1
                        );
			$monthly_investment_id = $this->api_purchase_model->addSipMonthlyInvestmentFunds($monthlyInvestmentdata);
			if($monthly_investment_id){
				$data=array("monthly_investment_id"=>$monthly_investment_id,"purchased_units_id"=>$purchase_unit_id);
                $this->api_purchase_model->addMonthlyInvestmentMappingData($data);
			}
		}

		if($purchase_unit_id){return 1;}
	}

	public function requestForNetBanking($upload_data,$user_data)
	{
		if($upload_data){
			$Investor_bank_acc = $this->api_purchase_model->getInvestorBankAndPanDetail($user_data->investor_id);
			$netbankingData = [
				"totalAmount"=>$upload_data->investment_amount,
				"investorId" => $user_data->investor_id,
				"bankid" => $Investor_bank_acc->atom_code,
				"prodStr" => $upload_data->prodStr,
				"investorBankAccountNumber" => decode($Investor_bank_acc->account_number),
				"investorName" => $user_data->username,
				"investorEmail" => $user_data->email,
				"investorMobile" => $user_data->phone,
				"investorAddress" => "",
				"batchId" => $upload_data->batch_id
			];
			$transactionId = $this->api_purchase_model->insertTransactionStartData($netbankingData);
			date_default_timezone_set("Asia/Kolkata");
			$datenow = date("d/m/Y");
			$paymentUrl = $this->config->item('Url');
			$postFields  = "";
			$postFields .= "&login=".$this->config->item('Login');
			$postFields .= "&pass=".$this->config->item('Password');
			$postFields .= "&ttype=".$this->config->item('ttype');
			$postFields .= "&prodid=".'Multi';
			$postFields .= "&amt=".$netbankingData['totalAmount'];
			$postFields .= "&txncurr=".$this->config->item('TxnCurr');
			$postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
			$postFields .= "&clientcode=".$this->config->item('clientCode');
			$postFields .= "&txnid=".$transactionId;
			$postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
			$postFields .= "&date=".$datenow;
			$postFields .= "&mprod=".$netbankingData['prodStr'];
			$postFields .= "&udf1=".$netbankingData['investorName'];
			$postFields .= "&udf2=".$netbankingData['investorEmail'];
			$postFields .= "&udf3=".$netbankingData['investorMobile'];
			$postFields .= "&ru=".base_url('api/apiPurchase/netBankingResponse');
			$postFields .= "&udf9=purchaseTransaction";
			$postFields .= "&bankid=".$netbankingData['bankid'];
			$str = $this->config->item('Login') . $this->config->item('Password') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";
			$signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKey'),false);
			$postFields .= "&signature=".$signature;
			$sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
			$sendUrlNew = $paymentUrl."?".substr($postFields,1);
			// echo $sendUrlNew;
			return  $sendUrlNew;
		}else{
			return false;
		}
	}

	public function requestForUPI($upload_data,$user_data)
	{
		if($upload_data){
			$Investor_bank_acc = $this->api_purchase_model->getInvestorBankAndPanDetail($user_data->investor_id);
			$netbankingData = [
				"totalAmount"=>$upload_data->investment_amount,
				"investorId" => $user_data->investor_id,
				"bankid" => $Investor_bank_acc->atom_code,
				"prodStr" => $upload_data->prodStr,
				"investorBankAccountNumber" => decode($Investor_bank_acc->account_number),
				"investorName" => $user_data->username,
				"investorEmail" => $user_data->email,
				"investorMobile" => $user_data->phone,
				"investorAddress" => "",
				"batchId" => $upload_data->batch_id,
				"upiid" => $Investor_bank_acc->upi_id
			];
			$transactionId = $this->api_purchase_model->insertTransactionStartData($netbankingData);
			date_default_timezone_set("Asia/Kolkata");
			$datenow = date("d/m/Y");
			$paymentUrl = $this->config->item('Url');
			$postFields  = "";
			$postFields .= "&login=".$this->config->item('Login');
			$postFields .= "&pass=".$this->config->item('Password');
			$postFields .= "&ttype=".$this->config->item('ttype');
			$postFields .= "&prodid=".'Multi';
			$postFields .= "&amt=".$netbankingData['totalAmount'];
			$postFields .= "&txncurr=".$this->config->item('TxnCurr');
			$postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
			$postFields .= "&clientcode=".$this->config->item('clientCode');
			$postFields .= "&txnid=".$transactionId;
			$postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
			$postFields .= "&mdd="."UP|SMSUPI|".$netbankingData['upiid'];
			$postFields .= "&date=".$datenow;
			$postFields .= "&mprod=".$netbankingData['prodStr'];
			$postFields .= "&udf1=".$netbankingData['investorName'];
			$postFields .= "&udf2=".$netbankingData['investorEmail'];
			$postFields .= "&udf3=".$netbankingData['investorMobile'];
			$postFields .= "&ru=".base_url('api/apiPurchase/netBankingResponse');
			// $postFields .= "&udf9=purchaseTransaction";
			// $postFields .= "&bankid=".$netbankingData['bankid'];
			$str = $this->config->item('Login') . $this->config->item('Password') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";
			$signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKey'),false);
			$postFields .= "&signature=".$signature;
			$sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
			return  $sendUrlNew = $paymentUrl."?".substr($postFields,1);
		}else{
			return false;
		}
	}

	public function netBankingResponse()
	{
		   //print_r($_POST);die;
		$this->load->model('purchase/purchase_model');
        $response = $_POST;
        $reslog = implode(" ",$response);
        $str = $response["mmp_txn"].$response["mer_txn"].$response["f_code"].$response["prod"].$response["discriminator"].$response["amt"].$response["bank_txn"];
        $signature =  hash_hmac("sha512",$str,$this->config->item("respHashKey"),false);
        if($signature == $response["signature"] && $response['f_code']=="Ok"){
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['bank_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            $totalAmount=$response['amt'];
            $this->purchase_model->updateMonthlyInvestment($response['mer_txn']);
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }
            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
			return redirect(base_url(). "assets/iset/Purchase/transectionStatus?status=1&amount=".$response['amt']);
        }
        else
        {
            return redirect(base_url()."assets/iset/Purchase/transectionStatus?status=2&amount=".$response['amt'] );
        }

	}

	public function emailTemp()
	{
		$this->load->view('api_view/test');
	}
}
