<?php

class ApiRegistration extends CI_Controller{
	
	function __construct()
	{
		parent::__construct();
		$this->load->model('api_model/api_registration_model','api_registration_model');
        $this->load->helper('partner_mail');
	}

	public function apiGetAgent()
    {
		 if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                            $user_data = json_decode(decode($post->login_token));
                            if(isset($user_data->investor_id)){
                                $res = $this->db->where('unique_id',$post->agentId)->get('pos_detail');
                                if($res->num_rows() > 0){
                                    response(['agentDetail'=>$res->row()]);
                                }else{
                                    $error[] = "Invalid agent Id";
                                    errorResponse($error,404);
                                }
                            }else{
                                $error[] = "login_token not recieve";
                                echo '{"status":500,"errors":'.json_encode($error).'}';
                            }
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }

        }else{
            errorResponse(['invalid token'],404);
        }
	}




	public function getBasicRegistration()
	{
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
            		$result = $this->api_registration_model->get_basic_registration();
            		if($result){
            			$data['investor_type'] = $result;
            		}else{
            			$data['investor_type'] = false;
            		}
            		$data['prefix'] = [
            			'Mr'=>'Mr',
            			'Mrs'=>'Mrs',
            			'Mis'=>'Mis'
            		];
            		$data['send_key_group'] = [
            			'investor_type_id',
            			'name_as_per_pan_card',
            			'email',
            			'mobile_number',
            			'password',
            			'prefix'
            		];
                    response($data);
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }

        }else{
            errorResponse(['invalid token'],404);
        }
	}

	public function saveBasicRegistration()
	{
        if($partner = checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
            		$upload_data = [];
            		$error = [];
        			if(isset($post->investor_type_id)){
        				if(is_numeric($post->investor_type_id)){
        					$upload_data['investor_type_id'] = $post->investor_type_id;
        				} else {
        					$error[] = "investor_type_id key only containt numeric value";
        				}
        			} else {
        				$error[] ="investor_type_id key not found";
        			}

        			if(isset($post->name_as_per_pan_card)){
        				if($post->name_as_per_pan_card!='')
        				{
        					$upload_data['name'] = $post->name_as_per_pan_card;
        				}
        				else
        				{
        					$error[] ="name_as_per_pan_card not be null";
        				}
        			}else{
        				$error[] ="name_as_per_pan_card key not found";
        			}

        			if(isset($post->email)){
        				if(filter_var($post->email, FILTER_VALIDATE_EMAIL)){
        					if(!$this->api_registration_model->check_email($post->email)){
        						$upload_data['email'] = $post->email;
        					} else {
        						$error[] ="email already exists";
        					}
        				}else{
        					$error[] ="invalid email id";
        				}
        			}else{
        				$error[] ="email key not found";
        			}

        			if(isset($post->mobile_number)){
        				if($post->mobile_number!='')
        				{
        					if(is_numeric($post->mobile_number)){
        						// $upload_data['investor_type_id'] = $post->investor_type_id;
        						if(preg_match('/^[0-9]{10}+$/', $post->mobile_number)){
        							$upload_data['mobile_number'] = $post->mobile_number;
        						} else {
        							$error[] = "mobile_number invalid";
        						}
        					} else {
        						$error[] = "mobile_number key only containt numeric value";
        					}
        				}
        				else
        				{
        					$error[] ="mobile_number not be null";
        				}
        			}else{
        				$error[] ="mobile_number key not found";
        			}

        			if(isset($post->password)){
        				if(strlen($post->password) > 5){
        					$upload_data['password'] = $post->password;
        				} else{
        					$error[] ="password lenth should be greater then 6";
        				}
        			} else {
        				$error[] ="password key not found";
        			}

        			if(isset($post->prefix)){
        				if($post->prefix!='')
        				{
        					$upload_data['prefix'] = $post->prefix;
        				}
        				else
        				{
        					$error[] ="prefix not be null";
        				}
        			}else{
        				$error[] ="prefix key not found";
        			}

        			if(count($error)>0){
        				// echo '{"status":500,"errors":'.json_encode($error).'}';
                        errorResponse($error,404);
        			}else{
        				$this->addInvestor((object) $upload_data,$partner);
        			}
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }

        }else{
            errorResponse(['invalid token'],404);
        }
	}

	public function addInvestor($data,$partner)
    {
        $access_data = $data;
    	$name_arr = explode(" ", $data->name);
    	$name_first = array_shift($name_arr);
		$name_last = array_pop($name_arr);
		$name_middle = trim(implode(' ', $name_arr));

        $name=encode(handleString($data->name));
        $email=$data->email;
        $prefix = $data->prefix;
        $phone=encode($data->mobile_number);
        $password = $data->password;
        $group = array('1'); // Sets user to admin.
        $additional_data = array(
            'first_name' => $name,
            'phone' => $phone,
            "email"=>$email,
            "name_first"=>$name_first,
            "name_middle"=>$name_middle,
            "name_last"=>$name_last,
            "prefix"=>$prefix,
            "device_use" => "Third Party Api"
           );

        $user_id = $this->ion_auth->register($name, $password, $email, $additional_data,$group);
        if($user_id)
        {
            $data=array(
                        "login_id"=>$user_id,
                        "token_image_path"=>'',
                        "token_image_name"=>'',
                        "agent_id"=> 4120,
                        "pos" => A5121
                      );

            $investor_id = $this->api_registration_model->addInvestor($data);
            if($investor_id)
            {
                $investorId=$investor_id;
                $this->addInvestorStatus($investorId);
        		$name = $this->encrypt->decode($name);
        		$phone = $this->encrypt->decode($phone);
				$data=array();
				$data["name"]=$name;
				$data["investor_id"] = $investor_id;
				$html=$this->load->view('accountVerificationMail_view', $data,true);
				$subject ="Account verification email";
				// $out = sendEmail($email,$subject,$html); updateInvestoLatter
                notificationAlert('New Registration',$name.' Create new account on investocafe. email id '.$email.' phone number '.$phone,$investorId);
                $code = str_replace("+",'[plus]',$this->encrypt->encode($investor_id));
        		$replace_data = [
                    "customername"=>$access_data->name,
                    "sender" => $partner->partner_name,
                    "varify_link"=>'<a href="'.base_url().'api/apiRegistration/verifyEmail?invId='.$code.'">Click Here To Verify<a>',
                    "email"=>$partner->partner_email,
                    "phone_numer"=>$partner->phone,
                    "address_line_one"=>$partner->address_line_one,
                    "address_line_two"=>$partner->address_line_two,
                    "logo_url"=>$partner->logo
                ];
                sendSMSTO($access_data->mobile_number,2,$partner->sms_name,$replace_data);
                sendSMSTO($access_data->mobile_number,2,$partner->sms_name,$replace_data,'hi');
                sendEmailTO($email,2,$partner->sms_name,$replace_data);
                response(["msg" => "successfully register please varify email and login"]);
            }
            else
            {
                // $error[] = "Server Error Please try again";
				// echo '{"status":500,"errors":'.json_encode($error).'}';
                errorResponse(['Server Error Please try again'],404);
            }
			//Add Verification Mail
        }
        else
        {
            // echo '{"success":false,"response":" "}';
            // $error[] = "";
			// echo '{"status":500,"errors":'.json_encode($error).'}';
            errorResponse(['user already exists'],404);
        }
    }

    public function addInvestorStatus($investorId)
    {
        $today_date= date("Y-m-d H:i:s");
        $data=array(
                    "investor_id"=>$investorId,
                    "first_registration" => 1 ,
                    "first_registration_date" => $today_date
                   );
        $result=$this->api_registration_model->updateInvestorStatus($data);
    }

    public function sendAccountActivationSms($userName,$userPhone)
    {
        if($userPhone!="" && $userName!="")
        {
			$ch = curl_init();
			$url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0AYour%20investment%20account%20has%20been%20activated.%20%0ALog%20in%20to%20your%20investocafe%20account%20and%20start%20investing.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4";
			$url=str_replace(" ", "%20", $url1);
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$output = curl_exec($ch);
			$dbData = array ('phone'=>$userPhone,'response'=>$output);
			$this->db->insert('msg_log',$dbData);
			curl_close($ch);
			if ( $output === FALSE)
			{
				$output=curl_error($ch); //echoes last session error
				return false;
			}
			return $output;
        }
    }


    // second registration
    public function investorGetInfo()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                		if(decode($post->login_token)){
                			$user_data = json_decode(decode($post->login_token));
                			if(isset($user_data->investor_id)){
                				$row = $this->api_registration_model->getInvestorDatailFirstStatpRegitration($user_data->investor_id);
                				if($row){
                					$row->name = decode($row->name);
                					$row->phone = decode($row->phone);
                					if($row->date_of_birth=='0000-00-00'){
                						$row->date_of_birth = '';
                					}
                					$dt['user_detail'] = $row;
                				} else {
                					$dt['user_detail'] = false;
                				}
            	                $dt["country_list"] = $this->api_registration_model->getCountyList();
            	                $dt['gender'] = [
            	                	'Male'=>'Male',
            	                	'Female'=>'Female'
            	                ];
            	                $dt['send_key_group'] = [
            						'investor_name',
            						'date_of_birth',
            						'place_of_birth',
            						'county_of_birth_id',
            						'mobile_number',
            						'gender',
            						'login_token'
            					];
            	                // $dt["allNationalities"] = $this->api_registration_model->getAllNationalities();
            	                // echo '{"status":200,"data":'.json_encode($dt).'}';
                                 response($dt);
                			}else{
                				$error[] = "login_token not recieve";
            					echo '{"status":500,"errors":'.json_encode($error).'}';
                			}
                		}else{
                			$error[] = "Invalid login token";
            				errorResponse($error,404);
                		}
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }

        }else{
            errorResponse(['invalid token'],404);
        }
    }


    public function saveInvestorInfo()
    {
        if($partner = checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        	$upload_data = [];
                        	$error = [];
                        	$recieve_data = $post;
            				$user_data = json_decode(decode($recieve_data->login_token));
            				if(isset($recieve_data->date_of_birth)){
            					$dob = explode('-', $recieve_data->date_of_birth);
            					if((checkdate($dob[1],$dob[2],$dob[0]))){
            						$diff = abs(strtotime(date("Y-m-d")) - strtotime($recieve_data->date_of_birth));
        							$years = floor($diff / (365*60*60*24));
        							if($years>17){
        								$upload_data['date_of_birth'] = $recieve_data->date_of_birth;
        							}else{
        								$error[] = "Investor age should be greater then 18 year old";
        							}
            					} else {
            						$error[] = "Invalid date of birth";
            					}
            				} else {
            					$error[] = "date_of_birth not exists";
            				}

            				// 
            				if(isset($recieve_data->place_of_birth)){
            					if($recieve_data->place_of_birth != ''){
            						$upload_data['place_of_birth'] = $recieve_data->place_of_birth;
            					}else{
            						$error[] = "place of birth not null";
            					}
            				}else{
            					$error[] = "key place_of_birth not exists";
            				}

            				// 
            				if(isset($recieve_data->county_of_birth_id)){
            					if($recieve_data->county_of_birth_id!=''){
            						$upload_data['county_of_birth_id'] = $recieve_data->county_of_birth_id;
            					}else{
            						$error[] = "county_of_birth_id not null";
            					}
            				}else{
            					$error[] = "key county_of_birth_id not exists";
            				}

            				if(isset($recieve_data->gender)){
            					if($recieve_data->gender=='Male' || $recieve_data->gender=='Female'){
            						$upload_data['gender'] = $recieve_data->gender;
            					}else{
            						$error[] = "Invalid gender";
            					}
            				} else {
            					$error[] = "key gender not exists";
            				}

            				if(count($error)>0){
            					// echo '{"status":200,"errors":'.json_encode($error).'}';
                                errorResponse($error,404);
            				}else{
                                $pos = $this->db->WHERE(['unique_id' => $recieve_data->PosAgentId])->get('pos_detail');
                                if($pos->num_rows() > 0){
                                    $agent_id = $pos->row()->self_id;
                                }else{
                                    $agent_id = $partner->user_id;
                                }
            					$data = array(
        				            "nationality_id" => 86,
        				            "status" => 'Resident Individual',
        				            "date_of_birth" => $recieve_data->date_of_birth,
        				            "place_of_birth" => $recieve_data->place_of_birth,
        				            "country_of_birth_id" => $recieve_data->county_of_birth_id,
        				            "gender" => $recieve_data->gender,
        				            "armed_forces" => 0,
                                    "kin"=>encode(1),
                                    "agent_id"=>$agent_id,
                                    "pos"=>$recieve_data->PosAgentId
        				        );
            					 // print_r($data);
                  //                exit;
        				        $result = $this->api_registration_model->updateInvestorInfo($user_data->investor_id, $data);
        				        if($result){
        				        	$this->updateInvestorstatus($user_data->investor_id);
        				        	// echo '{"status":200,"msg":"updated success"}';
                                    response(["msg"=>"Data updated success"]);
        				        } else {
                                    $error[] = "Server Error try again";
                                    errorResponse($error,404);
        				        }
            				}
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }

        }else{
            errorResponse(['invalid token'],404);
        }
    }

    public function updateInvestorstatus($investorId)
    {
        $today_date = date("Y-m-d H:i:s");
        $data       = array(
            "is_investor_form_complet_date" => $today_date,
            "is_investor_form_complet" => 0,
            "is_investor_registered" => 1
        );
        $result   = $this->api_registration_model->updateInvestorStatusSecontRegitration($investorId, $data);
    }

    // third registration 
    public function getAddressInfo()
    {

        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
            		        $recieve_data = $post;
            				// 
            				$user_data = json_decode(decode($recieve_data->login_token));
            				// $this->load->model('registration/registration_model');
            				// data from admin
            				$data = [];
            				$invId = $user_data->investor_id;
        					$data["investor_detail"]      = $this->api_registration_model->getInvestorDetail($invId);
                            $data["investor_detail"]->pan = decode($data["investor_detail"]->pan);
        					$data["city_list"]            = $this->api_registration_model->getCityList();
        					$data["state_list"]           = $this->api_registration_model->getStateList();
        					$data["country_ist"]          = $this->api_registration_model->getCountyList();
        					$data["address_proof_list"]   = $this->api_registration_model->getInvestorAddressProofList();
        					$data["id_proof_list"]        = $this->api_registration_model->getInvestorIdProofList();
        					$data["family_status_list"]   = $this->api_registration_model->getInvestorFamilyStatusList();
        					$data["occuption_list"]       = $this->api_registration_model->getInvestorOccupationList();
        					$data['send_key_group'] = [
        						'pincode',
        						'address_1',
        						'address_2',
        						'city',
        						'state_id',
        						'address_proof_id',
        						'pan_number',
        						'family_status_id',
        						'father_or_spouse_name',
        						'mother_name',
        						'occupation_id',
        						'income_in_lakh',
        						'date_of_annyvarsary'
        					];
        					// echo "<pre>";
        					// print_r();
        					// echo '{"status":200,"data":'.json_encode($data).'}';
                            response($data);
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }

        }else{
            errorResponse(['invalid token'],404);
        }
    }

    public function saveAddressInfo()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        	$error = [];
                        	$recieve_data = $post;
            				// print_r($recieve_data);
            				if(isset($recieve_data->pincode)){
            					if(strlen($recieve_data->pincode) == 6){
            						if(is_numeric($recieve_data->pincode)){
            							$save_data['pincode'] = $recieve_data->pincode;
            						}else{
            							$error[] = "invalid pincode";
            						}
            					}else{
            						$error[] = "invalid pincode";
            					}
            				}else{
            					$error[] = "Key pincode not recieve";
            				}

            				// 
            				if(isset($recieve_data->address_1)){
            					if(strlen($recieve_data->address_1)<41 and $recieve_data->address_1 != ""){
            						$save_data['address'] = $recieve_data->address_1;
            					}else{
            						$error[] = "address_1 lenth should be less then or equal to 40";
            					}
            				}else{
            					$error[] = "Key address_1 not recieve";
            				}

            				if(isset($recieve_data->address_2)){
            					if(strlen($recieve_data->address_2)<41){
        							$save_data['address_2'] = $recieve_data->address_2;
        						}else if($recieve_data->address_2==""){
        							$save_data['address_2'] = "";
        						}else{
        							$error[] = "address_2 lenth should be less then or equal to 40";
        						}
            				}else{
            					$save_data['address_2'] = "";
            				}

            				if(isset($recieve_data->city) && $recieve_data->city!=""){
            					$save_data['original_city'] = $recieve_data->city;
            				}else{
            					$error[] = "key city is mandatory";
            				}

            				if(isset($recieve_data->state_id)){
            					$state_reposne = $this->checkstate($recieve_data->state_id,$recieve_data->city);
            					if($state_reposne['status']){
            						$save_data['city_id'] = $state_reposne['city_id'];
            						$save_data['state_id'] = $recieve_data->state_id;
            					}else{
            						$error[] = 'Invalid state id';
            					}
            				}else{
            					$error[] = 'Key state_id is mandatory';
            				}

            				if(isset($recieve_data->address_proof_id)){
            					if(is_numeric($recieve_data->address_proof_id)){
            						if($recieve_data->address_proof_id > 0 && $recieve_data->address_proof_id < 10){
            							$save_data['investor_address_proof_id'] = $recieve_data->address_proof_id;
            						}else{
            							$error[] = 'Invalid address_proof_id';
            						}
            					}else{
            						$error[] = 'Invalid address_proof_id';
            					}
            				}else{
            					$error[] = 'Key address_proof_id is mandatory';
            				}

            				if(isset($recieve_data->pan_number)){
            					if(preg_match('/^([a-zA-Z]){5}([0-9]){4}([a-zA-Z]){1}?$/', $recieve_data->pan_number)){
            						$save_data['pan'] = encode(strtoupper($recieve_data->pan_number));
            					}else{
            						$error[] = 'Invalid Pan Number';
            					}
            				}else{
            					$error[] = 'Key pan_number is mandatory';
            				}

            				if(isset($recieve_data->family_status_id)){
            					if(in_array($recieve_data->family_status_id, [1,2,3])){
            						$save_data['investor_family_status_id'] = $recieve_data->family_status_id;
            					}else{
            						$error[] = 'Invalid family_status_id';
            					}
            				}else{
            					$error[] = 'Key family_status_id is mandatory';
            				}

            				if(isset($recieve_data->father_or_spouse_name)){
            					if($recieve_data->father_or_spouse_name !=''){
            						$save_data['father_spouse_name'] = $recieve_data->father_or_spouse_name;
            					}else{
            						$error[] = 'father_or_spouse_name is not null';
            					}
            				}else{
            					$error[] = 'Key father_or_spouse_name is mandatory';
            				}

            				if(isset($recieve_data->mother_name)){
            					if($recieve_data->mother_name !=''){
            						$save_data['mother_name'] = $recieve_data->mother_name;
            					}else{
            						$error[] = 'mother_name is not null';
            					}
            				}else{
            					$error[] = 'Key mother_name is mandatory';
            				}

            				if(isset($recieve_data->occupation_id)){
            					if(in_array($recieve_data->occupation_id, [1,2,3,4,5,6,7,8,9,10,11,12,13])){
            						$save_data['occupation_id'] = $recieve_data->occupation_id;
            					}else{
            						$error[] = 'Invalid occupation_id';
            					}
            				}else{
            					$error[] = 'Key occupation_id is mandatory';
            				}

            				if(isset($recieve_data->income_in_lakh)){
            					if(is_numeric($recieve_data->income_in_lakh)){
            						$save_data['income'] = $recieve_data->income_in_lakh;
            					}else{
            						$error[] = 'Invalid income_in_lakh';
            					}
            				}else{
            					$error[] = 'Key income_in_lakh is mandatory';
            				}

            				if(isset($recieve_data->date_of_annyvarsary) && $recieve_data->date_of_annyvarsary!=''){
            					$doa = explode('-', $recieve_data->date_of_annyvarsary);
            					if((@checkdate(@$doa[1],@$doa[2],@$doa[0]))){
            						$save_data['doa'] = $recieve_data->date_of_annyvarsary;
            					}else{
            						$error[] = 'date_of_annyvarsary invalid date';
            					}
            				}

            				if(count($error)>0){
                                errorResponse($error,404);
        	    			}else{
        	    				$user_data = json_decode(decode($recieve_data->login_token));
        	    				$save_data['application_number'] = $user_data->investor_id . "APN" . date("ymd");
        	    				$save_data['country'] = 76;
        	    				$save_data['is_complete_inv_detail'] = 1;

        	    				$response = $this->api_registration_model->updateInvestorInfo($user_data->investor_id,$save_data);
        	    				if($response){
                                    response(["msg"=>"Data updated successfully"]);
        	    				}else{
                                    $error[] = "database error please try again";
                                    errorResponse($error,404);
        	    				}
        	    			}
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            errorResponse(['invalid token'],404);
        }
    }

    public function checkstate($state_id,$city)
    {
    	$res = $this->db->query("SELECT `id`,`state_name` FROM state WHERE id = '".$state_id."'");
    	if($res->num_rows() > 0){
    		$res_city = $this->db->query("SELECT `id`,`location_name` FROM `city` WHERE `location_name`= '".$city."'");
    		if($res_city->num_rows() > 0){
    			return [
    				"status"=>true,
    				"city_id"=>$res_city->row()->id
    			];
    		}else{
    			$res_city = $this->db->query("SELECT `id`,`location_name` FROM `city` WHERE `location_name`= '".get_neear_city($res->row()->state_name)."'");
    			return [
    				"status"=>true,
    				"city_id"=>$res_city->row()->id
    			];
    		}
    	}else{
    		return [
    			"status"=>false,
    			"msg"=>"Invalid state id"
    		];
    	}
    }

    //bank detail
    public function getBankDetail()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        		$recieve_data = $post;
                        		if(isset($recieve_data->login_token)){
                        			if(decode($recieve_data->login_token)){
                        				$user_data = json_decode(decode($recieve_data->login_token));
                    					$bank_data       = $this->api_registration_model->getInvestorBankAndPanDetail($user_data->investor_id);
                                        $res = $this->db->query("SELECT `nominee_details_id`, `name`, `relation_with_investor`, `date_of_birth`, `address`,`percentage` FROM `nominee_details` WHERE `investor_id` = $user_data->investor_id AND STATUS = 1");
                                        if($res->num_rows() > 0){
                                            $dt["nominee_detail"] = $res->result();
                                        }else{
                                            $dt["nominee_detail"] = false;
                                        }
                                        if($bank_data){
                                            $dt["bankData"] = $bank_data;
                                            $dt["bankData"]->account_holder_name = decode($bank_data->account_holder_name);
                                            $dt["bankData"]->account_number = decode($bank_data->account_number);
                                        }else{
                                            $dt["bankData"] = (object) [
                                                        "account_holder_name"=>"",
                                                        "account_number"=>"",
                                                        "account_type_id"=>"",
                                                        "ifsc_code"=>"",
                                                        "branch_city"=>"",
                                                        "branch_state"=>"",
                                                        "branch_name"=>"",
                                                        "bank_master_id"=>"",
                                                        "account_type"=>"",
                                                        "bank_name"=>"",
                                                        "atom_code"=>"",
                                            ];
                                        }
                                        
                    					$dt["bankMasterList"]      = $this->api_registration_model->getbankMasterAll();
                    					$dt["bankAccountTypeList"] = $this->api_registration_model->getInvestorBankAccountTypeList();
                    					$dt['send_key_group'] = [
                    						'name_as_per_bank_account',
                    						'account_number',
                    						'account_type_id',
                    						'ifsc_code',
                    						'bank_master_id',
                    						'branch_name',
                    						'branch_city',
                    						'branch_state'
                    					];
                    					response($dt,200);
                        			}else{
                        				$error[] = "Invalid login_token";
                    					errorResponse($error,500);
                        			}
                        		}else{
                        			$error[] = "Invalid login_token";
                    				errorResponse($error,500);
                        		}
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            errorResponse(['invalid token'],404);
        }
    }

    public function getSameAsInvestorAddress()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                            $recieve_data = $post;
                            if(decode($recieve_data->login_token)){
                                $user_data = json_decode(decode($recieve_data->login_token));
                                // print_r($user_data);
                                $res = $this->db->query("SELECT investor.address, investor.address_2, investor.pincode, state.state_name, country.country_name FROM investor JOIN state ON state.id = investor.state_id JOIN country ON country.country_id = investor.country WHERE investor_id = $user_data->investor_id");
                                if($res->num_rows() > 0){
                                    response(['address' => $res->row()]);
                                }else{
                                    $error[] = "Data not found";
                                    errorResponse($error,500);
                                }
                            }else{
                                $error[] = "Invalid login_token";
                                errorResponse($error,500);
                            }
                                
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            errorResponse(['invalid token'],404);
        }
    }

    public function fetchBankDataFromIFSC()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        		$recieve_data = $post;
                        		if(isset($recieve_data->login_token)){
                        			if(decode($recieve_data->login_token)){
                                        $ifsc = $recieve_data->ifsc_code;
                                        $response = $this->api_registration_model->getBankDetailUsingIFSC($ifsc);
                        				if($response){
                        					response($response);
                        				}else{
                        					$error[] = "Invalid IFSC code";
                    						errorResponse($error,404);
                        				}
                        				
                        			}else{
                        				$error[] = "Invalid login_token";
                    					errorResponse($error,500);
                        			}
                        		}else{
                        			$error[] = "Invalid login_token";
                    				errorResponse($error,500);
                        		}
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            errorResponse(['invalid token'],404);
        }
    }

    public function saveBankDetail()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        	$error = [];
                        	$recieve_data = $post;
            				$user_data = json_decode(decode($recieve_data->login_token));
            				$save_data = [];
            				if(isset($recieve_data->name_as_per_bank_account)){
            					if($recieve_data->name_as_per_bank_account != ""){
            						$save_data['name'] = encode($recieve_data->name_as_per_bank_account);
            						$save_data['account_holder_name'] = encode($recieve_data->name_as_per_bank_account);
            					}else{
            						$error[] = "name_as_per_bank_account is mandatory";
            					}
            				}else{
            					$error[] = "key name_as_per_bank_account not found";
            				}

            				// 
            				if(isset($recieve_data->account_number)){
            					if($recieve_data->account_number != ""){
            						$save_data['account_number'] = encode($recieve_data->account_number);
            					}else{
            						$error[] = "account_number is mandatory";
            					}
            				}else{
            					$error[] = "key account_number not found";
            				}

            				// 
            				if(isset($recieve_data->account_type_id)){
            					if(in_array($recieve_data->account_type_id, [1,2])){
            						$save_data['account_type_id'] = $recieve_data->account_type_id;
            					}else{
            						$error[] = "account_type_id is invalid";
            					}
            				}else{
            					$error[] = "key account_type_id not found";
            				}

            				// 
            				if(isset($recieve_data->ifsc_code)){
            					if(true){
            						$save_data['ifsc_code'] = $recieve_data->ifsc_code;
        	    				}else{
        	    					$error[] = "Invalid IFSC code";
        	    				}
            				}else{
            					$error[] = "key ifsc_code not found";
            				}

            				// 
            				if(isset($recieve_data->bank_master_id)){
            					if($this->api_registration_model->get_bank_master($recieve_data->bank_master_id)){
            						$save_data['bank_master_id'] = $recieve_data->bank_master_id;
            					}else{
            						$error[] = "Invalid Bank Master id";
            					}
            				}else{
            					$error[] = "key bank_master_id not found";
            				}

            				// 
            				if(isset($recieve_data->branch_name)){
            					if($recieve_data->branch_name != ''){
            						$save_data['branch_name'] = $recieve_data->branch_name;
            					}else{
            						$error[] = "Branch name is mandatory";
            					}
            				}else{
            					$error[] = "key branch_name not found";
            				}

            				// 
            				if(isset($recieve_data->branch_city)){
            					if($recieve_data->branch_city != ''){
            						$save_data['branch_city'] = $recieve_data->branch_city;
            					}else{
            						$error[] = "branch_city is mandatory";
            					}
            				}else{
            					$error[] = "key branch_city not found";
            				}

            				// 
            				if(isset($recieve_data->branch_state)){
            					if($recieve_data->branch_state != ""){
            						$save_data['branch_state'] = $recieve_data->branch_state;
            					}else{
            						$error[] = "branch_state is mandatory";
            					}
            				}else{
            					$error[] = "key branch_state not found";
            				}

            				if(count($error)>0){
            					errorResponse($error,404);
            				}else{
            					$save_data['investor_id'] = $user_data->investor_id;
            					$r = $this->api_registration_model->updateInvestorBankDetails($user_data->investor_id,$save_data);
            					if($r){
                                    $this->db->WHERE('investor_id',$user_data->investor_id)->update('investor',[
                                        "is_do_not_reg_nominee"=>0,
                                        "is_incomplete_bank_detail"=>0,
                                        "investor_id_proof_id"=> 7
                                    ]);
            						response(["msg"=>'successfully update']);
            					}else{
            						$error[] = "Server Error";
        							errorResponse($error,500);
            					}
            				}
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            errorResponse(['invalid token'],404);
        }
    }

    public function saveNominee()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        	$error = [];
                        	
                        		$recieve_data = $post;
                        		if(isset($recieve_data->login_token)){
                        			if(decode($recieve_data->login_token)){
                        				$user_data = json_decode(decode($recieve_data->login_token));
                        				$save_data = [];
                        		
                        				if(isset($recieve_data->nominee_name)){
                        					if($recieve_data->nominee_name != ""){
                        						$save_data['name'] = $recieve_data->nominee_name;
                        					}else{
                        						$error[] = "Nominee name is mandatory";
                        					}
                        				}else{
                        					$error[] = "key nominee_name is not found";
                        				}

                        				if(isset($recieve_data->relation_with_investor)){
                        					if($recieve_data->relation_with_investor != ""){
                        						$save_data['relation_with_investor'] = $recieve_data->relation_with_investor;
                        					}else{
                        						$error[] = "relation_with_investor is mandatory";
                        					}
                        				}else{
                        					$error[] = "key relation_with_investor is not found";
                        				}

                        				if(isset($recieve_data->percentage)){
                                            // echo "run";
                                            // exit;
                        				}else{
                        					$error[] = "key percentage is not found";
                        				}

                        				$guardian_mandatory_indicator = 0;
                        				if(isset($recieve_data->date_of_birth)){
                        					$dob = explode('-', $recieve_data->date_of_birth);
                        					if((@checkdate(@$dob[1],@$dob[2],@$dob[0]))){
                        						$save_data['date_of_birth'] = $recieve_data->date_of_birth;
                        						$diff = abs(strtotime(date("Y-m-d")) - strtotime($recieve_data->date_of_birth));
                    							$years = floor($diff / (365*60*60*24));
                    							if($years<18){
                    								$guardian_mandatory_indicator = 1;
                    							}
                        					}else{
                        						$error[] = 'date_of_birth invalid date please use formate yyyy-mm-dd';
                        					}
                        				}else{
                        					$error[] = "key date_of_birth is not found";
                        				}

                        				if(isset($recieve_data->guardian_name) && $guardian_mandatory_indicator==1){
                        					if($recieve_data->guardian_name != ""){
                        						$save_data['guardian_name'] = $recieve_data->guardian_name;
                        					}else{
                        						$error[] = "guardian_name is mandatory";
                        					}
                        				}else if($guardian_mandatory_indicator==1){
                        					$error[] = "key guardian_name is not found";
                        				}else{
                        					$save_data['guardian_name'] = "";
                        				}

                        				if(isset($recieve_data->relation_with_guardian) && $guardian_mandatory_indicator==1){
                        					if($recieve_data->relation_with_guardian != ""){
                        						$save_data['relation_with_guardian'] = $recieve_data->relation_with_guardian;
                        					}else{
                        						$error[] = "relation_with_guardian is mandatory";
                        					}
                        				}else if($guardian_mandatory_indicator==1){
                        					$error[] = "key relation_with_guardian is not found";
                        				}else{
                        					$save_data['relation_with_guardian'] = "";
                        				}

                        				if(isset($recieve_data->address)){
                        					if($recieve_data->address !=""){
                        						$save_data['address'] = $recieve_data->address;
                        					}else{
                        						$error[] = "address is mandatory";
                        					}
                        				}else{
                        					$error[] = "key address is not found";
                        				}
                                        // echo $user_data->investor_id;
                                        // exit;
                        				$nominee_per_data = $this->api_registration_model->getPersentageOfNominee($user_data->investor_id);
                        				if(isset($recieve_data->percentage)){
                        					if($recieve_data->percentage !=""){
                        						if($recieve_data->percentage == 0){
                        							$error[] = "percent should not be 0";
                        						}else if($nominee_per_data[0] == 0){
                        							$error[] = "You already add 100% of nominee";
                        						}else if($nominee_per_data[0]< $recieve_data->percentage){
                        							$error[] = "Your remaining percent is ".$nominee_per_data[0]." you can't assign more then it";
                        						}else if($nominee_per_data[1] == 2 and $nominee_per_data[0]> $recieve_data->percentage){
                        							$error[] = "You have to assign all ".$nominee_per_data[0]."% of your remaining percent to your 3rd nominee";
                        						}else if($nominee_per_data[1] == 3){
                        							$error[] = "You already add all 3 nominee";
                        						}else{
                        							$save_data['percentage'] = $recieve_data->percentage;
                        						}
                        					}else{
                        						$error[] = "percentage is mandatory";
                        					}
                        				}else{
                        					$error[] = "key percentage is not found";
                        				}

                        				if(isset($recieve_data->pin_code)){
                        					if( strlen($recieve_data->pin_code) != 6 ){
                        						$error[] = "Invalid pincode";
                        					}else if(!is_numeric($recieve_data->pin_code)){
                        						$error[] = "Invalid pincode";
                        					}else{
                        						$save_data['pin_code'] = $recieve_data->pin_code;
                        					}
                        				}else{
                        					$error[] = "key pin_code is not found";
                        				}

                        				if(count($error) > 0){
                        					errorResponse($error,500);
                        				}else{
                        					$save_data['investor_id'] = $user_data->investor_id;
                        					// print_r($save_data);
                        					// exit;
                        					$resultAddNominee = $this->api_registration_model->addInvestorNomineeDetails($save_data);
                        					if($resultAddNominee){
                        						response([
                        							"msg"=>"successfully save",
                        							"remaining_percent"=> $nominee_per_data[0] - $save_data['percentage'],
                                                    "last_id"=>$resultAddNominee
                        						]);
                        					}else{
                        						$error[] = "Server error nominee not add please try again";
                    							errorResponse($error,500);
                        					}
                        				}

                        			}else{
                        				$error[] = "Invalid login_token";
                    					errorResponse($error,500);
                        			}
                        		}else{
                        			$error[] = "Invalid login_token";
                    				errorResponse($error,500);
                        		}
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            errorResponse(['invalid token'],404);
        }
    }

    public function createDocumentList()
	{ 
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        	$error = [];
                        		$recieve_data = $post;
                    			if(decode($recieve_data->login_token)){
                    				$user_data = json_decode(decode($recieve_data->login_token));
                					// $get = json_decode(file_get_contents('php://input'));
                				    $investorId= $user_data->investor_id;
                					$arrayDoc = [];
                					$this->load->model('registration/registration_model');
                					$result=$this->registration_model->getInvestorDetail($investorId);
                					$resultNominee=$this->registration_model->getInvestorNomineeDetail($investorId);
                					$resultBank=$this->registration_model->getInvestorBankAndPanDetail($investorId);
                					$nomineeData=$resultNominee;
                					$bankData=$resultBank;
                					$investorDetailRow=$result;
                					$overseasDetails=$this->registration_model->getInvestorOverseasDetail($investorId);
                					$investorStatus=$this->common_model->getInvestorStatus($investorId);
                					$docTypeList=$this->registration_model->getdocumentTypeList();
                					if(isset($investorDetailRow) && !empty($investorDetailRow) && isset($investorStatus) && !empty($investorStatus))
                					{
                					    $investorType = $investorDetailRow->investor_type;
                					    $idProof=$investorDetailRow->id_proof;
                					    $addressProof = $investorDetailRow->address_proof;
                					    $isKycDone=$investorStatus->is_kyc_done;
                					    // $arrCheckList=[];
                					    if(($investorType=="Resident Indian (Individual)") && ($isKycDone==1))
                					    {
                					      // print_r("true");die;
                					      if($idProof==$addressProof)
                					      {
                					        $arrCheckList[]=$idProof;
                					        $arrCheckList[]="Signed Mandate Form";
                					        $arrCheckList[]="Signed Service Agreement";
                					        $arrCheckList[]="Signed Investor's Application Form";
                					        $arrCheckList[]="Signed Pancard";
                					        $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									   array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }

                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									    array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                					    else if(($investorType=="Resident Indian (Individual)") && ($isKycDone!=1))
                					    {
                					      if($idProof==$addressProof)
                					      {
                					        $arrCheckList[]=$idProof;
                					        $arrCheckList[]="Signed Pancard";
                					        $arrCheckList[]="Signed Mandate Form";
                					        $arrCheckList[]="Signed Service Agreement";
                					        $arrCheckList[]="Signed Investor's Application Form";
                					        $arrCheckList[]="Signed Address Proof";
                					        $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					        $arrCheckList[]="Signed KYC form";
                					        $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									    array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									   array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                					    else if((($investorType=="Non-Resident Indian(NRI)(individual) (NRE)") || ($investorType=="Non-Resident Indian(NRI)(individual) (NRO)")) && ($isKycDone==1))
                					    {
                					      if($idProof==$addressProof)
                					      {
                					        if($idProof=="Passport")
                					        {
                					          $arrCheckList[]="Passport with Visa";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					          foreach($arrCheckList as $row)
                					          {
                					            if(isset($docTypeList) && !empty($docTypeList))
                					            {
                					              foreach ($docTypeList as $docRow)
                					              {
                					                if($docRow->document_name==$row)
                					                {
                										array_push($arrayDoc,$docRow->document_type_id);
                					                }
                					              }
                					            }
                					          }
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]="Passport with Visa";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					          foreach($arrCheckList as $row)
                					          {
                					            if(isset($docTypeList) && !empty($docTypeList))
                					            {
                					              foreach ($docTypeList as $docRow)
                					              {
                					                if($docRow->document_name==$row)
                					                {
                										array_push($arrayDoc,$docRow->document_type_id);
                					                }
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Passport with Visa";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Passport with Visa";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									               array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                					    else if((($investorType=="Non-Resident Indian(NRI)(individual) (NRE)") || ($investorType=="Non-Resident Indian(NRI)(individual) (NRO)")) && ($isKycDone!=1))
                					    {
                					      if($idProof==$addressProof)
                					      {
                					        if($idProof=="Passport")
                					        {
                					          $arrCheckList[]="Passport with Visa";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					          foreach($arrCheckList as $row)
                					          {
                					            if(isset($docTypeList) && !empty($docTypeList))
                					            {
                					              foreach ($docTypeList as $docRow)
                					              {
                					                if($docRow->document_name==$row)
                					                {
                										              array_push($arrayDoc,$docRow->document_type_id);
                					                }
                					              }
                					            }
                					          }
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]="Passport with Visa";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					          foreach($arrCheckList as $row)
                					          {
                					            if(isset($docTypeList) && !empty($docTypeList))
                					            {
                					              foreach ($docTypeList as $docRow)
                					              {
                					                if($docRow->document_name==$row)
                					                {
                										              array_push($arrayDoc,$docRow->document_type_id);
                					                }
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Passport with Visa";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Passport with Visa";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }

                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									   array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                					    else if(($investorType=="Person of indian origin (PIO)(Individual) Non-Resident") && ($isKycDone==1))
                					    {
                					      if($idProof==$addressProof)
                					      {
                					        $arrCheckList[]=$idProof;
                					        $arrCheckList[]="Signed copy of PIO card";
                					        $arrCheckList[]="Signed Mandate Form";
                					        $arrCheckList[]="Signed Service Agreement";
                					        $arrCheckList[]="Signed Investor's Application Form";
                					        $arrCheckList[]="Signed Pancard";
                					        $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									   array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }

                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									   array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                					    else if(($investorType=="Person of indian origin (PIO)(Individual) Non-Resident") && ($isKycDone!=1))
                					    {
                					      if($idProof==$addressProof)
                					      {
                					        $arrCheckList[]=$idProof;
                					        $arrCheckList[]="Signed copy of PIO card";
                					        $arrCheckList[]="Signed Mandate Form";
                					        $arrCheckList[]="Signed Service Agreement";
                					        $arrCheckList[]="Signed Investor's Application Form";
                					        $arrCheckList[]="Signed Pancard";
                					        $arrCheckList[]="Signed Address Proof";
                					        $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					        $arrCheckList[]="Signed KYC form";
                					        $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									    array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }

                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									   array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                					    else if((($investorType=="Non-Resident Indian(NRI)(individual) Mariner (NRE)") || ($investorType=="Non-Resident Indian(NRI)(individual) Mariner (NRO)")) && ($isKycDone==1))
                					    {
                					      if($idProof==$addressProof)
                					      {
                					        $arrCheckList[]=$idProof;
                					        $arrCheckList[]="Signed copy of PIO card";
                					        $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					        $arrCheckList[]="Signed Mandate Form";
                					        $arrCheckList[]="Signed Service Agreement";
                					        $arrCheckList[]="Signed Investor's Application Form";
                					        $arrCheckList[]="Signed Pancard";
                					        $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									    array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application FormF";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application FormF";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }

                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									    array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                					    else if((($investorType=="Non-Resident Indian(NRI)(individual) Mariner (NRE)") || ($investorType=="Non-Resident Indian(NRI)(individual) Mariner (NRO)")) && ($isKycDone!=1))
                					    {
                					      if($idProof==$addressProof)
                					      {
                					        $arrCheckList[]=$idProof;
                					        $arrCheckList[]="Signed copy of PIO card";
                					        $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					        $arrCheckList[]="Signed Mandate Form";
                					        $arrCheckList[]="Signed Service Agreement";
                					        $arrCheckList[]="Signed Investor's Application Form";
                					        $arrCheckList[]="Signed Pancard";
                					        $arrCheckList[]="Signed Address Proof";
                					        $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					        $arrCheckList[]="Signed KYC form";
                					        $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									    array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                					        }
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									    array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                						else if($investorType=="On Behalf Of Minor")
                					    {
                					      if($idProof==$addressProof)
                					      {
                					        $arrCheckList[]=$idProof;
                					        $arrCheckList[]="Signed copy of PIO card";
                					        $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					        $arrCheckList[]="Signed Mandate Form";
                					        $arrCheckList[]="Signed Service Agreement";
                					        $arrCheckList[]="Signed Investor's Application Form";
                					        $arrCheckList[]="Signed Pancard";
                					        $arrCheckList[]="Signed Address Proof";
                					        $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					        $arrCheckList[]="Signed KYC form";
                					        $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                							          $arrCheckList[]="Birth certificate of minor";
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									    array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					      else
                					      {
                					        if($idProof=="Pancard")
                					        {
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                							            $arrCheckList[]="Birth certificate of minor";
                					        }
                					        else
                					        {
                					          $arrCheckList[]=$idProof;
                					          $arrCheckList[]=$addressProof;
                					          $arrCheckList[]="Signed copy of PIO card";
                					          $arrCheckList[]="Signed copy of CDC (continuous discharge certificate) booklet";
                					          $arrCheckList[]="Signed Mandate Form";
                					          $arrCheckList[]="Signed Service Agreement";
                					          $arrCheckList[]="Signed Investor's Application Form";
                					          $arrCheckList[]="Signed Pancard";
                					          $arrCheckList[]="Signed Address Proof";
                					          $arrCheckList[]="1 passport size photograph pasted on KYC form with sign across on it";
                					          $arrCheckList[]="Signed KYC form";
                					          $arrCheckList[]="Cancelled cheque/last 6 months bank statement";
                							  $arrCheckList[]="Birth certificate of minor";
                							}
                					        foreach($arrCheckList as $row)
                					        {
                					          if(isset($docTypeList) && !empty($docTypeList))
                					          {
                					            foreach ($docTypeList as $docRow)
                					            {
                					              if($docRow->document_name==$row)
                					              {
                									   array_push($arrayDoc,$docRow->document_type_id);
                					              }
                					            }
                					          }
                					        }
                					      }
                					    }
                					}

                				}else{
                    				$error[] = "Invalid login_token";
                					errorResponse($error,500);
                				}
                                array_push($arrayDoc,"26");
                                array_push($arrayDoc,"27");
                                array_push($arrayDoc,"20");
                                array_push($arrayDoc,"50");

                                // $data=array("investor_id"=>$investorId,"log_msg"=>json_encode($arrayDoc));
                                // addSystemLog($data); // helper function
                                $result=$this->registration_model->updateInvestorDocumentChecklist($investorId,$arrayDoc);
                                $this->createInvestorFormPdf($investorId);
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            errorResponse(['invalid token'],404);
        }
	}

    public function createInvestorFormPdf($investorId)
    {
        $this->load->model('registration/registration_model');
        $result                   = $this->registration_model->getInvestorDetail($investorId);
        $resultNominee            = $this->registration_model->getInvestorNomineeDetail($investorId);
        $resultBank               = $this->registration_model->getInvestorBankAndPanDetail($investorId);
        $resultInvStatus          = $this->registration_model->getInvestorStatus($investorId);
        $data["addressProofList"] = $this->registration_model->getInvestorAddressProofList();
        $data["nomineeData"]      = $resultNominee;
        $data["idProofList"]      = $this->registration_model->getInvestorIdProofList();
        $data["bankData"]         = $resultBank;
        $data["row"]              = $result;
        $data["invStatus"]        = $resultInvStatus;
        $motherName               = spliteAndCheckName($result->mother_n);
        $data["mother_f_name"]    = $motherName['name_first'];
        $data["mother_m_name"]    = $motherName['name_middle'];
        $data["mother_l_name"]    = $motherName['name_last'];
        $pdfBody                  = $this->load->view('investor_form_pdf_view', $data, true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try {
            $mpdf                   = new mPDF('win-1252', 'A4', '', 'DejaVuSans', 0, 0, 0, 0, 10, 10, '');
            $mpdf->useOnlyCoreFonts = true; // false is default
            $mpdf->SetProtection(array(
                'print'
            ));
            $mpdf->SetTitle("INVESTOR DETAILS");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');
            $html = $pdfBody;
            $mpdf->WriteHTML($html);
            $fileName = 'investor' . $investorId . date('YmdHis', time()) . '.pdf';
            $mpdf->Output(APPPATH . '../assets/uploads/investor_form_pdf/' . $fileName, 'F');
            $pdfPath = realpath(APPPATH . '../assets/uploads/investor_form_pdf/' . $fileName);
            $data    = array(
                "investor_pdf_form_url" => $fileName
            );
            $result  = $this->registration_model->updateInvestorInfo($investorId, $data);
            return base_url() . "assets/uploads/investor_form_pdf/" . $fileName;
        }
        catch (Exception $e) {
            echo $e;
            die;
            exit;
        }
    }

    public function removeNominee()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                            $nominee_id = $post->nominee_details_id;
                            $this->db->query("UPDATE nominee_details SET`status` = 2 WHERE `nominee_details_id` = $nominee_id");
                            response(["msg"=>"Remove nominee successfully"]);
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Login token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            errorResponse(['invalid token'],404);
        }
    }

    function verifyEmail()
    {
        $string=$this->input->get("invId");
        $id=str_replace("[plus]",'+',$string);
        $investorId=$this->encrypt->decode($id);
        if($investorId)
        {
            $resultInfo=$this->api_registration_model->varifyinvestordetailgetdata($investorId);
            if(isset($resultInfo) && !empty($resultInfo))
            {
                if($resultInfo->is_verify==0)
                {
                    $data=array("is_verify"=>1);
                    $result=$this->api_registration_model->updateInvestorInfo($investorId,$data);
                    if($result)
                    {
                        // $resultuser=$this->api_registration_model->getUserDataForSendEmail($investorId);
                        // $userName=$this->encrypt->decode($resultuser->username);
                        // $userPhone=$this->encrypt->decode($resultuser->phone);
                        // $sentSms=$this->sendAccountActivationSms($userName,$userPhone);
                     
                        // redirect(base_url().'loginRegistration?task=login');
                        echo '
                        <!DOCTYPE html>
                            <html lang="en">
                            <head>
                              <title>Bootstrap Example</title>
                              <meta charset="utf-8">
                              <meta name="viewport" content="width=device-width, initial-scale=1">
                              <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
                            </head>
                            <body>
                                <div style="padding: 32px;background: #ffe000;border-radius: 12px;color: #463d00;font-weight: 600;display:blog;text-align: center;margin-top: 12%;margin-left: 5%;margin-right: 5%;"><span style="">Your email verified successfully <a style="text-decoration: none;"" href="https://www.investocafe.com/assets/iset/"><b>Click Here</b></a> to complete your registration</span><div>
                            
                            </body>
                            </html>

                        ';
                    }
                    else
                    {
                        echo "Your email address is already verified";
                    }
                }
                else
                {
                    echo "Your email address is already verified";
                }
            }
            else
            {
                $this->_loadView('amit_theme/registration/error_view');
            }
        }
        else
        {
            echo "Invalid Request";
        }
    }
}

