<?php

class ApiWithdraw extends CI_Controller{

	function __construct(){
		parent::__construct();
		$this->load->model('api_model/api_withdraw_model');
	}

	public function index()
	{
		echo "withraw controller";
	}

	public function getRedeemFundByCategory()
	{
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($post)){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
                            if(isset($post->fund_type_id)){
                                $userdata = json_decode(decode($post->login_token));
                                $res = $this->api_withdraw_model->getFreeFunds($post->fund_type_id,$userdata->investor_id);
                                if($res){
                                    response(['funds' => $res]);
                                }else{
                                    $error[] = "No fund found for withdraw ";
                                    errorResponse($error,404);
                                }
                            }else{
                                $error[] = "fund_type_id not found";
                                errorResponse($error,404);
                            }
							
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else{
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}

	public function checkAvailableWithdrwalFunds($fundTypeId,$investor_id)
    {
    	$this->load->model('withdraw/withdraw_model');
        $investorId=$investor_id;
        $resultPurchaseFunds=$this->withdraw_model->getPurchaseFundsReadytoPurchase($fundTypeId,$investorId);
        $resultSoldFunds=$this->withdraw_model->getSoldFunds($fundTypeId,$investorId);
        $data["withdrawFunds"]= array();
        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            foreach ($resultPurchaseFunds as $puchaseRow)
            {
                $fundName=$puchaseRow->scheme_description;
                $minWithDrawalAmount=$puchaseRow->redemption_min_amount;
                $purchaseFundId=$puchaseRow->fund_id;
                $folioNumber=$puchaseRow->folio_number;
                $purchaseUnits=$puchaseRow->unit_count;
                $nav=$puchaseRow->nav;
                $minUnits=$puchaseRow->redemption_min_units;
                $soldCount=0;

                if(isset($resultSoldFunds) && !empty($resultSoldFunds))
                {
                    foreach ($resultSoldFunds as $soldRow)
                    {
                        $soldFundId=$soldRow->fund_id;
                        $soldUnits=$soldRow->unit_count;
                        if($soldFundId==$purchaseFundId)
                        {
                            $balanceUnit=($purchaseUnits-$soldUnits);
                            $soldCount++;
                        }
                    }
                }

                if($soldCount==0)
                {
                    $balanceUnit=$purchaseUnits;
                }

                $withdrawalAmount=round(($balanceUnit*$nav),2);
                $data["withdrawFunds"][]=array(
                    "fund_id"=>$purchaseFundId,
                    "fund_name"=>$fundName,
                    "folio_number"=>$folioNumber,
                    "min_amount"=>$minWithDrawalAmount,
                    "withdrawal_amount"=>$withdrawalAmount,
                    "nav"=>$nav,
                    "redemption_min_units"=>$minUnits,
                    "unit_count"=>$balanceUnit);
            }
            return $data["withdrawFunds"];
        }
    }

    public function createRedeemEntery()
    {
        if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                            $user_data = json_decode(decode($post->login_token));
                            if(isset($post->redeem_fund_json)){
                                $fund_data = $post->redeem_fund_json;
                                $batchId=$this->api_withdraw_model->createNewPurchaseBatchId("Redeem");
                                if($fund_data){
                                    foreach($fund_data as $f_data){
                                        $this->matchFundValue($user_data->investor_id, (object) $f_data,$batchId,$post->investor_ip);
                                    }
                                    response(["msg"=>"Your request for redeemtion is successfully placed"]);
                                }else{
                                    $error[] = "Invalid redeem_fund_json";
                                    errorResponse($error,404);
                                }
                            }else{
                                $error[] = "redeem_fund_json key not recieve";
                                errorResponse($error,404);
                            }
                            // response(['successfully create redeem entery']);
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Key login_token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
    }

    public function matchFundValue($investor_id,$fund_arr,$batchId,$ip){
        if(isset($fund_arr->fund_id)){
            $res = $this->api_withdraw_model->validateFund($fund_arr->fund_id,$investor_id);

            if($res){
                if(isset($fund_arr->amount)){
                    if(isset($fund_arr->redeem_type)){
                        if(isset($ip)){
                            // print_r($res->free_units_current_value." ".$fund_arr->amount);
                            // exit;
                            if(round($res->free_units_current_value) >= round($fund_arr->amount)){
                                 $fundData=array(
                                    "fund_id"=>$fund_arr->fund_id,
                                    "sold_amount"=>$fund_arr->amount,
                                    "unit_count"=>$fund_arr->amount/$res->current_nav,
                                    "investor_id"=>$investor_id,
                                    "request_date"=>date("Y-m-d"),
                                    "folio_number"=>$res->folio_number,
                                    "request_status"=>0,
                                    "withdraw_type"=>$fund_arr->redeem_type,
                                    "batch_id"=>$batchId,
                                    "investor_ip"=>$ip,
                                );
                                $resmsg = investor_detail($investor_id);
                                $msg = $this->encrypt->decode($resmsg->username)." Api withdraw amount of $fund_arr->amount. request email - ".$resmsg->email." phone ".$this->encrypt->decode($resmsg->phone);
                                notificationAlert('withdraw',$msg,$investor_id);
                                $response = $this->api_withdraw_model->insertSoldUnits($fundData);
                                if($response){
                                    return true;
                                }else{
                                    return false;
                                }
                            }else{
                                $error[] = "Invalid redeem amount";
                                errorResponse($error,404);
                            }
                        }else{
                            $error[] = "investor_ip key not receive";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "redeem_type key not found";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "Amount key not found";
                    errorResponse($error,404);
                }
            }else{
                $error[] = "Invalid fund_id";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Fund id not receive";
            errorResponse($error,404);
        }
    }
}