<?php

class ApiEditProfie extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		$this->load->model('api_model/api_edit_profile_model');
	}
	
	public function index()
	{
		echo 'Welcome to Edit profile';
	}

	public function getUserInfo()
	{
		$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							print_r($user_data);
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}

	// get nominee to view all functions
	public function getNominee()
	{
		$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
								$response = $this->api_edit_profile_model->get_nominee_detail($user_data->investor_id);
								if($response){
									$remaining_per = 100 - array_sum(array_column($response, 'percentage'));
									response(['nominees' => $response,'remaining_percent'=>$remaining_per]);
								}else{
	    							response(['nominees' => false,'remaining_percent'=>100]);
								}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
	}

	public function saveNominee()
    {
    	$error = [];
    	if(checkToken()){
			if(methodCheck() == 'POST'){
				$recieve_data = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($recieve_data->login_token)){
						if(decode($recieve_data->login_token)){
		    				$user_data = json_decode(decode($recieve_data->login_token));
		    				$save_data = [];
		    		
		    				if(isset($recieve_data->nominee_name)){
		    					if($recieve_data->nominee_name != ""){
		    						$save_data['name'] = $recieve_data->nominee_name;
		    					}else{
		    						$error[] = "Nominee name is mandatory";
		    					}
		    				}else{
		    					$error[] = "key nominee_name is not found";
		    				}

		    				if(isset($recieve_data->relation_with_investor)){
		    					if($recieve_data->relation_with_investor != ""){
		    						$save_data['relation_with_investor'] = $recieve_data->relation_with_investor;
		    					}else{
		    						$error[] = "relation_with_investor is mandatory";
		    					}
		    				}else{
		    					$error[] = "key relation_with_investor is not found";
		    				}

		    				if(isset($recieve_data->percentage)){

		    				}else{
		    					$error[] = "key percentage is not found";
		    				}

		    				$guardian_mandatory_indicator = 0;
		    				if(isset($recieve_data->date_of_birth)){
		    					$dob = explode('-', $recieve_data->date_of_birth);
		    					if((@checkdate(@$dob[1],@$dob[2],@$dob[0]))){
		    						$save_data['date_of_birth'] = $recieve_data->date_of_birth;
		    						$diff = abs(strtotime(date("Y-m-d")) - strtotime($recieve_data->date_of_birth));
									$years = floor($diff / (365*60*60*24));
									if($years<18){
										$guardian_mandatory_indicator = 1;
									}
		    					}else{
		    						$error[] = 'date_of_birth invalid date please use formate yyyy-mm-dd';
		    					}
		    				}else{
		    					$error[] = "key date_of_birth is not found";
		    				}

		    				if(isset($recieve_data->guardian_name) && $guardian_mandatory_indicator==1){
		    					if($recieve_data->guardian_name != ""){
		    						$save_data['guardian_name'] = $recieve_data->guardian_name;
		    					}else{
		    						$error[] = "guardian_name is mandatory";
		    					}
		    				}else if($guardian_mandatory_indicator==1){
		    					$error[] = "key guardian_name is not found";
		    				}else{
		    					$save_data['guardian_name'] = "";
		    				}

		    				if(isset($recieve_data->relation_with_guardian) && $guardian_mandatory_indicator==1){
		    					if($recieve_data->relation_with_guardian != ""){
		    						$save_data['relation_with_guardian'] = $recieve_data->relation_with_guardian;
		    					}else{
		    						$error[] = "relation_with_guardian is mandatory";
		    					}
		    				}else if($guardian_mandatory_indicator==1){
		    					$error[] = "key relation_with_guardian is not found";
		    				}else{
		    					$save_data['relation_with_guardian'] = "";
		    				}

		    				if(isset($recieve_data->address)){
		    					if($recieve_data->address !=""){
		    						$save_data['address'] = $recieve_data->address;
		    					}else{
		    						$error[] = "address is mandatory";
		    					}
		    				}else{
		    					$error[] = "key address is not found";
		    				}
		    				$this->load->model('api_model/api_registration_model');
		    				$nominee_per_data = $this->api_registration_model->getPersentageOfNominee($user_data->investor_id);
		    				if(isset($recieve_data->percentage)){
		    					if($recieve_data->percentage !=""){
		    						if($recieve_data->percentage == 0){
		    							$error[] = "percent should not be 0";
		    						}else if($nominee_per_data[0] == 0){
		    							$error[] = "You already add 100% of nominee";
		    						}else if($nominee_per_data[0]< $recieve_data->percentage){
		    							$error[] = "Your remaining percent is ".$nominee_per_data[0]." you can't assign more then it";
		    						}else if($nominee_per_data[1] == 2 and $nominee_per_data[0]> $recieve_data->percentage){
		    							$error[] = "You have to assign all ".$nominee_per_data[0]."% of your remaining percent to your 3rd nominee";
		    						}else if($nominee_per_data[1] == 3){
		    							$error[] = "You already add all 3 nominee";
		    						}else{
		    							$save_data['percentage'] = $recieve_data->percentage;
		    						}
		    					}else{
		    						$error[] = "percentage is mandatory";
		    					}
		    				}else{
		    					$error[] = "key percentage is not found";
		    				}

		    				if(isset($recieve_data->pin_code)){
		    					if( strlen($recieve_data->pin_code) != 6 ){
		    						$error[] = "Invalid pincode";
		    					}else if(!is_numeric($recieve_data->pin_code)){
		    						$error[] = "Invalid pincode";
		    					}else{
		    						$save_data['pin_code'] = $recieve_data->pin_code;
		    					}
		    				}else{
		    					$error[] = "key pin_code is not found";
		    				}

		    				if(count($error) > 0){
		    					errorResponse($error,500);
		    				}else{
		    					$save_data['investor_id'] = $user_data->investor_id;
		    					$data["investor_id"] = $user_data->investor_id;
		    					$data["userName"] = $user_data->username;
								$data["nominee_name"] = trim($save_data['name']);
								$data["nominee_relation"] = trim($save_data['relation_with_investor']);
								$data["nominee_percentage"] = trim($save_data['percentage']);
								$data["guardian_name"] = trim($save_data['guardian_name']);
								$data["nominee_dob"] = trim($save_data['date_of_birth']);
								$data["nominee_address"] = trim($save_data['address']);
								$data['user_info'] = $this->api_edit_profile_model->getUserInfo($user_data->investor_id);
								$mailBody = $this->load->view('api_view/nominee_change_pdf_view',$data,true);
								$path = $this->createPDF($mailBody);
		    					$resultAddNominee = $this->api_registration_model->addInvestorNomineeDetails($save_data);
		    					if($resultAddNominee){
		    						response([
		    							"msg"=>"successfully save",
		    							"remaining_percent"=> $nominee_per_data[0] - $save_data['percentage'],
		    							"pdf"=>$path
		    						]);
		    					}else{
		    						$error[] = "Server error nominee not add please try again";
									errorResponse($error,500);
		    					}
		    				}

		    			}else{
		    				$error[] = "Invalid login_token";
							errorResponse($error,500);
		    			}
		    		}else{
		    			$error[] = "Login_token not receive";
						errorResponse($error,500);
		    		}
		    	}else{
		    		$error[] = "data not receive";
					errorResponse($error,404);
		    	}
		    }else{
		    	$error[] = methodCheck()." Method not allowed";
				errorResponse($error,404);
		    }
		}else{
		    	$error[] = "Invalid Token";
				errorResponse($error,404);
		}
    }

    public function getBankDetail()
    {
    	$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							// print_r($user_data);
							$bank_data = $this->api_edit_profile_model->getBankDetail($user_data->investor_id);
							if($bank_data){
								$bank_master = $this->api_edit_profile_model->getBankmaster();
								$BankAcType = $this->api_edit_profile_model->getBankType();
								response(['bank_data' => $bank_data,'bank_master'=>$bank_master,'BankAcType'=>$BankAcType]);
							}else{
								$error[] = "No bank found that you added";
	    						errorResponse($error,404);
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }


    public function createChangeBankEntery()
    {
    	$error = [];
    	$save_data=[];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							if(isset($post->account_holder_name)){
								if($post->account_holder_name != ""){
									$save_data['account_holder_name'] = $post->account_holder_name;
								}else{
									$error[] = "account_holder_name is mandatory";
								}
							}else{
								$error[] = "Key account_holder_name not receive";
							}

							if(isset($post->account_no)){
								if(is_numeric($post->account_no)){
									$save_data['account_no'] = $post->account_no;
								}else{
									$error[] = "Invalid Account number";
								}
							}else{
								$error[] = "Key account_no not receive";
							}

							if(isset($post->account_type_id)){
								if(in_array($post->account_type_id, [1,2])){
									$save_data['account_no'] = $post->account_type_id;
								}else{
									$error[] = "Invalid value for account_type_id";
								}
							}else{
								$error[] = "Key account_type_id not receive";
							}

							if(isset($post->bank_master_id)){
								if(is_numeric($post->bank_master_id) && $post->bank_master_id > 0 && $post->bank_master_id < 96){
									$save_data['account_no'] = $post->bank_master_id;
								}else{
									$error[] = "Invalid value for bank_master_id";
								}
							}else{
								$error[] = "Key bank_master_id not receive";
							}

							if(isset($post->branch_city)){
								if($post->branch_city != ""){
									$save_data['branch_city'] = $post->branch_city;
								}else{
									$error[] = "Invalid value for branch_city";
								}
							}else{
								$error[] = "Key branch_city not receive";
							}

							if(isset($post->branch_state)){
								if($post->branch_state !=""){
									$save_data['branch_state'] = $post->branch_state;
								}else{
									$error[] = "Invalid value for branch_state";
								}
							}else{
								$error[] = "Key branch_state not receive";
							}

							if(isset($post->branch_name)){
								if($post->branch_name != ""){
									$save_data['branch_name'] = $post->branch_name;
								}else{
									$error[] = "Invalid value for branch_state";
								}
							}else{
								$error[] = "Key branch_name not receive";
							}

							if(isset($post->ifsc_code)){
								if($post->ifsc_code != ""){
									$save_data['ifsc_code'] = $post->ifsc_code;
								}else{
									$error[] = "Invalid value for ifsc_code";
								}
							}else{
								$error[] = "Key ifsc_code not receive";
							}

							$save_data['investor_id'] = $user_data->investor_id;
							$save_data['request_date'] = Date("Y-m-d");
							$save_data['status'] = 0;

							if(count($error) > 0){
								errorResponse($error,404);
							}else{
								$response = $this->api_edit_profile_model->insertBankDetails($save_data);
								if($response){
									$get_user_detail = $this->api_edit_profile_model->getUserData($user_data->user_id);
									$get_bank_detail = $this->api_edit_profile_model->getBankDetails($user_data->user_id);
									if($get_user_detail)
									{
										$data["user_address"]=$get_user_detail->address;
										$data["user_pincode"]=$get_user_detail->pincode;
										$data["user_city"]=$get_user_detail->location_name;
										$data["user_state"]=$get_user_detail->state_name;
										$data["user_investorId"]=$user_data->investor_id;
										$data["user_pan"]=$get_user_detail->pan;
										$data["user_name"]=$get_user_detail->username;
										$data["user_email"]=$get_user_detail->email;
										$data["user_phone"]=$get_user_detail->phone;
										$data["user_registeredDate"]=$get_user_detail->is_investor_registered_date;
									}

									$data["userName"]=$user_data->username;
									$data["account_holder_name"]=trim($post->account_holder_name);
									$data["account_number"]=trim($post->account_no);
									$data["account_type"]="";
									$data["ifsc_code"]=trim($post->ifsc_code);
									$data["bank_name"]=trim($get_bank_detail->bank_name);
									$data["branch_city"]=trim($get_bank_detail->branch_city);
									$data["branch_name"]=trim($get_bank_detail->branch_name);
									$data["branch_state"]=trim($get_bank_detail->branch_state);

									$mailBody = $this->load->view('bank_change_pdf_view',$data,true);
									$mailBody2 = $this->load->view('bank_mandate_pdf_view',$data,true);
									$pdf1= $this->createPDF($mailBody,'bank_change_pdf_view');
									$pdf2= $this->createPDF($mailBody2,'bank_mandate_pdf_view');
									response(['success'=>true,"msg"=>"bank update successfully","pdf1"=>$pdf1,"pdf2"=>$pdf2]);
								}else{
									$error[] = "Somthing went to wrong please try again";
	    							errorResponse($error,404);
								}
							}

						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }

    public function getAddressDetail()
    {
    	$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							// print_r($user_data);
							$response = $this->api_edit_profile_model->getAddressDetail($user_data->investor_id);
							if($response){
								$state_list = $this->api_edit_profile_model->getStateList();
								response(['address'=>$response,'states'=>$state_list]);
							}else{
								$error[] = "Your profile did not have address data";
	    						errorResponse($error,404);
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }

    public function saveUpdatedAddress()
    {
    	$error = [];
    	$save_data = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							// print_r($post);
							if(isset($post->new_address)){
								if($post->new_address != ""){
									if(strlen($post->new_address) <41){
										$save_data['address'] = $post->new_address;
									}else{
										$error[] = "new_address fild length did not greater then 40";
									}
								}else{
									$error[] = "new_address is not blank";
								}
							}else{
								$error[] = "Key new_address is not found";
							}

							if(isset($post->new_address2)){
								if($post->new_address2 == ""){
									$save_data['address_2'] = "";
								}else{
									if(strlen($post->new_address2) <41){
										$save_data['address_2'] = $post->new_address2;
									}else{
										$error[] = "address_2 fild length did not greater then 40";
									}
								}
							}else{
								$error[] = "Key new_address_2 is not found";
							}

							if(isset($post->new_pincode)){
								if(!is_numeric($post->new_pincode)){
									$error[] = "Invalid pincode";
								}else if(strlen($post->new_pincode)!=6){
									$error[] = "Invalid pincode";
								}else{
									$save_data['pincode'] = $post->new_pincode;
								}
							}else{
								$error[] = "Key new_pincode is not found";
							}


							if(isset($post->new_state_id)){
								if(in_array($post->new_state_id,[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37])){
									$save_data['state_id'] = $post->new_state_id;
								}else{
									$error[] = "Invalid new_state_id";
								}
							}else{
								$error[] = "Key new_state_id is not found";
							}

							$save_data['request_date'] = date('Y-m-d', time());
							$save_data['country_id'] =76;
							$save_data['status'] =0;
							$save_data['investor_id'] =$user_data->investor_id;

							if(isset($post->new_city)){
								if($post->new_city != ""){
									$response = $this->api_edit_profile_model->getCityId($post->new_city,$post->new_state_id);
									if($response){
										$save_data['city_id'] = $response;
									}else{
										$error[] = "Invalid new_state_id";
									}
								}else{
									$error[] = "new_city is not be blank";
								}
							}else{
								$error[] = "Key new_city is not found";
							}
							if(count($error)>0){
								errorResponse($error,404);
							}else{
								$insert_id = $this->api_edit_profile_model->insertCommunicationAddress($save_data);
								if($insert_id){
									$userData=$this->api_edit_profile_model->getUserData($user_data->user_id);
									if($userData)
									{
										$data["user_address"]=$userData->address;
										$data["user_pincode"]=$userData->pincode;
										$data["user_city"]=$userData->location_name;
										$data["user_state"]=$userData->state_name;
										$data["user_investorId"]=$user_data->investor_id;
										$data["user_pan"]=$userData->pan;
									}

									$data["userName"]=encode($user_data->username);
									$data["new_address"]=trim($post->new_address);
									$data["new_address2"]=trim($post->new_address2);
									$data["new_pincode"]=trim($post->new_pincode);
									$data["new_city_name"]=trim($post->new_city);
									$data["new_state_name"]=$userData->state_name;
									$mailBody = $this->load->view('api_view/address_change_pdf_view',$data,true);
									$pdf = $this->createPDF($mailBody,$path="_change_address_form_");
									response(['success'=>true,"msg"=>"successfully update","pdf"=>$pdf]);
								}else{
									$error[] = "Somthing went to wrong please try again";
									errorResponse($error,404);
								}
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }

    public function createPDF($html,$path="_change_nominee_form_")
    {
		$this->load->library('mpdf60/mPDF');
		try
		{
			$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
			$mpdf->useOnlyCoreFonts = true;    // false is default
			$mpdf->SetProtection(array('print'));
			$mpdf->SetTitle("Change Nominee");
			$mpdf->SetAuthor("Author");
			$mpdf->showWatermarkText = true;
			$mpdf->SetDisplayMode('fullpage');
			$mpdf->WriteHTML($html);
			$fileName = $investorId .$path.date('YmdHis', time()).'.pdf';
			$mpdf->Output(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName, 'F');
			$pdfPath = realpath(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName);
			// echo $pdfPath ;
			return base_url()."/assets/uploads/changeNomineeForm/".$fileName;
		}catch(Exception $e){
			return false;
		}
    }


    public function getContactNumber()
    {
    	$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							response(["success"=>true,"contact_number"=>$user_data->phone]);
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }


    public function updateContactNumber()
    {
    	$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							if(isset($post->contact_number)){
								if(is_numeric($post->contact_number)){
									if(preg_match('/^[0-9]{10}+$/', $post->contact_number)){
										$data['phone'] = encode( $post->contact_number);
									}else{
										$error[] = "Invalid contact_number number";
									}
								}else{
									$error[] = "Invalid contact_number number";
								}
							}else{
								$error[] = "Key contact_number not exist";
							}

							if(count($error) > 0){
								errorResponse($error,404);
							}else{
								$result=$this->ion_auth->update($user_data->user_id,$data);
								if($result){
									response(['success'=>true,"msg"=> "Contact number successfully update"]);
								}else{
									$error[] = "Somthing went to wrong please try again";
	    							errorResponse($error,404);
								}
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }

    public function updatePassword()
    {
    	$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							if(isset($post->old_password)){
								if($post->old_password!=""){
									if($this->ion_auth->hash_password_db($user_data->user_id, $post->old_password)){
										if(isset($post->new_password)){
											if($post->new_password !=""){
												if(strlen($post->new_password) < 6){
													$error[] = "password lenght should be equal or greater then 6";
												}else{
													$data['password'] = $post->new_password;
												}
											}else{
												$error[] = "new password should not be blank";
											}
										}else{
											$error[] = "Key new_password is not exist";
										}
									}else{
										$error[] = "Old password is inccorect";
									}
								}else{
									$error[] = "old_password is not be blank";
								}
							}else{
								$error[] = "Key old_password is not exist";
							}

							if(count($error) > 0){
								errorResponse($error,404);
							}else{
								$result=$this->ion_auth->update($user_data->user_id,$data);
								if($result){
									response(['success'=>true,"msg"=> "New password updated successfully"]);
								}else{
									$error[] = "Somthing went to wrong please try again";
	    							errorResponse($error,404);
								}
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }


    public function getNameOrEmail()
    {
    	$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));
							response(["success"=>true,"name"=>$user_data->username,"email"=>$user_data->email]);
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }

    public function updateNameAndEmail()
    {
    	$error = [];
		if(checkToken()){
			if(methodCheck() == 'POST'){
				$post = (object) $this->input->post();
				if(!empty($this->input->post())){
					if(isset($post->login_token)){
						if(decode($post->login_token)){
							$user_data = json_decode(decode($post->login_token));

							if(isset($post->password)){
								if($post->password!=""){
									if($this->ion_auth->hash_password_db($user_data->user_id, $post->password)){

									}else{
										$error[] = "Invalid password";
									}
								}else{
									$error[] = "password field should not be blank";
								}
							}else{
								$error[] = "key password not found";
							}

							if(isset($post->name)){
								if($post->name != ""){
									$save_data['username'] = encode($post->name);
									$save_data['first_name'] = encode($post->name);
								}else{
									$error[] = "Name field should not be blank";
								}
							}else{
								$error[] = "Key name not exist";
							}

							if(isset($post->email)){
								if($post->email != ""){
									if(filter_var($post->email, FILTER_VALIDATE_EMAIL)) {
										  if($this->api_edit_profile_model->checkEmail($post->email,$user_data->user_id)){
										  	$save_data['email'] = $post->email;
										  }else{
										  	$error[] = "Email id already exist";
										  }
									}else{
										$error[] = "Invalid email id";
									}
								}else{
									$error[] = "Email field should not be blank";
								}
							}else{
								$error[] = "Key email not exist";
							}

							if(count($error) > 0){
								errorResponse($error,404);
							}else{
								 $result=$this->ion_auth->update($user_data->user_id, $save_data);
								 if($result){
								 	response(['success'=>true,"msg"=> "data updated successfully"]);
								 }else{
								 	$error[] = "Somthing went to wrong please try again";
	    							errorResponse($error,404);
								 }
							}
						}else{
							$error[] = "Invalid login token";
	    					errorResponse($error,404);
						}
					}else{
						$error[] = "Key login_token not receive";
	    				errorResponse($error,404);
					}
				}else{
					$error[] = "post data empty";
	    			errorResponse($error,404);
				}
			}else {
				$error[] = methodCheck()." Method not allowed";
	    		errorResponse($error,404);
			}
		}else{
			$error[] = "Invalid token";
	    	errorResponse($error,404);
		}
    }
}