<?php

class ApiUploadDocument extends CI_Controller{
	
	function __construct()
	{
		parent::__construct();
		$this->load->model('api_model/api_upload_document_model');
	}

	public function index()
	{
		echo "run api upload file";
	}

	public function getuploadData()
	{
		if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        	$user_data = json_decode(decode($post->login_token));
                        	$res = $this->api_upload_document_model->getUploadedDocument($user_data->investor_id);
                        	response(['upload_doc' => $res]);
                        }else{
							$error[] = "Invalid login token";
                            errorResponse($error,404);
						}
                    }else{
                        $error[] = "Key login_token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
	}

	public function upload()
	{
		if(checkToken()){
            if(methodCheck() == 'POST'){
                $post = (object) $this->input->post();
                if(!empty($post)){
                    if(isset($post->login_token)){
                        if(decode($post->login_token)){
                        	if(isset($post->doc_type_id)){
                        		if($post->doc_type_id!=""){
                        			if(in_array($post->doc_type_id, [4,5,20,50,7])){
			                            $user_data = json_decode(decode($post->login_token));
			                            $config['upload_path'] = "assets/uploads/cancelled_cheque/";
								        $config['allowed_types'] = 'gif|jpg|png|pdf';
								        $config['max_size'] = 1000;
								        $config['file_name'] = $user_data->investor_id."_".$post->doc_type_id."_".date("dmyhis");
								        $this->load->library('upload', $config);
								        if (!$this->upload->do_upload('file')) {
								            $error[] = $this->upload->display_errors('', '');
			                            	errorResponse($error,404);
								        } else {
								            $data = array('image_metadata' => $this->upload->data());
								            if($data){
								            	$file_path = base_url()."assets/uploads/cancelled_cheque/".$data['image_metadata']['orig_name'];
								            	$fileType = array(".JPG", ".jpg", ".PNG", ".png",".JPEG",".jpeg");
							                    if (in_array($data['image_metadata']['file_ext'], $fileType)){
							                       $file_path =  $this->createCKYCFormPdf($file_path,$user_data->investor_id,$post->doc_type_id);
							                    }
								            	$response = $this->api_upload_document_model->updateDoc($user_data->investor_id,$post->doc_type_id,$file_path);
								            	if($response){
								            		response(['success'=>"file successfully uploaded","file_path"=>$file_path]);
								            	}else{
								            		$error[] = "Somthing went to wrong please try again";
	                            					errorResponse($error,404);
								            	}
								            }else{
								            	$error[] = "Somthing went to wrong please try again";
	                            				errorResponse($error,404);
								            }
								        }
								    }else{
								    	$error[] = "Invalid Doc type id";
                            			errorResponse($error,404);
								    }
							    }else{
							    	$error[] = "doc_type_id should not be blank";
                            		errorResponse($error,404);
							    }
						    }else{
						    	 $error[] = "doc_type_id key not receive";
                            	 errorResponse($error,404);
						    }
                        }else{
                            $error[] = "Invalid login token";
                            errorResponse($error,404);
                        }
                    }else{
                        $error[] = "Key login_token not receive";
                        errorResponse($error,404);
                    }
                }else{
                    $error[] = "post data empty";
                    errorResponse($error,404);
                }
            }else{
                $error[] = methodCheck()." Method not allowed";
                errorResponse($error,404);
            }
        }else{
            $error[] = "Invalid token";
            errorResponse($error,404);
        }
	}

	public function createCKYCFormPdf($img_path,$investorId,$docTypeId)
    {
		$data['img_path'] = $img_path;
		$pdfBody = $this->load->view('api_view/img_to_pdf_view',$data,true);
		$this->load->library('mpdf60/mPDF');
		$uploadFileName = $investorId."_".$docTypeId."_".date("dmyhis").".".'pdf';
		$pdfPath = '';
		try
		{
			$mpdf=new mPDF('win-1252','A4','','DejaVuSans',0,0,0,0,10,10,'');
			$mpdf->useOnlyCoreFonts = true;    // false is default
			$mpdf->SetProtection(array('print'));
			$mpdf->SetTitle("INVESTOR DETAILS");
			$mpdf->SetAuthor("Audit");
			$mpdf->showWatermarkText = true;
			$mpdf->SetDisplayMode('fullpage');
			$html=$pdfBody;
			$mpdf->WriteHTML($html);
			$fileName = $uploadFileName;
			$mpdf->Output(APPPATH.'../assets/uploads/investor_document/'.$fileName, 'F');
			$pdfPath = realpath(APPPATH.'../assets/uploads/investor_document/'.$fileName);
			$data=array("investor_pdf_form_url"=>$fileName);
			return base_url()."assets/uploads/investor_document/".$fileName;
		}
		catch(Exception $e)
		{
			return false;
		}
    }
}