<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : ApiAdditionalPurchaseCron
|   MODEL USE : api_model
|   DATE : 08/10/2016
|   AUTHOER : amit meena
|   COMMENT : This controller is used to get First purchase data from data base then create a xml or txt file 
|   for karvy and cams then call api to hit the cams or karvy server
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class ApiAdditionalPurchaseCron extends CI_Controller
{
/*
-----------------------------------------------------------------------------------------------------
|   USE : __construct
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS USED TO LOAD HELPER AND MODEL TO ALL FUNCTION
-----------------------------------------------------------------------------------------------------
*/
	function __construct()
	{
		parent::__construct();
		$this->load->config('config_cams');
		$this->load->config('config_karvy');
		$this->load->model('purchase_cron/api_model');
		$this->load->helper('cams_helper');
		$this->load->helper('karvy_helper');

		$this->camsFiles = array();
	}

	function hitCams()
	{
		// echo 11;
		
		// echo camsCurlCommandBulk("B0000004000120180316123002.txt");
		//echo 22;
		$filePath = "assets/uploads/CAMS/17May2019_firstPurchase_29365.xml";
		echo $filePath;
		$purchased_units_id = 29365;
		$AMC_code = 'RMF';
		$output = execKarvyJavaUrl($AMC_code, $filePath, '1'.$purchased_units_id, 'p');
		print_r($output);
	}
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : cronFirstPurchase
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : Create a xml file for additional purchase (one time investment)
-----------------------------------------------------------------------------------------------------
*/

	function cronAdditionalPurchase()
	{	
		log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : cronAdditionalPurchase, Message : start running  *****');
		$additionalPurchasedList = $this->api_model->getAdditionalPurchasedList();
		
		if(isset($additionalPurchasedList) && !empty($additionalPurchasedList))
		{
			log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : cronAdditionalPurchase, Message : get addtitional purchased data  *****');
			foreach($additionalPurchasedList as $row)
			{
				$purchaseData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($purchaseData->investor_id);
				$nriArr=array(10,21,11);
				$overseasDetails="";
				if(isset($investorDetails->Karvy_tax_code) )
				{
		   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($purchaseData->investor_id);
		   			}
		   		}

				$investorBankDetails = $this->api_model->getInvestorBankDetails($purchaseData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($purchaseData->fund_id);
				$resultFolio=getLatestFolioNumber($purchaseData->AMC_CODE,$purchaseData->investor_id);
				
				$folioNumber="";
				if($resultFolio)
				{
            		$folioNumber=$resultFolio;
        		}
				log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : cronAdditionalPurchase, Message : get purchased data for investor id '.$purchaseData->investor_id.' with folio '.$folioNumber.' *****');
				// $folioNumber="599322779404";
				echo "folio".$folioNumber."<br>";
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($purchaseData->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$this->config->load('config_karvy');
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["purchaseData"]=$purchaseData;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					

					if($fundDetails->api_type_id == 1 && $purchaseData->investment_plan_type != 'STP')
					{
						// $getKarvyXML = $this->createAdditionalPurchaseKarvyXML($data);
					}
					else if($fundDetails->api_type_id == 1 && $purchaseData->investment_plan_type == 'STP')
					{
						$this->createAdditionalPurchaseSTPKarvyXML($data);
					}
					else if($fundDetails->api_type_id == 2 && $purchaseData->investment_plan_type == 'STP')
					{
						$this->createAdditionalPurchaseSTPCamsTxt($data);
					}
					elseif($fundDetails->api_type_id == 2)
					{
						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$data["payoutMecCode"]=$payoutMecCode;
						// $getCAMSTxt = $this->createAdditionalPurchaseCamsTxt($data);
					}
				}
				
			}

			if(count($this->camsFiles))
			{

				//B0005000120180313130641.txt
				$camsFiles = $this->camsFiles;
				$num_records = "";
				$count_cams = count($camsFiles);

				if (count($camsFiles)<=9) {
					$num_records = "000".$count_cams;
				}
				if (count($camsFiles)<=99 && $num_records=="") {
					$num_records = "00".$count_cams;
				}		
				if (count($camsFiles)<=999 && $num_records=="") {
					$num_records = "0".$count_cams;
				}	
				if (count($camsFiles)<=9999 && $num_records=="") {
					$num_records = $count_cams;
				}

				$fileName = "B000".$num_records."0001".date("YmdHis").".txt";
				echo $fileName;
				$myfile =fopen("assets/uploads/CAMS/".$fileName, "w");
				foreach ($camsFiles as $key=>$camsFile) {
					
					if($key!=($count_cams-1))
						fwrite($myfile,$camsFile. "\r\n");
					else
						fwrite($myfile,$camsFile);
					
				}
				fclose($myfile);
				$output =camsCurlCommandBulk($fileName);
				 //$data = $this->xmltoarray($output);

				 log_message('info', '*****  Controller : ApiAdditionalPurchaseCronBulk, Function : createAdditionalPurchaseKarvyXML, Message : successfully hit '.$output.' *****');
			}	
		}
		
	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : createFirstPurchaseKarvyXML
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : Create karvy api xml file for after first purchase (one time investment)
-----------------------------------------------------------------------------------------------------
*/

	function createAdditionalPurchaseKarvyXML($data)
	{
		$purchased_units_id = $data['purchaseData']->purchased_units_id;
		$AMC_code = $data['fundDetails']->AMC_code;
		log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : create Karvy XML for purchased_units_id '.$purchased_units_id.'  *****');
		// $string = $this->load->view('amit_theme/purchase_cron/karvy_additional_purchase_xml_view', $data);
		$string = $this->load->view('amit_theme/purchase_cron/karvy_additional_purchase_xml_view', $data, true);

		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_additionalPurchase_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			echo "run1";
			 $filePath = "assets/uploads/Karvy/".date("dMY")."_additionalPurchase_".$purchased_units_id.".xml";
			echo '<br>'.$filePath; 
			 $this->db->where('purchased_units_id',$purchased_units_id)
					->update('purchased_units',['feed_path' => $filePath]);
			log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : successfully created feed  '.$filePath.' *****');
			//$output = execKarvyJavaUrl($AMC_code, $filePath, '1'.$purchased_units_id, 'p');
			echo $filePath.'<br> hit successfully ';
			log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : hit successfully  '.$filePath.' *****');
			log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : Karvy Response  '.$output.' *****');
			//$this->api_model->update_request_status($purchased_units_id);  
		}
	}

/*
-----------------------------------------------------------------------------------------------------
|   USE : createFirstPurchaseKarvyXML
|   DATE : 21/05/2018
|   AUTHOER : AMIT MEENA
|   COMMENT : Create karvy api xml file for after first purchase (STP investment)
-----------------------------------------------------------------------------------------------------
*/

	function createAdditionalPurchaseSTPKarvyXML($data)
	{
		$purchased_units_id = $data['purchaseData']->purchased_units_id;
		$AMC_code = $data['fundDetails']->AMC_code;
		$data['stp_fund'] = $this->getStpFundDetail($purchased_units_id);
		// $string = $this->load->view('amit_theme/purchase_cron/karvy_additional_purchase_stp_xml_view', $data ,true);
		$string = $this->load->view('amit_theme/purchase_cron/karvyCron/karvy_additional_purchase_stp_xml_view_new_file', $data ,true);
		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_STP_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			$filePath = "assets/uploads/Karvy/".date("dMY")."_STP_".$purchased_units_id.".xml";
			echo '<br>'.$filePath; 
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			// $output = execKarvyJavaUrl($AMC_code, $filePath, '1'.$purchased_units_id, 'p');
			hitKarvyFeed($string,$purchased_units_id);
			echo $filePath.'<br> hit successfully ';
			$this->api_model->update_request_status($purchased_units_id);  
		}
	}

	function createAdditionalPurchaseSTPCamsTxt($data)
	{
		$purchased_units_id = $data['purchaseData']->purchased_units_id;
		$AMC_code = $data['fundDetails']->AMC_code;
		$stp_data = $this->db->query("SELECT DATE_FORMAT(stp_frequency.`created_at`,'%m/%d/%Y') as stp_date, funds.scheme_code, is_all FROM stp_frequency JOIN funds ON stp_frequency.fill_fund_id = funds.fund_id WHERE `current_queue_purchased_units_id` = $purchased_units_id");
		if($stp_data->num_rows() > 0)
		{
			$data['stp_data'] = $stp_data->row();
			$string = $this->load->view('amit_theme/purchase_cron/cams_add_purchase_stp_txt', $data, true);
			$fileName = getFileName($AMC_code, $purchased_units_id);
			$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
			$fileName = $fileName.".txt";
			$result=fwrite($myfile, $string);
			fclose($myfile);
			echo $fileName;
			
		  	if($result)
			{
				$save_path = "assets/uploads/CAMS/".$fileName;
				$save_path_arr = explode('&$', $string);
				$this->camsFiles[] = $save_path_arr[0];
				$this->camsFiles[] = $save_path_arr[1];
				 $this->db->where('purchased_units_id',$purchased_units_id)
						->update('purchased_units',['feed_path' => $save_path]);
				  $output = camsCurlCommand($fileName);
				$data = $this->xmltoarray($output);
				  $success = $data[5]['value'];
				   log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : successfully created feed  '.$save_path.' *****');
				   $this->api_model->update_request_status($purchased_units_id); 
				  //log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : successfully hit '.$success.' *****');
			} 
		}
	}


/*
-----------------------------------------------------------------------------------------------------
|   USE : createAdditionalPurchaseCamsTxt
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to create cams txt file and hit to cams server
-----------------------------------------------------------------------------------------------------
*/

	function createAdditionalPurchaseCamsTxt($data)
	{
		$purchased_units_id = $data['purchaseData']->purchased_units_id;
		$AMC_code = $data['fundDetails']->AMC_code;
		log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : create Karvy XML for purchased_units_id '.$purchased_units_id.'  *****');
		$string = $this->load->view('amit_theme/purchase_cron/cams_add_purchase_txt', $data, true);
		$fileName = getFileName($AMC_code, $purchased_units_id);
		$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
		$fileName = $fileName.".txt";
		$result=fwrite($myfile, $string);
		fclose($myfile);
		echo $fileName;
		
	  	if($result)
		{
			$save_path = "assets/uploads/CAMS/".$fileName;
			$this->camsFiles[] = $string;
			 $this->db->where('purchased_units_id',$purchased_units_id)
					->update('purchased_units',['feed_path' => $save_path]);
			   //$output = camsCurlCommand($fileName);
			   $data = $this->xmltoarray($output);
			   $success = $data[5]['value'];
			   log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : successfully created feed  '.$save_path.' *****');
			   $this->api_model->update_request_status($purchased_units_id); 
			  //log_message('info', '*****  Controller : ApiAdditionalPurchaseCron, Function : createAdditionalPurchaseKarvyXML, Message : successfully hit '.$success.' *****');
		}  
		
	}
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : xmltoarray
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this is mail function of the class its used to create xml or txt file and hit on server
-----------------------------------------------------------------------------------------------------
*/	

	function xmltoarray($data)
	{
		$parser = xml_parser_create('');
		xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8");
		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
		xml_parse_into_struct($parser, trim($data), $xml_values);
		xml_parser_free($parser);
		$returnArray = array();
		return $xml_values;
	}

	function manualAdditionalPurchaseKarvyXML($purchased_units_id,$AMC_code,$filePath)
	{
		$output = execKarvyJavaUrl($AMC_code, $filePath, '1'.$purchased_units_id, 'S');
	}

	public function getStpFundDetail($purchased_units_id)
	{
		$res = $this->db->query("SELECT funds.scheme_code,funds.plan_code,DATE_FORMAT(stp_frequency.created_at,'%Y-%m-%d') as reg_date,stp_frequency.fill_purchased_units_id,is_all FROM `stp_frequency` JOIN funds ON funds.fund_id = stp_frequency.fill_fund_id WHERE stp_frequency.current_queue_purchased_units_id = $purchased_units_id");
		if($res->num_rows() > 0){
			return $res->row();
		}
		else
		{
			return false;
		}
	}
}
