<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class ApiAdditionalPurchaseSIPCron extends CI_Controller
{
	function __construct()
	{
		 parent::__construct();
		 $this->load->config('config_cams');
 		$this->load->config('config_karvy');
		$this->load->model('purchase_cron/api_model');
		 $this->load->helper('cams_helper');
		 $this->load->helper('karvy_helper');
		$this->load->helper('common_helper');
	}

	// Create a xml file for additional purchase (monthly sip)
	function cronAdditionalPurchaseSIP()
	{
		$additionalPurchasedSIPList = $this->api_model->getAdditionalPurchasedSIPList();
		//print_r($getFirstPurchasedList);die;
		if(isset($additionalPurchasedSIPList) && !empty($additionalPurchasedSIPList))
		{
			$activityMsg="Successfully get todays additional purchase list(monthly sip)";
			log_message("info","*****".$activityMsg."*****");
			addActivityLog($activityMsg);

			foreach($additionalPurchasedSIPList as $row)
			{
				//print_r($row);die;
				$purchaseDataSIP=$row;
				$investorDetails = $this->api_model->getInvestorDetails($purchaseDataSIP->investor_id);
				$nriArr=array(10,21,11);
				$overseasDetails="";
	   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
	   			{
	   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($purchaseDataSIP->investor_id);
	   			}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($purchaseDataSIP->investor_id);
				$SIPMontlyDetails = $this->api_model->getMontlyInvestmentDetails($purchaseDataSIP->purchased_units_id);
				$fundDetails = $this->api_model->getFundDetails($purchaseDataSIP->fund_id);
				//print_r($fundDetails);die;
				$resultFolio=getLatestFolioNumberOld($purchaseDataSIP->fund_id,$purchaseDataSIP->investor_id);

				$folioNumber="";
		        if($resultFolio){
		            $folioNumber=$resultFolio;
		        }
		      
				$firstPurchaseSIP = $this->api_model->getFirstPurchaseSIPDetails($purchaseDataSIP->investor_id, $purchaseDataSIP->fund_id);
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($purchaseDataSIP->investor_id);
				//print_r($firstPurchaseSIP);die;
				if(isset($fundDetails) && !empty($fundDetails))
				{
					if($fundDetails->api_type_id == 1){
						//Karvy
						$activityMsg="Creating Karvy XML for additional purchase (monthly sip)scheme code - ".$fundDetails->scheme_code." and fund Id = ".$purchaseDataSIP->fund_id." and investor_id = ".$purchaseDataSIP->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);

			
						$getKarvyXML = $this->createAdditionalPurchaseSIPKarvyXML($investorDetails,$overseasDetails, $fundDetails, $purchaseDataSIP, $investorBankDetails,$nomineeDetails,$folioNumber,$firstPurchaseSIP);
					}elseif($fundDetails->api_type_id == 2){
						//CAMS
						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$activityMsg="Creating CAMS Feed file for additional purchase (monthly sip)scheme code - ".$fundDetails->scheme_code." and fund Id = ".$purchaseDataSIP->fund_id." and investor_id = ".$purchaseDataSIP->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						$getCAMSTxt = $this->createAdditionalPurchaseSIPCamsTxt($investorDetails,$overseasDetails, $fundDetails, $purchaseDataSIP, $investorBankDetails,$nomineeDetails,$folioNumber,$firstPurchaseSIP, $payoutMecCode,$SIPMontlyDetails);
					

					}elseif($fundDetails->api_type_id == 3){
						//franklin
						$activityMsg="Creating Karvy XML for additional purchase (monthly sip)scheme code - ".$fundDetails->scheme_code." and fund Id = ".$purchaseDataSIP->fund_id." and investor_id = ".$purchaseDataSIP->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						//$getFranklinFile = $this->createFranklinFile($investorDetails,$overseasDetails, $fundDetails, $purchaseDataSIP, $investorBankDetails,$folioNumber,$firstPurchaseSIP);
					}
				}
				else
				{
					$activityMsg="Fund bank details not available for fund Id = ".$purchaseDataSIP->fund_id.")";
					log_message("info","*****".$activityMsg."*****");
					addActivityLog($activityMsg);
				}
			}
		}
		else
		{
			$activityMsg="No Details found in todays additional purchase list(monthly sip) investment";
			log_message("info","*****".$activityMsg."*****");
			addActivityLog($activityMsg);
		}
	}

	// Create karvy api xml file for after first purchase (one time investment)
	function createAdditionalPurchaseSIPKarvyXML($investorDetails,$overseasDetails, $fundDetails, $purchaseDataSIP,$investorBankDetails,$nomineeDetails,$folioNumber,$firstPurchaseSIP)
	{
		if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
		{
			$this->config->load('config_cams');
			$data["investorDetails"]=$investorDetails;
			$data["overseasDetails"]=$overseasDetails;
			$data["fundDetails"]=$fundDetails;
			$data["purchaseDataSIP"]=$purchaseDataSIP;
			$data["investorBankDetails"]=$investorBankDetails;
			$data["nomineeDetails"]=$nomineeDetails;
			$data["folioNumber"]=$folioNumber;
			$data["firstPurchaseSIP"]=$firstPurchaseSIP;
			
			$string = $this->load->view('karvy_additional_purchase_sip_xml_view', $data, true);
			$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_additionalPurchaseSIP_".$purchaseDataSIP->purchased_units_id.".xml", "w");
			$result=fwrite($myfile, $string);
			fclose($myfile);
			if($result)
			{
				$activityMsg="Successfully created additional purchase xml(monthly sip) xml for - purchased_unit_id =".$firstPurchaseSIP->purchased_units_id." scheme code - ".$fundDetails->scheme_code." and fund Id = ".$firstPurchaseSIP->fund_id." and investor_id = ".$firstPurchaseSIP->investor_id;
				log_message("info","*****".$activityMsg."*****");

				$filePath = "assets/uploads/Karvy/".date("dMY")."_additionalPurchaseSIP_".$purchaseDataSIP->purchased_units_id.".xml";
				echo $filePath;
		/* 		
			 $output = execKarvyJavaUrl($fundDetails->AMC_code, $filePath, '1'.$purchaseDataSIP->purchased_units_id , 'p');
				
				if($output == true)
				{
				echo '<br>'.$purchaseDataSIP->purchased_units_id.' hit sucessfully <br>';
					$this->api_model->update_request_status($purchaseDataSIP->purchased_units_id);
					$activityMsg="successfully send request using karvy api for purchased_unit_id =".$purchaseDataSIP->purchased_units_id." file size is=".$result;
					log_message("info","*****".$activityMsg."*****");
				}
				else
				{
					$activityMsg="Some Error Are there in karvy responce for purchased_unit_id =".$purchaseDataSIP->purchased_units_id." file size is=".$result;
					log_message("info","*****".$activityMsg."*****");
						sendErrorEmail($activityMsg);
				}
				 */
				
			}
			else
			{
				$activityMsg="Failed to creating additional purchase(monthly sip) xml for purchased_unit_id =".$purchaseDataSIP->purchased_units_id." file size is=".$result;
				log_message("info","*****".$activityMsg."*****");
			}
			addActivityLog($activityMsg);
		}
	}

	function createAdditionalPurchaseSIPCamsTxt($investorDetails,$overseasDetails, $fundDetails, $purchaseDataSIP, $investorBankDetails,$nomineeDetails,$folioNumber,$firstPurchaseSIP, $payoutMecCode,$SIPMontlyDetails)
	{
	  	//print_r($SIPMontlyDetails);die;
	  	if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails))
	  	{
			$data["investorDetails"]=$investorDetails;
			$data["overseasDetails"]=$overseasDetails;
			$data["fundDetails"]=$fundDetails;
			$data["purchaseDataSIP"]=$purchaseDataSIP;
			$data["firstPurchaseSIP"]=$firstPurchaseSIP;
			$data["investorBankDetails"]=$investorBankDetails;
			$data["nomineeDetails"]=$nomineeDetails;
			$data["folioNumber"]=$folioNumber;
/*============================================================================================================================
	Change By TechnoUniverse
	Auther : Amit Meena 
	Date : 19/08/2016
	Comment : we take $SIPMontlyDetails->monthly_investment_id as SIP Registration Number but if we have id That is less then 31 
	then we send special id in cams txt file
=============================================================================================================================*/
			if($SIPMontlyDetails->monthly_investment_id < 31 )
			{
				if($SIPMontlyDetails->monthly_investment_id == 5)
				{
					$SIPMontlyDetails->monthly_investment_id = 4;
				}
				else
				{
					$SIPMontlyDetails->monthly_investment_id  = $SIPMontlyDetails->monthly_investment_id - 15;
				}
				
			}
			$data['SIPMontlyDetails']=$SIPMontlyDetails;
			$data["payoutMecCode"]=$payoutMecCode;

			//print_r($data);die;
			$string = $this->load->view('cams_add_SIP_purchase_txt', $data, true);
			$fileName = getFileName($fundDetails->AMC_code, $purchaseDataSIP->purchased_units_id);
			$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
			$result=fwrite($myfile, $string);
			fclose($myfile);
			if($result)
			{
			  	$activityMsg="Successfully created add purchase(SIP investment) txt for purchased_unit_id =".$purchaseDataSIP->purchased_units_id." file size is=".$result;
			  	log_message("info","*****".$activityMsg."*****");
			  	//camsCurlCommand($dirpath, $this->config->item('url'));
			  	/*=================================================================================================
			  		Change by technouniverse
					Date : 22/08/2016
					Comment : Using 'camsCurlCommand' Function We Can hit The Cams API
			  	==================================================================================================*/
				$fileName = $fileName.".txt";
				echo $fileName;
			    //$output = camsCurlCommand($fileName);
				/*=================================================================================================
					Techno Comment : update_request_status function is used to set request status 0 to 1 when data 
					                 Proccessed
				==================================================================================================*/
/*

----------------------------------------------------------------------------------------------------------------
|	CHNAGE BY TECHNOUNIVERSE
|	AUTHOR : AMIT MEENA
|	DATE : 08/09/2016
|	COMMENT : FIRST WE CONVERSE CAMS RESPONCE TO ARRAY USING "xmltoarray" FUNCTION THEN WE GET THE SUCCESS  VALUE 
		      
-----------------------------------------------------------------------------------------------------------------
*/				

				$data = $this->xmltoarray($output);
				$success = $data[5]['value'];
				if($success == 1)
				{
					$this->api_model->update_request_status($purchaseDataSIP->purchased_units_id);
				}
				
			}
			else
			{
			  	$activityMsg="Failed to creating add purchase(SIP investment) txt for purchased_unit_id =".$purchaseDataSIP->purchased_units_id." file size is=".$result;
			  	log_message("info","*****".$activityMsg."*****");
			}
			addActivityLog($activityMsg);
	  	}
	}

/*
-----------------------------------------------------------------------------------------------------------
|	TECHNOINIVERSE CHNAGE 
|	AUTHOER : AMIT MEENA
|	DATE : 08/09/2016
|	COMMENT : THIS FUNCTION IS USE TO CONVERST CAMS RESPONCE TO ARRAY
------------------------------------------------------------------------------------------------------------
*/
	
	function xmltoarray($data)
	{
		$parser = xml_parser_create('');
		xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8");
		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
		xml_parse_into_struct($parser, trim($data), $xml_values);
		xml_parser_free($parser);
		$returnArray = array();
		return $xml_values;
	}
}
