<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : ApiFirstPurchaseCron
|   MODEL USE : api_model
|   DATE : 07/10/2016
|   AUTHOER : amit meena
|   COMMENT : This controller is used to get First purchase data from data base then create a xml or txt file 
|   for karvy and cams then call api to hit the cams or karvy server
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class ApiFirstPurchaseCron extends CI_Controller
{

/*
-----------------------------------------------------------------------------------------------------
|   USE : __construct
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS USED TO LOAD HELPER AND MODEL TO ALL FUNCTION
-----------------------------------------------------------------------------------------------------
*/
	function __construct()
	{
		parent::__construct();
		$this->load->config('config_cams');
		$this->load->config('config_karvy');
		$this->load->model('purchase_cron/api_model' ,'api_model');
		$this->load->helper('cams_helper');
		$this->load->helper('karvy_helper');
	}

/*
-----------------------------------------------------------------------------------------------------
|   USE : cronFirstPurchase
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this is main function of the class its used to create xml or txt file and hit on server
-----------------------------------------------------------------------------------------------------
*/

	function cronFirstPurchase()
	{

		$getFirstPurchasedList = $this->api_model->getFirstPurchasedList();
		

		log_message('info', '*****  Controller : ApiFirstPurchaseCron, Function : cronFirstPurchase, Message : get first purchased list *****');
		if(isset($getFirstPurchasedList) && !empty($getFirstPurchasedList))
		{
			foreach($getFirstPurchasedList as $firstPurchase)
			{
				$investorDetails = $this->api_model->getInvestorDetails($firstPurchase->investor_id);
				//echo "<pre>";
				//print_r($investorDetails);
				
				$overseasDetails="";
				$nriArr=array(10,21,11);
				if(isset($investorDetails->Karvy_tax_code) )
				{
					if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($firstPurchase->investor_id);
		   			}
				}
   			
				$investorBankDetails = $this->api_model->getInvestorBankDetails($firstPurchase->investor_id);
				$fundDetails = $this->api_model->getFundDetails($firstPurchase->fund_id);
				echo $this->db->last_query();
				/* echo "<pre>";
				print_r($fundDetails); */
			
				$resultFolio=getLatestFolioNumber($firstPurchase->amc_code,$firstPurchase->investor_id);
				$folioNumber="";
		        if($resultFolio)
		        {
		            $folioNumber=$resultFolio;
		        }
				echo  $folioNumber."<br />";
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($firstPurchase->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["firstPurchase"]=$firstPurchase;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					log_message('info', '*****  Controller : ApiFirstPurchaseCron, Function : cronFirstPurchase, Message : get data for investor '.$firstPurchase->investor_id.' *****');
					if($fundDetails->api_type_id == 1)
					{
						$getKarvyXML = $this->createFirstPurchaseKarvyXML($data);
					}
					elseif($fundDetails->api_type_id == 2)
					{
						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$data['payoutMecCode'] = $payoutMecCode;
						$this->createFirstPurchaseCamsTxt($data);
					}
					elseif($fundDetails->api_type_id == 3)
					{
						
					}

				}

			}

			if(count($this->camsFiles))
			{

				//B0005000120180313130641.txt
				$camsFiles = $this->camsFiles;
				$num_records = "";
				$count_cams = count($camsFiles);

				if (count($camsFiles)<=9) {
					$num_records = "000".$count_cams;
				}
				if (count($camsFiles)<=99 && $num_records=="") {
					$num_records = "00".$count_cams;
				}		
				if (count($camsFiles)<=999 && $num_records=="") {
					$num_records = "0".$count_cams;
				}	
				if (count($camsFiles)<=9999 && $num_records=="") {
					$num_records = $count_cams;
				}

				$fileName = "B000".$num_records."0001".date("YmdHis").".txt";
				$myfile =fopen("assets/uploads/CAMS/".$fileName, "w");
				foreach ($camsFiles as $key=>$camsFile) {
					
					if($key!=($count_cams-1))
						fwrite($myfile,$camsFile. "\r\n");
					else
						fwrite($myfile,$camsFile);
					
				}
				fclose($myfile);
				 $output =camsCurlCommandBulk($fileName);
				 //$data = $this->xmltoarray($output);

				log_message('info', '*****  Controller : ApiAdditionalPurchaseCronBulk, Function : createAdditionalPurchaseKarvyXML, Message : successfully hit '.$output.' *****');
			}
		}

	}

/*
-----------------------------------------------------------------------------------------------------
|   USE : createFirstPurchaseKarvyXML
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to create Karvy xml file and hit to karvy server 
-----------------------------------------------------------------------------------------------------
*/
	function createFirstPurchaseKarvyXML($data)
	{
		$purchased_units_id = $data['firstPurchase']->purchased_units_id;
		$this->config->load('config_karvy');
		log_message('info', '*****  Controller : ApiFirstPurchaseCron, Function : cronFirstPurchase, Message : create Karvy XML for purchased_units_id '.$purchased_units_id.' *****');
		$string = $this->load->view('amit_theme/purchase_cron/karvy_first_purchase_xml_view', $data, true);
		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_firstPurchase_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		
		if($result)
		{
			$filePath = "assets/uploads/Karvy/".date("dMY")."_firstPurchase_".$purchased_units_id.".xml";
			echo $filePath.' <br>';
			log_message('info', '*****  Controller : ApiFirstPurchaseCron, Function : cronFirstPurchase, Message : successfull created feed '.$filePath.' *****');
            		$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			//$output = execKarvyJavaUrl($data['fundDetails']->AMC_code, $filePath, '1'.$purchased_units_id , 'p');
			echo '<br> hit successfully';
			log_message('info', '*****  Controller : ApiFirstPurchaseCron, Function : cronFirstPurchase, Message : hit successfully *****');
			//$this->api_model->update_request_status($purchased_units_id); 
		}
	}

/*
-----------------------------------------------------------------------------------------------------
|   USE : cronFirstPurchase
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to create cams txt file and hit to cams server
-----------------------------------------------------------------------------------------------------
*/

	function createFirstPurchaseCamsTxt($data)
	{	
		$amc_code = $data['fundDetails']->AMC_code;
		$purchased_units_id = $data['firstPurchase']->purchased_units_id;
		log_message('info', '*****  Controller : ApiFirstPurchaseCron, Function : craeting cams text file for purchased_units_id '.$purchased_units_id.' *****');
		$string = $this->load->view('amit_theme/purchase_cron/cams_first_purchase_txt', $data, true);
		$fileName = getFileName($amc_code, $purchased_units_id);
		$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
		    $fileName = $fileName.".txt";
		    echo $fileName;
			log_message('info', '*****  Controller : ApiFirstPurchaseCron, Function : successfully crated '.$fileName.' *****');
			$this->camsFiles[] = $string;
			 $save_path = "assets/uploads/CAMS/".$fileName;
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $save_path]);
		   	$output = camsCurlCommand($fileName);
		 	//$data = $this->xmltoarray($output);
		 	$success = $data[5]['value'];
			log_message('info', '*****  Controller : ApiFirstPurchaseCron, Function : hit successfully '.$success.' *****');
			$this->api_model->update_request_status($purchased_units_id); 
		}
	}


/*
-----------------------------------------------------------------------------------------------------
|   USE : cronFirstPurchase
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this is mail function of the class its used to create xml or txt file and hit on server
-----------------------------------------------------------------------------------------------------
*/	
	function xmltoarray($data)
	{
		$parser = xml_parser_create('');
		xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8");
		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
		xml_parse_into_struct($parser, trim($data), $xml_values);
		xml_parser_free($parser);
		$returnArray = array();
		return $xml_values;
	}
}
