<?php

class ApiKFinCron extends CI_Controller{
	
	function __construct()
	{
		parent::__construct();
		$this->load->config('config_cams');
		$this->load->config('config_karvy');
		$this->load->model('purchase_cron/api_model');
		$this->load->helper('cams_helper');
		$this->load->helper('karvy_helper');
		$this->load->helper('common_helper');
	}

	public function index()
	{
		$this->cronFirstPurchaseSIP();
		$this->cronFirstPurchase();
		$this->cronAdditionalPurchase();
	}

	public function cronFirstPurchaseSIP()
	{
		$firstPurchasedSIPList = $this->api_model->getFirstPurchasedSIPList();
		if(isset($firstPurchasedSIPList) && !empty($firstPurchasedSIPList))
		{
			foreach($firstPurchasedSIPList as $firstPurchaseSIP)
			{
				$investorDetails = $this->api_model->getInvestorDetails($firstPurchaseSIP->investor_id);
				$nriArr=array(10,21,11);
				$overseasDetails="";
				if(isset($investorDetails->Karvy_tax_code) )
				{
					if(in_array($investorDetails->Karvy_tax_code, $nriArr))
					{
						$overseasDetails = $this->api_model->getInvestorOverseasDetails($firstPurchaseSIP->investor_id);
					}
				}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($firstPurchaseSIP->investor_id);
				$SIPMontlyDetails = $this->api_model->getMontlyInvestmentDetails($firstPurchaseSIP->purchased_units_id);
				$fundDetails = $this->api_model->getFundDetails($firstPurchaseSIP->fund_id);
				$resultFolio=getLatestFolioNumber($firstPurchaseSIP->AMC_CODE,$firstPurchaseSIP->investor_id);
				$folioNumber="";
		        if($resultFolio)
		        {
		            $folioNumber=$resultFolio;
		        }
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($firstPurchaseSIP->investor_id);	
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["firstPurchase"]=$firstPurchaseSIP;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					$data["SIPMontlyDetails"]=$SIPMontlyDetails;
					if($fundDetails->api_type_id == 1)
					{
						$getKarvyXML = $this->createFirstPurchaseSIPKarvyXML($data);
					}
				}
			}
		}
	}

	public function cronFirstPurchase()
	{
		$getFirstPurchasedList = $this->api_model->getFirstPurchasedList();
		// print_r($getFirstPurchasedList);
		// exit;
		if(isset($getFirstPurchasedList) && !empty($getFirstPurchasedList))
		{
			foreach($getFirstPurchasedList as $firstPurchase)
			{
				$investorDetails = $this->api_model->getInvestorDetails($firstPurchase->investor_id);
				$overseasDetails="";
				$nriArr=array(10,21,11);
				if(isset($investorDetails->Karvy_tax_code) )
				{
					if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($firstPurchase->investor_id);
		   			}
				}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($firstPurchase->investor_id);
				$fundDetails = $this->api_model->getFundDetails($firstPurchase->fund_id);
				$resultFolio=getLatestFolioNumber($firstPurchase->amc_code,$firstPurchase->investor_id);
				$folioNumber="";
		        if($resultFolio)
		        {
		            $folioNumber=$resultFolio;
		        }

				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($firstPurchase->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					echo "run";
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["firstPurchase"]=$firstPurchase;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					if($fundDetails->api_type_id == 1)
					{
						// echo "<pre>";
						// print_r($data);
						$getKarvyXML = $this->createFirstPurchaseKarvyXML($data);
					}
				}
			}
		}
	}

	public function cronAdditionalPurchase()
	{
		$additionalPurchasedList = $this->api_model->getAdditionalPurchasedList();
		if(isset($additionalPurchasedList) && !empty($additionalPurchasedList))
		{
			foreach($additionalPurchasedList as $row)
			{
				$purchaseData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($purchaseData->investor_id);
				$nriArr=array(10,21,11);
				$overseasDetails="";
				if(isset($investorDetails->Karvy_tax_code) )
				{
		   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($purchaseData->investor_id);
		   			}
		   		}

				$investorBankDetails = $this->api_model->getInvestorBankDetails($purchaseData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($purchaseData->fund_id);
				$resultFolio=getLatestFolioNumber($purchaseData->AMC_CODE,$purchaseData->investor_id);
				
				$folioNumber="";
				if($resultFolio)
				{
            		$folioNumber=$resultFolio;
        		}

				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($purchaseData->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$this->config->load('config_karvy');
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["firstPurchase"]=$purchaseData;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					if($fundDetails->api_type_id == 1 && $purchaseData->investment_plan_type != 'STP')
					{
						$getKarvyXML = $this->createAdditionalPurchaseKarvyXML($data);
					}
				}
			}
		}
	}

	public function cronRedemption()
	{
		$withdrawType=1;
		$this->load->model('purchase_cron/api_model' ,'api_model');
		$withdrawList = $this->api_model->getRedemptionListNew($withdrawType);
		// echo "<pre>";
		// print_r($withdrawList);
		// exit;
		if(isset($withdrawList) && !empty($withdrawList))
		{
			foreach($withdrawList as $row)
			{
				$withdrawData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($withdrawData->investor_id);
				$overseasDetails="";
				$nriArr=array(10,21,11);
	   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
	   			{
	   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($withdrawData->investor_id);
	   			}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($withdrawData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($withdrawData->fund_id);
				$folioNumber=getLatestFolioNumber($fundDetails->AMC_code,$withdrawData->investor_id);
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($withdrawData->investor_id);
				if(isset($fundDetails) && !empty($fundDetails))
				{
					if($fundDetails->api_type_id == 1){
						$getKarvyXML = $this->createWithdrwalByAmountKarvyXML($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber);
					}
				}
			}
		}
	}

	public function createWithdrwalByAmountKarvyXML($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber)
	{
		$this->config->load('config_karvy');
		$data["investorDetails"]=$investorDetails;
		$data["overseasDetails"]=$overseasDetails;
		$data["fundDetails"]=$fundDetails;
		$data["withdrawData"]=$withdrawData;
		$data["investorBankDetails"]=$investorBankDetails;
		$data["nomineeDetails"]=$nomineeDetails;
		$data["folioNumber"]=$folioNumber;
		$string = $this->load->view('purchase_cron/karvy_first_redemption_169_xml_view', $data,true);
		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_withdrawByAmount_".$withdrawData->sold_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			$filePath = "assets/uploads/Karvy/".date("dMY")."_withdrawByAmount_".$withdrawData->sold_units_id.".xml"; 
			hitKarvyFeed169($string,$withdrawData->sold_units_id);
			$this->api_model->update_request_status_for_sold_units($withdrawData->sold_units_id,$filePath);
		}

	}

	public function createFirstPurchaseSIPKarvyXML($data)
	{
		// echo "<pre>";
		// print_r($data);
		// exit;
		$purchased_units_id = $data['firstPurchase']->purchased_units_id;
		$string=$this->load->view('purchase_cron/karvy_first_purchase_sip_169_xml_view', $data,true);
		$myfile=fopen("assets/uploads/Karvy/".date("dMY")."_firstPurchaseSIP_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			hitKarvyFeed169($string,$purchased_units_id);
			echo $filePath = "assets/uploads/Karvy/".date("dMY")."_firstPurchaseSIP_".$purchased_units_id.".xml";
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			$this->api_model->update_request_status($purchased_units_id);   
		}
	}

	public function createFirstPurchaseKarvyXML($data)
	{
		$purchased_units_id = $data['firstPurchase']->purchased_units_id;
		$this->config->load('config_karvy');
		$string = $this->load->view('purchase_cron/karvy_first_purchase_169_xml_view', $data,true);
		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_firstPurchase_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			hitKarvyFeed169($string,$purchased_units_id);
			echo $filePath = "assets/uploads/Karvy/".date("dMY")."_firstPurchase_".$purchased_units_id.".xml";
            $this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			$this->api_model->update_request_status($purchased_units_id); 
		}
	}

	public function createAdditionalPurchaseKarvyXML($data)
	{
		$purchased_units_id = $data['firstPurchase']->purchased_units_id;
		$AMC_code = $data['fundDetails']->AMC_code;
		$string = $this->load->view('purchase_cron/karvy_add_purchase_169_xml_view', $data, true);
		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_additionalPurchase_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			hitKarvyFeed169($string,$purchased_units_id);
			echo $filePath = "assets/uploads/Karvy/".date("dMY")."_additionalPurchase_".$purchased_units_id.".xml";
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			$this->api_model->update_request_status($purchased_units_id);  
		}
	}

	public function cronSTP()
	{
		$additionalPurchasedList = $this->api_model->getAdditionalPurchasedList();
		// echo "<pre>";
		// print_r($additionalPurchasedList );
		// exit;
		if(isset($additionalPurchasedList) && !empty($additionalPurchasedList))
		{
			foreach($additionalPurchasedList as $row)
			{
				$purchaseData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($purchaseData->investor_id);
				$nriArr=array(10,21,11);
				$overseasDetails="";
				if(isset($investorDetails->Karvy_tax_code) )
				{
		   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($purchaseData->investor_id);
		   			}
		   		}

				$investorBankDetails = $this->api_model->getInvestorBankDetails($purchaseData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($purchaseData->fund_id);
				$resultFolio=getLatestFolioNumber($purchaseData->AMC_CODE,$purchaseData->investor_id);
				
				$folioNumber="";
				if($resultFolio)
				{
            		$folioNumber=$resultFolio;
        		}

				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($purchaseData->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$this->config->load('config_karvy');
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["purchaseData"]=$purchaseData;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					if($fundDetails->api_type_id == 1 && $purchaseData->investment_plan_type == 'STP')
					{
						$getKarvyXML = $this->createSTPPurchaseKarvyXML($data);
					}
				}
			}
		}
	}

	public function createSTPPurchaseKarvyXML($data)
	{
		$purchased_units_id = $data['purchaseData']->purchased_units_id;
		$AMC_code = $data['fundDetails']->AMC_code;
		$data['stp_fund'] = $this->getStpFundDetail($purchased_units_id);
		$string = $this->load->view('purchase_cron/karvy_stp_purchase_169_xml_view', $data,true);
		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_STP_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			$filePath = "assets/uploads/Karvy/".date("dMY")."_STP_".$purchased_units_id.".xml";
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			hitKarvyFeed169($string,$purchased_units_id);
			$this->api_model->update_request_status($purchased_units_id);  
		}
	}

	public function getStpFundDetail($purchased_units_id)
	{
		$res = $this->db->query("SELECT funds.scheme_code,funds.plan_code,DATE_FORMAT(stp_frequency.created_at,'%Y-%m-%d') as reg_date,stp_frequency.fill_purchased_units_id,is_all FROM `stp_frequency` JOIN funds ON funds.fund_id = stp_frequency.fill_fund_id WHERE stp_frequency.current_queue_purchased_units_id = $purchased_units_id");
		if($res->num_rows() > 0){
			return $res->row();
		}
		else
		{
			return false;
		}
	}
}