<?php

class apiKarvyCron extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		$this->load->config('config_cams');
		$this->load->config('config_karvy');
		$this->load->model('purchase_cron/api_model');
		$this->load->helper('cams_helper');
		$this->load->helper('karvy_helper');
		$this->load->helper('common_helper');
	}

	public function runFile()
	{
		$this->cronFirstPurchaseSIP();
		$this->cronFirstPurchase();
		$this->cronAdditionalPurchase();
	}

	public function cronFirstPurchaseSIP()
	{
		$firstPurchasedSIPList = $this->api_model->getFirstPurchasedSIPList();
		if(isset($firstPurchasedSIPList) && !empty($firstPurchasedSIPList))
		{
			foreach($firstPurchasedSIPList as $firstPurchaseSIP)
			{
				$investorDetails = $this->api_model->getInvestorDetails($firstPurchaseSIP->investor_id);
				$nriArr=array(10,21,11);
				$overseasDetails="";
				if(isset($investorDetails->Karvy_tax_code) )
				{
					if(in_array($investorDetails->Karvy_tax_code, $nriArr))
					{
						$overseasDetails = $this->api_model->getInvestorOverseasDetails($firstPurchaseSIP->investor_id);
					}
				}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($firstPurchaseSIP->investor_id);
				$SIPMontlyDetails = $this->api_model->getMontlyInvestmentDetails($firstPurchaseSIP->purchased_units_id);
				$fundDetails = $this->api_model->getFundDetails($firstPurchaseSIP->fund_id);
				$resultFolio=getLatestFolioNumber($firstPurchaseSIP->AMC_CODE,$firstPurchaseSIP->investor_id);
				$folioNumber="";
		        if($resultFolio)
		        {
		            $folioNumber=$resultFolio;
		        }
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($firstPurchaseSIP->investor_id);	
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["firstPurchaseSIP"]=$firstPurchaseSIP;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					$data["SIPMontlyDetails"]=$SIPMontlyDetails;
					if($fundDetails->api_type_id == 1)
					{
						$getKarvyXML = $this->createFirstPurchaseSIPKarvyXML($data);
					}
				}
			}
		}
	}

	public function cronFirstPurchase()
	{
		$getFirstPurchasedList = $this->api_model->getFirstPurchasedList();
		if(isset($getFirstPurchasedList) && !empty($getFirstPurchasedList))
		{
			foreach($getFirstPurchasedList as $firstPurchase)
			{
				$investorDetails = $this->api_model->getInvestorDetails($firstPurchase->investor_id);
				$overseasDetails="";
				$nriArr=array(10,21,11);
				if(isset($investorDetails->Karvy_tax_code) )
				{
					if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($firstPurchase->investor_id);
		   			}
				}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($firstPurchase->investor_id);
				$fundDetails = $this->api_model->getFundDetails($firstPurchase->fund_id);
				$resultFolio=getLatestFolioNumber($firstPurchase->amc_code,$firstPurchase->investor_id);
				$folioNumber="";
		        if($resultFolio)
		        {
		            $folioNumber=$resultFolio;
		        }
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($firstPurchase->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["firstPurchase"]=$firstPurchase;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					if($fundDetails->api_type_id == 1)
					{
						$getKarvyXML = $this->createFirstPurchaseKarvyXML($data);
					}
				}
			}
		}
	}

	public function cronAdditionalPurchase()
	{
		$additionalPurchasedList = $this->api_model->getAdditionalPurchasedList();
		if(isset($additionalPurchasedList) && !empty($additionalPurchasedList))
		{
			foreach($additionalPurchasedList as $row)
			{
				$purchaseData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($purchaseData->investor_id);
				$nriArr=array(10,21,11);
				$overseasDetails="";
				if(isset($investorDetails->Karvy_tax_code) )
				{
		   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($purchaseData->investor_id);
		   			}
		   		}

				$investorBankDetails = $this->api_model->getInvestorBankDetails($purchaseData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($purchaseData->fund_id);
				$resultFolio=getLatestFolioNumber($purchaseData->AMC_CODE,$purchaseData->investor_id);
				
				$folioNumber="";
				if($resultFolio)
				{
            		$folioNumber=$resultFolio;
        		}

				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($purchaseData->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$this->config->load('config_karvy');
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["purchaseData"]=$purchaseData;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					if($fundDetails->api_type_id == 1 && $purchaseData->investment_plan_type != 'STP')
					{
						$getKarvyXML = $this->createAdditionalPurchaseKarvyXML($data);
					}
				}
			}
		}
	}

	public function createFirstPurchaseSIPKarvyXML($data)
	{
		$purchased_units_id = $data['firstPurchaseSIP']->purchased_units_id;
		$string=$this->load->view('amit_theme/purchase_cron/karvyCron/karvy_first_purchase_sip_xml_view_new_file', $data,true);
		$myfile=fopen("assets/uploads/Karvy/".date("dMY")."_firstPurchaseSIP_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			hitKarvyFeed($string,$purchased_units_id);
			echo $filePath = "assets/uploads/Karvy/".date("dMY")."_firstPurchaseSIP_".$purchased_units_id.".xml";
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			$this->api_model->update_request_status($purchased_units_id);   
		}
	}

	public function createFirstPurchaseKarvyXML($data)
	{
		$purchased_units_id = $data['firstPurchase']->purchased_units_id;
		$this->config->load('config_karvy');
		$string = $this->load->view('amit_theme/purchase_cron/karvyCron/karvy_first_purchase_xml_view_new_file', $data, true);
		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_firstPurchase_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			hitKarvyFeed($string,$purchased_units_id);
			echo $filePath = "assets/uploads/Karvy/".date("dMY")."_firstPurchase_".$purchased_units_id.".xml";
            $this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			$this->api_model->update_request_status($purchased_units_id); 
		}
	}

	public function createAdditionalPurchaseKarvyXML($data)
	{
		$purchased_units_id = $data['purchaseData']->purchased_units_id;
		$AMC_code = $data['fundDetails']->AMC_code;
		$string = $this->load->view('amit_theme/purchase_cron/karvyCron/karvy_additional_purchase_xml_view_new_file', $data, true);
		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_additionalPurchase_".$purchased_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			hitKarvyFeed($string,$purchased_units_id);
			echo $filePath = "assets/uploads/Karvy/".date("dMY")."_additionalPurchase_".$purchased_units_id.".xml";
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $filePath]);
			$this->api_model->update_request_status($purchased_units_id);  
		}
	}

	// public function hitKarvy($data,$purchased_units_id)
	// {
	// 	$curl = curl_init();
	// 	curl_setopt_array($curl, array(
	// 	  CURLOPT_URL => "https://cpupload.kfintech.com/STP/STPService.svc/TransactionUpload130",
	// 	  CURLOPT_RETURNTRANSFER => true,
	// 	  CURLOPT_ENCODING => "",
	// 	  CURLOPT_MAXREDIRS => 10,
	// 	  CURLOPT_TIMEOUT => 30,
	// 	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	// 	  CURLOPT_CUSTOMREQUEST => "POST",
	// 	  CURLOPT_POSTFIELDS => "$data",
	// 	  CURLOPT_HTTPHEADER => array(
	// 	    "Postman-Token: e85a3954-d25d-44bf-b4c3-96ea4bdc9905",
	// 	    "cache-control: no-cache"
	// 	  ),
	// 	));

	// 	$response = curl_exec($curl);
	// 	$err = curl_error($curl);
	// 	curl_close($curl);
	// 	if ($err) {
	// 	  echo "cURL Error #:" . $err;
	// 	} else {
		  
	// 		$xml_file = simplexml_load_string($response);
	// 		echo "<pre>";
	// 		$arr = $this->xmltoarray($xml_file);
	// 	  $str = "Karvy=RES=".$purchased_units_id."=p=".$arr['DtInformation']['RETURN_MSG']."=".$xml_file;
	// 	  $this->db->insert('activity_log',['description'=>$str]);
	// 	}
	// }

	// public function xmltoarray($xmlfile)
	// {
	// 	$ob= simplexml_load_string($xmlfile);
	// 	$json  = json_encode($ob);
	// 	return $configData = json_decode($json, true);
	// }
}