<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : ApiRedemptionCron
|   MODEL USE : api_model
|   DATE : 08/10/2016
|   AUTHOER : amit meena
|   COMMENT : this controller is used to create a Redemption feed of karvy and cams and hit it to there server
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class ApiRedemptionCron extends CI_Controller
{
/*
-----------------------------------------------------------------------------------------------------
|   USE : __construct
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS USED TO LOAD HELPER AND MODEL TO ALL FUNCTION
-----------------------------------------------------------------------------------------------------
*/
	function __construct()
	{
		 parent::__construct();
		 $this->load->config('config_cams');
 		 $this->load->config('config_karvy');
		 $this->load->model('purchase_cron/api_model' ,'api_model');
		 $this->load->helper('cams');
		 $this->load->helper('karvy');
	}
	
	
	public function index()
	{
		exit;
		$this->cronRedemptionByAmount();
		$this->cronRedemptionByUnit();
		$this->cronRedemptionByAll();
	}

/*
-----------------------------------------------------------------------------------------------------
|   USE : cronRedemptionByAmount
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is create a feed in terms of amount
-----------------------------------------------------------------------------------------------------
*/
	function cronRedemptionByAmount()
	{
		$withdrawType=1;
		$withdrawList = $this->api_model->getRedemptionList($withdrawType);
		if(isset($withdrawList) && !empty($withdrawList))
		{
			foreach($withdrawList as $row)
			{
				$activityMsg="Successfully get todays withdrwal by amount list(one time investment)";
				log_message("info","*****".$activityMsg."*****");
				addActivityLog($activityMsg);
				//print_r($row);die;
				$withdrawData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($withdrawData->investor_id);
				$overseasDetails="";
				$nriArr=array(10,21,11);
	   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
	   			{
	   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($withdrawData->investor_id);
	   			}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($withdrawData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($withdrawData->fund_id);
				echo $fundDetails->AMC_code ." ".$withdrawData->investor_id;
				$folioNumber=getLatestFolioNumber($fundDetails->AMC_code,$withdrawData->investor_id);
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($withdrawData->investor_id);
				if(isset($fundDetails) && !empty($fundDetails))
				{
					if($fundDetails->api_type_id == 1){
						$activityMsg="Creating Karvy withdrawal XML for scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						//Karvy
						$getKarvyXML = $this->createWithdrwalByAmountKarvyXML($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber);
					}elseif($fundDetails->api_type_id == 2){
						//CAMS
						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$activityMsg="Creating cams withdrawal XML for scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						$getCAMSTxt = $this->createWithdrwalByAmountCamsTxt($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber,$payoutMecCode);
					}elseif($fundDetails->api_type_id == 3){
						//franklin
						$activityMsg="Creating franklin withdrawal XML for scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						//$getFranklinFile = $this->createFranklinFile($investorDetails,$overseasDetails, $fundDetails, $firstPurchase, $investorBankDetails,$folioNumber);
					}
				}
				else
				{
					$activityMsg="Fund bank details not available for fund Id = ".$withdrawData->fund_id.")";
					log_message("info","*****".$activityMsg."*****");
					addActivityLog($activityMsg);
				}
			}
		}
		else
		{
			$activityMsg="No Details found in todays withdrawal amount funds";
			echo $activityMsg;
			log_message("info","*****".$activityMsg."*****");
			addActivityLog($activityMsg);
		}
	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : createFirstPurchaseKarvyXML
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : Create karvy api xml file for after first purchase (one time investment)
-----------------------------------------------------------------------------------------------------
*/
	// Create karvy api xml file for withdraw(one time investment)
	function createWithdrwalByAmountKarvyXML($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber)
	{
		$this->config->load('config_karvy');
		$data["investorDetails"]=$investorDetails;
		$data["overseasDetails"]=$overseasDetails;
		$data["fundDetails"]=$fundDetails;
		$data["withdrawData"]=$withdrawData;
		$data["investorBankDetails"]=$investorBankDetails;
		$data["nomineeDetails"]=$nomineeDetails;
		$data["folioNumber"]=$folioNumber;
	
		//print_r($data);die;
		// $string = $this->load->view('amit_theme/withdraw_cron/karvy_withdraw_amount_xml_view.php', $data, true);
		$string = $this->load->view('amit_theme/withdraw_cron/karvy/karvy_withdraw_amount_xml_view_new_file.php', $data,true);

		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_withdrawByAmount_".$withdrawData->sold_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			$activityMsg="Successfully created withdraw by amount (one time investment) xml for sold_unit_id =".$withdrawData->sold_units_id." scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
			//execKarvyJavaUrl($fundDetails->AMC_code, $dirpath);

			$filePath = "assets/uploads/Karvy/".date("dMY")."_withdrawByAmount_".$withdrawData->sold_units_id.".xml";
			echo '<br>'.$filePath; 
			
			// execKarvyJavaUrl($fundDetails->AMC_code, $filePath ,$withdrawData->sold_units_id,'r');
			// echo $string;
			hitKarvyFeed($string,$withdrawData->sold_units_id);
			$this->api_model->update_request_status_for_sold_units($withdrawData->sold_units_id,$filePath);
		}
		else
		{
			$activityMsg="Failed to  creating withdraw by amount(one time investment) xml sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
		}
		addActivityLog($activityMsg);

	}

/*
-----------------------------------------------------------------------------------------------------
|   USE : createWithdrwalByAmountCamsTxt
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to create cmps feed by amount
-----------------------------------------------------------------------------------------------------
*/
	function createWithdrwalByAmountCamsTxt($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber, $payoutMecCode)
	{
		$data["investorDetails"]=$investorDetails;
		$data["overseasDetails"]=$overseasDetails;
		$data["fundDetails"]=$fundDetails;
		$data["withdrawData"]=$withdrawData;
		$data["investorBankDetails"]=$investorBankDetails;
		$data["nomineeDetails"]=$nomineeDetails;
		$data["folioNumber"]=$folioNumber;
		$data["payoutMecCode"]=$payoutMecCode;

		$string = $this->load->view('amit_theme/withdraw_cron/cams_red_amount_txt.php', $data, true);
		$fileName = getFileName($fundDetails->AMC_code, $withdrawData->sold_units_id);

		$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			$activityMsg="Successfully created withdraw by amount (one time investment) txt for sold_unit_id =".$withdrawData->sold_units_id." scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
			$fileName = $fileName.".txt";
			echo $fileName;
			$output = camsCurlCommand($fileName);
			
			$this->api_model->update_request_status_for_sold_units($withdrawData->sold_units_id,"assets/uploads/CAMS/".$fileName);
		}
		else
		{
			$activityMsg="Failed to  creating withdraw by amount(one time investment) xml sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
		}
		addActivityLog($activityMsg);
	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : createWithdrwalByAmountCamsTxt
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to create cmps feed by Units
-----------------------------------------------------------------------------------------------------
*/
	function cronRedemptionByUnit()
	{
	
		$withdrawType=2;
		$withdrawList = $this->api_model->getRedemptionList($withdrawType);

		if(isset($withdrawList) && !empty($withdrawList))
		{
			foreach($withdrawList as $row)
			{
				$activityMsg="Successfully get todays withdrwal by unit list(one time investment)";
				log_message("info","*****".$activityMsg."*****");
				addActivityLog($activityMsg);
				//print_r($row);die;
				$withdrawData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($withdrawData->investor_id);

				$overseasDetails="";
				$nriArr=array(10,21,11);
	   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
	   			{
	   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($withdrawData->investor_id);
	   			}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($withdrawData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($withdrawData->fund_id);
				$folioNumber=getLatestFolioNumber($fundDetails->AMC_code,$withdrawData->investor_id);
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($withdrawData->investor_id);
				if(isset($fundDetails) && !empty($fundDetails))
				{
					if($fundDetails->api_type_id == 1){
						$activityMsg="Creating Karvy withdrawal by unit XML for (one time investment) scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						//Karvy
						$getKarvyXML = $this->createWithdrwalByUnitKarvyXML($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber);
					}elseif($fundDetails->api_type_id == 2){
						//CAMS
						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$activityMsg="Creating cams withdrawal XML for scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						$getCAMSTxt = $this->createWithdrwalByUnitCamsTxt($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber,$payoutMecCode);
					}elseif($fundDetails->api_type_id == 3){
						//franklin
						//$getFranklinFile = $this->createFranklinFile($investorDetails,$overseasDetails, $fundDetails, $firstPurchase, $investorBankDetails,$folioNumber);
					}
				}
				else
				{
					$activityMsg="Fund bank details not available for fund Id = ".$withdrawData->fund_id.")";
					log_message("info","*****".$activityMsg."*****");
					addActivityLog($activityMsg);
				}
			}
		}
		else
		{
			$activityMsg="No Details found in todays withdrawal unit(one time investment) funds'";
			echo $activityMsg;
			log_message("info","*****".$activityMsg."*****");
			addActivityLog($activityMsg);
		}
	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : createWithdrwalByAmountCamsTxt
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : Create karvy api xml file for withdraw
-----------------------------------------------------------------------------------------------------
*/

	function createWithdrwalByUnitKarvyXML($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber)
	{
		$this->config->load('config_karvy');
		$data["investorDetails"]=$investorDetails;
		$data["overseasDetails"]=$overseasDetails;
		$data["fundDetails"]=$fundDetails;
		$data["withdrawData"]=$withdrawData;
		$data["investorBankDetails"]=$investorBankDetails;
		$data["nomineeDetails"]=$nomineeDetails;
		$data["folioNumber"]=$folioNumber;
		//print_r($data);die;
		// $string = $this->load->view('amit_theme/withdraw_cron/karvy_withdraw_unit_xml_view.php', $data, true);
		$string = $this->load->view('amit_theme/withdraw_cron/karvy/karvy_withdraw_unit_xml_view_new_file.php', $data, true);

		$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_withdrawByUnit_".$withdrawData->sold_units_id.".xml", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			$activityMsg="Successfully created withdraw by unit (one time investment) xml for sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
			$filePath = "assets/uploads/Karvy/".date("dMY")."_withdrawByUnit_".$withdrawData->sold_units_id.".xml";
			echo '<br>'.$filePath; 
			// execKarvyJavaUrl($fundDetails->AMC_code, $filePath ,$withdrawData->sold_units_id,'r');
			hitKarvyFeed($string,$withdrawData->sold_units_id);
			$this->api_model->update_request_status_for_sold_units($withdrawData->sold_units_id,$filePath);
		}
		else
		{
			$activityMsg="Failed to  creating withdraw by units(one time investment) xml sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
		}
		addActivityLog($activityMsg);
	}

/*
-----------------------------------------------------------------------------------------------------
|   USE : createWithdrwalByAmountCamsTxt
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : Create karvy api xml file for withdraw
-----------------------------------------------------------------------------------------------------
*/
	function createWithdrwalByUnitCamsTxt($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber,$payoutMecCode)
	{
		$data["investorDetails"]=$investorDetails;
		$data["overseasDetails"]=$overseasDetails;
		$data["fundDetails"]=$fundDetails;
		$data["withdrawData"]=$withdrawData;
		$data["investorBankDetails"]=$investorBankDetails;
		$data["nomineeDetails"]=$nomineeDetails;
		$data["folioNumber"]=$folioNumber;
		$data["payoutMecCode"]=$payoutMecCode;
		$string = $this->load->view('amit_theme/withdraw_cron/cams_red_units_txt.php', $data, true);
		$fileName = getFileName($fundDetails->AMC_code, $withdrawData->sold_units_id);
		$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			$activityMsg="Successfully created withdraw by units (one time investment) txt for sold_unit_id =".$withdrawData->sold_units_id." scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
			$output = camsCurlCommand($fileName.".txt");
			$this->api_model->update_request_status_for_sold_units($withdrawData->sold_units_id,"assets/uploads/CAMS/".$fileName.".txt");
		}
		else
		{
			$activityMsg="Failed to  creating withdraw by units (one time investment) xml sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
		}
		addActivityLog($activityMsg);
	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : xmltoarray
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this is mail function of the class its used to create xml or txt file and hit on server
-----------------------------------------------------------------------------------------------------
*/	
	function cronRedemptionByAll()
	{
		$withdrawType=3;
		$withdrawList = $this->api_model->getRedemptionList($withdrawType);
		if(isset($withdrawList) && !empty($withdrawList))
		{
			foreach($withdrawList as $row)
			{
				$activityMsg="Successfully get todays withdrwal by all list(one time investment)";
				log_message("info","*****".$activityMsg."*****");
				addActivityLog($activityMsg);
				//print_r($row);die;
				$withdrawData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($withdrawData->investor_id);
				$overseasDetails="";
				//print_r($investorDetails);die;
				$nriArr=array(10,21,11);
	   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
	   			{
	   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($withdrawData->investor_id);
	   			}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($withdrawData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($withdrawData->fund_id);
				//print_r($fundDetails);die;
				$folioNumber=getLatestFolioNumber($fundDetails->AMC_code,$withdrawData->investor_id);
				$folioNumber = $row->folio_number;
				// echo $folioNumber;
				// exit;
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($withdrawData->investor_id);
				if(isset($fundDetails) && !empty($fundDetails))
				{
					if($fundDetails->api_type_id == 1){
						$activityMsg="Creating Karvy withdrawal by all XML for (one time investment) scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						//Karvy
						$getKarvyXML = $this->createWithdrwalByAllKarvyXML($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber);
					}elseif($fundDetails->api_type_id == 2){
						//CAMS
						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$activityMsg="Creating cams withdrawal XML for scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id.")";
						log_message("info","*****".$activityMsg."*****");
						addActivityLog($activityMsg);
						$getCAMSTxt = $this->createWithdrwalByAllCamsTxt($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber,$payoutMecCode);
					}elseif($fundDetails->api_type_id == 3){
						//franklin
						//$getFranklinFile = $this->createFranklinFile($investorDetails,$overseasDetails, $fundDetails, $firstPurchase, $investorBankDetails,$folioNumber);
					}
				}
				else
				{
					$activityMsg="Fund bank details not available for fund Id = ".$withdrawData->fund_id.")";
					log_message("info","*****".$activityMsg."*****");
					addActivityLog($activityMsg);
				}
			}
		}
		else
		{
			$activityMsg="No Details found in todays withdrawal all(one time investment) funds'";
			echo $activityMsg;
			log_message("info","*****".$activityMsg."*****");
			addActivityLog($activityMsg);
		}
	}

/*
-----------------------------------------------------------------------------------------------------
|   USE : xmltoarray
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this is mail function of the class its used to create xml or txt file and hit on server
-----------------------------------------------------------------------------------------------------
*/	
	// Create karvy api xml file for withdraw
	function createWithdrwalByAllKarvyXML($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber)
	{
		$this->config->load('config_karvy');
		$data["investorDetails"]=$investorDetails;
		$data["overseasDetails"]=$overseasDetails;
		$data["fundDetails"]=$fundDetails;
		$data["withdrawData"]=$withdrawData;
		$data["investorBankDetails"]=$investorBankDetails;
		$data["nomineeDetails"]=$nomineeDetails;
		$data["folioNumber"]=$folioNumber;
		// echo "<pre>";
		// print_r($data);die;
		// $string = $this->load->view('amit_theme/withdraw_cron/karvy_withdraw_all_xml_view.php', $data, true);
		$string = $this->load->view('amit_theme/withdraw_cron/karvy/karvy_withdraw_all_xml_view_new_file.php', $data, true);

		/*$dirpath='assets/uploads/Karvy/'.date("dMY").'/withdraw_all_xml';
		if(makedirs($dirpath))
		{*/
			$myfile =fopen("assets/uploads/Karvy/".date("dMY")."_withdrawByAll_".$withdrawData->sold_units_id.".xml", "w");
			$result=fwrite($myfile, $string);
			fclose($myfile);
			if($result)
			{
				$activityMsg="Successfully created withdraw by all (one time investment) xml for sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
				log_message("info","*****".$activityMsg."*****");
				$filePath = "assets/uploads/Karvy/".date("dMY")."_withdrawByAll_".$withdrawData->sold_units_id.".xml";
				echo '<br>'.$filePath; 
				// $res = execKarvyJavaUrl($fundDetails->AMC_code, $filePath ,$withdrawData->sold_units_id,'r');
				hitKarvyFeed($string,$withdrawData->sold_units_id);
				echo "<br />".$res;
				$this->api_model->update_request_status_for_sold_units($withdrawData->sold_units_id,$filePath);
			}
			else
			{
				$activityMsg="Failed to  creating withdraw by all (one time investment) xml sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
				log_message("info","*****".$activityMsg."*****");
			}
			addActivityLog($activityMsg);
		/*}
		else
		{
			$activityMsg="Failed to create folders for withdraw by all(one time investment) xml sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
			addActivityLog($activityMsg);
		}*/
	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : xmltoarray
|   DATE : 07/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this is mail function of the class its used to create xml or txt file and hit on server
-----------------------------------------------------------------------------------------------------
*/	
	function createWithdrwalByAllCamsTxt($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber,$payoutMecCode)
	{
		$data["investorDetails"]=$investorDetails;
		$data["overseasDetails"]=$overseasDetails;
		$data["fundDetails"]=$fundDetails;
		$data["withdrawData"]=$withdrawData;
		$data["investorBankDetails"]=$investorBankDetails;
		$data["nomineeDetails"]=$nomineeDetails;
		$data["folioNumber"]=$folioNumber;
		$data["payoutMecCode"]=$payoutMecCode;
		
		$string = $this->load->view('amit_theme/withdraw_cron/cams_red_all_txt.php', $data, true);
		$fileName = getFileName($fundDetails->AMC_code, $withdrawData->sold_units_id);
		
		$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		
		if($result)
		{
			$activityMsg="Successfully created withdraw by all (one time investment) txt for sold_unit_id =".$withdrawData->sold_units_id." scheme code - ".$fundDetails->scheme_code." and fund Id = ".$withdrawData->fund_id." and investor_id = ".$withdrawData->investor_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
			//$output = camsCurlCommand($fileName);
			echo $fileName = $fileName.".txt";
			$output = camsCurlCommand($fileName);
			echo $withdrawData->sold_units_id;
			$this->api_model->update_request_status_for_sold_units($withdrawData->sold_units_id,"assets/uploads/CAMS/".$fileName.".txt");
		}
		else
		{
			$activityMsg="Failed to  creating withdraw by all (one time investment) xml sold_unit_id =".$withdrawData->sold_units_id." file size is=".$result;
			log_message("info","*****".$activityMsg."*****");
		}
		addActivityLog($activityMsg);
	}
}
