<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Cron extends CI_Controller {

    function __construct()
    {
      // Call the Model constructor
       parent::__construct();
       $this->load->model('cron/cron_model','cron_model');
    }

    public function index()
    {
		$this->monthlyStatementEmail();
    }

    function monthlyStatementEmail()
    {
        // fetch all the investors who are active in users table and verified in investor table
        $investorsListResult=$this->cron_model->getInvestorsList();
        if($investorsListResult)
        {
            $rowStr = "";
            // for each investor from investor list
            foreach ($investorsListResult as $row)
            {
                // investor_id
                $investor_id = $row->investor_id;
                // investor name
                $investor_name = strtoupper($this->encrypt->decode($row->first_name));
                $data["investor_name"]=$this->encrypt->decode($row->first_name);
                // investor email
                $investorEmail = $row->email;
                $data["investor_email"]= $row->email;
                $totalPresentAmount=0;
                $totalInvestedAmount=0;
                $fundTypeId=0;

                $data["equityInvestmentAmount"] = $this->getEquityInvestmentData($investor_id);
                $data["equityPresentAmount"] = $this->getEquityWithdrawalData($investor_id);
                $data["debtInvestmentAmount"] = $this->getDebtInvestmentData($investor_id);
                $data["debtPresentAmount"] = $this->getDebtWithdrawalData($investor_id);
                $data["taxSavingInvestmentAmount"]=$this->getTaxSavingInvestmentData($investor_id);
                $data["taxSavingPresentAmount"]=$this->getTaxSavingWithdrawalData($investor_id);
                $data["MIPInvestmentAmount"]=$this->getMIPInvestmentData($investor_id);
                $data["MIPPresentAmount"]=$this->getMIPWithdrawalData($investor_id);
                $data["totalInvestmentAmount"]=$data["equityInvestmentAmount"]+$data["debtInvestmentAmount"]+$data["taxSavingInvestmentAmount"]+$data["MIPInvestmentAmount"];
                $data["totalPresentAmount"]=$data["equityPresentAmount"]+$data["debtPresentAmount"]+$data["taxSavingPresentAmount"]+$data["MIPPresentAmount"];

				echo "<pre>";
				print_r($data);
				
                // send monthly account statement mail to investor
                //$sendMonthlyEmail=$this->sendMonthlyStatementMail($data,$investorEmail);
                /*if($sendMonthlyEmail)
                 {
                    echo "SUCCESSFULLY sent monthly statement mail to " . $data["investor_name"];
                    log_message('info', 'Controller : cron, Function : monthlyStatementEmail, Message : SUCCESSFULLY sent monthly statement mail to ' . $data["investor_name"] . ' *****');
                 }
                 else
                 {
                    echo "FAILED to send monthly statement mail to " . $investor_name;
                    log_message('info', 'Controller : cron, Function : monthlyStatementEmail, Message : FAILED to send monthly statement mail to ' . $data["investor_name"] .' *****');
                 }*/
            }
        }
        else
        {
            // no active and verified investor present in DB!!
            echo "No verified investors present !!!";
            log_message('info', '***** Controller : cron, Function : monthlyStatementEmail, Message : No verified investors present *****');
        }

        // add cron info
        $cronUrl=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
        $cronDate=date("Y-m-d h:i:s");
        $cronDesc="Cron succefully executed and sent monthly statement";

        $data=array("cron_url"=>$cronUrl,"cron_date"=>$cronDate,"cron_desc"=>$cronDesc);
        addCronLog($data);
    }

    function checkWithdrawalFundsAmount($fundTypeId,$investor_id)
    {
        // get all equity purchase funds which is approved by bank and request_status=1
        $resultPurchaseFunds=$this->cron_model->getPurchaseFundsReadytoPurchase($fundTypeId,$investor_id);
        // get all equity sold funds which is approved by bank and request_status=1
        $resultSoldFunds=$this->cron_model->getSoldFunds($fundTypeId,$investor_id);

        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            foreach ($resultPurchaseFunds as $purchaseRow)
            {
                $fundName=$purchaseRow->fund_name;

                $purchaseFundId=$purchaseRow->fund_id;
                $purchaseUnits=$purchaseRow->unit_count;
                $nav=$purchaseRow->nav;
                $investedAmount=$purchaseRow->invested_amount;

                /** check count fund is sold or not **/
                $soldCount=0;

                if(isset($resultSoldFunds) && !empty($resultSoldFunds))
                {
                    foreach ($resultSoldFunds as $soldRow)
                    {
                        $soldFundId=$soldRow->fund_id;
                        $soldUnits=$soldRow->unit_count;
                        if($soldFundId==$purchaseFundId)
                        {
                            $balanceUnit=round(($purchaseUnits-$soldUnits),2);
                            $soldCount++;
                        }
                    }
                }

                if($soldCount==0)
                {
                    $balanceUnit=$purchaseUnits;
                }

                /** calculate withdraw amount **/
                $withdrawalAmount=round(($balanceUnit*$nav),2);

                /** add withdraw funds list **/
                $data["withdrawFunds"][]=array("fund_id"=>$purchaseFundId,
                                                "fund_name"=>$fundName,
                                                "withdrawal_amount"=>$withdrawalAmount,
                                                "nav"=>$nav,
                                                "unit_counts"=>$balanceUnit);
            }
            return $data["withdrawFunds"];
        }
    }

    // get Equity Invested Funds Amount
    function getEquityInvestmentData($investor_id)
    {
        $fundTypeId=1; //1 for equity
        $equityInvestmentAmount=0;
        // get Equity Invested Funds Amount
        $equityInvestmentFundsResult=$this->checkInvestmentFundsAmount($fundTypeId,$investor_id);
        if(isset($equityInvestmentFundsResult) && !empty($equityInvestmentFundsResult))
        {
            $equityInvestmentAmount = $equityInvestmentFundsResult->total_amount;
            if($equityInvestmentAmount==0)
            {
                return 0;
            }
            else
            {
                return $equityInvestmentAmount;
            }
        }
        else
        {
            return 0.00;
        }
    }

    // get Equity Withdrawn Funds Amount
    function getEquityWithdrawalData($investor_id)
    {
        $fundTypeId=1; //1 for equity
        $equityPresentAmount=0;
        $equityWithdrawalFundsResult=$this->checkWithdrawalFundsAmount($fundTypeId,$investor_id);
        if(isset($equityWithdrawalFundsResult) && !empty($equityWithdrawalFundsResult))
        {
           foreach ($equityWithdrawalFundsResult as $equityWithdrawalFundsRow)
            {
                $amount=$equityWithdrawalFundsRow["withdrawal_amount"];
                $equityPresentAmount=round(($equityPresentAmount+$amount),2);
            }

            return $equityPresentAmount;
        }
        else
        {
            return 0.00;
        }
    }

    // get Debt Invested Funds Amount
    function getDebtInvestmentData($investor_id)
    {
        $fundTypeId=2; //2 for debt
        $debtInvestedAmount=0;
        $debtInvestmentFundsResult=$this->checkInvestmentFundsAmount($fundTypeId,$investor_id);
        if(isset($debtInvestmentFundsResult) && !empty($debtInvestmentFundsResult))
        {
            $debtInvestmentAmount = $debtInvestmentFundsResult->total_amount;
            if($debtInvestmentAmount==0)
            {
                return 0;
            }
            else
            {
                return $debtInvestmentAmount;
            }
        }
        else
        {
            return 0;
        }
    }

    // get Debt Withdrawn Funds Amount
    function getDebtWithdrawalData($investor_id)
    {
        $fundTypeId=2; //2 for debt
        $debtPresentAmount=0;
        $debtWithdrawalFundsResult=$this->checkWithdrawalFundsAmount($fundTypeId,$investor_id);
        if(isset($debtWithdrawalFundsResult) && !empty($debtWithdrawalFundsResult))
        {
           foreach ($debtWithdrawalFundsResult as $debtWithdrawalFundsRow)
            {
                $amount=$debtWithdrawalFundsRow["withdrawal_amount"];
                $debtPresentAmount=round(($debtPresentAmount+$amount),2);
            }

            return $debtPresentAmount;
        }
        else
        {
            return 0;
        }
    }

    // get Tax Saving Invested Funds Amount
    function getTaxSavingInvestmentData($investor_id)
    {
        $fundTypeId=3; // 3 for tax saving
        $taxSavingInvestedAmount=0;
        $taxSavingInvestmentFundsResult=$this->checkInvestmentFundsAmount($fundTypeId,$investor_id);
        if(isset($taxSavingInvestmentFundsResult) && !empty($taxSavingInvestmentFundsResult))
        {
            $taxSavingInvestmentAmount = $taxSavingInvestmentFundsResult->total_amount;
            if($taxSavingInvestmentAmount==0)
            {
                return 0;
            }
            else
            {
                return $taxSavingInvestmentAmount;
            }
        }
        else
        {
            return 0.00;
        }
    }

    // get Tax Saving Withdrawn Funds Amount
    function getTaxSavingWithdrawalData($investor_id)
    {
        $fundTypeId=3; // 3 for tax saving
        $taxSavingPresentAmount=0;
        $taxSavingWithdrawalFundsResult=$this->checkWithdrawalFundsAmount($fundTypeId,$investor_id);
        if(isset($taxSavingWithdrawalFundsResult) && !empty($taxSavingWithdrawalFundsResult))
        {
           foreach ($taxSavingWithdrawalFundsResult as $taxSavingWithdrawalFundsRow)
            {
                $amount=$taxSavingWithdrawalFundsRow["withdrawal_amount"];
                $taxSavingPresentAmount=round(($taxSavingPresentAmount+$amount),2);
            }

            return $taxSavingPresentAmount;
        }
        else
        {
            return 0.00;
        }
    }

    // get MIP Invested Funds Amount
    function getMIPInvestmentData($investor_id)
    {
        $fundTypeId=4; // 4 for MIP
        $MIPInvestedAmount=0;
        $mipInvestmentFundsResult=$this->checkInvestmentFundsAmount($fundTypeId,$investor_id);
        if(isset($mipInvestmentFundsResult) && !empty($mipInvestmentFundsResult))
        {
            $MIPInvestmentAmount = $mipInvestmentFundsResult->total_amount;
            if($MIPInvestmentAmount==0)
            {
                return 0;
            }
            else
            {
                return $MIPInvestmentAmount;
            }
        }
        else
        {
            return 0.00;
        }
    }

    // get MIP Withdrawn Funds Amount
    function getMIPWithdrawalData($investor_id)
    {
        $fundTypeId=4; // 4 for MIP
        $MIPPresentAmount=0;
        $MIPWithdrawalFundsResult=$this->checkWithdrawalFundsAmount($fundTypeId,$investor_id);
        if(isset($MIPWithdrawalFundsResult) && !empty($MIPWithdrawalFundsResult))
        {
           foreach ($MIPWithdrawalFundsResult as $MIPWithdrawalFundsRow)
            {
                $amount=$MIPWithdrawalFundsRow["withdrawal_amount"];
                $MIPPresentAmount=round(($MIPPresentAmount+$amount),2);
            }

            return $MIPPresentAmount;
        }
        else
        {
            return 0.00;
        }
    }

    function checkInvestmentFundsAmount($fundTypeId,$investor_id)
    {
        $resultInvestedAmount=$this->cron_model->getInvestedAmount($fundTypeId,$investor_id);
        return $resultInvestedAmount;
    }

    function sendMonthlyStatementMail($data,$investorEmail)
    {
	return true;
        $today = date('M d, Y', time());
        $data["today"]=$today;
        echo $html=$this->load->view('send_monthly_statement_mail_view', $data,true);
        $this->load->library("email");
        $this->email->set_newline("\r\n");
        $this->email->set_mailtype("html");
        $this->email->to($investorEmail);
       // $this->email->bcc("nikunj.vijayvargiya@gmail.com");
        $this->email->from("Investocafe Assistant<help@investocafe.com>", "Investocafe");
        $this->email->subject("Your Monthly Account Statement");
        $this->email->message($html);
        $result=$this->email->send();
        //echo $this->email->print_debugger();
        return $result;
    }

    /**  cron for goals achived sending greets email **/
    function  sendGreetsForGoalsAchivement()
    {
        log_message('info', '***** Controller : cron, Function : sendGreetsForGoalsAchivement, Message : cron for sending greets email for goals achieved  *****');
        $restulGoals=$this->cron_model->getAllInvestorGoalsList();
        $restulCurrentValue=$this->cron_model->getAllInvestorCurrentValueLsit();
        if(isset($restulGoals) && !empty($restulGoals))
        {
            foreach ($restulGoals as $row)
            {
                $goalAmount=$row->goal_amount;
                if(isset($restulCurrentValue) && !empty($restulCurrentValue))
                {
                    foreach ($restulCurrentValue as $rowCv)
                    {
                        if($row->investor_id==$rowCv->investor_id)
                        {
                            $currentValue=$rowCv->sum_nav;
                            $username=$this->encrypt->decode($rowCv->username);
                            $email=$rowCv->email;
                            if($goalAmount<=$currentValue)
                            {
                                $sent=$this->sendEmailForGoalsAchivement($username,$email);
                                if($sent)
                                {
                                    echo "Sent goals achieved greeting msg to =" .$row->investor_id."<br/>";
                                    log_message('info', '***** Controller : cron, Function : sendGreetsForGoalsAchivement, Message : Sent goals achieved greeting msg to =' .$row->investor_id.' *****');
                                }
                                else
                                {
                                    echo "Failed to send goals achieved greeting msg to investor id =" .$row->investor_id."<br/>";
                                    log_message('info', '***** Controller : cron, Function : sendGreetsForGoalsAchivement, Message : Failed to send goals achieved greeting msg to investor id =' .$row->investor_id.' *****');
                                }
                            }
                            else
                            {
                                echo "goals not achieved to =" .$row->investor_id."<br/>";
                                log_message('info', '***** Controller : cron, Function : sendGreetsForGoalsAchivement, Message : goals not achieved to =' .$row->investor_id.' *****');
                            }
                        }
                    }
                }
                else
                {
                    log_message('info', '***** Controller : cron, Function : sendGreetsForGoalsAchivement, Message : Result Current value list not found *****');
                    echo "Result Current value list not found <br>";
                }
            }
        }
        else
        {
            log_message('info', '***** Controller : cron, Function : sendGreetsForGoalsAchivement, Message : Result goals list not found *****');
            echo "Result goals list not found";
        }

        // add cron info
        $cronUrl=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
        $cronDate=date("Y-m-d h:i:s");
        $cronDesc="Cron succefully executed and sent goals achived greets email";

        $data=array("cron_url"=>$cronUrl,"cron_date"=>$cronDate,"cron_desc"=>$cronDesc);
        addCronLog($data);
    }

    function sendEmailForGoalsAchivement($username,$email)
    {
        $today = date('M d, Y', time());
        $data["username"]=$username;
        $data["today"]=$today;
        $html=$this->load->view('send_goals_achive_mail_view', $data,true);
        $this->load->library("email");
        $this->email->set_newline("\r\n");
        $this->email->set_mailtype("html");
        $this->email->to($email);
       // $this->email->bcc("nikunj.vijayvargiya@gmail.com");
        $this->email->from("Investocafe Assistant<help@investocafe.com>", "Investocafe");
        $this->email->subject("Your Goals Achived");
        $this->email->message($html);
        $result=$this->email->send();
        //echo $this->email->print_debugger();
        return $result;
    }

    function disclosuresCron()
    {
      $tomorrowDate = date("Y-m-d", strtotime("+ 1 day"));
      $tomorrowDateFormat = date("l, jS F Y", strtotime("+ 1 day"));
      $disclosuresExpiryList=$this->cron_model->getClosuresExpiryList($tomorrowDate);
      if($disclosuresExpiryList)
      {
        $sendDisclosuresExpiryEmail=$this->sendDisclosuresExpiryEmail($disclosuresExpiryList,$tomorrowDateFormat);
        if($sendDisclosuresExpiryEmail)
        {
          echo "SUCCESSFULLY sent disclosures list expiring on " . $tomorrowDateFormat;
          log_message('info', '***** Controller : cron, Function : disclosuresCron, Message : SUCCESSFULLY sent disclosures list expiring on ' . $tomorrowDateFormat . ' *****');
        }
        else
        {
          echo "FAILED to send disclosures list expiring on " . $tomorrowDateFormat;
          log_message('info', '***** Controller : cron, Function : disclosuresCron, Message : FAILED to send disclosures list expiring on ' . $tomorrowDateFormat . ' *****');
        }
      }
      else
      {
        echo "No disclosures are getting expired tomorrow !!!";
        log_message('info', '***** Controller : cron, Function : disclosuresCron, Message : No disclosures are getting expired tomorrow !!!  *****');
      }
    }

    function sendDisclosuresExpiryEmail($disclosuresExpiryList,$tomorrowDateFormat)
    {
      $today = date('M d, Y', time());
      $data["result"]=$disclosuresExpiryList;
      $data["formattedNextDay"]=$tomorrowDateFormat;
      $data["today"]=$today;
      $html=$this->load->view('send_disclosures_expiry_mail_view', $data,true);
      $this->load->library("email");
      $this->email->set_newline("\r\n");
      $this->email->set_mailtype("html");
      $this->email->to("admin@investocafe.com");
      $this->email->from("Investocafe Assistant<help@investocafe.com>", "Investocafe");
      $this->email->subject("AMC's getting expired on ".$tomorrowDateFormat);
      $this->email->message($html);
      $result=$this->email->send();
      //echo $this->email->print_debugger();
      return $result;
    }
}
