<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class FundImport extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
		 ini_set('memory_limit', '-1');
		 ini_set('max_execution_time', 800);
		 $this->load->library('excel');
		 $this->load->model('fundimport_model');
	}

	function axisFundCodes(){

		$excelFile = "assets/uploads/fundCodesSheets/Axis MF Scheme codes for all plans.xls";

    $objPHPExcel = PHPExcel_IOFactory::load($excelFile);
    $allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
    $arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet

		//print_r($allDataInSheet);die;
		$insertionData = array();
		$insertionData['api_type_id'] = 1;//For Karvy

   for($i=5;$i<=$arrayCount;$i++)
   {

		 //print_r($allDataInSheet[$i]);die;
		 $insertionData['fund_code'] = $allDataInSheet[$i]["A"];
		 $insertionData['scheme_code'] = $allDataInSheet[$i]["B"];
		 $insertionData['scheme_description'] = $allDataInSheet[$i]["C"];
		 $insertionData['plan_code'] = $allDataInSheet[$i]["D"];
		 $insertionData['plan_description'] = $allDataInSheet[$i]["E"];
		 $insertionData['option_code'] = $allDataInSheet[$i]["F"];
		 $insertionData['option_description'] = $allDataInSheet[$i]["G"];

		 if($allDataInSheet[$i]["H"] == 'EQUITY FUND' || $allDataInSheet[$i]["H"] == 'Equity'){
			 	$insertionData['fund_type_id'] = 1;
		 }elseif($allDataInSheet[$i]["H"] == 'DEBT FUND' || $allDataInSheet[$i]["H"] == 'DEBT'){
			 $insertionData['fund_type_id'] = 2;
		 }elseif($allDataInSheet[$i]["H"] == 'TAX SAVING'){
			 $insertionData['fund_type_id'] = 3;
		 }elseif($allDataInSheet[$i]["H"] == 'LIQUID FUND'){
			 $insertionData['fund_type_id'] = 4;
		 }


		 $originalDateNFOStartDate = changeDateFormat($allDataInSheet[$i]["I"]);
		 $newDateNFOStartDate = date("Y-m-d", strtotime($originalDateNFOStartDate));
		 $insertionData['NFO_start_date'] = $newDateNFOStartDate;

		 $originalDateNFOEndDate = changeDateFormat($allDataInSheet[$i]["J"]);
		 $newDateNFOEndDate = date("Y-m-d", strtotime($originalDateNFOEndDate));
		 $insertionData['NFO_end_date'] = $newDateNFOEndDate;


		 $originalDateAllotmentDate = changeDateFormat($allDataInSheet[$i]["K"]);
		 $newDateAllotmentDate = date("Y-m-d", strtotime($originalDateAllotmentDate));
		 $insertionData['allotment_date'] = $newDateAllotmentDate;


		 $insertionData['maturity_date'] = $allDataInSheet[$i]["L"];
		 $insertionData['min_purchase_amt'] = $allDataInSheet[$i]["M"];
		 $insertionData['purchase_in_multiple_of'] = $allDataInSheet[$i]["N"];
		 $insertionData['min_additional_purchase_amt'] = $allDataInSheet[$i]["O"];
		 $insertionData['additional_purchase_in_multiple_of'] = $allDataInSheet[$i]["P"];
		 $insertionData['redemption_min_amount'] = $allDataInSheet[$i]["Q"];
		 $insertionData['redemption_in_multiple_of'] = $allDataInSheet[$i]["R"];
		 $insertionData['redemption_min_units'] = $allDataInSheet[$i]["S"];
		 $insertionData['redemption_min_units_in_multiple_of'] = $allDataInSheet[$i]["T"];
		 $insertionData['switch_in_the_scheme_min_amount'] = $allDataInSheet[$i]["U"];
		 $insertionData['switch_in_the_scheme_in_multiple_of'] = $allDataInSheet[$i]["V"];
		 $insertionData['switch_in_the_scheme_min_units'] = $allDataInSheet[$i]["W"];
		 $insertionData['switch_in_the_scheme_min_units_in_multiple_of'] = $allDataInSheet[$i]["X"];
		 $insertionData['switch_out_of_the_scheme_min_amount'] = $allDataInSheet[$i]["Y"];
		 $insertionData['switch_out_of_the_scheme_in_multiple_of'] = $allDataInSheet[$i]["Z"];
		 $insertionData['switch_out_of_the_scheme_min_units'] = $allDataInSheet[$i]["AA"];
		 $insertionData['switch_out_of_the_scheme_min_units_in_multiple_of'] = $allDataInSheet[$i]["AB"];
		 $insertionData['SIP_min_amount'] = $allDataInSheet[$i]["AC"];
		 $insertionData['SIP_in_multiple_of'] = $allDataInSheet[$i]["AD"];
		 $insertionData['STP_min_amount'] = $allDataInSheet[$i]["AE"];
		 $insertionData['STP_in_multiple_of'] = $allDataInSheet[$i]["AF"];
		 $insertionData['SWP_min_amount'] = $allDataInSheet[$i]["AG"];
		 $insertionData['SWP_in_multiple_of'] = $allDataInSheet[$i]["AH"];
		 $insertionData['exit_load_flag'] = $allDataInSheet[$i]["AI"];
		 $insertionData['exit_load'] = $allDataInSheet[$i]["AJ"];



		 $result=$this->fundimport_model->saveFundsData($insertionData);
		 if($result){
			 log_message('info', '***** Controller : FundImport, Function : axisFundCodes, Message : Successfully inserted fund -  '.$result.' *****');
		 }
		 else {
		 	 log_message('info', '***** Controller : FundImport, Function : axisFundCodes, Message : Failed to insert axis fund  *****');
		 }
		 //print_r($insertionData);die;

    }

	}


	function utiFundCodes(){

		$excelFile = "assets/uploads/fundCodesSheets/UTI Product codes.xlsx";

    $objPHPExcel = PHPExcel_IOFactory::load($excelFile);
    $allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
    $arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet

		//print_r($allDataInSheet);die;
		$insertionData = array();
		$insertionData['api_type_id'] = 1;//For Karvy
		$insertionData['AMC_code'] = 'UTI';


   for($i=2;$i<=$arrayCount;$i++)
   {

		 //print_r($allDataInSheet[$i]);die;

		 $insertionData['scheme_code'] = $allDataInSheet[$i]["B"];
		 $insertionData['plan_code'] = $allDataInSheet[$i]["C"];
		 $insertionData['scheme_description'] = $allDataInSheet[$i]["E"];
		 $insertionData['fund_code'] = $allDataInSheet[$i]["G"];
		 $insertionData['old_fund_code'] = $allDataInSheet[$i]["F"];

		 if($allDataInSheet[$i]["H"] == 'EQUITY FUND' || $allDataInSheet[$i]["H"] == 'EQUITY'){
			 	$insertionData['fund_type_id'] = 1;
		 }elseif($allDataInSheet[$i]["H"] == 'DEBT FUND' || $allDataInSheet[$i]["H"] == 'DEBT'){
			 $insertionData['fund_type_id'] = 2;
		 }elseif($allDataInSheet[$i]["H"] == 'TAX SAVING'){
			 $insertionData['fund_type_id'] = 3;
		 }elseif($allDataInSheet[$i]["H"] == 'LIQUID FUND' || $allDataInSheet[$i]["H"] == 'LIQUID'){
			 $insertionData['fund_type_id'] = 4;
		 }

		 $insertionData['status'] = $allDataInSheet[$i]["I"];
		 $insertionData['ISIN'] = $allDataInSheet[$i]["J"];

		 $result=$this->fundimport_model->saveFundsData($insertionData);
		 if($result){
			 log_message('info', '***** Controller : FundImport, Function : utiFundCodes, Message : Successfully inserted fund -  '.$result.'  *****');
		 }
		 else
		 {
		 		log_message('info', '***** Controller : FundImport, Function : utiFundCodes, Message : Failed to insert uti fund *****');
		 }
		 //print_r($insertionData);die;

    }

	}

	function iciciFundCodes(){

	//	$excelFile = "assets/uploads/fundCodesSheets/23032016114945_69640703R39.xls";//iciciFundCodes

		$excelFile = "assets/uploads/fundCodesSheets/IDFC scheme type.xls";//IDFC


		$objPHPExcel = PHPExcel_IOFactory::load($excelFile);
		$allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
		$arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet

		//print_r($allDataInSheet);die;
		$insertionData = array();
		$insertionData['api_type_id'] = 2;//For CAMS


	 for($i=2;$i<=$arrayCount;$i++)
	 {
//print_r($allDataInSheet[$i]);die;
				 $insertionData['AMC_code'] = trim($allDataInSheet[$i]["A"]);
				 $insertionData['scheme_code'] = trim($allDataInSheet[$i]["C"]);
				 $insertionData['scheme_description'] = trim($allDataInSheet[$i]["D"]);
				 $insertionData['sch_type'] = trim($allDataInSheet[$i]["E"]);


				 $insertionData['div_reinv'] = trim($allDataInSheet[$i]["D"]);
				 $insertionData['sip_allow'] = trim($allDataInSheet[$i]["G"]);
				 $insertionData['lien'] = trim($allDataInSheet[$i]["H"]);
				 $insertionData['swt_mn_amt'] = trim($allDataInSheet[$i]["I"]);

				 if(trim($allDataInSheet[$i]["J"]) == '100000000000000016'){
				 	$insertionData['swt_mx_amt'] = '100000000000000000';
				 }else{
					$insertionData['swt_mx_unt'] = trim($allDataInSheet[$i]["J"]);
				 }

				 $insertionData['swt_mn_unt'] = trim($allDataInSheet[$i]["K"]);

				 if(trim($allDataInSheet[$i]["L"]) == '100000000000000016'){
				 		$insertionData['swt_mx_unt'] = '100000000000000000';
				 }else{
				 	$insertionData['swt_mx_unt'] = trim($allDataInSheet[$i]["L"]);
				 }

				 $insertionData['swi_multi'] = trim($allDataInSheet[$i]["M"]);
				 $insertionData['adp_mn_amt'] = trim($allDataInSheet[$i]["N"]);


				 if(trim($allDataInSheet[$i]["O"]) == '100000000000000016'){
				 		$insertionData['adp_mx_amt'] = '100000000000000000';
				 }else{
				 	$insertionData['adp_mx_amt'] = trim($allDataInSheet[$i]["O"]);
				 }

				 //$insertionData['adp_mx_amt'] = trim($allDataInSheet[$i]["O"]);
				 $insertionData['adp_mn_unt'] = trim($allDataInSheet[$i]["P"]);

				 if(trim($allDataInSheet[$i]["Q"]) == '100000000000000016'){
				 		$insertionData['adp_mx_unt'] = '100000000000000000';
				 }else{
				 	$insertionData['adp_mx_unt'] = trim($allDataInSheet[$i]["Q"]);
				 }
				 //$insertionData['adp_mx_unt'] = trim($allDataInSheet[$i]["Q"]);

				 $insertionData['min_purchase_amt'] = trim($allDataInSheet[$i]["R"]);

				 if(trim($allDataInSheet[$i]["S"]) == '100000000000000016'){
				 		$insertionData['newp_mxval'] = '100000000000000000';
				 }else{
				 	$insertionData['newp_mxval'] = trim($allDataInSheet[$i]["S"]);
				 }
				 //$insertionData['newp_mxval'] = trim($allDataInSheet[$i]["S"]);

				 $insertionData['p_mn_incr'] = trim($allDataInSheet[$i]["T"]);
				 $insertionData['redemption_min_amount'] = trim($allDataInSheet[$i]["U"]);


				 if(trim($allDataInSheet[$i]["V"]) == '100000000000000016'){
					 $insertionData['red_mx_amt'] = '100000000000000000';
				 }else{
				 	 $insertionData['red_mx_amt'] = trim($allDataInSheet[$i]["V"]);
				 }
				 //$insertionData['red_mx_amt'] = trim($allDataInSheet[$i]["V"]);

				 $insertionData['redemption_min_units'] = trim($allDataInSheet[$i]["W"]);

				 if(trim($allDataInSheet[$i]["X"]) == '100000000000000016'){
					 $insertionData['red_mx_unt'] = '100000000000000000';
				 }else{
				 	 $insertionData['red_mx_unt'] = trim($allDataInSheet[$i]["X"]);
				 }
				 //$insertionData['red_mx_unt'] = trim($allDataInSheet[$i]["X"]);


				 $insertionData['SWP_min_amount'] = trim($allDataInSheet[$i]["Z"]);

				 if(trim($allDataInSheet[$i]["AA"]) == '100000000000000016'){
					 $insertionData['SWP_max_amount'] = '100000000000000000';
				 }else{
				 	 $insertionData['SWP_max_amount'] = trim($allDataInSheet[$i]["AA"]);
				 }
				 //$insertionData['SWP_max_amount'] = trim($allDataInSheet[$i]["AA"]);

				 $insertionData['close_end'] = trim($allDataInSheet[$i]["AB"]);
				 $insertionData['elss_sch'] = trim($allDataInSheet[$i]["AC"]);

				 $originalDateMaturityDate = changeDateFormatCams($allDataInSheet[$i]["AD"]);
				 $newDateMaturityDate = date("Y-m-d", strtotime($originalDateMaturityDate));
				 $insertionData['maturity_date'] = $newDateMaturityDate;

				 $insertionData['face_value'] = trim($allDataInSheet[$i]["AE"]);


				 if($allDataInSheet[$i]["AF"] == 'EQUITY FUND' || $allDataInSheet[$i]["AF"] == 'EQUITY'){
						$insertionData['fund_type_id'] = 1;
				 }elseif($allDataInSheet[$i]["AF"] == 'DEBT FUND' || $allDataInSheet[$i]["AF"] == 'DEBT'){
					 $insertionData['fund_type_id'] = 2;
				 }elseif($allDataInSheet[$i]["AF"] == 'TAX SAVING'){
					 $insertionData['fund_type_id'] = 3;
				 }elseif($allDataInSheet[$i]["AF"] == 'CASH'){
					 $insertionData['fund_type_id'] = 4;
				 }

				$insertionData['sebi_class'] = trim($allDataInSheet[$i]["AG"]);
				$insertionData['settle_per'] = trim($allDataInSheet[$i]["AH"]);
				$insertionData['sip_dates'] = trim($allDataInSheet[$i]["AI"]);
				$insertionData['swp_dates'] = trim($allDataInSheet[$i]["AJ"]);
				$insertionData['stp_dates'] = trim($allDataInSheet[$i]["AK"]);
				$insertionData['sys_freqs'] = trim($allDataInSheet[$i]["AL"]);
				$insertionData['swp_allow'] = trim($allDataInSheet[$i]["AM"]);
				$insertionData['stp_allow'] = trim($allDataInSheet[$i]["AN"]);
				$insertionData['plan_type'] = trim($allDataInSheet[$i]["AO"]);
				$insertionData['sf_code'] = trim($allDataInSheet[$i]["AP"]);
				$insertionData['sf_name'] = trim($allDataInSheet[$i]["AQ"]);

				$originalDateStartDate = changeDateFormatCams($allDataInSheet[$i]["AR"]);
				$newDateStartDate = date("Y-m-d", strtotime($originalDateStartDate));
				$insertionData['start_date'] = $newDateStartDate;

				$insertionData['swt_allow'] = trim($allDataInSheet[$i]["AS"]);
				$insertionData['adp_mn_inc'] = trim($allDataInSheet[$i]["AT"]);
				$insertionData['pur_allow'] = trim($allDataInSheet[$i]["AU"]);
				$insertionData['red_allow'] = trim($allDataInSheet[$i]["AV"]);
			 	$insertionData['SIP_mn_ins'] = trim($allDataInSheet[$i]["AW"]);
			 	$insertionData['SIP_min_amount'] = trim($allDataInSheet[$i]["AX"]);
			 	$insertionData['SIP_mn_ins'] = trim($allDataInSheet[$i]["AW"]);
			 	$insertionData['SIP_min_amount'] = trim($allDataInSheet[$i]["AX"]);
			  $insertionData['SIP_in_multiple_of'] = trim($allDataInSheet[$i]["AY"]);

				if(trim($allDataInSheet[$i]["AZ"]) == '100000000000000016'){
					$insertionData['SIP_mx_amt'] = '100000000000000000';
				}else{
					$insertionData['SIP_mx_amt'] = trim($allDataInSheet[$i]["AZ"]);
				}
			  //$insertionData['SIP_mx_amt'] = trim($allDataInSheet[$i]["AZ"]);


				$insertionData['SWP_mn_ins'] = trim($allDataInSheet[$i]["BA"]);
				$insertionData['SWP_in_multiple_of'] = trim($allDataInSheet[$i]["BB"]);
				$insertionData['parent_scheme_code'] = trim($allDataInSheet[$i]["BC"]);
				$insertionData['ISIN'] = trim($allDataInSheet[$i]["BD"]);
 				//print_r($insertionData);die;
				 $result=$this->fundimport_model->saveFundsData($insertionData);
				 if($result){
					 log_message('info', '***** Controller : FundImport, Function : iciciFundCodes, Message : Successfully inserted fund -  '.$result.' *****');
				 }
				 else {
				 	log_message('info', '***** Controller : FundImport, Function : iciciFundCodes, Message : Failed to insert icici fund *****');
				 }

		}

	}

	function birlaFundCodes(){

		$excelFile = "assets/uploads/fundCodesSheets/Birla Fund codes.xlsx";

		$objPHPExcel = PHPExcel_IOFactory::load($excelFile);
		$allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
		$arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet

		//print_r($allDataInSheet);die;
		$insertionData = array();
		$insertionData['api_type_id'] = 2;//For CAMS
		$insertionData['AMC_code'] = 'B';


	 for($i=2;$i<=$arrayCount;$i++)
	 {

		 //print_r($allDataInSheet[$i]);die;

		 $insertionData['scheme_code'] = $allDataInSheet[$i]["A"];
		 $insertionData['scheme_description'] = $allDataInSheet[$i]["B"];
		 $insertionData['min_purchase_amt'] = $allDataInSheet[$i]["C"];
		 $insertionData['min_additional_purchase_amt'] = $allDataInSheet[$i]["D"];
		 $insertionData['redemption_min_amount'] = $allDataInSheet[$i]["E"];

		 $insertionData['SIP_min_amount'] = $allDataInSheet[$i]["F"];
		 $insertionData['SWP_min_amount'] = $allDataInSheet[$i]["G"];

		 $insertionData['cut_off_time_purchase'] = $allDataInSheet[$i]["I"];
		 $insertionData['cut_off_time_redemption'] = $allDataInSheet[$i]["J"];



/*
		 if($allDataInSheet[$i]["H"] == 'EQUITY FUND' || $allDataInSheet[$i]["H"] == 'EQUITY'){
				$insertionData['fund_type_id'] = 1;
		 }elseif($allDataInSheet[$i]["H"] == 'DEBT FUND' || $allDataInSheet[$i]["H"] == 'DEBT'){
			 $insertionData['fund_type_id'] = 2;
		 }elseif($allDataInSheet[$i]["H"] == 'TAX SAVING'){
			 $insertionData['fund_type_id'] = 3;
		 }elseif($allDataInSheet[$i]["H"] == 'LIQUID FUND' || $allDataInSheet[$i]["H"] == 'LIQUID'){
			 $insertionData['fund_type_id'] = 4;
		 }
*/
		 $result=$this->fundimport_model->saveFundsData($insertionData);
		 if($result){
			 log_message('info', '***** Controller : FundImport, Function : birlaFundCodes, Message : Successfully inserted fund -  '.$result.' *****');
		 }
		 else {
		 	 log_message('info', '***** Controller : FundImport, Function : birlaFundCodes, Message : Failed to insert birla fund *****');
		 }
		 //print_r($insertionData);die;

		}

	}

	function birlamf(){
		$excelFile = "assets/uploads/camsXls/BIRLAMF.xls";

    $objPHPExcel = PHPExcel_IOFactory::load($excelFile);
    $allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);

		//$sheetCount = $objPHPExcel->getSheetCount();
		//$sheetNames = $objPHPExcel->getSheetNames();
		//Array ( [0] => LOCATION [1] => Sheet2 [2] => Occupation [3] => pay out_mechanism [4] => state master [5] => tax status )
		//$sheetDetails = $objPHPExcel->getSheetByName();
		try {
		        $objWorksheet =  $objPHPExcel->setActiveSheetIndex('1');
		}
		catch (Exception $e) {
		    echo 'Sheet is not exists!';
		}


		print_r($objWorksheet);die;

    $arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet


		$insertionData = array();

   for($i=2;$i<=$arrayCount;$i++)
   {

		 //print_r($allDataInSheet[$i]);die;

		 $insertionData['scheme_code'] = $allDataInSheet[$i]["B"];
		 $insertionData['plan_code'] = $allDataInSheet[$i]["C"];


		 $result=$this->fundimport_model->saveFundsData($insertionData);
		 if($result){
			 log_message('info', '***** Controller : FundImport, Function : birlamf, Message : Successfully inserted fund -  '.$result.' *****');
		 }
		 else {
		 	 log_message('info', '***** Controller : FundImport, Function : birlamf, Message : Failed to insert birlamf fund -  '.$result.' *****');
		 }
		 //print_r($insertionData);die;

    }

	}

}
