<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class GetSumNav extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('sum_nav_model');
	   $this->load->model('dashboard_model');
	}

	public function index()
	{
        $investorList=$this->sum_nav_model->getInvestorList();
        if(isset($investorList) && !empty($investorList))
        {
            foreach($investorList as $investor)
            {
                $investorId = $investor->investor_id;
                $resultCurrentAmount=$this->dashboard_model->getAllInvestmentCurrentValue($investorId);
                $currentDate=date("Y-m-d");
                $data["date"]=$currentDate;
                $data["investor_id"]=$investorId;
                $data["sum_nav"]=$resultCurrentAmount;
                $checkInvestorDateExists=$this->sum_nav_model->checkInvestorDateExists($investorId,$currentDate);
                if($checkInvestorDateExists)
                {
                    $updateSumNav=$this->sum_nav_model->updateSumNav($investorId,$currentDate,$resultCurrentAmount);
										log_message('info', '***** Controller : getSumNav, Function : index, Message : updated sum of NAV for Investor Id '.$investorId.' for '.$currentDate.' *****');
                }
                else
                {
                    $insertSumNav=$this->sum_nav_model->insertSumNav($data);
										log_message('info', '***** Controller : getSumNav, Function : index, Message : Inserted sum of NAV for Investor Id '.$investorId.' for '.$currentDate.' *****');
                }
            }

            // add cron info
            $cronUrl=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
            $cronDate=date("Y-m-d h:i:s");
            $cronDesc="Cron successfully executed to insert sum of NAV for Investors";

            $data=array("cron_url"=>$cronUrl,"cron_date"=>$cronDate,"cron_desc"=>$cronDesc);
            addCronLog($data);
        }
        else
        {
						log_message('info', '***** Controller : getSumNav, Function : index, Message : Inserted list not found for NAV  for '.$currentDate.' *****');
        }
    }
}
