<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class ManageAccount extends CI_Controller {

  	function __construct()
  	{
  	    // Call the Model constructor
  	    parent::__construct();

        $this->load->model('manage_account_model');
        $this->load->model('dashboard_model');
  	}

  	public function index()
  	{
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->data['pageTitle'] = 'Manage Account';
                    $this->_loadView('manage_account_view');
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited Manage Account page");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function _loadView($view)
    {
        $userId=$_SESSION["userId"];
        $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
        if($result)
        {
            $data["profileImageUrl"]=$result->profile_image_url;
            $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
            $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
            $data["is_verify"]=$result->is_verify;
        }
        else
        {
            $data["profileImageUrl"]="";
        }

        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }

        $data['jsFile'] ='manageAccount.js';
        $data['jsFileExtra'] ='sipCalculation.js';
        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('dashboard_header_view',$data);
        $this->load->view($view,$data);
        $this->load->view('amit_theme/common/footer',$data );
    }

    function getAddress()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $userId=$_SESSION["userId"];
            $result=$this->manage_account_model->getAddress($userId);
            if($result)
            {

                $address = $result->address;
                $pincode = $result->pincode;
                $city = $result->city;
                $state = $result->state;
                $country = $result->country_name;
                echo '{"success":true,"address":"'.$address.'","pincode":"'.$pincode.'","city":"'.$city.'","state":"'.$state.'","country":"'.$country.'"}';
                log_message('info', '***** Successfully fetched address *****');
            }
            else
            {
                echo '{"success":false}';
                log_message('info', '***** Failed to fetch address *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Session out while fetching address *****');
        }
    }

    function getBankDetails()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $userId=$_SESSION["userId"];
            $result=$this->manage_account_model->getBankDetails($userId);
            if($result)
            {
                $account_name = $this->encrypt->decode($result->account_holder_name);
                $account_number = $this->encrypt->decode($result->account_number);
                $account_type = $result->account_type;
                $ifsc_code = $result->ifsc_code;
                $bank_name = rtrim($result->bank_name);
                echo '{"success":true,"account_name":"'.$account_name.'","account_number":"'.$account_number.'","account_type":"'.$account_type.'","ifsc_code":"'.$ifsc_code.'","bank_name":"'.$bank_name.'"}';
                log_message('info', '***** Successfully fetched bank details *****');
            }
            else
            {
                echo '{"success":false}';
                log_message('info', '***** Failed to fetch bank details *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Session out while fetching bank details *****');
        }
    }

    function getNomineeDetails()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $userId=$_SESSION["userId"];
            $result=$this->manage_account_model->getNomineeDetails($userId);
            if($result)
            {
                $rowStr="";
                foreach($result as $row)
                {
                  $nominee_id = $row->nominee_details_id;
                  $nominee_name = $row->name;
                  $nominee_relation = $row->relation_with_investor;

                  // date time convert format
                  if($row->date_of_birth=="0000-00-00")
                  {
                      $date_of_birth="";
                  }
                  else
                  {
                      $date = new DateTime($row->date_of_birth);
                      $date_of_birth=$date->format('M d, Y');
                  }

                  $guardian_name = $row->guardian_name ;
                  $address = $row->address;
                  $percentage = $row->percentage;

                  $rowStr .= '['.$nominee_id.',"'.$nominee_name.'","'.$nominee_relation.'","'.$date_of_birth.'","'.$address.'","'.$guardian_name.'",'.$percentage.'],';
                }

                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** Successfully fetched nominee details *****');
            }
            else
            {
                echo '{"success":false}';
                log_message('info', '***** Failed to fetch nominee details *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Session out while fetching nominee details *****');
        }
    }

    function updateCommunicationAddress()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $userId=$_SESSION["userId"];
            $new_address = $this->input->post('new_communication_address');
            $new_pincode = $this->input->post('new_pincode');
            $new_city = $this->input->post('new_city');
            $new_state = $this->input->post('new_state');
            $new_country = $this->input->post('new_country');
            $result=$this->manage_account_model->updateCommunicationAddress($userId,$new_address,$new_pincode,$new_city,$new_state,$new_country);
            if($result)
            {
                echo '{"success":true,"message":"Communication address updated successfully"}';
                log_message('info', '***** Successfully updated address details *****');
            }
            else
            {
                echo '{"success":false}';
                log_message('info', '***** Failed to update address details *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Session out while updating address details *****');
        }
    }

    function updateBankDetails()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $userId=$_SESSION["userId"];
            $account_name = $this->encrypt->encode($this->input->post('account_name'));
            $account_number = $this->encrypt->encode($this->input->post('account_number'));
            $account_type = $this->input->post('account_type');
            $ifsc_code = $this->input->post('ifsc_code');
            $bank_name = $this->input->post('bank_name');
            $branch_city = $this->input->post('branch_city');
            $branch_name = $this->input->post('branch_name');

            $result=$this->manage_account_model->updateBankDetails($userId,$account_name,$account_number,$account_type,$ifsc_code,$bank_name,$branch_city,$branch_name);
            if($result)
            {
                echo '{"success":true,"message":"Bank details updated successfully"}';
                log_message('info', '***** Successfully updated bank details *****');
            }
            else
            {
                echo '{"success":false}';
                log_message('info', '***** Failed to update bank details *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Session out while updating bank details *****');
        }
    }

    function insertNomineeDetails()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $userId=$_SESSION["userId"];
            $nominee_name = $this->input->post('nominee_name');
            $nominee_relation = $this->input->post('nominee_relation');
            $guardian_name = $this->input->post('guardian_name');
            $date = new DateTime($this->input->post('nominee_dob'));
            $nominee_dob=$date->format('Y-m-d');
            $nominee_dob_format=$date->format('M j, Y');
            $nominee_address = $this->input->post('nominee_address');
            $investorId=$_SESSION["investor_id"];

            $nomineeData=array(
            "name"=>$nominee_name,
            "relation_with_investor"=>$nominee_relation,
            "date_of_birth"=>$nominee_dob,
            "address"=>$nominee_address,
            "guardian_name"=>$guardian_name,
            "investor_id"=>$investorId,
            "status"=>0
        );

            // update nominee details in db
            $result=$this->manage_account_model->insertNomineeDetails($nomineeData);
            if($result)
            {
                log_message('info', '***** Successfully inserted new nominee details *****');
                // fetch user details
                $userData=$this->manage_account_model->getUserData($userId);
                if($userData)
                {
                    $data["user_address"]=$userData->address;
                    $data["user_pincode"]=$userData->pincode;
                    $data["user_city"]=$userData->city;
                    $data["user_state"]=$userData->state;
                    $data["user_investorId"]=$userData->investor_id;
                    $data["user_pan"]=$userData->pan;
                }
                // generate pdf file
                $data["userName"]=$_SESSION["userName"];
                $data["nominee_name"]=trim($nominee_name);
                $data["nominee_relation"]=trim($nominee_relation);
                $data["guardian_name"]=trim($guardian_name);
                $data["nominee_dob"]=trim($nominee_dob_format);
                $data["nominee_address"]=trim($nominee_address);
                $mailBody = $this->load->view('nominee_change_pdf_view',$data,true);
                $this->load->library('mpdf60/mPDF');
                $pdfPath = '';
                try
                {
                    $mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
                    $mpdf->useOnlyCoreFonts = true;    // false is default
                    $mpdf->SetProtection(array('print'));
                    $mpdf->SetTitle("Investocafe");
                    $mpdf->SetAuthor("Author");
                    $mpdf->showWatermarkText = true;
                    $mpdf->SetDisplayMode('fullpage');

                    $html=$mailBody;
                    $mpdf->WriteHTML($html);
                    $fileName = $userId .'_change_nominee_form_'.date('YmdHis', time()).'.pdf';
                    $mpdf->Output(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName, 'F');
                    $pdfPath = realpath(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName);

                    $result2=$this->manage_account_model->savePdfUrlData($fileName,$userId);
                    log_message('info', '***** Successfully updated new nominee details pdf url *****');
                    if($result2)
                    {
//                        echo '{"success":true}';
//                        log_message('info', '***** Successfully created audit pdf *****');
                        $emailResult=$this->sendNomineeChangeMail($nominee_name,$nominee_dob_format,$guardian_name,$nominee_address,$nominee_relation,$pdfPath);
                echo '{"success":true,"message":"Nominee details updated successfully","pdf_name":"'.$fileName.'"}';
                log_message('info', '***** Successfully sent new nominee details mail *****');
                    }
                    else
                    {
                        echo '{"success":false}';
                        log_message('info', '***** Unable to save nominee details pdf url *****');
                    }
                }
                catch(Exception $e)
                {
                    echo '{"success":false,"error":"'.$e.'"}';
                    log_message('info', '***** session out while saving nominee details pdf url *****');
                }

            }
            else
            {
                echo '{"success":false}';
                log_message('info', '***** Failed to insert new nominee details *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Session out for inserting new nominee details *****');
        }
    }

    function sendNomineeChangeMail($nominee_name,$nominee_dob_format,$guardian_name,$nominee_address,$nominee_relation,$pdfPath)
    {
        $email=$_SESSION["email"];
        $name=$_SESSION["userName"];
        $today = date('d M Y h:i a', time());
        $data=array();

        $data["name"]=$name;
        $data["nominee_name"]=$nominee_name;
        $data["nominee_dob"]=$nominee_dob_format;
        $data["nominee_relation"]=$nominee_relation;
        $data["nominee_address"]=$nominee_address;
        $data["guardian_name"]=$guardian_name;
        $html=$this->load->view('nominee_change_email_view', $data,true);
        $this->load->library("email");
        $this->email->set_newline("\r\n");
        $this->email->set_mailtype("html");
        $this->email->to($email);
        $this->email->bcc("explorerarchana@gmail.com");
        $this->email->from(" Investocafe Assistant<info@investocafe.com>", "Investocafe");
        $this->email->subject("Change of Nominee: Action Required");
        $this->email->message($html);
        $this->email->attach($pdfPath);
        $result=$this->email->send();
        //echo $this->email->print_debugger();
        return $result;
    }
}
