<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class PurchaseNetbanking extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('dashboard_model');
       $this->load->model('purchase_model');
       $this->load->helper('transaction_helper');
	}

	public function index($fundTypeId=0)
	{
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("start_invest_equity_info_view",null);
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
	}

    function _loadView($view,$fundTypeId)
    {
        $userId=$_SESSION["userId"];
        $investorId=$_SESSION["investor_id"];

        $resultStatus=$this->common_model->getInvestorStatus($investorId);
        if($resultStatus)
        {
            $kycDone=$resultStatus->is_kyc_done;
        }

        /** invest more in all funds **/
        if($fundTypeId)
        {
            $data["radioFundDetails"]=$this->getFundDetailsByFundTypeId($fundTypeId);
        }

        $data["investorBankDetails"]=$this->purchase_model->getInvestorBankAndPanDetail($investorId);

        //  get fund type name by fund type id
        $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);

        $data["fundTypeName"]=$fundTypeName;
        $data["fundTypeId"]=$fundTypeId;

        $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
        if($result)
        {
            $data["profileImageUrl"]=$result->profile_image_url;
            $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
            $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
            $data["is_verify"]=$result->is_verify;
        }
        else
        {
            $data["profileImageUrl"]="";
        }
        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }

        // check invstor is ready for investment or not
        $investorStatus=$this->common_model->getInvestorStatus($investorId);
        if($investorStatus)
        {
            $data["investorStatus"]=$investorStatus;
        }
        //print_r($data);die;
        $data['jsFile'] ='purchase.js';
        $data['jsFileExtra'] ='sipCalculation.js';
        $this->load->view('includes/header',$data);
        $this->load->view('dashboard_header_view',$data);
        $this->load->view($view,$data);
        $this->load->view('includes/footer',$data );
    }


    function updateFatcaDeclaration()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $fatca=$this->input->post("fatca");
            $investorId=$_SESSION["investor_id"];
            $result=$this->purchase_model->updateFatcaDeclaration($fatca,$investorId);
            if($result)
            {
                if($fatca==1)
                {
                   $pdfResult=$this->createFatcaPDF($investorId);
                   if($pdfResult)
                   {
                     echo '{"success":true}';
                     $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"FATCA pdf generated");
                     addSystemLog($data); // helper function
                   }
                   else
                   {
                      echo '{"success":false}';
                   }

                }
                else
                {
                    echo '{"success":false}';
                }
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Update FATCA declearation");
                addSystemLog($data); // helper function
            }
            else
            {
                echo '{"success":false}';
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
        }
    }

    /** Common  method for all funds type **/
    function startInvestByType($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("investment_type_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Invest More button clicked for Fund Type -  $fundTypeName");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** Common  method for all funds type **/
    function howWouldLikeInvest($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("how_would_you_like_to_invest_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"One Time Investment button clicked for Fund Type -  $fundTypeName");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** Common  method for all funds type **/
    function howWouldLikeInvestSIP($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("how_would_you_like_to_invest_sip_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Start a Monthly SIP button clicked for Fund Type -  $fundTypeName");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id **/
    function startInvestByOneClick($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("start_invest_by_one_click_radiobtn_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase $fundTypeName funds(One Click) page by selecting setup automated transfer");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id with Net banking **/
    function startInvestByOneClickNetBanking($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("start_invest_by_one_click_radiobtn_nb_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase $fundTypeName funds(One Click) page by selecting netbanking");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id with Net banking **/
    function startInvestByMoreOptionNetBanking($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("start_invest_by_more_option_radiobtn_nb_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase $fundTypeName funds(Do it Yourself) page by selecting selecting netbanking");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

     /** common purchase for all fund by fund type id **/
    function startInvestByMoreOption($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
               $this->_loadView("start_invest_by_more_option_radiobtn_view",$fundTypeId);
               $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
               $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase $fundTypeName funds(Do it Yourself) page by selecting setup automated transfer");
               addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id **/
    function confirmationInvestedFunds()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("confirm_invested_funds_view",null);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$this->session->flashdata('message'));
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id **/
    function purchaseOneTimeInvestmentFunds()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorIp=$_SERVER['REMOTE_ADDR'];
            $transactionType=$this->input->post("transactionType");
            $investmentDate=$this->input->post("investmentDate");
            $json=$this->input->post("json");
            $fundTypeId=$this->input->post("fundTypeId");
            $jsonArray=json_decode($json,true);

            // get fund type name by fund type id
            $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
            date_default_timezone_set("Asia/Kolkata");
            $date = new DateTime($investmentDate);
            $requestDate=$date->format('Y-m-d ').date("h:i:s");
            $investorId=$_SESSION["investor_id"];
            $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
            //  get fund type name by fund type id
            $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
            if(isset($jsonArray) && !empty($jsonArray))
            {
                $count=0;
                $totalAmount=0;
                foreach ($jsonArray as $row)
                {
                    $perFundInvestAmount=$row[1];
                    $totalAmount=$totalAmount+$row[1];
                    $fundId=$row[0];
                    $checkResult=$this->purchase_model->checkFirstTimePurchaseFund($fundId,$investorId);
                    if($checkResult){

                        $isFirstPurchase=0;
                    }else{
                        $isFirstPurchase=1;
                    }

                    $resultFolio=getLatestFolioNumber($fundId,$investorId);
                    if($resultFolio){
                        $folioNumber=$resultFolio;
                    }else{
                        $folioNumber="";
                    }

                    $unitCounts=0;

                    // create new api batch id
                    //$apiTypeId=$row->api_type_id;
                    $apiTypeId="";

                    $apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
                    $data=array(
                        "fund_id"=>$fundId,
                        "purchased_amount"=>$perFundInvestAmount,
                        "unit_count"=>$unitCounts,
                        "investor_id"=>$investorId,
                        "request_date"=>$requestDate,
                        "batch_id"=>$batchId,
                        "folio_number"=>$folioNumber,
                        "is_first_purchase"=>$isFirstPurchase,
                        "api_batch_id"=>$apiBatchId,
                        "investment_plan_type"=>"One Time",
                        "investor_ip"=>$investorIp,
                        );
                    $result=$this->purchase_model->addPurchaseFunds($data);
                    if($result)
                    {}else{$count++;}
                }

                if($count==0)
                {
                    if($transactionType==1)
                    {
                        // save daily agenda task
                        $action="Need to submit document for today's purchase - Investor Id - ".$investorId." , Name- ".$this->encrypt->decode($_SESSION['userName']).".";
                        $date=date("Y-m-d h:i:s");
                        addDailyAgenda($action,$date);
                    }

                    $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
                    if (strpos($checkUrl, 'localhost') === false)
                    {
                        // send sms
                        if(isset($_SESSION["userId"]) && !empty($_SESSION["userId"]))
                        {
                            $userId=$_SESSION["userId"];
                            $resultData=$this->common_model->getUseDetailsByUserId($userId);
                            if($resultData)
                            {
                                $name=$this->encrypt->decode($resultData->username);
                                $phone=$this->encrypt->decode($resultData->phone);
                                $sentSms=$this->sendPurchaseSms($name,$phone,$totalAmount);
                                if($sentSms)
                                {
                                    log_message('info', '***** Sent sms for purchase *****');
                                }
                                else
                                {
                                    log_message('info', '***** Failed sending sms for purchase *****');
                                }
                            }
                        }
                    }
                    $sentEmailResult=$this->sendPurchaseFundByMoreOptionsEmail($totalAmount,$investmentDate,$jsonArray,$fundTypeName,$transactionType);

                    if($sentEmailResult)
                    {
                        $this->session->set_flashdata('message', " Rs. ".$totalAmount. " invested in ".$fundTypeName." funds effect from ".$investmentDate);
                        echo '{"success":true,"msg":"Successfully invested in '.$fundTypeName.' funds"}';
                        log_message('info', '***** Successfully invested in '.$fundTypeName.' funds by more option sent email*****');
                    }
                    else
                    {
                        $this->session->set_flashdata('message', " Rs. ".$totalAmount. "invested in ".$fundTypeName." funds effect from ".$investmentDate);
                        echo '{"success":true,"msg":"Successfully invested in '.$fundTypeName.' funds"}';
                        log_message('info', '***** Successfully invested in '.$fundTypeName.' funds by more option but email not sent*****');
                    }
                }
                else
                {
                    echo '{"success":false,"msg":"Failed invested in '.$fundTypeName.' funds"}';
                    log_message('info', '***** Failed invested in '.$fundTypeName.' funds *****');
                }
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
        }
    }

    function sendPurchaseSms($userName,$userPhone,$amount)
    {
        if($userPhone!="" && $userName!="")
        {
            $ch = curl_init();

            //Like us on bit.ly/eshpind----------------
            $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AhFLcgCDmJF56b081c8&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0AYour%20request%20for%20BUYING%20of%20Rs.%20".$amount."%20has%20been%20received%20at%20our%20end%2C%20It%20will%20be%20processed%20shortly.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4;";
            $url=str_replace(" ", "%20", $url1);
            //echo $url;
            curl_setopt($ch, CURLOPT_URL, $url);
            //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

            //return the transfer as a string
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

            //$output contains the output string
            $output = curl_exec($ch);

            $dbData = array ('phone'=>$userPhone,'response'=>$output);
            $this->db->insert('msg_log',$dbData);
            //close curl resource to free up system resources
            curl_close($ch);

            if ( $output === FALSE)
            {
              $output=curl_error($ch); //echoes last session error
              return false;
            }
            return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
            log_message("info","***** Invalid user name or phone number for send Sms For purchase funds *****");
        }
    }

    function sendPurchaseFundByMoreOptionsEmail($amount,$investmentDate,$investedFundList,$fundTypeName,$transactionType)
    {
        if($transactionType==1)
        {
            $transactionType="Automated Transfer";
        }else{$transactionType="Netbanking";}
        $email=$_SESSION["email"];
        $name=$this->encrypt->decode($_SESSION["userName"]);
        $today = date('d M Y h:i a', time());
        $data=array();
        $data["fundTypeName"]=$fundTypeName;
        $data["name"]=$name;
        $data["transactionType"]=$transactionType;
        $data['amount']=$amount;
        $data['requestDate']=$investmentDate;
        $data["fundsList"]=$investedFundList;
        $html=$this->load->view('invested_funds_by_mo_confirmation_email_view', $data,true);
        $this->load->library("email");
        $this->email->set_newline("\r\n");
        $this->email->set_mailtype("html");
        $this->email->to($email);
        $recipients=array('explorerarchana@gmail.com');
        $this->email->bcc($recipients);
        $this->email->from("Investocafe Assistant<help@investocafe.com>", "Investocafe");
        $subject="Your investment with Investocafe has been scheduled";
        $this->email->subject($subject);
        $this->email->message($html);
        $result=$this->email->send();
        //echo $this->email->print_debugger();
        return $result;
    }

    //---------------//---------------//-----------------//----------------//

    function startInvestingMonthlySetup($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("start_invest_sip_monthly_one_click_radiobtn_view",$fundTypeId);
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase monthly sip $fundTypeName funds(One Click) page by selecting setup automated transfer");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function startInvestingSIPMonthlyNetbankingSetup($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("start_invest_sip_monthly_one_click_radiobtn_nb_view",$fundTypeId);
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase monthly sip $fundTypeName funds(One Click) page by selecting netbanking");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function startInvestByMoreOptionSipMonthly($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("start_invest_sip_monthly_more_option_radiobtn_view",$fundTypeId);
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase monthly sip  $fundTypeName funds(Do it Yourself) page by selecting setup automated transfer");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function startInvestByMoreOptionSipMonthlyNetbanking($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("start_invest_sip_monthly_more_option_radiobtn_nb_view",$fundTypeId);
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase monthly sip  $fundTypeName funds(Do it Yourself) page by selecting netbanking");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    // purchase fund for sip monthly common for one click or more option view
    function purchaseFundsForSipMonthlyOnServer()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorIp=$_SERVER['REMOTE_ADDR'];
            $transactionType=$this->input->post("transactionType");
            $investmentDate=$this->input->post("investmentDate");
            $noOfMonths=$this->input->post("noOfMonths");
            $json=$this->input->post("json");
            $fundTypeId=$this->input->post("fundTypeId");
            $jsonArray=json_decode($json,true);

            // get fund type name by fund type id
            $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
            date_default_timezone_set("Asia/Kolkata");
            $date = new DateTime($investmentDate);
            $requestDate=$date->format('Y-m-d ').date("h:i:s");

            $time = strtotime($requestDate);
            $nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));

            $investorId=$_SESSION["investor_id"];
            $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
            //  get fund type name by fund type id

            $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
            if(isset($jsonArray) && !empty($jsonArray))
            {
                $count=0;
                $totalAmount=0;
                foreach ($jsonArray as $row)
                {
                    $perFundInvestAmount=$row[1];
                    $totalAmount=$totalAmount+$row[1];
                    $fundId=$row[0];
                    $checkResult=$this->purchase_model->checkFirstTimePurchaseSIPFund($fundId,$investorId);
                    if($checkResult){
                        $isFirstPurchase=0;
                    }else{
                        $isFirstPurchase=1;
                    }

                    $resultFolio=getLatestFolioNumber($fundId,$investorId);
                    if($resultFolio){
                        $folioNumber=$resultFolio;
                    }else{
                        $folioNumber="";
                    }

                    $unitCounts= 0;

                    // create new api batch id
                    //$apiTypeId=$row->api_type_id;
                    $apiTypeId="";

                    // add sip monthly setup table
                    $sipEndDate = date('Y-m-d', strtotime("+".$noOfMonths." months", strtotime($requestDate)));
                    $monthlyInvestmentdata= array("fund_id"=>$fundId,
                        "investor_id"=>$investorId,
                        "amount"=>$perFundInvestAmount,
                        "sip_start_date"=>$requestDate,
                        "sip_end_date"=>$sipEndDate,
                        "next_investment_date"=>$nextInvestmentDate,
                        "no_of_months"=>$noOfMonths,
                        "batch_id"=>$batchId,
                        );
				
                    $monthlyInvestmentId=$this->purchase_model->addSipMonthlyInvestmentFunds($monthlyInvestmentdata);
/*
------------------------------------------------------------------------------------------------------------------------
|	CHNAGE BY TECHNOUNIVERSE
|	DATE : 27/08/2016
|	AUTHOER : AMIT MEENA
|	COMMENT : There is we add new function calles addDailyAgenda to insert next investment date in daily_agenda table
------------------------------------------------------------------------------------------------------------------------
*/					
					$action ="Today is SIP of InvestorId - ".$investorId;
					$date = $nextInvestmentDate;
					addDailyAgenda($action,$date);
					
                    $apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
                    $data=array(
                        "fund_id"=>$fundId,
                        "purchased_amount"=>$perFundInvestAmount,
                        "unit_count"=>$unitCounts,
                        "investor_id"=>$investorId,
                        "request_date"=>$requestDate,
                        "batch_id"=>$batchId,
                        "folio_number"=>$folioNumber,
                        "is_first_purchase"=>$isFirstPurchase,
                        "api_batch_id"=>$apiBatchId,
                        "investment_plan_type"=>"SIP Monthly",
                        "is_monthly_sip"=>1,
                        "investor_ip"=>$investorIp,
                        );

                    $purchasedUnitsId=$this->purchase_model->addPurchaseFunds($data);
                    if($purchasedUnitsId)
                    {
                        // add details in monthly mapping table
                        $data=array("monthly_investment_id"=>$monthlyInvestmentId,"purchased_units_id"=>$purchasedUnitsId);
                        $this->purchase_model->addMonthlyInvestmentMappingData($data);
                    }else{$count++;}
                }

                if($count==0)
                {
                    if($transactionType==1)
                    {
                        // save daily agenda task
                        $action="Need to submit document for today's purchase - Investor Id - ".$investorId." , Name- ".$this->encrypt->decode($_SESSION['userName']).".";
                        $date=date("Y-m-d h:i:s");
                        addDailyAgenda($action,$date);
                    }

                    $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
                    if (strpos($checkUrl, 'localhost') === false)
                    {
                        // send sms
                        if(isset($_SESSION["userId"]) && !empty($_SESSION["userId"]))
                        {
                            $userId=$_SESSION["userId"];
                            $resultData=$this->common_model->getUseDetailsByUserId($userId);
                            if($resultData)
                            {
                                $name=$this->encrypt->decode($resultData->username);
                                $phone=$this->encrypt->decode($resultData->phone);
                                $sentSms=$this->sendPurchaseSms($name,$phone,$totalAmount);
                                if($sentSms)
                                {
                                    log_message('info', '***** Sent sms for purchase *****');
                                }
                                else
                                {
                                    log_message('info', '***** Failed sending sms for purchase *****');
                                }
                            }
                        }
                    }

                    $sentEmailResult=$this->sendPurchaseFundByMoreOptionsEmail($totalAmount,$investmentDate,$jsonArray,$fundTypeName,$transactionType);

                    if($sentEmailResult)
                    {
                        $this->session->set_flashdata('message', " Rs. ".$totalAmount. " monthly invested in ".$fundTypeName." funds effect from ".$investmentDate);
                        echo '{"success":true,"msg":"Successfully invested in '.$fundTypeName.' funds"}';
                        log_message('info', '***** Successfully invested in '.$fundTypeName.' funds by more option sent email*****');
                    }
                    else
                    {
                        $this->session->set_flashdata('message', " Rs. ".$totalAmount. "monthly invested in ".$fundTypeName." funds effect from ".$investmentDate);
                        echo '{"success":true,"msg":"Successfully invested in '.$fundTypeName.' funds"}';
                        log_message('info', '***** Successfully invested in '.$fundTypeName.' funds by more option but email not sent*****');
                    }
                }
                else
                {
                    echo '{"success":false,"msg":"Failed invested in '.$fundTypeName.' funds"}';
                    log_message('info', '***** Failed invested in '.$fundTypeName.' funds *****');
                }
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
        }
    }

    // modify one time investment
    function modify($fundTypeId=null)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            $investorId=$_SESSION["investor_id"];
            $userId=$_SESSION["userId"];
            $batchId=$this->input->get("batchId");
            if(in_array("6", $pageId))
            {
                $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
                if($result)
                {
                    $data["profileImageUrl"]=$result->profile_image_url;
                    $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                    $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
                    $data["is_verify"]=$result->is_verify;
                }
                else
                {
                    $data["profileImageUrl"]="";
                }

                if($fundTypeId)
                {
                    $data["investFunds"]=$this->purchase_model->getInstedFundsByBatchId($batchId,$investorId);
                }

                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);

                $data["fundTypeName"]=$fundTypeName;
                $data["fundTypeId"]=$fundTypeId;

                $data['jsFile'] ='purchase.js';
                $data['jsFileExtra'] ='sipCalculation.js';
                $this->load->view('includes/header',$data);
                $this->load->view('dashboard_header_view',$data);
                $this->load->view("modify_plan_view",$data);
                $this->load->view('includes/footer',$data );
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited modify plans funds page");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function modifyPurchasedFundsOnServer()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $pageId=$_SESSION["pageId"];
            if(in_array("6", $pageId))
            {
                $requestDateOld=$this->input->post("requestDate");
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $json=$this->input->post("json");
                $fundTypeId=$this->input->post("fundTypeId");
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $investedFundList=json_decode($json,true);
                $result=$this->purchase_model->updatePurchsedFundsOnServer($investedFundList,$requestDate,$investorId);
                if($result)
                {
                    $message="Successfully modify ".$fundTypeName." funds effect from ".$requestDateOld;
                    $this->session->set_flashdata('message',$message);
                    log_message('info', '***** '.$message.' *****');
                    echo '{"success":true}';
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function

                }
                else
                {
                    $message="Failed moditying invested '.$fundTypeName.' funds";
                    echo '{"success":false}';
                    $this->session->set_flashdata('message',$message);
                    log_message('info', '***** '.$message.' *****');
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
            }
        }
    }

    // modify sip plan
    function modifysip($fundTypeId=null)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            $investorId=$_SESSION["investor_id"];
            $userId=$_SESSION["userId"];
            $batchId=$this->input->get("batchId");
            if(in_array("6", $pageId))
            {
                $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
                if($result)
                {
                    $data["profileImageUrl"]=$result->profile_image_url;
                    $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                    $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
                    $data["is_verify"]=$result->is_verify;
                }
                else
                {
                    $data["profileImageUrl"]="";
                }

                if($fundTypeId)
                {
                    $data["investFunds"]=$this->purchase_model->getSIPInvestedFundsByBatchId($batchId,$investorId);
                }

                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);

                $data["fundTypeName"]=$fundTypeName;
                $data["fundTypeId"]=$fundTypeId;

                $data['jsFile'] ='purchase.js';
                $data['jsFileExtra'] ='sipCalculation.js';
                $this->load->view('includes/header',$data);
                $this->load->view('dashboard_header_view',$data);
                $this->load->view("modify_sip_plan_view",$data);
                $this->load->view('includes/footer',$data );
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited modify sip plans funds page");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function modifysipPurchasedFundsOnServer()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $pageId=$_SESSION["pageId"];
            if(in_array("6", $pageId))
            {
                $requestDateOld=$this->input->post("requestDate");
                $noOfMonths=$this->input->post("noOfMonths");
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $json=$this->input->post("json");
                $fundTypeId=$this->input->post("fundTypeId");
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $investedFundList=json_decode($json,true);
                $result=$this->purchase_model->updateSipPurchsedFundsOnServer($investedFundList,$requestDate,$investorId,$noOfMonths);
                if($result)
                {
                    $message="Successfully modify monthly sip ".$fundTypeName." funds effect from ".$requestDateOld;
                    $this->session->set_flashdata('message', $message);
                    log_message('info', '***** '.$message.' *****');
                    echo '{"success":true}';
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
                else
                {
                    echo '{"success":false}';
                    $message="Failed moditying invested  '.$fundTypeName.' funds";
                    log_message('info', '***** '.$message.' *****');
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
            }
        }
    }

	function getFundDetailsByFundTypeId($fundTypeId)
    {
        $result=$this->purchase_model->getFundsByFundTypeId($fundTypeId);
		if(isset($result) && !empty($result))
        {
            for($i=0,$j=0; $i<count($result); $i++,$j++)
            {
                //print_r($result[$i]);die;
                $rowArr = $result[$i];
                //print_r($rowArr->partner_fund_id);die;
                if(isset($rowArr->partner_fund_id) && $rowArr->partner_fund_id != 0)
                {
                    $dividendFundDetails=$this->purchase_model->getFundDetailsById($rowArr->partner_fund_id);
                    //print_r($dividendFundDetails);


                    $data[$rowArr->sf_name]['growthArr'] = $rowArr;
                    $data[$rowArr->sf_name]['dividendArr'] = $dividendFundDetails;

                    $i = $i+1;
                }else{
                    //echo $rowArr['scheme_description'];
                    $data[$rowArr->scheme_description]['regularPlan'] = $rowArr;

                }
            }

            if(isset($data) && !empty($data))
            {
                //print_r($rowArr);
                return $data;
            }
            else{
                return false;
            }
        }
		else
        {
            return false;
        }
    }

    function createFatcaPDF($investorId)
    {
        $result = $this->purchase_model->getInvestorDetailById($investorId);
        $taxResident = $this->purchase_model->getTaxResidentInfo($investorId);
        //print_r($taxResident);
        $data['row'] = $result;
        $data['taxResidentRow'] =  $taxResident;
        //print_r($data); die;
        $pdfBody = $this->load->view('fatca_pdf_view',$data,true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try
        {
            $mpdf=new mPDF('win-1252','A4','','DejaVuSans',0,0,0,0,10,10,'');
            $mpdf->useOnlyCoreFonts = true;    // false is default
            $mpdf->SetProtection(array('print'));
            $mpdf->SetTitle("INVESTOR DETAILS");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');

            $html=$pdfBody;
            $mpdf->WriteHTML($html);

            $fileName = 'investor'.$investorId.date('YmdHis', time()).'.pdf';
            $mpdf->Output(APPPATH.'../assets/uploads/fatca_form_pdf/'.$fileName, 'F');
            $pdfPath = realpath(APPPATH.'../assets/uploads/fatca_form_pdf/'.$fileName);

            $data=array("fatca_pdf_form_url"=>$fileName);
            $result=$this->purchase_model->updateInvestorInfo($investorId,$data);
            return $result;
        }
        catch(Exception $e)
        {
            echo $e;die;
        }
    }
}
