<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class ReferFriend extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
       $this->load->model("refer_a_friend_model");
	}

	public function index()
	{
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("9", $pageId))
            {
                $this->_loadView("refer_friend_view");
            }
            else
            {
                $this->_loadView("refer_friend_view");
            }
        }
        else
        {
            $this->_loadView("refer_friend_view");
            redirect(base_url());
        }
	}

    public function referAFriend()
    {
        $invId=$_SESSION["investor_id"];
        $name= $this->input->post("name");
        $email=$this->input->post("email");
        $phone=$this->input->post("phone");
        $data=array(
            "investor_id"=>$invId,
            "name_of_friend"=>$name,
            "friends_email"=>$email,
            "friends_phone"=>$phone
            );
        $result=$this->refer_a_friend_model->referFriend($data);
        if($result)
        {
            $emailResult=$this->sendEmailToReferredFriend($name,$email);
            if($emailResult)
            {
                echo '{"success":true}';
								log_message('info', '***** Controller : referFriend, Function : referAFriend, Message : Successfully sent mail to referred friend *****');
            }
            else
            {
                echo '{"success":false}';
								log_message('info', '***** Controller : referFriend, Function : referAFriend, Message : Failed to send mail to referred friend *****');
            }
        }
        else
        {
            echo '{"success":false}';
						log_message('info', '***** Controller : referFriend, Function : referAFriend, Message : No data exists for refer friend *****');
        }
    }


    public function sendEmailToReferredFriend($name,$email)
    {
        $today = date('d M Y h:i a', time());
        $data=array();
        $username=$_SESSION["userName"];
        $data["name"]=$name;
        $data["username"]=$username;
        $html=$this->load->view('refer_friend_email_view',$data,true);
        $this->email->set_newline("\r\n");
        $this->email->set_mailtype("html");
        $this->email->to($email);
        $this->email->bcc("explorerarchana@gmail.com");
        $this->email->from(" Investocafe Assistant<help@investocafe.com>", "Investocafe");
        $this->email->subject("Start Invest");
        $this->email->message($html);
        $result=$this->email->send();
        //echo $this->email->print_debugger(); die;
        return $result;
    }

    function _loadView($view)
    {
        $data['jsFile'] ='referFriend.js';
        $this->load->view('includes/header',$data);
        $this->load->view($view);
        $this->load->view('includes/footer',$data );
    }
}
