<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class RiskProfileAgeCheckCron extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('risk_profile_age_check_model');
	}

	public function index()
    {

    }

    function ageCheckDaily()
    {
        $investorList = $this->risk_profile_age_check_model->getInvestorList();
        if(isset($investorList) && !empty($investorList))
        {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : Fetched active investors list who have done risk profiling *****');
            foreach($investorList as $investor)
            {
                $investorId = $investor->investor_id;
								// print_r("Investor Id : ".$investorId."<br>");
								$tempUserId = $investor->tempUser_id;
								// print_r("Temp Id : ".$tempUserId."<br>");
								$tempUserPhone = $investor->tempUser_phone;
                $email=$investor->tempUser_email;
                $username=$this->encrypt->decode($investor->username);
								// print_r("investor Name : ".$username."<br>");
                $dob=$investor->date_of_birth;
                $age=date_create($dob)->diff(date_create('today'))->y;
                // print_r("Current Age in investor table : ".$age."<br>");
                $riskProfileData = $this->risk_profile_age_check_model->getRiskProfileData($investorId,$tempUserId);
								if($riskProfileData)
								{
									log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : Fetched risk profile data for the investorId : '.$investorId.' and tempUserId : '.$tempUserId.' *****');
									$riskProfileAge=$riskProfileData->age;
									// print_r("Risk profile Age in risk_profile table : ".$riskProfileAge."<br>");
									$dependents=$riskProfileData->dependents;
	                $horizon=$riskProfileData->investment_horizon;
									$downside=$riskProfileData->downside;
									$current_average=$riskProfileData->average;

	                $ageCheckResult=$this->ageCheck($riskProfileAge,$age);
									if($ageCheckResult)
									{
											// print_r("risk profile age and registered investor age are the SAME <br><br>");
											log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : Result - risk profile age and registered investor age are the same *****');
									}
									else
									{
											// print_r("risk profile age and registered investor age are DIFFERENT <br>");
											log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : Result - risk profile age and registered investor age are different *****');
											// ratio for existing risk profile age
											// print_r("Risk Profile Age :".$riskProfileAge."<br>");
											log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : fetch age ratio for the existing age *****');
											$existingAgeRatio=$this->getRatio($riskProfileAge);
											// print_r("Existing Age Ratio : ".$existingAgeRatio."<br>");
											// update new age in risk_profile
											$updateAgeResult=$this->updateAge($riskProfileAge,$age,$dob,$tempUserId,$investorId);
											if($updateAgeResult)
											{
												// print_r("Updated age in risk profile table - true for investorId : ".$investorId."<br>");
												log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : updated new age in risk_profile table for the user'.$investorId.' *****');
												// print_r("updated age!! <br>---------<br>");
												log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : fetch age ratio for the new age *****');
												$newAgeRatio=$this->getRatio($age);
												// print_r("New average ratio : ".$newAgeRatio."<br>");
												if($newAgeRatio ==$existingAgeRatio )
												{
													// same ratio
													// print_r("same age ratio...");die;
													log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : existing age ratio and new age ratio are the same *****');
												}
												else
												{
													// print_r("different age ratio...<br>");
														log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : existing age ratio and new age ratio are different *****');
														// different ratio
														// calculate new average
														$newAverage=$this->calculateAverage($age,$dependents,$horizon,$downside);
														if($newAverage)
														{
															// print_r("new average : ".$newAverage."<br>");
															log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : calculated new average for the investor '.$investorId.' *****');
															$updateAverageResult=$this->risk_profile_age_check_model->updateAverage($current_average,$newAverage,$tempUserId,$investorId);
															if($updateAverageResult)
															{
																// print_r("updated new average<br>");
																log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : updated new average for the investor '.$investorId.' in risk_profile table *****');
																$sent=$this->sendEmailForRiskProfileAgeRangeChange($age,$username,$email,$newAverage,$current_average,$existingAgeRatio,$newAgeRatio);
                                if($sent)
                                {
																		print_r("mail sent to investor id : ".$investorId."<br><br>");
																		log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : Sent change in risk profile age range mail to investor id '.$investorId.' *****');
                                }
                                else
                                {
																		print_r("mail not sent to investor id : ".$investorId."<br><br>");
																		log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : Failed to send change in risk profile age range mail to investor id '.$investorId.' *****');
                                }
															}
															else
															{
																// print_r("false");
																log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : unable to update new average for the investor '.$investorId.' in risk_profile table *****');
															}
														}
												}
											}
											else
											{
												// print_r("updated age - false as today's month,day not equal to date-of-birth month,day..<br><br>");
												log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : not updated new age in risk_profile table for the user'.$investorId.' as today"s month,day not equal to date-of-birth month,day *****');
											}
									}

								}
								else
								{
									// print_r("false<br><br>");
									log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : No risk profile data exists *****');
								}
            }
        }
        else
        {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheckDaily, Message : No Risk Profile data available for active investors in temp_users table *****');
        }
    }

    function ageCheck($riskProfileAge,$age)
    {
        $riskProfileAge=$riskProfileAge;
        $investorAge=$age;

				if($riskProfileAge==$investorAge)
				{
					  // print_r("same age");die;
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheck, Message : risk profile age and registered investor age are the same *****');
						return true;
				}
				else
				{
						// print_r("different age<br>");
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : ageCheck, Message : risk profile age and registered investor age are different *****');
						return false;
				}
    }

		function updateAge($riskProfileAge,$age,$dob,$tempUserId,$investorId)
		{
			$riskProfileAge=$riskProfileAge;
			$investorAge=$age;

			$date_of_birth=strtotime($dob);
			$today=strtotime(date('Y-m-d', time()));

			$month1_date_of_birth = date('m', $date_of_birth);
			$month2_today = date('m', $today);

			$day1_date_of_birth = date('d', $date_of_birth);
			$day2_today = date('d', $today);

			if($month1_date_of_birth==$month2_today)
			{
				// print_r("month same...<br>");
				log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : updateAge, Message : todays month and date-of-birth month are the same *****');
				if($day1_date_of_birth==$day2_today)
				{
					// print_r("day same...<br>");
					log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : updateAge, Message : todays day and date-of-birth day are the same *****');
					$year1_date_of_birth = date('Y', $date_of_birth);
					$year2_today = date('Y', $today);
					$newAge=$year2_today-$year1_date_of_birth;
					// print_r("month and day same");die;
					// print_r("temp user id : ".$tempUserId."<br>");
					// print_r("investor id : ".$investorId."<br><br>");
					$updateRiskProfileAge = $this->risk_profile_age_check_model->updateRiskProfileAge($tempUserId,$investorId,$newAge);
					if($updateRiskProfileAge)
					{
						// print_r("updated age in risk profile table ...<br>");
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : updateAge, Message : updated risk profile age *****');
						return true;
					}
					else
					{
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : updateAge, Message : failed to update risk profile age *****');
						return false;
					}
				}
			}
			else
			{
				log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : updateAge, Message : todays month and date-of-birth month are different. same goes for day  *****');
				return false;
			}
		}

		function getRatio($age)
		{
			$riskProfileAge=$age;
			if($riskProfileAge<35)
			{
					log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : getRatio, Message : age ratio - 80:20 *****');
					return "80:20";
			}
			else if($riskProfileAge>=35 && $riskProfileAge<50)
			{
					log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : getRatio, Message : age ratio - 60:40 *****');
					return "60:40";
			}
			else if($riskProfileAge>=50 && $riskProfileAge<=65)
			{
					log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : getRatio, Message : age ratio - 40:60 *****');
					return "40:60";
			}
			else if($riskProfileAge>=65)
			{
					log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : getRatio, Message : age ratio - 20:80 *****');
					return "20:80";
			}
		}

		function calculateAverage($age,$dependents,$horizon,$downside)
		{
			$ageRatio=$this->myAgeRatio($age);
      $dependentsRatio=$this->myDependentsRatio($dependents);
      $horizonRatio=$this->myHorizonRatio($horizon);
      $downsideRatio=$this->myDownsideRatio($downside);
      return $this->getAverage($ageRatio,$dependentsRatio,$horizonRatio,$downsideRatio);
		}


    function myAgeRatio($age)
    {
        $dobAge=$age;

        if($dobAge<35)
        {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myAgeRatio, Message : age ratio - 80:20 *****');
            return "80:20";
        }
        else if($dobAge>=35 && $dobAge<50)
        {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myAgeRatio, Message : age ratio - 60:40 *****');
            return "60:40";
        }
        else if($dobAge>=50 && $dobAge<=65)
        {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myAgeRatio, Message : age ratio - 40:60 *****');
            return "40:60";
        }
        else if($dobAge>65)
        {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myAgeRatio, Message : age ratio - 20:80 *****');
            return "20:80";
        }
    }

		function myDependentsRatio($dependents)
		{
				if($dependents==0)
				{
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myDependentsRatio, Message : dependents ratio - 80:20 *****');
						return "80:20";
				}
				else if($dependents==1)
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myDependentsRatio, Message : dependents ratio - 70:30 *****');
	          return "70:30";
	      }
	      else if($dependents==2)
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myDependentsRatio, Message : dependents ratio - 60:40 *****');
	          return "60:40";
	      }
	      else if($dependents>2)
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myDependentsRatio, Message : dependents ratio - 30:70 *****');
	          return "30:70";
	      }
		}

		function myHorizonRatio($horizon)
		{
				if($horizon=="<3yrs")
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myHorizonRatio, Message : horizon ratio - 40:60 *****');
	          return "40:60";
	      }
	      else if($horizon==">3yrs")
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myHorizonRatio, Message : horizon ratio - 80:20 *****');
	          return "80:20";
	      }
		}

		function myDownsideRatio($downside)
		{
				if($downside=="REMAIN INVESTED")
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myDownsideRatio, Message : downside ratio - 60:40 *****');
	          return "60:40";
	      }
	      else if($downside=="INVEST MORE")
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myDownsideRatio, Message : downside ratio - 80:20 *****');
	          return "80:20";
	      }
	      else if($downside=="REDEEM PARTIALLY")
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myDownsideRatio, Message : downside ratio - 40:60 *****');
	          return "40:60";
	      }
	      else if($downside=="REDEEM COMPLETELY")
	      {
						log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : myDownsideRatio, Message : downside ratio - 20:80 *****');
	          return "20:80";
	      }
		}

		function getAverage($ageRatio,$dependentsRatio,$horizonRatio,$downsideRatio)
		{
			$newAverage="";
			$count=0;
			$equity_age=0;
			$debt_age=0;
			$equity_dependent=0;
			$debt_dependent=0;
			$equity_horizon=0;
			$debt_horizon=0;
			$debt_downside=0;
			$equityAverage=0;
			$debtAverage=0;

			if(!empty($ageRatio) || $ageRatio=="0:0")
			{
					$count++;
					$age_result = explode(":", $ageRatio);
					$equity_age = intval($age_result[0]);
					$debt_age = intval($age_result[1]);
			}

			if(!empty($dependentsRatio) || $dependentsRatio=="0:0")
			{
					$count++;
					$dependent_result = explode(":", $dependentsRatio);
					$equity_dependent = intval($dependent_result[0]);
					$debt_dependent = intval($dependent_result[1]);
			}

			if(!empty($horizonRatio) || $horizonRatio=="0:0")
			{
					$count++;
					$horizon_result = explode(":", $horizonRatio);
					$equity_horizon = intval($horizon_result[0]);
					$debt_horizon = intval($horizon_result[1]);
			}

			if(!empty($downsideRatio) || $downsideRatio=="0:0")
			{
					$count++;
					$downside_result = explode(":", $downsideRatio);
					$equity_downside = intval($downside_result[0]);
					$debt_downside = intval($downside_result[1]);
			}

			$equityAverage=number_format(($equity_age+$equity_dependent+$equity_horizon+$equity_downside)/$count,2,'.','');
			$debtAverage=number_format(($debt_age+$debt_dependent+$debt_horizon+$debt_downside)/$count,2,'.','');
			$newAverage=$equityAverage.":".$debtAverage;
			// print_r($newAverage);die;
			return $newAverage;
		}

    function sendEmailForRiskProfileAgeRangeChange($age,$username,$email,$newAverage,$current_average,$existingAgeRatio,$newAgeRatio)
    {
        $today = date('M d, Y', time());
        $data["username"]=$username;
        $data["currentAverage"]=$current_average;
        $data["newAverageResult"]=$newAverage;
        $data["age"]=$age;
        $data["today"]=$today;
        $html=$this->load->view('send_risk_profile_age_change_mail_view', $data,true);
        $this->load->library("email");
        $this->email->set_newline("\r\n");
        $this->email->set_mailtype("html");
        $this->email->to($email);
				$this->email->cc("Anvesh Pandey<anvesh.pandey@investocafe.com>,<rahul.gehlot@investocafe.com>,Neha Joshi <neha.joshi@investocafe.com>");
        $this->email->bcc("explorerarchana@gmail.com");
        $this->email->from("Investocafe Assistant<info@investocafe.com>", "Investocafe");
        $this->email->subject("Your risk profile has been updated due to change in age");
        $this->email->message($html);
        $result=$this->email->send();
        //echo $this->email->print_debugger();
        return $result;
    }


    //------ Send sendSmsForRiskProfileAgeRangeChange -------//
    function sendSmsForRiskProfileAgeRangeChange($userName,$tempUserPhone)
    {
      if($tempUserPhone!="" && $userName!="")
      {
          $ch = curl_init();

          //Like us on bit.ly/eshpind----------------
          $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AhFLcgCDmJF56b081c8&mobiles=".$tempUserPhone."&message=Dear%20".$userName."%2C%0AYour%20risk%20profile%20has%20changed%20due%20to%20change%20in%20age%2C%20pls%20check%20your%20registered%20email%20for%20details%20or%20speak%20to%20our%20advisors.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4;";
          $url=str_replace(" ", "%20", $url1);
          //echo $url;
          curl_setopt($ch, CURLOPT_URL, $url);
          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

          //return the transfer as a string
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

          //$output contains the output string
          $output = curl_exec($ch);

          $dbData = array ('phone'=>$tempUserPhone,'response'=>$output);
          $this->db->insert('msg_log',$dbData);
          //close curl resource to free up system resources
          curl_close($ch);

          if ( $output === FALSE)
          {
              $output=curl_error($ch); //echoes last session error
              return false;
          }
          return $output;
      }
      else
      {
        echo "Invalid user name or phone number";
				log_message('info', '***** Controller : RiskProfileAgeCheckCron, Function : sendSmsForRiskProfileAgeRangeChange, Message : Invalid user name or phone number for send Sms For Risk Profile AgeRange Change sending sms *****');
      }
    }

		function testSIP()
		{
			$data['jsFile'] ='testSIP.js';
			$this->load->view('includes/header',$data);
			$this->load->view('testSIP_view',$data);
			$this->load->view('includes/footer',$data );
		}
}
