<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : Dashboard
|   MODEL USE : registration_model
|   DATE : 04/10/2016
|   AUTHOER : amit meena
|   COMMENT : This class is used to show dashboard and get all data on dashboard
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class Dashboard extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('dashboard/dashboard_model');
	    $this->load->model('dashboard/account_statement_model');
	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : index
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS LOAD tdashboard view
-----------------------------------------------------------------------------------------------------
*/
	public function index()
	{
		// print_r($_SESSION);die;
		
		$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {

            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {

                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("amit_theme/dashboard/dashboard_view2");
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited Dashboard page");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }
	
	public function dash()
	{
		$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadDashboardView("amit_theme/dashboard/dashboard_view2");
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited Dashboard page");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }
	
	

    
/*
-----------------------------------------------------------------------------------------------------
|   USE : checkWithdrawEligiblityTaxSaving
|   DATE : 14/12/2016
|   AUTHOER : prakash
|   COMMENT : get funds eligiblie after no. of years for withdraw
-----------------------------------------------------------------------------------------------------
*/
    public function checkWithdrawEligiblityTaxSaving($investorId,$fundsTypeId,$afterYear){
         log_message('info', '*****  Controller : Dashboard, Function : checkWithdrawEligiblityTaxSaving, Message : enter checkWithdrawEligiblityTaxSaving investor id '.$investorId.' *****');
		$taxSavingWR=$this->dashboard_model->getDataForTaxSavingWithdrawPurchaseEligiblity($investorId,$fundsTypeId);
		$arrayEligiblePurchases=array();
		if ($taxSavingWR){
			foreach($taxSavingWR as $row){            
				$withdraw_date = date('Y-m-d H:i:s', strtotime('+'.$afterYear.' year', strtotime($row->date_of_purchase)));
				$today_date=date('Y-m-d H:i:s');
				$to_time = strtotime($today_date);
				$from_time = strtotime($withdraw_date);
				$eligiblityDays=round(($from_time - $to_time) / (24*60*60),5);
				if($eligiblityDays<0){
					array_push($arrayEligiblePurchases,$row->purchased_units_id);
				}
			}
		}
            return $arrayEligiblePurchases;

    }

/*
-----------------------------------------------------------------------------------------------------
|   USE : purchaseEquity
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this fucntion load purchaseEquity view
-----------------------------------------------------------------------------------------------------
*/
    function purchaseEquity()
    {
        $this->_loadView("purchase_equity_view");
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : _loadView
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : load view function is used to load header and footer and data to load 
-----------------------------------------------------------------------------------------------------
*/
	function _loadDashboardView($view)
    {
        $userId=$_SESSION["userId"];
        $investorId=$_SESSION["investor_id"];
	    	$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
	    	if($result)
	    	{
	    		$data["profileImageUrl"]=$result->profile_image_url;
                $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
                $data["is_verify"] = $result->is_verify;
	    	}
	    	else
	    	{
	    		$data["profileImageUrl"]="";
	    	}

        // get invested fund type list which is already invested by investor
        $investedFundType=array();
        $investedRequestFundType=array();
        $resultFundType=$this->dashboard_model->getInvestedFundType($investorId);
        if(isset($resultFundType) && !empty($resultFundType))
        {
            foreach ($resultFundType as $row)
            {
                if($row->unit_count>0)
                {
                    array_push($investedFundType, $row->fund_type_id);
                }
                array_push($investedRequestFundType, $row->fund_type_id);

            }
        }

        $data['investedFundType'] =$investedFundType;
		
		   $isEligibleForTaxSavingWithdrawRes=$this->checkWithdrawEligiblityTaxSaving($investorId,3,3);// 3=tax saving, 3=no. of years
        if(!empty($isEligibleForTaxSavingWithdrawRes)){
            $data['isEligibleForTaxSavingWithdraw']=1;
        }else{
            $data['isEligibleForTaxSavingWithdraw']=0;
        }
        
		
		
		
        $data['investedRequestFundType'] =$investedRequestFundType;
        $resultStatus=$this->common_model->getInvestorStatus($investorId);
        if($resultStatus)
        {
            $data["is_kyc_done"]=$resultStatus->is_kyc_done;
            $data["is_investor_registered"]=$resultStatus->is_investor_registered;
            $data["is_investor_form_complet"]=$resultStatus->is_investor_form_complet;
            $data["is_do_not_reg_nominee"]=$resultStatus->is_do_not_reg_nominee;
            $data["is_incomplete_bank_detail"]=$resultStatus->is_incomplete_bank_detail;
			$data["reset_tem_password"]=$resultStatus->reset_tem_password;
        }

        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }

		//-----------------------------------------------------------------------
			      $userId=$_SESSION["userId"];
				$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
				if($result)
				{
					$data["profileImageUrl"]=$result->profile_image_url;
					$data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
					$data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
					$data["is_verify"]=$result->is_verify;
				}
				else
				{
					$data["profileImageUrl"]="";
				}
				$resultGoalTypeList=$this->common_model->getAllGoalTypeList();
				if($resultGoalTypeList)
				{
					$data["goalTypeList"]=$resultGoalTypeList;
				}
				
				$resultSIP = $this->dashboard_model->getMySIPModel($investorId);
				if($resultSIP)
				{
					$data['mySIP'] = $resultSIP;
				}
				else
				{
					$data['mySIP'] = "";
				} 
				$investorId=$_SESSION["investor_id"];
				$resultInvestedFundNameList=$this->account_statement_model->getInvestedFundNameList($investorId);
				$data["investedFundNameList"]=$resultInvestedFundNameList;

				$resultInvestedTaxSavingsFundList=$this->account_statement_model->getInvestedTaxSavingsFundList($investorId);
				$data["investedTaxSavingsFundList"]=$resultInvestedTaxSavingsFundList;
				

				$resultInvestedFunds=$this->account_statement_model->getAllInvestedFundsList($investorId);
				$data["investedFunds"]=$resultInvestedFunds;
				$data["taxSvngInvFunds"]=$this->account_statement_model->getInvestmentHistory(5,3,$investorId);
				// get short terms and long terms capital gains
				$data["shortTermsCostValue"]=$this->account_statement_model->calShortTermsCostValue($investorId);
				$data["shortTermsCurrentValue"]=$this->account_statement_model->calShortTermsCurrentValue($investorId);


				$data["longTermsCurrentValue"]=$this->account_statement_model->calLongTermsCurrentValue($investorId);
				$data["longTermsCostValue"]=$this->account_statement_model->calLongTermsCostValue($investorId);

				$data["longTermGain"]="";
				//$data['jsFile'] ='dashboard/accountStatement.js'
			
		//----------------------------------------------------------------------
        $data['jsFile'] ='dashboard/dashboard.js';
        $data['jsFileExtra'] ='sipCalculation/sipCalculation.js';
		$data['jsFileExtra2'] ='dashboard/accountStatement.js';
		$rowdata = $this->db->query("select users.facebook_id,users.google_id from users where id= $userId");
		$rowdata =  $rowdata->row();
		$data['facebook_id'] = $rowdata->facebook_id;
		$data['google_id'] = $rowdata->google_id;
		/* 
		echo "<pre>";
		print_r($data);
		exit; */
        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view);
        $this->load->view('amit_theme/common/footer',$data );
    }
	
	
	function _loadView($view)
    {
        $userId=$_SESSION["userId"];
        $investorId=$_SESSION["investor_id"];
	    	$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
	
	    	if($result)
	    	{
	    		$data["profileImageUrl"]=$result->profile_image_url;
                $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
                $data["is_verify"] = $result->is_verify;
				 $mother_name = $this->db->select("mother_name")->from("users")->where("id",$userId)->get()->row()->mother_name;

				if($mother_name)
				{ 
					$data["mother_name"] = $mother_name;
				}
				else
				{
					$data["mother_name"] = $result->mother_name;
				} 
				$data['investor_type_id'] = $result->investor_type_id;
				$data['pan'] = $result->pan;
	    	}
	    	else
	    	{
	    		$data["profileImageUrl"]="";
	    	}

        // get invested fund type list which is already invested by investor
        $investedFundType=array();
        $investedRequestFundType=array();
        $resultFundType=$this->dashboard_model->getInvestedFundType($investorId);
		$NAVdate = $this->db->query("select ts as date from fund_history where is_latest = 1 group by date");
		if($NAVdate->num_rows()>0)
		{
			$data['NAVdate'] = $NAVdate->row()->date;
		}
		else
		{
			$data['NAVdate'] = "";
		}
        if(isset($resultFundType) && !empty($resultFundType))
        {
            foreach ($resultFundType as $row)
            {
                if($row->unit_count>0)
                {
                    array_push($investedFundType, $row->fund_type_id);
                }
                array_push($investedRequestFundType, $row->fund_type_id);

            }
        }

        $data['investedFundType'] =$investedFundType;
		
		   $isEligibleForTaxSavingWithdrawRes=$this->checkWithdrawEligiblityTaxSaving($investorId,3,3);// 3=tax saving, 3=no. of years
        if(!empty($isEligibleForTaxSavingWithdrawRes)){
            $data['isEligibleForTaxSavingWithdraw']=1;
        }else{
            $data['isEligibleForTaxSavingWithdraw']=0;
        }
        
		
		
		
        $data['investedRequestFundType'] =$investedRequestFundType;
        $resultStatus=$this->common_model->getInvestorStatus($investorId);
        if($resultStatus)
        {
            $data["is_kyc_done"]=$resultStatus->is_kyc_done;
            $data["is_investor_registered"]=$resultStatus->is_investor_registered;
            $data["is_investor_form_complet"]=$resultStatus->is_investor_form_complet;
            $data["is_do_not_reg_nominee"]=$resultStatus->is_do_not_reg_nominee;
            $data["is_incomplete_bank_detail"]=$resultStatus->is_incomplete_bank_detail;
			$data["reset_tem_password"]=$resultStatus->reset_tem_password;
        }

        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }

		//-----------------------------------------------------------------------
			   /*  $userId=$_SESSION["userId"];
				$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
			
				if($result)
				{
					$data["profileImageUrl"]=$result->profile_image_url;
					$data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
					$data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
					$data["is_verify"]=$result->is_verify;
					$data["mother_name"] = $result->mother_name;
				}
				else
				{
					$data["profileImageUrl"]="";
				} */
				$resultGoalTypeList=$this->common_model->getAllGoalTypeList();
				if($resultGoalTypeList)
				{
					$data["goalTypeList"]=$resultGoalTypeList;
				}
				
				$resultSIP = $this->dashboard_model->getMySIPModel($investorId);
				if($resultSIP)
				{
					$data['mySIP'] = $resultSIP;
				}
				else
				{
					$data['mySIP'] = "";
				} 
				$investorId=$_SESSION["investor_id"];
				$resultInvestedFundNameList=$this->account_statement_model->getInvestedFundNameList($investorId);
				$data["investedFundNameList"]=$resultInvestedFundNameList;

				$resultInvestedTaxSavingsFundList=$this->account_statement_model->getInvestedTaxSavingsFundList($investorId);
				$data["investedTaxSavingsFundList"]=$resultInvestedTaxSavingsFundList;
				

				$resultInvestedFunds=$this->account_statement_model->getAllInvestedFundsList($investorId);
				$data["investedFunds"]=$resultInvestedFunds;
				$data["taxSvngInvFunds"]=$this->account_statement_model->getInvestmentHistory(5,3,$investorId);
				// get short terms and long terms capital gains
				$data["shortTermsCostValue"]=$this->account_statement_model->calShortTermsCostValue($investorId);
				$data["shortTermsCurrentValue"]=$this->account_statement_model->calShortTermsCurrentValue($investorId);


				$data["longTermsCurrentValue"]=$this->account_statement_model->calLongTermsCurrentValue($investorId);
				$data["longTermsCostValue"]=$this->account_statement_model->calLongTermsCostValue($investorId);

				$data["longTermGain"]="";
				//$data['jsFile'] ='dashboard/accountStatement.js'
			
		//----------------------------------------------------------------------
        $data['jsFile'] ='dashboard/dashboard2.js';
        $data['jsFileExtra'] ='sipCalculation/sipCalculation.js';
		$data['jsFileExtra2'] ='dashboard/accountStatement.js';
		/* echo "<pre>";
		print_r($data);
		exit; */
		if($investorId==12){
			// echo "<pre>";
			// print_r($data);
			// exit;
		}
        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view);
        $this->load->view('amit_theme/common/footer',$data );
    }
	
	
	
	
	
	/*
-----------------------------------------------------------------------------------------------------
|   USE : _loadViewCopy
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : load view function is used to load header and footer and data to load with goal edit page
-----------------------------------------------------------------------------------------------------
*/
	function _loadViewCopy($view,$goal_id)
    {
        $userId=$_SESSION["userId"];
        $investorId=$_SESSION["investor_id"];
	    	$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
	    	if($result)
	    	{
	    		$data["profileImageUrl"]=$result->profile_image_url;
                $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
                $data["is_verify"] = $result->is_verify;
	    	}
	    	else
	    	{
	    		$data["profileImageUrl"]="";
	    	}

			$resultGoal=$this->dashboard_model->fetchGoal($goal_id,$investorId);
			if($resultGoal){
				$data['goalDetails']=$resultGoal;
			}
			
        // get invested fund type list which is already invested by investor
        $investedFundType=array();
        $investedRequestFundType=array();
        $resultFundType=$this->dashboard_model->getInvestedFundType($investorId);
        if(isset($resultFundType) && !empty($resultFundType))
        {
            foreach ($resultFundType as $row)
            {
                if($row->unit_count>0)
                {
                    array_push($investedFundType, $row->fund_type_id);
                }
                array_push($investedRequestFundType, $row->fund_type_id);

            }
        }

        $data['investedFundType'] =$investedFundType;
        $data['investedRequestFundType'] =$investedRequestFundType;
        $resultStatus=$this->common_model->getInvestorStatus($investorId);
        if($resultStatus)
        {
            $data["is_kyc_done"]=$resultStatus->is_kyc_done;
            $data["is_investor_registered"]=$resultStatus->is_investor_registered;
            $data["is_investor_form_complet"]=$resultStatus->is_investor_form_complet;
            $data["is_do_not_reg_nominee"]=$resultStatus->is_do_not_reg_nominee;
            $data["is_incomplete_bank_detail"]=$resultStatus->is_incomplete_bank_detail;
			$data["reset_tem_password"]=$resultStatus->reset_tem_password;
        }

        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }

		//-----------------------------------------------------------------------
			      $userId=$_SESSION["userId"];
				$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
				if($result)
				{
					$data["profileImageUrl"]=$result->profile_image_url;
					$data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
					$data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
					$data["is_verify"]=$result->is_verify;
				}
				else
				{
					$data["profileImageUrl"]="";
				}
				$resultGoalTypeList=$this->common_model->getAllGoalTypeList();
				if($resultGoalTypeList)
				{
					$data["goalTypeList"]=$resultGoalTypeList;
				}

				$investorId=$_SESSION["investor_id"];
				$resultInvestedFundNameList=$this->account_statement_model->getInvestedFundNameList($investorId);
				$data["investedFundNameList"]=$resultInvestedFundNameList;

				$resultInvestedTaxSavingsFundList=$this->account_statement_model->getInvestedTaxSavingsFundList($investorId);
				$data["investedTaxSavingsFundList"]=$resultInvestedTaxSavingsFundList;

				$resultInvestedFunds=$this->account_statement_model->getAllInvestedFundsList($investorId);
				$data["investedFunds"]=$resultInvestedFunds;
				$data["taxSvngInvFunds"]=$this->account_statement_model->getInvestmentHistory(5,3,$investorId);
				// get short terms and long terms capital gains
				$data["shortTermsCostValue"]=$this->account_statement_model->calShortTermsCostValue($investorId);
				$data["shortTermsCurrentValue"]=$this->account_statement_model->calShortTermsCurrentValue($investorId);


				$data["longTermsCurrentValue"]=$this->account_statement_model->calLongTermsCurrentValue($investorId);
				$data["longTermsCostValue"]=$this->account_statement_model->calLongTermsCostValue($investorId);

				$data["longTermGain"]="";
				//$data['jsFile'] ='dashboard/accountStatement.js'
			
		//----------------------------------------------------------------------
        $data['jsFile'] ='dashboard/dashboard.js';
        $data['jsFileExtra'] ='sipCalculation/sipCalculation.js';
		$data['jsFileExtra2'] ='dashboard/accountStatement.js';
		
        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view);
        $this->load->view('amit_theme/common/footer',$data );
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : completeRegistration
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function first set investor id in session and redirect to registration page
-----------------------------------------------------------------------------------------------------
*/

    function completeRegistration()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $userId=$_SESSION["userId"];
            $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
            if($result)
            {
                $_SESSION["investor_id"]=$result->investor_id;
                $_SESSION["readyforUpdate"]=true;
				log_message('info', '*****  Controller : Dashboard, Function : completeRegistration, Message : complete Regitration user id '.$userId.' *****');
                redirect(base_url().'investorDetail');
            }
        }
        else
        {
            redirect(base_url().'login');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : sendConfirmationMail
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : if user not receive confirmation mail then this function send confirmation mail
-----------------------------------------------------------------------------------------------------
*/
    function sendConfirmationMail()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $userId=$_SESSION["userId"];
            $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
            if($result)
            {
                $invId=$result->investor_id;
                $resultInfo=$this->registration_model->getInvestorDetail($invId);
                $email=$resultInfo->email;
                $name=$resultInfo->name;
				log_message('info', '*****  Controller : Dashboard, Function : sendConfirmationMail, Message : send mail on '.$email.' *****');
                $result=sendConfirmationEmail($email,$name);
            }
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : sendConfirmationMail
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : upload user image in dashboard page
-----------------------------------------------------------------------------------------------------
*/

    public function addUploadImage()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["userId"]) && !empty($_SESSION["userId"]))
            {
                if(isset($_FILES))
                {
                    foreach($_FILES  as $key)
                    {
                        $uploadFileName = str_replace(' ', '_',date("dmyhis").$key["name"]); // assign new name
                        $originalfileName =$key["name"]; //same name
                        $type=$key["type"];
                        $size=$key["size"];
                        $tempName=$key["tmp_name"];

                        $imageFile=array('image/jpg','image/JPG','image/jpeg',
                          'image/JPEG','image/png','image/PNG',
                          'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
                          'application/pdf');

                        /******** Set path according to server******/
                        $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];

                        $pathAndName ="assets/uploads/profileImage/".$uploadFileName;


                        $allowedFileType=array('image/jpg',
                                                'image/JPG',
                                                'image/tiff',
                                                'image/jpeg',
                                                'image/TIFF',
                                                'image/png',
                                              );

                        if( in_array($type,$allowedFileType))
                        {
							
                            if(move_uploaded_file($tempName, $pathAndName))
                            {
                                $data= array(
    	                                    'profile_image_url' => $pathAndName,
    	                                    );

    	                    	$userId=$_SESSION["userId"];
								
    	                    	$result=$this->dashboard_model->updateImageUrlOnServer($userId,$data);
    	                        if($result)
    	                        {
    	                            echo '{"success":true,"userId":"'.$userId.'","path":"'.$pathAndName.'"}';
									log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : addUploadImage, Message : Successfully uploaded profile image *****');
    	                        }
    	                        else
    	                        {
    	                            echo '{"success":false,"message":"server error"}';
									log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : addUploadImage, Message : File uploaded but failed to update in database *****');
    	                        }
                            }
                            else
                            {
                                echo '{"success":false,"message":"server error"}';
								log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : addUploadImage, Message : Failed to upload the file in the required path *****');
                            }
                        }
                        else
                        {
                            echo '{"success":false}';
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : addUploadImage, Message : Failed to upload the file as invalid file type selected *****');
                        }
                    }
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : addUploadImage, Message : Failed to upload the file as Invalid or no file found *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : addUploadImage, Message : User Id not in session *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Dashboard, Function : addUploadImage, Message : Session expired while trying to upload profile picture *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : getAllInvestmentStatus
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : get all investment showing invested amount and current value
-----------------------------------------------------------------------------------------------------
*/

     function getAllInvestmentStatus()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
			
			

            $resultCurrentAmount=$this->dashboard_model->getAllInvestmentCurrentValue($investorId);
            $resultInvestedAmount=$this->dashboard_model->getAllInvestmentInvestedValue($investorId);
            $currentinvestmentamt  = $this->dashboard_model->getCurrentInvestedAmount($investorId);

			if (isset($_SESSION["rel_amnt"][$investorId])) {
				$resultCurrentAmount = $resultCurrentAmount - $_SESSION["net_amnt"][$investorId];
			}

            echo '{"success":true,"currentAmount":"'.$resultCurrentAmount.'","investedAmount":"'.$resultInvestedAmount.'","curentInv":"'.$currentinvestmentamt.'"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getAllInvestmentStatus, Message :  Displaying Invested Amount and Current Value => currentAmount : Rs.'.$resultCurrentAmount.'/- and investedAmount : Rs.'.$resultInvestedAmount.'/- *****');
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getAllInvestmentStatus, Message :  Session expired while trying to retrieve investedAmount and currentAmount *****');
        }
    }
	
	

/*
-----------------------------------------------------------------------------------------------------
|   USE : getRiskProfileData
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : get getRiskProfileData of the user
-----------------------------------------------------------------------------------------------------
*/
    function getRiskProfileData()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $email=$_SESSION["email"];
            $resultRiskProfile=$this->dashboard_model->getRiskProfileData($email);
            if($resultRiskProfile)
            {
	            $investorId=$_SESSION["investor_id"];
				$tempUsersInvestorId=$resultRiskProfile->investor_id;
				if($tempUsersInvestorId==0)
				{
					$tempUsersId=$resultRiskProfile->temp_users_id;
					$riskProfileId=$resultRiskProfile->risk_profile_id;
					$data["investor_id"]=$investorId;
				    // update investor id in risk_profile table
					$updateInvestorId = $this->dashboard_model->updateInvestorId($data,$riskProfileId,$tempUsersId);
				}
                $average = $resultRiskProfile->average;
                echo '{"success":true,"average":"'.$average.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getRiskProfileData, Message :  Successfully fetched risk profile data *****');
            }
            else
            {
                echo '{"success":false,"average":"No Data"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getRiskProfileData, Message :  No data exists to display risk profile *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Dashboard, Function : getRiskProfileData, Message :  Session expired while trying to fetch risk profile data *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : saveGoals
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to save users goal to databas
-----------------------------------------------------------------------------------------------------
*/
    function saveGoals()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $goal_type_id=$this->input->post("goal_type_id");
            $amount=$this->input->post("amount");
            $timeline=$this->input->post("timeline");
            $monthly_saving_amount=$this->input->post("monthly_saving_amount");
            $data["investor_id"]=$investorId;
            $data["goal_type_id"]=$goal_type_id;
            $data["goal_timeline"]=$timeline;
            $data["goal_amount"]=$amount;
            $data["monthly_saving_amount"]=$monthly_saving_amount;
            $saveGoalResult=$this->dashboard_model->saveGoal($investorId,$data);
            if($saveGoalResult)
            {
                echo '{"success":true,"response":"Saved goal details"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : saveGoals, Message : Successfully saved the goals *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : saveGoals, Message : Failed to save the goals *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Dashboard, Function : saveGoals, Message : Session expired while trying to save the goals *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : fetchGoals
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to fetch goal from data base and show to user
-----------------------------------------------------------------------------------------------------
*/
    function fetchGoals()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $fetchGoalsResult=$this->dashboard_model->fetchGoals($investorId);
            if($fetchGoalsResult)
            {
                $rowStr="";
                $totalAmount=0;
                foreach($fetchGoalsResult as $fetchGoalsRow)
                {
					$goal_id=$fetchGoalsRow->goal_id;
                    $date=new datetime($fetchGoalsRow->ts);
                    $goalCreateDate=$date->format("d/m/Y");
                    $amount=$fetchGoalsRow->goal_amount;
					$monthly_saving_amount = $fetchGoalsRow->monthly_saving_amount;
                    $title=$fetchGoalsRow->goal_title;
                    $totalAmount = $totalAmount + $amount;
                    $rowStr .= '['.$goal_id.',"'.$title.'","'.$goalCreateDate.'",'.$monthly_saving_amount.','.$amount.'],';
                }

                echo '{"success":true,"totalAmount":"'.$totalAmount.'","data":['.rtrim($rowStr, ',').']}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : fetchGoals, Message : Successfully fetched the list of goals *****');
            }
            else
            {
                echo '{"success":false,"response":"No Data"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : fetchGoals, Message : No data present to display the list of goals ****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : fetchGoals, Message : Session expired while fetching the list of goals *****');
        }
    }
	
	
	/*
-----------------------------------------------------------------------------------------------------
|   USE : editGoal
|   DATE : 08/11/2016
|   AUTHOER : prakash
|   COMMENT : this function is used to update goal
-----------------------------------------------------------------------------------------------------
*/
  public function editGoal($goal_id)
	{
		$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadViewCopy("amit_theme/dashboard/edit_goal_view",$goal_id);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited Dashboard page");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

	
	/*
-----------------------------------------------------------------------------------------------------
|   USE : updateGoal
|   DATE : 08/11/2016
|   AUTHOER : prakash
|   COMMENT : this function is used to update goal
-----------------------------------------------------------------------------------------------------
*/
    function updateGoal()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
			
			echo 'goal_amount'.$this->input->post('goal_amount');
			//echo 'monthly_saving_amount'.$this->input->post('monthly_saving_amount');
	/* 		$goal_id=$this->input->post('goal_id');
			$goal_amount=$this->input->post('goal_amount');
			$monthly_saving_amount=$this->input->post('monthly_saving_amount'); */
			/* if($this->dashboard_model->updateGoal($goal_id,$monthly_saving_amount,$goal_amount)){
				redirect(base_url().'dashboard');
				
			}else{
				redirect(base_url().'dashboard');
			} */
			
		}
		
	}	
	
	/*
-----------------------------------------------------------------------------------------------------
|   USE : deleteGoal
|   DATE : 08/11/2016
|   AUTHOER : prakash
|   COMMENT : this function is used to delete goal
-----------------------------------------------------------------------------------------------------
*/
    function deleteGoal($goal_id)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
			
			if($this->dashboard_model->deleteGoal($goal_id))
			{
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : deleteGoal, Message : successfully delete goal *****');
				echo '{"success":true}';
			}
			else
			{
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : deleteGoal, Message : problem to delete goal *****');
				echo '{"success":false}';
			}
			
		}
		
	}	
/*
-----------------------------------------------------------------------------------------------------
|   USE : getPresentValue
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to getPresentValue of the user
-----------------------------------------------------------------------------------------------------
*/
    function getPresentValue()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $resultCurrentAmount=$this->dashboard_model->getAllInvestmentCurrentValue($investorId);
            echo '{"success":true,"currentAmount":"'.$resultCurrentAmount.'"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPresentValue, Message : Fetched current value => currentAmount : '. $resultCurrentAmount.' *****');
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPresentValue, Message : Session expired while fetching the current value *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : insertNifty
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : 
-----------------------------------------------------------------------------------------------------
*/
    function insertNifty()
    {
        $array = $this->input->post("lines");
        foreach ($array as $arr) {
            $date=$arr[0];
            $dateExplode=explode(":", $date);
            $newDate=new DateTime($dateExplode[1]);
            $td=date('Y-m-d',strtotime($dateExplode[1]));
            $open=explode(":", $arr[2]);
            $high=explode(":", $arr[3]);
            $low=explode(":", $arr[4]);
            $close=explode(":", $arr[5]);
            $quantity=explode(":", $arr[6]);
            $average=explode(":", $arr[7]);
            $data["date"]=$td;
            $data["open"]=$open[1];
            $data["high"]=$high[1];
            $data["low"]=$low[1];
            $data["close"]=$close[1];
            $data["volume"]=$quantity[1];
            $resultNiftyInsert=$this->dashboard_model->insertNifty($data);
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : getPortfolioReturn_BenchmarkNiftyReturn_LineChart
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : 
-----------------------------------------------------------------------------------------------------
*/
    function getPortfolioReturn_BenchmarkNiftyReturn_LineChart()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $rowSumNav="";
            $rowNifty="";
            $rowOpen="";
            $investmentReadyDate="";
            $isReadyForInvestmentResult=$this->dashboard_model->getReadyDateForInvestment($investorId);
            if($isReadyForInvestmentResult )
            {
                if($isReadyForInvestmentResult->is_ready_for_investment_date=="0000-00-00 00:00:00")
                {
					$investmentReadyDate = "0000-00-00";
					$resultNiftyReturns=$this->dashboard_model->getNiftyData($investmentReadyDate);

					if($resultNiftyReturns)
					{
							foreach($resultNiftyReturns as $row)
							{
									$date=$row->date;
									$dateExplode=explode("-", $date);
									$dateYear=$dateExplode[0];
									$dateMonth=$dateExplode[1]-1;
									$dateDay=$dateExplode[2];
									$date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
									$open=$row->open;
									$rowOpen .= '['.$date.','.$open.'],';
							}
					}

					echo '{"success":true,"status":"only nifty","open":['.rtrim($rowOpen, ',').']}';
					// log_message('info', '***** successfully fetched sum of nav per day for the logged in investor and also nifty data *****');
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPortfolioReturn_BenchmarkNiftyReturn_LineChart, Message : Successfully fetched sum of NAV per day for the logged in investor and also nifty data *****');
                }
                else
                {
                    $readyForInvestmentDate=$isReadyForInvestmentResult->is_ready_for_investment_date;
                    $dateExplode=explode(" ", $readyForInvestmentDate);
                    $investmentReadyDate=$dateExplode[0];
                    $resultPortfolioReturns=$this->dashboard_model->getPortfolio_return($investorId);
                    if($resultPortfolioReturns)
                    {
                        foreach($resultPortfolioReturns as $row)
                        {
                            $date=$row->date;
                            $dateExplode=explode("-", $date);
                            $dateYear=$dateExplode[0];
                            $dateMonth=$dateExplode[1]-1;
                            $dateDay=$dateExplode[2];
                            $date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
                            $sum_nav=$row->sum_nav;
                            $rowSumNav .= '['.$date.','.$sum_nav.'],';
                        }
                    }

                    $resultNiftyReturns=$this->dashboard_model->getNiftyData($investmentReadyDate);

                    if($resultNiftyReturns)
                    {
                        foreach($resultNiftyReturns as $row)
                        {
                            $date=$row->date;
                            $dateExplode=explode("-", $date);
                            $dateYear=$dateExplode[0];
                            $dateMonth=$dateExplode[1]-1;
                            $dateDay=$dateExplode[2];
                            $date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
                            $open=$row->open;
                            $rowOpen .= '['.$date.','.$open.'],';
                        }
                    }

                    echo '{"success":true,"status":"both nifty and sumNav","sumNav":['.rtrim($rowSumNav, ',').'],"open":['.rtrim($rowOpen, ',').']}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPortfolioReturn_BenchmarkNiftyReturn_LineChart, Message : Successfully fetched sum of NAV per day for the logged in investor and also nifty data *****');
                }

            }
            else
            {
                echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPortfolioReturn_BenchmarkNiftyReturn_LineChart, Message : No data present in database to display getPortfolioReturn_BenchmarkNiftyReturn_LineChart *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Dashboard, Function : getPortfolioReturn_BenchmarkNiftyReturn_LineChart, Message : Session expired while fetching the getPortfolioReturn_BenchmarkNiftyReturn_LineChart details *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : getRequiredPortfolioReturn_BenchmarkNiftyReturn_LineChart
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : 
-----------------------------------------------------------------------------------------------------
*/
    function getRequiredPortfolioReturn_BenchmarkNiftyReturn_LineChart()
    {
        $fromDate=$this->input->post("from");
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $rowSumNav="";
            $rowNifty="";
            $rowOpen="";
            $investmentReadyDate="";
            $isReadyForInvestmentResult=$this->dashboard_model->getReadyDateForInvestment($investorId);
            if($isReadyForInvestmentResult )
            {
                if($isReadyForInvestmentResult->is_ready_for_investment_date=="0000-00-00 00:00:00")
                {
    				$investmentReadyDate = $fromDate;
    				$resultNiftyReturns=$this->dashboard_model->getNiftyData($investmentReadyDate);

    				if($resultNiftyReturns)
    				{
    						foreach($resultNiftyReturns as $row)
    						{
    								$date=$row->date;
    								$dateExplode=explode("-", $date);
    								$dateYear=$dateExplode[0];
    								$dateMonth=$dateExplode[1]-1;
    								$dateDay=$dateExplode[2];
    								$date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
    								$open=$row->open;
    								$rowOpen .= '['.$date.','.$open.'],';
    						}
    				}

    				echo '{"success":true,"status":"only nifty","open":['.rtrim($rowOpen, ',').']}';
    				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getRequiredPortfolioReturn_BenchmarkNiftyReturn_LineChart, Message : Successfully fetched sum of NAV per day for the logged in investor and also nifty data  *****');
                }
                else
                {
                    $resultPortfolioReturns=$this->dashboard_model->getRequiredPortfolio_return($investorId,$fromDate);
                    if($resultPortfolioReturns)
                    {
                        foreach($resultPortfolioReturns as $row)
                        {
                            $date=$row->date;
                            $dateExplode=explode("-", $date);
                            $dateYear=$dateExplode[0];
                            $dateMonth=$dateExplode[1]-1;
                            $dateDay=$dateExplode[2];
                            $date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
                            $sum_nav=$row->sum_nav;
                            $rowSumNav .= '['.$date.','.$sum_nav.'],';
                        }
                    }

                    $resultNiftyReturns=$this->dashboard_model->getNiftyData($fromDate);

                    if($resultNiftyReturns)
                    {
                        foreach($resultNiftyReturns as $row)
                        {
                            $date=$row->date;
                            $dateExplode=explode("-", $date);
                            $dateYear=$dateExplode[0];
                            $dateMonth=$dateExplode[1]-1;
                            $dateDay=$dateExplode[2];
                            $date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
                            $open=$row->open;
                            $rowOpen .= '['.$date.','.$open.'],';
                        }
                    }

                    echo '{"success":true,"sumNav":['.rtrim($rowSumNav, ',').'],"open":['.rtrim($rowOpen, ',').']}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getRequiredPortfolioReturn_BenchmarkNiftyReturn_LineChart, Message : Successfully fetched sum of NAV per day for the logged in investor and also nifty data  *****');
                }

            }
            else
            {
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getRequiredPortfolioReturn_BenchmarkNiftyReturn_LineChart, Message : Investor is not yet ready for investment  *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller : Dashboard, Function : getRequiredPortfolioReturn_BenchmarkNiftyReturn_LineChart, Message : Session expired while trying to fetch the data for getRequiredPortfolioReturn_BenchmarkNiftyReturn_LineChart *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : getPortfolioReturn_aspiredTarget_lineChart
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : 
-----------------------------------------------------------------------------------------------------
*/
    function getPortfolioReturn_aspiredTarget_lineChart()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $rowSumNav="";
            $rowGoalsAmount="";
			$rowOpen="";
            $investmentReadyDate="";
            $isReadyForInvestmentResult=$this->dashboard_model->getReadyDateForInvestment($investorId);
            if($isReadyForInvestmentResult )
            {
                if($isReadyForInvestmentResult->is_ready_for_investment_date=="0000-00-00 00:00:00")
                {
					$investmentReadyDate = "0000-00-00";
					$resultNiftyReturns=$this->dashboard_model->getNiftyData($investmentReadyDate);

					if($resultNiftyReturns)
					{
							foreach($resultNiftyReturns as $row)
							{
									$date=$row->date;
									$dateExplode=explode("-", $date);
									$dateYear=$dateExplode[0];
									$dateMonth=$dateExplode[1]-1;
									$dateDay=$dateExplode[2];
									$date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
									$open=$row->open;
									$rowOpen .= '['.$date.','.$open.'],';
							}
					}

					echo '{"success":true,"status":"only nifty","open":['.rtrim($rowOpen, ',').']}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPortfolioReturn_aspiredTarget_lineChart, Message : Successfully fetched sum of NAV per day for the logged in investor and also nifty data *****');
                }
                else
                {
                    $readyForInvestmentDate=$isReadyForInvestmentResult->is_ready_for_investment_date;
                    $dateExplode=explode(" ", $readyForInvestmentDate);
                    $investmentReadyDate=$dateExplode[0];
                    $resultPortfolioReturns=$this->dashboard_model->getPortfolio_return($investorId);
                    if($resultPortfolioReturns)
                    {
                        foreach($resultPortfolioReturns as $row)
                        {
                            $date=$row->date;
                            $dateExplode=explode("-", $date);
                            $dateYear=$dateExplode[0];
                            $dateMonth=$dateExplode[1]-1;
                            $dateDay=$dateExplode[2];
                            $date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
                            $sum_nav=$row->sum_nav;
                            $rowSumNav .= '['.$date.','.$sum_nav.'],';

                            $resultGoals=$this->dashboard_model->totalGoalsTarget($investorId);
                            if($resultGoals)
                            {
                                $totalGoalAmount=$resultGoals->goal_amount;
								if(is_null($totalGoalAmount))
								{

								}
								else
								{
									$rowGoalsAmount .= '['.$date.','.$totalGoalAmount.'],';
								}
                            }
                        }
                    }

					$resultNiftyReturns=$this->dashboard_model->getNiftyData($investmentReadyDate);

					if($resultNiftyReturns)
					{
						foreach($resultNiftyReturns as $row)
						{
							$date=$row->date;
							$dateExplode=explode("-", $date);
							$dateYear=$dateExplode[0];
							$dateMonth=$dateExplode[1]-1;
							$dateDay=$dateExplode[2];
							$date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
							$open=$row->open;
							$rowOpen .= '['.$date.','.$open.'],';
						}
					}
                    echo '{"success":true,"sumNav":['.rtrim($rowSumNav, ',').'],"open":['.rtrim($rowOpen, ',').'],"goals":['.rtrim($rowGoalsAmount, ',').']}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPortfolioReturn_aspiredTarget_lineChart, Message : Successfully fetched sum of NAV per day for the logged in investor and also total goals data *****');
                }
            }
            else
            {
                echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPortfolioReturn_aspiredTarget_lineChart, Message : No Data exists in database to display getPortfolioReturn_aspiredTarget_lineChart *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getPortfolioReturn_aspiredTarget_lineChart, Message : Session expired while trying to fetch the data for getPortfolioReturn_aspiredTarget_lineChart *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : showGoalCalculationByGoalTypeId
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : 
-----------------------------------------------------------------------------------------------------
*/
    function showGoalCalculationByGoalTypeId()
    {
        $goalTypeId=$this->input->post("goalTypeId");
        if($goalTypeId==8)
        {
            echo $this->load->view("modal_my_monthly_sip_view");
        }
        else if($goalTypeId==1)
        {
            echo $this->load->view("modal_education_cal_view");
        }
        else if($goalTypeId==2)
        {
            echo $this->load->view("modal_marriage_cal_view");
        }
        else if($goalTypeId==3)
        {
            echo $this->load->view("modal_retirement_cal_view");
        }
        else if($goalTypeId==9)
        {
            echo $this->load->view("modal_return_on_my_sip_cal_view");
        }
        else if($goalTypeId==10)
        {
            echo $this->load->view("modal_step_up_sip_cal_view");
        } 
		else if($goalTypeId==6)
        {
            echo $this->load->view("modal_my_tax_saving_view");
        }
        else
        {
            echo $this->load->view("modal_add_other_type_goal_view");
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : getRequiredPortfolioReturn_aspiredTarget_lineChart
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : 
-----------------------------------------------------------------------------------------------------
*/
		function getRequiredPortfolioReturn_aspiredTarget_lineChart()
		{
			$fromDate=$this->input->post("from");
			$logged=$this->ion_auth->logged_in();
			if(checkuser_session())
			{
					$investorId=$_SESSION["investor_id"];
					$rowSumNav="";
					$rowGoalsAmount="";
					$rowOpen="";
					$investmentReadyDate="";
					$isReadyForInvestmentResult=$this->dashboard_model->getReadyDateForInvestment($investorId);
					if($isReadyForInvestmentResult )
					{
						if($isReadyForInvestmentResult->is_ready_for_investment_date=="0000-00-00 00:00:00")
						{
							$investmentReadyDate = $fromDate;
							$resultNiftyReturns=$this->dashboard_model->getNiftyData($investmentReadyDate);

							if($resultNiftyReturns)
							{
								foreach($resultNiftyReturns as $row)
								{
									$date=$row->date;
									$dateExplode=explode("-", $date);
									$dateYear=$dateExplode[0];
									$dateMonth=$dateExplode[1]-1;
									$dateDay=$dateExplode[2];
									$date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
									$open=$row->open;
									$rowOpen .= '['.$date.','.$open.'],';
								}
							}

							echo '{"success":true,"status":"only nifty","open":['.rtrim($rowOpen, ',').']}';
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getRequiredPortfolioReturn_aspiredTarget_lineChart, Message : Successfully fetched sum of NAV per day for the logged in investor and also nifty data *****');
						}
						else
						{
							$readyForInvestmentDate=$isReadyForInvestmentResult->is_ready_for_investment_date;
							$dateExplode=explode(" ", $readyForInvestmentDate);
							$investmentReadyDate=$dateExplode[0];
							$resultPortfolioReturns=$this->dashboard_model->getRequiredPortfolio_return($investorId,$fromDate);
							if($resultPortfolioReturns)
							{
									foreach($resultPortfolioReturns as $row)
									{
											$date=$row->date;
											$dateExplode=explode("-", $date);
											$dateYear=$dateExplode[0];
											$dateMonth=$dateExplode[1]-1;
											$dateDay=$dateExplode[2];
											$date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
											$sum_nav=$row->sum_nav;
											$rowSumNav .= '['.$date.','.$sum_nav.'],';

											$resultGoals=$this->dashboard_model->totalGoalsTarget($investorId);
											if($resultGoals)
											{
													$totalGoalAmount=$resultGoals->goal_amount;
													$rowGoalsAmount .= '['.$date.','.$totalGoalAmount.'],';
											}
									}
							}

							$resultNiftyReturns=$this->dashboard_model->getNiftyData($fromDate);

							if($resultNiftyReturns)
							{
									foreach($resultNiftyReturns as $row)
									{
											$date=$row->date;
											$dateExplode=explode("-", $date);
											$dateYear=$dateExplode[0];
											$dateMonth=$dateExplode[1]-1;
											$dateDay=$dateExplode[2];
											$date="Date.UTC(".$dateYear.",".$dateMonth.",".$dateDay.")";
											$open=$row->open;
											$rowOpen .= '['.$date.','.$open.'],';
									}
							}
							echo '{"success":true,"sumNav":['.rtrim($rowSumNav, ',').'],"open":['.rtrim($rowOpen, ',').'],"goals":['.rtrim($rowGoalsAmount, ',').']}';
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getRequiredPortfolioReturn_aspiredTarget_lineChart, Message : Successfully fetched sum of NAV per day for the logged in investor and also total goals data *****');
						}
                    }
					else
					{
						echo '{"success":false}';
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getRequiredPortfolioReturn_aspiredTarget_lineChart, Message : No data exists in database to display getPortfolioReturn_aspiredTarget_lineChart *****');
					}
			}
			else
			{
				echo '{"success":false,"session":"out"}';
				log_message('info', '***** Controller : Dashboard, Function : getRequiredPortfolioReturn_aspiredTarget_lineChart, Message : Session expired while trying to fetch the data for getRequiredPortfolioReturn_aspiredTarget_lineChart *****');
			}
		}
/*
-----------------------------------------------------------------------------------------------------
|   USE : getSipListCountByFundTypeId
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : 
-----------------------------------------------------------------------------------------------------
*/
		function getSipListCountByFundTypeId()
		{
			$logged=$this->ion_auth->logged_in();
			if(checkuser_session())
			{
				$fundTypeId=$this->input->post("fundTypeId");
				$investorId=$_SESSION["investor_id"];
				$getSipListCountResult=$this->dashboard_model->getSipListCountByFundTypeId($fundTypeId,$investorId);
				if($getSipListCountResult->count>0)
				{
					echo '{"success":true,"fundTypeId":'.$fundTypeId.'}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getSipListCountByFundTypeId, Message : sip exists for the investor id : '.$investorId.' *****');
				}
				else
				{
					echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : getSipListCountByFundTypeId, Message : sip does not exist for the investor id : '.$investorId.' *****');
				}
			}
			else
			{
				echo '{"success":false,"session":"out"}';
				log_message('info', '***** Controller : Dashboard, Function : getSipListCountByFundTypeId, Message : Session expired while trying to fetch getSipListCountByFundTypeId data *****');
			}
		}

        // public function getCurentInvValue()
        // {
        //     $inv_id 
        //     $res = $this->dashboard_model->getCurrentInvestedAmount($inv_id);
        //     echo $res;
        // }

        public function checkPosition()
        {
            $investorId = $_SESSION["investor_id"];
            $resultStatus=$this->common_model->getInvestorStatus($investorId);
            if($resultStatus->is_investor_registered == 0)
            {
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : checkPosition, Message : redirct to registration *****');
                $_SESSION["readyforUpdate"] = true;
                redirect('registration');
            }
            elseif($resultStatus->is_investor_form_complet == 0)
            {
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : checkPosition, Message : redirct to investorDetail *****');
                return redirect('investorDetail');
            }
            else
            {
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Dashboard, Function : checkPosition, Message : redirct to AddBankAndNominiDatail *****');
                return redirect('AddBankAndNominiDatail');
            }

            
        }
		
		
    function updateCurrentUserLoginIdPassword()
    {
    	$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
	    	$currentPassword=$this->input->post("currentPasswordCollapseTwo");
	    	$password=$this->input->post("newPasswordCollapseTwo");

	    	$userId=$_SESSION["userId"];
	    	$data = array(
							'password' => $password,
						 );
			$result=$this->ion_auth->update($userId, $data);
			if($result)
			{
				echo '{"success":true}';
				$message="Successfully updated user password";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : '.$message.' *****');
				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
    			addSystemLog($data); // helper function
			}
			else
			{
				echo '{"success":false}';
    			$message="Failed to update user password";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : '.$message.' *****');
    			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
        		addSystemLog($data); // helper function
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : Session expired while updating user password *****');
		}
    }
	
	
	/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : updateCurrentUserLoginIdPassword
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT :  Update logged in user id and password
-----------------------------------------------------------------------------------------------------
*/
    function firstPasswordChange()
    {
    	$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
	    	$currentPassword=$this->input->post("currentPasswordCollapseTwo");
	    	$password=$this->input->post("newPasswordCollapseTwo");

	    	$userId=$_SESSION["userId"];
	    	$data = array(
							'password' => $password,
						 );
			$result=$this->ion_auth->update($userId, $data);
			if($result)
			{
				echo '{"success":true}';
				$message="Successfully updated user password";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : '.$message.' *****');
				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
    			addSystemLog($data); // helper function
				$investorId = $_SESSION["investor_id"];
				$this->statusesetnew($investorId);
			}
			else
			{
				echo '{"success":false}';
    			$message="Failed to update user password";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : '.$message.' *****');
    			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
        		addSystemLog($data); // helper function
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : Session expired while updating user password *****');
		}
    }
	
	function statusesetnew($investorId)
    {
         $data=array(
                    "reset_tem_password" => 1 ,
                   );
		$this->load->model('registration/registration_model','registration_model');
        $result=$this->registration_model->updateInvestorStatusSecontRegitration($investorId ,$data);

		log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : addInvestorStatus, Message : Successfully added investor status *****');
    }
	

	
	
	
	
	

	        /*

-----------------------------------------------------------------------------------------------------

|   USE : appDashboardView

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : load view function is used to load header and footer and data to load 

-----------------------------------------------------------------------------------------------------

*/

    function appDashboardView()
    {

        $get = json_decode(file_get_contents("php://input"));
		$userId=$get->userId;

        $investorId=$get->investorId;
			$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);

			$this->load->model('registration/registration_model','registration_model');
			$resultBank=$this->registration_model->getInvestorBankAndPanDetail($investorId);
			if($resultBank)
			{
				 $data['bank_name'] = $resultBank->bank_name;
				  $bankAccountNumber = $this->encrypt->decode($resultBank->account_number);
				  $data['account_number'] = "XXXXXXXXX".substr($bankAccountNumber , -4);
				  $stop_date = date("Y-m-d");
				  $data['afterTwoDateDate'] = date('M d,Y', strtotime($stop_date . ' +2 day'));
			}
			if($result)
			{
				if (strpos($result->profile_image_url, 'facebook') || strpos($result->profile_image_url, 'googleusercontent'))
				{
					 $data["profileImageUrl"]=$result->profile_image_url;
				}
				else
				{
					$data["profileImageUrl"]=base_url().$result->profile_image_url;
				}
				
				$mother_name = $this->db->select("mother_name")->from("users")->where("id",$userId)->get()->row()->mother_name;

				if($mother_name)
				{ 
					$data["mother_name"] = $mother_name;
				}
				else
				{
					if($result->mother_name)
					{
						$data["mother_name"] = $result->mother_name;
					}
					else
					{
						$data["mother_name"] = "";
					}
				}
                
                $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
				$data["investor_pdf_form_url"]=base_url()."assets/uploads/investor_form_pdf/".$result->investor_pdf_form_url;
                $data["fatca_verify"]=$result->fatca_verify;
                $data["is_verify"] = $result->is_verify;

            }
            else
            {
                $data["profileImageUrl"]="";
            }
		
        // gt invested fund type list which is already invested by investor
        $investedFundType=array();
        $investedRequestFundType=array();
        $resultFundType=$this->dashboard_model->getInvestedFundType($investorId);
        if(isset($resultFundType) && !empty($resultFundType))
        {
            foreach ($resultFundType as $row)
            {
                if($row->unit_count>0)
                {
                    array_push($investedFundType, $row->fund_type_id);
                }
                array_push($investedRequestFundType, $row->fund_type_id);
                if($row->fund_type_id==3){
                     $isEligibleForTaxSavingWithdrawRes=$this->checkWithdrawEligiblityTaxSaving($investorId,3,3);// 3=tax saving, 3=no. of years
                        if(!empty($isEligibleForTaxSavingWithdrawRes)){
                            $data['isEligibleForTaxSavingWithdraw']=1;
                        }else{
                            $data['isEligibleForTaxSavingWithdraw']=0;
                        }
                }
            }

        }

	   /*  $cancelChequeUrlRes=$this->dashboard_model->getcancelChequeUrl($investorId);
		if($cancelChequeUrlRes){
		$data["cancelChequeUrl"]=$cancelChequeUrlRes->url;	
		}else{
		$data["cancelChequeUrl"]="";
		} */
        $data['investedFundType'] =$investedFundType;
        $data['investedRequestFundType'] =$investedRequestFundType;
        $resultStatus=$this->common_model->getInvestorStatus($investorId);
        if($resultStatus)
        {
			$data["is_nach_enabled"]=$resultStatus->is_nach_enabled;
			$data["is_mandate_received"]=$resultStatus->is_mandate_received;
            $data["is_kyc_done"]=$resultStatus->is_kyc_done;
            $data["is_investor_registered"]=$resultStatus->is_investor_registered;
            $data["is_investor_form_complet"]=$resultStatus->is_investor_form_complet;
            $data["is_do_not_reg_nominee"]=$resultStatus->is_do_not_reg_nominee;
            $data["is_incomplete_bank_detail"]=$resultStatus->is_incomplete_bank_detail;
			$data['user_registration_date'] = $resultStatus->is_investor_registered_date;
        }
	
		$document_check_list = $this->db->query("select * from investor_document_type where investor_id =$investorId");
		$document_check_list =  $document_check_list->result();
		foreach($document_check_list as $document_check_list)
		{
			if($document_check_list->document_type_id == 7)
			{
				$data["panCardUrl"]= $document_check_list->url;
			}
			if($document_check_list->document_type_id == 4)
			{
				$data["cancelChequeUrl"]= $document_check_list->url;
			}
			
			if($document_check_list->document_type_id ==50)
			{
				$data["investorFormPDF"]= $document_check_list->url;
			}
			if($document_check_list->document_type_id ==20)
			{
				$data["aadharFormPDF"]= $document_check_list->url;
			}

			if($document_check_list->document_type_id ==6)
			{
				$data["addressProof"]= $document_check_list->url;
			}
		}
		
        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }
        $out = json_encode($data);
		log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appDashboardView, Message : load data : '.$out.' *****');
        echo $out;
    }

/*

---------------------------------------------------------------------------------------------

|	FUNCTION NAME : appGetAllInvestmentStatus

|	DATE : 25/10/2016

|	AUTHOR : AMIT MEENA

|	COMMENT : THIS FUNCTION IS USE TO FET VALES OF INVESTMENT 

---------------------------------------------------------------------------------------------

*/

	function appShowAllSip()
	{
		$get = json_decode(file_get_contents("php://input"));
		$investorId=$get->investorId;
		$resultSIP = $this->dashboard_model->getMySIPModel($investorId);
		if($resultSIP)
		{
			// $resultSIP['is_sip_skip_active'] = 1;
			$data = json_encode($resultSIP);
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appShowAllSip, Message : load data : '.$data.' *****');
			echo '{"success":"true", "is_sip_skip_active":1, "data":'.$data.'}';
		}
		else
		{
			$data = json_encode($resultSIP);
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appShowAllSip, Message : load data failed *****');
			echo '{"success":"false"}';
		}
	}


	function appANDROIDShowAllSip()
	{
		$get = json_decode(file_get_contents("php://input"));
		$investorId=$get->investorId;
		$resultSIP = $this->dashboard_model->getMySIPModel($investorId);
		if($resultSIP)
		{
			$resultSIP['is_sip_skip_active'] = 1;
			$data = json_encode($resultSIP);
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appShowAllSip, Message : load data : '.$data.' *****');
			echo '{"success":"true","data":['.$data.']}';
		}
		else
		{
			$data = json_encode($resultSIP);
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appShowAllSip, Message : load data failed *****');
			echo '{"success":"false"}';
		}
	}



	function appGetAllInvestmentStatus()
	{
		$get = json_decode(file_get_contents("php://input"));
		$investorId=$get->investorId;
        if($investorId)
        {
            $resultCurrentAmount=$this->dashboard_model->getAllInvestmentCurrentValue($investorId);
            $resultInvestedAmount=$this->dashboard_model->getAllInvestmentInvestedValue($investorId);
            $currentinvestmentamt  = $this->dashboard_model->getCurrentInvestedAmount($investorId);
            echo '{"success":"true","currentAmount":"'.round($resultCurrentAmount).'","investedAmount":"'.round($resultInvestedAmount).'","curentInv":"'.$currentinvestmentamt.'"}';
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : getAllInvestmentStatus, Message :  Displaying Invested Amount and Current Value => currentAmount : Rs.'.$resultCurrentAmount.'/- and investedAmount : Rs.'.$resultInvestedAmount.'/- *****');
        }
        else
        {
            echo '{"success":"false","session":"out"}';
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : getAllInvestmentStatus, Message :  Session expired while trying to retrieve investedAmount and currentAmount *****');

        }

    }

	

/*

-----------------------------------------------------------------------------------------------------

|   USE : getRiskProfileData

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : get getRiskProfileData of the user

-----------------------------------------------------------------------------------------------------

*/

    function appGetetRiskProfileData()
    {
			$get = json_decode(file_get_contents("php://input"));
            $email= $get->email;
            $resultRiskProfile=$this->dashboard_model->getRiskProfileData($email);
            if($resultRiskProfile)
            {
	            $investorId=$get->investorId;
				$tempUsersInvestorId=$resultRiskProfile->investor_id;
				if($tempUsersInvestorId==0)
				{
					$tempUsersId=$resultRiskProfile->temp_users_id;
					$riskProfileId=$resultRiskProfile->risk_profile_id;
					$data["investor_id"]=$investorId;
				    // update investor id in risk_profile table
					$updateInvestorId = $this->dashboard_model->updateInvestorId($data,$riskProfileId,$tempUsersId);
				}
                $average = $resultRiskProfile->average;
                echo '{"success":"true","average":"'.$average.'"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : getRiskProfileData, Message :  Successfully fetched risk profile data *****');
            }
            else
            {
                echo '{"success":"false","average":"No Data"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : getRiskProfileData, Message :  No data exists to display risk profile *****');
            }
    }


/*

-----------------------------------------------------------------------------------------------------
|   USE : fetchGoals
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to fetch goal from data base and show to user
-----------------------------------------------------------------------------------------------------
*/

    function appFetchGoals()
    {
			$get = json_decode(file_get_contents("php://input"));
            $investorId = $get->investorId;
            $fetchGoalsResult=$this->dashboard_model->fetchGoals($investorId);
            if($fetchGoalsResult)
            {
                $rowStr="";
                $totalAmount=0;
                foreach($fetchGoalsResult as $fetchGoalsRow)
                {
                    $date=new datetime($fetchGoalsRow->ts);
                    $goalCreateDate=$date->format("d/m/Y");
                    $monthly_saving_amount = $fetchGoalsRow->monthly_saving_amount;
                    $amount=$fetchGoalsRow->goal_amount;
                    $title=$fetchGoalsRow->goal_title;
					$goalId = $fetchGoalsRow->goal_id;
                    $totalAmount = $totalAmount + $amount;
                    $rowStr .= '{"title":"'.$title.'","goalCreateDate":"'.$goalCreateDate.'","monthly_saving_amount":"'.$monthly_saving_amount.'","amount":"'.$amount.'","Id":"'.$goalId.'"},';
                }

                echo '{"success":"true","totalAmount":"'.$totalAmount.'","data":['.rtrim($rowStr, ',').']}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : fetchGoals, Message : Successfully fetched the list of goals *****');
            }
            else
            {
                echo '{"success":"false","response":"No Data"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : fetchGoals, Message : No data present to display the list of goals ****');
            }
      
    }

/*
-----------------------------------------------------------------------------------------------------
|   USE : appAddUploadImage
|   DATE : 25/11/2016
|   AUTHOER : prakash
|   COMMENT : upload user image in dashboard page
-----------------------------------------------------------------------------------------------------
*/

    public function appAddUploadImage()
    {
		$investorId=$this->input->post('investorId');
		$userId=$this->input->post('userId');
		if($investorId && $userId)
        {
			$investorId =trim($investorId);
            $info = new SplFileInfo($_FILES["myfile0"]["name"]);
            $fileExt=strtolower($info->getExtension());
            $uploadFileName = "".$investorId."_4_".date("dmyhis").".".$fileExt; // assign new name
            $type     = $_FILES["myfile0"]["type"];
            $tempName = $_FILES["myfile0"]["tmp_name"];
            $size     = $_FILES["myfile0"]["size"];
            $originalfileName = $_FILES["myfile0"]["name"];
		    $imageFile=array('image/jpg','image/JPG','image/jpeg',
                          'image/JPEG','image/png','image/PNG');
                        $pathAndName ="assets/uploads/profileImage/".$uploadFileName;
                        $allowedFileType=array('image/jpg',
                                                'image/JPG',
                                                'image/tiff',
                                                'image/jpeg',
                                                'image/TIFF',
                                                'image/png',
                                              );
                        if( in_array($type,$allowedFileType))
                        {
                            if(move_uploaded_file($tempName, $pathAndName))
                            {
                                $data= array(
    	                                   'profile_image_url' => $pathAndName,
    	                                    );

								$result=$this->dashboard_model->updateImageUrlOnServer($userId,$data);
    	                        if($result)
    	                        {
    	                            echo '{"success":"true","userId":"'.$userId.'","path":"'.$pathAndName.'"}';
									log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appAddUploadImage, Message : Successfully uploaded profile image *****');
    	                        }
    	                        else
    	                        {
    	                            echo '{"success":"false","message":"server error"}';
									log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appAddUploadImage, Message : File uploaded but failed to update in database *****');
    	                        }
                            }
                            else
                            {
                                echo '{"success":"false","message":"server error"}';
								log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appAddUploadImage, Message : Failed to upload the file in the required path *****');
                            }
                        }
                        else
                        {
                            echo '{"success":"false"}';
							log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appAddUploadImage, Message : Failed to upload the file as invalid file type selected *****');
                        }
            }
            else
            {
                echo '{"success":"false","session":"out"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : appAddUploadImage, Message : User Id not in session *****');
            }
    }

	
	function appDeleteGoal()
    {
		$data = json_decode(file_get_contents('php://input'));
        $logged=$this->ion_auth->logged_in();
        if($data->goal_id)
        {
			
			if($this->dashboard_model->deleteGoal($data->goal_id))
			{
				log_message('info', '***** InvestorId :, Controller : Dashboard, Function : appDeleteGoal, Message : deleted goal successfully *****');
				echo '{"success":"true"}';
			}
			else
			{
				log_message('info', '***** InvestorId :, Controller : Dashboard, Function : appDeleteGoal, Message : deleted goal failuar *****');
				echo '{"success":"false"}';
			}
			
		}
		else
		{
			log_message('info', '***** InvestorId :, Controller : Dashboard, Function : appDeleteGoal, Message : deleted goal failuar *****');
			echo '{"success":"false"}';
		}
		
	}
	
	
	public function update_mother_name_on_server()
	{
		$data = json_decode(file_get_contents('php://input'));
		$motherName = $data->motherName;
		$investorId = $data->investorId;
		$userId = $data->userId;
		if($motherName && $investorId)
		{
			$this->db->where("investor_id",$investorId)->update("investor",['mother_name' => $motherName]);
			$this->db->where("id",$userId)->update("users",['mother_name' => $motherName]);
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : mother name update success *****');
			echo '{"success":"true"}';
		}
		else
		{
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Dashboard, Function : update_mother_name_on_server, Message : deleted goal failuar *****');
			echo '{"success":"false"}';
		}
	}
	
	
	function appHtmlDashboardView($investorId)
    {
    	$this->get_investment_detail($investorId);
		// $userId= $this->uri->segment(4);

		// 	$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
  //           if($result)
  //           {
  //               $data["profileImageUrl"]=base_url().$result->profile_image_url;
  //               $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
  //               $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
		// 		$data["investor_pdf_form_url"]=$result->investor_pdf_form_url;
  //               $data["fatca_verify"]=$result->fatca_verify;
  //               $data["is_verify"] = $result->is_verify;
  //           }
  //           else
  //           {
  //               $data["profileImageUrl"]="";
  //           }
			
		// 	$NAVdate = $this->db->query("select ts as date from fund_history where is_latest = 1 group by date");
		// 	if($NAVdate->num_rows()>0)
		// 	{
		// 		$data['NAVdate'] = $NAVdate->row()->date;
		// 	}
		// 	else
		// 	{
		// 		$data['NAVdate'] = "";
		// 	}
  //       // get invested fund type list which is already invested by investor
		
  //       $investedFundType=array();
  //       $investedRequestFundType=array();
  //       $resultFundType=$this->dashboard_model->getInvestedFundType($investorId);
  //       if(isset($resultFundType) && !empty($resultFundType))
  //       {
  //           foreach ($resultFundType as $row)
  //           {
  //               if($row->unit_count>0)
  //               {
  //                   array_push($investedFundType, $row->fund_type_id);
  //               }
  //               array_push($investedRequestFundType, $row->fund_type_id);
  //           }
  //       }
		
		// $cancelChequeUrlRes=$this->dashboard_model->getcancelChequeUrl($investorId);
		// if($cancelChequeUrlRes){
		// $data["cancelChequeUrl"]=$cancelChequeUrlRes->url;	
		// }else{
		// $data["cancelChequeUrl"]="";
		// }
  //       $data['investedFundType'] =$investedFundType;
  //       $data['investedRequestFundType'] =$investedRequestFundType;
  //       $resultStatus=$this->common_model->getInvestorStatus($investorId);
  //       if($resultStatus)
  //       {
	 //    	$data["is_nach_enabled"]=$resultStatus->is_nach_enabled;
		// 	$data["is_mandate_received"]=$resultStatus->is_mandate_received;
  //           $data["is_kyc_done"]=$resultStatus->is_kyc_done;
  //           $data["is_investor_registered"]=$resultStatus->is_investor_registered;
  //           $data["is_investor_form_complet"]=$resultStatus->is_investor_form_complet;
  //           $data["is_do_not_reg_nominee"]=$resultStatus->is_do_not_reg_nominee;
  //           $data["is_incomplete_bank_detail"]=$resultStatus->is_incomplete_bank_detail;
  //       }
		
		// $data['resultCurrentAmount']=$this->dashboard_model->getAllInvestmentCurrentValue($investorId);
  //       $data['resultInvestedAmount']=$this->dashboard_model->getAllInvestmentInvestedValue($investorId);
		
  //       $data['currentinvestmentamt']= $this->dashboard_model->getCurrentInvestedAmount($investorId);
		// $investmentfunds = $this->appGetFundsInvestedDetailsee($investorId);
		// $data['investmentfunds'] = json_decode($investmentfunds);
		
  //       $this->load->view('mobile_view/dasgboard_html_view',$data);
    }
	
	public function get_investment_detail($investor_id)
	{
		$calculted_funds = [];
		$res_fund_amount = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id = $investor_id ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id = $investor_id AND request_status = 1 AND fund_history.is_latest = 1 GROUP BY purchased_units.fund_id");
		if($res_fund_amount->num_rows() > 0)
		{
			$fund_amount = $res_fund_amount->result();
			foreach($fund_amount as $fs)
			{
				$current_invested_amount = $this->investmentCurrentValue($fs->fund_id,$investor_id);
				@$calculted_funds['total']['all']['current_investment_amount'] += $current_invested_amount;
				@$calculted_funds['total']['all']['current_investment_value'] += $fs->current_amount;
				@$calculted_funds['total'][$fs->fund_type_id]['current_investment_amount'] += $current_invested_amount;
				@$calculted_funds['total'][$fs->fund_type_id]['current_investment_value'] += $fs->current_amount;
				$fs->current_investment_amount = $current_invested_amount;
				$calculted_funds['key'.$fs->fund_type_id][] = $fs;
			}
		}

		$data['purchased'] = ((object)$calculted_funds);
		// echo "<pre>";
		// print_r($data);
		$this->load->view('mobile_view/dasgboard_html_view2',$data);
	}

	public function get_investment_detailtest($investor_id)
	{
		$calculted_funds = [];
		$res_fund_amount = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id = $investor_id ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id = $investor_id AND request_status = 1 AND fund_history.is_latest = 1 GROUP BY purchased_units.fund_id");
		if($res_fund_amount->num_rows() > 0)
		{
			$fund_amount = $res_fund_amount->result();
			foreach($fund_amount as $fs)
			{
				$current_invested_amount = $this->investmentCurrentValue($fs->fund_id,$investor_id);
				@$calculted_funds['total']['all']['current_investment_amount'] += $current_invested_amount;
				@$calculted_funds['total']['all']['current_investment_value'] += $fs->current_amount;
				@$calculted_funds['total'][$fs->fund_type_id]['current_investment_amount'] += $current_invested_amount;
				@$calculted_funds['total'][$fs->fund_type_id]['current_investment_value'] += $fs->current_amount;
				$fs->current_investment_amount = $current_invested_amount;
				$calculted_funds['key'.$fs->fund_type_id][] = $fs;
			}
		}

		$data['purchased'] = ((object)$calculted_funds);
		echo "<pre>";
		print_r($data);
		exit;
		$this->load->view('mobile_view/dasgboard_html_view2',$data);
	}


	public function investmentCurrentValue($fund_id,$investor_id)
	{
		$res_purchase_fund = $this->db->query("SELECT * FROM purchased_units WHERE investor_id = $investor_id AND request_status = 1 AND fund_id = $fund_id");
		$res_unit_sum_sold_fund = $this->db->query("SELECT SUM(unit_count) as units FROM sold_units WHERE investor_id = $investor_id AND request_status = 1 AND fund_id = $fund_id");
		if($res_unit_sum_sold_fund->num_rows() > 0)
		{
			$purchase_fund = $res_purchase_fund->result();
			$total_sold_units =  $res_unit_sum_sold_fund->row()->units;
			$remaining_units =$total_sold_units;
			$current_amount = 0;
			foreach($purchase_fund as $pf)
			{
				$remaining_units = $remaining_units - $pf->unit_count;
				if($current_amount > 0)
				{
					$current_amount = $current_amount + $pf->purchased_amount;
				}

				if($remaining_units < 0 && $current_amount ==0)
				{
					$old_nav = $pf->purchased_amount/$pf->unit_count;
					$current_amount = $old_nav* abs($remaining_units);
				}
			}

			return round($current_amount);
		}
	}
	
	function appGetFundsInvestedDetailsee($investorId)
    {
        if($investorId)
        {
			$this->load->model('dashboard/account_statement_model');
            $getFundsInvestedResult=$this->account_statement_model->getFundsInvestedDetails($investorId);
			
            if($getFundsInvestedResult)
            {
                $rowStr="";
                foreach($getFundsInvestedResult as $getFundsInvestedRow)
                {
                    $unitCount=$getFundsInvestedRow->unit_count;
                    $fund_id=$getFundsInvestedRow->fund_id;
					$fund_type_id=$getFundsInvestedRow->fund_type_id;
                    $total_purchased_amount_by_fundId=$getFundsInvestedRow->total_amount;
                    $total_sold_amount_by_fundIdResult=$this->account_statement_model->getFundsSoldDetails($investorId,$fund_id);
					
				   if($total_sold_amount_by_fundIdResult)
                    {
                      $total_sold_amount_by_fundId=$total_sold_amount_by_fundIdResult->total_amount;
                    }
                    else
					{
                      $total_sold_amount_by_fundId=0;
                    }
                    $presentInvestedAmount=$total_purchased_amount_by_fundId-$total_sold_amount_by_fundId;
                    $fund_name=$getFundsInvestedRow->fund_name;

                    $presentResult=$this->checkPresentValueByFundId($fund_id,$investorId);
                    if(isset($presentResult) && !empty($presentResult))
                    {
                       $amount=$presentResult;
                    }
                    $rowStr .= '{"fund_name" : "'.$fund_name.'","presentInvestedAmount" : "'.$presentInvestedAmount.'","fund_id" : "'.$fund_id.'","fund_type_id" : "'.$fund_type_id.'", "unitCount" : "'.$unitCount.'","amount" : "'.$amount.'"},';
                }

                return '{"success":"true","data":['.rtrim($rowStr, ',').']}';
                log_message('info', '***** InvestorId : '.$investorId.', Controller : accountStatement, Function : getFundsInvestedDetails, Message : Successfully fetched FundsInvestedDetails *****');
            }
            else
            {
               
            }

        }
        else
        {
            echo '{"success":"false","session":"out"}';
            log_message('info', '***** Controller : accountStatement, Function : getFundsInvestedDetails, Message : Session expired while fetching FundsInvestedDetails *****');
        }

    }
	
	function checkPresentValueByFundId($fund_id,$investorId)
    {
        $resultPurchaseFunds=$this->account_statement_model->getPurchaseFundsReadytoPurchase($fund_id,$investorId);
        $resultSoldFunds=$this->account_statement_model->getSoldFundsAfterSuccess($fund_id,$investorId);

        $amount="";

        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            $purchaseFundId=$resultPurchaseFunds->fund_id;
            $purchaseUnits=$resultPurchaseFunds->unit_count;
            $nav=$resultPurchaseFunds->nav;
            $soldCount=0;

            if(isset($resultSoldFunds) && !empty($resultSoldFunds))
            {
                $soldFundId=$resultSoldFunds->fund_id;
                $soldUnits=$resultSoldFunds->unit_count;
                if($soldFundId==$purchaseFundId)
                {
                  $balanceUnit=($purchaseUnits-$soldUnits);
                  $soldCount++;
                }
            }

            if($soldCount==0)
            {
                $balanceUnit=$purchaseUnits;
            }

            /** caluculate withdraw amount **/
            $withdrawalAmount=round(($balanceUnit*$nav),2);
            $amount=$withdrawalAmount;
            return $amount;
        }
    }

 	function ekycSuccess()
	{
	    if(isset($_REQUEST["result"]))
		{
			$result = explode("|", $_REQUEST["result"]);
			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$_REQUEST["result"]);
            addSystemLog($data); 
				
				if ($result[0] =='Y') 
				{
					$investor_id = $_SESSION["investor_id"];
					if($investor_id){
						$this->registration_model->updateKycStatusDone($investor_id,array("is_kyc_done"=>1,"is_kyc_done_date"=>date("Y-m-d h:i:s")));
					}
					$_SESSION["kyc_msg"] = "Congratulations! You are now KYC complaint";
					redirect(base_url("dashboard"));
				}
				else
				{
					if($result[2] == 'EK-113')
					{
						$_SESSION["kyc_msg"] = "KYC already done";
						redirect(base_url("dashboard"));
					}else{
						$_SESSION["kyc_msg"] = $result[3];
						redirect(base_url("dashboard"));
					}
				}
		}

		redirect(base_url("dashboard"));
	}


	function emandateSuccess()
	{
		$response = $_POST;
		$investor_id = $_SESSION["investor_id"];
		if(isset($response['msg']))
		{
		    $msg = $response['msg'];
		    log_message('info', '***** Controller : Dashboard, Function : emandateSuccess, Message :  response '.$msg.' *****');
		    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$msg);
            addSystemLog($data); // helper function
		    $final_array = explode("|",  $msg );

		    // echo "<br />";
		    $newHash = $final_array[count($final_array)-1];
		    // echo "<br />";
		    // echo $_SESSION['token'];
		    unset($final_array[count($final_array)-1]);
		    $newData = implode("|", $final_array);
		    $oldHash = md5($newData ."|".$_SESSION['key']);

		    if($oldHash == $newHash && $final_array[1]=='failure')
		    {
		        $_SESSION["kyc_msg"] = $final_array[2];
		    }
		    else if($oldHash == $newHash)
		    {
		    	$_SESSION["kyc_msg"] = "Your Request Successfully placed";
		    	$this->db->where('investor_id',$investor_id)->update('investor',['umrn'=>$investor_id]);
		    }
		    else
		        $_SESSION["kyc_msg"] = "There were some issues with E-Mandate";
		    
		    
		}
		// $this->db->where('investor_id',$investor_id)->update('investor',['umrn'=>$investor_id]);
		redirect(base_url("dashboard"));
	}

	public function mailtest()
	{
		$email = "amitmeena0206@gmail.com";
		$name = "Amit Meena";
		sendConfirmationEmail($email,$name);
	}

	public function appMandat($investor_id)
	{
		// $get = json_decode(file_get_contents("php://input"));
		// $investor_id = $get->investor_id;
		// echo $investor_id;
		try{
			$this->load->view('amit_theme/dashboard/mandat_app_view',compact('investor_id'));
		}catch(Exception $e){
			print_r($e);
		}
		
	}

	function appEmandateSuccess()
	{
		$response = $_POST;
		if(isset($response['msg']))
		{
		    $msg = $response['msg'];
		    log_message('info', '***** Controller : Dashboard, Function : emandateSuccess, Message Mobile :  response '.$msg.' *****');
		    $final_array = explode("|",  $msg );
		    $newHash = $final_array[count($final_array)-1];
		    unset($final_array[count($final_array)-1]);
		    $newData = implode("|", $final_array);
		    $oldHash = md5($newData ."|".$_SESSION['key']);

		    if($oldHash == $newHash && $final_array[1]=='failure')
		    {
		        $final_response = $final_array[2];
		    }
		    else if($oldHash == $newHash)
		    {
		    	$final_response = "Your Request Successfully placed";
		    }
		    else
		        $final_response = "There were some issues with E-Mandate";
		}

		$this->load->view('eman',['kyc_msg'=>$final_response]);
	}

	public function appEkyc($investor_id)
	{
		$invDetails = investor_detail($investor_id);
		$pan = $invDetails->pan;
		$this->load->view('amit_theme/dashboard/appKycFields',compact('investor_id','pan'));
	}

	public function appEkycSuccess()
	{
		$kyc_msg = 'default';
		if(isset($_REQUEST["result"]))
		{
			$result = explode("|", $_REQUEST["result"]);				
			if ($result[0] =='Y') 
			{
				$kyc_msg = "Congratulations! You are now KYC complaint";
			}
			else
			{
				if($result[2] == 'EK-113')
				{
					$kyc_msg = "KYC already done";
				}else{
					$kyc_msg = $result[3];
				}
			}
		}

		$this->load->view('eman',compact('kyc_msg'));
	}

	public function redirectToRegisterPage()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $res = $this->db->select('investor_type_id')->from('investor')->where('investor_id',$investorId)->get();

            if($res->num_rows() > 0)
            {
                echo $res->row()->investor_type_id;
                if($res->row()->investor_type_id == 1){
                    echo "Resident Indian (Individual)";
                    return redirect('residentIndianIndividual');
                }
                else if ($res->row()->investor_type_id == 2) {
                    
                    echo "Non-Resident Indian(Individual)";
                    return redirect('nriRegistration');
                }
                else if ($res->row()->investor_type_id == 3) {
                    
                    echo "Person of indian origin (PIO)(Individual)";
                    return redirect('nriRegistration');
                }
                else if ($res->row()->investor_type_id == 4) {
                    
                    echo "Non-Resident Indian-Mariner(Individual)";
                    return redirect('nriRegistration');
                }
                else if ($res->row()->investor_type_id == 7) {
                    
                    echo "On Behalf Of Minor";
                    return redirect('minor');
                }
                else if ($res->row()->investor_type_id == 8) {
                    
                    echo "huf";
                    return redirect('hufRegistration');
                }
                else if ($res->row()->investor_type_id == 9) {
                    
                    echo "Corporate";
                    return redirect('corporate');
                }
                else if ($res->row()->investor_type_id == 11) {
                    
                    echo "Partnership Firm";
                    return redirect('partnershipFirmRegistration');
                }
                else if ($res->row()->investor_type_id == 24) {
                    
                    echo "Sole Proprietorship";
                    return redirect('soleProprietorship');
                }
                
            }
            else
            {
                return redirect('login');
            }

        }
        else
        {
            return redirect('login');
        }
    }

}
