<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : DownloadForm
|   MODEL USE : registration_model
|   DATE : 08/10/2016
|   AUTHOER : amit meena
|   COMMENT : This function is used to downoload investor form like investor pgf and fatka and others
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class DownloadForm extends CI_Controller
{
	function __construct()
	{
        // Call the Model constructor
        parent::__construct();
        $this->load->model('dashboard/download_form_model');
        $this->load->model('dashboard/dashboard_model');
		$this->load->model('dashboard/preferences_model','preferences_model');
	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : index
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS LOAD tdashboard view
-----------------------------------------------------------------------------------------------------
*/
	public function index()
	{
		$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("amit_theme/dashboard/download_form_view");
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited Download page");
                    addSystemLog($data); // helper function
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : _loadView
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to load 
-----------------------------------------------------------------------------------------------------
*/
    function _loadView($view)
    {
        $userId=$_SESSION["userId"];
        $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
        if($result)
        {
            $data["profileImageUrl"]=$result->profile_image_url;
            $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
            $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
            $data["is_verify"]=$result->is_verify;
        }
        else
        {
            $data["profileImageUrl"]="";
        }

        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }

        $investorId  = $_SESSION["investor_id"];
        $result = $this->download_form_model->getLoggedInUserEcsMandate($investorId);
        $data['row']=$result;
        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view);
        $this->load->view('amit_theme/common/footer',$data ); 
    }
	
			/*
-----------------------------------------------------------------------------------------------------
|   USE : downloadInvestorPdf
|   DATE : 25/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to download investor document pdf file.
-----------------------------------------------------------------------------------------------------
*/
	function downloadInvestorPdf(){
		 $investorId  = $_SESSION["investor_id"];
		 echo $investorId;
		$result = $this->download_form_model->getLoggedInUserEcsMandate($investorId);
		//echo '<pre>';print_R($result);exit;
	    if(!empty($result))
		{
			$file = $result->investor_pdf_form_url;
			$append_path='assets/uploads/investor_form_pdf/';
			$file_name='investor_detail.pdf';
			$file=$append_path.$file;
			$this->downloadFile($file_name,$file);
		}
		else
		{
			log_message('info', '*****  Controller : downloadForm, Function : downloadInvestorPdf, Message : Unable to get investor details *****');
			echo 'Unable to get investor details!';
		}
		
		
	}
	
	
				/*
-----------------------------------------------------------------------------------------------------
|   USE : downloadNomineeChangeForm
|   DATE : 25/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to download change nominess form pdf file.
-----------------------------------------------------------------------------------------------------
*/
	function downloadNomineeChangeForm(){
		 $investorId  = $_SESSION["investor_id"];
		 $result = $this->preferences_model->getNomineePdf($investorId);
		  if($result)
		{
			$file = $result->signedNominee_url;
			$append_path='assets/uploads/changeNomineeForm/';
			$file_name='change_nominee_form.pdf';
			$file=$append_path.$file;
			$this->downloadFile($file_name,$file);
		}
		else
		{
			log_message('info', '*****  Controller : downloadForm, Function : downloadNomineeChangeForm, Message : Unable to get investor details *****');
			echo 'Unable to get investor details!';
		}
		
		
	}
		/*
-----------------------------------------------------------------------------------------------------
|   USE : downloadPdfFile
|   DATE : 22/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to download investor document pdf file.
-----------------------------------------------------------------------------------------------------
*/
	function downloadPdfFile()
	{
		$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
		 $investorId  = $_SESSION["investor_id"];
        $result = $this->download_form_model->getLoggedInUserEcsMandate($investorId);
	    if(!empty($result))
		{
			$file = $result->investor_pdf_form_url;
			$append_path='assets/uploads/investor_form_pdf/';
			$file_name='investor_detail.pdf';
			$file=$append_path.$file;
			$fileType = pathinfo($file);
			$returnType ;
			
		if (file_exists($file) && is_readable($file)) { 
			 
			if($fileType['extension']=="pdf")
				{
				$returnType = "header('Content-type: application/pdf')";
				}
				echo $returnType ; 
				header('Content-Description: File Transfer');
				echo $returnType ; 
				header("Content-Type: application/force-download");// some browsers need this
				header("Content-Disposition: attachment; filename=\"$file_name\"");
				header('Expires: 0');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
				header('Content-Length: ' . filesize($file));
				ob_clean();
				flush();
				readfile($file);
				exit;
				}
			else 
				{
			header("HTTP/1.0 404 Not Found");
			echo "<h3>Error 404: File Not Found : <br /><em>$file</em></h3>";

				}
			
			}
			else
			{
				log_message('info', '*****  Controller : downloadForm, Function : downloadPdfFile, Message : investor data not exists! *****');
				echo 'investor data not exists!';
			}
		
		}
		else
        {
			log_message('info', '*****  Controller : downloadForm, Function : downloadPdfFile, Message : redirect to home *****');
            redirect(base_url());
        } 
		
	}


	
		/*
-----------------------------------------------------------------------------------------------------
|   USE : downloadFile
|   DATE : 25/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function is used to download pdf file.
-----------------------------------------------------------------------------------------------------
*/
	
	function downloadFile($file_name,$file)
	{
		$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
			$fileType = pathinfo($file);
			$returnType ;
			if (file_exists($file) && is_readable($file)) 
			{ 
				if($fileType['extension']=="pdf")
				{
					$returnType = "header('Content-type: application/pdf')";
				}
				echo $returnType ; 
				header('Content-Description: File Transfer');
				echo $returnType ; 
				header("Content-Type: application/force-download");// some browsers need this
				header("Content-Disposition: attachment; filename=\"$file_name\"");
				header('Expires: 0');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
				header('Content-Length: ' . filesize($file));
				ob_clean();
				flush();
				readfile($file);
				exit;
			}
			else 
			{
				header("HTTP/1.0 404 Not Found");
				log_message('info', '*****  Controller : downloadForm, Function : downloadFile, Message : Not Found *****');
				echo "<h3>Error 404: File Not Found : <br /><em>$file</em></h3>";
			}
		}
		else
        {
			log_message('info', '*****  Controller : downloadForm, Function : downloadFile, Message : redirect to home *****');
            redirect(base_url());
        } 
		
	}

}
