<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class FirstPurchaseByApiTypeReport extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->model('first_purchase_api_type_report_model');
        $this->load->helper('download');
    }

    public function index()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("35", $pageId))
            {
                $this->_loadView('first_purchase_by_api_type_view');
                $data=array("user_id"=>$_SESSION["userId"],"log_msg"=>"Visited first purchase by api type page");
                addSystemLog($data); // helper function
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: index, Message: Visited first purchase by api type page *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function _loadView($view)
    {
        $data = array();
        $resultAPIName = $this->first_purchase_api_type_report_model->getAPIList();
        if($resultAPIName)
        {
            $data['apiNameList']=$resultAPIName;
        }
        else
        {
            $data['apiNameList']="";
        }

        $this->load->view('includes/head',$data);
        $data['jsFile'] ='firstPurchaseByApiType.js';
        $this->load->view($view,$data);
        $this->load->view('includes/leftmenu');
        $this->load->view('includes/right');
        $this->load->view('includes/foot',$data);
    }

    function getFirstPurchaseDetails()
    {
        if(checkuser_session())
        {
            $apiTypeId = $this->input->post("apiTypeId");
            $getDetailsResult = $this->first_purchase_api_type_report_model->getFirstPurchaseDetails($apiTypeId);
            //print_r($getDetailsResult);die;
            if($getDetailsResult)
            {
                $rowStr="";
                foreach ($getDetailsResult as $row)
                {
                   $userName=$this->encrypt->decode($row->username);
                   $pan=$this->encrypt->decode($row->pan);
				   if($row->first_purchase_doc)
				   {
					   $first_purchase_doc = 'checked';
				   }
				   else
				   {
					   $first_purchase_doc = '';
				   }
                   $rowStr.= '["'.$row->investor_id.'","'.$userName.'","'.$row->email.'","'.$row->api_name.'","'.$pan.'","'.$row->is_kyc_done.'","'.$row->batch_id.'","'.$first_purchase_doc.'"],';
                }
                echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
                if($apiTypeId==1)
                {
                    log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: getFirstPurchaseDetails, Message: Successfully fetched Karvy first purchase details to be displayed in table *****');
                }
                else if($apiTypeId==2)
                {
                    log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: getFirstPurchaseDetails, Message: Successfully fetched CAMS first purchase details to be displayed in table *****');
                }
                else
                {
                    log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: getFirstPurchaseDetails, Message: Successfully fetched Franklin first purchase details to be displayed in table *****');
                }  
            }
            else
            {
                echo '{"success":false}';
                if($apiTypeId==1)
                {
                    log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: getFirstPurchaseDetails, Message: Failed to fetch Karvy first purchase details to be displayed in table *****');
                }
                else if($apiTypeId==2)
                {
                    log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: getFirstPurchaseDetails, Message: Failed to fetch CAMS first purchase details to be displayed in table *****');
                }
                else
                {
                    log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: getFirstPurchaseDetails, Message: Failed to fetch Franklin first purchase details to be displayed in table *****');
                }
            }
        }
        else
        {
            echo '{"success":false}';
            log_message('info', '***** Controller: firstPurchaseByApiTypeReport, Function: getFirstPurchaseDetails, Message: Session expired while fetching the first purchase by api type details *****');
        }
    }

    // Start Karvy zip file downloaind funcionality
    // ajax request for downloading karvy fatca zip file
    function downloadKarvyFatcaZipFile()
    {
        if(checkuser_session())
        {
            $investorId=$this->input->post("investorId");
            $apiTypeId=$this->input->post("apiTypeId");
            if($apiTypeId==1)
            {
                // karvy fatca form default document type id is 26
                $docTypeId=26;
            }

            // get input pdf file need to convert .tif file.
            $result=$this->first_purchase_api_type_report_model->getFatcaPdfPath($investorId,$docTypeId);
			//echo $this->db->last_query();

            if($result)
            {
                $pdfPath=$result->url;
                if($pdfPath)
                {
                    // create karvy uploaded pdf to .tif file format
                    $this->createkarvyPdfToKarvyTif($investorId,$pdfPath,$docTypeId);
                }
                else
                {
                    echo '{"success":false,"msg":"Fatca pdf url not found in database"}';
                    log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadKarvyFatcaZipFile, Message: Fatca pdf url not found in database for investor id = "'.$investorId.'" *****');

                }
            }
            else
            {
                echo '{"success":false,"msg":"No data found in database"}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadKarvyFatcaZipFile, Message: No data found in database for investor id = "'.$investorId.'" *****');
            }
        }
    }

    // karvy  fatca pdf to .tif
    function createkarvyPdfToKarvyTif($investorId,$pdfUrl,$docTypeId)
    {
        $pan='';
        $this->db->where("investor_id",$investorId);
        $query=$this->db->get("investor");
        if($query->num_rows())
        {
            $result=$query->row();
            $pan=$this->encrypt->decode($result->pan);
        }

        $path = parse_url($pdfUrl, PHP_URL_PATH);

        //To get the dir, use: dirname($path)

        $changePDfpath=$_SERVER['DOCUMENT_ROOT'] . $path;
        $datadir = realpath("assets/uploads/fatca_tif_karvy");

        if($docTypeId==26)
        {
            $fileName=$pan.'.tif';
        }

        $outputTiffFileName = $datadir.'/'.$fileName;
        $dbTiffFileName = base_url().'assets/uploads/fatca_tif_karvy/'.$fileName;
        $inputPDFFileName = $changePDfpath;

        //ghost script command to run
        $cmd = "gs -SDEVICE=tiffg4 -r600x600 -sPAPERSIZE=letter -sOutputFile='$outputTiffFileName' -dNOPAUSE -dBATCH  $inputPDFFileName";
        //$cmd = "gs -q -dNOPAUSE -sDEVICE=tiffg4 -sOutputFile=$outputTiffFileName $inputPDFFileName -c quit";
        //Execute the ghost script that takes the PDF as an input and coverts and saves the it in the data directory.
        $response =  exec($cmd);
        log_message('info', $cmd);
        $fileExists=file_exists(realpath($outputTiffFileName));
        if($fileExists)
        {
            // create karvy tif to zip file
            $this->createKarvyFatcaTifToZip($outputTiffFileName,$pan);
        }
        else
        {
            echo '{"success":false,"msg":"problem in tif file creation for karvy."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: createkarvyPdfToKarvyTif, Message: problem in creation fatca tif file for karvy *****');
        }
    }

    // karvy fatca tif to zip file
    function createKarvyFatcaTifToZip($outputTiffFileName,$pan)
    {
        $datadir = "assets/uploads/fatca_zip_karvy/";
        $zip = new ZipArchive();

        $DelFilePath=$pan.".zip";

        if(file_exists($datadir.$DelFilePath)) {

            unlink ($datadir.$DelFilePath);
        }
        if ($zip->open($datadir.$DelFilePath, ZIPARCHIVE::CREATE) != TRUE) {
              die ("Could not open archive");
        }

        $zip->addFile($outputTiffFileName,$pan.".tif");
        header('Content-type: application/zip');
        header('Content-Disposition: attachment; filename="'.$DelFilePath.'"');
        //readfile($datadir."/".$DelFilePath);
        // close and save archive
        $zip->close();
        $fileExists=file_exists(realpath($datadir.$DelFilePath));
        if($fileExists)
        {
            echo '{"success":true,"url":"'.base_url().$datadir.$DelFilePath.'"}';
        }else
        {
            echo '{"success":false,"msg":"Zip file not exits in database."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: createKarvyFatcaTifToZip, Message: Not found fatca zip file while downloading zip file for karvy *****');
        }
    }
    // End Karvy zip file downloaind funcionality

    // Start CAMS zip file downloaind funcionality
    // ajax request for downloading cams fatca zip file
    function downloadCamsFatcaZipFile()
    {
        if(checkuser_session())
        {
            $investorId=$this->input->post("investorId");
            $apiTypeId=$this->input->post("apiTypeId");
            // cams fatca form default document type id is 26
            $docTypeId=27;
            // get input pdf file need to convert .tif file.
            $result=$this->first_purchase_api_type_report_model->getFatcaPdfPath($investorId,$docTypeId);
            if($result)
            {
                $pdfPath = $result->url;
                if($pdfPath)
                {
                    // create cams uploaded pdf to .tif file format
                    $this->createCamsPdfToCamsTif($investorId,$pdfPath);
                }
                else
                {
                    echo '{"success":false,"msg":"Fatca pdf url not found in database"}';
                    log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadCamsFatcaZipFile, Message: Fatca pdf url not found in database for investor id ="'.$investorId.'" *****');
                }
            }
            else
            {
                echo '{"success":false,"msg":"No data found in database"}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadCamsFatcaZipFile, Message: No data found in database for investor id ="'.$investorId.'" *****');
            }
        }
    }

    // cams fatca pdf to .tif
    function createCamsPdfToCamsTif($investorId,$pdfUrl)
    {
        $pan='';
        $this->db->where("investor_id",$investorId);
        $query = $this->db->get("investor");
        if($query->num_rows())
        {
			$result=$query->row();
            $pan=$this->encrypt->decode($result->pan);
        }

        $path = parse_url($pdfUrl, PHP_URL_PATH);

        //To get the dir, use: dirname($path)
        $changePDfpath=$_SERVER['DOCUMENT_ROOT'] . $path;
        $datadir = realpath("assets/uploads/fatca_tif_cams");


        $fileName="FATCA$".$pan.'$SDF.tif';


        $outputTiffFileName = $datadir.'/'.$fileName;
        $dbTiffFileName = base_url().'assets/uploads/fatca_tif_cams/'.$fileName;
        $inputPDFFileName = $changePDfpath;

        //ghost script command to run
        $cmd = "gs -SDEVICE=tiffg4 -r400x400 -sPAPERSIZE=letter -sOutputFile='$outputTiffFileName' -dNOPAUSE -dBATCH  $inputPDFFileName";
        //$cmd = "gs -q -dNOPAUSE -sDEVICE=tiffg4 -sOutputFile=$outputTiffFileName $inputPDFFileName -c quit";
        //Execute the ghost script that takes the PDF as an input and coverts and saves the it in the data directory.
        $response =  exec($cmd);
        log_message('info', $cmd);
        $fileExists=file_exists(realpath($outputTiffFileName));
        if($fileExists)
        {
            // create cams tif to zip file
            $this->createCamsFatcaTifToZip($outputTiffFileName,$pan);
        }
        else
        {
            echo '{"success":false,"msg":"problem in tif file creation for cams."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: createcamsPdfTocamsTif, Message: problem in creation fatca tif file for cams *****');
        }
    }

    // cams fatca tif to zip file
    function createCamsFatcaTifToZip($outputTiffFileName,$pan)
    {
        $datadir = "assets/uploads/fatca_zip_cams/";
        $zip = new ZipArchive();

        $DelFilePath=$pan.'.zip';

        if(file_exists($datadir.$DelFilePath))
		{
            unlink ($datadir.$DelFilePath);
        }
		
        if ($zip->open($datadir.$DelFilePath, ZIPARCHIVE::CREATE) != TRUE)
		{
              die ("Could not open archive");
        }

        // add a folder name of pan number
        $zip->addFile($outputTiffFileName,$pan."/FATCA$".$pan.'$SDF.tif');
        header('Content-type: application/zip');
        header('Content-Disposition: attachment; filename="'.$DelFilePath.'"');
        //readfile($datadir."/".$DelFilePath);
        // close and save archive
        $zip->close();
        $fileExists = file_exists(realpath($datadir.$DelFilePath));
        if($fileExists)
        {
            echo '{"success":true,"url":"'.base_url().$datadir.$DelFilePath.'"}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: createCamsFatcaTifToZip, Message: Successfully created cams zip file  *****');
        }else
        {
            echo '{"success":false,"msg":"Zip file not exits in database."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: createCamsFatcaTifToZip, Message: Zip file not exits in database *****');
        }
    }
	
    // End CAMS fatca zip file downloaind funcionality
    function downloadKarvyCompleteZipFile()
    {
        if(checkuser_session())
        {
            $investorId=$this->input->post("investorId");
            $investorName=$this->input->post("investorName");
            $kycStatus=$this->input->post("kycStatus");
            $investor_type_id = $this->db->query("SELECT investor_type_id FROM investor WHERE investor_id = $investorId")->row()->investor_type_id;
            $docCount=0;
            if($kycStatus==1)
            {
				$docCount=4;
            }else
			{
				$docCount=6;
			}
            $pan=$this->input->post("pan");
            // if company pass tru as last variable
            $result=$this->first_purchase_api_type_report_model->getAllDocumentList($investorId,$kycStatus,$investor_type_id);
            if(true)
            {
                $this->mergeKarvySelectedPdf($result,$pan,$investorName);
            }
            else
            {
                echo '{"success":false,"msg":"There are no sufficient documents for download."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadKarvyCompleteZipFile, Message: There are no sufficient documents to download for investor id = "'.$investorId.'" *****');
            }
        }
        else{
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller: firstPurchaseByApiTypeReport, Function: downloadFatca, Message: Session expired while downloading fatca tif file *****');
        }
    }

    function mergeKarvySelectedPdf($pdfList,$pan,$investorName)
    {

        $datadir=$_SERVER['DOCUMENT_ROOT']."/investocafeadmin/assets/uploads/investor_document/";
        $allFile="";
        if(isset($pdfList) && !empty($pdfList))
        {
            foreach ($pdfList as $row)
            {
                if($row->url!="")
                {
                    $path = parse_url($row->url, PHP_URL_PATH);
                    //To get the dir, use: dirname($path)
                    $changePDfpath=$_SERVER['DOCUMENT_ROOT'] . $path;
                    $allFile.=$changePDfpath." 1-z ";
                }
            }
        }

        if($allFile)
        {
            $outputPdf=$datadir."0_temp/".date("dmyhis")."_karvy_".$pan.".pdf";
			
            // $cmd="qpdf --empty --pages a.pdf 1-z b.pdf 1-z c.pdf 1-z d.pdf 1-z e.pdf 1-z -- $outputPdf";
            if($_SERVER["SERVER_NAME"]=="localhost")
            {
                 $cmd="/usr/bin/qpdf --empty --pages $allFile-- $outputPdf";
            }else{
                $cmd="/usr/local/bin/qpdf --empty --pages $allFile-- $outputPdf";
            }
           
            $response = exec($cmd);//shell_exec($cmd);
            log_message('info', "$cmd");
            log_message('info', "response--- $response");
            $fileExists=file_exists(($outputPdf));
            if($fileExists)
            {
                $this->convertKarvyFinalTiff($outputPdf,$pan,$investorName);
            }
            else
            {
                echo '{"success":false,"msg":"Problem in single pdf file creation for karvy."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: mergeKarvySelectedPdf, Message: Problem in merging single pdf for karvy *****');
            }
        }
        else
        {
            echo '{"success":false,"msg":"No uploaded file available."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: mergeKarvySelectedPdf, Message: Problem in merging single pdf for karvy *****');
        }
    }

    function convertKarvyFinalTiff($outputPdf,$pan,$investorName)
    {
        $datadir = "assets/uploads/karvy_all_document_tiff/";
        $arnNumber=explode("-", $this->config->item("arn_number"));
        $fileName=$arnNumber[1].$pan;
        $outputTiffFileName = $fileName.".tif";
        $inputPDFFileName = $outputPdf;
        //ghost script command to run
        $cmd = "gs -SDEVICE=tiffg4 -r400x400 -sPAPERSIZE=letter -sOutputFile=$datadir'$outputTiffFileName' -dNOPAUSE -dBATCH  $inputPDFFileName";
        $response = exec($cmd);
        log_message('info', "$cmd");
        log_message('info', "response--- $response");
        $fileExists=file_exists(realpath($datadir.$outputTiffFileName));
        log_message('info', realpath($datadir.$outputTiffFileName));
        if($fileExists)
        {
            $this->createKarvyZIPFile($outputTiffFileName,$pan);
        }else
        {
            echo '{"success":false,"msg":"problem in tif file creation for karvy."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: convertKarvyFinalTiff, Message: problem in creation all document tif file for karvy *****');
        }
    }

    function createKarvyZIPFile($outputTiffFileName,$pan)
    {
        $tiffDatadir = "assets/uploads/karvy_all_document_tiff/";
        $datadir = "assets/uploads/karvy_zip_document/";
        $zip = new ZipArchive();
        $arnNumber=explode("-", $this->config->item("arn_number"));
        // generate a unique file number
        $fileNumber=$this->first_purchase_api_type_report_model->getTodaysZipFileCount();
        $fileNumberLength=strlen($fileNumber);
        if($fileNumberLength==1){
            $fileNumber="00".$fileNumber;
        }else if($fileNumberLength==2){
            $fileNumber="0".$fileNumber;
        }
        $fileName=$arnNumber[1].date("dmy").$fileNumber;

        $DelFilePath=$fileName.".zip";

        if(file_exists($datadir.$DelFilePath)){
            unlink ($datadir.$DelFilePath);
        }
        if ($zip->open($datadir.$DelFilePath, ZIPARCHIVE::CREATE) != TRUE) {
            die ("Could not open archive");
        }

        $zip->addFile($tiffDatadir.$outputTiffFileName,$outputTiffFileName);
        header('Content-type: application/zip');
        header('Content-Disposition: attachment; filename="'.$DelFilePath.'"');
        //readfile($datadir."/".$DelFilePath);
        // close and save archive
        $zip->close();
        $fileExists=file_exists(realpath($datadir.$DelFilePath));
        if($fileExists)
        {
            $this->first_purchase_api_type_report_model->addTodaysZipFileCount();
            echo '{"success":true,"url":"'.base_url().$datadir.$DelFilePath.'"}';
        }else
        {
            echo '{"success":false,"msg":"Zip file not exits in database."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: createKarvyZIPFile, Message: Not found zip file while downloading zip file for karvy *****');
        }
    }

    function downloadCamsCompleteZipFile()
    {
        if(checkuser_session())
        {
            $investorId=$this->input->post("investorId");
            $investorName=$this->input->post("investorName");
            $kycStatus=$this->input->post("kycStatus");
            $investor_type_id = $this->db->query("SELECT investor_type_id FROM investor WHERE investor_id = $investorId")->row()->investor_type_id;
            $docCount=0;
            if($kycStatus==1)
            {
                $docCount=4;
            }
			else
			{
				$docCount=6;
			}
            $pan=$this->input->post("pan");
            $result=$this->first_purchase_api_type_report_model->getAllDocumentList($investorId,$kycStatus,$investor_type_id);
            // count($result)==$docCount
            if(true)
            {
                $this->mergeCamsSelectedPdf($result,$pan,$investorName);
            }
            else
            {
                echo '{"success":false,"msg":"There are no sufficient documents for download."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadCamsCompleteZipFile, Message: There are no sufficient documents to download for investor id ="'.$investorId.'" *****');
            }
        }else{
            echo '{"success":false,"session":"out"}';
        }
    }

    function mergeCamsSelectedPdf($pdfList,$pan,$investorName)
    {
        $datadir="assets/uploads/investor_document/";
        $allFile="";
        if(isset($pdfList) && !empty($pdfList))
        {
            foreach ($pdfList as $row)
            {
                if($row->url!="")
                {
                    $path = parse_url($row->url, PHP_URL_PATH);

                    //To get the dir, use: dirname($path)
                    $changePDfpath=$_SERVER['DOCUMENT_ROOT'] . $path;
                    $allFile.=$changePDfpath." 1-z ";
                }
            }
        }
        if($allFile)
        {

            $outputPdf=$datadir."0_temp/".date("dmyhis")."_cams_".$pan.".pdf";
            // $cmd="qpdf --empty --pages a.pdf 1-z b.pdf 1-z c.pdf 1-z d.pdf 1-z e.pdf 1-z -- $outputPdf";
            if($_SERVER["SERVER_NAME"]=="localhost")
            {
                 $cmd="/usr/bin/qpdf --empty --pages $allFile-- $outputPdf";
            }else{
                 $cmd="/usr/local/bin/qpdf --empty --pages $allFile-- $outputPdf";
            }

            $response = exec($cmd);//shell_exec($cmd);
            log_message('info', "$cmd");
            log_message('info', "response--- $response");
            $fileExists=file_exists(realpath($outputPdf));
            if($fileExists)
            {
                $this->convertCamsFinalTiff($outputPdf,$pan,$investorName);
            }
            else
            {
                echo '{"success":false,"msg":"Problem in single pdf file creation for cams."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: mergeCamsSelectedPdf, Message: Problem in merging single pdf for cams *****');
            }
        }
        else
        {
            echo '{"success":false,"msg":"No uploaded file available."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: mergeCamsSelectedPdf, Message: Problem in merging single pdf for cams *****');
        }
    }

    function convertCamsFinalTiff($outputPdf,$pan,$investorName)
    {
        $datadir = "assets/uploads/cams_all_document_tiff/";
        $arnNumber=$this->config->item("arn_number");
        $fileName=$arnNumber."$".$pan.'$ALL';
        $outputTiffFileName = $fileName.".tif";
        $inputPDFFileName = $outputPdf;

        //ghost script command to run
        $cmd = "gs -SDEVICE=tiffg4 -r400x400 -sPAPERSIZE=letter -sOutputFile=$datadir'$outputTiffFileName' -dNOPAUSE -dBATCH  $inputPDFFileName";
        $response = exec($cmd);
        log_message('info', "$cmd");
        log_message('info', "response--- $response");
        if($response)
        {
            $fileExists=file_exists(realpath($datadir.$outputTiffFileName));
            if($fileExists)
            {
                $this->createCamsZIPFile($outputTiffFileName,$pan);
            }else
            {
                echo '{"success":false,"msg":"problem in tif file creation for cams."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: convertCamsFinalTiff, Message: problem in creation all document tif file for cams *****');
            }
        }
    }

    function createCamsZIPFile($outputTiffFileName,$pan)
    {
        $tiffDatadir = "assets/uploads/cams_all_document_tiff/";
        $datadir = "assets/uploads/cams_zip_document/";
        $zip = new ZipArchive();
        $arnNumber=$this->config->item("arn_number");
        $fileName=$pan;
        $DelFilePath=$fileName.".zip";

        if(file_exists($datadir.$DelFilePath))
		{
            unlink($datadir.$DelFilePath);
        }
        if ($zip->open($datadir.$DelFilePath, ZIPARCHIVE::CREATE) != TRUE)
		{
            die ("Could not open archive");
        }

        // add a folder inside folder all document zip file.
        $zip->addFile($tiffDatadir.$outputTiffFileName,$pan."/".$outputTiffFileName);
        header('Content-type: application/zip');
        header('Content-Disposition: attachment; filename="'.$DelFilePath.'"');
        //readfile($datadir."/".$DelFilePath);
        // close and save archive
        $zip->close();
        $fileExists=file_exists(realpath($datadir.$DelFilePath));
        if($fileExists)
        {
            echo '{"success":true,"url":"'.base_url().$datadir.$DelFilePath.'"}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: createCamsZIPFile, Message: Successfully created cams zip file for download *****');
        }else
        {
            echo '{"success":false,"msg":"Zip file not exits in database."}';
            log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: createCamsZIPFile, Message: Not found zip file while downloading zip file for cams *****');
        }
    }

    // downaload karvy csv file..
    function downloadKarvyCsvFile()
    {
        if(checkuser_session())
        {
            $investorId=$this->input->post("investorId");
            $investorDetails = $this->first_purchase_api_type_report_model->getInvestorDetails($investorId);
            $taxResidency = $this->first_purchase_api_type_report_model->getTaxresidency($investorId);
            $data["investorDetails"]=$investorDetails;
            $data["taxResidency"]=$taxResidency;
            $pan=$this->encrypt->decode($investorDetails->pan);
			if($investorDetails->investor_type_id == 9 || $investorDetails->investor_type_id == 11)
			{
				if($investorDetails->investor_type_id == 9)
				{
					$res = $this->db->from("company_partners")->where(["investor_id"=>$investorId,"percent_of_beneficial >" => 14])->get();
				}
				else
				{
					$res = $this->db->from("company_partners")->where(["investor_id"=>$investorId,"percent_of_beneficial >" => 14])->get();
				}
				
				if($res->num_rows()>0)
				{
					$data['ubo_count'] = $res->num_rows();
					$data['ubo'] = $res->result();
				}
				$string = $this->load->view('fatca_feed_karvy_pvt', $data, true);
			}
			else
			{
				$string = $this->load->view('fatca_feed_karvy', $data, true);
			}
            
            $fileName="fatca$".$pan.'$'.date('dmY').'.csv';
            $path="assets/uploads/csv_karvy/".$fileName;
            $myfile =fopen($path, "w");
            $result=fwrite($myfile, $string);
            fclose($myfile);
            if($result)
            {
                echo '{"success":true,"url":"'.$path.'"}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadKarvyCsvFile, Message: Successfully downloaded karvy csv file for investor id = "'.$investorId.'" *****');
            }
            else
            {
                echo '{"success":false,"msg":"Failed try again server error found."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadKarvyCsvFile, Message: Failed to download karvy csv file for investor id = "'.$investorId.'" *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller: firstPurchaseByApiTypeReport, Function: downloadKarvyCsvFile, Message: Session out on trying to download karvy csv file *****');
        }
    }


    function downloadKarvyCsvFiletest($investorId)
    {
        
            echo "<pre>";
            $investorDetails = $this->first_purchase_api_type_report_model->getInvestorDetails($investorId);
            $taxResidency = $this->first_purchase_api_type_report_model->getTaxresidency($investorId);
            $data["investorDetails"]=$investorDetails;
            $data["taxResidency"]=$taxResidency;
            $pan=$this->encrypt->decode($investorDetails->pan);
            if($investorDetails->investor_type_id == 9 || $investorDetails->investor_type_id == 11)
            {
                if($investorDetails->investor_type_id == 9)
                {
                    $res = $this->db->from("company_partners")->where(["investor_id"=>$investorId,"percent_of_beneficial >" => 24])->get();
                }
                else
                {
                    $res = $this->db->from("company_partners")->where(["investor_id"=>$investorId,"percent_of_beneficial >" => 14])->get();
                }
                
                if($res->num_rows()>0)
                {
                    $data['ubo_count'] = $res->num_rows();
                    $data['ubo'] = $res->result();
                }
                $string = $this->load->view('fatca_feed_karvy_pvt', $data);
            }
            else
            {
                $string = $this->load->view('fatca_feed_karvy', $data);
            }
            
            // $fileName="fatca$".$pan.'$'.date('dmY').'.csv';
            // $path="assets/uploads/csv_karvy/".$fileName;
            // $myfile =fopen($path, "w");
            // $result=fwrite($myfile, $string);
            // fclose($myfile);
            // if($result)
            // {
            //     echo '{"success":true,"url":"'.$path.'"}';
            //     log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadKarvyCsvFile, Message: Successfully downloaded karvy csv file for investor id = "'.$investorId.'" *****');
            // }
            // else
            // {
            //     echo '{"success":false,"msg":"Failed try again server error found."}';
            //     log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadKarvyCsvFile, Message: Failed to download karvy csv file for investor id = "'.$investorId.'" *****');
            // }
    }
	
	
	
    // downaload karvy csv file..


    // downaload cams csv file..
    function downloadCamsCsvFile()
    {
        if(checkuser_session())
        {
            $investorId = $this->input->post("investorId");
            $investorDetails = $this->first_purchase_api_type_report_model->getInvestorDetails($investorId);
            $taxResidency =  $this->first_purchase_api_type_report_model->getTaxresidency($investorId);
            $data["investorDetails"]=$investorDetails;
            $data["taxResidency"]=$taxResidency;
            $pan=$this->encrypt->decode($investorDetails->pan);
			
			if($investorDetails->investor_type_id == 9 || $investorDetails->investor_type_id == 11)
			{
				if($investorDetails->investor_type_id == 9)
				{
					$res = $this->db->from("company_partners")->where(["investor_id"=>$investorId,"percent_of_beneficial >" => 14])->get();
				}
				else
				{
					$res = $this->db->from("company_partners")->where(["investor_id"=>$investorId,"percent_of_beneficial >" => 14])->get();
				}
				
				if($res->num_rows()>0)
				{
					$data['ubo_count'] = $res->num_rows();
					$data['ubo'] = $res->result();
				}

                $data['state_array'] = [
                    "AN" => "Andaman & Nicobar",
                    "AP" => "Andhra Pradesh",
                    "AR" => "Arunachal Pradesh",
                    "AS" => "Assam",
                    "BR" => "Bihar",
                    "CH" => "Chandigarh",
                    "CG" => "Chattisgarh",
                    "DN" => "Dadra and Nagar Haveli",
                    "DD" => "Daman & Diu",
                    "DL" => "Delhi",
                    "GA" => "Goa",
                    "GJ" => "Gujarat",
                    "HR" => "Haryana",
                    "HP" => "Himachal Pradesh",
                    "JK" => "Jammu & Kashmir",
                    "JH" => "Jharkhand",
                    "KA" => "Karnataka",
                    "KL" => "Kerala",
                    "LD" => "Lakshadweep",
                    "MP" => "Madhya Pradesh",
                    "MH" => "Maharashtra",
                    "MN" => "Manipur",
                    "ML" => "Meghalaya",
                    "MZ" => "Mizoram",
                    "NL" => "Nagaland",
                    "OR" => "Orissa",
                    "PY" => "Pondicherry",
                    "PB" => "Punjab",
                    "RJ" => "Rajasthan",
                    "SK" => "Sikkim",
                    "TN" => "Tamil Nadu",
                    "TR" => "Tripura",
                    "UP" => "Uttar Pradesh",
                    "UA" => "Uttarakhand",
                    "WB" => "West Bengal",
                    "XX" => "Others"
                ];

				$string = $this->load->view('fatca_feed_cams_pvt', $data, true);
			}
			else
			{
				$string = $this->load->view('fatca_feed_cams', $data, true);
			}
            
            $fileName="fatca$".$pan.'$'.date('dmY').'.csv';
            $path="assets/uploads/csv_cams/".$fileName;
            $myfile =fopen($path, "w");
            $result=fwrite($myfile, $string);
            fclose($myfile);
            if($result)
            {
                echo '{"success":true,"url":"'.$path.'"}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadCamsCsvFile, Message: Successfully downloaded cams csv file for investor id = "'.$investorId.'" *****');
            }
            else
            {
                echo '{"success":false,"msg":"Failed try again server error found."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadCamsCsvFile, Message: Failed to download cams csv file for investor id = "'.$investorId.'" *****');
				
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller: firstPurchaseByApiTypeReport, Function: downloadCamsCsvFile, Message: Session out on trying to download cams csv file *****');
        }
    }

    // download Karvy dbf
    function downloadKarvyDbfFile()
    {
        if(checkuser_session())
        {
            define ('BOOLEAN_FIELD',   'L');
            define ('CHARACTER_FIELD', 'C');
            define ('DATE_FIELD',      'D');
            define ('NUMBER_FIELD',    'N');

            define ('READ_ONLY',  '0');
            define ('WRITE_ONLY', '1');
            define ('READ_WRITE', '2');

            $investorId=$this->input->post("investorId");
            $batchId=$this->input->post("batchId");
            $investorDetails = $this->first_purchase_api_type_report_model->getInvestorDetails($investorId);
            $investorStatus = $this->first_purchase_api_type_report_model->getInvestorStatus($investorId);
            $kycStatus=$investorStatus->is_kyc_done;
            $arnNumber=$this->config->item("arn_number");
            $arn=explode('-', $arnNumber);
            if($investorDetails)
            {
                $investorName=$this->encrypt->decode($investorDetails->first_name);
                $panNo=$this->encrypt->decode($investorDetails->pan);
                $InvestorId=$investorDetails->investor_id;

                if($kycStatus==1)
                {
                    $docTypeList='AOF,PAN';
                }else{
                    $docTypeList='AOF,PAN,KYC';
                }

                $Field1=$batchId;
                $Field2="1";
                $Field3=$arn[1].$panNo;
                $Field4="";// optional
                $Field5="investocafe";//Broker code
                $Field6=$arnNumber;
                $Field7="";// optional
                $Field8="";// optional
                $Field9=$investorName;
                $Field10="1";
                $Field11="N";
                $Field12="ON";
                $Field13=$docTypeList;
                $Field14=$panNo;
                $Field15=$InvestorId;
                $Field16="Y";
            }

            $addData=array($Field1,$Field2,$Field3,$Field4,$Field5,$Field6,$Field7,$Field8,$Field9,$Field10,$Field11,$Field12,$Field13,$Field14,$Field15,$Field16);
            $def = array(
              array("Field1","C",20),
              array("Field2","N",15,0),
              array("Field3","C",15),
              array("Field4","C",3),
              array("Field5","C",20),
              array("Field6","C",20),
              array("Field7","C",15),
              array("Field8",  "C",18),
              array("Field9", "C",70),
              array("Field10", "C",1),
              array("Field11", "C",1),
              array("Field12", "C",2),
              array("Field13", "C",30),
              array("Field14", "C",10),
              array("Field15", "C",20),
              array("Field16", "C",1),
            );

            // creation
            $datadir="assets/uploads/dbf_karvy/";
            $fileName="DOC_".$arnNumber.date("dmy")."_".$InvestorId.".dbf";
            $path=base_url().$datadir.$fileName;
            if (dbase_create($datadir.$fileName, $def))
            {
                $id = dbase_open ($datadir.$fileName,2);
                dbase_add_record($id, $addData);
                echo '{"success":true,"url":"'.$path.'"}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadDbfFile, Message: Successfully created dbf file to download for investor id = "'.$investorId.'" *****');
            }else{
                echo '{"success":false,"msg":"Failed try again server error found."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadDbfFile, Message: Failed to create dbf file to download for investor id = "'.$investorId.'" *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller: firstPurchaseByApiTypeReport, Function: downloadDbfFile, Message: Session out on trying to download dbf file *****');
        }
    }

    // download Cams text file
    function downloadCamsTextFile()
    {
        if(checkuser_session())
        {
            $investorId=$this->input->post("investorId");
            $investorDetails = $this->first_purchase_api_type_report_model->getInvestorDetails($investorId);
            $arnNumber=$this->config->item("arn_number");
            $arn=explode('-', $arnNumber);
            if($investorDetails)
            {
                $investorName=$this->encrypt->decode($investorDetails->first_name);
                $pan=$this->encrypt->decode($investorDetails->pan);
                $InvestorId=$investorDetails->investor_id;

                $string=$arnNumber."|".$pan.'|'.$investorName."|ALL|".$arnNumber."$".$pan.'$ALL';
            }

            $fileName='DATA-'.$pan.'.txt';
            $path="assets/uploads/text_cams/".$fileName;
            $myfile =fopen($path, "w");
            $result=fwrite($myfile, $string);
            fclose($myfile);
            if(file_exists(realpath($path)))
            {
                echo '{"success":true,"url":"'.base_url().$path.'"}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadCamsTextFile, Message: Successfully downloaded cams text file for investor id = "'.$investorId.'" *****');
            }
            else
            {
                echo '{"success":false,"msg":"Failed try again server error found."}';
                log_message('info', '***** User Id : '.$_SESSION["userId"].', Controller: firstPurchaseByApiTypeReport, Function: downloadCamsTextFile, Message: Failed to download cams text file for investor id = "'.$investorId.'" *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
            log_message('info', '***** Controller: firstPurchaseByApiTypeReport, Function: downloadCamsTextFile, Message: Session out on trying to download cams text file *****');
        }
    }
	
	public function checkbox()
	{
		if(checkuser_session())
        {
			$investorId=$this->input->post("investorId");
			$this->db->where('investor_id',$investorId)
					 ->update('investor',['first_purchase_doc' => 1]);
			if($this->db->affected_rows() >0 )
			{
				echo '{"success":true}';
			}
			else
			{
				echo '{"success":false,"msg":"error"}';
			}
			
		}
		else
		{
			echo '{"success":false,"session":"out"}';	
		}
	}
	
	
	function downloadCamsCsvFiletest()
    {
       
            $investorId = 523;
            $investorDetails = $this->first_purchase_api_type_report_model->getInvestorDetails($investorId);
            $taxResidency =  $this->first_purchase_api_type_report_model->getTaxresidency($investorId);
			
            $data["investorDetails"]=$investorDetails;
            $data["taxResidency"]=$taxResidency;

            $pan=$this->encrypt->decode($investorDetails->pan);
			
            
            $fileName="fatca$".$pan.'$'.date('dmY').'.csv';
            $path="assets/uploads/csv_cams/".$fileName;
            $myfile =fopen($path, "w");
            $result=fwrite($myfile, $string);
            fclose($myfile);
            if($result)
            {
                echo '{"success":true,"url":"'.$path.'"}';
			}

    }
}
