<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class FundDocuments extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
		 $this->load->model('fund_documents_model');
	}

	public function index()
	{
		$this->data['pageTitle'] = 'Fund Documents';
	 	$this->_loadNewView('fund_documents_view');
		
  	}

	function _loadNewView($view,$fundIdData)
  	{
		if(checkuser_session())
		{
			$this->data['getGoing']="dashboard";
		}
		else
		{
			$this->data['getGoing']="registration";
		}
		$userId=$_SESSION["userId"];
		$investorId=$_SESSION["investor_id"];
		$fundDetailsResult=$this->fund_documents_model->getFundDetails($fundIdData);
		$this->data["amcCode"]=$fundDetailsResult->AMC_code;
		$this->data["fundName"]=$fundDetailsResult->scheme_description;
		$this->data["minPurchaseAmt"]=$fundDetailsResult->min_purchase_amt;
		$this->data["purchaseInMultipleOf"]=$fundDetailsResult->purchase_in_multiple_of;
		$this->data["min_additional_purchase_amt"]=$fundDetailsResult->min_additional_purchase_amt;
		$this->data["additional_purchase_in_multiple_of"]=$fundDetailsResult->additional_purchase_in_multiple_of;
		$this->data["redemption_min_amount"]=$fundDetailsResult->redemption_min_amount;
		$this->data["redemption_min_units"]=$fundDetailsResult->redemption_min_units;
		$this->data["SIPminAmount"]=$fundDetailsResult->SIP_min_amount;
		$this->data["SIPinMultipleOf"]=$fundDetailsResult->SIP_in_multiple_of;
		$fundPdfResult=$this->fund_documents_model->getFundPdfList($fundIdData);

		if($fundPdfResult)
		{
			$this->data["fundPdfList"]=$fundPdfResult;
		}

		$fundRiskometer=$this->fund_documents_model->getFundRiskometerUrl($fundIdData);
		if($fundRiskometer)
		{
			$this->data["riskometerUrl"]=$fundRiskometer->riskometer_url;
		}

		$fundInfoDetails=$this->fund_documents_model->getFundInfoDetails($fundIdData);
		if($fundInfoDetails)
		{
			$this->data["fundInfoDetails"]=$fundInfoDetails;
		}
		
		
		$partnerFundIdResult=$this->fund_documents_model->getPartnerFundId($fundIdData);
		if($partnerFundIdResult)
		{
			if($partnerFundIdResult->partner_fund_id!=0)
			{
				$this->data["partnerFundIdExists"]=1;
				$partnerFundId=$partnerFundIdResult->partner_fund_id;

				$partnerFundDetailsResult=$this->fund_documents_model->getFundDetails($partnerFundId);
				$this->data["partner_amcCode"]=$partnerFundDetailsResult->AMC_code;
				$this->data["partner_fundName"]=$partnerFundDetailsResult->scheme_description;
				$this->data["partner_minPurchaseAmt"]=$partnerFundDetailsResult->min_purchase_amt;
				$this->data["partner_purchaseInMultipleOf"]=$partnerFundDetailsResult->purchase_in_multiple_of;
				$this->data["partner_min_additional_purchase_amt"]=$partnerFundDetailsResult->min_additional_purchase_amt;
				$this->data["partner_additional_purchase_in_multiple_of"]=$partnerFundDetailsResult->additional_purchase_in_multiple_of;
				$this->data["partner_redemption_min_amount"]=$partnerFundDetailsResult->redemption_min_amount;
				$this->data["partner_redemption_min_units"]=$partnerFundDetailsResult->redemption_min_units;
				$this->data["partner_SIPminAmount"]=$partnerFundDetailsResult->SIP_min_amount;
				$this->data["partner_SIPinMultipleOf"]=$partnerFundDetailsResult->SIP_in_multiple_of;
				$partnerFundRiskometer=$this->fund_documents_model->getFundRiskometerUrl($partnerFundId);
				if($partnerFundRiskometer)
				{
					$this->data["partnerRiskometerUrl"]=$partnerFundRiskometer->riskometer_url;
				}
			}
			else
			{
				$this->data["partnerFundIdExists"]=0;
			}
		}

		// print_r($fundDetailsResult->min_purchase_amt);die;
	  	$this->data['jsFile'] = 'fundDocuments.js';
	    //$this->load->view('includes/header',$this->data);
	    $this->load->view($view,$this->data);
	    //$this->load->view('includes/footer',$this->data );
  	}

	function id($fundIdData=0)
	{

		$this->_loadNewView("fund_documents_view",$fundIdData);
	}
	
	public function testCheckFunds($fundIdData){
	echo 'fund id:'.$fundIdData.' <br>';
	$fundDetailsResult=$this->fund_documents_model->getFundDetails($fundIdData);
		if($fundDetailsResult){
			
		$this->data["amcCode"]=$fundDetailsResult->AMC_code;
		$this->data["fundName"]=$fundDetailsResult->scheme_description;
		$this->data["minPurchaseAmt"]=$fundDetailsResult->min_purchase_amt;
		$this->data["purchaseInMultipleOf"]=$fundDetailsResult->purchase_in_multiple_of;
		$this->data["min_additional_purchase_amt"]=$fundDetailsResult->min_additional_purchase_amt;
		$this->data["additional_purchase_in_multiple_of"]=$fundDetailsResult->additional_purchase_in_multiple_of;
		$this->data["redemption_min_amount"]=$fundDetailsResult->redemption_min_amount;
		$this->data["redemption_min_units"]=$fundDetailsResult->redemption_min_units;
		$this->data["SIPminAmount"]=$fundDetailsResult->SIP_min_amount;
		$this->data["SIPinMultipleOf"]=$fundDetailsResult->SIP_in_multiple_of;

		$fundPdfResult=$this->fund_documents_model->getFundPdfList($fundIdData);
		if($fundPdfResult)
		{
			$this->data["fundPdfList"]=$fundPdfResult;
		}

		$fundRiskometer=$this->fund_documents_model->getFundRiskometerUrl($fundIdData);
		if($fundRiskometer)
		{
			$this->data["riskometerUrl"]=$fundRiskometer->riskometer_url;
		}

		$partnerFundIdResult=$this->fund_documents_model->getPartnerFundId($fundIdData);
		if($partnerFundIdResult)
		{
			if($partnerFundIdResult->partner_fund_id!=0)
			{
				$this->data["partnerFundIdExists"]=1;
				$partnerFundId=$partnerFundIdResult->partner_fund_id;
				$partnerFundDetailsResult=$this->fund_documents_model->getFundDetails($partnerFundId);
				$this->data["partner_amcCode"]=$partnerFundDetailsResult->AMC_code;
				$this->data["partner_fundName"]=$partnerFundDetailsResult->scheme_description;
				$this->data["partner_minPurchaseAmt"]=$partnerFundDetailsResult->min_purchase_amt;
				$this->data["partner_purchaseInMultipleOf"]=$partnerFundDetailsResult->purchase_in_multiple_of;
				$this->data["partner_min_additional_purchase_amt"]=$partnerFundDetailsResult->min_additional_purchase_amt;
				$this->data["partner_additional_purchase_in_multiple_of"]=$partnerFundDetailsResult->additional_purchase_in_multiple_of;
				$this->data["partner_redemption_min_amount"]=$partnerFundDetailsResult->redemption_min_amount;
				$this->data["partner_redemption_min_units"]=$partnerFundDetailsResult->redemption_min_units;
				$this->data["partner_SIPminAmount"]=$partnerFundDetailsResult->SIP_min_amount;
				$this->data["partner_SIPinMultipleOf"]=$partnerFundDetailsResult->SIP_in_multiple_of;
				$partnerFundRiskometer=$this->fund_documents_model->getFundRiskometerUrl($partnerFundId);
				if($partnerFundRiskometer)
				{
					$this->data["partnerRiskometerUrl"]=$partnerFundRiskometer->riskometer_url;
				}
			}
			else
			{
				$this->data["partnerFundIdExists"]=0;
			}
		}else{
			log_message('info', '*****  Controller : FundDocuments, Function : testCheckFunds, Message : partnerFundIdResult not exists *****');
			echo 'partnerFundIdResult not exists';
		}
			
		
		echo '<pre>';
		print_r($this->data);
		}else{
			log_message('info', '*****  Controller : FundDocuments, Function : testCheckFunds, Message : fund not exists with id *****');
			echo 'fund not exists with id';
		}
		
		
	}
	
	
	
	
}
