<?php

class Redeem extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		$this->load->model('gold/gold_auth_model','gam');
		$this->load->helper('gold');
	}

	public function index()
	{
		$res = $this->db->where('is_active',1)->get('product_catalog');
		if($res->num_rows() > 0){
			$data['product_catalog'] = $res->result();
			$view = "product_catalog_view";
			layout($data,$view);
		}
	}

	public function product($product_id)
	{
		$res = $this->db->where('product_catalog_id',$product_id)->get('product_catalog');
		if($res->num_rows() > 0){
			$data['product_catalog'] = $res->row();
			$data['balQuantity'] = $this->getBalance();

			$view = "product_redeem_view";
			layout($data,$view);
		}
	}

	public function getBalance()
    {
    	if(!checkuser_session()){
			return redirect('https://www.investocafe.com/loginRegistration?login=true');
		}
		$uri = "oat/getportfoliobalance";
		$payload = '';
		$cookie = get_token();
		$addHeaders = 'customerRefNo:'.$_SESSION['investor_id'];
		$response = postfn($uri,$payload,$cookie,$addHeaders);
		$gold_data = json_decode($response);
		if($gold_data){
			return $gold_data[0]->balQuantity;
		}else{
			return '00.00';
		}
    }

    public function placeRequest()
    {
    	if(!checkuser_session()){
			return '{"success":false, "msg":"sesstion out"}';
			
		}

    	if($_POST){
    		$investorId = $_SESSION['investor_id'];
    		
    		$res = $this->db->query("SELECT `address`, `address_2`, original_city, state.state_name, `pincode`, users.phone, state.fatca_code, state.gold_code FROM investor JOIN state ON state.id = investor.state_id JOIN users ON users.id = investor.login_id WHERE investor_id = $investorId");
    		if($res->num_rows() > 0){

    			$product = $this->db->where('sku_code',$_POST['productSKU'])->get('product_catalog');
    			if($product->num_rows() > 0){
    				$productRow = $product->row();
    				$add = $res->row();
	    			$data = [
						"customerRefNo"=> $investorId,
						"transactionRefNo"=> "123456",
						"productList"=> [
								[
								  "productSKU"=> $_POST['productSKU'],
								  "quantity"=> $_POST['redeem_units'],
								  "makingCharge"=> $productRow->all_total
								]
						],
						"channel"=> "WEB",
						"deliveryAddress"=> [
							"line1"=> $add->address,
							"line2"=> $add->address_2,
							"city"=> $add->original_city,
							"state"=> $add->state_name,
							"zip"=> $add->pincode,
							"country"=> "India",
							"mobileNumber"=> decode($add->phone),
							"statecode"=> $add->gold_code
						]
	    			];

					$uri = "redeem/rfqredeem";
					$payload = json_encode($data);
					$cookie = get_token();
					$response = postfn($uri,$payload,$cookie);
					$gold_data = json_decode($response);
					if( property_exists($gold_data,'quoteId') ){
						$arr_data = [
							"quoteId" => $gold_data->quoteId,
							"grandTotal" => $gold_data->grandTotal,
							"metalTotal" => $gold_data->metalTotal,
							"metalValue" => $gold_data->metalValue,
							"productSKU" => $gold_data->productList[0]->productSKU,
							"hsnCode" => $gold_data->productList[0]->hsnCode,
							"preTaxPrice" => $gold_data->productList[0]->preTaxPrice,
							"quantity" => $gold_data->productList[0]->quantity,
							"investor_id"=>$investorId
						];

						$this->db->insert('gold_redeem',$arr_data);
						$batchId  = $this->db->insert_id();
						$this->payMakingCharges($batchId,$gold_data->grandTotal);
						
					}else{
						echo '{"success":false,"msg":"somthing went to wrong"}';
					}
    			}else{
    				echo '{"success":false,"msg":"Product not found"}';
    			}
    			
    		}else{
    			echo '{"success":false,"msg":"address not found"}';
    		}
    	}else{
    		echo '{"success":false,"msg":"data not received"}';
    	}
    }

    public function payMakingCharges($batchId,$amount)
    {
		$investorId=$_SESSION["investor_id"];
		$this->load->model('registration/registration_model','registration_model');
		$getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
		$getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
		$investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
		$netbankingData['totalAmount'] = $amount;
		$netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
		$netbankingData['prodStr'] = "<product><id>1</id><name>RMFAMC</name><amount>".$amount."</amount></product>";
		$netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
		$netbankingData['investorEmail'] = $getInvestorDetails->email;
		$netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
		$netbankingData['investorAddress'] = $getInvestorDetails->address;
		$netbankingData['batchId'] = $batchId;
		$this->netbankingRequest($netbankingData,$batchId);
    }

    public function netbankingRequest($netbankingData,$transactionId)
    {
        $resonceUrl = 'gold/redeem/netBankingResponse';
        $investorId=$_SESSION["investor_id"];
        date_default_timezone_set("Asia/Kolkata");
        $datenow = date("d/m/Y");
        $this->config->load('config_atom');
        $paymentUrl = $this->config->item('Url');
        $postFields  = "";
        $postFields .= "&login=".$this->config->item('Login');
        $postFields .= "&pass=".$this->config->item('Password');
        $postFields .= "&ttype=".$this->config->item('ttype');
        $postFields .= "&prodid=".'Multi';
        $postFields .= "&amt=".$netbankingData['totalAmount'];
        $postFields .= "&txncurr=".$this->config->item('TxnCurr');
        $postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
        $postFields .= "&clientcode=".urlencode(base64_encode($this->config->item('clientCode')));
        $postFields .= "&txnid=".$transactionId;
        $postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
        $postFields .= "&date=".$datenow;
        $postFields .= "&mprod=".$netbankingData['prodStr'];
        $postFields .= "&udf1=".$netbankingData['investorName'];
        $postFields .= "&udf2=".$netbankingData['investorEmail'];
        $postFields .= "&udf3=".$netbankingData['investorMobile'];
        $postFields .= "&ru=".base_url().$resonceUrl;
        $postFields .= "&udf9=purchaseTransaction";
        $postFields .= "&bankid=".$netbankingData['bankid'];


        $str = $this->config->item('Login') . $this->config->item('Password') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";

        $signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKey'),false);

        $postFields .= "&signature=".$signature;
        $sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
        $sendUrlNew = $paymentUrl."?".substr($postFields,1);
        echo '{"success":true,"amount":"'.$netbankingData['totalAmount'].'", "url":"'.$sendUrlNew.'"}';
    }

    public function netBankingResponse()
    {
    	$response = $_POST;
    	$str = $response["mmp_txn"].$response["mer_txn"].$response["f_code"].$response["prod"].$response["discriminator"].$response["amt"].$response["bank_txn"];
        $signature =  hash_hmac("sha512",$str,$this->config->item("respHashKey"),false);
        $this->load->model('purchase/purchase_model');
        $updateResNetbanking = $this->purchase_model->addNetbankingEntry($response);
        if($response['f_code']=="Ok"){
        	$this->db->where('gold_redeem_id',$response['mer_txn'])->update('gold_redeem',['is_success',1]);
        	$this->session->set_flashdata('message', "transection amount of Rs. ".$response["amt"]. " is successful ");
        	$this->requestToRedeem($response['mer_txn']);
        }else{
        	$this->session->set_flashdata('message', " Rs. ".$response["amt"]. " Transection is failed");
        }
        return redirect('gold/trade/confirm');
    }


    public function requestToRedeem($gold_redeem_id)
    {
    	echo $gold_redeem_id;
    	$res = $this->db->where('gold_redeem_id',$gold_redeem_id)->get('gold_redeem');
    	if($res->num_rows() > 0){
    		$row = $res->row();
    		$data = [
			  "quoteId"=> $row->quoteId,
			  "transactionDate"=> $row->ts.".123",
			  "transactionOrderID"=>$gold_redeem_id
			];
			$uri = "redeem/rfqexecuteredeem";
			$payload = json_encode($data);
			$cookie = get_token();
			$response = postfn($uri,$payload,$cookie);
			$gold_data = json_decode($response);
			$data = [
				"gm"=> -$row->metalTotal,
				"amount" =>0,
				"tax1" => 0,
				"tax2" => 0,
				"prtax_amt"=> 0,
				"investor_id"=>$row->investor_id,
				"quoteId"=>$row->quoteId,
				"rate"=>0,
				"purchase_type"=>1,
				"sip_id" => 0,
				"is_netbanking"=>0,
				"txn_type"=>3
			];
			$res = $this->db->insert('gold_purchase_units',$data);
			return true;
    	}else{
    		return false;
    	}
    }
}