<?php

class Trade extends CI_Controller{

	function __construct()
	{
		parent::__construct();
		$this->load->model('gold/gold_auth_model','gam');
		$this->load->helper('gold');
	}


	public function gdDashboard()
	{
		if(!checkuser_session()){
			return redirect('https://www.investocafe.com/loginRegistration?login=true');
		}
		$data=[];
		$investorId = $_SESSION['investor_id'];
		$data['is_profile_created'] = $this->gam->getDashboardData();
		$data['gm'] = $this->gam->getPortFolio($investorId);
		$view = "gold_dashboard_view";
		layout($data,$view);
	}

	public function getBalance()
    {
    	
		$uri = "oat/getportfoliobalance";
		echo $payload = '';
		$cookie = get_token();
		$addHeaders = 'customerRefNo:'.$_SESSION['investor_id'];
		$response = postfn($uri,$payload,$cookie,$addHeaders);
		$gold_data = json_decode($response);
		if($gold_data){
			return $gold_data[0]->balQuantity;
		}else{
			return '00.00';
		}
    }

	public function gdPurchaseType()
	{
		if(!checkuser_session()){
			return redirect('https://www.investocafe.com/loginRegistration?login=true');
		}
		$view = "gd_purchase_type_view";
		$data=[];
		layout($data,$view);
	}

	public function confirm()
	{
		$view = "confirm_txn_view";
		$data=[];
		layout($data,$view);
	}


	public function getTrade()
	{
		if(!checkuser_session()){
			return redirect('https://www.investocafe.com/loginRegistration?login=true');
		}
		$uri = "trade/getQuoteBuy";
		$payload = "";
		$cookie = get_token();
		$response = postfn($uri,$payload,$cookie);
		$gold_data = json_decode($response);
		// echo "<pre>";
		// print_r($gold_data);
		// exit;
		$view = "rate_view";
		$data=[];
		layout(compact('gold_data'),$view);
	}

	function cutAfterDot($number, $afterDot = 4){
		$a = $number * pow(10, $afterDot);
		$b = floor($a);
		$c = pow(10, $afterDot);
		// echo "a $a, b $b, c $c<br/>";
		return $a/$c ;
	}

	public function save()
	{
		if(!checkuser_session()){
			echo '{"success":false,"msg":"Session out"}';	
		}
		if($_POST){
			$sip_id = 0;
			$isNatBanking=0;
			if($_POST['purchase_type']==2){
				$sdata = [
					"amount" =>$_POST['gold_amount'],
					"investor_id"=>$_SESSION['investor_id'],
					"sip_date"=>$_POST['datepicker'],
					"number_of_month"=>120
				];

				$response = $this->db->insert('gold_sip',$sdata);
				$sip_id  = $this->db->insert_id();
			}
			if($_POST['txn_type']==2) $isNatBanking=1;
			$gm = ($_POST['gold_amount']/$_POST['rate']);
			$gm = (sprintf('%.4f', floor($gm*10000*($gm>0?1:-1))/10000*($gm>0?1:-1)));
			$tax1 = round($_POST['gold_amount']*(1-(1/(1+ (3/100) )))*((1.5/100)/ (3/100) ),2);
			$tax2=$tax1;
			$beforeamount = $_POST['gold_amount'] - 2*$tax1;
			$data = [
				"gm"=> $gm,
				"amount" =>$_POST['gold_amount'],
				"tax1" => $tax1,
				"tax2" => $tax2,
				"prtax_amt"=> $beforeamount,
				"investor_id"=>$_SESSION['investor_id'],
				"quoteId"=>$_POST['batch_id'],
				"rate"=>$_POST['rate'],
				"purchase_type"=>$_POST['purchase_type'],
				"sip_id" => $sip_id,
				"is_netbanking"=>$isNatBanking
			];
			$res = $this->db->insert('gold_purchase_units',$data);
			$batchId  = $this->db->insert_id();
			if($res){
				if($_POST['txn_type']==2){
					$investorId=$_SESSION["investor_id"];
					$this->load->model('registration/registration_model','registration_model');
					$getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
					$getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
					$investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
					$netbankingData['totalAmount'] = $_POST['gold_amount'];
					$netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
					$netbankingData['prodStr'] = "<product><id>1</id><name>RMFAMC</name><amount>".$_POST['gold_amount']."</amount></product>";
					$netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
					$netbankingData['investorEmail'] = $getInvestorDetails->email;
					$netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
					$netbankingData['investorAddress'] = $getInvestorDetails->address;
					$netbankingData['batchId'] = $batchId;
					$this->netbankingRequest($netbankingData,$batchId);
				}else{
					$this->session->set_flashdata('message', " Rs. ".$_POST['gold_amount']. " invested in gold effect from ".Date("d M, Y"));
					echo '{"sucess":true,"msg":"sucesspully add","url":"'.base_url('gold/trade/confirm').'"}';
				}
			}else{
				echo '{"somthing went to wrong please try again"}';
			}

		}else{
			echo '{"success":false,"msg":"data not recieve"}';
		}
	}

	public function netbankingRequest($netbankingData,$transactionId)
    {
        $resonceUrl = 'gold/trade/netBankingResponse';
        $investorId=$_SESSION["investor_id"];
        date_default_timezone_set("Asia/Kolkata");
        $datenow = date("d/m/Y");
        $this->config->load('config_atom');
        $paymentUrl = $this->config->item('Url');
        $postFields  = "";
        $postFields .= "&login=".$this->config->item('Login');
        $postFields .= "&pass=".$this->config->item('Password');
        $postFields .= "&ttype=".$this->config->item('ttype');
        $postFields .= "&prodid=".'Multi';
        $postFields .= "&amt=".$netbankingData['totalAmount'];
        $postFields .= "&txncurr=".$this->config->item('TxnCurr');
        $postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
        $postFields .= "&clientcode=".urlencode(base64_encode($this->config->item('clientCode')));
        $postFields .= "&txnid=".$transactionId;
        $postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
        $postFields .= "&date=".$datenow;
        $postFields .= "&mprod=".$netbankingData['prodStr'];
        $postFields .= "&udf1=".$netbankingData['investorName'];
        $postFields .= "&udf2=".$netbankingData['investorEmail'];
        $postFields .= "&udf3=".$netbankingData['investorMobile'];
        $postFields .= "&ru=".base_url().$resonceUrl;
        $postFields .= "&udf9=purchaseTransaction";
        $postFields .= "&bankid=".$netbankingData['bankid'];


        $str = $this->config->item('Login') . $this->config->item('Password') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";

        $signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKey'),false);

        $postFields .= "&signature=".$signature;
        $sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
        $sendUrlNew = $paymentUrl."?".substr($postFields,1);
        echo '{"sucess":true,"url":"'.$sendUrlNew.'"}';
    }


    public function netBankingResponse()
    {
    	$response = $_POST;
    	$str = $response["mmp_txn"].$response["mer_txn"].$response["f_code"].$response["prod"].$response["discriminator"].$response["amt"].$response["bank_txn"];
        $signature =  hash_hmac("sha512",$str,$this->config->item("respHashKey"),false);
        $this->load->model('purchase/purchase_model');
        $updateResNetbanking = $this->purchase_model->addNetbankingEntry($response);
        if($response['f_code']=="Ok"){
        	echo "run";
        	$this->session->set_flashdata('message', " Rs. ".$response["amt"]. " invested in gold effect from ".Date("d M, Y"));
        	$this->db->where('gold_purchase_units_id',$response["mer_txn"])
        	->update('gold_purchase_units',['txn_id'=>$response['mmp_txn'],'is_netbanking_success'=>1]);
        	$this->orderPlace($response['mer_txn']);
        }else{
        	$this->session->set_flashdata('message', " Rs. ".$response["amt"]. " Transection is failed");
        }

        return redirect('gold/trade/confirm');
    }


    public function orderPlace($txn_number)
    {
    	$payload = $this->gam->getGDPurchase($txn_number);
    	if($payload){
    		$uri = "trade/rfqexecuteWithUpdatedQuote";
			$cookie = get_token();
			$response = postfn($uri,$payload,$cookie);
			echo "<pre>";
			print_r($response);
			exit;
			$gold_data = json_decode($response);
			if(property_exists($gold_data,'quantity')){
				unset($gold_data->billingAddress);
				$gold_data->txn_number = $txn_number;
				$this->db->insert('gold_response',(object) $gold_data);
				$this->db->where('gold_purchase_units_id',$txn_number)
        		->update('gold_purchase_units',['trans_upload_status'=>2]);
				// return redirect('gold/trade/confirm');
				return true;
			}else{
				// echo "Falied ".$txn_number." ".json_encode($response);
				return false;
			}
    	}else{
    		return false;
    	}
    }


    public function redeem()
    {
    	if(!checkuser_session()){
			return redirect('https://www.investocafe.com/loginRegistration?login=true');
		}
		$uri = "trade/getQuoteSell";
		$payload = "";
		$cookie = get_token();
		$response = postfn($uri,$payload,$cookie);
		$gold_data = json_decode($response);
		$view = "sell_view";
		$data=[];
		$investorId = $_SESSION['investor_id'];
		$data['gm'] = $this->gam->getPortFolio($investorId);
		$data['gold_data'] = $gold_data;
		layout(compact('gold_data','data'),$view);
    }

    public function saveRedemtion()
	{
		if(!checkuser_session()){
			echo '{"success":false,"msg":"Session out"}';	
		}
		if($_POST){
			$sip_id = 0;
			$isNatBanking=0;
			$gm = round($_POST['gold_amount']/$_POST['rate'],4);
			// echo $gm = (sprintf('%.4f', floor($gm*10000*($gm>0?1:-1))/10000*($gm>0?1:-1)));
			$tax1 = round($_POST['gold_amount']*(1-(1/(1+ (3/100) )))*((1.5/100)/ (3/100) ),2);
			$tax2=$tax1;
			$beforeamount = $_POST['gold_amount'] - 2*$tax1;
			$data = [
				"gm"=> -$gm,
				"amount" =>$_POST['gold_amount'],
				"tax1" => 0,
				"tax2" => 0,
				"prtax_amt"=> $_POST['gold_amount'],
				"investor_id"=>$_SESSION['investor_id'],
				"quoteId"=>$_POST['batch_id'],
				"rate"=>$_POST['rate'],
				"purchase_type"=>$_POST['purchase_type'],
				"sip_id" => 0,
				"is_netbanking"=>0,
				"txn_type"=>2
			];

			$res = $this->db->insert('gold_purchase_units',$data);
			$batchId  = $this->db->insert_id();
			if($res){
				$response = $this->orderPlace($batchId);
				if($response){
					$this->session->set_flashdata('message', " Rs. ".$_POST['gold_amount']. " redeem request place successfuly, effect from ".Date("d M, Y"));
					echo '{"sucess":true,"msg":"sucesspully add","url":"'.base_url('gold/trade/confirm').'"}';
				}else{
					echo '{"success":false,"msg":"somthing went to wrong please try again"}';
				}
			}else{
				echo '{"success":false,"msg":"somthing went to wrong please try again"}';
			}

		}else{
			echo '{"success":false,"msg":"data not recieve"}';
		}
	}

}