<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : Home
|   MODEL USE : registration_model
|   DATE : 08/10/2016
|   AUTHOER : amit meena
|   COMMENT : This function is used to load home view and show data from database
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class Home extends CI_Controller {

  	function __construct()
  	{
  	    // Call the Model constructor
  	    parent::__construct();

        $this->load->model('submit_question_model');
        $this->load->model('registration_model');
        $this->load->model('home_model');
		$this->load->model('risk_profile_user_model', 'risk_model');
        $this->data = array();
  	}
    
/*
-----------------------------------------------------------------------------------------------------
|   USE : index
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS LOAD tdashboard view
-----------------------------------------------------------------------------------------------------
*/
  	public function index()
  	{
        $this->data['pageTitle'] = 'Investocafe';
        $this->data['title'] = "Online Mutual fund investment";
        $this->_loadNewView('amit_theme/home/home_view');
  	}

		public function home_test()
  	{ 
        $this->data['pageTitle'] = 'Investocafe';
        $this->_loadNewView_test('amit_theme/home/home_view_test');
  	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : _loadNewView
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is load header of footer view
-----------------------------------------------------------------------------------------------------
*/
    function _loadNewView($view)
    {
        $logged = $this->ion_auth->logged_in();
        $testimonial = $this->home_model->getTestimonial();
        $latest_blog = $this->home_model->get_popular_articles();
        $this->data['latest_blog'] = $latest_blog;
        $this->data['testimonial'] =array_slice($testimonial,0,4);
        if (checkuser_session()) {
            $this->data['getGoing'] = "dashboard";
            $result = $this->risk_model->checkInvestorIdExists($_SESSION["email"]);
            $this->data['name'] = $this->encrypt->decode($result->username);
            $this->data['email'] = $result->email;
            $this->data['phone'] = $this->encrypt->decode($result->phone);
        } else {
            $this->data['getGoing'] = "Welcome";
        }

        $this->data['jsFile'] = 'home/home.js';

        $this->load->view('theme/common/header',$this->data);
        $this->load->view('theme/home/home_view',$this->data);
        $this->load->view('theme/common/footer',$this->data);
    }

     function _loadNewView_test($view)
    {
        $logged=$this->ion_auth->logged_in();
        $testimonial = $this->home_model->getTestimonial();
        $this->data['testimonial'] = $testimonial;
        if(checkuser_session())
        {
            $this->data['getGoing']="dashboard";
            $result=$this->risk_model->checkInvestorIdExists($_SESSION["email"]);
            $this->data['name']=$this->encrypt->decode($result->username);
            $this->data['email']=$result->email;
            $this->data['phone']=$this->encrypt->decode($result->phone);
        }
        else
        {
          $this->data['getGoing']="Welcome";
        }
        // $allCompanyLogoResult=$this->home_model->getAllCompanyDetails();
        // $this->data["companyList"]=$allCompanyLogoResult;
        $this->data['jsFile'] ='home/home.js';
        $this->load->view('amit_theme/common/header_test',$this->data);
        $this->load->view($view,$this->data);
        $this->load->view('amit_theme/common/footer',$this->data );
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : howItWorks
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to show how it work our system
-----------------------------------------------------------------------------------------------------
*/
    public function howItWorks()
    {
        $this->data['pageTitle'] = 'Investocafe - How it Works';
        $this->_loadView('how_its_work_view');
        $data['page'] = true;
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : howItWorks
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This functin is used show our team
-----------------------------------------------------------------------------------------------------
*/
  	public function team()
  	{
        $this->data['pageTitle'] = 'Investocafe - Team';
  	     $this->_loadView('team_view');
  	}
/*
-----------------------------------------------------------------------------------------------------
|   USE : tour
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to show tour
-----------------------------------------------------------------------------------------------------
*/
    public function tour()
    {
        $this->data['pageTitle'] = 'Investocafe - Tour';
        $this->_loadView('tour_view');
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : contact
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to show contact detail
-----------------------------------------------------------------------------------------------------
*/
    public function contact()
    {
        $this->data['pageTitle'] = 'Investocafe - Contact';
        $this->_loadView('team_view');
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : help
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to load help section
-----------------------------------------------------------------------------------------------------
*/
    public function help()
    {
        $this->data['pageTitle'] = 'Investocafe - Help';
        $this->_loadView('help_view');
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : termsOfUse
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to get termsOfUse from testtimonial table
-----------------------------------------------------------------------------------------------------
*/
    public function termsOfUse()
    {
        $this->data['pageTitle'] = 'Investocafe - Terms of Use';
        $this->_loadView('terms_of_use_view');
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : privacyPolicy
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to get privacyPolicy of investocafe
-----------------------------------------------------------------------------------------------------
*/
    public function privacyPolicy()
    {
        $this->data['pageTitle'] = 'Investocafe - Privacy Policy';
        $this->_loadView('terms_of_use_view');
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : disclosures
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis get the disclosures of the investocafe
-----------------------------------------------------------------------------------------------------
*/
    public function disclosures()
    {
        $this->data['pageTitle'] = 'Investocafe - Disclosures';
        $this->_loadView('terms_of_use_view');
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : whyInvestocafe
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to get why investocafe
-----------------------------------------------------------------------------------------------------
*/
    public function whyInvestocafe()
    {
        $this->data['pageTitle'] = 'Why Investocafe';
        $this->_loadView('why_investocafe_view');
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : whyInvestocafe
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : ask question about investment
-----------------------------------------------------------------------------------------------------
*/
    function submitQuestion()
    {
        $name=$this->input->post('name');
        $emailId=$this->input->post('emailId')." Phone:".$this->input->post('phone');
        $question=$this->input->post('question');
        $data=array(
          "name"=>$name,
          "email"=>$emailId,
          "question"=>$question,
        );
        $result=$this->submit_question_model->submitQuestion($data);
        if($result)
        {
            $sent=$this->sendAskQuestionEmail($name,$emailId,$question);
            if($sent)
            {
                echo '{"success":true}';
                log_message('info', '***** Controller : home, Function : submitQuestion, Message : Successfully sent ask question email *****');
            }
            else
            {
                echo '{"success":false}';
                log_message('info', '***** Controller : home, Function : submitQuestion, Message : Failed to send ask question email *****');
            }
        }
        else
        {
          echo "failed";
          log_message('info', '***** Controller : home, Function : submitQuestion, Message : Failed to insert ask question data *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : _loadView
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to load header and footer of the view
-----------------------------------------------------------------------------------------------------
*/
    function _loadView($view)
    {
        $this->data['jsFile'] ='';
        $this->load->view('amit_theme/common/header',$this->data);
        $this->load->view($view,$this->data);
        $this->load->view('amit_theme/common/footer',$this->data );
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : sendAskQuestionEmail
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to  send Ask Question using  Email
-----------------------------------------------------------------------------------------------------
*/
    function sendAskQuestionEmail($name,$emailId,$question)
    {
        $today = date('d M Y h:i a', time());
        $data=array();
        $data["name"]=$name;
        $data["emailId"]=$emailId;
        $data["question"]=$question;
        $html=$this->load->view('ask_question_email_view', $data,true);
        $email = 'customercare@investocafe.com,info@investocafe.com';
        $subject="Ask Question From Investor";
		$out = sendEmail($email,$subject,$html);
		return true;
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : getBlogs
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to load blogs
-----------------------------------------------------------------------------------------------------
*/
    function getBlogs()
    {
        $ch = curl_init();

        //Like us on bit.ly/eshpind----------------
        $url1="http://api.tumblr.com/v2/blog/blog.investocafe.com/posts?api_key=OfGprXgbMOoRw4niPN4CrNgFclw1ZIxiGdSVJcpgqQbn0KEhg8&total_posts=2;";
        $url=str_replace(" ", "%20", $url1);
        //echo $url;
        curl_setopt($ch, CURLOPT_URL, $url);
        //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

        //return the transfer as a string
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        //$output contains the output string
        $output = curl_exec($ch);
        if ( $output === FALSE)
        {
            $output=curl_error($ch); //echoes last session error
            return false;
        }
        return $output;
    }

    function saveTempUserData()
    {
        // $tempUserEmailPhone=$this->input->post("tempUserEmailPhone");
        // $checkEmailExistsResult=$this->home_model->checkEmailExists($tempUserEmailPhone);
        // if($checkEmailExistsResult)
        // {
        //     $_SESSION["temp_email"]=$tempUserEmailPhone;
        //     echo '{"success":true,"response":"Email or phone exists in db.."}';
        //     log_message('info', '***** CheckEmailExists function true *****');
        // }
        // else
        // {
        //     $data["email_phone"]=$tempUserEmailPhone;
        //     $_SESSION["temp_email"]=$tempUserEmailPhone;
        //     $result=$this->home_model->saveTempUserData($data);
        //     if($result)
        //     {
        //         echo '{"success":true,"response":"Inserted Temp User Email or Phone"}';
        //         log_message('info', '***** Successfully inserted temporary user email or phone no. details *****');
        //     }
        // }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : updateTempUserData
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to update temp user
-----------------------------------------------------------------------------------------------------
*/
    function updateTempUserData()
    {
        $column_value=$this->input->post("column_value");
        $column_name=$this->input->post("column_name");
        $email=$_SESSION["temp_email"];
        if($column_name=="age_range")
        {
            $data["age_range"]=$column_value;
        }
        else if($column_name=="dependents_range")
        {
            $data["dependents_range"]=$column_value;
        }
        else if($column_name=="horizon_range")
        {
            $data["horizon_range"]=$column_value;
        }
        else if($column_name=="attitude_range")
        {
            $data["attitude_range"]=$column_value;
        }
        else if($column_name=="liquidity_range")
        {
            $data["liquidity_range"]=$column_value;
        }
        else if($column_name=="downside_range")
        {
            $data["downside_range"]=$column_value;
        }

        $result=$this->home_model->updateTempUserData($data,$column_name,$email);
        if($result)
        {
            echo '{"success":true,"response":"Updated Temp Users table"}';
            log_message('info', '***** Controller : home, Function : updateTempUserData, Message : Successfully updated temporary users details *****');
        }
        else
        {
            echo '{"success":false}';
            log_message('info', '***** Controller : home, Function : updateTempUserData, Message : Failed to update temporary users details *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : updateAverageTempUserData
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to load updateAverageTempUserData
-----------------------------------------------------------------------------------------------------
*/
    function updateAverageTempUserData()
    {
        $average=$this->input->post("average");
        $temp_users_id=$_SESSION["temp_users_id"];
        $data["average"]=$average;
        $result=$this->home_model->updateAverageTempUserData($data,$temp_users_id);
        if($result)
        {
            echo '{"success":true,"response":"Updated average risk profile of temporary User"}';
            log_message('info', '***** Controller : home, Function : updateAverageTempUserData, Message : Successfully updated average risk profile of temporary User *****');
        }
        else
        {
            echo '{"success":false}';
            log_message('info', '***** Controller : home, Function : updateAverageTempUserData, Message : Failed to update average risk profile of temporary User *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : saveStepOneData
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to save saveStepOneData
-----------------------------------------------------------------------------------------------------
*/
    function saveStepOneData()
    {
		$name=$this->input->post("name");
        $email=$this->input->post("email");
        $phone=$this->input->post("phone");
		$checkEmailExistsResult=$this->home_model->checkEmailExists($email);
        if($checkEmailExistsResult)
        {
            // email exists
            $_SESSION["temp_user_email"]=$email;
            // get temp user id from database
            $tempUserId=$this->home_model->getTempUserId($email);
            $_SESSION["temp_users_id"]=$tempUserId;
            setcookie("tempUserId", $tempUserId, time() + 60*60*24*40); /* expire in 40 days */
            $data["temp_user_name"]=$this->encrypt->encode($name);
            $data["temp_user_phone"]=$this->encrypt->encode($phone);
            $tempUserDataUpdateResult=$this->home_model->updateTempUserData($data,$email);
            echo '{"success":true,"response":"Email exists in database"}';
            log_message('info', '***** Controller : home, Function : saveStepOneData, Message : CheckEmailExists function true - email exists in database *****');
        }
        else
        {
            // email does not exists
            $data["temp_user_name"]=$this->encrypt->encode($name);
            $data["temp_user_email"]=$email;
            $data["temp_user_phone"]=$this->encrypt->encode($phone);
            $_SESSION["temp_user_email"]=$email;
            $tempUserDataResult=$this->home_model->saveTempUserData($data);
            if($tempUserDataResult)
            {
               $temp_user_id=$tempUserDataResult;
               setcookie("tempUserId", $temp_user_id, time() + 60*60*24*40); /* expire in 1 hour */
               $_SESSION["temp_users_id"]=$temp_user_id;
               notificationAlert('Risk Profile',$name.' check risk profile. email id '.$email.' phone number '.$phone);
               echo '{"success":true,"response":"Inserted Temp User Name, Email and Phone"}';
               log_message('info', '***** Controller : home, Function : saveStepOneData, Message : Successfully inserted temporary user name, email and phone no. details *****');
            }
            else
            {
              echo '{"success":false,"response":"Failed to insert Temp User Name, Email and Phone"}';
              log_message('info', '***** Controller : home, Function : saveStepOneData, Message : Failed to insert temporary user name, email and phone no. details *****');
            }
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : saveStepTwoData
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to save step two data
-----------------------------------------------------------------------------------------------------
*/
    function saveStepTwoData()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
          $investorId=$_SESSION["investor_id"];
        }
        else
        {
          $investorId=0;
        }
        $age=$this->input->post("age");
        $monthlyAmount=$this->input->post("monthlyAmount");
        $dependents=$this->input->post("dependents");
        $temp_users_id=$_SESSION["temp_users_id"];
        $data["temp_users_id"]=$temp_users_id;
        $data["age"]=$age;
        $data["monthly_amount"]=$monthlyAmount;
        $data["dependents"]=$dependents;
        $data["investor_id"]=$investorId;
        $checkTempUserExistsResult=$this->home_model->checkTempUserExists($temp_users_id);
        if($checkTempUserExistsResult)
        {
            // Temporary user exists
            $updateStepTwoResult=$this->home_model->updateStepTwo($data,$temp_users_id);
            if($updateStepTwoResult)
            {
              echo '{"success":true,"response":"Updated step 2 - risk profile data"}';
              log_message('info', '***** Controller : home, Function : saveStepTwoData, Message : Updated step 2 - risk profile data *****');
            }
            else
            {
              echo '{"success":false}';
              log_message('info', '***** Controller : home, Function : saveStepTwoData, Message : Failed to update step 2 - risk profile data *****');
            }
        }
        else
        {
            // Temporary user does not exists
            $insertStepTwoResult=$this->home_model->insertStepTwo($data);
            if($insertStepTwoResult)
            {
              echo '{"success":true,"response":"Inserted step 2 - risk profile data"}';
              log_message('info', '***** Controller : home, Function : saveStepTwoData, Message : Inserted step 2 - risk profile data *****');
            }
            else
            {
              echo '{"success":false,"response":"Failed to insert step 2 - risk profile data"}';
              log_message('info', '***** Controller : home, Function : saveStepTwoData, Message : Failed to insert step 2 - risk profile data *****');
            }
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : updateHorizonRange
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to update Horizon Range of user
-----------------------------------------------------------------------------------------------------
*/
    function updateHorizonRange()
    {
      $horizonRange=$this->input->post("horizonRange");
      $temp_users_id=$_SESSION["temp_users_id"];
      $data["investment_horizon"]=$horizonRange;
      $updateHorizonRangeResult=$this->home_model->updateHorizonRange($data,$temp_users_id);
      if($updateHorizonRangeResult)
      {
          echo '{"success":true,"response":"Updated Temp Users horizon range in risk profile"}';
          log_message('info', '***** Controller : home, Function : updateHorizonRange, Message : Successfully updated temp users horizon range in risk profile *****');
      }
      else
      {
          echo '{"success":false}';
          log_message('info', '***** Controller : home, Function : updateHorizonRange, Message : Failed to update temp users horizon range in risk profile *****');
      }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : updateDownsideRange
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to update Down side rang
-----------------------------------------------------------------------------------------------------
*/
    function updateDownsideRange()
    {
      $downsideRange=$this->input->post("downsideRange");
      $temp_users_id=$_SESSION["temp_users_id"];
      $data["downside"]=$downsideRange;
      $updateDownsideRangeResult=$this->home_model->updateDownsideRange($data,$temp_users_id);
      if($updateDownsideRangeResult)
      {
          echo '{"success":true,"response":"Updated Temp Users downside range in risk profile"}';
          log_message('info', '***** Controller : home, Function : updateDownsideRange, Message : Successfully updated temp users downside range in risk profile *****');
      }
      else
      {
          echo '{"success":false}';
          log_message('info', '***** Controller : home, Function : updateDownsideRange, Message : Failed to update temp users downside range in risk profile *****');
      }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : mailRiskProfileDetails
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to mail risk profile of the user
-----------------------------------------------------------------------------------------------------
*/
    function mailRiskProfileDetails()
    {
		$temp_users_id=$_SESSION["temp_users_id"];
		$post = $this->home_model->getTempUserData($temp_users_id);
		$my_name = $this->encrypt->decode($post->temp_user_name);
		$my_email = $_SESSION["temp_user_email"];
		$myPhone = $this->encrypt->decode($post->temp_user_phone);
        $risk_type=$this->input->post("risk_type");
        $risk_profile_average=$this->input->post("average");
		echo $my_name." ".$my_email." ".$risk_type." ".$risk_profile_average;
        $status = $this->sendRiskProfileSms($my_name,$myPhone);
        if($status)
        {
            log_message('info', '***** Controller : home, Function : SMS, Message : Successfully sent sms - '.$myPhone.' *****');
            
        }
        else
        {
            log_message('info', '***** Controller : home, Function : SMS, Message : Failed tos send sms - '.$myPhone.' *****');
        }
		
        $sent=$this->sendRiskProfile($my_name,$my_email,$risk_type,$risk_profile_average);
        if($sent)
        {
            log_message('info', '***** Controller : home, Function : mailRiskProfileDetails, Message : Successfully sent risk profile details to the temp user email - '.$my_email.' *****');
        }
        else
        {
            log_message('info', '***** Controller : home, Function : mailRiskProfileDetails, Message : Failed tos send risk profile details to the temp user email - '.$my_email.' *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : mailRiskProfileDetails
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis function is used to send risk profile to the users
-----------------------------------------------------------------------------------------------------
*/
   
    function sendRiskProfile($my_name,$my_email,$risk_type,$risk_profile_average)
    {
        $data["myName"]=$my_name;
        $data["riskType"]=$risk_type;
        $data["email"]=@$_SESSION["temp_user_email"];
        $data["riskProfileAverage"]=$risk_profile_average;
        $html=$this->load->view('risk_profile_email_view', $data,true);
        $subject="Your risk profile";
		$out = sendEmail($my_email,$subject,$html);
        return $out;
    }
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : sendRiskProfileSms
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : This function is used to send risk profile sms to user
-----------------------------------------------------------------------------------------------------
*/
    function sendRiskProfileSms($my_name,$userPhone)
    {
        if($my_name!="" && $userPhone!="")
        {
          $ch = curl_init();
          //Like us on bit.ly/eshpind----------------
          $msg = "Dear ".$my_name.", congratulations on completing and knowing your risk profile, details of same has been sent on your email. Complete registration to start investing. Team Investocafe.";
          $msg = str_replace(" ","%20" ,$msg);
          $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=".$msg."&sender=INCAFE&route=4";
          $url=str_replace(" ", "%20", $url1);
          //echo $url;
          curl_setopt($ch, CURLOPT_URL, $url);
          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";
          //return the transfer as a string
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
          //$output contains the output string
          $output = curl_exec($ch);
          $dbData = array ('phone'=>$userPhone,'response'=>$output);
          $this->db->insert('msg_log',$dbData);
          //close curl resource to free up system resources
          curl_close($ch);

          if ( $output === FALSE)
          {
              $output=curl_error($ch); //echoes last session error
              return false;
          }
          return $output;
        }
        else
        {
            // echo "Invalid user name or phone number";
            log_message('info', '***** Controller : SendMessage, Function : sendAccountActivationSms, Message : Invalid user name or phone number provided for sending SMS For Risk Profile, AgeRange Change *****');
        }
    }
	
	
	
	
	
	
	
	
		

/*

----------------------------------------- Mobile Application ----------------------------------------------------------

*/

/*

-----------------------------------------------------------------------------------------------------

|   USE : saveStepOneData

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : This function is used to save saveStepOneData

-----------------------------------------------------------------------------------------------------

*/

    function aapSaveStepOneData()

    {

		$get = json_decode(file_get_contents("php://input"));

        $name = $get->name;

        $email = $get->email;

        $phone = $get->phone;

			

			

        $checkEmailExistsResult=$this->home_model->checkEmailExists($email);

        if($checkEmailExistsResult)

        {

            $tempUserId=$this->home_model->getTempUserId($email);

            $data["temp_user_name"]=$this->encrypt->encode($name);

            $data["temp_user_phone"]=$this->encrypt->encode($phone);

            $tempUserDataUpdateResult=$this->home_model->updateTempUserData($data,$email);

            echo '{"success":"true","response":"Email exists in database" ,"Email":"'.$email.'" ,"temp_user_id":"'.$tempUserId.'"}';

            log_message('info', '***** Controller : home, Function : saveStepOneData, Message : CheckEmailExists function true - email exists in database *****');

        }

        else

        {

            // email does not exists

            $data["temp_user_name"]=$this->encrypt->encode($name);

            $data["temp_user_email"]=$email;

            $data["temp_user_phone"]=$this->encrypt->encode($phone);

            $tempUserDataResult=$this->home_model->saveTempUserData($data);

            if($tempUserDataResult)

            {

               $temp_user_id=$tempUserDataResult;



               echo '{"success":"true","response":"Inserted Temp User Name, Email and Phone" ,"Email":"'.$email.'" ,"temp_user_id":"'.$temp_user_id.'"}';

               log_message('info', '***** Controller : home, Function : saveStepOneData, Message : Successfully inserted temporary user name, email and phone no. details *****');

            }

            else

            {

              echo '{"success":"false","response":"Failed to insert Temp User Name, Email and Phone"}';

              log_message('info', '***** Controller : home, Function : saveStepOneData, Message : Failed to insert temporary user name, email and phone no. details *****');

            }

        }

    }

/*

-----------------------------------------------------------------------------------------------------

|   USE : saveStepTwoData

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : This function is used to save step two data

-----------------------------------------------------------------------------------------------------

*/

    function appSaveStepTwoData()

    {

		$get = json_decode(file_get_contents("php://input"));

		@$investorId = $get->investorId;//if investorId then value else investorId = 0
		if(!$investorId){
			$investorId=0;
		}
        $age = $get->age;

        $monthlyAmount = $get->monthlyAmount;

        $dependents= $get->dependents;

        $temp_users_id = $get->temp_users_id;

		

        $data["temp_users_id"]=$temp_users_id;

        $data["age"]=$age;

        $data["monthly_amount"]=$monthlyAmount;

        $data["dependents"]=$dependents;

        $data["investor_id"]=$investorId;

	

        $checkTempUserExistsResult=$this->home_model->checkTempUserExists($temp_users_id);

        if($checkTempUserExistsResult)

        {

            // Temporary user exists

            $updateStepTwoResult=$this->home_model->updateStepTwo($data,$temp_users_id);
		
            if($updateStepTwoResult)

            {

              echo '{"success":"true","response":"Updated step 2 - risk profile data"}';

              log_message('info', '***** Controller : home, Function : saveStepTwoData, Message : Updated step 2 - risk profile data *****');

            }

            else

            {

              echo '{"success":"false"}';

              log_message('info', '***** Controller : home, Function : saveStepTwoData, Message : Failed to update step 2 - risk profile data *****');

            }

        }

        else

        {
	
            // echo 'Temporary user does not exists'; exit;

            if($this->home_model->insertStepTwo($data))

            {
				// $insertStepTwoResult=$this->home_model->insertStepTwo($data);

              echo '{"success":"true","response":"Inserted step 2 - risk profile data"}';

              log_message('info', '***** Controller : home, Function : saveStepTwoData, Message : Inserted step 2 - risk profile data *****');

            }

            else

            {

              echo '{"success":"false","response":"Failed to insert step 2 - risk profile data"}';

              log_message('info', '***** Controller : home, Function : saveStepTwoData, Message : Failed to insert step 2 - risk profile data *****');

            }

        }

    }

	

/*

-----------------------------------------------------------------------------------------------------

|   USE : updateHorizonRange

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : THis function is used to update Horizon Range of user

-----------------------------------------------------------------------------------------------------

*/

    function appUpdateHorizonRange()

    {

	  $get = json_decode(file_get_contents("php://input"));

      $horizonRange = $get->horizonRange;

      $temp_users_id= $get->temp_users_id;

      $data["investment_horizon"]=$horizonRange;



      $updateHorizonRangeResult=$this->home_model->updateHorizonRange($data,$temp_users_id);

	  

      if($updateHorizonRangeResult)

      {

          echo '{"success":"true","response":"Updated Temp Users horizon range in risk profile"}';

          log_message('info', '***** Controller : home, Function : updateHorizonRange, Message : Successfully updated temp users horizon range in risk profile *****');

      }

      else

      {

          echo '{"success":"false"}';

          log_message('info', '***** Controller : home, Function : updateHorizonRange, Message : Failed to update temp users horizon range in risk profile *****');

      }

    }

	

/*

-----------------------------------------------------------------------------------------------------

|   USE : updateDownsideRange

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : THis function is used to update Down side rang

-----------------------------------------------------------------------------------------------------

*/

    function appUpdateDownsideRange()

    {

	  $get = json_decode(file_get_contents("php://input"));

      $downsideRange = $get->downsideRange;

      $temp_users_id = $get->temp_users_id;

      $data["downside"]=$downsideRange;

      $updateDownsideRangeResult=$this->home_model->updateDownsideRange($data,$temp_users_id);

      if($updateDownsideRangeResult)

      {

          echo '{"success":"true","response":"Updated Temp Users downside range in risk profile"}';

          log_message('info', '***** Controller : home, Function : updateDownsideRange, Message : Successfully updated temp users downside range in risk profile *****');

      }

      else

      {

          echo '{"success":"false"}';

          log_message('info', '***** Controller : home, Function : updateDownsideRange, Message : Failed to update temp users downside range in risk profile *****');

      }

    }

	

/*

-----------------------------------------------------------------------------------------------------

|   USE : updateTempUserData

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : THis function is used to update temp user

-----------------------------------------------------------------------------------------------------

*/

    function appUpdateTempUserData()

    {

        $column_value=$this->input->post("column_value");

        $column_name=$this->input->post("column_name");

        $email=$_SESSION["temp_email"];

        if($column_name=="age_range")

        {

            $data["age_range"]=$column_value;

        }

        else if($column_name=="dependents_range")

        {

            $data["dependents_range"]=$column_value;

        }

        else if($column_name=="horizon_range")

        {

            $data["horizon_range"]=$column_value;

        }

        else if($column_name=="attitude_range")

        {

            $data["attitude_range"]=$column_value;

        }

        else if($column_name=="liquidity_range")

        {

            $data["liquidity_range"]=$column_value;

        }

        else if($column_name=="downside_range")

        {

            $data["downside_range"]=$column_value;

        }



        $result=$this->home_model->updateTempUserData($data,$column_name,$email);

        if($result)

        {

            echo '{"success":"true","response":"Updated Temp Users table"}';

            log_message('info', '***** Controller : home, Function : updateTempUserData, Message : Successfully updated temporary users details *****');

        }

        else

        {

            echo '{"success":"false"}';

            log_message('info', '***** Controller : home, Function : updateTempUserData, Message : Failed to update temporary users details *****');

        }

    }

	

	/*

-----------------------------------------------------------------------------------------------------

|   USE : updateAverageTempUserData

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : THis function is used to load updateAverageTempUserData

-----------------------------------------------------------------------------------------------------

*/

    function appUpdateAverageTempUserData()
    {
		$get = json_decode(file_get_contents("php://input"));
        $average = $get->average;
        $temp_users_id= $get->temp_users_id;
        $data["average"]=$average;
        $result=$this->home_model->updateAverageTempUserData($data,$temp_users_id);
        if($result)
        {
            $this->appMailRiskProfileDetails($temp_users_id);
            echo '{"success":"true","response":"Updated average risk profile of temporary User"}';
            log_message('info', '***** Controller : home, Function : updateAverageTempUserData, Message : Successfully updated average risk profile of temporary User *****');
        }
        else
        {
            echo '{"success":"false"}';
            log_message('info', '***** Controller : home, Function : updateAverageTempUserData, Message : Failed to update average risk profile of temporary User *****');
        }

    }

/*

-----------------------------------------------------------------------------------------------------

|   USE : mailRiskProfileDetails

|   DATE : 04/10/2016

|   AUTHOER : AMIT MEENA

|   COMMENT : THis function is used to mail risk profile of the user

-----------------------------------------------------------------------------------------------------

*/

    function appMailRiskProfileDetails($temp_user_id)
    {
		$res = $this->db->query("SELECT temp_users.* ,risk_profile.average as average FROM temp_users JOIN risk_profile on temp_users.temp_users_id = risk_profile.temp_users_id WHERE temp_users.temp_users_id=$temp_user_id");
		$userData = $res->row();
        $my_name = $this->encrypt->decode($userData->temp_user_name);
        $my_email = $userData->temp_user_email;
        $myPhone = $this->encrypt->decode($userData->temp_user_phone);
		$spliteAvg = explode(":",$userData->average);
		$equityAverage = $spliteAvg[0];
		if($equityAverage>=70)
		{
			$riskType="an aggressive";
		}
		else if($equityAverage<70 && $equityAverage>=30)
		{
			$riskType="a moderate";
		}
		else if($equityAverage<30)
		{
			$riskType="a conservative";
		}
		$risk_type = $riskType;
		$risk_profile_average =$userData->average;

        $status = $this->sendRiskProfileSms($my_name,$myPhone);
        if($status)
        {
            log_message('info', '***** Controller : home, Function : SMS, Message : Successfully sent sms - '.$myPhone.' *****');
            
        }
        else
        {
            log_message('info', '***** Controller : home, Function : SMS, Message : Failed tos send sms - '.$myPhone.' *****');
        }
        $sent=$this->sendRiskProfile($my_name,$my_email,$risk_type,$risk_profile_average);
        if($sent)
        {
            log_message('info', '***** Controller : home, Function : mailRiskProfileDetails, Message : Successfully sent risk profile details to the temp user email - '.$my_email.' *****');
        }
        else
        {
            log_message('info', '***** Controller : home, Function : mailRiskProfileDetails, Message : Failed tos send risk profile details to the temp user email - '.$my_email.' *****');
        }

    }

	



	/*

-----------------------------------------------------------------------------------------------------

|   FUNCTION : appSubmitQuestion

|   DATE : 19/11/2016

|   AUTHOER : Prakash

|   COMMENT : ask question about investment in app

-----------------------------------------------------------------------------------------------------

*/

    function appSubmitQuestion()
    {
		$get_app_data = json_decode(file_get_contents("php://input"));
        $name=$get_app_data->name;
        $emailId=$get_app_data->emailId;
        $question=$get_app_data->question;
        $data=array(
          "name"=>$name,
          "email"=>$emailId,
          "question"=>$question,
        );

        //print_r($data); die;

        $result=$this->submit_question_model->submitQuestion($data);
        if($result)
        {
            $sent=$this->sendAskQuestionEmail($name,$emailId,$question);
            if($sent)
            {
                echo '{"success":"true","msg":"Successfully asked question"}';
                log_message('info', '***** Controller : home, Function : submitQuestion, Message : Successfully sent ask question email *****');
            }
            else
            {
                echo '{"success":"false","msg":"failed to ask question"}';
                log_message('info', '***** Controller : home, Function : submitQuestion, Message : Failed to send ask question email *****');
            }
        }
        else
        {
          echo "failed";
          log_message('info', '***** Controller : home, Function : submitQuestion, Message : Failed to insert ask question data *****');
        }

    }


	
	
}
