<?php

class Huf extends CI_Controller
{
	function __construct()
    {
        parent::__construct();
        $this->load->model('registration/registration_model', 'registration_model');
    }

    public function index()
    {
        $logged = $this->ion_auth->logged_in();
        if (checkuser_session()) {
            $data = array();
            if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
                $investorId               = $_SESSION["investor_id"];
                $data["row"]              = $this->registration_model->getInvestorDatailFirstStatpRegitration($investorId);
                $data["countryList"]      = $this->registration_model->getCountyList();
                $data["allNationalities"] = $this->registration_model->getAllNationalities();
                $data['jsFile']           = 'reg/corporate_registration.js';
                $this->layout('theme/registration/corporate_registration_view', $data);
            } else {
                return redirect('login');
            }
        } else {
            return redirect('login');
        }
    }


    public function layout($view, $data)
    {
    	$this->load->view('theme/common/header', $data);
        $this->load->view($view, $data);
        $this->load->view('theme/common/footer', $data);
    }

    public function updateInvestorInfo()
    {
		$name = $this->input->post("name");
		$array = explode(" ",$name);
		$count = count($array);
		if($count == 1)
		{
			$name_first = $array[0];
			$name_middle = "";
			$name_last = "";
		}
		else if($count == 2)
		{
			$name_first = $array[0];
			$name_middle = "";
			$name_last = $array[1];
		}
		else if($count == 3)
		{
			$name_first = $array[0];
			$name_middle = $array[1];
			$name_last = $array[2];
		}
		else if($count == 4)
		{
			$name_first = $array[0];
			$name_middle = $array[1]." ".$array[2];
			$name_last = $array[3];
		}
        $investor_type=$this->input->post("investor_type");
        $nationality=$this->input->post("nationality");
		$motherName=$this->input->post("motherName");
        $allTaxResidencies=$this->input->post("allTaxResidencies");
        $company=$this->input->post("company");
     	$countryOfResidence=76;
        $status="Non Resident";
        $armedForces=0;
        $name=$this->encrypt->encode(handleString($this->input->post("name")));
        $phone=$this->encrypt->encode($this->input->post("phone"));
        $dob=$this->input->post("dob");
        $placeOfBirth = $this->input->post("placeOfBirth");
        $countryOfBirth = $this->input->post("countryOfBirth");
        $gender="Not define";

        $userId=$_SESSION["userId"];
        $investorId = $_SESSION["investor_id"];
        $data = array(
                        "username" => $name,
                        "first_name"=>$name,
                        "phone"=>$phone,
                        "name_first" => $name_first,
                        "name_last" => $name_last,
                        "name_middle" => $name_middle,
                        "company" => $company
                     );
					 
        $result=$this->ion_auth->update($userId, $data);

        $data=array(
                    "nationality_id"=>86,
                    "status"=>$status,
                    "date_of_birth"=>$dob,
                    "place_of_birth"=>$placeOfBirth,
                    "country_of_birth_id"=>$countryOfBirth,
                    "gender"=>$gender,
                    "country"=>$countryOfResidence,
                    "armed_forces"=>$armedForces,
                    );

        $result=$this->registration_model->updateInvestorInfo($investorId,$data);
        if($result)
        {
            $this->updateInvestorstatus($investorId);
            echo '{"success":true,"response":"updated"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : updateInvestorInfo, Message : Successfully updated investor details *****');
        }
		else
		{
			echo '{"success":false}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : updateInvestorInfo, Message : Failed to update investor details *****');
		}
    }

    function updateInvestorstatus($investorId)
    {
        $today_date= date("Y-m-d H:i:s");
        $data=array(
                    "is_investor_registered_date"=>$today_date,
                    "is_investor_registered"=>1,
                   );
       $result=$this->registration_model->updateInvestorStatusSecontRegitration($investorId,$data); 
    }

    // investor detail

    public function investorDetail()
    {
        $data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId                  = $_SESSION["investor_id"];
            $result                 = $this->registration_model->getInvestorDetail($invId);
            $resultBank             = $this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"] = $this->common_model->getInvestorStatus($invId);
            $data["bankData"]       = $resultBank;
            $data["row"]            = $result;
            
            $result                    = $this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]         = $result;
            $data["overseasDetails"]   = $this->registration_model->getInvestorOverseasDetail($invId);
            $result                    = $this->registration_model->checkInvestorOverseasDetail($invId);
            $data["overseasAvailable"] = $result;
            $resultNominee             = $this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]       = $resultNominee;
            
            $data["cityList"]            = $this->registration_model->getCityList();
            $data["stateList"]           = $this->registration_model->getStateList();
            $data["countryList"]         = $this->registration_model->getCountyList();
            $data["addressProofList"]    = $this->registration_model->getInvestorAddressProofList();
            $data["idProofList"]         = $this->registration_model->getInvestorIdProofList();
            $data["familyStatusList"]    = $this->registration_model->getInvestorFamilyStatusList();
            $data["occuptionList"]       = $this->registration_model->getInvestorOccupationList();
            $data["bankAccountTypeList"] = $this->registration_model->getInvestorBankAccountTypeList();
            $data["bankMasterList"]      = $this->registration_model->getbankMasterAll();
            $data["assistedEmpData"]     = $this->registration_model->getAssistantEmpList();
            $data['company_data']        = $this->registration_model->getCompanyAddrees($invId);
            
            $result            = $this->registration_model->getCompanyAddrees($invId);
            $data["invDetail"] = $result;
            $data['jsFile']    = 'reg/corporate_investor_detail.js';
            // echo "<pre>";
            // print_r($data);
            // exit;
            $this->layout('theme/registration/corporate_investor_detail_view', $data);
        } else {
            echo "Session Expired";
        }
    }

    function modifyInvestorDetail()
    {
        $pincode=$this->input->post("pincode");
        $address=handleString($this->input->post("address"));
        $address2=handleString($this->input->post("address2"));
        $city=$this->input->post("city");
        $original_city=$this->input->post("original_city");
        $state=$this->input->post("state");
        $state = $this->registration_model->get_state_model($state);
        $address_proof=$this->input->post("address_proof");
        $id_proof=$this->input->post("id_proof");
        $panNo=$this->encrypt->encode($this->input->post("panNo"));
        $status=$this->input->post("status");
        $name=handleString($this->input->post("name"));
        if($name == "undefined undefined undefined")
        {
            $name ="";
        }
        $occupation=$this->input->post("occupation");
        $income=$this->input->post("income");
        $doa=$this->input->post("doa");
        $politicallyExposed=$this->input->post("politicallyExposed");
        $relatedPoliticallyExposed=$this->input->post("relatedPoliticallyExposed");
        $politicallyExposedRemark=$this->input->post("politicallyExposedRemark");
        $assistedEmpCheckbox=$this->input->post("assistedEmpCheckbox");
        $assistedEmpName=$this->input->post("assistedEmpName");
        $guardain_name = $this->input->post("guardianName");
        $guardian_dob = $this->input->post("guardianDOB");
        $relation_with_guardian = $this->input->post("guardianRelation");
        $mother_name = $this->input->post("mother_name");
        $worthIncome = $this->input->post("worthIncome");
        if($mother_name == "undefined undefined undefined")
        {
            $mother_name = "";
        }
        if($assistedEmpName == 'none')
        {
            $assistedEmpName=0;
        }
        if($politicallyExposed==1 || $relatedPoliticallyExposed==1)
        {
            $politicallyExposedRemark=$this->input->post("politicallyExposedRemark");
        }
        else
        {
            $politicallyExposedRemark="";
        }

        $investorId=$_SESSION["investor_id"];
        $applicationNumber=$investorId."APN".date("ymd");
        $updateInvdata=array(
                            "application_number"=>$applicationNumber,
                            "pan"=>$panNo,
                            "pincode"=>$pincode,
                            "address"=>$address,
                            "address_2"=>$address2,
                            "city_id"=>$city,
                            "original_city" => $original_city,
                            "state_id"=>$state,
                            "investor_address_proof_id"=>$address_proof,
                            "investor_id_proof_id"=>$id_proof,
                            "investor_family_status_id"=>$status,
                            "father_spouse_name"=>$name,
                            "occupation_id"=>$occupation,
                            "income"=>$income,
                            "doa"=>$doa,
                            "politically_exposed"=>$politicallyExposed,
                            "related_politically_exposed"=>$relatedPoliticallyExposed,
                            "politically_exposed_remark"=>$politicallyExposedRemark,
                            "is_do_not_reg_nominee"=>1,
                            "is_incomplete_bank_detail"=>1,
                            "is_complete_inv_detail" =>1,
                            "is_assisted_by_emp"=>$assistedEmpCheckbox,
                            "assisted_emp_id"=>$assistedEmpName,
                            "guardain_name"=>$guardain_name,
                            "guardian_dob"=>$guardian_dob,
                            "relation_with_guardian"=>$relation_with_guardian,
                            "mother_name"=>$mother_name,
                            "worth_income" => $worthIncome,
                            "worth_income_date" => $this->input->post("worthIncomeDate")
                            );

        $updateInvResult=$this->registration_model->updateInvestorInfo($investorId,$updateInvdata);
        if($updateInvResult)
        {
            $this->registration_model->update_is_inv_colmn_in_investor_table($investorId);
            $this->updateInvestorstatusForInvestor($investorId);
            if($this->input->post("Register_pincode") != "")
            {
                    $data2 =[
                        "company_address_pincode"=>$this->input->post("Register_pincode"),
                        "company_address_1" =>$this->input->post("Register_address"),
                        "company_address_2" =>$this->input->post("Register_address2"),
                        "company_address_city"=>$this->input->post("Register_mainCity"),
                        "company_address_state"=>$this->input->post("Register_state"),
                        "entity_involved" => $this->input->post("entityInvolved"),
                        "type_of_company" => $this->input->post("companyType"),
                        "investor_id" => $investorId,
                        "worth_income_date" => $this->input->post("worthIncomeDate")
                        ];

                    $this->registration_model->update_company_address($investorId,$data2);
            }
            echo '{"success":true,"msg":"updated"}';
        }
        else
        {
            echo '{"success":false}';
        }
    }

    function updateInvestorstatusForInvestor($investorId)
    {
        $today_date= date("Y-m-d H:i:s");
        $data=array(
                    "is_investor_form_complet_date"=>$today_date,
                    "is_investor_form_complet"=>1,
                   );
       $result=$this->registration_model->updateInvestorStatusSecontRegitration($investorId,$data);
           
    }

    public function addPartner()
    {
        $data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId                  = $_SESSION["investor_id"];
            $result                 = $this->registration_model->getInvestorDetail($invId);
            $data["row"]            = $result;
            
            $result                    = $this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]         = $result;
            
            $data["cityList"]            = $this->registration_model->getCityList();
            $data["stateList"]           = $this->registration_model->getStateList();
            $data["countryList"]         = $this->registration_model->getCountyList();
            $data["addressProofList"]    = $this->registration_model->getInvestorAddressProofList();
            $data["idProofList"]         = $this->registration_model->getInvestorIdProofList();
            $data["familyStatusList"]    = $this->registration_model->getInvestorFamilyStatusList();
            $data["occuptionList"]       = $this->registration_model->getInvestorOccupationList();
            $data['jsFile']    = 'reg/corporate_add_partners.js';
            $this->layout('theme/registration/corporate_add_partners_view', $data);
        }
        else
        {
            return redirect('/login');
        }
    }

    public function addPartnerOnServer()
    {
        $post = $this->input->post();
        $investor_id = $_SESSION['investor_id'];
        if($investor_id)
        {
            $data = [
            "partner_name" => $post['partnerName'],
            "partner_pan" => $post['partnerPANNo'],
            "partner_adhaar_no" => $post['partnerAdhaarNo'],
            "partner_address_1" => $post['partnerAddressLine1'],
            "partner_address_2" => $post['partnerAddressLine2'],
            "partner_state" => $post['partnerState'],
            "partner_city" => $post['partnerCity'],
            "company_partner_pincode" => $post['pincodePartner'],
            "investor_id" => $investor_id,
            "partner_dob" => $post['partnerDob'],
            "partner_occupation" => $post['partnerOccupation'],
            "partnerGender" =>$post['partnerGender'],
            "controlling_person_type" =>$post['controllingPersonType'],
            "partner_nationality" => $post['partnerNationality'],
            "partner_tax_id_type" => $post['partnerTAXIDType'],
            "partner_father_name" => $post['partnerFatherName'],
            "partner_place_of_birth" => $post['partnerPlaceOfBirth'],
            "partner_contry_of_birth" => $post['partnerContryOfBirth'],
            "partner_mobile_number" => $post['partnerMobileNumber'],
            "percent_of_beneficial" => $post['partnerPercentOfBeneficial'],
            "partner_rel" => $post['partnerRel'],
            "ext1" => 0
            ];

            $this->db->insert('company_partners',$data);
            if($this->db->affected_rows() > 0 )
            {
                echo '{"success" :true , "msg":"data insert successfully"}';
            }
            else
            {
                echo '{"success" :false , "msg" : "there is some problem"}';
            }
        }
        else
        {
            echo '{"success" :false , "msg" : "session out"}';
        }
    }
    
    public function getCompanyPartners()
    {
        $investorId = $_SESSION['investor_id'];
        $res = $this->db->from('company_partners')->where(['investor_id'=>$investorId,'ext1' => 0])->get();
        if($res->num_rows() >0)
        {
            $data = $res->result();
            $str = "";
            foreach($data as $dt)
            {
                $str .= "<tr><td>".$dt->partner_name."</td><td>".$dt->partner_pan."</td><td>".$dt->partner_adhaar_no."</td><td>".$dt->partner_address_1." ".$dt->partner_address_2.+" ".$dt->partner_city." ".$dt->partner_state." ".$dt->company_partner_pincode."</td><td><button class='btn btn-danger w3-padding-tiny' onclick='remove_partener(".$dt->company_partners_id.")'><i class='fa fa-times' aria-hidden='true'></i></button></td><td>".$dt->percent_of_beneficial."</td></tr>";
            }
            echo '{"success":true,"data":"'.$str.'"}';
        }
        else
        {
            echo '{"success":false}';
        }
    }

    public function addBankDetail()
    {
        $data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorDetail($invId);
            $resultBank=$this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"]=$this->common_model->getInvestorStatus($invId);
            $data["bankData"]=$resultBank;
            $data["row"]=$result;
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]=$result;
            $data["overseasDetails"]=$this->registration_model->getInvestorOverseasDetail($invId);
            $resultNominee=$this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]=$resultNominee;
            $data["bankMasterList"]=$this->registration_model->getbankMasterAll();
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorDetail($invId);
            $data["invDetail"] = $result;
            $data["bankAccountTypeList"]=$this->registration_model->getInvestorBankAccountTypeList();
            $data['jsFile']    = 'reg/corporate_add_bank.js';
            $this->layout('theme/registration/corporate_add_bank_view', $data);
        }
        else
        {
            return redirect('/login');
        }
    }

      public function modifyBankDetail()
      {
      
          $investorName=$this->encrypt->encode(handleString($this->input->post("investorName")));
          $accountNo=$this->encrypt->encode($this->input->post("accountNo"));
          $acctHolderName=$this->encrypt->encode(handleString($this->input->post("acctHolderName")));
          $bankMasterId=$this->input->post("bankMasterId");
          $accountType=$this->input->post("accountType");
          $ifscCode=$this->input->post("ifscCode");
          $branchName=$this->input->post("branchName");
          $cityName=$this->input->post("cityName");
          $stateName=$this->input->post("stateName");
          $investorId=$_SESSION["investor_id"];
          $bankData=array(
                          "name"=>$investorName,
                          "account_number"=>$accountNo,
                          "account_holder_name"=>$acctHolderName,
                          "bank_master_id"=>$bankMasterId,
                          "branch_name"=>$branchName,
                          "branch_city"=>$cityName,
                          "branch_state"=>$stateName,
                          "account_type_id"=>$accountType,
                          "ifsc_code"=>$ifscCode,
                          "investor_id"=>$investorId,
                          );

          $resultAddBankDetails=$this->registration_model->updateInvestorBankDetails($investorId,$bankData);
          if($resultAddBankDetails)
          {
                    $result = $this->registration_model->update_is_inv_table($investorId);
                    $this->registration_model->update_referal($investorId);
                    $this->createInvestorFormPdf($investorId);
                    $_SESSION["readyforUpdate"]=true;
                    echo '{"success":true,"msg":"updated"}';
          }
          else
          {
              echo '{"success":false}';
          }
      }

    public function createInvestorFormPdf($investorId)
    {
        $result=$this->registration_model->getInvestorDetail($investorId);
        $resultNominee=$this->registration_model->getInvestorNomineeDetail($investorId);
        $resultBank=$this->registration_model->getInvestorBankAndPanDetail($investorId);
        $resultInvStatus = $this->registration_model->getInvestorStatus($investorId);
        $data["addressProofList"]=$this->registration_model->getInvestorAddressProofList();
        $data["nomineeData"]=$resultNominee;
        $data["idProofList"]=$this->registration_model->getInvestorIdProofList();
        $data["bankData"]=$resultBank;
        $data["row"]=$result;
        $data["invStatus"]= $resultInvStatus;
        $data['company_data'] = $this->db->from("company_address_table")->where("investor_id",$investorId)->get()->row();
        $data['company_partners'] = $this->db->from("company_partners")->where(["investor_id"=>$investorId ,"ext1" => 0])->get()->result();
        $data['company_controlling_person'] = $this->db->from("company_partners")->where(["investor_id"=>$investorId ,"ext1" => 0,'controlling_account_person' => 1])->get()->row();
        $pdfBody = $this->load->view('company_doc/kyc_non',$data,true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try
        {
            $mpdf=new mPDF('win-1252','A4','','DejaVuSans',0,0,0,0,10,10,'');
            $mpdf->useOnlyCoreFonts = true;    // false is default
            $mpdf->SetProtection(array('print'));
            $mpdf->SetTitle("INVESTOR DETAILS");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');
            $html=$pdfBody;
            $mpdf->WriteHTML($html);
            $fileName = 'investor'.$investorId.date('YmdHis', time()).'.pdf';
            $mpdf->Output(APPPATH.'../assets/uploads/investor_form_pdf/'.$fileName, 'F');
            $pdfPath = realpath(APPPATH.'../assets/uploads/investor_form_pdf/'.$fileName);
            $data=array("investor_pdf_form_url"=>$fileName);
            $result=$this->registration_model->updateInvestorInfo($investorId,$data);
            //print_r($data);
            return $fileName;
        }
        catch(Exception $e)
        {
            echo $e;die;
            exit;
        }
    }
}