<?php

class hufRegistration extends CI_Controller{

	function __construct()
    {
        parent::__construct();
        $this->load->model('registration/registration_model', 'registration_model');
    }

    public function index()
    {    	
        $logged = $this->ion_auth->logged_in();
        if (checkuser_session()) {
            $data = array();
            if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
                if(isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id']))
		        {
		           $invId=$_SESSION["investor_id"];
		           $status = $this->registration_model->checkFirstRegitration($invId);
		           if($status)
		           {
		                $result=$this->registration_model->getInvestorDatailFirstStatpRegitration($invId);
		                $data["row"]=$result;
		           }
		           else
		           {
		               $result=$this->registration_model->getInvestorDetailInRegistrationForm($invId);
		               $data["row"]=$result;
		               $data["allTaxResidencies"]=$this->registration_model->getAllTaxResidencies($invId);
		           }
		        }
				
		        $data["investorTypeList"]=$this->registration_model->getAllInvestorType();
		        $data["countryList"]=$this->registration_model->getCountyList();
		        $data["allNationalities"]=$this->registration_model->getAllNationalities();
		        $data['jsFile']           = 'reg/huf_registration.js';

                $this->layout('amit_theme/reg/huf_registration_view', $data);
            } else {
                return redirect('login');
            }
        } else {
            return redirect('login');
        }
    }

    public function layout($view, $data)
    {
    	$this->load->view('amit_theme/common/header', $data);
        $this->load->view($view, $data);
        $this->load->view('amit_theme/common/footer', $data);
    }

    public function getInvestorDetail()
    {
    	$data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId                  = $_SESSION["investor_id"];
            $result                 = $this->registration_model->getInvestorDetail($invId);
            $resultBank             = $this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"] = $this->common_model->getInvestorStatus($invId);
            $data["bankData"]       = $resultBank;
            $data["row"]            = $result;
            $result                    = $this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]         = $result;
            $data["overseasDetails"]   = $this->registration_model->getInvestorOverseasDetail($invId);
            $result                    = $this->registration_model->checkInvestorOverseasDetail($invId);
            $data["overseasAvailable"] = $result;
            $resultNominee             = $this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]       = $resultNominee;
            $data["cityList"]            = $this->registration_model->getCityList();
            $data["stateList"]           = $this->registration_model->getStateList();
            $data["countryList"]         = $this->registration_model->getCountyList();
            $data["addressProofList"]    = $this->registration_model->getInvestorAddressProofList();
            $data["idProofList"]         = $this->registration_model->getInvestorIdProofList();
            $data["familyStatusList"]    = $this->registration_model->getInvestorFamilyStatusList();
            $data["occuptionList"]       = $this->registration_model->getInvestorOccupationList();
            $data["bankAccountTypeList"] = $this->registration_model->getInvestorBankAccountTypeList();
            $data["bankMasterList"]      = $this->registration_model->getbankMasterAll();
            $data["assistedEmpData"]     = $this->registration_model->getAssistantEmpList();
            $data['company_data']        = $this->registration_model->getCompanyAddrees($invId);
            $result            = $this->registration_model->getCompanyAddrees($invId);
            $data["invDetail"] = $result;
            $data['jsFile']    = 'reg/huf_investor_detail.js';
            // echo "<pre>";
            // print_r($data);
            // exit;
            $this->layout('amit_theme/reg/huf_investor_detail_view', $data);
        } else {
            echo "Session Expired";
        }
    }

    public function addPartner()
    {
        $data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId                  = $_SESSION["investor_id"];
            $result                 = $this->registration_model->getInvestorDetail($invId);
            $data["row"]            = $result;
            
            $result                    = $this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]         = $result;
            
            $data["cityList"]            = $this->registration_model->getCityList();
            $data["stateList"]           = $this->registration_model->getStateList();
            $data["countryList"]         = $this->registration_model->getCountyList();
            $data["addressProofList"]    = $this->registration_model->getInvestorAddressProofList();
            $data["idProofList"]         = $this->registration_model->getInvestorIdProofList();
            $data["familyStatusList"]    = $this->registration_model->getInvestorFamilyStatusList();
            $data["occuptionList"]       = $this->registration_model->getInvestorOccupationList();
            $data['jsFile']    = 'reg/huf_add_partners.js';
            $this->layout('amit_theme/reg/huf_add_partners_view', $data);
        }
        else
        {
            return redirect('/login');
        }
    }

    public function addBankDetail()
    {
        $data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorDetail($invId);
            $resultBank=$this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"]=$this->common_model->getInvestorStatus($invId);
            $data["bankData"]=$resultBank;
            $data["row"]=$result;
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]=$result;
            $data["overseasDetails"]=$this->registration_model->getInvestorOverseasDetail($invId);
            $resultNominee=$this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]=$resultNominee;
            $data["bankMasterList"]=$this->registration_model->getbankMasterAll();
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorDetail($invId);
            $data["invDetail"] = $result;
            $data["bankAccountTypeList"]=$this->registration_model->getInvestorBankAccountTypeList();
            $data['jsFile']    = 'reg/huf_add_bank.js';
            $this->layout('amit_theme/reg/huf_add_bank_view', $data);
        }
        else
        {
            return redirect('/login');
        }
    }
}