<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class ApiAdditionalPurchaseCron extends CI_Controller
{

	function __construct()
	{
		parent::__construct();
		$this->load->config('config_cams');
		$this->load->config('config_karvy');
		$this->load->model('purchase_cron/api_model');
		$this->load->helper('cams_helper');
		$this->load->helper('karvy_helper');
		$this->camsFiles = array();
	}

	public function getAdditionalPurchasedList()
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        //DATE_FORMAT(`request_date`,'%Y-%m-%d')='$todaysDate' and
        $sql="SELECT * FROM `purchased_units` WHERE
        `request_status` = 0 and `is_first_purchase` = 0 and date_of_deposit<>'0000-00-00 00:00:00' and deposit_ref_no <>'' and trans_upload_status=0 and purchased_units.investment_plan_type != 'STP' 
		and DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
            return $query->result();
        }
        else
        {
            return false;
        }
    }


	function cronAdditionalPurchase()
	{	
		$additionalPurchasedList = $this->getAdditionalPurchasedList();
		if(isset($additionalPurchasedList) && !empty($additionalPurchasedList))
		{
			foreach($additionalPurchasedList as $row)
			{
				$purchaseData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($purchaseData->investor_id);
				$nriArr=array(10,21,11);
				$overseasDetails="";
				if(isset($investorDetails->Karvy_tax_code) )
				{
		   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($purchaseData->investor_id);
		   			}
		   		}

				$investorBankDetails = $this->api_model->getInvestorBankDetails($purchaseData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($purchaseData->fund_id);
				$resultFolio=getLatestFolioNumber($purchaseData->AMC_CODE,$purchaseData->investor_id);
				$folioNumber="";
				if($resultFolio)
				{
            		$folioNumber=$resultFolio;
        		}
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($purchaseData->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$this->config->load('config_karvy');
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["purchaseData"]=$purchaseData;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					if($fundDetails->api_type_id == 2 && $purchaseData->investment_plan_type != 'STP')
					{

						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$data["payoutMecCode"]=$payoutMecCode;
						$getCAMSTxt = $this->createAdditionalPurchaseCamsTxt($data);
					}
				}
				
			}

			if(count($this->camsFiles))
			{
				$camsFiles = $this->camsFiles;
				$num_records = "";
				$count_cams = count($camsFiles);
				if (count($camsFiles)<=9) {
					$num_records = "000".$count_cams;
				}
				if (count($camsFiles)<=99 && $num_records=="") {
					$num_records = "00".$count_cams;
				}		
				if (count($camsFiles)<=999 && $num_records=="") {
					$num_records = "0".$count_cams;
				}	
				if (count($camsFiles)<=9999 && $num_records=="") {
					$num_records = $count_cams;
				}

				$fileName = "B000".$num_records."0001".date("YmdHis").".txt";
				$myfile =fopen("assets/uploads/CAMS/".$fileName, "w");
				foreach ($camsFiles as $key=>$camsFile) {
					
					if($key!=($count_cams-1))
						fwrite($myfile,$camsFile. "\r\n");
					else
						fwrite($myfile,$camsFile);
					
				}
				fclose($myfile);
				$output =camsCurlCommandBulkNew($fileName);
			}	
		}
		
	}


	function createAdditionalPurchaseCamsTxt($data)
	{
		// echo "<pre>";
		// print_r($data);
		// exit;
		$purchased_units_id = $data['purchaseData']->purchased_units_id;
		$AMC_code = $data['fundDetails']->AMC_code;
		$string = $this->load->view('purchase_cron/cams_add_purchase_168_txt.php', $data, true);
		$fileName = getFileName($AMC_code, $purchased_units_id);
		$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
		echo $fileName = $fileName.".txt";
		echo "<br />";
		$result=fwrite($myfile, $string);
		fclose($myfile);
		
	  	if($result)
		{
			$save_path = "assets/uploads/CAMS/".$fileName;
			$this->camsFiles[] = $string;
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $save_path]);
			$this->api_model->update_request_status($purchased_units_id); 
		}
	}
	
}
