<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class ApiFirstPurchaseCron extends CI_Controller
{

	function __construct()
	{
		parent::__construct();
		$this->load->config('config_cams');
		$this->load->config('config_karvy');
		$this->load->model('purchase_cron/api_model' ,'api_model');
		$this->load->helper('cams_helper');
		$this->load->helper('karvy_helper');
	}

	function cronFirstPurchase()
	{

		$getFirstPurchasedList = $this->api_model->getFirstPurchasedList();
		// echo "<pre>";
		// print_r($getFirstPurchasedList);
		// exit;
		if(isset($getFirstPurchasedList) && !empty($getFirstPurchasedList))
		{
			foreach($getFirstPurchasedList as $firstPurchase)
			{
				$investorDetails = $this->api_model->getInvestorDetails($firstPurchase->investor_id);				
				$overseasDetails="";
				$nriArr=array(10,21,11);
				if(isset($investorDetails->Karvy_tax_code) )
				{
					if(in_array($investorDetails->Karvy_tax_code, $nriArr))
		   			{
		   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($firstPurchase->investor_id);
		   			}
				}
   			
				$investorBankDetails = $this->api_model->getInvestorBankDetails($firstPurchase->investor_id);
				$fundDetails = $this->api_model->getFundDetails($firstPurchase->fund_id);			
				$resultFolio=getLatestFolioNumber($firstPurchase->amc_code,$firstPurchase->investor_id);
				$folioNumber="";
		        if($resultFolio)
		        {
		            $folioNumber=$resultFolio;
		        }
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($firstPurchase->investor_id);
				if(isset($investorDetails) && !empty($investorDetails) && isset($fundDetails) && !empty($fundDetails) && isset($investorBankDetails) && !empty($investorBankDetails))
				{
					$data["investorDetails"]=$investorDetails;
					$data["overseasDetails"]=$overseasDetails;
					$data["fundDetails"]=$fundDetails;
					$data["firstPurchase"]=$firstPurchase;
					$data["purchaseData"]=$firstPurchase;
					$data["investorBankDetails"]=$investorBankDetails;
					$data["nomineeDetails"]=$nomineeDetails;
					$data["folioNumber"]=$folioNumber;
					if($fundDetails->api_type_id == 2)
					{
						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$data['payoutMecCode'] = $payoutMecCode;
						$this->createFirstPurchaseCamsTxt($data);
					}
				}
			}

			if(count($this->camsFiles))
			{

				//B0005000120180313130641.txt
				$camsFiles = $this->camsFiles;
				$num_records = "";
				$count_cams = count($camsFiles);

				if (count($camsFiles)<=9) {
					$num_records = "000".$count_cams;
				}
				if (count($camsFiles)<=99 && $num_records=="") {
					$num_records = "00".$count_cams;
				}		
				if (count($camsFiles)<=999 && $num_records=="") {
					$num_records = "0".$count_cams;
				}	
				if (count($camsFiles)<=9999 && $num_records=="") {
					$num_records = $count_cams;
				}

				$fileName = "B000".$num_records."0001".date("YmdHis").".txt";
				$myfile =fopen("assets/uploads/CAMS/".$fileName, "w");
				foreach ($camsFiles as $key=>$camsFile) {
					
					if($key!=($count_cams-1))
						fwrite($myfile,$camsFile. "\r\n");
					else
						fwrite($myfile,$camsFile);
					
				}
				fclose($myfile);
				$output =camsCurlCommandBulkNew($fileName);
			}
		}

	}


	function createFirstPurchaseCamsTxt($data)
	{	
		$amc_code = $data['fundDetails']->AMC_code;
		$purchased_units_id = $data['firstPurchase']->purchased_units_id;
		// $string = $this->load->view('amit_theme/purchase_cron/cams_first_purchase_txt', $data, true);
		$string = $this->load->view('purchase_cron/cams_first_purchase_168_txt', $data, true);
		$fileName = getFileName($amc_code, $purchased_units_id);
		$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
		    $fileName = $fileName.".txt";
			$this->camsFiles[] = $string;
			$save_path = "assets/uploads/CAMS/".$fileName;
			$this->db->where('purchased_units_id',$purchased_units_id)->update('purchased_units',['feed_path' => $save_path]);
			$this->api_model->update_request_status($purchased_units_id); 
		}
	}
}
