<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class ApiRedemptionCron extends CI_Controller
{

	function __construct()
	{
		 parent::__construct();
		 $this->load->config('config_cams');
 		 $this->load->config('config_karvy');
		 $this->load->model('purchase_cron/api_model' ,'api_model');
		 $this->load->helper('cams');
		 $this->load->helper('karvy');
		 $this->camsFiles = array();
	}
	
	
	public function index()
	{
		$this->cronRedemptionByAmount();
	}

	function getRedemptionList()
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT * FROM `sold_units` WHERE
        DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'
        and `request_status` = 0
		and `is_cancel` = 0
		and `trans_upload_status` = 0
        and DATE_FORMAT(`date_of_sale`,'%Y-%m-%d') ='0000-00-00'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
            return $query->result();
        }
        else
        {
            return false;
        }
    }

	function cronRedemptionByAmount()
	{
		$withdrawList = $this->getRedemptionList();
		if(isset($withdrawList) && !empty($withdrawList))
		{
			foreach($withdrawList as $row)
			{
				$withdrawData=$row;
				$investorDetails = $this->api_model->getInvestorDetails($withdrawData->investor_id);
				$overseasDetails="";
				$nriArr=array(10,21,11);
	   			if(in_array($investorDetails->Karvy_tax_code, $nriArr))
	   			{
	   				$overseasDetails = $this->api_model->getInvestorOverseasDetails($withdrawData->investor_id);
	   			}
				$investorBankDetails = $this->api_model->getInvestorBankDetails($withdrawData->investor_id);
				$fundDetails = $this->api_model->getFundDetails($withdrawData->fund_id);
				// echo $fundDetails->AMC_code ." ".$withdrawData->investor_id;
				$folioNumber=getLatestFolioNumber($fundDetails->AMC_code,$withdrawData->investor_id);
				$nomineeDetails = $this->api_model->getInvestorNomineeDetail($withdrawData->investor_id);
				if(isset($fundDetails) && !empty($fundDetails))
				{
					if($fundDetails->api_type_id == 2){
						//CAMS
						$payoutMecCode = $this->api_model->getPayoutMechCodeForCams($fundDetails->AMC_code);
						$getCAMSTxt = $this->createWithdrwalByAmountCamsTxt($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber,$payoutMecCode);
					}
				}
			}
		}

		if(count($this->camsFiles))
		{
			$camsFiles = $this->camsFiles;
			$num_records = "";
			$count_cams = count($camsFiles);
			if (count($camsFiles)<=9) {
				$num_records = "000".$count_cams;
			}
			if (count($camsFiles)<=99 && $num_records=="") {
				$num_records = "00".$count_cams;
			}		
			if (count($camsFiles)<=999 && $num_records=="") {
				$num_records = "0".$count_cams;
			}	
			if (count($camsFiles)<=9999 && $num_records=="") {
				$num_records = $count_cams;
			}

			echo $fileName = "B000".$num_records."0001".date("YmdHis").".txt";
			$myfile =fopen("assets/uploads/CAMS/".$fileName, "w");
			foreach ($camsFiles as $key=>$camsFile) {
				
				if($key!=($count_cams-1))
					fwrite($myfile,$camsFile. "\r\n");
				else
					fwrite($myfile,$camsFile);
				
			}
			fclose($myfile);
			$output =camsCurlCommandBulkNew($fileName);
		}	
	}

	function createWithdrwalByAmountCamsTxt($investorDetails,$overseasDetails, $fundDetails, $withdrawData, $investorBankDetails,$nomineeDetails,$folioNumber, $payoutMecCode)
	{
		$data["investorDetails"]=$investorDetails;
		$data["overseasDetails"]=$overseasDetails;
		$data["fundDetails"]=$fundDetails;
		$data["withdrawData"]=$withdrawData;
		$data["investorBankDetails"]=$investorBankDetails;
		$data["nomineeDetails"]=$nomineeDetails;
		$data["folioNumber"]=$folioNumber;
		$data["payoutMecCode"]=$payoutMecCode;
		$string = $this->load->view('purchase_cron/cams_red_amount_168_txt.php', $data, true);
		$fileName = getFileName($fundDetails->AMC_code, $withdrawData->sold_units_id);

		$myfile =fopen("assets/uploads/CAMS/".$fileName.".txt", "w");
		$result=fwrite($myfile, $string);
		fclose($myfile);
		if($result)
		{
			$fileName = $fileName.".txt";
			$this->camsFiles[] = $string;
			// $output = camsCurlCommandBulkNew($fileName);
			$this->api_model->update_request_status_for_sold_units($withdrawData->sold_units_id,"assets/uploads/CAMS/".$fileName);
		}
	}

}
