<?php

class Minor extends CI_Controller
{
	function __construct()
    {
        parent::__construct();
        $this->load->model('registration/registration_model', 'registration_model');
    }


    public function index()
    {
        $logged = $this->ion_auth->logged_in();
        if (checkuser_session()) {
            $data = array();
            if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
                $investorId               = $_SESSION["investor_id"];
                $data["row"]              = $this->registration_model->getInvestorDatailFirstStatpRegitration($investorId);
                $data["countryList"]      = $this->registration_model->getCountyList();
                $data["allNationalities"] = $this->registration_model->getAllNationalities();
                $data['jsFile']           = 'reg/minor_registration.js';
                $this->layout('theme/registration/minor_registration_view', $data);
            } else {
                return redirect('login');
            }
        } else {
            return redirect('login');
        }
    }

    public function layout($view, $data)
    {
    	$this->load->view('theme/common/header', $data);
        $this->load->view($view, $data);
        $this->load->view('theme/common/footer', $data);
    }


    public function updateInvestorInfo()
    {
        $name  = $this->input->post("name");
        $array = explode(" ", $name);
        $count = count($array);
        if ($count == 1) {
            $name_first = $array[0];
            $name_middle  = "";
            $name_last  = "";
        } else if ($count == 2) {
            $name_first  = $array[0];
            $name_middle = "";
            $name_last   = $array[1];
        } else if ($count == 3) {
            $name_first  = $array[0];
            $name_middle = $array[1];
            $name_last   = $array[2];
        } else if ($count == 4) {
            $name_first  = $array[0];
            $name_middle = $array[1] . " " . $array[2];
            $name_last   = $array[3];
        }
        
        $armedForces    = $this->input->post("armedForces");
        $name           = $this->encrypt->encode(handleString($this->input->post("name")));
        $phone          = $this->encrypt->encode($this->input->post("phone"));
        $dob            = $this->input->post("dob");
        $placeOfBirth   = $this->input->post("placeOfBirth");
        $countryOfBirth = $this->input->post("countryOfBirth");
        $gender         = $this->input->post("gender");
        
        $userId     = $_SESSION["userId"];
        $data       = array(
            "username" => $name,
            "first_name" => $name,
            "phone" => $phone,
            "name_first" => $name_first,
            "name_last" => $name_last,
            "name_middle" => $name_middle
        );
        $result     = $this->ion_auth->update($userId, $data);
        $investorId = $_SESSION['investor_id'];
        $data       = array(
            "nationality_id" => 86,
            "status" => 'Resident Individual',
            "date_of_birth" => $dob,
            "place_of_birth" => $placeOfBirth,
            "country_of_birth_id" => $countryOfBirth,
            "gender" => $gender,
            "armed_forces" => $armedForces
        );
        
        $result = $this->registration_model->updateInvestorInfo($investorId, $data);
        if ($result) {
            $this->updateInvestorstatus($investorId);
            echo '{"success":true,"response":"updated"}';
            log_message('info', '***** InvestorId : ' . $_SESSION["investor_id"] . ', Controller : registration, Function : updateInvestorInfo, Message : Successfully updated investor details *****');
        } else {
            echo '{"success":false}';
            log_message('info', '***** InvestorId : ' . $_SESSION["investor_id"] . ', Controller : registration, Function : updateInvestorInfo, Message : Failed to update investor details *****');
        }
    }

    public function updateInvestorstatus($investorId)
    {
        $today_date = date("Y-m-d H:i:s");
        $data       = array(
            "is_investor_form_complet_date" => $today_date,
            "is_investor_form_complet" => 1
        );
        $result     = $this->registration_model->updateInvestorStatusSecontRegitration($investorId, $data);
    }

    // start investor detail--

    public function investorDetail()
    {
        $data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId                  = $_SESSION["investor_id"];
            $result                 = $this->registration_model->getInvestorDetail($invId);
            $resultBank             = $this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"] = $this->common_model->getInvestorStatus($invId);
            $data["bankData"]       = $resultBank;
            $data["row"]            = $result;
            
            $result                    = $this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]         = $result;
            $data["overseasDetails"]   = $this->registration_model->getInvestorOverseasDetail($invId);
            $result                    = $this->registration_model->checkInvestorOverseasDetail($invId);
            $data["overseasAvailable"] = $result;
            $resultNominee             = $this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]       = $resultNominee;
            
            $data["cityList"]            = $this->registration_model->getCityList();
            $data["stateList"]           = $this->registration_model->getStateList();
            $data["countryList"]         = $this->registration_model->getCountyList();
            $data["addressProofList"]    = $this->registration_model->getInvestorAddressProofList();
            $data["idProofList"]         = $this->registration_model->getInvestorIdProofList();
            $data["familyStatusList"]    = $this->registration_model->getInvestorFamilyStatusList();
            $data["occuptionList"]       = $this->registration_model->getInvestorOccupationList();
            $data["bankAccountTypeList"] = $this->registration_model->getInvestorBankAccountTypeList();
            $data["bankMasterList"]      = $this->registration_model->getbankMasterAll();
            $data["assistedEmpData"]     = $this->registration_model->getAssistantEmpList();
            
            $result            = $this->registration_model->getInvestorDetail($invId);
            $data["invDetail"] = $result;
            $data['jsFile']    = 'reg/minor_investor_detail.js';
            $this->layout('theme/registration/minor_investor_detail', $data);
        } else {
            echo "Session Expired";
            // redirect('/');
        }
    }


    function modifyInvestorDetail()
    {
        $pincode=$this->input->post("pincode");
        $address=handleString($this->input->post("address"));
        $address2=handleString($this->input->post("address2"));
        $city=$this->input->post("city");
        $original_city=$this->input->post("original_city");
        $state=$this->input->post("state");
        $state = $this->registration_model->get_state_model($state);
        $address_proof=$this->input->post("address_proof");
        $id_proof=$this->input->post("id_proof");
        $panNo=$this->encrypt->encode($this->input->post("panNo"));
        $status=$this->input->post("status");
        $name=handleString($this->input->post("name"));
        if($name == "undefined undefined undefined")
        {
            $name ="";
        }
        $occupation=$this->input->post("occupation");
        $income=$this->input->post("income");
        $doa=$this->input->post("doa");
        $politicallyExposed=$this->input->post("politicallyExposed");
        $relatedPoliticallyExposed=$this->input->post("relatedPoliticallyExposed");
        $politicallyExposedRemark=$this->input->post("politicallyExposedRemark");
        $assistedEmpCheckbox=$this->input->post("assistedEmpCheckbox");
        $assistedEmpName=$this->input->post("assistedEmpName");
        $guardain_name = $this->input->post("guardianName");
        $guardian_dob = $this->input->post("guardianDOB");
        $relation_with_guardian = $this->input->post("guardianRelation");
        $mother_name = $this->input->post("mother_name");
        if($mother_name == "undefined undefined undefined")
        {
            $mother_name = "";
        }
        if($assistedEmpName == 'none')
        {
            $assistedEmpName=0;
        }
        if($politicallyExposed==1 || $relatedPoliticallyExposed==1)
        {
            $politicallyExposedRemark=$this->input->post("politicallyExposedRemark");
        }
        else
        {
            $politicallyExposedRemark="";
        }

        $investorId=$_SESSION["investor_id"];
        $applicationNumber=$investorId."APN".date("ymd");
        $updateInvdata=array(
                            "application_number"=>$applicationNumber,
                            "pan"=>$panNo,
                            "pincode"=>$pincode,
                            "address"=>$address,
                            "address_2"=>$address2,
                            "city_id"=>$city,
                            "original_city" => $original_city,
                            "state_id"=>$state,
                            "investor_address_proof_id"=>$address_proof,
                            "investor_id_proof_id"=>$id_proof,
                            "investor_family_status_id"=>$status,
                            "father_spouse_name"=>$name,
                            "occupation_id"=>$occupation,
                            "income"=>$income,
                            "doa"=>$doa,
                            "country" => 76,
                            "politically_exposed"=>$politicallyExposed,
                            "related_politically_exposed"=>$relatedPoliticallyExposed,
                            "politically_exposed_remark"=>$politicallyExposedRemark,
                            "is_do_not_reg_nominee"=>1,
                            "is_incomplete_bank_detail"=>1,
                            "is_complete_inv_detail" =>1,
                            "is_assisted_by_emp"=>$assistedEmpCheckbox,
                            "assisted_emp_id"=>$assistedEmpName,
                            "guardain_name"=>$guardain_name,
                            "guardian_dob"=>$guardian_dob,
                            "relation_with_guardian"=>$relation_with_guardian,
                            "mother_name"=>$mother_name,
                            );
        $updateInvResult=$this->registration_model->updateInvestorInfo($investorId,$updateInvdata);
        if($updateInvResult)
        {
            $this->registration_model->update_is_inv_colmn_in_investor_table($investorId);
            $this->updateInvestorstatus($investorId);
            echo '{"success":true,"msg":"updated"}';
        }
        else
        {
            echo '{"success":false}';
        }
    }

//  bank detail.
    public function minorBankDetail()
    {
        $data = [];
        $data=array();
        if(isset($_SESSION['investor_id']) && !empty($_SESSION['investor_id']))
        {
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorDetail($invId);
            $resultBank=$this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"]=$this->common_model->getInvestorStatus($invId);
            $data["bankData"]=$resultBank;
            $data["row"]=$result;
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]=$result;
            $data["overseasDetails"]=$this->registration_model->getInvestorOverseasDetail($invId);
            $resultNominee=$this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]=$resultNominee;
            $data["bankMasterList"]=$this->registration_model->getbankMasterAll();
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorDetail($invId);
            $data["invDetail"] = $result;
            $data["bankAccountTypeList"]=$this->registration_model->getInvestorBankAccountTypeList();
            $data['jsFile']    = 'reg/minor_bank_detail.js';
            // echo "<pre>";
            // print_r($data);
            // exit;
            $this->layout('theme/registration/minor_bank_detail_view',$data);
        }
        else
        {
            redirect('login');
        }
    }

    public function modifyBankDetail()
    {
          $investorName=$this->encrypt->encode(handleString($this->input->post("investorName")));
          $accountNo=$this->encrypt->encode($this->input->post("accountNo"));
          $acctHolderName=$this->encrypt->encode(handleString($this->input->post("acctHolderName")));
          $bankMasterId=$this->input->post("bankMasterId");
          $accountType=$this->input->post("accountType");
          $ifscCode=$this->input->post("ifscCode");
          $branchName=$this->input->post("branchName");
          $cityName=$this->input->post("cityName");
          $stateName=$this->input->post("stateName");
          $investorId=$_SESSION["investor_id"];
          $bankData=array(
                          "name"=>$investorName,
                          "account_number"=>$accountNo,
                          "account_holder_name"=>$acctHolderName,
                          "bank_master_id"=>$bankMasterId,
                          "branch_name"=>$branchName,
                          "branch_city"=>$cityName,
                          "branch_state"=>$stateName,
                          "account_type_id"=>$accountType,
                          "ifsc_code"=>$ifscCode,
                          "investor_id"=>$investorId,
                          );

          $resultAddBankDetails=$this->registration_model->updateInvestorBankDetails($investorId,$bankData);
          if($resultAddBankDetails)
          {
                $result = $this->registration_model->update_is_inv_table($investorId);
                $this->registration_model->update_referal($investorId);
                $this->createInvestorFormPdf($investorId);
                $_SESSION["readyforUpdate"]=true;
                echo '{"success":true,"msg":"updated"}';
          }
          else
          {
              echo '{"success":false}';
          }
    }

    public function createInvestorFormPdf($investorId)
    {
        $result=$this->registration_model->getInvestorDetail($investorId);
        $resultNominee=$this->registration_model->getInvestorNomineeDetail($investorId);
        $resultBank=$this->registration_model->getInvestorBankAndPanDetail($investorId);
        $resultInvStatus = $this->registration_model->getInvestorStatus($investorId);
        $data["addressProofList"]=$this->registration_model->getInvestorAddressProofList();
        $data["nomineeData"]=$resultNominee;
        $data["idProofList"]=$this->registration_model->getInvestorIdProofList();
        $data["bankData"]=$resultBank;
        $data["row"]=$result;
        $data["invStatus"]= $resultInvStatus;
        $data['company_data'] = $this->db->from("company_address_table")->where("investor_id",$investorId)->get()->row();
        $data['company_partners'] = $this->db->from("company_partners")->where(["investor_id"=>$investorId , "percent_of_beneficial >" => 25,"ext1" => 0])->get()->result();

        $pdfBody = $this->load->view('investor_form_pdf_view',$data,true);
        
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try
        {
            $mpdf=new mPDF('win-1252','A4','','DejaVuSans',0,0,0,0,10,10,'');
            $mpdf->useOnlyCoreFonts = true;    // false is default
            $mpdf->SetProtection(array('print'));
            $mpdf->SetTitle("INVESTOR DETAILS");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');
            $html=$pdfBody;
            $mpdf->WriteHTML($html);
            $fileName = 'investor'.$investorId.date('YmdHis', time()).'.pdf';
            $mpdf->Output(APPPATH.'../assets/uploads/investor_form_pdf/'.$fileName, 'F');
            $pdfPath = realpath(APPPATH.'../assets/uploads/investor_form_pdf/'.$fileName);
            $data=array("investor_pdf_form_url"=>$fileName);
            $result=$this->registration_model->updateInvestorInfo($investorId,$data);
            //print_r($data);
            return $fileName;
        }
        catch(Exception $e)
        {
            echo $e;die;
            exit;
        }
    }

    public function getDetailsByIfscCode()
    {
        $ifscCode=$this->input->post("ifscCode");
        $result=$this->registration_model->getDetailsByIfscCode($ifscCode);
        if($result)
        {
          $bankStateName=$result->bank_state_name;
          $bankBranchName=$result->bank_branch_name;
          $bankCityName=$result->bank_city_name;
          $bankMasterId=$result->bank_master_id;
          echo '{"success":true,"bankStateName":"'.$bankStateName.'","bankBranchName":"'.$bankBranchName.'","bankCityName":"'.$bankCityName.'","bankMasterId":"'.$bankMasterId.'"}';
        }
        else
        {
          echo '{"success":false}';
        }
    }

    public function checkNomineePercentage()
    {
        $percentage=$this->input->post("percentage");
        $investorId=$_SESSION["investor_id"];
        $totalPercentage=$this->registration_model->checkNomineeTotalPercentage($investorId);
        $total=0;
        if($totalPercentage)
        {
            $total=$total+$totalPercentage->total_percentage;
            $balancePercentage=(100-$total);
            echo '{"success":true,"total":"'.$total.'","balance":"'.$balancePercentage.'"}';
        }
        else
        {
            echo '{"success":false}';
        }
    }

    public function addNomineeDatails()
    {
        $nomineeName=$this->input->post("nomineeName");
        $relation=$this->input->post("relation");
        $percentage=$this->input->post("percentage");
        $dob=$this->input->post("dob");
        $guardianName=$this->input->post("guardianName");
        $nomineeAddress=handleString($this->input->post("nomineeAddress"));
        $investorId=$_SESSION["investor_id"];
        $guardianRel = $this->input->post("guardianRel");
        $pincodeNom = $this->input->post("pincodeNom");
        $nomineeData=array(
            "name"=>$nomineeName,
            "relation_with_investor"=>$relation,
            "percentage"=>$percentage,
            "date_of_birth"=>$dob,
            "guardian_name"=>$guardianName,
            "address"=>$nomineeAddress,
            "investor_id"=>$investorId,
            "relation_with_guardian" => $guardianRel,
            "pin_code" => $pincodeNom
        );
        $noOfNominee=$this->registration_model->checkNoOfNominee($investorId);
        if($noOfNominee<3)
        {
            $resultAddNominee=$this->registration_model->addInvestorNomineeDetails($nomineeData);
            if($resultAddNominee)
            {
                $date=new DateTime($dob);
                $dob=$date->format('d M Y');
                echo '{"success":true,"nomineeId":"'.$resultAddNominee.'","dob":"'.$dob.'"}';
            }
            else
            {
                echo '{"success":false","errorMsg":"Server error found"}';
            }
        }
        else
        {
            echo '{"success":false,"errorMsg":"Maximum 3 nominee(s) allowed."}';
        }
    }

    public function removeNominee()
    {
        $nomineeId=$this->input->post("nomineeId");
        $result=$this->registration_model->removeNominee($nomineeId);
        if($result)
        {
            echo '{"success":true}';
        }
        else
        {
            echo '{"success":false}';
        }
    }

    public function uploadCancelChequeImage($docTypeId=4)
    {
        $invId=$_SESSION["investor_id"];
        if(isset($_FILES))
        {
            $info = new SplFileInfo($_FILES["myfile0"]["name"]);
            $fileExt=strtolower($info->getExtension());
            if($docTypeId == 4)
            {
                $uploadFileName = $invId."_4_".date("dmyhis").".".$fileExt; // assign new name
                $pathAndName ="assets/uploads/cancelled_cheque/".$uploadFileName;
            }
           
            $type     = $_FILES["myfile0"]["type"];
            $tempName = $_FILES["myfile0"]["tmp_name"];
            $size     = $_FILES["myfile0"]["size"];
            $originalfileName = $_FILES["myfile0"]["name"];
            
            
            if(move_uploaded_file($tempName, $pathAndName))
            {
                $docData= array(
                        'url'=> base_url().'assets/uploads/cancelled_cheque/'.$uploadFileName,
                        'original_name'=>$originalfileName,
                        'document_type_id'=>$docTypeId,
                        'investor_id'=>$invId
                        );
                ; // Default document type for cancelled cheque or last 6 month bank statement
                $result = $this->registration_model->addInvestorDocumentType($invId,$docData,$docTypeId);
                if($result)
                {
                    echo '{"success":true,"message":"file uploaded"}';
                }
                else
                {
                    echo '{"success":false,"message":"failed to upload"}';
                }
            }
            else
            {
                echo '{"success":false,"message":"server error"}';
            }
        }
        else
        {
            echo '{"success":false}';
        }
    }

    public function copyInvestorAddress()
    {
        $investor_id = $_SESSION['investor_id'];
        $result = $this->db->query("select investor.address,investor.address_2,investor.original_city,state.state_name from investor join state ON state.id = investor.state_id WHERE investor_id = $investor_id");
        if($result->row())
        {
            $data = $result->row();
            echo '{"success":true,"address":"'.$data->address.'","address_2":"'.$data->address_2.'","original_city":"'.$data->original_city.'","state_name":"'.$data->state_name.'"}';
        }
        else
        {
            echo '{"success":true}';
        }
    }
 
}
