<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
------------------------------------------------------------------------------------------------------------------------------
|	CHNAGE BY TECHNOUNIVERSE
|	DATE : 27-08-16
|	AUTHOER : AMIT MEENA
|	COMMENT : This is MonthlySipCron run daily and create entery in purchase_unites , mothly investoment and mothly_investment_mapping 
			  table and also add next investment date in daily_agenda table using "addDailyAgenda" function in line number 83
------------------------------------------------------------------------------------------------------------------------------
*/
class MonthlySipCron extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('purchase/purchase_model' ,'purchase_model');
	}

	public function index()
	{
		log_message("info", "***** Controller : MonthlySipCron,  Function : index, Messege : start running monthlySIP cron *****");
        $this->purchaseMonthlySipFunds();
        // Stp cron call
        $this->everyday();
		$this->everyWeek();
		$this->everyfifteenday();
		$this->everyMonth();
		$this->createSwp();
		
	}

	public function createSwp()
	{
		$date = Date('Y-m-d');
		$time = strtotime($date);
		$final = date("Y-m-d", strtotime("+1 month", $time));
		$res = $this->db->where('request_date',"$date")->get('swp');
		$data_Arr = [];
		if($res->num_rows() > 0){
			foreach ($res->result() as $key => $value) {
				array_push($data_Arr, [
					"sold_amount"=>$value->sold_amount,
					"investor_id"=>$value->investor_id,
					"request_date"=>$value->request_date,
					"fund_id"=>$value->fund_id,
					"folio_number"=> $value->folio_number,
					"withdraw_type"=>1
				]);
				$this->db->where('swp_id',$value->swp_id)->update('swp',['request_date'=>$final]);
			}
			$this->db->insert_batch('sold_units',$data_Arr);
		}
	}

	function purchaseMonthlySipFunds()
	{
		date_default_timezone_set("Asia/Kolkata");
		$investmentDate=date("Y-m-d");
	    $date = new DateTime($investmentDate);
		$requestDate=$date->format('Y-m-d ').date("h:i:s");
		$time = strtotime($requestDate);
	    $nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));
		// echo $nextInvestmentDate;
		date_default_timezone_set("Asia/Kolkata");
        $todaysDate=date("d-m");	
        // echo $todaysDate;		
	    $restul=$this->purchase_model->getPurchaseFundsListForSipMonthly($todaysDate);
	    // echo "<pre>";
	    // print_r($restul);
	    // exit;
	    if(isset($restul) && !empty($restul))
	    {
	        $count=0;
	        $totalAmount=0;
	        foreach ($restul as $row)
	        {
	            $amount=$row->amount;
	            $fundId=$row->fund_id;
	            $investorId=$row->investor_id;
	           	$noOfInvestedMonths=($row->no_of_invested_months+1);
				$amc_code = $this->purchase_model->get_amc_code($fundId);
	            $folioNumber=getLatestFolioNumber($amc_code,$investorId);
	            $isFirstPurchase=0;
				$purchasedBatchId = $this->purchase_model->createNewPurchaseBatchId("purchase");
	            $unitCounts= 0;
	            // create new api batch id 
	            //$apiTypeId=$row->api_type_id; 
	            $apiTypeId="";
	           	$monthlyInvestmentId=$row->monthly_investment_id;
	            $apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
	            $data=array(
						"fund_id"=>$fundId,
						"purchased_amount"=>$amount,
						"unit_count"=>$unitCounts,
						"investor_id"=>$investorId,
						"request_date"=>$requestDate,
						"batch_id"=>$purchasedBatchId,
						"folio_number"=>$folioNumber,
						"is_first_purchase"=>$isFirstPurchase,
						"api_batch_id"=>$apiBatchId,
						"investment_plan_type"=>"SIP Monthly",
						"is_monthly_sip"=>1,
						"investor_ip" => $_SERVER['REMOTE_ADDR'],
						"mer_txn" => 0 ,
						"AMC_CODE" => $amc_code
	                );
				
	            $purchasedUnitsId=$this->purchase_model->addPurchaseFundsForCron($data);
	            if($purchasedUnitsId)
	            {
					log_message("info", "***** purchasedUnitsId : ".$purchasedUnitsId.", Controller : MonthlySipCron,  Function : purchaseMonthlySipFunds, Messege : successfull insert data for next sip *****");
	            	$monthlyInvestmentdata= array(
                        "next_investment_date"=>$nextInvestmentDate,
                        "no_of_invested_months"=>$noOfInvestedMonths,
                        );
                    $resulrOut=$this->purchase_model->updateSipMonthlyInvestmentFunds($monthlyInvestmentId,$monthlyInvestmentdata);
					// CHNAGE BY TECHNOUNIVERSE
					$action ="Today is SIP of InvestorId - ".$investorId;
					$date = $nextInvestmentDate;
					addDailyAgenda($action,$date);
	                // add details in monthly mapping table
	                $data=array("monthly_investment_id"=>$monthlyInvestmentId,"purchased_units_id"=>$purchasedUnitsId); 
	                $this->purchase_model->addMonthlyInvestmentMappingData($data);
	            }else{$count++;}
	        }
		}
		
		$todaysDate = date('d-m',strtotime("+3 day"));
		// echo $todaysDate;
	    $restul = $this->purchase_model->getPurchaseFundsListForSipMonthlySendSms($todaysDate);
		// print_r($restul);
		if($restul)
		{
			foreach($restul as $res)
			{
				$first_name =  $this->encrypt->decode($res->first_name);
				$phone =  $this->encrypt->decode($res->phone);
				// echo $first_name." ".$phone."<br>";
				//$first_name =  $this->encrypt->decode($res->first_name);
				//echo $res->email;
				$investmentDate=date($res->next_investment_date);
				$amount = $res->amount;
				$date = new DateTime($investmentDate);
				$requestDate=$date->format('d M Y');
				if($phone != '9355755007'){
					$this->sendSMS($phone,$first_name,$requestDate,$amount);
				}
				if(($res->no_of_months-$res->no_of_invested_months)<3){
	        	 	$monthss = ($res->no_of_months-$res->no_of_invested_months);
			    	echo $monthName = date('F',strtotime("+".$monthss." months"));
			    	$mail = $res->email;
			    	// $this->sipCompleteCron($first_name,$monthName,$mail);
			    	// exit;
			    }
			}
		}
 	}

 	public function checkBalance($investor_id)
 	{
 		$res = $this->db->query("SELECT (SUM(`purchased_amount`) - (SELECT SUM(`sold_amount`) FROM sold_units WHERE investor_id = $investor_id AND sold_units.request_status = 1)) as balance FROM purchased_units WHERE investor_id = $investor_id AND request_status = 1");
 		if($res->num_rows() > 0)
 		{
 			if($res->row()->balance > 49999)
 				return  true;
 			else
 				return false;
 		}
 		else
 		{
 			return false;
 		}
 	}
	
    public function sendSMS($userPhone,$userName,$date,$amount)
	{
		if($userPhone!="" && $userName!="")
        {
			$ch = curl_init();
			$url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear ".$userName." ,your monthly SIP of Rs. ".$amount."  is scheduled on ".$date.".Keep your account sufficiently funded .%20%0ATeam%20Investocafe.&sender=INCAFE&route=4&DLT_TE_ID=1207162122925699475";

			         $url=str_replace(" ", "%20", $url1);
			         echo $url;
			         curl_setopt($ch, CURLOPT_URL, $url);
			         curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			         $output = curl_exec($ch);
			         $dbData = array ('phone'=>$userPhone,'response'=>$output);
			         $this->db->insert('msg_log',$dbData);
			         curl_close($ch);
			         if ( $output === FALSE)
			         {
			           $output=curl_error($ch); //echoes last session error
			           return false;
			         }
			         return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
            log_message("info", "***** mobileNo : ".$userPhone.", Controller : MonthlySipCron,  Function : sendSMS, Messege : Invalid user name or phone number for send Sms For purchase funds. *****");
        }
	} 

	// when sip got compete

	public function sipCompleteCron($name,$month,$mail)
	{
		$email = $mail;
		$data['name'] = $name;
		$data['link'] = '';
		$data['link_text'] = "Complete Your Registration to Begin Investing";
		$data['contant'] ="Greetings from Investocafe !<br/><br/>We wish to inform you that the installment amount towards your SIP has come to an end in the month of $month.We are glad that you are almost near to achieving your Life Goals however in order to gain the maximum returns on investment, it is always advisable that you should remain invested for a longer duration.<br/><br/> Think no more and extend your SIP to reap the best Returns in times to come. To continue your SIP for longer tenure <a href='https://investocafe.com/login/'>click here</a> <br/><br/>If you have any queries, please write to us at info@investocafe.com. You can call us on 0731-4043703, and we'll be glad to assist you.You can also visit www.investocafe.com to extend your SIP Tenure";
		$view = "auth/email/follow_up_email";
		$subject = " Investment Alert | Your installment of SIP has come to an end,Extend it today!";
		$this->sendRiskMail($email,$view,$data,$subject);
	}

	function sendRiskMail($email,$view,$data,$subject)
    {
    	echo "run";
        echo $html=$this->load->view($view, $data);
		$out = sendEmail($email,$subject,$html);
        return $out;
    } 

	// stp Cron block
	public function everyday()
	{
		$res = $this->db->from('stp_frequency')->where(['frequency'=>'Every Day','is_cancel' => 0])->get();
		$this->commonInsert($res);
	}

	public function everyWeek()
	{
		// select every week data
		$day = date("l");
		if($day == 'Monday')
		{
			$res = $this->db->from('stp_frequency')->where(['frequency'=>'Every Week','is_cancel' => 0])->get();
			$this->commonInsert($res);
		}
	}

	public function everyfifteenday()
	{
		// select every fifteen day data
		$date = date('d');
		if($date == '16')
		{
			$res = $this->db->from('stp_frequency')->where(['frequency'=>'Every 15 days','is_cancel' => 0])->get();
			$this->commonInsert($res);
		}
	}

	public function everyMonth()
	{
		// select every month data and 15 day data
		$date = date('d');
		if($date == '01')
		{
		 // $res = $this->db->from('stp_frequency')->where(['is_cancel' => 0,'frequency'=>'Every 15 days'])->or_where(['frequency'=>'Every Months','is_cancel' => 0])->get();
		 $res = $this->db->query("SELECT * FROM (`stp_frequency`) WHERE (`frequency` = 'Every 15 days' OR `frequency` = 'Every Months') AND `is_cancel` = 0");
		 $this->commonInsert($res);
		}
	}

	public function commonInsert($res)
	{
		if($res->num_rows() > 0)
		{
				$data_array = [];
				$result = $res->result();
				$investorIp=$_SERVER['REMOTE_ADDR'];
				$date = $date = new DateTime(date("Y-m-d"));
				$requestDate = $date->format('Y-m-d ').date("h:i:s");
				date_default_timezone_set("Asia/Kolkata");
				foreach ($result as $key => $value) {
					$fundId = $value->fund_id;
					$perFundInvestAmount = $value->amount;
					$unitCounts = 0;
					$investorId =  $value->investor_id;
					$nb_request = 0;
					$nb_request_status = 0;
					$transactionId = '';
					$amc_code = $this->purchase_model->get_amc_code($fundId);
					$checkResult=$this->purchase_model->checkFirstTimePurchaseFund($fundId,$investorId);
					if($checkResult){
							$isFirstPurchase=0;
					}else{
							$isFirstPurchase=1;
					}
					$apiTypeId="";
					$apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
					$batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
					echo $amc_code." ".$investorId;
					$resultFolio=getLatestFolioNumber($amc_code,$investorId);
					if($resultFolio){
							$folioNumber=$resultFolio;
					}else{
							$folioNumber="";
					}
					$data=array(
								"fund_id"=>$fundId,
								"purchased_amount"=>$perFundInvestAmount,
								"unit_count"=>$unitCounts,
								"investor_id"=>$investorId,
								"request_date"=>$requestDate,
								"batch_id"=>$batchId,
								"folio_number"=>$folioNumber,
								"is_first_purchase"=>0,
								"api_batch_id"=>$apiBatchId,
								"investment_plan_type"=>"STP",
								"investor_ip"=>$investorIp,
								"nb_request"=>$nb_request,
								"nb_request_status"=>$nb_request_status,
								"mer_txn"=>$transactionId,
		                        "amc_code" => $amc_code
							);
					echo "<pre>";
					print_r($data);
					$purchased_id =$this->purchase_model->addPurchaseFunds($data);
					$this->currentQueue($value->stp_frequency_id,$purchased_id);
				}
		}
	}

	public function currentQueue($stp_frequency_id,$purchased_units_id)
	{
		$this->db->query("UPDATE stp_frequency SET `transfer_amount` = `transfer_amount` + `amount`, `current_queue_purchased_units_id` = $purchased_units_id WHERE stp_frequency_id = $stp_frequency_id");
	}


	public function completeSIPreport()
	{
		echo $month = date("m")-3;
		$date = date("Y-$month-01");
		$res = $this->db->query("SELECT monthly_investment.monthly_investment_id, users.username, users.phone, monthly_investment.amount, monthly_investment.no_of_invested_months, funds.fund_name, monthly_investment.next_investment_date FROM monthly_investment JOIN investor ON investor.investor_id = monthly_investment.investor_id JOIN users ON users.id = investor.login_id JOIN funds ON funds.fund_id = monthly_investment.fund_id WHERE `no_of_months` = `no_of_invested_months` AND `is_stopped_sip` = 0 AND `next_investment_date` > '".$date."'");
		if($res->num_rows() > 0)
		{
			// echo "<pre>";
			// print_r($res->result());
			$data['sip_data'] = $res->result();
			$html = $this->load->view('email_templates/complete_sip_email_template',$data,true);
			$email = "anvesh.pandey@investocafe.com";
			$subject = "Complete SIP report";
        	$out = sendEmail($email,$subject,$html);
        	$ids = [];
        	foreach($res->result() as $dt)
        	{
        		array_push($ids, $dt->monthly_investment_id);
        	}
        	echo "<pre>";
        	print_r($ids);
        	$List = implode(', ', $ids); 
        	$this->db->query("UPDATE monthly_investment SET no_of_months = no_of_months+no_of_months WHERE monthly_investment_id IN (".$List.")");
		}
	}
}