<?php
 class PartnershipFirmRegistration extends CI_Controller
 {
 	function __construct()
    {
        parent::__construct();
        $this->load->model('registration/registration_model', 'registration_model');
    }

    public function index()
    {    	
        $logged = $this->ion_auth->logged_in();
        if (checkuser_session()) {
            $data = array();
            if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
                if(isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id']))
		        {
		           $invId=$_SESSION["investor_id"];
		           $status = $this->registration_model->checkFirstRegitration($invId);
		           if($status)
		           {
		                $result=$this->registration_model->getInvestorDatailFirstStatpRegitration($invId);
		                $data["row"]=$result;
		           }
		           else
		           {
		               $result=$this->registration_model->getInvestorDetailInRegistrationForm($invId);
		               $data["row"]=$result;
		               $data["allTaxResidencies"]=$this->registration_model->getAllTaxResidencies($invId);
		           }
		        }
				
		        $data["investorTypeList"]=$this->registration_model->getAllInvestorType();
		        $data["countryList"]=$this->registration_model->getCountyList();
		        $data["allNationalities"]=$this->registration_model->getAllNationalities();
		        $data['jsFile']           = 'reg/partnership_registration.js';

                $this->layout('theme/registration/partnership_registration_view', $data);
            } else {
                return redirect('login');
            }
        } else {
            return redirect('login');
        }
    }

    public function layout($view, $data)
    {
    	$this->load->view('theme/common/header', $data);
        $this->load->view($view, $data);
        $this->load->view('theme/common/footer', $data);
    }

    public function updateInvestorInfo()
    {
		$name = $this->input->post("name");
		$array = explode(" ",$name);
		$count = count($array);
		if($count == 1)
		{
			$name_first = $array[0];
			$name_middle = "";
			$name_last = "";
		}
		else if($count == 2)
		{
			$name_first = $array[0];
			$name_middle = "";
			$name_last = $array[1];
		}
		else if($count == 3)
		{
			$name_first = $array[0];
			$name_middle = $array[1];
			$name_last = $array[2];
		}
		else if($count == 4)
		{
			$name_first = $array[0];
			$name_middle = $array[1]." ".$array[2];
			$name_last = $array[3];
		}

        $company=$this->input->post("company");
		$countryOfResidence=76;
        $status="Non Resident";
        

        $armedForces=$this->input->post("armedForces");

        $name=$this->encrypt->encode(handleString($this->input->post("name")));
        $phone=$this->encrypt->encode($this->input->post("phone"));
        $dob=$this->input->post("dob");
        $placeOfBirth = $this->input->post("placeOfBirth");
        $countryOfBirth = $this->input->post("countryOfBirth");
		$gender="not define";
		
        $userId=$_SESSION["userId"];
        $data = array(
                        "username" => $name,
                        "first_name"=>$name,
                        "phone"=>$phone,
                        "name_first" => $name_first,
                        "name_last" => $name_last,
                        "name_middle" => $name_middle,
                        "company" => $company
                     );
					 
        $result=$this->ion_auth->update($userId, $data);
        $investorId=$_SESSION['investor_id'];
        $data=array(

                    "nationality_id"=>86,
                    "status"=>$status,
                    "date_of_birth"=>$dob,
                    "place_of_birth"=>$placeOfBirth,
                    "country_of_birth_id"=>$countryOfBirth,
                    "gender"=>$gender,
                    "country"=>$countryOfResidence,
                    "armed_forces"=>0,
                    );


        $result=$this->registration_model->updateInvestorInfo($investorId,$data);
        if($result)
        {
            $this->updateInvestorstatus($investorId);
            echo '{"success":true,"response":"updated"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : updateInvestorInfo, Message : Successfully updated investor details *****');
        }
		else
		{
			echo '{"success":false}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : updateInvestorInfo, Message : Failed to update investor details *****');
		}
    }

    function updateInvestorstatus($investorId)
    {
        $today_date= date("Y-m-d H:i:s");
        $data=array(
                    "is_investor_registered_date"=>$today_date,
                    "is_investor_registered"=>1,
                   );
       $result=$this->registration_model->updateInvestorStatusSecontRegitration($investorId,$data); 
    }

    public function getInvestorDetail()
    {
    	$data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId                  = $_SESSION["investor_id"];
            $result                 = $this->registration_model->getInvestorDetail($invId);
            $resultBank             = $this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"] = $this->common_model->getInvestorStatus($invId);
            $data["bankData"]       = $resultBank;
            $data["row"]            = $result;
            
            $result                    = $this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]         = $result;
            $data["overseasDetails"]   = $this->registration_model->getInvestorOverseasDetail($invId);
            $result                    = $this->registration_model->checkInvestorOverseasDetail($invId);
            $data["overseasAvailable"] = $result;
            $resultNominee             = $this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]       = $resultNominee;
            
            $data["cityList"]            = $this->registration_model->getCityList();
            $data["stateList"]           = $this->registration_model->getStateList();
            $data["countryList"]         = $this->registration_model->getCountyList();
            $data["addressProofList"]    = $this->registration_model->getInvestorAddressProofList();
            $data["idProofList"]         = $this->registration_model->getInvestorIdProofList();
            $data["familyStatusList"]    = $this->registration_model->getInvestorFamilyStatusList();
            $data["occuptionList"]       = $this->registration_model->getInvestorOccupationList();
            $data["bankAccountTypeList"] = $this->registration_model->getInvestorBankAccountTypeList();
            $data["bankMasterList"]      = $this->registration_model->getbankMasterAll();
            $data["assistedEmpData"]     = $this->registration_model->getAssistantEmpList();
            $data['company_data']        = $this->registration_model->getCompanyAddrees($invId);
            
            $result            = $this->registration_model->getCompanyAddrees($invId);
            $data["invDetail"] = $result;
            $data['jsFile']    = 'reg/partnership_investor_detail.js';
            $this->layout('theme/registration/partnership_investor_detail_view', $data);
        } else {
            echo "Session Expired";
        }
    }

    public function addPartner()
    {
        $data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId                  = $_SESSION["investor_id"];
            $result                 = $this->registration_model->getInvestorDetail($invId);
            $data["row"]            = $result;
            $result                    = $this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]         = $result;
            $data["cityList"]            = $this->registration_model->getCityList();
            $data["stateList"]           = $this->registration_model->getStateList();
            $data["countryList"]         = $this->registration_model->getCountyList();
            $data["addressProofList"]    = $this->registration_model->getInvestorAddressProofList();
            $data["idProofList"]         = $this->registration_model->getInvestorIdProofList();
            $data["familyStatusList"]    = $this->registration_model->getInvestorFamilyStatusList();
            $data["occuptionList"]       = $this->registration_model->getInvestorOccupationList();
            $data['jsFile']    = 'reg/partnership_add_partners.js';
            $this->layout('theme/registration/partnership_add_partners_view', $data);
        }
        else
        {
            return redirect('/login');
        }
    }

    public function addBankDetail()
    {
        $data = array();
        if (isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id'])) {
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorDetail($invId);
            $resultBank=$this->registration_model->getInvestorBankAndPanDetail($invId);
            $data["investorStatus"]=$this->common_model->getInvestorStatus($invId);
            $data["bankData"]=$resultBank;
            $data["row"]=$result;
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorRegistrationFormModifyDetail($invId);
            $data["modifyRow"]=$result;
            $data["overseasDetails"]=$this->registration_model->getInvestorOverseasDetail($invId);
            $resultNominee=$this->registration_model->getInvestorNomineeDetail($invId);
            $data["nomineeData"]=$resultNominee;
            $data["bankMasterList"]=$this->registration_model->getbankMasterAll();
            $invId=$_SESSION["investor_id"];
            $result=$this->registration_model->getInvestorDetail($invId);
            $data["invDetail"] = $result;
            $data["bankAccountTypeList"]=$this->registration_model->getInvestorBankAccountTypeList();
            $data['jsFile']    = 'reg/partnership_add_bank.js';
            $this->layout('theme/registration/partnership_add_bank_view', $data);
        }
        else
        {
            return redirect('/login');
        }
    }
 }