<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : Preferences
|   MODEL USE : preferences_model , registration_model
|   DATE : 08/10/2016
|   AUTHOER : amit meena
|   COMMENT :
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/

class Preferences extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('dashboard/preferences_model');
	   $this->load->model('registration/registration_model');
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : index
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS USED TO LAOD VIEW OF INVESRT FORM
-----------------------------------------------------------------------------------------------------
*/
	public function index()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
        	{
				$pageId=($_SESSION["pageId"]);
          		if(in_array("6", $pageId))
	          	{
		          	$this->_loadView("amit_theme/dashboard/preferences_view");
		          	$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited Manage Account page");
					addSystemLog($data); // helper function
	          	}
				else
				{
					redirect(base_url());
				}
			}
			else
			{
				redirect(base_url());
			}
		}
		else
		{
			redirect(base_url());
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : _loadView
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THis functionis isused to load header and footer view
-----------------------------------------------------------------------------------------------------
*/
    function _loadView($view)
    {
		$investorId=$_SESSION["investor_id"];
    	$result=$this->preferences_model->getNotificationDispalyList();
    	if($result)
    	{
    		$data['notificationList']=$result;
    	}
		$data["bankAccountTypeList"]=$this->registration_model->getInvestorBankAccountTypeList();
			$data["bankMasterList"]=$this->registration_model->getbankMasterList();
		$totalNomineeCountResult=$this->registration_model->checkNoOfNominee($investorId);
		 $userdata=$this->registration_model->getInvestorDetail($investorId);
		$data["profileImageUrl"]=   $userdata->profile_image_url;
		if($totalNomineeCountResult==0)
		{
			$data["totalNomineeCount"] = 0;
		}
		else
		{
			$data["totalNomineeCount"] = $totalNomineeCountResult;
		}
		$data["cityList"]=$this->preferences_model->getCityList();
		$data["stateList"]=$this->preferences_model->getStateList();
		$data['jsFile'] ='dashboard/preferences.js';
		$this->load->view('amit_theme/common/header',$data);
		$this->load->view($view);
		$this->load->view('amit_theme/common/footer',$data );
    }
/*
-----------------------------------------------------------------------------------------------------
*/
	public function sendOtpTOClient()
	{
		$userId = $_SESSION["userId"];
		$this->load->helper('string');
		$otp = random_string('numeric', 4);
		$result=$this->preferences_model->Create_otp_for_edit_profile($userId,$otp);
		$dataContactName=$this->encrypt->decode($result->name);
		$dataContactPhone=$this->encrypt->decode($result->phone);
		$email = $result->email;
		$data['name'] = $dataContactName;
		$data['link'] = '';
		$data['link_text'] = '';
		$data['contant'] ="Your edit profile OTP is ".$otp.". Enter OTP and  edit your profile";
		$view = "auth/email/follow_up_email";
		$subject = "Edit profile OTP";
		$this->sendOTPMailToClient($email,$view,$data,$subject);
		$output = $this->sendPurchaseSms($dataContactName,$dataContactPhone,$otp);
		return redirect('preferences/verifyOTP');
	}


	// withdraw otp
	public function sendOtpTOClientSIP()
	{
		// temprary stop withdraw otp

		// echo '{"success":true,"otp":"32322"}';
		// exit;
		$userId = $_SESSION["userId"];
		$this->load->helper('string');
		$otp = random_string('numeric', 4);
		$result=$this->preferences_model->Create_otp_for_edit_profile($userId,$otp);
		$dataContactName=$this->encrypt->decode($result->name);
		$dataContactPhone=$this->encrypt->decode($result->phone);
		$email = $result->email;
		$data['name'] = $dataContactName;
		$data['link'] = '';
		$data['link_text'] = '';
		$data['contant'] ="Your Investocafe account OTP is ".$otp.". Enter OTP and  edit your profile";
		$view = "auth/email/follow_up_email";
		$subject = "Edit profile OTP";
		$this->sendOTPMailToClient($email,$view,$data,$subject);
		$output = $this->sendPurchaseSms($dataContactName,$dataContactPhone,$otp);
		// return redirect('preferences/verifyOTP');
		echo '{"success":true,"otp":'.$otp.'}';
	}

	function sendOTPMailToClient($email,$view,$data,$subject)
    {
        $html=$this->load->view($view, $data,true);
		// $out = sendEmail($email,$subject,$html);
		$out = sendEmailAws($email,$subject,$html);
        return $out;
    } 

	public function verifyOTP()
	{
		$this->_loadView("amit_theme/dashboard/edit_profile_otp_view.php");
	}
	
	public function checkEditOtp()
	{
		$userId = $_SESSION["userId"];
		$post = $this->input->post();
		$otp = $post['otp'];
		$result = $this->preferences_model->match_otp_for_check($userId,$otp);
		if($result)
		{
			return redirect('preferences/preferences');
		}
		else
		{
			$this->session->set_flashdata('Error',"<div class='alert alert-danger w3-center w3-border-0'>OTP is Wrong ,Please Enter Correct OTP</div>");
			return redirect('preferences/verifyOTP');
		}
	}
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : getCurrentLoggedInUserInfo
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : get logged in user details
-----------------------------------------------------------------------------------------------------
*/
    
    function getCurrentLoggedInUserInfo()
    {
    	$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
	    	//$userId=$_SESSION["userId"];
	    	$investorId=$_SESSION["investor_id"];
	    	$result=$this->preferences_model->getInvestorDetails($investorId);
	    	if($result)
	    	{
	    		$currentEmailId=$result->email;
          		$dataContactName=$this->encrypt->decode($result->name);
	    		$currentContactName=ucwords($dataContactName);
				echo '{"success":true,"currentEmailId":"'.$currentEmailId.'","currentContactName":"'.$currentContactName.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getCurrentLoggedInUserInfo, Message : Successfully fetched user name, email *****');
	    	}
			else
			{
				echo '{"success":true}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getCurrentLoggedInUserInfo, Message : Failed to fetch user name, email *****');
			}
	  	}
	    else
	    {
	    	echo '{"success":false,"session":"out"}';
			log_message('info', '*****  Controller : Preferences, Function : getCurrentLoggedInUserInfo, Message : Session expired while fetching user name, email *****');
	    }
    }
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : getCurrentLoggedInUserInfo
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : update mail name and password
-----------------------------------------------------------------------------------------------------
*/
    function updateCurrentUserInfo()
    {
    	$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
	    	$userId=$_SESSION["userId"];
	    	$name=$this->encrypt->encode($this->input->post("name"));
	      	$email=$this->input->post("email");

        	$data = array(
						"first_name"=>$name,
						"username"=>$name,
		        		 "email"=>$email,
					   );
				$result=$this->ion_auth->update($userId, $data);
	    	if($result)
	    	{
				$investorId=$_SESSION["investor_id"];
				$resultInfo=$this->preferences_model->getInvestorDetails($investorId);
				if($resultInfo)
				{
					$phone=$this->encrypt->decode($resultInfo->phone);
				}
				$this->sendpasswordchnage($phone,1);
				$_SESSION["userName"]=$this->encrypt->encode($this->input->post("name"));
	    		echo '{"success":true}';
	    		$message="Successfully updated user name, email and password";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCurrentUserInfo, Message : '.$message.' *****');
	      		$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	        	addSystemLog($data); // helper function
	    	}
	    	else
	    	{
	    		echo '{"success":false}';
	    		$message="Failed to update user name, email and password";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCurrentUserInfo, Message : '.$message.' *****');
      			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
          		addSystemLog($data); // helper function
	    	}
    	}
    	else
    	{
    		echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : updateCurrentUserInfo, Message : Session expired while updating user name, email and password *****');
    	}
    }
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : updateCurrentUserLoginIdPassword
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT :  Update logged in user id and password
-----------------------------------------------------------------------------------------------------
*/
    function updateCurrentUserLoginIdPassword()
    {
    	$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
	    	$currentPassword=$this->input->post("currentPasswordCollapseTwo");
	    	$password=$this->input->post("newPasswordCollapseTwo");

	    	$userId=$_SESSION["userId"];
	    	$data = array(
							'password' => $password,
						 );
			$result=$this->ion_auth->update($userId, $data);
			if($result)
			{
				$investorId=$_SESSION["investor_id"];
				$resultInfo=$this->preferences_model->getInvestorDetails($investorId);
				if($resultInfo)
				{
					$phone=$this->encrypt->decode($resultInfo->phone);
				}
				$this->sendpasswordchnage($phone,2);
				echo '{"success":true}';
				$message="Successfully updated user password";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : '.$message.' *****');
				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
    			addSystemLog($data); // helper function
			}
			else
			{
				echo '{"success":false}';
    			$message="Failed to update user password";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : '.$message.' *****');
    			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
        		addSystemLog($data); // helper function
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : updateCurrentUserLoginIdPassword, Message : Session expired while updating user password *****');
		}
    }
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : checkNewEmailExists
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function check for email already exit or not in database when changing email
-----------------------------------------------------------------------------------------------------
*/
    function checkNewEmailExists()
    {
    	$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
	        $newEmailId=$this->input->post("newEmailId");
	        $userId=$_SESSION["userId"];
	        $check_email=$this->preferences_model->checkUserNewEmail($userId,$newEmailId);
	        if($check_email)
	        {
	            echo '{"success":true,"response":"already registered"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkNewEmailExists, Message : New email already registered *****');
	        }
	        else
	        {
	            echo '{"success":false,"response":"new email id"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkNewEmailExists, Message : New email id *****');
	        }
	  	}
	    else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : checkNewEmailExists, Message : Session expired while checking for new email id *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : getNotificationAnswerInfo
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : get notification list
-----------------------------------------------------------------------------------------------------
*/
	function getNotificationAnswerInfo()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
	      	//$userId=$_SESSION["userId"];
	      	$investorId=$_SESSION["investor_id"];
	      	$resultInfo=$this->preferences_model->getInvestorDetails($investorId);
	      	if($resultInfo)
	      	{
	      		$email=$resultInfo->email;
	      		$phone=$this->encrypt->decode($resultInfo->phone);
	      	}

			$result=$this->preferences_model->getNotificationAnswerInfo($investorId);
      		if($result)
      		{
	          	$rowStr="";
	          	foreach ($result as $row)
	      		{
	      			$rowStr.='["'.$row->notification_answer_id.'","'.$row->notification_id.'","'.$row->is_email.'","'.$row->is_sms.'"],';
	      		}

				echo '{"success":true,"data":['.rtrim($rowStr, ',').'],"email":"'.$email.'","phone":"'.$phone.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getNotificationAnswerInfo, Message : Successfully fetched notification info *****');
			}
			else
			{
			  	echo '{"success":false,"response":"no data"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getNotificationAnswerInfo, Message : Failed to fetch notification info *****');
			}
	  	}
	  	else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : getNotificationAnswerInfo, Message : Session expired while fetching notification info *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : checkCurrentPasswordExists
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : Check current password exist or not in database when changing password
-----------------------------------------------------------------------------------------------------
*/
	function checkCurrentPasswordExists()
    {
		if(checkuser_session())
		{
        	$password = $this->input->post("password");
        	$userId=$_SESSION["userId"];
			$result=$this->ion_auth->hash_password_db($userId, $password);
			if($result)
	        {
	            echo '{"success":true,"response":"valid"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkCurrentPasswordExists, Message : Current password exists in database *****');
	        }
	        else
	        {
	            echo '{"success":false,"response":"invalid"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkCurrentPasswordExists, Message : Current password does not exist in database *****');
	        }
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : checkCurrentPasswordExists, Message : Session expired while checking for current password *****');
		}
    }
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : checkCurrentPasswordExists
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : Update notification 
-----------------------------------------------------------------------------------------------------
*/
	function updateNotificationAnswerInfo()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			$json=$this->input->post("json");
			$jsonArray=json_decode($json);
			$jsonArray=array_unique($jsonArray,SORT_REGULAR);// remove duplicate entry
			//$userId=$_SESSION["userId"];
			$investorId=$_SESSION["investor_id"];
  			$result=$this->preferences_model->updateNotificationAnswerInfo($investorId,$jsonArray);
			if($result)
			{
			  	echo '{"success":true}';
		  		$message="Successfully updated notification info";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNotificationAnswerInfo, Message : '.$message.' *****');
				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
				addSystemLog($data); // helper function
			}
			else
			{
			  	echo '{"success":false}';
			  	$message="Failed to update notification info";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNotificationAnswerInfo, Message : '.$message.' *****');
				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
				addSystemLog($data); // helper function
			}
		}
	    else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNotificationAnswerInfo, Message : Session expired while updating notification info *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : checkCurrentPasswordExists
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : get logged in user contact info
-----------------------------------------------------------------------------------------------------
*/
	function getContactInfo()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			$userId=$_SESSION["userId"];
			$result=$this->preferences_model->getContactInfo($userId);
			if($result)
			{
				$phone=$this->encrypt->decode($result->phone);
				$overSeasNo=$this->encrypt->decode($result->overseas_no);
				$residencePhone=$this->encrypt->decode($result->residence_phone);
				$officePhone=$this->encrypt->decode($result->office_phone);
				// print_r($residencePhone);die;
				echo '{"success":true,"phone":"'.$phone.'","overSeasNo":"'.$overSeasNo.'","residencePhone":"'.$residencePhone.'","officePhone":"'.$officePhone.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getContactInfo, Message : Successfully fetched contact info *****');
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getContactInfo, Message : Failed to fetch contact info *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getContactInfo, Message : Session expired while fetching contact info *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : checkCurrentPasswordExists
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function update logged in user contact info
-----------------------------------------------------------------------------------------------------
*/
	function updateContactInfo()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			$phone=$this->encrypt->encode($this->input->post("phone"));
			$overseasNo=$this->encrypt->encode($this->input->post("overseasNo"));
			$residenceNo=$this->encrypt->encode($this->input->post("residenceNo"));
			$officeNo=$this->encrypt->encode($this->input->post("officeNo"));


			$userId=$_SESSION["userId"];
			/** investor table data **/
    		$data = array(
						'phone' => $phone,
					 );

    		$result=$this->ion_auth->update($userId,$data);
    		/** investor table data **/
			$data2= array(
				  "overseas_no"=>$overseasNo,
				  "residence_phone"=>$residenceNo,
				  "office_phone"=>$officeNo,
			     );
    		$result1=$this->preferences_model->updateContactInfo($userId,$data2);
			if($result1)
			{
				echo '{"success":true}';
   				$message="Successfully updated contact info";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateContactInfo, Message : '.$message.' *****');
    			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
        		addSystemLog($data); // helper function
			}
			else
			{
				echo '{"success":false}';
    			$message="Failed to update contact info";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateContactInfo, Message : '.$message.' *****');
    			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
        		addSystemLog($data); // helper function
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : updateContactInfo, Message : Session expired while updating contact info *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : getAddress
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : this function update logged in user contact info
-----------------------------------------------------------------------------------------------------
*/
	function getAddress()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			$userId=$_SESSION["userId"];
			$result=$this->preferences_model->getAddress($userId);
			if($result)
			{
				$address = $result->address;
				$address2 = $result->address_2;
				$pincode = $result->pincode;
				$city_name = $result->location_name;
				$city_id = $result->location_id;
				$state_name = $result->state_name;
				$state_id = $result->state_id;
				echo '{"success":true,"address":"'.$address.'","address2":"'.$address2.'","pincode":"'.$pincode.'","city_name":"'.$city_name.'","city_id":"'.$city_id.'","state_name":"'.$state_name.'","state_id":"'.$state_id.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getAddress, Message : Successfully fetched address *****');
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getAddress, Message : Failed to fetch address *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : getAddress, Message : Session expired while fetching address *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : getBankDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : getBankDetails
-----------------------------------------------------------------------------------------------------
*/
	function getBankDetails()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			$userId=$_SESSION["userId"];
			$result=$this->preferences_model->getBankDetails($userId);
			if($result)
			{
				$account_name = $this->encrypt->decode($result->account_holder_name);
				$account_number = $this->encrypt->decode($result->account_number);
				$account_type = $result->account_type;
				$account_type_id = $result->account_type_id;
				$ifsc_code = $result->ifsc_code;
				$bank_master_id = $result->bank_master_id;
				$bank_name = rtrim($result->bank_name);
				$branch_name = rtrim($result->branch_name);
				$branch_state = rtrim($result->branch_state);
				$branch_city = rtrim($result->branch_city);
				echo '{"success":true,"account_name":"'.$account_name.'","account_number":"'.$account_number.'","account_type":"'.$account_type.'","account_type_id":"'.$account_type_id.'","ifsc_code":"'.$ifsc_code.'",
				"bank_master_id":"'.$bank_master_id.'","bank_name":"'.$bank_name.'","branch_name":"'.$branch_name.'","branch_state":"'.$branch_state.'","branch_city":"'.$branch_city.'","investor_type_id":"'.$result->investor_type_id.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getBankDetails, Message : Successfully fetched bank details *****');
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getBankDetails, Message : Failed to fetch bank details *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : getBankDetails, Message : Session out while fetching bank details *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : updateCommunicationAddress
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : updateCommunicationAddress
-----------------------------------------------------------------------------------------------------
*/
	function updateCommunicationAddress()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			$userId=$_SESSION["userId"];
			$new_address = $this->input->post('new_communication_address');
			$new_pincode = $this->input->post('new_pincode');
			$new_city = $this->input->post('new_city');
			$new_state = $this->input->post('new_state');
			$new_country = $this->input->post('new_country');
			if($new_country=="India")
			{
				$new_countryCode=76;
			}
			$result=$this->preferences_model->updateCommunicationAddress($userId,$new_address,$new_pincode,$new_city,$new_state,$new_countryCode);
			if($result)
			{
				echo '{"success":true,"message":"Communication address updated successfully"}';
				$message="Communication address updated successfully";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCommunicationAddress, Message : '.$message.' *****');
    			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
        		addSystemLog($data); // helper function
			}
			else
			{
				echo '{"success":false}';
				$message="Failed to update address details";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCommunicationAddress, Message : '.$message.' *****');
    			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
        		addSystemLog($data); // helper function
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateCommunicationAddress, Message : Session expired while updating address details  *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : updateCommunicationAddress
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : insertCommunicationAddress
-----------------------------------------------------------------------------------------------------
*/
	function insertCommunicationAddress()
	{
		if(checkuser_session())
		{
			$userId=$_SESSION["userId"];
			$investorId=$_SESSION["investor_id"];
			$new_address = $this->input->post('new_communication_address');
			$new_address2 = $this->input->post('new_communication_address2');
			$new_pincode = $this->input->post('new_pincode');
			$new_city = $this->input->post('new_city');
			$new_city_name = $this->input->post('new_city_name');
			$new_state_name = $this->input->post('new_state_name');
			$new_state = $this->input->post('new_state');
			$country_code=76;

			$current_date = date('Y-m-d', time());

			$data=array(
				'address' => $new_address,
				'address_2' => $new_address2,
				'pincode'=>$new_pincode,
				'city_id'=>$new_city,
				"state_id"=>$new_state,
				"country_id"=>$country_code,
				"investor_id"=>$investorId,
				"status"=>0,
				"request_date"=>$current_date
			 );
			$result=$this->preferences_model->insertCommunicationAddress($data);
			if($result)
			{
				// print_r($result);die;
				$modifiedAddressInsertedId = $result;
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertCommunicationAddress, Message : Successfully inserted change address details  *****');

				$userData=$this->preferences_model->getUserData($userId);
				if($userData)
				{
					$data["user_address"]=$userData->address;
					$data["user_pincode"]=$userData->pincode;
					$data["user_city"]=$userData->location_name;
					$data["user_state"]=$userData->state_name;
					$data["user_investorId"]=$_SESSION["investor_id"];
					$data["user_pan"]=$userData->pan;
				}

				$data["userName"]=$_SESSION["userName"];
				$data["new_address"]=trim($new_address);
				$data["new_address2"]=trim($new_address2);
				$data["new_pincode"]=trim($new_pincode);
				$data["new_city_name"]=trim($new_city_name);
				$data["new_state_name"]=trim($new_state_name);

				$mailBody = $this->load->view('address_change_pdf_view',$data,true);
				$this->load->library('mpdf60/mPDF');
				$pdfPath = '';
				try
				{
					$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
					$mpdf->useOnlyCoreFonts = true;    // false is default
					$mpdf->SetProtection(array('print'));
					$mpdf->SetTitle("Change Address");
					$mpdf->SetAuthor("Author");
					$mpdf->showWatermarkText = true;
					$mpdf->SetDisplayMode('fullpage');

					$html=$mailBody;
					$mpdf->WriteHTML($html);
					$fileName = $investorId .'_change_address_form_'.date('YmdHis', time()).'.pdf';
					$mpdf->Output(APPPATH.'../assets/uploads/changeAddressForm/'.$fileName, 'F');
					$pdfPath = realpath(APPPATH.'../assets/uploads/changeAddressForm/'.$fileName);

					$result2=$this->preferences_model->saveAddressPdfUrlData($fileName,$userId,$modifiedAddressInsertedId);
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertCommunicationAddress, Message : Successfully updated new address details pdf url  *****');

					if($result2)
					{
						// print_r("result2 true....");die;
						$emailAddressChangeResult=$this->sendAddressChangeMail($new_address,$new_address2,$new_pincode,$new_city_name,$new_state_name,$pdfPath);
						if($emailAddressChangeResult)
						{
							echo '{"success":true,"message":"Address details updated successfully","pdf_name":"'.$fileName.'"}';
							$message=" Updated address details and successfully sent new address details mail";
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertCommunicationAddress, Message : '.$message.'  *****');
							$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
							addSystemLog($data); // helper function
						}
						else
						{
							echo '{"success":true,"message":"address details updated successfully","pdf_name":"'.$fileName.'"}';
							$message=" Updated address details but failed to send new address details mail";
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertCommunicationAddress, Message : '.$message.'  *****');
							$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
							addSystemLog($data); // helper function
						}
					}
					else
					{
						echo '{"success":false}';
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertCommunicationAddress, Message : Unable to save address details pdf url  *****');
					}
				}
				catch(Exception $e)
				{
					echo '{"success":false,"error":"'.$e.'"}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertCommunicationAddress, Message : Session expired while saving address details pdf url  *****');
				}
			}
			else
			{
				echo '{"success":false}';
				$message="Failed to insert address details";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertCommunicationAddress, Message : '.$message.'  *****');
				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
				addSystemLog($data); // helper function
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : insertCommunicationAddress, Message : Session expired while saving address details  *****');
	   	}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : updateBankDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : updateBankDetails
-----------------------------------------------------------------------------------------------------
*/
	function updateBankDetails()
	{
		$logged=$this->ion_auth->logged_in();
	    if(checkuser_session())
	    {
	      $investorId=$_SESSION["investor_id"];
	      $account_name = $this->encrypt->encode($this->input->post('account_name'));
	      $account_number = $this->encrypt->encode($this->input->post('account_number'));
	      $account_type = $this->input->post('account_type');
	      $ifsc_code = $this->input->post('ifsc_code');
	      $bank_master_id = $this->input->post('bank_master_id');
	      $data=array(
	      	'account_holder_name' => $account_name,
	      	'account_number'=>$account_number,
	      	'account_type_id'=>$account_type,
	      	"ifsc_code"=>$ifsc_code,
	      	"bank_master_id"=>$bank_master_id,
	       );
	        $result=$this->preferences_model->updateBankDetails($investorId,$data);
	        if($result)
	        {
	          	echo '{"success":true,"message":"Bank details updated successfully"}';
	          	$message="Successfully updated bank details";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateBankDetails, Message : '.$message.'  *****');
	    		$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	          	addSystemLog($data); // helper function
	        }
	        else
	        {
	          	echo '{"success":false}';
	          	$message="Failed to update bank details";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateBankDetails, Message : '.$message.'  *****');
    			$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	          	addSystemLog($data); // helper function
	        }
	    }
	    else
	    {
	      	echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : updateBankDetails, Message : Session expired while updating bank details  *****');
	    }
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : insertBankDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : insertBankDetails
-----------------------------------------------------------------------------------------------------
*/
	function insertBankDetails()
	{
		$logged=$this->ion_auth->logged_in();
    	if(checkuser_session())
    	{
			$userId=$_SESSION["userId"];
			$investorId=$_SESSION["investor_id"];
			$account_name = $this->encrypt->encode($this->input->post('account_name'));
			$account_number = $this->encrypt->encode($this->input->post('account_number'));
			$account_type = $this->input->post('account_type');
			$account_type_name = $this->input->post('account_type_name');
			$ifsc_code = $this->input->post('ifsc_code');
			$bank_name = $this->input->post('bank_name');
			$bank_master_id = $this->input->post('bank_master_id');
			$branch_name = $this->input->post('branch_name');
			$branch_state = $this->input->post('branch_state');
			$branch_city = $this->input->post('branch_city');
			$current_date = date('Y-m-d', time());

	      	$data=array(
	      	'account_holder_name' => $account_name,
	      	'account_no'=>$account_number,
	      	'account_type'=>$account_type,
	      	"ifsc_code"=>$ifsc_code,
	      	"bank_master_id"=>$bank_master_id,
					"branch_city"=>$branch_city,
					"branch_state"=>$branch_state,
					"branch_name"=>$branch_name,
					"investor_id"=>$investorId,
					"request_date"=>$current_date,
					"status"=>0
	       );
        	$result=$this->preferences_model->insertBankDetails($data);
        	if($result)
        	{
				$modifiedBankInsertedId = $result;
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : Successfully inserted change bank details  *****');

				$userData=$this->preferences_model->getUserData($userId);
				if($userData)
				{
						$data["user_address"]=$userData->address;
						$data["user_pincode"]=$userData->pincode;
						$data["user_city"]=$userData->location_name;
						$data["user_state"]=$userData->state_name;
						$data["user_investorId"]=$_SESSION["investor_id"];
						$data["user_pan"]=$userData->pan;
						$data2["user_name"]=$userData->username;
						$data2["user_email"]=$userData->email;
						$data2["user_phone"]=$userData->phone;
						$data2["user_registeredDate"]=$userData->is_investor_registered_date;
				}
				// generate pdf for modified bank Details

				$data["userName"]=$_SESSION["userName"];
				$data["account_holder_name"]=trim($account_name);
				$data["account_number"]=trim($account_number);
				$data["account_type"]=trim($account_type_name);
				$data["ifsc_code"]=trim($ifsc_code);
				$data["bank_name"]=trim($bank_name);
				$data["branch_city"]=trim($branch_city);
				$data["branch_name"]=trim($branch_name);
				$data["branch_state"]=trim($branch_state);

				$data2["account_number"]=trim($account_number);
				$data2["ifsc_code"]=trim($ifsc_code);
				$data2["bank_name"]=trim($bank_name);
				$data2["userName"]=$_SESSION["userName"];

				$mailBody = $this->load->view('bank_change_pdf_view',$data,true);
				$mailBody2 = $this->load->view('bank_mandate_pdf_view',$data2,true);
				$this->load->library('mpdf60/mPDF');
				$pdfPath = '';
				$pdfPath2 = '';
				try
				{
					$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
					$mpdf->useOnlyCoreFonts = true;    // false is default
					$mpdf->SetProtection(array('print'));
					$mpdf->SetTitle("Change Bank");
					$mpdf->SetAuthor("Author");
					$mpdf->showWatermarkText = true;
					$mpdf->SetDisplayMode('fullpage');

					$html=$mailBody;
					$mpdf->WriteHTML($html);
					$fileName = $investorId .'_change_bank_form_'.date('YmdHis', time()).'.pdf';
					$mpdf->Output(APPPATH.'../assets/uploads/changeBankForm/'.$fileName, 'F');
					$pdfPath = realpath(APPPATH.'../assets/uploads/changeBankForm/'.$fileName);

					$result2=$this->preferences_model->saveChangeBankPdfUrlData($fileName,$userId,$modifiedBankInsertedId);
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : Successfully updated new bank details pdf url  *****');

					$mpdf2=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
					$mpdf2->useOnlyCoreFonts = true;    // false is default
					$mpdf2->SetProtection(array('print'));
					$mpdf2->SetTitle("Bank Mandate");
					$mpdf2->SetAuthor("Author");
					$mpdf2->showWatermarkText = true;
					$mpdf2->SetDisplayMode('fullpage');

					$html2=$mailBody2;
					$mpdf2->WriteHTML($html2);
					$fileName2 = $investorId .'_bank_mandate_form_'.date('YmdHis', time()).'.pdf';
					$mpdf2->Output(APPPATH.'../assets/uploads/changeBankForm/'.$fileName2, 'F');
					$pdfPath2 = realpath(APPPATH.'../assets/uploads/changeBankForm/'.$fileName2);

					$bankMandateUrlUpdateresult=$this->preferences_model->saveBankMandateUrlData($fileName2,$userId,$modifiedBankInsertedId);
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : Successfully updated new bank details pdf url  *****');

					if($result2)
					{
						$emailResult=$this->sendBankChangeMail($account_name,$investorNameOnPancard,$account_number,$account_type_name,$ifsc_code,$bank_name,$branch_name,$branch_state,$branch_city,$pdfPath,$pdfPath2);
						if($emailResult)
						{
							echo '{"success":true,"message":"Bank details updated successfully","pdf_name":"'.$fileName.'","mandate_pdfUrl":"'.$fileName2.'"}';
							$message=" Updated bank details and successfully sent new bank details mail";
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : '.$message.'  *****');
		      				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
						else
						{
							echo '{"success":true,"message":"bank details updated successfully","pdf_name":"'.$fileName.'","mandate_pdfUrl":"'.$fileName2.'"}';
							$message=" Updated bank details but failed to send new bank details mail";
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : '.$message.'  *****');
		      				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
					}
					else
					{
						echo '{"success":false}';
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : Unable to save bank details pdf url  *****');
					}
				}
				catch(Exception $e)
				{
					echo '{"success":false,"error":"'.$e.'"}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : session expired while saving bank details pdf url *****');
				}
			}
	        else
	        {
	          	echo '{"success":false}';
	          	$message="Failed to add/modify bank details";
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : '.$message.'  *****');
	    		$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	          	addSystemLog($data); // helper function
	        }
	    }
	    else
	    {
	      	echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : insertBankDetails, Message : Session expired while updating bank details  *****');
	    }
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : getNomineeDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : getNomineeDetails
-----------------------------------------------------------------------------------------------------
*/
	function getNomineeDetails()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			$userId=$_SESSION["userId"];
			$result=$this->preferences_model->getNomineeDetails($userId);
			if($result)
			{
				$rowStr="";
				foreach($result as $row)
				{
					$nominee_id = $row->nominee_details_id;
					$nominee_name = $row->name;
					$nominee_relation = $row->relation_with_investor;

					// date time convert format
					if($row->date_of_birth=="0000-00-00")
					{
						$date_of_birth="";
					}
					else
					{
						$date = new DateTime($row->date_of_birth);
						$date_of_birth=$date->format('M d, Y');
					}

					$guardian_name = $row->guardian_name ;
					$address = $row->address;
					$percentage = $row->percentage;

					$rowStr .= '['.$nominee_id.',"'.$nominee_name.'","'.$nominee_relation.'","'.$date_of_birth.'","'.$address.'","'.$guardian_name.'",'.$percentage.'],';
				}
				echo '{"success":true,"data":['.rtrim($rowStr, ',').']}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getNomineeDetails, Message : Successfully fetched nominee details  *****');
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getNomineeDetails, Message : Failed to fetch nominee details  *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getNomineeDetails, Message : Session expired while fetching nominee details  *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : insertNomineeDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : insertNomineeDetails
-----------------------------------------------------------------------------------------------------
*/
	function insertNomineeDetails()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
			$userId=$_SESSION["userId"];
			$nominee_name = $this->input->post('nominee_name');
			$nominee_relation = $this->input->post('nominee_relation');
			$nominee_percentage = $this->input->post('nominee_percentage');
			$guardian_name = $this->input->post('guardian_name');
			$date = new DateTime($this->input->post('nominee_dob'));
			$nominee_dob=$date->format('Y-m-d');
			$nominee_dob_format=$date->format('M j, Y');
			$nominee_address = $this->input->post('nominee_address');
			$investorId=$_SESSION["investor_id"];

			$nomineeData=array(
			"name"=>$nominee_name,
			"relation_with_investor"=>$nominee_relation,
			"percentage"=>$nominee_percentage,
			"date_of_birth"=>$nominee_dob,
			"address"=>$nominee_address,
			"guardian_name"=>$guardian_name,
			"investor_id"=>$investorId,
			"status"=>0
		  	);

			// update nominee details in db
			$result=$this->preferences_model->insertNomineeDetails($nomineeData);
			if($result)
			{
				$nomineeDetailsInsertedId=$result;
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertNomineeDetails, Message : Successfully inserted new nominee details  *****');
				// fetch user details
				$userData=$this->preferences_model->getUserData($userId);
				if($userData)
				{
						$data["user_address"]=$userData->address;
						$data["user_pincode"]=$userData->pincode;
						$data["user_city"]=$userData->location_name;
						$data["user_state"]=$userData->state_name;
						$data["user_investorId"]=$_SESSION["investor_id"];
						$data["user_pan"]=$userData->pan;
				}
				// generate pdf file
				$data["userName"]=$_SESSION["userName"];
				$data["nominee_name"]=trim($nominee_name);
				$data["nominee_relation"]=trim($nominee_relation);
				$data["nominee_percentage"]=trim($nominee_percentage);
				$data["guardian_name"]=trim($guardian_name);
				$data["nominee_dob"]=trim($nominee_dob_format);
				$data["nominee_address"]=trim($nominee_address);
				$mailBody = $this->load->view('nominee_change_pdf_view',$data,true);
				$this->load->library('mpdf60/mPDF');
				$pdfPath = '';
				try
				{
					$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
					$mpdf->useOnlyCoreFonts = true;    // false is default
					$mpdf->SetProtection(array('print'));
					$mpdf->SetTitle("Change Nominee");
					$mpdf->SetAuthor("Author");
					$mpdf->showWatermarkText = true;
					$mpdf->SetDisplayMode('fullpage');

					$html=$mailBody;
					$mpdf->WriteHTML($html);
					$fileName = $investorId .'_change_nominee_form_'.date('YmdHis', time()).'.pdf';
					$mpdf->Output(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName, 'F');
					$pdfPath = realpath(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName);

					$result2=$this->preferences_model->savePdfUrlData($fileName,$userId,$nomineeDetailsInsertedId);
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertNomineeDetails, Message : Successfully updated new nominee details pdf url  *****');
					if($result2)
					{
						$emailResult=$this->sendNomineeChangeMail($nominee_name,$nominee_dob_format,$nominee_address,$nominee_relation,$pdfPath,$guardian_name,$nominee_percentage);
						if($emailResult)
						{
							echo '{"success":true,"message":"Nominee add successfully","pdf_name":"'.$fileName.'"}';
							$message=" Updated Nominee details and successfully sent new nominee details mail";
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertNomineeDetails, Message : '.$message.'  *****');
		      				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
						else
						{
							echo '{"success":true,"message":"Nominee add successfully","pdf_name":"'.$fileName.'"}';
							$message=" Updated Nominee details but failed to send new nominee details mail";
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertNomineeDetails, Message : '.$message.'  *****');
	      					$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
					}
					else
					{
						echo '{"success":false}';
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertNomineeDetails, Message : Unable to save nominee details pdf url  *****');
					}
				}
				catch(Exception $e)
				{
					echo '{"success":false,"error":"'.$e.'"}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertNomineeDetails, Message : session expired while saving nominee details pdf url  *****');
				}
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertNomineeDetails, Message : Failed to insert new nominee details  *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : insertNomineeDetails, Message : Session expired while inserting new nominee details  *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : insertNomineeDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : insertNomineeDetails
-----------------------------------------------------------------------------------------------------
*/
	function sendNomineeChangeMail($nominee_name,$nominee_dob_format,$nominee_address,$nominee_relation,$pdfPath,$guardian_name,$nominee_percentage)
	{
		$email=$_SESSION["email"];
		$name=$_SESSION["userName"];
		$today = date('d M Y h:i a', time());
		$data=array();

		$data["name"]=$name;
		$data["nominee_name"]=$nominee_name;
		$data["nominee_dob"]=$nominee_dob_format;
		$data["nominee_relation"]=$nominee_relation;
		$data["nominee_address"]=$nominee_address;
		$data["guardian_name"]=$guardian_name;
		$data["nominee_percentage"]=$nominee_percentage;
		$html=$this->load->view('nominee_change_email_view', $data,true);
		$this->load->library("email");
		$this->email->set_newline("\r\n");
		$this->email->set_mailtype("html");
		$this->email->to($email);
		$this->email->cc("anvesh.pandey@investocafe.com,rahul.gehlot@investocafe.com,neha.joshi@investocafe.com");
		// $this->email->bcc("nikunj17287@gmail.com");
		$this->email->from(" Investocafe Assistant<info@investocafe.com>", "Investocafe");
		$this->email->subject("Change of Nominee: Action Required");
		$this->email->message($html);
		$this->email->attach($pdfPath);
		$result=$this->email->send();
		//echo $this->email->print_debugger();
		return $result;
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : updateNomineeDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : updateNomineeDetails
-----------------------------------------------------------------------------------------------------
*/

	function updateNomineeDetails()
	{
		$logged=$this->ion_auth->logged_in();
		if(checkuser_session())
		{
		  	$userId=$_SESSION["userId"];
			$nomineeId=$this->input->post("nomineeId");
			$nomineeName=$this->input->post("nomineeName");
			$nomineeRelation=$this->input->post("nomineeRelation");
			$nomineePercentage=$this->input->post("nomineePercentage");
			$nomineeDOB=$this->input->post("nomineeDOB");
			$nomineeDOB_dc=date_create($this->input->post("nomineeDOB"));
			$nomineeDOB_format= date_format($nomineeDOB_dc,"F d, Y");
			$nomineeGuardian=$this->input->post("nomineeGuardian");
			$nomineeAddress=$this->input->post("nomineeAddress");
			$investorId=$_SESSION["investor_id"];

			$data = array(
						'name' => $nomineeName,
						'relation_with_investor'=>$nomineeRelation,
						'date_of_birth'=>$nomineeDOB,
						'address'=>$nomineeAddress,
						'status'=>1,
						'guardian_name'=>$nomineeGuardian,
						'percentage'=>$nomineePercentage
					 );
			$resultUpdate=$this->preferences_model->updateNomineeDetails($investorId, $data, $nomineeId);
			if($resultUpdate)
			{
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNomineeDetails, Message : Successfully updated nominee details  *****');
				$userData=$this->preferences_model->getUserData($userId);
				if($userData)
				{
						$data["user_address"]=$userData->address;
						$data["user_pincode"]=$userData->pincode;
						$data["user_city"]=$userData->location_name;
						$data["user_state"]=$userData->state_name;
						$data["user_investorId"]=$_SESSION["investor_id"];
						$data["user_pan"]=$userData->pan;
				}

				$data["userName"]=$_SESSION["userName"];
				$data["nominee_name"]=trim($nomineeName);
				$data["nominee_relation"]=trim($nomineeRelation);
				$data["nominee_percentage"]=trim($nomineePercentage);
				$data["guardian_name"]=trim($nomineeGuardian);
				$data["nominee_dob"]=trim($nomineeDOB_format);
				$data["nominee_address"]=trim($nomineeAddress);
				$mailBody = $this->load->view('nominee_change_pdf_view',$data,true);
				$this->load->library('mpdf60/mPDF');
				$pdfPath = '';
				try
				{
					$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
					$mpdf->useOnlyCoreFonts = true;    // false is default
					$mpdf->SetProtection(array('print'));
					$mpdf->SetTitle("Change Nominee");
					$mpdf->SetAuthor("Author");
					$mpdf->showWatermarkText = true;
					$mpdf->SetDisplayMode('fullpage');

					$html=$mailBody;
					$mpdf->WriteHTML($html);
					$fileName = $investorId .'_change_nominee_form_'.date('YmdHis', time()).'.pdf';
					$mpdf->Output(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName, 'F');
					$pdfPath = realpath(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName);
					//$result2=$this->preferences_model->updatePdfUrlData($fileName,$investorId,$nomineeId);
					if($result2 =true)
					{
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNomineeDetails, Message : Successfully updated new nominee details pdf url  *****');
						$emailResult=$this->sendNomineeChangeMail($nomineeName,$nomineeDOB_format,$nomineeAddress,$nomineeRelation,$pdfPath,$nomineeGuardian,$nomineePercentage);
						if($emailResult)
						{
							echo '{"success":true,"message":"Nominee details updated successfully","pdf_name":"'.$fileName.'"}';
							$message="Updated Nominee details and successfully sent new nominee details mail";
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNomineeDetails, Message : '.$message.'  *****');
		      				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
						else
						{
							echo '{"success":true,"message":"Nominee details updated successfully","pdf_name":"'.$fileName.'"}';
							$message="Updated Nominee details but failed to send new nominee details mail";
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNomineeDetails, Message : '.$message.'  *****');
		      				$data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
					}
					else
					{
						echo '{"success":false}';
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNomineeDetails, Message : Unable to save nominee details pdf url  *****');
					}
				}
				catch(Exception $e)
				{
					echo '{"success":false,"error":"'.$e.'"}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNomineeDetails, Message : Session expired while updating nominee details pdf url  *****');
				}
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNomineeDetails, Message : Failed to update nominee details  *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : updateNomineeDetails, Message : Session expired while updating nominee details  *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : getPendingNomineeDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : getPendingNomineeDetails
-----------------------------------------------------------------------------------------------------
*/
	function getPendingNomineeDetails()
	{
		if(checkuser_session())
		{
			$investorId=$_SESSION["investor_id"];
			$result=$this->preferences_model->getPendingNomineeDetails($investorId);
			if($result)
			{
				$pendingCount=$result->pending_count;
				echo '{"success":true,"pending_count":"'.$pendingCount.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getPendingNomineeDetails, Message : Successfully fetched pendingNomineeCount  *****');
			}
			else
			{
				echo '{"success":false,"pending_count":"0"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getPendingNomineeDetails, Message : Failed to fetch pendingNomineeCount  *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : getPendingNomineeDetails, Message : Session expired while fetching pendingNomineeCount  *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : checkNomineePercentage
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : checkNomineePercentage
-----------------------------------------------------------------------------------------------------
*/
	function checkNomineePercentage()
	{
		if(checkuser_session())
		{
			$percentage=$this->input->post("percentage");
			$investorId=$_SESSION["investor_id"];
			$totalPercentage=$this->preferences_model->checkNomineeTotalPercentage($investorId);
			$total=0;
			if($totalPercentage)
			{
				$total=$total+$totalPercentage->total_percentage;
				$balancePercentage=(100-$total);
				echo '{"success":true,"total":"'.$total.'","balance":"'.$balancePercentage.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkNomineePercentage, Message : Successfully fetched total and balance percentage  *****');
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkNomineePercentage, Message : Failed to fetch total and balance percentage  *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkNomineePercentage, Message : Session expired while fetching total and balance percentage  *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : checkEditNomineePercentage
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : checkEditNomineePercentage
-----------------------------------------------------------------------------------------------------
*/
	function checkEditNomineePercentage()
	{
		if(checkuser_session())
		{
			$newPercentage=$this->input->post("newPercentage");
			$currentPercentage=$this->input->post("currentPercentage");
			$investorId=$_SESSION["investor_id"];
			$totalPercentage=$this->preferences_model->checkNomineeTotalPercentage($investorId);
			$total=0;
			if($totalPercentage)
			{
				$total=$total+$totalPercentage->total_percentage;
				$balancePercentage=100-($total-$currentPercentage+$newPercentage);
				echo '{"success":true,"total":"'.$total.'","balance":"'.$balancePercentage.'"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkEditNomineePercentage, Message : Successfully checked total and balance percentage  *****');
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkEditNomineePercentage, Message : Failed to check total and balance percentage  *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : checkEditNomineePercentage, Message : Session expired while checking total and balance percentage  *****');
		}
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : deleteNomineeDetails
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : deleteNomineeDetails
-----------------------------------------------------------------------------------------------------
*/
	function deleteNomineeDetails()
	{
		if(checkuser_session())
		{
			$investorId=$_SESSION["investor_id"];
			$nomineeId=$this->input->post("nomineeId");
			$data['status']=2;
			$result=$this->preferences_model->deleteNomineeDetails($investorId,$nomineeId,$data);
			if($result)
			{
				echo '{"success":true}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : deleteNomineeDetails, Message : Successfully deleted the nominee details of nominee Id: '.$nomineeId.'  *****');
			}
			else
			{
				echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : deleteNomineeDetails, Message : Failed to delete the nominee details of nominee Id: '.$nomineeId.'  *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : deleteNomineeDetails, Message : Session expired while deleting nominee details  *****');
		}
	}


	function sendBankChangeMailApp($account_name,$investorNameOnPancard,$account_number,$account_type_name,$ifsc_code,$bank_name,$branch_name,$branch_state,$branch_city,$pdfPath,$pdfPath2,$userName,$email)
	{
		$email=$email;
		$name=$this->encrypt->encode($userName);
		$today = date('d M Y h:i a', time());
		$data=array();

		$data["name"]=$this->encrypt->decode($name);
		$data["account_name"]=$account_name;
		$data["investor_name_on_pancard"]=$investorNameOnPancard;
		$data["account_no"]=$account_number;
		$data["account_type"]=$account_type_name;
		$data["ifsc_code"]=$ifsc_code;
		$data["bank_name"]=$bank_name;
		$data["branch_name"]=$branch_name;
		$data["branch_state"]=$branch_state;
		$data["branch_city"]=$branch_city;

		$html=$this->load->view('bank_change_email_view', $data,true);
		// $this->load->library("email");
		// $this->email->set_newline("\r\n");
		// $this->email->set_mailtype("html");
		// $this->email->to($email);
		// // $this->email->cc("anvesh.pandey@investocafe.com,rahul.gehlot@investocafe.com,neha.joshi@investocafe.com");
		// // $this->email->bcc("nikunj17287@gmail.com");
		// $this->email->from(" Investocafe Assistant<info@investocafe.com>", "Investocafe");
		// $this->email->subject("Change of Bank: Action Required");
		// $this->email->message($html);
		// $this->email->attach($pdfPath,$pdfPath2);
		// $result=$this->email->send();
		//echo $this->email->print_debugger();
		$subject = "Change of Bank: Action Required";
		$result = sendEmail($email,$subject,$html);
		return $result;
	}	
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : sendBankChangeMail
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : sendBankChangeMail
-----------------------------------------------------------------------------------------------------
*/
	function sendBankChangeMail($account_name,$investorNameOnPancard,$account_number,$account_type_name,$ifsc_code,$bank_name,$branch_name,$branch_state,$branch_city,$pdfPath,$pdfPath2)
	{
		$email=$_SESSION["email"];
		$name=$_SESSION["userName"];
		$today = date('d M Y h:i a', time());
		$data=array();

		$data["name"]=$name;
		$data["account_name"]=$account_name;
		$data["investor_name_on_pancard"]=$investorNameOnPancard;
		$data["account_no"]=$account_number;
		$data["account_type"]=$account_type_name;
		$data["ifsc_code"]=$ifsc_code;
		$data["bank_name"]=$bank_name;
		$data["branch_name"]=$branch_name;
		$data["branch_state"]=$branch_state;
		$data["branch_city"]=$branch_city;

		$html=$this->load->view('bank_change_email_view', $data,true);
		$this->load->library("email");
		$this->email->set_newline("\r\n");
		$this->email->set_mailtype("html");
		$this->email->to($email);
		$this->email->cc("anvesh.pandey@investocafe.com,rahul.gehlot@investocafe.com,neha.joshi@investocafe.com");
		// $this->email->bcc("nikunj17287@gmail.com");
		$this->email->from(" Investocafe Assistant<info@investocafe.com>", "Investocafe");
		$this->email->subject("Change of Bank: Action Required");
		$this->email->message($html);
		$this->email->attach($pdfPath,$pdfPath2);
		$result=$this->email->send();
		//echo $this->email->print_debugger();
		return $result;
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : sendAddressChangeMail
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : sendAddressChangeMail
-----------------------------------------------------------------------------------------------------
*/
	function sendAddressChangeMail($new_address,$new_address2,$new_pincode,$new_city_name,$new_state_name,$pdfPath)
	{
		$email=$_SESSION["email"];
		$name=$_SESSION["userName"];
		// print_r($name);die;
		$today = date('d M Y h:i a', time());
		$data=array();

		$data["name"]=$name;
		$data["new_address"]=$new_address;
		$data["new_pincode"]=$new_pincode;
		$data["new_city_name"]=$new_city_name;
		$data["new_state_name"]=$new_state_name;

		$html=$this->load->view('address_change_email_view', $data,true);
		// $this->load->library("email");
		// $this->email->set_newline("\r\n");
		// $this->email->set_mailtype("html");
		// $this->email->to($email);
		// $this->email->cc("anvesh.pandey@investocafe.com,rahul.gehlot@investocafe.com,neha.joshi@investocafe.com");
		// //$this->email->bcc("nikunj17287@gmail.com");
		// $this->email->from(" Investocafe Assistant<info@investocafe.com>", "Investocafe");
		// $this->email->subject("Change of Address: Action Required");
		// $this->email->message($html);
		// $this->email->attach($pdfPath);
		// $result=$this->email->send();
		//echo $this->email->print_debugger();
		$subject = "Change of Address: Action Required";
		$result = sendEmail($email,$subject,$html);
		return $result;
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : sendPurchaseSms
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : sendAddressChangeMail
-----------------------------------------------------------------------------------------------------
*/	
	// stop temp
	function sendpasswordchnage($userPhone,$sendid)
    {
        if($userPhone!="")
        {
            $ch = curl_init();
            //Like us on bit.ly/eshpind----------------
			if($sendid == 1)
			{
				$url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear Investor, your Email has been changed successfully.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4";
			}
			else
			{
				$url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear Investor, your password has been changed successfully.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4";
			
			}
		   
			
           $url=str_replace(" ", "%20", $url1);
            //echo $url;
            curl_setopt($ch, CURLOPT_URL, $url);
            //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

            //return the transfer as a string
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

            //$output contains the output string
            $output = curl_exec($ch);

            $dbData = array ('phone'=>$userPhone,'response'=>$output);
            $this->db->insert('msg_log',$dbData);
            //close curl resource to free up system resources
            curl_close($ch);

            if ( $output === FALSE)
            {
              $output=curl_error($ch); //echoes last session error
              return false;
            }
            return $output;
        }
        else
        {
            //echo "Invalid user name or phone number";
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : sendPurchaseSms, Messege : Invalid user name or phone number for send Sms For purchase funds. *****");
        }
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : sendPurchaseSms
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : sendAddressChangeMail
-----------------------------------------------------------------------------------------------------
*/	
	// stop temp
	function sendPurchaseSms($userName,$userPhone,$OTP)
    {
        $ch = curl_init();
        if($userPhone!="")
        {
            $ch = curl_init();
			 $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear ".$userName.", your Investocafe account OTP is ".$OTP.". Enter OTP and edit your profile.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4&country=91&DLT_TE_ID=1207160699207959752";
			
            $url=str_replace(" ", "%20", $url1);
			
            curl_setopt($ch, CURLOPT_URL, $url);
            //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

            //return the transfer as a string
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

            //$output contains the output string
            $output = curl_exec($ch);

            $dbData = array ('phone'=>$userPhone,'response'=>$output);
            $this->db->insert('msg_log',$dbData);
            //close curl resource to free up system resources
            curl_close($ch);

            if ( $output === FALSE)
            {
              $output=curl_error($ch); //echoes last session error
              return false;
            }
            return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : sendPurchaseSms, Messege : Invalid user name or phone number for send Sms For purchase funds. *****");
        }
       
    }
	
	
	
		
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : all app methods starts here
|   DATE : 17/11/2016
|   AUTHOR : prakash
-----------------------------------------------------------------------------------------------------
*/	

/*
-----------------------------------------------------------------------------------------------------
|   USE : appGetCurrentLoggedInUserInfo
|   DATE : 17/11/2016
|   AUTHOER : prakash
|   COMMENT : It is used to fill the data in edit profile section
-----------------------------------------------------------------------------------------------------
*/
    function appGetCurrentLoggedInUserInfo()
    {
	  $get_app_data = json_decode(file_get_contents("php://input"));
      $investorId = $get_app_data->investorId;
	  $userId=$get_app_data->userId; 
	  if($investorId && $userId)
	  {
		$data["bankAccountTypeList"]=$this->registration_model->getInvestorBankAccountTypeList();
		$data["bankMasterList"]=$this->registration_model->getbankMasterList();
		$totalNomineeCountResult=$this->registration_model->checkNoOfNominee($investorId);
		$userdata=$this->registration_model->getInvestorDetail($investorId);
		$data["profileImageUrl"]=   $userdata->profile_image_url;
		if($totalNomineeCountResult==0)
		{
			$data["totalNomineeCount"] = 0;
		}
		else
		{
			$data["totalNomineeCount"] = $totalNomineeCountResult;
		}
	
		$resultCityList=$this->preferences_model->getCityListForApp();
		$data["cityList"]=$resultCityList;
		$data["stateList"]=$this->preferences_model->getStateListForApp();
		
	    	$result=$this->preferences_model->getInvestorDetails($investorId);
	    	if($result)
	    	{
				$data['investorDetails']->currentEmailId = $result->email;
          		$dataContactName=$this->encrypt->decode($result->name);
	    		$data['investorDetails']->currentContactName= ucwords($dataContactName);
			
			}
			else
			{
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : getCurrentLoggedInUserInfo, Message : Failed to fetch user name, email *****');
			}
			
		
			$result=$this->preferences_model->getContactInfo($userId);
			if($result)
			{
				$data['contactDetails']->phone =$this->encrypt->decode($result->phone);
				if($result->overseas_no)
				{
				$data['contactDetails']->overseas_no=$this->encrypt->decode($result->overseas_no);	
				}
				else
				{
				$data['contactDetails']->overseas_no="";	
				}
				
				
				if($result->residence_phone)
				{
				$data['contactDetails']->residence_phone=$this->encrypt->decode($result->residence_phone);	
				}
				else
				{
				$data['contactDetails']->residence_phone="";	
				}
					if($result->office_phone)
				{
				$data['contactDetails']->office_phone=$this->encrypt->decode($result->office_phone);
				}
				else
				{
				$data['contactDetails']->office_phone="";	
				}
				
				
			}
			else
			{
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : getCurrentLoggedInUserInfo, Message : Failed to fetch user name, email *****');
			}
				$addressDetails=$this->preferences_model->getAddress($userId);
			if($addressDetails)
			{
				$data['addressDetails'] = $addressDetails;
			}
			else
			{
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appGetCurrentLoggedInUserInfo, Message : Failed to fetch user name, email *****');
			}
			
			$bankDetails=$this->preferences_model->getBankDetails($userId);
			if($bankDetails)
			{
				 $acHolderName = $this->encrypt->decode($bankDetails->account_holder_name);
				
				$data['bankDetails']->account_name = $acHolderName;
				$data['bankDetails']->account_number = $this->encrypt->decode($bankDetails->account_number);
				$data['bankDetails']->account_type = $bankDetails->account_type;
				$data['bankDetails']->account_type_id = $bankDetails->account_type_id;
				$data['bankDetails']->ifsc_code = $bankDetails->ifsc_code;
				$data['bankDetails']->bank_master_id = $bankDetails->bank_master_id;
				$data['bankDetails']->bank_name = rtrim($bankDetails->bank_name);
				$data['bankDetails']->branch_name = rtrim($bankDetails->branch_name);
				$data['bankDetails']->branch_state = rtrim($bankDetails->branch_state);
				$data['bankDetails']->branch_city = rtrim($bankDetails->branch_city);
			}
			else 
			{
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appGetCurrentLoggedInUserInfo, Message : Failed to fetch user name, email *****');
			}
			$nominee_data=$this->preferences_model->getNomineeDetails($userId);
			if($nominee_data)
			{
				foreach($nominee_data as $key=> $nd)
				{
					if($nd->address == '')
					{
						$nominee_data[$key]->address =  $addressDetails->address." ".$addressDetails->address_2." ".$addressDetails->location_name." ".$addressDetails->state_name." ".$addressDetails->pincode;
					}
				}
				$data['nominee_data']=$nominee_data;
			}
			else
			{
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appGetCurrentLoggedInUserInfo, Message : Failed to fetch user name, email *****');
			}
				$result=$this->preferences_model->getPendingNomineeDetails($investorId);
			if($result)
			{
				$data['pendingCount']=$result->pending_count;
			}
			else
			{
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appGetCurrentLoggedInUserInfo, Message : Failed to fetch user name, email *****');
			}	
			
			$data['app'] = [
				'android'=>'1.15',
				'ios' => '1.3'
			];
			$out = json_encode($data);
			echo $out;
			
	  }
	    else
	    {
	    	echo '{"success":false,"msg":"need investor & user id"}';
			log_message('info', '*****  Controller : Preferences, Function : appGetCurrentLoggedInUserInfo, Message : Session expired while fetching user name, email *****');
	    }
    }
	
	
	

/*
-----------------------------------------------------------------------------------------------------
|   USE : appUpdateContactInfo
|   DATE : 17/11/2016
|   AUTHOER : prakash
|   COMMENT : It is used to update contact phone data
-----------------------------------------------------------------------------------------------------
*/	
	function appUpdateContactInfo()
	{
	  $get_app_data = json_decode(file_get_contents("php://input"));
	   $investorId = $get_app_data->investorId;
	  $userId=$get_app_data->userId; 
	  if($investorId&&$userId)
	  {
			$phone=$this->encrypt->encode($get_app_data->phone);
			$overseas_no=$this->encrypt->encode($get_app_data->overseas_no);
			$residence_phone=$this->encrypt->encode($get_app_data->residence_phone);
			$office_phone=$this->encrypt->encode($get_app_data->office_phone);

			/** investor table data **/
    		$data = array(
						'phone' => $phone,
					 );

    		$result=$this->ion_auth->update($userId,$data);
    		/** investor table data **/
			$data2= array(
				  "overseas_no"=>$overseas_no,
				  "residence_phone"=>$residence_phone,
				  "office_phone"=>$office_phone,
			     );
    		$result1=$this->preferences_model->updateContactInfo($userId,$data2);
			if($result1)
			{
				$message="Successfully updated contact info";
				echo '{"success":"true","msg":"'.$message.'"}';
				log_message('info', '***** userId : '.$userId.', Controller : Preferences, Function : appUpdateContactInfo, Message : '.$message.' *****');
   				
			}
			else
			{
				$message="Failed to update contact info";
				echo '{"success":"false","msg":"'.$message.'"}';
    			log_message('info', '***** userId : '.$userId.', Controller : Preferences, Function : appUpdateContactInfo, Message : '.$message.' *****');
    			}
		}
		else
		{
			echo '{"success":"false","session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : appUpdateContactInfo, Message : Session expired while updating contact info *****');
		}
	}
	

/*
-----------------------------------------------------------------------------------------------------
|   USE : appUpdateCurrentUserInfo
|   DATE : 17/11/2016
|   AUTHOER : prakash
|   COMMENT : It is used to update user name,email data
-----------------------------------------------------------------------------------------------------
*/	
	function appUpdateCurrentUserInfo()
    {
    	
	  $get_app_data = json_decode(file_get_contents("php://input"));
	  $investorId = $get_app_data->investorId;
	  $userId=$get_app_data->userId;
	  $password=$get_app_data->password; 
	  $result=$this->ion_auth->hash_password_db($userId, $password);
	  if(!$result)
	  {
		  echo '{"success":"false","msg":"Password Invalid"}';
		  exit;
	  }
	  
	  if($investorId&&$userId)
	  {
		  $name=$this->encrypt->encode($get_app_data->name);
	      $email=$get_app_data->email;
          $data = array(
						"first_name"=>$name,
						"username"=>$name,
						"email"=>$email,
						);
					 
			if(true)
			{
			  $result=$this->ion_auth->update($userId, $data);
				if($result)
				{
					$resultInfo=$this->preferences_model->getInvestorDetails($investorId);
					if($resultInfo)
					{
						$phone=$this->encrypt->decode($resultInfo->phone);
					}
					$message="Successfully updated user name, email and password";
					echo '{"success":"true","msg":"'.$message.'"}';
					log_message('info', '***** userId : '.$userId.', Controller : Preferences, Function : appUpdateCurrentUserInfo, Message : '.$message.' *****');
				}
				else
				{
					$message="Failed to update user name, email and password";
					echo '{"success":false,"msg":"'.$message.'"}';
					log_message('info', '***** userId : '.$userId.', Controller : Preferences, Function : appUpdateCurrentUserInfo, Message : '.$message.' *****');
				}
			} 
			else
			{
					$message="Wrong Email,password";
					echo '{"success":false,"msg":"'.$message.'"}';
					log_message('info', '***** userId : '.$userId.', Controller : Preferences, Function : appUpdateCurrentUserInfo, Message : '.$message.' *****');
				
			}
		
    	}
    	else
    	{
    		echo '{"success":"false","session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : appUpdateCurrentUserInfo, Message : Session expired while updating user name, email and password *****');
    	}
    }
/*
-----------------------------------------------------------------------------------------------------
|   USE : appUpdateCurrentUserLoginIdPassword
|   DATE : 17/11/2016
|   AUTHOER : prakash
|   COMMENT : It is used to update login password
-----------------------------------------------------------------------------------------------------
*/	
    function appUpdateCurrentUserLoginIdPassword()
    {
	  $get_app_data = json_decode(file_get_contents("php://input"));
	   $investorId = $get_app_data->investorId;
	  $userId=$get_app_data->userId; 
	  if($investorId && $userId)
	  {
	    	$currentPassword=$get_app_data->currentPassword;
	    	$password=$get_app_data->newPassword;
			$data = array(
							'password' => $password,
						 );
			
			if($this->ion_auth->hash_password_db($userId, $currentPassword))
			{ 
				$result=$this->ion_auth->update($userId, $data);
				if($result)
				{ 
					$resultInfo=$this->preferences_model->getInvestorDetails($investorId);
					if($resultInfo)
					{
						$phone=$this->encrypt->decode($resultInfo->phone);
					}
					$this->sendpasswordchnage($phone,2);
					$message="Successfully updated user password";
					echo '{"success":"true","msg":"'.$message.'"}';
					log_message('info', '***** user_id : '.$userId.', Controller : Preferences, Function : appUpdateCurrentUserLoginIdPassword, Message : '.$message.' *****');
				
				}
				else
				{
					$message="Failed to update user password";
					echo '{"success":"false","msg":"'.$message.'"}';
					log_message('info', '***** investorId : '.$investorId.', Controller : Preferences, Function : appUpdateCurrentUserLoginIdPassword, Message : '.$message.' *****');
				
				}
			
			}
			else
			{
			
				echo '{"success":"false","msg":"Invalid current password"}';
    			log_message('info', '***** investorId : '.$investorId.', Controller : Preferences, Function : appUpdateCurrentUserLoginIdPassword, Message : '.$message.' *****');
    		
			}
			
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : appUpdateCurrentUserLoginIdPassword, Message : Session expired while updating user password *****');
		}
    }
	
	
	/*
-----------------------------------------------------------------------------------------------------
|   USE : appUpdateCommunicationAddress
|   DATE : 17/11/2016
|   AUTHOER : prakash
|   COMMENT : It is used to update communication address
-----------------------------------------------------------------------------------------------------
*/	
	
    function appUpdateCommunicationAddress()
	{
		 $get_app_data = json_decode(file_get_contents("php://input"));
	   $investorId = $get_app_data->investorId;
	  $userId=$get_app_data->userId; 
	  if($investorId&&$userId)
	  {
			$new_address = $get_app_data->new_communication_address;
			$new_pincode = $get_app_data->new_pincode;
			$new_city = $get_app_data->new_city;
			$new_state = $get_app_data->new_state;
			$new_countryCode=76;
			$result=$this->preferences_model->updateCommunicationAddress($userId,$new_address,$new_pincode,$new_city,$new_state,$new_countryCode);
			if($result)
			{
				$message="Communication address updated successfully";
				echo '{"success":"true","msg":"'.$message.'"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateCommunicationAddress, Message : '.$message.' *****');
    		
			}
			else
			{
				$message="Failed to update address details";
				echo '{"success":"false","msg":"'.$message.'"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateCommunicationAddress, Message : '.$message.' *****');
    		
			}
		}
		else
		{
			echo '{"success":"false","session":"out"}';
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateCommunicationAddress, Message : Session expired while updating address details  *****');
		}
	}
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : appUpdateBankDetails
|   DATE : 17/11/2016
|   AUTHOER : prakash
|   COMMENT : It is used to update bank details
-----------------------------------------------------------------------------------------------------
*/	

function appUpdateBankDetails()
{

	$get_app_data = json_decode(file_get_contents("php://input"));

	$investorId = $get_app_data->investorId;
	$userId=$get_app_data->userId; 
	if($investorId && $userId)
	{
		$account_name = $this->encrypt->encode($get_app_data->account_name);
		$account_number = $this->encrypt->encode($get_app_data->account_number);
		$account_type = $get_app_data->account_type;
		$ifsc_code = $get_app_data->ifsc_code;
		$bank_master_id_new = $get_app_data->bank_master_id;
		$branch_city_new = $get_app_data->branch_city;
		$branch_state_new = $get_app_data->branch_state;
		$branch_name_new = $get_app_data->branch_name;
		$investor_id_new = $get_app_data->investor_id;
		// $branch_name_new = $get_app_data->branch_name;
		

		$result=$this->preferences_model->getBankDetails($userId);
		$bank_master_id = $result->bank_master_id;
		$account_type_id = $result->account_type_id;
		
		
		$bank_name = rtrim($result->bank_name);
		$branch_name = rtrim($result->branch_name);
		$branch_state = rtrim($result->branch_state);
		$branch_city = rtrim($result->branch_city);			

		$current_date = date('Y-m-d', time());

			$data=array(
				'account_holder_name' => $account_name,
				'account_no'=>$account_number,
				'account_type'=>$account_type_id,
				"ifsc_code"=>$ifsc_code,
				"bank_master_id"=>$bank_master_id_new,
				"branch_city"=>$branch_city_new,
				"branch_state"=>$branch_state_new,
				"branch_name"=>$branch_name_new,
				"investor_id"=>$investorId,
				"request_date"=>$current_date,
				"status"=>0
		);


		$result=$this->preferences_model->insertBankDetails($data);
		if($result)
		{
			$modifiedBankInsertedId = $result;
			$userData=$this->preferences_model->getUserData($userId);
			if($userData)
			{
					$data["user_address"]=$userData->address;
					$data["user_pincode"]=$userData->pincode;
					$data["user_city"]=$userData->location_name;
					$data["user_state"]=$userData->state_name;
					$data["user_investorId"]=$investorId;
					$data["user_pan"]=$userData->pan;
					$data2["user_name"]=$userData->username;
					$data2["user_email"]=$userData->email;
					$data2["user_phone"]=$userData->phone;
					$data2["user_registeredDate"]=$userData->is_investor_registered_date;
			}

			$data["userName"]=$userData->username;
			$data["account_holder_name"]=trim($account_name);
			$data["account_number"]=trim($account_number);
			$data["account_type"]=trim($account_type_name);
			$data["ifsc_code"]=trim($ifsc_code);
			$data["bank_name"]=trim($bank_name);
			$data["branch_city"]=trim($branch_city);
			$data["branch_name"]=trim($branch_name);
			$data["branch_state"]=trim($branch_state);

			$data2["account_number"]=trim($account_number);
			$data2["ifsc_code"]=trim($ifsc_code);
			$data2["bank_name"]=trim($bank_name);
			$data2["userName"]=$userData->username;

			$mailBody = $this->load->view('bank_change_pdf_view',$data,true);
			$mailBody2 = $this->load->view('bank_mandate_pdf_view',$data2,true);
			$this->load->library('mpdf60/mPDF');
			$pdfPath = '';
			$pdfPath2 = '';
			try
			{
				$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
				$mpdf->useOnlyCoreFonts = true;    // false is default
				$mpdf->SetProtection(array('print'));
				$mpdf->SetTitle("Change Bank");
				$mpdf->SetAuthor("Author");
				$mpdf->showWatermarkText = true;
				$mpdf->SetDisplayMode('fullpage');

				$html=$mailBody;
				$mpdf->WriteHTML($html);
				$fileName = $investorId .'_change_bank_form_'.date('YmdHis', time()).'.pdf';
				$mpdf->Output(APPPATH.'../assets/uploads/changeBankForm/'.$fileName, 'F');
				$pdfPath = realpath(APPPATH.'../assets/uploads/changeBankForm/'.$fileName);

				$result2=$this->preferences_model->saveChangeBankPdfUrlData($fileName,$userId,$modifiedBankInsertedId);

				$mpdf2=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
				$mpdf2->useOnlyCoreFonts = true;    // false is default
				$mpdf2->SetProtection(array('print'));
				$mpdf2->SetTitle("Bank Mandate");
				$mpdf2->SetAuthor("Author");
				$mpdf2->showWatermarkText = true;
				$mpdf2->SetDisplayMode('fullpage');

				$html2=$mailBody2;
				$mpdf2->WriteHTML($html2);
				$fileName2 = $investorId .'_bank_mandate_form_'.date('YmdHis', time()).'.pdf';
				$mpdf2->Output(APPPATH.'../assets/uploads/changeBankForm/'.$fileName2, 'F');
				$pdfPath2 = realpath(APPPATH.'../assets/uploads/changeBankForm/'.$fileName2);

				$bankMandateUrlUpdateresult=$this->preferences_model->saveBankMandateUrlData($fileName2,$userId,$modifiedBankInsertedId);

				if($result2)
				{
					$emailResult=$this->sendBankChangeMailApp($account_name,$investorNameOnPancard,$account_number,$account_type_name,$ifsc_code,$bank_name,$branch_name,$branch_state,$branch_city,$pdfPath,$pdfPath2,$userData->username,$userData->email);
					if($emailResult)
					{
						echo '{"success":true,"msg":"Bank details updated successfully","pdf_name":"'.$fileName.'","mandate_pdfUrl":"'.$fileName2.'"}';
					}
					else
					{
						echo '{"success":true,"msg":"Bank details updated successfully","pdf_name":"'.$fileName.'","mandate_pdfUrl":"'.$fileName2.'"}';
					}
				}
				else
				{
					echo '{"success":false}';
				}
			}
			catch(Exception $e)
			{
				echo '{"success":false,"error":"'.$e.'"}';
				// log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Preferences, Function : insertBankDetails, Message : session expired while saving bank details pdf url *****');
			}
		}
		else
		{
		  	echo '{"success":false}';
		}
	}else{
		echo '{"success":false}';
	}
}
function appUpdateBankDetails1()
	{
		 $get_app_data = json_decode(file_get_contents("php://input"));
	 
	  $investorId = $get_app_data->investorId;
	  $userId=$get_app_data->userId; 
	  if($investorId && $userId)
	  { 
	  
	      $account_name = $this->encrypt->encode($get_app_data->account_name);
	      $account_number = $this->encrypt->encode($get_app_data->account_number);
	      $account_type = $get_app_data->account_type;
	      $ifsc_code = $get_app_data->ifsc_code;
	      $bank_master_id = $get_app_data->bank_master_id;
	      $data=array(
	      	'account_holder_name' => $account_name,
	      	'account_number'=>$account_number,
	      	'account_type_id'=>$account_type,
	      	"ifsc_code"=>$ifsc_code,
	      	"bank_master_id"=>$bank_master_id,
	       );
	        $result=$this->preferences_model->updateBankDetails($investorId,$data);
	        if($result)
	        {
	          	$message="Successfully updated bank details";
				echo '{"success":"true","msg":"'.$message.'"}';
	          	log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateBankDetails, Message : '.$message.'  *****');
	    	
	        }
	        else
	        {
				$message="Failed to update bank details";	          
				echo '{"success":"false","msg":"'.$message.'"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateBankDetails, Message : '.$message.'  *****');
    		
	        }
	    }
	    else
	    {
	      	echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : appUpdateBankDetails, Message : Session expired while updating bank details  *****');
	    }
	}	
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : appUpdateNomineeDetails
|   DATE : 17/11/2016
|   AUTHOER : prakash
|   COMMENT : It is used to update nominee details
-----------------------------------------------------------------------------------------------------
*/		
	
	function appUpdateNomineeDetails()
	{
		 $get_app_data = json_decode(file_get_contents("php://input"));
	 
	  $investorId = $get_app_data->investorId;
	  $userId=$get_app_data->userId; 
	  $userName=$get_app_data->userName; 
	  if($investorId&&$userId)
	  {
		    $nomineeId=$get_app_data->nomineeId;
			$nomineeName=$get_app_data->nomineeName;
			$nomineeRelation=$get_app_data->nomineeRelation;
			$nomineePercentage=$get_app_data->nomineePercentage;
			$nomineeDOB=$get_app_data->nomineeDOB;
			$nomineeDOB_dc=date_create($get_app_data->nomineeDOB);
			$nomineeDOB_format= date_format($nomineeDOB_dc,"F d, Y");
			$nomineeGuardian=$get_app_data->nomineeGuardian;
			$nomineeAddress=$get_app_data->nomineeAddress;

			$current = $this->preferences_model->getCurrentPercentage($nomineeId);
			
			$percentage = $nomineePercentage;
			$totalPercentage=$this->preferences_model->checkNomineeTotalPercentage($investorId);
			 $totalPercentage->total_percentage;
			$total=0;
			if( $totalPercentage->total_percentage)
			{
				$total=($total+$totalPercentage->total_percentage)-$current;

				$balancePercentage=(100-$total);

				if($balancePercentage==0)
					$check = false;

				if($percentage > $balancePercentage)
				{
					$check = false;
				}
				else
				{
					$check = true;
				}
				
				
			}
			else
				$check = true;

			//$check = $this->checkNomTotalPercantage($investorId,$nomineePercentage,$currentPercentage);
			if(!$check )
			{
				echo '{"success":"false","msg":"Total percentage cannot be greater than 100."}';
				exit();
			}
			$data = array(
						'name' => $nomineeName,
						'relation_with_investor'=>$nomineeRelation,
						'date_of_birth'=>$nomineeDOB,
						'address'=>$nomineeAddress,
						'status'=>0,
						'guardian_name'=>$nomineeGuardian,
						'percentage'=>$nomineePercentage
					 );
			//print_r(	$data );
			$resultUpdate=$this->preferences_model->updateNomineeDetails($investorId, $data, $nomineeId);
			if($resultUpdate)
			{
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateNomineeDetails, Message : Successfully updated nominee details  *****');
				$userData=$this->preferences_model->getUserData($userId);
				if($userData)
				{
						$data["user_address"]=$userData->address;
						$data["user_pincode"]=$userData->pincode;
						$data["user_city"]=$userData->location_name;
						$data["user_state"]=$userData->state_name;
						$data["user_investorId"]=$investorId;
						$data["user_pan"]=$userData->pan;
				}

				$data["userName"]=$userName;
				$data["nominee_name"]=trim($nomineeName);
				$data["nominee_relation"]=trim($nomineeRelation);
				$data["nominee_percentage"]=trim($nomineePercentage);
				$data["guardian_name"]=trim($nomineeGuardian);
				$data["nominee_dob"]=trim($nomineeDOB_format);
				$data["nominee_address"]=trim($nomineeAddress);
				$mailBody = $this->load->view('nominee_change_pdf_view',$data,true);
				$this->load->library('mpdf60/mPDF');
				$pdfPath = '';
				try
				{
					$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
					$mpdf->useOnlyCoreFonts = true;    // false is default
					$mpdf->SetProtection(array('print'));
					$mpdf->SetTitle("Change Nominee");
					$mpdf->SetAuthor("Author");
					$mpdf->showWatermarkText = true;
					$mpdf->SetDisplayMode('fullpage');

					$html=$mailBody;
					$mpdf->WriteHTML($html);
					$fileName = $investorId .'_change_nominee_form_'.date('YmdHis', time()).'.pdf';
					$mpdf->Output(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName, 'F');
					$pdfPath = realpath(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName);
					//$result2=$this->preferences_model->updatePdfUrlData($fileName,$investorId,$nomineeId);
					if($result2 =true)
					{
						log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateNomineeDetails, Message : Successfully updated new nominee details pdf url  *****');
						$emailResult=$this->sendNomineeChangeMail($nomineeName,$nomineeDOB_format,$nomineeAddress,$nomineeRelation,$pdfPath,$nomineeGuardian,$nomineePercentage);
						if($emailResult)
						{
							echo '{"success":"true","msg":"Nominee details updated successfully","pdf_name":"'.$fileName.'"}';
							$message="Updated Nominee details and successfully sent new nominee details mail";
							log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateNomineeDetails, Message : '.$message.'  *****');
		      				$data=array("investor_id"=>$investorId,"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
						else
						{
							echo '{"success":"true","message":"Nominee details updated successfully","pdf_name":"'.$fileName.'"}';
							$message="Updated Nominee details but failed to send new nominee details mail";
							log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateNomineeDetails, Message : '.$message.'  *****');
		      	
						}
					}
					else
					{
						echo '{"success":"false","msg":"unable to update pdf data!"}';
						log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateNomineeDetails, Message : Unable to save nominee details pdf url  *****');
					}
				}
				catch(Exception $e)
				{
					echo '{"success":"false","msg":" error '.$e.'"}';
					log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateNomineeDetails, Message : Session expired while updating nominee details pdf url  *****');
				}
			}
			else
			{
				echo '{"success":"true","message":"Nominee details updated successfully","pdf_name":""}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateNomineeDetails, Message : Failed to update nominee details  *****');
			}
		}
		else
		{
			echo '{"success":"false","session":"out"}';
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appUpdateNomineeDetails, Message : Session expired while updating nominee details  *****');
		}
	}
	
	
	/*
-----------------------------------------------------------------------------------------------------
|   USE : appInsertNomineeDetails
|   DATE : 22/11/2016
|   AUTHOER : Prakash
|   COMMENT : appInsertNomineeDetails used to insert nominee details
-----------------------------------------------------------------------------------------------------
*/
	function appInsertNomineeDetails()
	{ 
	  $get_app_data = json_decode(file_get_contents("php://input"));
	  $investorId = $get_app_data->investorId;
	  $userId=$get_app_data->userId; 
	  $userName=$get_app_data->userName; 
	  if($investorId&&$userId)
	  {
			$nominee_name = $get_app_data->nomineeName;
			$nominee_relation = $get_app_data->nomineeRelation;
			$nominee_percentage = $get_app_data->nomineePercentage;
			$this->appCheckNomineePercentage($investorId,$nominee_percentage);
			$guardian_name = $get_app_data->nomineeGuardian;
			$date = new DateTime($get_app_data->dob);
			$nominee_dob=$date->format('Y-m-d');
			$nominee_dob_format=$date->format('M j, Y');
			$nominee_address = $get_app_data->nomineeAddress;
			$nomineeData=array(
			"name"=>$nominee_name,
			"relation_with_investor"=>$nominee_relation,
			"percentage"=>$nominee_percentage,
			"date_of_birth"=>$nominee_dob,
			"address"=>$nominee_address,
			"guardian_name"=>$guardian_name,
			"investor_id"=>$investorId,
			"status"=>0
		  	);

			$current = 0;
			
			$percentage = $nominee_percentage;
			$totalPercentage=$this->preferences_model->checkNomineeTotalPercentage($investorId);
			 $totalPercentage->total_percentage;
			$total=0;
			if( $totalPercentage->total_percentage)
			{
				$total=($total+$totalPercentage->total_percentage)-$current;

				$balancePercentage=(100-$total);

				if($balancePercentage==0)
					$check = false;

				if($percentage > $balancePercentage)
				{
					$check = false;
				}
				else
				{
					$check = true;
				}
				
				
			}
			else
				$check = true;

			//$check = $this->checkNomTotalPercantage($investorId,$nomineePercentage,$currentPercentage);
			if(!$check )
			{
				echo '{"success":"false","msg":"Total percentage cannot be greater than 100."}';
				exit();
			}

			// update nominee details in db
			$result=$this->preferences_model->insertNomineeDetails($nomineeData);
			if($result)
			{
				$nomineeDetailsInsertedId=$result;
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appInsertNomineeDetails, Message : Successfully inserted new nominee details  *****');
				// fetch user details
				$userData=$this->preferences_model->getUserData($userId);
				if($userData)
				{
						$data["user_address"]=$userData->address;
						$data["user_pincode"]=$userData->pincode;
						$data["user_city"]=$userData->location_name;
						$data["user_state"]=$userData->state_name;
						$data["user_investorId"]=$investorId;
						$data["user_pan"]=$userData->pan;
				}
				// generate pdf file
				$data["userName"]=$userName;
				$data["nominee_name"]=trim($nominee_name);
				$data["nominee_relation"]=trim($nominee_relation);
				$data["nominee_percentage"]=trim($nominee_percentage);
				$data["guardian_name"]=trim($guardian_name);
				$data["nominee_dob"]=trim($nominee_dob_format);
				$data["nominee_address"]=trim($nominee_address);
				$mailBody = $this->load->view('nominee_change_pdf_view',$data,true);
				$this->load->library('mpdf60/mPDF');
				$pdfPath = '';
				try
				{
					$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
					$mpdf->useOnlyCoreFonts = true;    // false is default
					$mpdf->SetProtection(array('print'));
					$mpdf->SetTitle("Change Nominee");
					$mpdf->SetAuthor("Author");
					$mpdf->showWatermarkText = true;
					$mpdf->SetDisplayMode('fullpage');

					$html=$mailBody;
					$mpdf->WriteHTML($html);
					$fileName = $investorId .'_change_nominee_form_'.date('YmdHis', time()).'.pdf';
					$mpdf->Output(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName, 'F');
					$pdfPath = realpath(APPPATH.'../assets/uploads/changeNomineeForm/'.$fileName);

					$result2=$this->preferences_model->savePdfUrlData($fileName,$userId,$nomineeDetailsInsertedId);
					log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appInsertNomineeDetails, Message : Successfully updated new nominee details pdf url  *****');
					if($result2)
					{
						$emailResult=$this->sendNomineeChangeMail($nominee_name,$nominee_dob_format,$nominee_address,$nominee_relation,$pdfPath,$guardian_name,$nominee_percentage);
						if($emailResult)
						{
							echo '{"success":"true","message":"Nominee details updated successfully","pdf_name":"'.$fileName.'"}';
							$message=" Updated Nominee details and successfully sent new nominee details mail";
							log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appInsertNomineeDetails, Message : '.$message.'  *****');
		      				$data=array("investor_id"=>$investorId,"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
						else
						{
							echo '{"success":true,"message":"Nominee details updated successfully","pdf_name":"'.$fileName.'"}';
							$message=" Updated Nominee details but failed to send new nominee details mail";
							log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appInsertNomineeDetails, Message : '.$message.'  *****');
	      					$data=array("investor_id"=>$investorId,"log_msg"=>$message);
	            			addSystemLog($data); // helper function
						}
					}
					else
					{
						echo '{"success":"false","msg":"unable to store pdf data!"}';
						log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appInsertNomineeDetails, Message : Unable to save nominee details pdf url  *****');
					}
				}
				catch(Exception $e)
				{
					echo '{"success":"false","msg":"Error '.$e.'"}';
					log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appInsertNomineeDetails, Message : session expired while saving nominee details pdf url  *****');
				}
			}
			else
			{
				echo '{"success":"false","msg":"unable to insert nominee details"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appInsertNomineeDetails, Message : Failed to insert new nominee details  *****');
			}
		}
		else
		{
			echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : appInsertNomineeDetails, Message : Session expired while inserting new nominee details  *****');
		}
	}


/*
-----------------------------------------------------------------------------------------------------
|   USE : appDeleteNomineeDetails
|   DATE : 22/11/2016
|   AUTHOER : Prakash
|   COMMENT : appDeleteNomineeDetails is used to delete nominee
-----------------------------------------------------------------------------------------------------
*/
	function appDeleteNomineeDetails()
	{
		$get_app_data = json_decode(file_get_contents("php://input"));
			$userId= $get_app_data->userId;
			$investorId= $get_app_data->investorId;
			if($investorId&&$userId)
			{
			$nomineeId=$get_app_data->nomineeId;
			$data['status']=2;
			$result=$this->preferences_model->deleteNomineeDetails($investorId,$nomineeId,$data);
			if($result)
			{
				echo '{"success":"true","msg":"Successfully deleted nominee"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appDeleteNomineeDetails, Message : Successfully deleted the nominee details of nominee Id: '.$nomineeId.'  *****');
			}
			else
			{
				echo '{"success":"false","msg":"unable to delete nominee"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : appDeleteNomineeDetails, Message : Failed to delete the nominee details of nominee Id: '.$nomineeId.'  *****');
			}
		} 
		else
		{
			echo '{"success":"false","session":"out"}';
			log_message('info', '***** Controller : Preferences, Function : appDeleteNomineeDetails, Message : Session expired while deleting nominee details  *****');
		}
	}
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : updateCommunicationAddress
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : insertCommunicationAddress used to insert communication address
-----------------------------------------------------------------------------------------------------
*/
	function appInsertCommunicationAddress()
	{
			$get_app_data = json_decode(file_get_contents("php://input"));
			$userId= $get_app_data->userId;
			$investorId= $get_app_data->investorId;
			$new_address = $get_app_data->new_communication_address;
			$new_address2 = $get_app_data->new_communication_address2;
			$new_pincode =  $get_app_data->new_pincode;
			$new_city  =    $get_app_data->new_city;
			$new_city_name =  $get_app_data->new_city_name;
			$new_state_name =  $get_app_data->new_state_name;
			$new_state =  $get_app_data->new_state;
			$email =  $get_app_data->email;
			$country_code=76;
			
			$current_date = date('Y-m-d', time());

			$data=array(
				'address' => $new_address,
				'address_2' => $new_address2,
				'pincode'=>$new_pincode,
				'city_id'=>$new_city,
				"state_id"=>$new_state,
				"country_id"=>$country_code,
				"investor_id"=>$investorId,
				"status"=>0,
				"request_date"=>$current_date
			 );
			
			$result=$this->preferences_model->insertCommunicationAddress($data);
			
			if($result)
			{
				// print_r($result);die;
				$modifiedAddressInsertedId = $result;
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : insertCommunicationAddress, Message : Successfully inserted change address details  *****');

				$userData=$this->preferences_model->getUserData($userId);
				if($userData)
				{
					$data["user_address"]=$userData->address;
					$data["user_pincode"]=$userData->pincode;
					$data["user_city"]=$userData->location_name;
					$data["user_state"]=$userData->state_name;
					$data["user_investorId"]=$_SESSION["investor_id"];
					$data["user_pan"]=$userData->pan;
				}

				$data["userName"] = $investorId;
				$data["new_address"] = trim($new_address);
				$data["new_address2"] = trim($new_address2);
				$data["new_pincode"] = trim($new_pincode);
				$data["new_city_name"] = trim($new_city_name);
				$data["new_state_name"] = trim($new_state_name);

				$mailBody = $this->load->view('address_change_pdf_view',$data,true);
				$this->load->library('mpdf60/mPDF');
				$pdfPath = '';
				try
				{
					$mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
					$mpdf->useOnlyCoreFonts = true;    // false is default
					$mpdf->SetProtection(array('print'));
					$mpdf->SetTitle("Change Address");
					$mpdf->SetAuthor("Author");
					$mpdf->showWatermarkText = true;
					$mpdf->SetDisplayMode('fullpage');

					$html=$mailBody;
					$mpdf->WriteHTML($html);
					$fileName = $investorId .'_change_address_form_'.date('YmdHis', time()).'.pdf';
					$mpdf->Output(APPPATH.'../assets/uploads/changeAddressForm/'.$fileName, 'F');
					$pdfPath = realpath(APPPATH.'../assets/uploads/changeAddressForm/'.$fileName);

					$result2=$this->preferences_model->saveAddressPdfUrlData($fileName,$userId,$modifiedAddressInsertedId);
					log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : insertCommunicationAddress, Message : Successfully updated new address details pdf url  *****');

					if($result2)
					{
						// print_r("result2 true....");die;
						$emailAddressChangeResult=$this->appSendAddressChangeMail($email,$name,$new_address,$new_address2,$new_pincode,$new_city_name,$new_state_name,$pdfPath);
						if($emailAddressChangeResult)
						{
							echo '{"success":"true","msg":"Address details updated successfully","pdf_name":"'.$fileName.'"}';
							$message=" Updated address details and successfully sent new address details mail";
							log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : insertCommunicationAddress, Message : '.$message.'  *****');
							$data=array("investor_id"=>$investorId,"log_msg"=>$message);
							addSystemLog($data); // helper function
						}
						else
						{
							echo '{"success":"true","msg":"address details updated successfully","pdf_name":"'.$fileName.'"}';
							$message=" Updated address details but failed to send new address details mail";
							log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : insertCommunicationAddress, Message : '.$message.'  *****');
							$data=array("investor_id"=> $investorId ,"log_msg"=>$message);
							addSystemLog($data); // helper function
						}
					}
					else
					{
						echo '{"success":"false"}';
						log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : insertCommunicationAddress, Message : Unable to save address details pdf url  *****');
					}
				}
				catch(Exception $e)
				{
					echo '{"success":"false","error":"'.$e.'"}';
					log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : insertCommunicationAddress, Message : Session expired while saving address details pdf url  *****');
				}
			}
			else
			{
				echo '{"success":"false"}';
				$message="Failed to insert address details";
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : insertCommunicationAddress, Message : '.$message.'  *****');
				$data=array("investor_id"=>$investorId,"log_msg"=>$message);
				addSystemLog($data); // helper function
			}
		
	}
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : sendAddressChangeMail
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : sendAddressChangeMail
-----------------------------------------------------------------------------------------------------
*/
	function appSendAddressChangeMail($email,$name,$new_address,$new_address2,$new_pincode,$new_city_name,$new_state_name,$pdfPath)
	{
		$email=$email;
		$name=$name;
		// print_r($name);die;
		$today = date('d M Y h:i a', time());
		$data=array();

		$data["name"]=$name;
		$data["new_address"]=$new_address;
		$data["new_pincode"]=$new_pincode;
		$data["new_city_name"]=$new_city_name;
		$data["new_state_name"]=$new_state_name;

		$html=$this->load->view('address_change_email_view', $data,true);
		// $this->load->library("email");
		// $this->email->set_newline("\r\n");
		// $this->email->set_mailtype("html");
		// $this->email->to($email);
		// $this->email->cc("anvesh.pandey@investocafe.com,rahul.gehlot@investocafe.com,neha.joshi@investocafe.com");
		// //$this->email->bcc("amitmeena0206@gmail.com");
		// $this->email->from(" Investocafe Assistant<info@investocafe.com>", "Investocafe");
		// $this->email->subject("Change of Address: Action Required");
		// $this->email->message($html);
		// $this->email->attach($pdfPath);
		// $result=$this->email->send();
		//echo $this->email->print_debugger();
		$subject = "Change of Address: Action Required";
		$result = sendEmail($email,$subject,$html);
		return $result;
	}
	
	
	
/*
-----------------------------------------------------------------------------------------------------
|   USE : appSendOtpTOClient
|   DATE : 15/12/2016
|   AUTHOER : prakash
|   COMMENT : appSendOtpTOClient used to send otp
-----------------------------------------------------------------------------------------------------
*/
	
	// withdraw otp
	public function appSendOtpTOClient()
	{
		// echo '{"success":"true","otp":"1212"}';	
		// exit;
	    $get_app_data = json_decode(file_get_contents("php://input"));
	    $userId= $get_app_data->userId;
		if($userId){
		$this->load->helper('string');
		$otp = random_string('numeric', 4);
		$result=$this->preferences_model->Create_otp_for_edit_profile($userId,$otp);
		$dataContactName=$this->encrypt->decode($result->name);
		$dataContactPhone=$this->encrypt->decode($result->phone);
		$output = $this->sendPurchaseSms($dataContactName,$dataContactPhone,$otp);
		if($output){
			echo '{"success":"true","otp":"'.$otp.'"}';	
		}else{
			echo '{"success":"false","msg":"error while sending otp"}';
		}
		
		}else{
			echo '{"success":"false","msg":"user id error"}';
		}
	}
	
	
	/*
-----------------------------------------------------------------------------------------------------
|   USE : checkNomineePercentage
|   DATE : 08/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : checkNomineePercentage
-----------------------------------------------------------------------------------------------------
*/
	function appCheckNomineePercentage($investorId,$nomPer)
	{
		if($investorId)
		{
			$percentage=$this->input->post("percentage");
			$totalPercentage=$this->preferences_model->checkNomineeTotalPercentage($investorId);
			$total=0;
			if($totalPercentage)
			{
				$total=$total+$totalPercentage->total_percentage;
				$balancePercentage=(100-$total);
				if($balancePercentage < $nomPer)
				{
					if($balancePercentage == 0)
					{
						echo '{"success":"false","errorMsg":"You attoted 100% to your nominee"}';
						exit;
					}
					echo '{"success":"false","total":"'.$total.'","balance":"'.$balancePercentage.'","errorMsg":"Percent should be '.$balancePercentage.' "}';
					exit;
				}
				else
				{
					return true;
				}
				
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Preferences, Function : checkNomineePercentage, Message : Successfully fetched total and balance percentage  *****');
				exit;
			}
			
		}
		
	}
}

// public function checkNomTotalPercantage($investorId,$percentage,$current = 0)
// {
// 	echo $current;die;
// 				//$percentage=$this->input->post("percentage");
// 			$totalPercentage=$this->preferences_model->checkNomineeTotalPercentage($investorId);

// 			$total=0;
// 			if($totalPercentage)
// 			{
// 				$total=($total+$totalPercentage->total_percentage)-$current;
// 				$balancePercentage=(100-$total);
// 				if($balancePercentage==0)
// 					return false;

// 				if($percentage > $balancePercentage)
// 				{
// 					return false;
// 				}
// 				else
// 				{
// 					return true;
// 				}
				
				
// 			}
// 			else
// 				return true;
// }
