<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : Registration
|   MODEL USE : registration_model
|   DATE : 03/10/2016
|   AUTHOER : amit meena
|   COMMENT : this controller class is used to help registration to user of investocafe
|   FUNCTION USE : index ,showRegistrationView , _loadViewSignUp , checkEmailExists , addInvestor
|                  addTaxResidencies , updateInvestorInfo , addInvestorStatus , blogs , updateBankDetails, 
|                  createTermAndConditionLogMsg
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class Registration extends CI_Controller
{
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : __construct
|   DATE : 03/10/2016
|   COMMENT :  this function is used to load registration_model model in all function
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
	function __construct()
  	{
  	    // Call the Model constructor
  	    parent::__construct();
		$this->load->model('registration/registration_model','registration_model');
  	}
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : index
|   DATE : 03/10/2016
|   COMMENT :  this function is used to call a function of showRegistrationView to load registration function
|   CHECK STATUS : TRUE || true
------------------------------------------------------------------------------------------------------------
*/


  	function index()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                //$defaultPage=($_SESSION["defaultPage"]);
                if(isset($_SESSION["readyforUpdate"]) && !empty($_SESSION["readyforUpdate"]))
                {
                    $this->showRegistrationView();
                }else
                {
                    //redirect(base_url().$defaultPage);
					$this->showRegistrationView();
                }
            }
            else
            {
                $this->showRegistrationView();
            }
        }
        else
        {
            $this->showRegistrationView();
        }
    }
	
	public function postAppRequest(){
					echo 'postAppRequest';		
				//$mobile=$this->input->post("mobile");
				$to = "nikunj17287@gmail.com";
				$subject = "App request";
			//	$txt = "User with mobile number: $mobile is looking for app";
				$headers = "From: Investocafe Assistant<help@investocafe.com>" . "\r\n" .
				"CC: neha.joshi@investocafe.com";

				//mail($to,$subject,$txt,$headers);
	}
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : showRegistrationView
|   DATE : 03/10/2016
|   COMMENT :  this function is used to get date form database to load that data to registration view
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function showRegistrationView()
    {
        $data=array();

			$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {

        if(isset($_SESSION["investor_id"]) && !empty($_SESSION['investor_id']))
        {
           $invId=$_SESSION["investor_id"];
		   
           $status = $this->registration_model->checkFirstRegitration($invId);

		
           if($status)
           {
                $result=$this->registration_model->getInvestorDatailFirstStatpRegitration($invId);
                $data["row"]=$result;
           }
           else
           {

               $result=$this->registration_model->getInvestorDetailInRegistrationForm($invId);

               $data["row"]=$result;
               $data["allTaxResidencies"]=$this->registration_model->getAllTaxResidencies($invId);
           }
           
        }
		

        $data["investorTypeList"]=$this->registration_model->getAllInvestorType();
        $data["countryList"]=$this->registration_model->getCountyList();
        $data["allNationalities"]=$this->registration_model->getAllNationalities();
		$res = $this->db->query("select users.id from users join investor on investor.login_id = users.id where investor.investor_id = ".$invId." ");
		$dataSocial = $this->ion_auth->hash_password_db($res->row()->id,'investorcafe');
		$data['is_social_regitration'] = $dataSocial;
        $this->_loadViewSignUp('amit_theme/registration/registration_view',$data);
		
		}else{
			redirect(base_url());
		}
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : _loadViewSignUp
|   DATE : 03/10/2016
|   COMMENT :  this function is used to load view of header and footer
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function _loadViewSignUp($view, $data)
    {
        $data["page1"]=true;
        $data["page2"]=false;
        $data["page3"]=false;
        $this->load->view('amit_theme/common/header',$data);
        $data['jsFile'] ='registration/registration.js';
        $this->load->view($view,$data);
        $this->load->view('amit_theme/common/footer',$data );
    }

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : checkEmailExists
|   DATE : 03/10/2016
|   COMMENT :  this function check email already exit or not in database in new user registration
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    public function checkEmailExists()
    {
        $email=$this->input->post("email");
        $check_email=$this->registration_model->checkUserExistingInfo($email);
        if($check_email)
        {
            echo '{"success":true,"response":"already registered"}';
			log_message('info', '***** Controller : registration, Function : checkEmailExists, Message : Email id '.$email.' already registered *****');
        }
        else
        {
            echo '{"success":false,"response":"new registration"}';
			log_message('info', '***** Controller : registration, Function : checkEmailExists, Message : New email id '.$email.' *****');
        }
    }

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : addInvestor
|   DATE : 03/10/2016
|   COMMENT :  this function is used to new investor registration
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------


    function addInvestor($app = 0)
    {
        if($app == 1)
        {
            echo "mobile app";
        }
        if($app == 2)
        {

        }
        exit;
        
        $investor_type = $this->input->post("investor_type");
        $nationality = $this->input->post("nationality");
        $countryOfResidence = $this->input->post("countryOfResidence");

        if($investor_type=="1")
        {
            $countryOfResidence=76;
        }
        else
        {
            $countryOfResidence=$this->input->post("countryOfResidence");
        }

        if($investor_type==1 || $investor_type==4)
        {
            $status="Resident Individual";
        }else
        {
            $status="Non Resident";
        }

        $allTaxResidencies = $this->input->post("allTaxResidencies");
        $allTaxResidencies = rtrim($allTaxResidencies,"|");

        // encrypted fields
        $name=$this->encrypt->encode(handleString($this->input->post("name")));
        $email=$this->input->post("email");
        $phone=$this->encrypt->encode($this->input->post("phone"));
        $phoneOverseas=$this->encrypt->encode($this->input->post("phoneOverseas"));

        $dob=$this->input->post("dob");
        $placeOfBirth = $this->input->post("placeOfBirth");
        $countryOfBirth = $this->input->post("countryOfBirth");

        $gender=$this->input->post("radio");
        $password=$this->input->post("password");
        $group = array('1'); // Sets user to admin.
        $tokenImagePath = $this->input->post("tokenImagePath"); // enhanced security token image path
        $tokenImageName = $this->input->post("tokenImageName"); // enhanced securuty token image name given by user

        $armedForces=$this->input->post("armedForces");

        $additional_data = array(
            'first_name' => $name,
            'phone' => $phone,
            "email"=>$email,
            );

        $id = $this->ion_auth->register($name, $password, $email, $additional_data,$group);

        if($id)
        {
            $_SESSION["userId"]=$id;
            $data=array(
                        "investor_type_id"=>$investor_type,
                        "nationality_id"=>$nationality,
                        "status"=>$status,
                        "date_of_birth"=>$dob,
                        "place_of_birth"=>$placeOfBirth,
                        "country_of_birth_id"=>$countryOfBirth,
                        "overseas_no"=>$phoneOverseas,
                        "gender"=>$gender,
                        "login_id"=>$id,
                        "token_image_path"=>$tokenImagePath,
                        "token_image_name"=>$tokenImageName,
                        "country"=>$countryOfResidence,
                        "armed_forces"=>$armedForces
                        );

            $result = $this->registration_model->addInvestor($data);

            if($result)
            {
                $_SESSION['investor_id']=$result;
                $investorId=$_SESSION['investor_id'];
                $this->addInvestorStatus($investorId);
                $ip_address=$this->input->ip_address();

                if($allTaxResidencies!="")
                {
                    $this->addTaxResidencies($allTaxResidencies,$investorId);
                }
				
				$email = $email;
				$name = $this->encrypt->decode($name);
				$result = sendConfirmationEmail($email,$name);

                echo '{"success":true,"response":"added"}';
				log_message('info', '***** Controller : registration, Function : addInvestor, Message : Successfully created investor login details - investorId='.$result.' *****');
                log_message('info', '***** Investor Id = '.$investorId.' Controller : registration, Function : addInvestor, Message :Accepted terms and condtions, ip address = '.$ip_address.'  *****');
            }
            else
            {
                echo '{"success":false,"response":"error"}';
				log_message('info', '***** Controller : registration, Function : addInvestor, Message : Failed to create investor login details - investorId='.$result.' *****');
            }
			//Add Verification Mail
		}
        else
        {
            echo '{"success":false,"response":"already exists "}';
			log_message('info', '***** Controller : registration, Function : addInvestor, Message : Email already exists *****');
        }
    }

------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : addTaxResidencies
|   DATE : 03/10/2016
|   COMMENT :  this function add investor addTaxResidencies
|   CHECK STATUS :
------------------------------------------------------------------------------------------------------------
*/
    function addTaxResidencies($allTaxResidencies,$investorId)
    {
      $result=$this->registration_model->addTaxResidencies($allTaxResidencies,$investorId);

      if($result)
      {
			log_message('info', '***** Controller : registration, Function : addTaxResidencies, Message : Successfully added tax residence of investor *****');
      }
      else
      {
            log_message('info', '***** Controller : registration, Function : addTaxResidencies, Message : Failed to add tax residence of investor *****');
      }
    }

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : addTaxResidencies
|   DATE : 03/10/2016
|   COMMENT :  this function update investor info if he/she want to chnage there info
|   CHECK STATUS :
------------------------------------------------------------------------------------------------------------
*/

    /** **/
    function updateInvestorInfo()
    {
		$password2 = $this->input->post("password");
		$userId=$_SESSION["userId"];
		 if($password2 != "")
		{
			$data22 = array('password' => $password2);
			$result222=$this->ion_auth->update($userId, $data22);
		}
        $investor_type=$this->input->post("investor_type");
        $nationality=$this->input->post("nationality");
		$motherName=$this->input->post("motherName");
        $allTaxResidencies=$this->input->post("allTaxResidencies");
        $countryOfResidence=$this->input->post("countryOfResidence");

        $countryOfResidence=$this->input->post("countryOfResidence");
        if($investor_type=="1")
        {
            $countryOfResidence=76;
        }
        else
        {
            //$nationality = "Other";
        }

        if($investor_type==1 || $investor_type==4)
        {
            $status="Resident Individual";
        }
        else
        {
            $status="Non Resident";
        }

        $armedForces=$this->input->post("armedForces");
        $allTaxResidencies=rtrim($allTaxResidencies,"|");
        $name=$this->encrypt->encode(handleString($this->input->post("name")));
        $phone=$this->encrypt->encode($this->input->post("phone"));
        $phoneOverseas=$this->encrypt->encode($this->input->post("phoneOverseas"));
        $dob=$this->input->post("dob");
        $placeOfBirth = $this->input->post("placeOfBirth");
        $countryOfBirth = $this->input->post("countryOfBirth");
        $gender=$this->input->post("gender");
		$email = $this->input->post("email");
		
        
        $data = array(
                        "first_name"=>$name,
                        "phone"=>$phone,
						"mother_name"=>$motherName,
						"email" => $email
                     );
					 
        $result=$this->ion_auth->update($userId, $data);
        $investorId=$_SESSION['investor_id'];
        $data=array(
                    "investor_type_id"=>$investor_type,
                    "nationality_id"=>$nationality,
                    "status"=>$status,
                    "date_of_birth"=>$dob,
                    "place_of_birth"=>$placeOfBirth,
                    "country_of_birth_id"=>$countryOfBirth,
                    "overseas_no"=>$phoneOverseas,
                    "gender"=>$gender,
                    "country"=>$countryOfResidence,
                    "armed_forces"=>$armedForces,
                    );

        if($allTaxResidencies!="")
        {
            $this->addTaxResidencies($allTaxResidencies,$investorId);
        }

        $result=$this->registration_model->updateInvestorInfo($investorId,$data);
        if($result)
        {
            $this->updateInvestorstatus($investorId);
            echo '{"success":true,"response":"updated"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : updateInvestorInfo, Message : Successfully updated investor details *****');
        }
		else
		{
			echo '{"success":false}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : updateInvestorInfo, Message : Failed to update investor details *****');
		}
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : addInvestorStatus
|   DATE : 03/10/2016
|   COMMENT :  this function is used to update investor statuse when he/she complate there registration
|   CHECK STATUS :
------------------------------------------------------------------------------------------------------------
*/

    /** add investor status **/
    function addInvestorStatus($investorId)
    {
        $today_date= date("Y-m-d H:i:s");
        $data=array(
                    "investor_id"=>$investorId,
                    "is_investor_registered_date"=>$today_date,
                    "is_investor_registered"=>1,
                   );
        $result=$this->registration_model->updateInvestorStatus($data);

		log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : addInvestorStatus, Message : Successfully added investor status *****');
    }

    function updateInvestorstatus($investorId)
    {
        $today_date= date("Y-m-d H:i:s");
        $data=array(
                    "is_investor_registered_date"=>$today_date,
                    "is_investor_registered"=>1,
                   );
       $result=$this->registration_model->updateInvestorStatusSecontRegitration($investorId,$data); 
    }

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : blogs
|   DATE : 03/10/2016
|   COMMENT : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function blogs()
    {
        $this->load->library('Tumblr');
        $consumerKey="";
        $consumerSecret="";
        $client = new Tumblr\API\Client($consumerKey, $consumerSecret);
        $client->setToken($token, $tokenSecret);

        // Make the request
        foreach ($client->getUserInfo()->user->blogs as $blog)
        {
            echo $blog->name . "\n";
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : updateBankDetails
|   DATE : 03/10/2016
|   COMMENT :  when use wants to chnage there bank detail
|   CHECK STATUS :
------------------------------------------------------------------------------------------------------------
*/
    function updateBankDetails()
    {
        if(isset($_SESSION["readyforUpdate"]) && !empty($_SESSION["readyforUpdate"]))
        {
            $investorId=$_SESSION["investor_id"];
            $bankData=array(
                        "account_number"=>"",
                        "bank_master_id"=>0,
                        "branch_name"=>"",
                        "branch_city"=>"",
                        "branch_state"=>"",
                        "account_type_id"=>"",
                        "ifsc_code"=>"",
                        );
            $resultAddBankDetails=$this->registration_model->updateInvestorBankDetails($investorId,$bankData);
            $resultAddBankDetails=$this->registration_model->deleteInvestorTaxResidency($investorId);
            $result=$this->registration_model->deleteInvestorOverseasDetails($investorId);
            if($resultAddBankDetails)
            {
                echo '{"success":true}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : updateBankDetails, Message : Successfully updated bank details *****');
            }else{
                echo '{"success":false}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : registration, Function : updateBankDetails, Message : Failed to update bank details *****');
            }
        }
        else{
                echo '{"success":false}';
				log_message('info', '***** Controller : registration, Function : updateBankDetails, Message : Ready for update value not available in session *****');
            }
    }

/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : createTermAndConditionLogMsg
|   DATE : 03/10/2016
|   COMMENT :  this function is to add t&c to the user log msg 
|   CHECK STATUS :
------------------------------------------------------------------------------------------------------------
*/
    function createTermAndConditionLogMsg()
    {   
        $ip_address=$this->input->ip_address();
        $name = $this->input->post("name");
        $email = $this->input->post("email");
        log_message('info', '***** Controller : registration, Function : createTermAndConditionLogMsg, Message : Investor name = "'.$name.'", Email Id = "'.$email.'" accepted terms and conditons, ip address = '.$ip_address.' *****');
    }


	
/*

------------------------------------------------------------------------------------------------------------

|   FUNTION NAME : appShowRegistrationView

|   DATE : 03/10/2016

|   COMMENT :  this function is to add t&c to the user log msg 

|   CHECK STATUS :

------------------------------------------------------------------------------------------------------------

*/



    function appShowRegistrationView()
    {
		$data = json_decode(file_get_contents("php://input"));
		$investorId = $data->investorId;
        $data=array();
        if(isset($investorId))
        {
           $invId=$investorId;
           $result=$this->registration_model->getInvestorDetailInRegistrationForm($invId);
           $data["row"]=$result;
           $data["allTaxResidencies"]=$this->registration_model->getAllTaxResidencies($invId);
        }
        $data["investorTypeList"]=$this->registration_model->getAllInvestorType();
        $data["countryList"]=$this->registration_model->getCountyList();
        $data["allNationalities"]=$this->registration_model->getAllNationalities();
		if(isset($investorId))
        {
			$res = $this->registration_model->getUserDetailForRegitration($investorId);
			$data['userdata']['name'] = $this->encrypt->decode($res->username);
			$data['userdata']['phone'] = $this->encrypt->decode($res->phone);
			$data['userdata']['email'] = $res->email;
		}
        if($data)
        {
             $out = json_encode($data);
             echo $out;
        }
        else
        {
            $data  = ['error' => 404];
            $out = json_encode($data);
            echo $out;

        }

       
    }



    



    public function download()

    {

        if (isset($_GET['file'])) {

    $ifile_name=$_GET['file'];

        //$file = $_GET['file'];// Always sanitize your submitted data!!!!!!

        //$file = filter_input(INPUT_GET, 'file', FILTER_SANITIZE_ENCODED);//works also

        $file = filter_input(INPUT_GET, 'file', FILTER_SANITIZE_SPECIAL_CHARS);



        $append_path='assets/uploads/investor_form_pdf/';

        $file=$append_path.$file;



        $fileType = pathinfo($file);

        $returnType ;

        if (file_exists($file) && is_readable($file)) { 

         

        switch ($fileType['extension']) {

        case "pdf" :

        $returnType = "header('Content-type: application/pdf')";

        break;

        case "txt":

        $returnType ="header('Content-type: text/plain')";

        break;

        case "html":

        $returnType ="header('Content-Type: text/html; charset=utf-8')";

        break;

        case "htm":

        $returnType ="header('Content-Type: text/html; charset=utf-8')";

        break;

        case "exe":

        $returnType ="header('Content-Type: application/octet-stream')";

        break;  

        case "zip":

        $returnType = "header('Content-Type: application/zip') ";   

        break;

        case "jpg":

        $returnType ="header('Content-Type: image/jpeg')";

        break;

        case "jpeg":

        $returnType ="header('Content-Type: image/jpeg')";

        break;

        case "gif":

        $returnType ="header('Content-Type: image/gif')";

        break;

        case "png":

        $returnType ="header('Content-Type: image/png')";

        break;  

        case "ppt":

        $returnType ="header('Content-Type: application/vnd.ms-powerpoint')";

        break;

        case "xls":

        $returnType ="header('Content-Type: application/vnd.ms-excel')";

        break;

        case "xml":

        $returnType = "header('Content-Type: application/vnd.ms-xml') ";        

        break;

        case "mpeg":

        $returnType ="header('Content-Type: audio/mpeg')";

        break;

        case "swf":

        $returnType ="header('Content-Type: text/html; application/x-shockwave-flash')";

        break;      

        }

        echo $returnType ; 

        header('Content-Description: File Transfer');

        echo $returnType ; 

        header("Content-Type: application/force-download");// some browsers need this

        header("Content-Disposition: attachment; filename=\"$ifile_name\"");

        header('Expires: 0');

        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');

        header('Pragma: public');

        header('Content-Length: ' . filesize($file));

        ob_clean();

        flush();

        readfile($file);

        exit;

        }else {

        header("HTTP/1.0 404 Not Found");

        echo "<h3>Error 404: File Not Found : <br /><em>$file</em></h3>";



        }

        }else {



        print '<h1 style="text-align:center">You you shouldn\'t be here ......</h1><br>'; 

        }

 

    }



	/*

------------------------------------------------------------------------------------------------------------

|   FUNTION NAME : AppUpdateInvestorInfo

|   DATE : 18/10/2016

|   COMMENT :  This Function Is used to update investor detail from mobile application

|   CHECK STATUS :

------------------------------------------------------------------------------------------------------------

*/

    function appUpdateInvestorInfo()
    {
        $data = json_decode(file_get_contents("php://input"));
        $investor_type= $data->investor_type;
        $nationality= $data->nationality;
        $allTaxResidencies= $data->allTaxResidencies;
        $countryOfResidence= $data->countryOfResidence;
		$userId = $data->user_id;
        if($investor_type=="1")
        {
            $countryOfResidence=76;
        }
        else
        {
            //$nationality = "Other";
        }
        if($investor_type==1 || $investor_type==4)
        {
            $status="Resident Individual";
        }
        else
        {
            $status="Non Resident";
        }

        $armedForces=$data->armedForces;
        $allTaxResidencies=rtrim($allTaxResidencies,"|");
        $phoneOverseas=$this->encrypt->encode($data->phoneOverseas);
        $dob=$data->dob;
        $placeOfBirth = $data->placeOfBirth;
        $countryOfBirth = $data->countryOfBirth;
        $gender=$data->gender;
        $investorId=$data->investorId;
		$motherName = $data->mother_name;
		$data2 = array(
						"mother_name"=>$motherName,
                     );
					 
        $result=$this->ion_auth->update($userId, $data2);
        $data=array(
                    "investor_type_id"=>$investor_type,
                    "nationality_id"=>$nationality,
                    "status"=>$status,
                    "date_of_birth"=>$dob,
                    "place_of_birth"=>$placeOfBirth,
                    "country_of_birth_id"=>$countryOfBirth,
                    "overseas_no"=>$phoneOverseas,
                    "gender"=>$gender,
                    "country"=>$countryOfResidence,
                    "armed_forces"=>$armedForces,
                    );
        if($allTaxResidencies!="")
        {
            $this->addTaxResidencies($allTaxResidencies,$investorId);
        }

        $result=$this->registration_model->updateInvestorInfo($investorId,$data);
        if($result)
        {
            $this->updateInvestorstatus($investorId);
            echo '{"success":true,"response":"updated"}';
        }
        else
        {
            echo '{"success":false}';
        }

    }

	
	

}
