<?php

class RelianceAPITest extends CI_Controller{
	
	function __construct()
    {
		parent::__construct();
		$this->load->config('config_karvy');
		$this->load->model('purchase_cron/api_model');
		$this->load->helper('karvy_helper');
    }
	
/*
-----------------------------------------------------------------------------------
|	API No. 2
|	Comment : This API is check availble redeem amount 
-----------------------------------------------------------------------------------
*/
	public function relianceAPITwo()
	{
		 $investor_id = $_SESSION['investor_id'];
		 log_message("info", "***** Controller : RelianceAPITest,  Function : relianceAPITwo, Messege : call api two for investor ".$investor_id." *****");
		if($investor_id)
		{
			$investorBankDetails = $this->api_model->getInvestorBankDetails($investor_id);
			$acno = $this->encrypt->decode($investorBankDetails->account_number);
			$fol = $this->db->query("select folio_number from purchased_units where investor_id = $investor_id and fund_id = 9227 and folio_number <> ''");
			if($fol->num_rows() > 0)
			{
				$arncode = $this->config->item('arn_code');
				$branch  = $this->config->item('user_code');
				$apikey  = "32557515-5995-4b35-f3f3-f9518482e527";
				$sendData = "";
				$sendData .="acno=".$fol->row()->folio_number."&";
				$sendData .="scheme=LP&";
				$sendData .="plan=IG&";
				$sendData .="arncode=".$arncode."&";
				$sendData .="branch=".$branch."&";
				$sendData .="proxybranch=&";
				$sendData .="deviceid=PARTNERAPI&";
				$sendData .="appVersion=1.0.1&";
				$sendData .="appName=INVESTOCAFE&";
				$sendData .="apikey=".$apikey."";
				$url = $this->config->item('redemption_scheme_details');
				$responce = $this->sendInfo($sendData,$url);
				echo("<pre>");
				print_r(json_decode($responce));
			}
		} 
		
	}
/*
-----------------------------------------------------------------------------------
|	API No. 4
|	Comment : This API is use to save request for redeem
-----------------------------------------------------------------------------------
*/
	public function relianceAPIFour()
	{
		$bankName = $this->input->post('bankName');
		$investor_id = $_SESSION['investor_id'];
		log_message("info", "***** Controller : RelianceAPITest,  Function : relianceAPIFour, Messege : call api Four for investor ".$investor_id." *****");
		$investorBankDetails = $this->api_model->getInvestorBankDetails($investor_id);
		$fol = $this->db->query("select folio_number from purchased_units where investor_id = $investor_id and fund_id = 9227 and folio_number <> ''");
		$acno = $fol->row()->folio_number;
		$arncode = $this->config->item('arn_code');
		$bank_name = $bankName;
		$branch  = $this->config->item('user_code');
		$apikey  = "32557515-5995-4b35-f3f3-f9518482e527";
		$trDate = date("m/d/Y");
		if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
			$ip = $_SERVER['HTTP_CLIENT_IP'];
		} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
		};

		$sendData = "";
		$sendData .="fund=RMF&";
		$sendData .="acno=".$acno."&";//Folio Number of the investor (Unique Account Number)
		$sendData .="arncode=".$arncode."&";//ARN Code of the calling Partner
		$sendData .="scheme=LP&";
		$sendData .="plan=IG&";
		$sendData .="options=G&";
		$sendData .="RedFlag=P&";
		$sendData .="UnitamtFlag=A&";
		$sendData .="UnitAmtValue=100&";
		$sendData .="userid=&";//Send Blank 
		$sendData .="Tpin=A&";
		$sendData .="Mstatus=&";//If redemption amount is Instant then send "Insta" else blank
		$sendData .="Fname=&";
		$sendData .="Mname=&";
		$sendData .="Lname=&";
		$sendData .="Cuttime=&";
		$sendData .="pangno=&";
		$sendData .="bank=".$bank_name ."&";//Name of the Bank as received in Service #2 RedInvbankDetails_V1 in API Details Page.
		$sendData .="ip=".$ip."&";
		$sendData .="oldihno=0&";//Send Text as "0" (Zero)
		$sendData .="trdate=".$trDate."&";//Date of transaction: Send current date in MM/DD/YYYY format
		$sendData .="entdate=".$trDate."&";//Date of Entry of Transaction: Send current date in MM/DD/YYYY format
		$sendData .="branch=".$branch ."&";//Branch Name as provided by Reliance to the Partner
		$sendData .="proxybranch=&";
		$sendData .="deviceid=PARTNERAPI&";
		$sendData .="appVersion=1.0.1&";
		$sendData .="appName=INVESTOCAFE&";
		$sendData .="apikey=".$apikey."";//Encoded key provided by Reliance to Partner
		$url = $this->config->item('redempti_on_save');
		$responce = $this->sendInfo($sendData,$url);
		//echo "<pre>";
		print_r($responce);
		//echo '{"success":true}';
	}
	
/*
-----------------------------------------------------------------------------------
|	API No. 5
|	Comment : This API is use to check status of redeem
-----------------------------------------------------------------------------------
*/	
	public function relianceAPIFive($refno)
	{
		log_message("info", "***** Controller : RelianceAPITest,  Function : relianceAPIFive, Messege : call api Five for Refrense no ".$refno." *****");
		$apikey  = "32557515-5995-4b35-f3f3-f9518482e527";
		$sendData = "";
		$sendData .= "fund=RMF&";
		$sendData .= "refno=".$refno."&";
		$sendData .= "deviceid=PARTNERAPI&";
		$sendData .= "appVersion=1.0.1&";
		$sendData .= "appName=INVESTOCAFE&";
		$sendData .= "apikey=".$apikey."";
		$url = $this->config->item('get_ref_no_status');
		$responce = $this->sendInfo($sendData,$url);
		echo "<pre>";
		print_r($responce);
	}
	
    function sendInfo($data,$url)
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_PORT , 443);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		$returnData = curl_exec($ch);
		curl_close($ch);
		return $returnData;
	}
	
/* 	{
		
		$investorDetails = $this->api_model->getInvestorDetails(55);
		$investorBankDetails = $this->api_model->getInvestorBankDetails(55);
		$email = $investorDetails->email;
		$phone = $this->encrypt->decode($$investorDetails->phone);
		$pan = $this->encrypt->decode($investorDetails->pan);
		$arncode = $this->config->item('arn_code');
		$dob = dateFormateForRelianceCard($investorDetails->date_of_birth);
		$IFSC = $investorBankDetails->ifsc_code;
		$ACTYPE = $investorBankDetails->account_type;
		$ACNUM = $this->encrypt->decode($investorBankDetails->account_number);
		$apikey = "XXXXXXXXXX";
		$sendData = "?";
		$sendData .= "arncode=".$arncode."&";
		$sendData .= "pan=".$pan."&";
		$sendData .= "scheme=LP&";
		$sendData .= "plan=IG&";
		$sendData .= "option=G&";
		$sendData .= "email=".$email."&";
		$sendData .= "mobile=".$phone."&";
		$sendData .= "dob=".$dob."&";
		$sendData .= "RI=Y&";
		$sendData .= "PEP=N&";
		$sendData .= "RPEP=N&";
		$sendData .= "PTI=Y&";
		$sendData .= "BII=Y&";
		$sendData .= "TAX=INDIVIDUAL&";
		$sendData .= "OCCUP=3&";
		$sendData .= "INCOME=1-5L&";
		$sendData .= "IFSC=".$IFSC."&";
		$sendData .= "ACTYPE=".$ACTYPE."&";
		$sendData .= "ACNUM=".$ACNUM."&";
		$sendData .= "deviceid=PARTNERAPI&";
		$sendData .= "appVersion=1.0.1&";
		$sendData .= "appName=INVESTOCAFE&";
		$sendData .= "apikey=".$apikey."";
		$this->sendInfo($sendData);
	} */
	
	public function appRelianceAPITwo()
	{
		$data = json_decode(file_get_contents('php://input'));
		$investor_id = $data->investor_id;
		if($investor_id)
		{
			$investorBankDetails = $this->api_model->getInvestorBankDetails($investor_id);
			$acno = $this->encrypt->decode($investorBankDetails->account_number);
			$fol = $this->db->query("select folio_number from purchased_units where investor_id = $investor_id and fund_id = 9227 and folio_number <> ''");
			if($fol->num_rows() > 0)
			{
				$arncode = $this->config->item('arn_code');
				$branch  = $this->config->item('user_code');
				$apikey  = "32557515-5995-4b35-f3f3-f9518482e527";
				$sendData = "";
				$sendData .="acno=".$fol->row()->folio_number."&";
				$sendData .="scheme=LP&";
				$sendData .="plan=IG&";
				$sendData .="arncode=".$arncode."&";
				$sendData .="branch=".$branch."&";
				$sendData .="proxybranch=&";
				$sendData .="deviceid=PARTNERAPI&";
				$sendData .="appVersion=1.0.1&";
				$sendData .="appName=INVESTOCAFE&";
				$sendData .="apikey=".$apikey."";
				$url = $this->config->item('redemption_scheme_details');
				$responce = $this->sendInfo($sendData,$url);
				print_r($responce);
			}
		} 
		
	}
	
	
	public function appRelianceAPIFour()
	{
		$data = json_decode(file_get_contents('php://input'));
		$bankName = $data->bankName;
		$investor_id = $data->investor_id;
		$amount = $data->amount;
		$investorBankDetails = $this->api_model->getInvestorBankDetails($investor_id);
		$fol = $this->db->query("select folio_number from purchased_units where investor_id = $investor_id and fund_id = 9227 and folio_number <> ''");
		$acno = $fol->row()->folio_number;
		$arncode = $this->config->item('arn_code');
		$bank_name = $bankName;
		$branch  = $this->config->item('user_code');
		$apikey  = "32557515-5995-4b35-f3f3-f9518482e527";
		$trDate = date("m/d/Y");
		if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
			$ip = $_SERVER['HTTP_CLIENT_IP'];
		} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
		};

		$sendData = "";
		$sendData .="fund=RMF&";
		$sendData .="acno=".$acno."&";//Folio Number of the investor (Unique Account Number)
		$sendData .="arncode=".$arncode."&";//ARN Code of the calling Partner
		$sendData .="scheme=LP&";
		$sendData .="plan=IG&";
		$sendData .="options=G&";
		$sendData .="RedFlag=P&";
		$sendData .="UnitamtFlag=A&";
		$sendData .="UnitAmtValue=".$amount."&";
		$sendData .="userid=&";//Send Blank 
		$sendData .="Tpin=A&";
		$sendData .="Mstatus=&";//If redemption amount is Instant then send "Insta" else blank
		$sendData .="Fname=&";
		$sendData .="Mname=&";
		$sendData .="Lname=&";
		$sendData .="Cuttime=&";
		$sendData .="pangno=&";
		$sendData .="bank=".$bank_name ."&";//Name of the Bank as received in Service #2 RedInvbankDetails_V1 in API Details Page.
		$sendData .="ip=".$ip."&";
		$sendData .="oldihno=0&";//Send Text as "0" (Zero)
		$sendData .="trdate=".$trDate."&";//Date of transaction: Send current date in MM/DD/YYYY format
		$sendData .="entdate=".$trDate."&";//Date of Entry of Transaction: Send current date in MM/DD/YYYY format
		$sendData .="branch=".$branch ."&";//Branch Name as provided by Reliance to the Partner
		$sendData .="proxybranch=&";
		$sendData .="deviceid=PARTNERAPI&";
		$sendData .="appVersion=1.0.1&";
		$sendData .="appName=INVESTOCAFE&";
		$sendData .="apikey=".$apikey."";//Encoded key provided by Reliance to Partner
		$url = $this->config->item('redempti_on_save');
		$responce = $this->sendInfo($sendData,$url);
		//echo "<pre>";
		print_r($responce);
		//echo '{"success":true}';
	}
}