<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class SendGreetings extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->model('send_greetings_model');
    }

    public function index()
    {
        $this->sendBirthdayGreetings();
        $this->sendAnniversaryGreetings();
    }

    public function sendBirthdayGreetings()
    {
        //get all the the rows from Investor table which have birthday today
        $todaysDate=date("m-d");
        $result=$this->send_greetings_model->getInvestorDetail($todaysDate);
        if($result)
        {
            $str = '';
            foreach($result as $row)
            {
                if($row->email!='')
                {
                  $email=$row->email;
                  $name=$this->encrypt->decode($row->username);
                  $phone=$this->encrypt->decode($row->phone);
                  $str .= $name." ".$phone." - Birthday<br />";
                  $sent=$this->sendBirthdayEmail($email,$name);
                  if($row->total_purchase>=1000000)
                  {
                    $action=$name." has birthday today wish to him personaly. phone and email are --".$phone."--".$email;

                    $data=array(
                        'date'=>date("Y-m-d h:i:s"),
                        "action"=>$action);
                      $res=$this->common_model->addDailyAgenda($data);
                      if($res){
                        log_message('info', '***** Controller : SendGreetings, Function : sendBirthdayGreetings, Message : Successfully added to daily agenda *****');
                      }
                      else {
                        log_message('info', '***** Controller : SendGreetings, Function : sendBirthdayGreetings, Message : Failed to add to daily agenda *****');
                      }
                   }

                   $sentSms=$this->sendBirthdaySms($name,$phone);
                   if($sentSms)
                   {
                      log_message('info', '***** Controller : SendGreetings, Function : sendBirthdayGreetings, Message : Sent birthday sms on mobile *****');
                   }
                }
            }
        }
        else
        {
            log_message('info', '***** Controller : SendGreetings, Function : sendBirthdayGreetings, Message : No Data found in todays birthday *****');
        }
        // add cron info
        $cronUrl=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
        $cronDate=date("Y-m-d h:i:s");
        $cronDesc="Cron succefully executed and sending birthday email and sms";

        $data=array("cron_url"=>$cronUrl,"cron_date"=>$cronDate,"cron_desc"=>$cronDesc);
        addCronLog($data);
        $this->sendToAdminEmail($str,"Todays Birthday");
    }

    // stop temp
    //------ Send Birthday SMS on Mobile -------//
    function sendBirthdaySms($userName,$userPhone)
    {
      if($userPhone!="" && $userName!="")
      {
          $ch = curl_init();

          //Like us on bit.ly/eshpind----------------
          $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0AA%20Birthday%20is%20a%20million%20moments%2C%20%0Aeach%20holding%20a%20promise%20of%20fulfillment%20of%20your%20dreams%2C%20%0Aand%20accomplishment%20of%20some%20special%20plans.%20%0AWish%20you%20a%20very%20happy%20birthday.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4&country=91&DLT_TE_ID=1207160699324789410";
          $url=str_replace(" ", "%20", $url1);
          //echo $url;
          curl_setopt($ch, CURLOPT_URL, $url);
          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

          //return the transfer as a string
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

          //$output contains the output string
          $output = curl_exec($ch);

          $dbData = array ('phone'=>$userPhone,'response'=>$output);
          $this->db->insert('msg_log',$dbData);
          //close curl resource to free up system resources
          curl_close($ch);

          if ( $output === FALSE)
          {
              $output=curl_error($ch); //echoes last session error
              return false;
          }
          return $output;
      }
      else
      {
        echo "Invalid user name or phone number";
        log_message('info', '***** Controller : SendGreetings, Function : sendBirthdaySms, Message : Invalid user name or phone number for birthday sending sms *****');
      }
    }

    public function sendAnniversaryGreetings()
    {
        //get all the the rows from Investor table which have anniversary today
        $todaysDate=date("m-d");
        $result=$this->send_greetings_model->getInvestorDoaDetail($todaysDate);
        if($result)
        {
            $str = '';
            $investorDetails = '';
            $i = 0;
            foreach($result as $row)
            {
                if($row->email!='')
                {
                   $i++;
                   $email=$row->email;
                   $name=$this->encrypt->decode($row->username);
				           $phone=$this->encrypt->decode($row->phone);
                   $this->sendAnniversaryEmail($email,$name);
                   $str .= $name." ".$phone." - Aniversary<br />";
                  if($row->total_purchase>100)
                  {
                    $action=$name." has anniversary today wish to personaly. phone and email are --".$phone."--".$email;
                      $data=array(
                        'date'=>date("Y-m-d h:i:s"),
                        "action"=>$action);
                      $res=$this->common_model->addDailyAgenda($data);
                      if($res){
                        log_message('info', '***** Controller : SendGreetings, Function : sendAnniversaryGreetings, Message : Successfully added to daily agenda *****');
                      }
                      else {
                        log_message('info', '***** Controller : SendGreetings, Function : sendAnniversaryGreetings, Message : Failed to add to daily agenda *****');
                      }
                   }
				   
				          $this->sendAnniversarySms($name,$phone);
                }
            }
        }
        else
        {
            log_message('info', '***** Controller : SendGreetings, Function : sendAnniversaryGreetings, Message : No Data found in todays anniversary *****');
        }

        $cronUrl=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
        $cronDate=date("Y-m-d h:i:s");
        $cronDesc="Cron succefully executed and sending anniversary email and sms";

        $data=array("cron_url"=>$cronUrl,"cron_date"=>$cronDate,"cron_desc"=>$cronDesc);
        addCronLog($data);

        // echo $str;
        $this->sendToAdminEmail($str,"Todays Anniversary");
    }

    
    // stop temp
    //------ Send Anniversary SMS on Mobile -------//
    function sendAnniversarySms($userName="amit",$userPhone="9993011209")
    {
      if($userPhone!="" && $userName!="")
      {
        $ch = curl_init();

        //Like us on bit.ly/eshpind----------------
        $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0A%20INVESTOCAFE%20wishes%20you%20and%20your%20spouse%20a%20very%20Happy%20Wedding%20Anniversary!!!%20Wish%20you%20delightful%20returns%20for%20your%20loved%20ones.%20%0AHappy%20Investing%20!%20%0ATEAM%20INVESTOCAFE.&sender=INCAFE&route=4&country=91&DLT_TE_ID=1207160699331621524";
        $url=str_replace(" ", "%20", $url1);
        //echo $url;
        curl_setopt($ch, CURLOPT_URL, $url);
        //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

        //return the transfer as a string
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        //$output contains the output string
        $output = curl_exec($ch);

        $dbData = array ('phone'=>$userPhone,'response'=>$output);
        $this->db->insert('msg_log',$dbData);
        //close curl resource to free up system resources
        curl_close($ch);

        if ( $output === FALSE)
        {
            $output=curl_error($ch); //echoes last session error
            return false;
        }
        return $output;
      }
      else
      {
        echo "Invalid user name or phone number";
        log_message('info', '***** Controller : SendGreetings, Function : sendAnniversarySms, Message : Invalid user name or phone number for anniversary sending sms *****');
      }
    }


    public function sendBirthdayEmail($email,$name)
    {
        date_default_timezone_set("Asia/Kolkata");
        $today = date('d M Y h:i a', time());
        $data=array();
        $data["name"]=$name;
        $html=$this->load->view('email_templates/birthday_template_view',$data, true);
        $subject = "Happy Birthday from Investocafe";
        $out = sendEmail($email,$subject,$html);
        // $out = sendEmailAws("pradeep.shekhawat@investocafe.com",$subject,$html);
        if($out)
        {
            log_message("info","***** Birthday message sent successfully to investor email - ".$email."*****");
        }
        else
        {
            log_message("info","***** Birthday message sending failed to investor email - ".$email."*****");
        }
        echo $result;
    }

    public function sendAnniversaryEmail($email,$name)
    {
        date_default_timezone_set("Asia/Kolkata");
        $today = date('d M Y h:i a', time());
        $data=array();
        $data["name"]=$name;
        $html=$this->load->view('email_templates/anniversary_template_view', $data,true);
        $subject = "Happy Anniversary from Investocafe";
        $out = sendEmail($email,$subject,$html);
        // $out = sendEmailAws("pradeep.shekhawat@investocafe.com",$subject,$html);
        if($out)
        {
            log_message("info","***** Anniversary message sent successfully to investor email - ".$email."*****");
        }
        else
        {
            log_message("info","***** Anniversary message sending failed to investor email - ".$email."*****");
        }
        echo $result;
    }

    public function sendToAdminEmail($html,$subject)
    {
        $out = sendEmailAws("tanish.goswami@investocafe.com",$subject,$html);
    }


}
