<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF CONTROLLER : SendMessage
|   MODEL USE : registration_model
|   DATE : 04/10/2016
|   AUTHOER : amit meena
|   COMMENT :THIS FUNCTION IS USED TO SEND SMS AND CONFIRMATION EMAIL TO CLIENT
|   FUNCTION USE : index , _loadView , sendRegistrationConfirmationMessage,sendRegistrationPdfEmail
-------------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class SendMessage extends CI_Controller {

    function __construct()
    {
      // Call the Model constructor
       parent::__construct();
       $this->load->model('registration/registration_model');
       $this->load->helper('path');
    }

/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : index
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS USED TO CALL TWO FUNCTION NAMED sendRegistrationPdfEmail ,sendRegistrationConfirmationMessage
-----------------------------------------------------------------------------------------------------
*/
    public function index()
    {
	   $this->sendRegistrationPdfEmail();
       $this->sendRegistrationConfirmationMessage();
        
    }
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : sendRegistrationConfirmationMessage
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : send registration confirmation email
-----------------------------------------------------------------------------------------------------
*/

     function sendRegistrationConfirmationMessage()
    {
        if(isset($_SESSION["investor_id"]))
        {
            $invId=$_SESSION["investor_id"];
            $resultInfo=$this->registration_model->getInvestorDetail($invId);
            if(isset($resultInfo) && !empty($resultInfo))
            {
                $email=$resultInfo->email;
                $name=$this->encrypt->decode($resultInfo->name);
				$userPhone=$this->encrypt->decode($resultInfo->phone);
				
                //$result=sendConfirmationEmail($email,$name);
                if($result =true)
                {
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : SendMessage, Function : sendRegistrationConfirmationMessage, Message : Successfully sent verification email to email id : '.$email.'and investor id : '.$invId.' *****');

                   if(isset($_SESSION["admin_email"] ))
                    {
                          $_SESSION["email"]      = $_SESSION["admin_email"]; 
                          $_SESSION["userName"]   = $_SESSION["admin_userName"];
                          $_SESSION["userId"]     = $_SESSION["admin_userId"];
                          $_SESSION["groupId"]    = $_SESSION["admin_groupId"];
                          $_SESSION["groupName"]  = $_SESSION["admin_groupName"];
                          $_SESSION['pageId']     = $_SESSION['admin_pageId'];

                          return redirect('https://investocafe.com/investocafeadmin/registrationReport');
                    }
                    

                    $this->data['isResendEmail']=$this->input->get("resend");
					
					
					
					echo $this->sendCongSms($name,$userPhone);
					return redirect(base_url('dashboard'));
					
                    $this->_loadView('amit_theme/registration/complete_registration_successfully_view');
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : SendMessage, Function : sendRegistrationConfirmationMessage, Message : Successfully registered investor *****');
                }
                else
                {
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : SendMessage, Function : sendRegistrationConfirmationMessage, Message : Failed to send verification email to email id : '.$email.'and investor id : '.$invId.' *****');
                    $this->_loadView('amit_theme/registration/error_view');
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : SendMessage, Function : sendRegistrationConfirmationMessage, Message : Error: Confirmation email not sent *****');
                }
            }
            else
            {
                $this->_loadView('amit_theme/registration/error_view');
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : SendMessage, Function : sendRegistrationConfirmationMessage, Message : Error: Investor details not matched with session id  *****');
            }
        }
        else
        {
            $this->_loadView('amit_theme/registration/error_view');
            log_message('info', '***** Controller : SendMessage, Function : sendRegistrationConfirmationMessage, Message : Error: Investor Id not available in session *****');
        }
    }

/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : sendRegistrationPdfEmail
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : send registration PDF  email TO CLIENT
-----------------------------------------------------------------------------------------------------
*/
  
	
	function sendRegistrationPdfEmail()
    {
        if(isset($_SESSION["investor_id"]))
        {
                $invId=$_SESSION["investor_id"];
                $resultInfo=$this->registration_model->getInvestorDetail($invId);
                if(isset($resultInfo) && !empty($resultInfo))
                {
                    $email=$resultInfo->email;
                    $name=$this->encrypt->decode($resultInfo->name);
                    $fileName = $resultInfo->investor_pdf_form_url;
					$downloadFilePath = base_url().'assets/uploads/investor_form_pdf/'.$fileName;
                    $data=array();
                    $data['name']=$name;
					$data['FilePath'] = $downloadFilePath;
                    $today = date('d M Y h:i a', time());
                    $html= $this->load->view('registration_pdf_email_view',$data,true);
                    $subject = "Registration Confirmation";
					$out = sendEmail($email,$subject,$html);
	
                    if($out)
                    {
                        log_message('info', '***** InvestorId : '.$invId.', Controller : SendMessage, Function : sendRegistrationPdfEmail, Message : Successfully sent registration pdf file to "'.$email.'" *****');
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$invId.', Controller : SendMessage, Function : sendRegistrationPdfEmail, Message : Failed to send registration pdf file to "'.$email.'" *****');
                    }
                }

        }

    }

/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : verifyEmail
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS FUNCTION IS USED TO CALL WHEN CLIENT CLICK ON CONFORM EMAIL LINK IN CONFIRMATION MAIL 
-----------------------------------------------------------------------------------------------------
*/
    function verifyEmail()
    {
        $string=$this->input->get("invId");
        $id=str_replace("[plus]",'+',$string);
        $investorId=$this->encrypt->decode($id);
        if($investorId)
        {
            log_message('info', '***** InvestorId : '.$investorId.', Controller : SendMessage, Function : verifyEmail, Message : Get investor detail by investor id =='.$investorId.' *****');
            $resultInfo=$this->registration_model->varifyinvestordetailgetdata($investorId);
			
            if(isset($resultInfo) && !empty($resultInfo))
            {
                if($resultInfo->is_verify==0)
                {
                    $data=array("is_verify"=>1);
                    $result=$this->registration_model->updateInvestorInfo($investorId,$data);
                    if($result)
                    {
						            $resultuser=$this->registration_model->getUserDataForSendEmail($investorId);
                        //$userName=$this->encrypt->decode($resultuser->name); //29-June-2017
						            $userName=$this->encrypt->decode($resultuser->username);
                        $userPhone=$this->encrypt->decode($resultuser->phone);
                        $sentSms=$this->sendAccountActivationSms($userName,$userPhone);
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : SendMessage, Function : verifyEmail, Message : Successfully sent account activation message to '.$userName.' *****');


                        $this->session->set_flashdata('verifyAcount', '<p class="p_section_content p_color">Thank You for verifying your email </p>');
                        redirect(base_url().'loginRegistration?task=login');
                    }
                    else
                    {
                        $this->_loadView('amit_theme/registration/error_view');
                         log_message('info', '***** InvestorId : '.$investorId.', Controller : SendMessage, Function : verifyEmail, Message : Failed to update information of the user id :  '.$userName.' *****');
                    }
                }
                else
                {
                    echo "Your email address is already verified";
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : SendMessage, Function : verifyEmail, Message : Your email address is already verified *****');
                }
            }
            else
            {
                $this->_loadView('amit_theme/registration/error_view');
                log_message('info', '***** InvestorId : '.$investorId.', Controller : SendMessage, Function : verifyEmail, Message : Investor details not found *****');
            }
        }
        else
        {
            echo "Invalid Request";
            log_message('info', '***** Controller : SendMessage, Function : verifyEmail, Message : Investor Id not found *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : verifyEmail
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : Send sendSmsForRiskProfileAgeRangeChange 
-----------------------------------------------------------------------------------------------------
*/

    function sendAccountActivationSms($userName,$userPhone="8103242526")
    {
        if($userPhone!="" && $userName!="")
        {
          $ch = curl_init();

          //Like us on bit.ly/eshpind----------------
          $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0AYour%20investment%20account%20has%20been%20activated.%20%0ALog%20in%20to%20your%20investocafe%20account%20and%20start%20investing.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4";
          $url=str_replace(" ", "%20", $url1);
          //echo $url;
          curl_setopt($ch, CURLOPT_URL, $url);
          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

          //return the transfer as a string
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

          //$output contains the output string
          $output = curl_exec($ch);

          $dbData = array ('phone'=>$userPhone,'response'=>$output);
          $this->db->insert('msg_log',$dbData);
          //close curl resource to free up system resources
          curl_close($ch);

          if ( $output === FALSE)
          {
              $output=curl_error($ch); //echoes last session error
              return false;
          }
          return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
            log_message('info', '***** Controller : SendMessage, Function : sendAccountActivationSms, Message : Invalid user name or phone number provided for sending SMS For Risk Profile, AgeRange Change *****');
        }
    }
	
	
    function sendCongSms($userName,$userPhone)
    {
        if($userPhone!="" && $userName!="")
        {
          $ch = curl_init();

          //Like us on bit.ly/eshpind----------------
          $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0ACongratulations !!! Your Registration is successful with Investocafe. We are glad to have you on board to your journey of Financial Independence.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4;";
          $url=str_replace(" ", "%20", $url1);
          //echo $url;
          curl_setopt($ch, CURLOPT_URL, $url);
          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

          //return the transfer as a string
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

          //$output contains the output string
          $output = curl_exec($ch);

          $dbData = array ('phone'=>$userPhone,'response'=>$output);
          $this->db->insert('msg_log',$dbData);
          //close curl resource to free up system resources
          curl_close($ch);

          if ( $output === FALSE)
          {
              $output=curl_error($ch); //echoes last session error
              return false;
          }
          return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
            log_message('info', '***** Controller : SendMessage, Function : sendAccountActivationSms, Message : Invalid user name or phone number provided for sending SMS For Risk Profile, AgeRange Change *****');
        }
    }
/*
-----------------------------------------------------------------------------------------------------
*/

/*
-----------------------------------------------------------------------------------------------------
|   USE : _loadView
|   DATE : 04/10/2016
|   AUTHOER : AMIT MEENA
|   COMMENT : THIS HELP TO LOAD VIEW OF COMMON VIEWS
-----------------------------------------------------------------------------------------------------
*/
    function _loadView($view)
    {
        $this->data['jsFile'] ='registration/errorView.js';
        $this->data['page_error'] = "Error while confirming registration!";
        $this->load->view('amit_theme/common/header',$this->data);
        $this->load->view($view,$this->data);
        $this->load->view('amit_theme/common/footer',$this->data );
    }
}
