<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class SipCalculation extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('sip_calculation_model');
    }

	public function index()
	{
		$this->data['pageTitle'] = 'SIP Calculation';
        $this->data['title'] = "Mutual fund and SIP calculator";
        $this->_loadNewView('theme/sipCalculation/sip_calculation_view');
  	}

  	function _loadNewView($view)
    {
		$logged=$this->ion_auth->logged_in();
		if(!$logged)
		{
			$this->data['temp_user']="yes";
		}
		else {
			$this->data['temp_user']="no";
		}
		$this->data['jsFile'] = 'sipCalculation/sipCalculation.js';
        $this->load->view('theme/common/header',$this->data);
        $this->load->view($view,$this->data);
        $this->load->view('theme/common/footer',$this->data);
    }

    function addGoalsToMyMonthlyInvestment()
    {
        $logged=$this->ion_auth->logged_in();
        if($logged && checkuser_session())
        {
			
            if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $monthlySavings=$this->input->post("monthlySavings");
                $noOfMonth=$this->input->post("noOfMonth");
                $goalAmount=$this->input->post("goalAmount");
                $investorId=$_SESSION["investor_id"];

                $data=array(
                            "goal_timeline"=>$noOfMonth,
                            "monthly_saving_amount"=>$monthlySavings,
                            "goal_amount"=>$goalAmount,
                            "goal_type_id"=>8,
                            "investor_id"=>$investorId
                            );
                $resutl=$this->sip_calculation_model->addGoals($data);
                if($resutl)
                {
                    echo '{"success":true}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addGoalsToMyMonthlyInvestment, Message : Successfully added to tax saving goals  *****');
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addGoalsToMyMonthlyInvestment, Message : Failed to add tax saving goals  *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addGoalsToMyMonthlyInvestment, Message : Investor Id not available in session  *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addGoalsToMyMonthlyInvestment, Message :  Session expired while trying to add in Tax Saving goals  *****');
        }
    }

    function addToMyGoalsMyChildsEducationInvestment()
    {
     	
            if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $monthlySavings=$this->input->post("monthlySavings");
                $noOfMonth=$this->input->post("noOfMonth");
                $goalAmount=$this->input->post("goalAmount");
                $investorId=$_SESSION["investor_id"];

                $data=array(
                            "goal_timeline"=>$noOfMonth,
                            "monthly_saving_amount"=>$monthlySavings,
                            "goal_amount"=>$goalAmount,
                            "goal_type_id"=>1,
                            "investor_id"=>$investorId
                            );
                $resutl=$this->sip_calculation_model->addGoals($data);
                if($resutl)
                {
                    echo '{"success":true}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsEducationInvestment, Message : Successfully added to My Childs Education Goals  *****');
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsEducationInvestment, Message : Failed to add to My Childs Education Goals  *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsEducationInvestment, Message : Investor Id not available in session  *****');
            }
       
    }

    function addToMyGoalsMyChildsMarriageInvestment()
    {
       
            if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $monthlySavings=$this->input->post("monthlySavings");
                $noOfMonth=$this->input->post("noOfMonth");
                $goalAmount=$this->input->post("goalAmount");
                $investorId=$_SESSION["investor_id"];

                $data=array(
                            "goal_timeline"=>$noOfMonth,
                            "monthly_saving_amount"=>$monthlySavings,
                            "goal_amount"=>$goalAmount,
                            "goal_type_id"=>2,
                            "investor_id"=>$investorId
                            );
                $resutl=$this->sip_calculation_model->addGoals($data);
                if($resutl)
                {
                    echo '{"success":true}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsMarriageInvestment, Message : Successfully added to My Childs Marriage goals  *****');
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsMarriageInvestment, Message : Failed to add to My Childs Marriage goals  *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsMarriageInvestment, Message : Investor Id not in session  *****');
            }
        
    }

	
	 function addToMyGoalsMyOthersInvestment()
    {
        
            if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $monthlySavings=$this->input->post("monthlySavings");
                $noOfMonth=$this->input->post("noOfMonth");
                $goalAmount=$this->input->post("goalAmount");
				$goal_type_id=$this->input->post("goal_type");
                $investorId=$_SESSION["investor_id"];

                $data=array(
                            "goal_timeline"=>$noOfMonth,
                            "monthly_saving_amount"=>$monthlySavings,
                            "goal_amount"=>$goalAmount,
                            "goal_type_id"=>$goal_type_id,
                            "investor_id"=>$investorId
                            );
                $resutl=$this->sip_calculation_model->addGoals($data);
                if($resutl)
                {
                    echo '{"success":true}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsMarriageInvestment, Message : Successfully added to My Childs Marriage goals  *****');
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsMarriageInvestment, Message : Failed to add to My Childs Marriage goals  *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyChildsMarriageInvestment, Message : Investor Id not in session  *****');
            }
       
    }
    function addToMyGoalsMyRetirementInvestment()
    {
        
            if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $monthlySavings=$this->input->post("monthlySavings");
                $noOfMonth=$this->input->post("noOfMonth");
                $goalAmount=$this->input->post("goalAmount");
                $investorId=$_SESSION["investor_id"];

                $data=array(
                            "goal_timeline"=>$noOfMonth,
                            "monthly_saving_amount"=>$monthlySavings,
                            "goal_amount"=>$goalAmount,
                            "goal_type_id"=>3,
                            "investor_id"=>$investorId
                            );
                $resutl=$this->sip_calculation_model->addGoals($data);
                if($resutl)
                {
                    echo '{"success":true}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyRetirementInvestment, Message : Successfully added to My Retirement goals  *****');
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyRetirementInvestment, Message : Failed to add to My Retirement goals *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsMyRetirementInvestment, Message : Investor Id not available in session  *****');
            }
        
    }

    function addToMyGoalsReturnOnMySIPInvestment()
    {
        
            if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $monthlySavings=$this->input->post("monthlySavings");
                $noOfMonth=$this->input->post("noOfMonth");
                $goalAmount=$this->input->post("goalAmount");
                $investorId=$_SESSION["investor_id"];

                $data=array(
                            "goal_timeline"=>$noOfMonth,
                            "monthly_saving_amount"=>$monthlySavings,
                            "goal_amount"=>$goalAmount,
                            "goal_type_id"=>9,
                            "investor_id"=>$investorId
                            );
                $resutl=$this->sip_calculation_model->addGoals($data);
                if($resutl)
                {
                    echo '{"success":true}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsReturnOnMySIPInvestment, Message : Successfully added to MyGoalsReturnOnMySIPInvestment   *****');
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsReturnOnMySIPInvestment, Message : Failed to add to MyGoalsReturnOnMySIPInvestment  *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsReturnOnMySIPInvestment, Message : Investor Id not available in session  *****');
            }
        
    }

    function addToMyGoalsStepUpSip()
    {
          if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $monthlySavings=$this->input->post("monthlySavings");
                $noOfMonth=$this->input->post("noOfMonth");
                $goalAmount=$this->input->post("goalAmount");
                $investorId=$_SESSION["investor_id"];

                $data=array(
                            "goal_timeline"=>$noOfMonth,
                            "monthly_saving_amount"=>$monthlySavings,
                            "goal_amount"=>$goalAmount,
                            "goal_type_id"=>10,
                            "investor_id"=>$investorId
                            );
                $resutl=$this->sip_calculation_model->addGoals($data);
                if($resutl)
                {
                    echo '{"success":true}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsStepUpSip, Message : Successfully added to MyGoalsStepUpSip  *****');
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsStepUpSip, Message : Failed to add to MyGoalsStepUpSip  *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : sipCalculation, Function : addToMyGoalsStepUpSip, Message : Investor Id not available in session  *****');
            }
        
    }

    // calculate my monthly investment
    function calculateMyMonthlyInvestment()
    {
        $parm=$this->input->post("parm");
        $ch = curl_init();

          //Like us on bit.ly/eshpind----------------
          $url1="https://www.fundsindia.com/content/jsp/calculators/MutulfundSipCalcAction.do?method=sipAsPerNeed".$parm;
          $url=str_replace(" ", "%20", $url1);
          //echo $url;
          curl_setopt($ch, CURLOPT_URL, $url);
          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

          //return the transfer as a string
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

          //$output contains the output string
          $output = curl_exec($ch);

          //close curl resource to free up system resources
          curl_close($ch);

          if ( $output === FALSE)
          {
            $output=curl_error($ch); //echoes last session error
            echo $output;
          }
          else
          {
            echo $output;
          }
    }

    function calculateReturnOnMySIPInvestment()
    {
        $parm=$this->input->post("parm");
		$email=$this->input->post("email");
		$subscribed=$this->input->post("subscribed");
		$phone=$this->input->post("phone");

        $ch = curl_init();

        //Like us on bit.ly/eshpind----------------
        $url1="https://www.fundsindia.com/content/jsp/calculators/MutulfundSipCalcAction.do?method=sipReturns".$parm;
        $url=str_replace(" ", "%20", $url1);
        //echo $url;
        curl_setopt($ch, CURLOPT_URL, $url);
        //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

        //return the transfer as a string
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        //$output contains the output string
        $output = curl_exec($ch);

        //close curl resource to free up system resources
        curl_close($ch);
		$this->subscribeUser($email,$phone,$subscribed,"SIP Returns Calculator");
        if ( $output === FALSE)
        {
        $output=curl_error($ch); //echoes last session error
            echo $output;
        }
        else
        {
            echo $output;
        }
    }

    function calculateReturnOnMyStepUpSIPInvestment()
    {
        $parm=$this->input->post("parm");
        $ch = curl_init();

        //Like us on bit.ly/eshpind----------------
        $url1="https://www.fundsindia.com/content/jsp/calculators/MutulfundSipCalcAction.do?method=stepUpSipReturn".$parm;
        $url=str_replace(" ", "%20", $url1);
        //echo $url;
        curl_setopt($ch, CURLOPT_URL, $url);
        //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

        //return the transfer as a string
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        //$output contains the output string
        $output = curl_exec($ch);

        //close curl resource to free up system resources
        curl_close($ch);

        if ( $output === FALSE)
        {
        $output=curl_error($ch); //echoes last session error
            echo $output;
        }
        else
        {
            echo $output;
        }
    }
	
	
	
	

/*

-----------------------------------------------------Mobile API------------------------------------------------------------------

*/

  function appApiForGoalSave()

    {

		$get = json_decode(file_get_contents("php://input"));

		$investorId = $get->investorId;

		if($investorId)

		{

			$monthlySavings = $get->monthlySavings;

			$noOfMonth = $get->noOfMonth;

			$goalAmount = $get->goalAmount;

			$goal_type_id = $get->goal_type_id;
            if($goal_type_id==9)
            {
                $monthlySavings = $get->goalAmount;
                $goalAmount = $get->monthlySavings;

            }
			$data=array(

						"goal_timeline"=>$noOfMonth,

						"monthly_saving_amount"=>$monthlySavings,

						"goal_amount"=>$goalAmount,

						"goal_type_id"=>$goal_type_id,

						"investor_id"=>$investorId

						);

			$resutl=$this->sip_calculation_model->addGoals($data);

			if($resutl)

			{

				echo '{"success":"true"}';

				log_message('info', '***** InvestorId : '.$investorId.', Controller : sipCalculation, Function : addGoalsToMyMonthlyInvestment, Message : Successfully added to tax saving goals  *****');

			}

			else

			{

				echo '{"success":"false"}';

				log_message('info', '***** InvestorId : '.$investorId.', Controller : sipCalculation, Function : addGoalsToMyMonthlyInvestment, Message : Failed to add tax saving goals  *****');

			}

		}

		else

		{

			

			echo '{"success":"false","session":"out"}';

			log_message('info', '***** InvestorId : '.$investorId.', Controller : sipCalculation, Function : addGoalsToMyMonthlyInvestment, Message : Investor Id not available in session  *****');

		}

    }

	

	

	 function appCalculateMyMonthlyInvestment()

    {

		

		$get = json_decode(file_get_contents("php://input"));

		$sipTarget=$get->sipTarget;

		$sipNoOfMonths=$get->sipNoOfMonths;

		$sipCagrPer=$get->sipCagrPer;

		$parm="&sipTarget=$sipTarget&sipNoOfMonths=$sipNoOfMonths&sipCagrPer=$sipCagrPer";

		

			$ch = curl_init();



          //Like us on bit.ly/eshpind----------------

          $url1="https://www.fundsindia.com/content/jsp/calculators/MutulfundSipCalcAction.do?method=sipAsPerNeed".$parm;

		 //$url1="https://www.fundsindia.com/content/jsp/calculators/MutulfundSipCalcAction.do?method=sipAsPerNeed&sipTarget=15000&sipNoOfMonths=20&sipCagrPer=15";

		

			$url=str_replace(" ", "%20", $url1);

          //echo $url;

          curl_setopt($ch, CURLOPT_URL, $url);

          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";



          //return the transfer as a string

          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);



          //$output contains the output string

          $output = curl_exec($ch);



          //close curl resource to free up system resources

          curl_close($ch);


            $splitter=' ';

        //  $out=explode($splitter,$output);
           //$result = filter_var(strip_tags($output), FILTER_SANITIZE_NUMBER_FLOAT);

           $this->load->helper("domparser");

          if( $output){
            $html = str_get_html($output);
            $final_data = '';
            foreach($html->find('div[class=col-md-4]') as $key=>$e)
            {
                
                    $final_data =trim($e->innertext);
                   $final_data = str_replace("&#8377;", "", $final_data);
               
            }
              echo '{"success":"true","result":"'.$final_data.'"}';

          }else{

              echo '{"success":"true","result":"0.00"}';

          }

		

		  

    }

	

	function appCalculateReturnOnMySIPInvestment()
    {
		$get = json_decode(file_get_contents("php://input"));
		$sableToinvest=$get->sableToinvest;
		$snoOfMonths=$get->snoOfMonths;
		$sCagr=$get->sCagr;
		$parm="&sableToinvest=$sableToinvest&snoOfMonths=$snoOfMonths&sCagr=$sCagr";
        $ch = curl_init();

			//test url https://www.fundsindia.com/content/jsp/calculators/MutulfundSipCalcAction.do?method=sipReturns&sableToinvest=15000&snoOfMonths=5&sCagr=15

        //Like us on bit.ly/eshpind----------------

        $url1="https://www.fundsindia.com/content/jsp/calculators/MutulfundSipCalcAction.do?method=sipReturns".$parm;

		//$url1="https://www.fundsindia.com/content/jsp/calculators/MutulfundSipCalcAction.do?method=sipReturns&sableToinvest=15000&snoOfMonths=20&sCagr=15";       

	   $url=str_replace(" ", "%20", $url1);

        //echo $url; 

        curl_setopt($ch, CURLOPT_URL, $url);

        //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";



        //return the transfer as a string

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);



        //$output contains the output string

        $output = curl_exec($ch);



        //close curl resource to free up system resources

        curl_close($ch);



        if ( $output === FALSE)

        {

        $output=curl_error($ch); //echoes last session error

      

        }

        $splitter=' ';

		//  $out=explode($splitter,$output);
           //$result = filter_var(strip_tags($output), FILTER_SANITIZE_NUMBER_FLOAT);

           $this->load->helper("domparser");

		  if( $output){
            $html = str_get_html($output);
            $final_data = '';
            foreach($html->find('div[class=col-md-4]') as $key=>$e)
            {
                
                    $final_data =trim($e->innertext);
                   $final_data = str_replace("&#8377;", "", $final_data);
               
            }
			  echo '{"success":"true","result":"'.$final_data.'"}';

		  }else{

			  echo '{"success":"true","result":"0.00"}';

		  }

    }

		
	function calculateRetirementGoal()
	{
		
		if($this->input->post("currentMonthlyExpense")){		
		$cme=$this->input->post("currentMonthlyExpense");
		$ca=$this->input->post("currentAge");
		$ra=$this->input->post("retirementAge");
		$lf=$this->input->post("lifeSpan");
		$ei=$this->input->post("existingInvestment");
		$inf=$this->input->post("inflation");
		$prr=$this->input->post("postRetirementReturn");
		$erc=$this->input->post("expectedReturn");
		
		 $monthlyInflation=(((   pow(1+($inf/100),(1/12)) )-1)*100);
		 
		 $monthlyPRR1=((( pow(1+($prr/100)*3/12,4))-1)*100);
		 $monthlyPRR=(( pow(1+($monthlyPRR1/100),(1/12))-1)*100);
   
		 $periodMonlyIncomeNeeded=$lf-$ra;

		 $monthlyReqFirstYearAfterRetirement=round(($cme* pow((1+($inf/100)),($ra-$ca)) ),2);

		$monthlyPRR=$monthlyPRR/100;
	    $monthlyInflation=$monthlyInflation/100;

	     $c=   ($monthlyPRR-$monthlyInflation);

	     $a=$monthlyReqFirstYearAfterRetirement*(1+$monthlyPRR)/($monthlyPRR-$monthlyInflation);

		 $noOfMonths = ($lf-$ra)*12;

	     $b=(1-pow((1+$monthlyInflation)/(1+$monthlyPRR),$noOfMonths));

	     $totalAmount=$a*$b;
	    $totalAmount=round($totalAmount,2);

		 $periodCreateRetireCorpus=$ra-$ca;
		 $futureValueExistingInvest=round(($ei* pow((1+$erc/100),$periodCreateRetireCorpus)));

		 $corpusNeedsBuild=round(($totalAmount-$futureValueExistingInvest),2);

		$monthlySavings=round(($corpusNeedsBuild*($erc/100)/12)/((pow((1+($erc/100)/12),($periodCreateRetireCorpus*12)))-1));
		 
		echo '{"success":true,"monthlySavings":"'.$monthlySavings.'","periodMonlyIncomeNeeded":"'.$periodMonlyIncomeNeeded.'","monthlyReqFirstYearAfterRetirement":"'.$monthlyReqFirstYearAfterRetirement.'","totalAmount":"'.$totalAmount.'","futureValueExistingInvest":"'.$futureValueExistingInvest.'","corpusNeedsBuild":"'.$corpusNeedsBuild.'","periodCreateRetireCorpus":"'.$periodCreateRetireCorpus.'"}';
		   
		}else{
			echo '{"success":"false","result":"wrong"}';
		}
		
		
		
	}
	
	function appCalculateRetirementGoal()
	{
		$get = json_decode(file_get_contents("php://input"));
		if($get->currentMonthlyExpense)
		{		
			$cme = $get->currentMonthlyExpense;
			$ca  = $get->currentAge;
			$ra  = $get->retirementAge;
			$lf  = $get->lifeSpan;
			$ei  = $get->existingInvestment;
			$inf = $get->inflation;
			$prr = $get->postRetirementReturn;
			$erc = $get->expectedReturn;
		
		
		 $monthlyInflation=(((   pow(1+($inf/100),(1/12)) )-1)*100);
		 
		 $monthlyPRR1=((( pow(1+($prr/100)*3/12,4))-1)*100);
		 $monthlyPRR=(( pow(1+($monthlyPRR1/100),(1/12))-1)*100);
   
		 $periodMonlyIncomeNeeded=$lf-$ra;

		 $monthlyReqFirstYearAfterRetirement=round(($cme* pow((1+($inf/100)),($ra-$ca)) ),2);

		$monthlyPRR=$monthlyPRR/100;
	    $monthlyInflation=$monthlyInflation/100;

	     $c=   ($monthlyPRR-$monthlyInflation);

	     $a=$monthlyReqFirstYearAfterRetirement*(1+$monthlyPRR)/($monthlyPRR-$monthlyInflation);

		 $noOfMonths = ($lf-$ra)*12;

	     $b=(1-pow((1+$monthlyInflation)/(1+$monthlyPRR),$noOfMonths));

	     $totalAmount=$a*$b;
	    $totalAmount=round($totalAmount,2);

		 $periodCreateRetireCorpus=$ra-$ca;
		 $futureValueExistingInvest=round(($ei* pow((1+$erc/100),$periodCreateRetireCorpus)));

		 $corpusNeedsBuild=round(($totalAmount-$futureValueExistingInvest),2);

		$monthlySavings=round(($corpusNeedsBuild*($erc/100)/12)/((pow((1+($erc/100)/12),($periodCreateRetireCorpus*12)))-1));
		 
		echo '{"success":"true","monthlySavings":"'.$monthlySavings.'","periodMonlyIncomeNeeded":"'.$periodMonlyIncomeNeeded.'","monthlyReqFirstYearAfterRetirement":"'.$monthlyReqFirstYearAfterRetirement.'","totalAmount":"'.$totalAmount.'","futureValueExistingInvest":"'.$futureValueExistingInvest.'","corpusNeedsBuild":"'.$corpusNeedsBuild.'","periodCreateRetireCorpus":"'.$periodCreateRetireCorpus.'"}';
		   
		}else{
			echo '{"success":"false","result":"wrong"}';
		}
		
		
		 
	}

	function subscribeUser($email,$phone,$subscribed,$source)
	{
		
		if($subscribed=='true')
		{
			$subscribed=1;

		}
		else
		{
			$subscribed=0;
		}
		
		$data=array(

						"email"=>$email,
						"phone"=>$phone,
						"source"=>$source,
						"subscribed"=>$subscribed

						);
//print_r($data);


			$resutl=$this->sip_calculation_model->subscribeUser($data);
	}
	
	function saveEmailPhoneInfo()
	{

		$email=$this->input->post("email");
		$subscribed=$this->input->post("subscribed");
		$phone=$this->input->post("phone");
		$source=$this->input->post("source");

		

		$this->subscribeUser($email,$phone,$subscribed,$source);
	}
}
