<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class SipScheduleCron extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('sip_schedule_cron_model');
	}

	public function index()
	{
        $this->sipScheduleCronMailAdmin();
	}

    function sipScheduleCronMailAdmin()
    {
        $currentDate = date("Y-m-d");
        $tomorrowDate = date("Y-m-d", strtotime("+ 1 day"));
        $tomorrowDateFormat = date("l, jS F Y", strtotime("+ 1 day"));
        $sipScheduleResult=$this->sip_schedule_cron_model->getNextDaySipSchedule($tomorrowDate);
        if(isset($sipScheduleResult) && !empty($sipScheduleResult))
        {
            $rowStr = "";
        	log_message('info', '***** Controller : SipScheduleCron, Function : sipScheduleCronMailAdmin, Message : Fetched monthly investment schedule of investors for '.$tomorrowDateFormat.' *****');
            $sent=$this->sendSipScheduleToAdmin($sipScheduleResult,$tomorrowDateFormat);
            if($sent)
            {
        		log_message('info', '***** Controller : SipScheduleCron, Function : sipScheduleCronMailAdmin, Message : Successfully sent the list of sip of investors scheduled for '.$tomorrowDateFormat.' to admin *****');
            }
            else
            {
        		log_message('info', '***** Controller : SipScheduleCron, Function : sipScheduleCronMailAdmin, Message : Failed to send the list of sip of investors scheduled for '.$tomorrowDateFormat.' to admin *****');
            }
        }
        else
        {
        	log_message('info', '***** Controller : SipScheduleCron, Function : sipScheduleCronMailAdmin, Message : Failed to fetch monthly investment schedule of investors for '.$tomorrowDateFormat.' *****');
        }
    }

    function sendSipScheduleToAdmin($sipScheduleResult,$tomorrowDateFormat)
    { 
        $data["result"]=$sipScheduleResult;
        $data["formattedNextDay"]=$tomorrowDateFormat;
        $html=$this->load->view('sip_schedule_admin_mail_view', $data,true);
        $this->load->library("email");
        $this->email->set_newline("\r\n");
        $this->email->set_mailtype("html");
        $this->email->to("admin@investocafe.com");
        $this->email->bcc("nikunj.vijayvargiya@gmail.com");
        $this->email->from("Investocafe Assistant<info@investocafe.com>", "Investocafe");
        $this->email->subject("SIP scheduled for ".$tomorrowDateFormat);
        $this->email->message($html);
        $result=$this->email->send();
        //echo $this->email->print_debugger();
        return $result;
    }
}
