<?php

class Stp extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		$this->load->model('purchase/purchase_model');
		$this->config->load('config_atom');
	}

	public function howWouldLikeInvest()
	{
		$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
			$view = 'STP/STPHowWouldLikeInvest';
			$userId=$_SESSION["userId"];
	        $investorId=$_SESSION["investor_id"];
			$data["investorBankDetails"]=$this->purchase_model->getInvestorBankAndPanDetail($investorId);
			$this->_loadview($view,$data);
		}
		else
		{
			redirect(base_url());
		}

	}

	public function _loadview($view,$data)
	{
		$userId=$_SESSION["userId"];
	    $investorId=$_SESSION["investor_id"];
		$resultStatus=$this->common_model->getInvestorStatus($investorId);
        if($resultStatus)
        {
            $kycDone=$resultStatus->is_kyc_done;
			$data['kycDone'] = $kycDone;
        }
        $this->load->model('dashboard/dashboard_model');
        $cancelChequeUrlRes=$this->dashboard_model->getcancelChequeUrl($investorId);
		if($cancelChequeUrlRes){
			$data["cancelChequeUrl"]=$cancelChequeUrlRes->url;	
		}else{
			$data["cancelChequeUrl"]="";
		}

		$result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
        if($result)
        {
            $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
        }
        else
        {
            $data["incomplete_bank_detail"]= 0;
        }

		$this->load->view('amit_theme/common/header',$data);
		$this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view,$data);
        $this->load->view('amit_theme/common/footer',$data );
	}

	public function startInvesting()
	{
		$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
        	if(isset($_GET['type']))
        	{
	        	$ttype = $_GET['type'];
	        	if($ttype == 'Normal' || $ttype == 'Netbanking')
	        	{
					$view = 'STP/stp_start_invest_by_one_click'; 
					$fundTypeId = 9;
					$data['jsFile'] = 'stp/stpStartInvesting.js';
					$data['ttype'] = $ttype;
					$data["radioFundDetails"]=$this->getFundDetailsByFundTypeId($fundTypeId);
					$this->_loadview($view,$data);
				}
				else
				{
					redirect(base_url());
				}
			}
			else
			{
				redirect(base_url());
			}
		}
		else
		{
			redirect(base_url());
		}
	}

	function getFundDetailsByFundTypeId($fundTypeId)
    {
    	$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
	        $result=$this->purchase_model->getFundsByFundTypeId($fundTypeId);
			if(isset($result) && !empty($result))
	        {
	            foreach ($result as $key => $value) {
	            	$result[$key]->clild_funds = $this->getChildFunds($value->AMC_code);
	            }
	            return $result;
	        }
			else
	        {
	            return false;
	        }
        }
		else
		{
			redirect(base_url());
		}
    }

    public function getChildFunds($parentFund)
    {
    	$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
	    	$res = $this->db->from('funds')->where(['AMC_code'=> $parentFund,'fund_type_id !=' => 9])->get();
	    	// $res = $this->db->from('funds')->where(['AMC_code'=> $parentFund])->get();
	    	if($res->num_rows() > 0)
	    	{
	    		return $res->result();
	    	}
	    	else
	    	{
	    		return false;
	    	}
    	}
		else
		{
			redirect(base_url());
		}
    }


    public function getPurchaseddataFromSTP()
    {
    	$post = $this->input->post();
    	$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
        	$netBankingFlag = $post['net_banking_flag'];
        	$this->createPurchaseEnteryForSTP($post,$netBankingFlag);
        }
		else
		{
			echo '{"success":false,"msg":"Please re-login to complte this action"}';
		}

    }

    public function createPurchaseEnteryForSTP($post,$netBankingFlag)
    {
    	if($post)
        {
        	$ready_for_create_entery = true;
		    $fundId = $post['fund_id'];
		    $perFundInvestAmount = $post['requestAmount'];
		    $unitCounts=0;
		    $fundTypeId = 9;
		    $investorId= $_SESSION["investor_id"];
		    date_default_timezone_set("Asia/Kolkata");
		    $requestdateFormCal = $post['requestdate'];
			$date = new DateTime($requestdateFormCal);
			$requestDate=$date->format('Y-m-d ').date("h:i:s");
			$batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
			$amc_code = $this->purchase_model->get_amc_code($fundId);
		    $folioNumber = getLatestFolioNumber($amc_code,$investorId);;
		    $checkResult=$this->purchase_model->checkFirstTimePurchaseFund($fundId,$investorId);
			if($checkResult){
					$isFirstPurchase=0;
			}else{
					$isFirstPurchase=1;
			}
		    $apiTypeId="";
			$apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
		    $investorIp = $_SERVER['REMOTE_ADDR'];
		    $nb_request = 0;
			$nb_request_status = 0;
			$transactionId = 0;

			$investorIp=$_SERVER['REMOTE_ADDR'];
			$investorId=$_SESSION["investor_id"];
			
			if($netBankingFlag == 1)
			{
				$ready_for_create_entery = false;
				$result_res = $this->stpPurchaseByNetBanking($perFundInvestAmount,$fundId,$batchId);
				if($result_res)
				{
					$nb_request = 1;
					$transactionId = $result_res['transactionId'];
					$netbankingData = $result_res['netBankingdata'];
					$ready_for_create_entery = true;
				}
			}

			if($ready_for_create_entery)
			{
			    $data=array(
						"fund_id"=>$fundId,
						"purchased_amount"=>$perFundInvestAmount,
						"unit_count"=>$unitCounts,
						"investor_id"=>$investorId,
						"request_date"=>$requestDate,
						"batch_id"=>$batchId,
						"folio_number"=>$folioNumber,
						"is_first_purchase"=>$isFirstPurchase,
						"api_batch_id"=>$apiBatchId,
						"investment_plan_type"=>"One Time",
						"investor_ip"=>$investorIp,
						"nb_request"=>$nb_request,
						"nb_request_status"=>$nb_request_status,
						"mer_txn"=>$transactionId,
	                    "amc_code" => $amc_code
						);
			    $result=$this->purchase_model->addPurchaseFunds($data);
			    if($result)
			    {
			    	$data_array = [];
			    	foreach ($post['child_data'] as $key => $value)
			    	{
			    		if($value['amount'] > 0){
				    		array_push($data_array,[
				    			'investor_id' => $investorId,
				    			'amount'	  => $value['amount'],
				    			'fund_id'	  => $value['fund_id'],
				    			'frequency'	  => $post['frequency'],
				    			'fill_amount' => $perFundInvestAmount,
				    			'fill_purchased_units_id' => $result,
				    			'fill_fund_id'=> $fundId,
				    			'is_stoped_stp'			  =>0
				    		]);
				    	}
			    	}
			    	$response = $this->addFrequency($data_array);
			    	if($response)
			    	{
			    		if($netBankingFlag == 1)
						{
							$netbankingResponse = $this->netbankingRequest($netbankingData,$transactionId);
							echo $netbankingResponse;
						}
						else
						{
							$this->session->set_flashdata('message', " Rs. ".$perFundInvestAmount. " invested in Liquid funds effect from ".$requestdateFormCal);
			    		    echo '{"success":true,"msg":"Successfully purchased","url":"'.base_url().'purchase/confirmationInvestedFunds/'.$fundTypeId.'"}';
						}
			    	}
			    	else
			    	{
			    		echo '{"success":false,"msg":"Server Error"}';
			    	}
			
			    }
			    else
			    {
			    	echo '{"success":false,"msg":"Server Error"}';
			    }
			}
			else
			{
				echo '{"success":false,"msg":"payment getway failure"}';
			}
    	}
    	else
    	{
    		echo '{"success":false,"msg":"Something goes to wrong please try again"}';
    	}
    }

    public function stpPurchaseByNetBanking($totalAmount,$fund_id,$batchId)
    {
    	$logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
			$investorId = $_SESSION["investor_id"];
			$this->load->model('purchase_cron/api_model','api_model');
			$this->load->model('registration/registration_model','registration_model');
			$prodStr = '<products>';
				$fullFundDetails = $this->api_model->getFundDetails($fund_id);
				$prodStr .= "<product>";
				$prodStr .= "<id>1</id>";
				$prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
				$prodStr .= "<amount>".$totalAmount."</amount>";
				$prodStr .= "</product>";
			$prodStr .= '</products>';

			$netbankingData['totalAmount'] = $totalAmount;
			$netbankingData['investorId'] = $investorId;
			$getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
			$investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
			$netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
			$netbankingData['prodStr'] = $prodStr;
			$netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
			$getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
			$netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
			$netbankingData['investorEmail'] = $getInvestorDetails->email;
			$netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
			$netbankingData['investorAddress'] = $getInvestorDetails->address;
			$netbankingData['batchId'] = $batchId;
				
			$transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
			if($transactionId)
			{
            	return [
            			'transactionId' => $transactionId,
            			'netBankingdata'=> $netbankingData
            		];
			}
			else
			{
				echo '{"success":false,"msg":"Server unable to create transaction"}';
				exit;
			}
        }
    }

    function netbankingRequest($netbankingData,$transactionId)
	{
		$resonceUrl = 'purchase/netbankingResponse';
		$investorId=$_SESSION["investor_id"];
		date_default_timezone_set("Asia/Kolkata");
		$datenow = date("d/m/Y");
		$paymentUrl = $this->config->item('Url');
		$postFields  = "";
		$postFields .= "&login=".$this->config->item('Login');
		$postFields .= "&pass=".$this->config->item('Password');
		$postFields .= "&ttype=".$this->config->item('ttype');
		$postFields .= "&prodid=".'Multi';
		$postFields .= "&amt=".$netbankingData['totalAmount'];
		$postFields .= "&txncurr=".$this->config->item('TxnCurr');
		$postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
        $postFields .= "&clientcode=".urlencode(base64_encode($this->config->item('clientCode')));
		$postFields .= "&txnid=".$transactionId;
		$postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
		$postFields .= "&date=".$datenow;
		$postFields .= "&mprod=".$netbankingData['prodStr'];
		$postFields .= "&udf1=".$netbankingData['investorName'];
		$postFields .= "&udf2=".$netbankingData['investorEmail'];
		$postFields .= "&udf3=".$netbankingData['investorMobile'];
		$postFields .= "&ru=".base_url().$resonceUrl;
		$postFields .= "&udf9=purchaseTransaction";
		$postFields .= "&bankid=".$netbankingData['bankid'];

         $str = $this->config->item('Login') . $this->config->item('Password') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";

        $signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKey'),false);

        $postFields .= "&signature=".$signature;

		log_message('info','***** Purchase -  location : netbankingRequest InvestorId '.$investorId.' : postFields - '.$postFields.'  *****');
		$sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
        $sendUrlNew = $paymentUrl."?".substr($postFields,1);
		log_message('info',"***** InvestorId -  $investorId : sendURL - $sendUrl  *****");
        log_message('info','***** Purchase - location : netbankingRequest InvestorId '.$investorId.' : payment url - '.$url.'  *****');
        iLog('Send Net banking Request to ATOM',$investorId,'Web App','Investor',$investorId);
        return '{"success":true,"url":"'.$sendUrlNew.'"}';

        die;
		$returnData = $this->sendInfo($postFields,$paymentUrl);
		log_message('info','***** Purchase -  location : netbankingRequest InvestorId '.$investorId.' : first request data - '.$returnData.'  *****');
		$xmlObjArray = $this->xmltoarray($returnData);
		$url = $xmlObjArray['url'];
		if(isset($xmlObjArray['tempTxnId']) && !empty($xmlObjArray['tempTxnId'])){
			$postFields  = "";
			$postFields .= "&ttype=".$this->config->item('ttype');
			$postFields .= "&tempTxnId=".$xmlObjArray['tempTxnId'];
			$postFields .= "&token=".$xmlObjArray['token'];
			$postFields .= "&txnStage=1";
			$url = $paymentUrl."?".$postFields;
			log_message('info','***** Purchase - location : netbankingRequest InvestorId '.$investorId.' : payment url - '.$url.'  *****');
			return '{"success":true,"url":"'.$url.'"}';
		}else{
			return '{"success":false}';
		}
	}

	function sendInfo($data,$paymentUrl)
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $paymentUrl);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_PORT , 443);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		$returnData = curl_exec($ch);
		curl_close($ch);
		return $returnData;
	}

	function xmltoarray($data)
	{
		$parser = xml_parser_create('');
		xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8");
		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
		xml_parse_into_struct($parser, trim($data), $xml_values);
		xml_parser_free($parser);
		$returnArray = array();
		$returnArray['url'] = $xml_values[3]['value'];
		$returnArray['tempTxnId'] = $xml_values[5]['value'];
		$returnArray['token'] = $xml_values[6]['value'];
		return $returnArray;
	}

 //    function purchaseOneTimeInvestmentFunds()
 //    {
	
 //        $logged=$this->ion_auth->logged_in();
	
 //        if(checkuser_session())
 //        {
	// 		//print_r($_POST);die;
	// 		$investorId=$_SESSION["investor_id"];
 //            $transactionType=$this->input->post("transactionType");
 //            $investmentDate=$this->input->post("investmentDate");
 //            $json=$this->input->post("json");
 //            $fundTypeId=$this->input->post("fundTypeId");
 //            $jsonArray=json_decode($json,true);
	// 		$netbankingFlag=$this->input->post("netbankingFlag");
			
	// 		$batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
				
				
	// 		if(isset($netbankingFlag) && $netbankingFlag == 'true')
	// 		{
			
	// 			$this->load->model('purchase_cron/api_model','api_model');
	// 			$this->load->model('registration/registration_model','registration_model');
	// 			$totalAmount = 0;
	// 			$prodStr = '<products>';
	// 			$cnt=1;
	// 			if(!empty($jsonArray)){
	// 			foreach($jsonArray as $fundDetails)
	// 			{
					
	// 					$totalAmount = $totalAmount+$fundDetails[1];
	// 					$fullFundDetails = $this->api_model->getFundDetails($fundDetails[0]);
	// 					$prodStr .= "<product>";
	// 					$prodStr .= "<id>".$cnt."</id>";
	// 					$prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
	// 					$prodStr .= "<amount>".$fundDetails[1]."</amount>";
	// 					$prodStr .= "</product>";
	// 					$cnt=$cnt+1;
	// 			}
	// 			$prodStr .= '</products>';
	// 			$netbankingData['totalAmount'] = $totalAmount;
	// 			$netbankingData['investorId'] = $investorId;
	// 			$getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
	// 			$investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
	// 			$netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
	// 			$netbankingData['prodStr'] = $prodStr;
	// 			$netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
	// 			$getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
	// 			$netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
	// 			$netbankingData['investorEmail'] = $getInvestorDetails->email;
	// 			$netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
	// 			$netbankingData['investorAddress'] = $getInvestorDetails->address;
	// 			$netbankingData['batchId'] = $batchId;
					
	// 			$transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
	// 			if($transactionId){
	// 			//	echo 'transactionId '.$transactionId;exit;
	// 			$nb_request = '1';
	// 			$nb_request_status = '0';
	// 			$this->createPurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
	// 			log_message('info', '***** InvestorId : '.$investorId.', Controller : Prchase, Function : purchaseOneTimeInvestmentFunds, Message : Purchased units data created before netbanking payment *****');
	//            $purchaseType = 'OneTime';
	// 		   $netbankingResponse = $this->netbankingRequest($netbankingData,$transactionId,$purchaseType);

	// 			log_message('info', '***** Controller : Purchase, Function : purchaseOneTimeInvestmentFunds, Message : netbanking data created *****');
	// 			echo $netbankingResponse;
	// 			}else{
	// 				echo '{"success":false,"session":"unable to create transaction"}';
	// 			}
	// 		}else{
	// 			echo '{"success":false,"session":"Empty json"}';
	// 		}
			
	//         }else{
	// 				$nb_request = 0;
	// 				$nb_request_status = 0;
	// 				$transactionId = 0;
	// 				//echo  $fundTypeId;die;
	// 				$result = $this->createPurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
	// 				echo $result;
	// 			}
	// 		}
 //        else
 //        {
 //            echo '{"success":false,"session":"out"}';
 //        }
 //    }

 //    function createPurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId)
	// {
	// 	$investorIp=$_SERVER['REMOTE_ADDR'];
	// 	$investorId=$_SESSION["investor_id"];
	// 	date_default_timezone_set("Asia/Kolkata");
	// 	$date = new DateTime($investmentDate);
	// 	$requestDate=$date->format('Y-m-d ').date("h:i:s");
	// 	//  get fund type name by fund type id
	// 	$fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
	// 	if(isset($jsonArray) && !empty($jsonArray))
	// 	{
	// 		$count=0;
	// 		$totalAmount=0;
	// 		foreach ($jsonArray as $row)
	// 		{
	// 			$perFundInvestAmount=$row[1];
	// 			$totalAmount=$totalAmount+$row[1];
	// 			$fundId=$row[0];
 //                $amc_code = $this->purchase_model->get_amc_code($fundId);
	// 			$checkResult=$this->purchase_model->checkFirstTimePurchaseFund($fundId,$investorId);
	// 			if($checkResult){
	// 					$isFirstPurchase=0;
	// 			}else{
	// 					$isFirstPurchase=1;
	// 			}
               
	// 			$resultFolio=getLatestFolioNumber($amc_code,$investorId);
	// 			if($resultFolio){
	// 					$folioNumber=$resultFolio;
	// 			}else{
	// 					$folioNumber="";
	// 			}
	// 			$unitCounts=0;
	// 			$apiTypeId="";
	// 			$apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
	// 			$data=array(
	// 					"fund_id"=>$fundId,
	// 					"purchased_amount"=>$perFundInvestAmount,
	// 					"unit_count"=>$unitCounts,
	// 					"investor_id"=>$investorId,
	// 					"request_date"=>$requestDate,
	// 					"batch_id"=>$batchId,
	// 					"folio_number"=>$folioNumber,
	// 					"is_first_purchase"=>$isFirstPurchase,
	// 					"api_batch_id"=>$apiBatchId,
	// 					"investment_plan_type"=>"One Time",
	// 					"investor_ip"=>$investorIp,
	// 					"nb_request"=>$nb_request,
	// 					"nb_request_status"=>$nb_request_status,
	// 					"mer_txn"=>$transactionId,
 //                        "amc_code" => $amc_code
	// 					);
	// 			$result=$this->purchase_model->addPurchaseFunds($data);
	// 			if($result){}else{$count++;}
	// 		}
	// 		if($count==0)
	// 		{
	// 			if($transactionType==1)
	// 			{
	// 				$result = $this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$jsonArray,$fundTypeId,$fundTypeName,$transactionType);
	// 				return $result;
	// 			}
	// 		}
	// 		else
	// 		{
	// 			log_message('info', '***** Controller : Purchase, Function : createPurchaseEntry, Message :  Failed investment in '.$fundTypeName.' funds *****');
 //                return '{"success":false,"msg":"Failed investment in '.$fundTypeName.' funds"}';
	// 		}
	// 	}
	// }

	public function addFrequency($data)
	{
		if(count($data>0))
		{
			$res = $this->db->insert_batch('stp_frequency',$data);
			if($res){
				return $res;
			}else{
				return false;
			}
		}
		else
		{
			return true;
		}
	}


	public function appStartInvesting()
	{
    	if(isset($_GET['type']))
    	{
        	$ttype = $_GET['type'];
        	if($ttype == 'Normal' || $ttype == 'Netbanking')
        	{
				$fundTypeId = 9;
				$data['ttype'] = $ttype;
				$data["radioFundDetails"]=$this->appGetFundDetailsByFundTypeId($fundTypeId);
				echo '{"success":true,"data":'.json_encode($data).'}';
			}
			else
			{
				echo '{"success":false,"msg":"Invalid Type"}';
			}
		}
		else
		{
			echo '{"success":false,"msg":"type not define"}';
		}
	}


	function appGetFundDetailsByFundTypeId($fundTypeId)
    {
        $result=$this->purchase_model->getFundsByFundTypeId($fundTypeId);
		if(isset($result) && !empty($result))
        {
            foreach ($result as $key => $value) {
            	$result[$key]->clild_funds = $this->appGetChildFunds($value->AMC_code);
            }
            return $result;
        }
		else
        {
            return false;
        }
    }

    public function appGetChildFunds($parentFund)
    {
    	$res = $this->db->from('funds')->where(['AMC_code'=> $parentFund,'fund_type_id !=' => 9])->get();
    	// $res = $this->db->from('funds')->where(['AMC_code'=> $parentFund])->get();
    	if($res->num_rows() > 0)
    	{
    		return $res->result();
    	}
    	else
    	{
    		return false;
    	}
    }

    // mobile create entery

    public function appCreatePurchaseEnteryForSTP()
    {
    	$post = file_get_contents('php://input');
    	
    	if($post)
        {
        	$post = (array) json_decode($post);
        	$netBankingFlag = $post['net_banking_flag'];
        	$ready_for_create_entery = true;
		    $fundId = $post['fund_id'];
		    $perFundInvestAmount = $post['requestAmount'];
		    $unitCounts=0;
		    $fundTypeId = 9;
		    $investorId= $post["investor_id"];
		    date_default_timezone_set("Asia/Kolkata");
		    $requestdateFormCal = $post['requestdate'];
			$date = new DateTime($requestdateFormCal);
			$requestDate=$date->format('Y-m-d ').date("h:i:s");
			$batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
			$amc_code = $this->purchase_model->get_amc_code($fundId);
		    $folioNumber = getLatestFolioNumber($amc_code,$investorId);;
		    $checkResult=$this->purchase_model->checkFirstTimePurchaseFund($fundId,$investorId);
			if($checkResult){
					$isFirstPurchase=0;
			}else{
					$isFirstPurchase=1;
			}

		    $apiTypeId="";
			$apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
		    $investorIp = $_SERVER['REMOTE_ADDR'];
		    $nb_request = 0;
			$nb_request_status = 0;
			$transactionId = 0;

			$investorIp=$_SERVER['REMOTE_ADDR'];
			$investorId=$post["investor_id"];
			
			if($netBankingFlag == 1)
			{
				$ready_for_create_entery = false;
				$result_res = $this->appStpPurchaseByNetBanking($perFundInvestAmount,$fundId,$batchId,$investorId);
				if($result_res)
				{
					$nb_request = 1;
					$transactionId = $result_res['transactionId'];
					$netbankingData = $result_res['netBankingdata'];
					$ready_for_create_entery = true;
				}
			}

			if($ready_for_create_entery)
			{
			    $data=array(
						"fund_id"=>$fundId,
						"purchased_amount"=>$perFundInvestAmount,
						"unit_count"=>$unitCounts,
						"investor_id"=>$investorId,
						"request_date"=>$requestDate,
						"batch_id"=>$batchId,
						"folio_number"=>$folioNumber,
						"is_first_purchase"=>$isFirstPurchase,
						"api_batch_id"=>$apiBatchId,
						"investment_plan_type"=>"One Time",
						"investor_ip"=>$investorIp,
						"nb_request"=>$nb_request,
						"nb_request_status"=>$nb_request_status,
						"mer_txn"=>$transactionId,
	                    "amc_code" => $amc_code
						);
			    
			    $result=$this->purchase_model->addPurchaseFunds($data);
			    if($result)
			    {
			    	$data_array = [];
			    	foreach ($post['child_data'] as $key => $value)
			    	{
			    		$value =(array) $value;
			    		if($value['amount'] > 0){
				    		array_push($data_array,[
				    			'investor_id' => $investorId,
				    			'amount'	  => $value['amount'],
				    			'fund_id'	  => $value['fund_id'],
				    			'frequency'	  => $post['frequency'],
				    			'fill_amount' => $perFundInvestAmount,
				    			'fill_purchased_units_id' => $result,
				    			'fill_fund_id'=> $fundId,
				    			'is_stoped_stp'=>0
				    		]);
				    	}
			    	}
			    	$response = $this->addFrequency($data_array);
			    	if($response)
			    	{
			    		if($netBankingFlag == 1)
						{
							$netbankingResponse = $this->appNetbankingRequest($netbankingData,$transactionId,$investorId);
							echo $netbankingResponse;
						}
						else
						{
							$this->session->set_flashdata('message', " Rs. ".$perFundInvestAmount. " invested in Liquid funds effect from ".$requestdateFormCal);
			    		    echo '{"success":true,"msg":"Successfully purchased","url":"'.base_url().'purchase/confirmationInvestedFunds/'.$fundTypeId.'"}';
						}
			    	}
			    	else
			    	{
			    		echo '{"success":false,"msg":"Server Error"}';
			    	}
			
			    }
			    else
			    {
			    	echo '{"success":false,"msg":"Server Error"}';
			    }
			}
			else
			{
				echo '{"success":false,"msg":"payment getway failure"}';
			}
    	}
    	else
    	{
    		echo '{"success":false,"msg":"Something goes to wrong please try again"}';
    	}
    }

    public function appStpPurchaseByNetBanking($totalAmount,$fund_id,$batchId,$investor_id)
    {
    	
		$investorId = $investor_id;
		$this->load->model('purchase_cron/api_model','api_model');
		$this->load->model('registration/registration_model','registration_model');
		$prodStr = '<products>';
			$fullFundDetails = $this->api_model->getFundDetails($fund_id);
			$prodStr .= "<product>";
			$prodStr .= "<id>1</id>";
			$prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
			$prodStr .= "<amount>".$totalAmount."</amount>";
			$prodStr .= "</product>";
		$prodStr .= '</products>';

		$netbankingData['totalAmount'] = $totalAmount;
		$netbankingData['investorId'] = $investorId;
		$getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
		$investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
		$netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
		$netbankingData['prodStr'] = $prodStr;
		$netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
		$getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
		$netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
		$netbankingData['investorEmail'] = $getInvestorDetails->email;
		$netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
		$netbankingData['investorAddress'] = $getInvestorDetails->address;
		$netbankingData['batchId'] = $batchId;
			
		$transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
		if($transactionId)
		{
        	return [
        			'transactionId' => $transactionId,
        			'netBankingdata'=> $netbankingData
        		];
		}
		else
		{
			echo '{"success":false,"msg":"Server unable to create transaction"}';
			exit;
		}
    }

    function appNetbankingRequest($netbankingData,$transactionId,$investor_id)
	{
		$resonceUrl = 'purchase/appNetbankingResponse';
		$investorId= $investor_id;
		date_default_timezone_set("Asia/Kolkata");
		$datenow = date("d/m/Y");
		$paymentUrl = $this->config->item('Url');
		$postFields  = "";
		$postFields .= "&login=".$this->config->item('Login');
		$postFields .= "&pass=".$this->config->item('Password');
		$postFields .= "&ttype=".$this->config->item('ttype');
		$postFields .= "&prodid=".'Multi';
		$postFields .= "&amt=".$netbankingData['totalAmount'];
		$postFields .= "&txncurr=".$this->config->item('TxnCurr');
		$postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
        $postFields .= "&clientcode=".urlencode(base64_encode($this->config->item('clientCode')));
		$postFields .= "&txnid=".$transactionId;
		$postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
		$postFields .= "&date=".$datenow;
		$postFields .= "&mprod=".$netbankingData['prodStr'];
		$postFields .= "&udf1=".$netbankingData['investorName'];
		$postFields .= "&udf2=".$netbankingData['investorEmail'];
		$postFields .= "&udf3=".$netbankingData['investorMobile'];
		$postFields .= "&ru=".base_url().$resonceUrl;
		$postFields .= "&udf9=purchaseTransaction";
		$postFields .= "&bankid=".$netbankingData['bankid'];

         $str = $this->config->item('Login') . $this->config->item('Password') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";

        $signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKey'),false);

        $postFields .= "&signature=".$signature;

		log_message('info','***** Purchase -  location : netbankingRequest InvestorId '.$investorId.' : postFields - '.$postFields.'  *****');
		$sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
        $sendUrlNew = $paymentUrl."?".substr($postFields,1);
		log_message('info',"***** InvestorId -  $investorId : sendURL - $sendUrl  *****");
        log_message('info','***** Purchase - location : netbankingRequest InvestorId '.$investorId.' : payment url - '.$url.'  *****');
        iLog('Send Net banking Request to ATOM',$investorId,'Web App','Investor',$investorId);
        return '{"success":true,"url":"'.$sendUrlNew.'"}';
	}

	
}