<?php
class StpCron extends CI_Controller
{
	function __construct()
	{
        parent::__construct();
        $this->load->model('purchase/purchase_model');
	}

	public function index()
	{
		$this->everyday();
		$this->everyWeek();
		$this->everyfifteenday();
		$this->everyMonth();
		
	}

	public function everyday()
	{
		$res = $this->db->from('stp_frequency')->where(['frequency'=>'Every Day','is_cancel' => 0])->get();
		$this->commonInsert($res);
	}

	public function everyWeek()
	{
		// select every week data
		$day = date("l");
		if($day == 'Monday')
		{
			$res = $this->db->from('stp_frequency')->where(['frequency'=>'Every Week','is_cancel' => 0])->get();
			$this->commonInsert($res);
		}
	}

	public function everyfifteenday()
	{
		// select every fifteen day data
		$date = date('d');
		if($date == '16')
		{
			$res = $this->db->from('stp_frequency')->where(['frequency'=>'Every 15 days','is_cancel' => 0])->get();
			$this->commonInsert($res);
		}
	}

	public function everyMonth()
	{
		// select every month data and 15 day data
		$date = date('d');
		if($date == '01')
		{
		 // $res = $this->db->from('stp_frequency')->where(['is_cancel' => 0,'frequency'=>'Every 15 days'])->or_where(['frequency'=>'Every Months','is_cancel' => 0])->get();
		 $res = $this->db->query("SELECT * FROM (`stp_frequency`) WHERE (`frequency` = 'Every 15 days' OR `frequency` = 'Every Months') AND `is_cancel` = 0");
		 $this->commonInsert($res);
		}
	}

	public function commonInsert($res)
	{
		if($res->num_rows() > 0)
		{
				$data_array = [];
				$result = $res->result();
				$investorIp=$_SERVER['REMOTE_ADDR'];
				$date = $date = new DateTime(date("Y-m-d"));
				$requestDate = $date->format('Y-m-d ').date("h:i:s");
				date_default_timezone_set("Asia/Kolkata");
				foreach ($result as $key => $value) {
					$fundId = $value->fund_id;
					$perFundInvestAmount = $value->amount;
					$unitCounts = 0;
					$investorId =  $value->investor_id;
					
					$nb_request = 0;
					$nb_request_status = 0;
					$transactionId = '';
					$amc_code = $this->purchase_model->get_amc_code($fundId);
					$checkResult=$this->purchase_model->checkFirstTimePurchaseFund($fundId,$investorId);
					if($checkResult){
							$isFirstPurchase=0;
					}else{
							$isFirstPurchase=1;
					}
					$apiTypeId="";
					$apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
					$batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
					echo $amc_code." ".$investorId;
					$resultFolio=getLatestFolioNumber($amc_code,$investorId);
					if($resultFolio){
							$folioNumber=$resultFolio;
					}else{
							$folioNumber="";
					}
					$data=array(
								"fund_id"=>$fundId,
								"purchased_amount"=>$perFundInvestAmount,
								"unit_count"=>$unitCounts,
								"investor_id"=>$investorId,
								"request_date"=>$requestDate,
								"batch_id"=>$batchId,
								"folio_number"=>$folioNumber,
								"is_first_purchase"=>0,
								"api_batch_id"=>$apiBatchId,
								"investment_plan_type"=>"STP",
								"investor_ip"=>$investorIp,
								"nb_request"=>$nb_request,
								"nb_request_status"=>$nb_request_status,
								"mer_txn"=>$transactionId,
		                        "amc_code" => $amc_code
							);
					echo "<pre>";
					print_r($data);
					$purchased_id =$this->purchase_model->addPurchaseFunds($data);
					$this->currentQueue($value->stp_frequency_id,$purchased_id);
				}
		}
	}

	public function currentQueue($stp_frequency_id,$purchased_units_id)
	{
		$this->db->query("UPDATE stp_frequency SET `transfer_amount` = `transfer_amount` + `amount`, `current_queue_purchased_units_id` = $purchased_units_id WHERE stp_frequency_id = $stp_frequency_id");
	}


}