<?php

class Swp extends CI_Controller{
	
	public function index()
	{
		if(isset($_SESSION["investor_id"])){
			$data['funds']  = $this->getFundsInvestedDetails();
			$this->load->view('amit_theme/common/header',$data);
	        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
	        $this->load->view('theme/swp/swp_view',$data);
	        $this->load->view('amit_theme/common/footer',$data );
		}else{
			return redirect('/');
		}
	}

	public function getFundsInvestedDetails()
    {
		$amount=0;
		$investorId=$_SESSION["investor_id"];

		$getFundsInvestedResultNew = $this->db->query("SELECT funds.fund_name, SUM(unit_count) AS units, IFNULL( SUM(unit_count) -( SELECT SUM(unit_count) FROM sold_units WHERE fund_id = purchased_units.fund_id AND request_status = 1 AND investor_id =  $investorId ), SUM(unit_count) ) * fund_history.nav AS current_amount, purchased_units.fund_id, funds.fund_type_id, fund_type.name,funds.red_allow FROM purchased_units JOIN funds ON funds.fund_id = purchased_units.fund_id JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id JOIN fund_type ON fund_type.fund_type_id = funds.fund_type_id WHERE investor_id =  $investorId AND request_status = 1 AND fund_history.is_latest = 1  GROUP BY purchased_units.fund_id");
		if($getFundsInvestedResultNew && $investorId)
		{
		    $rowStr="";
		    	$arr = [];
		       $fund_amount = $getFundsInvestedResultNew->result();
		        foreach($fund_amount as $fs)
		        {
		            
		            $current_invested_amount = $this->investmentCurrentValuenew($fs->fund_id,$investorId);
		            @$calculted_funds['total'][$fs->fund_type_id]['current_investment_amount'] += $current_invested_amount;
		            @$calculted_funds['total'][$fs->fund_type_id]['current_investment_value'] += $fs->current_amount;
		            $fs->current_investment_amount = $current_invested_amount;
		            $calculted_funds['key'.$fs->fund_type_id][] = $fs;
		            $rowStr .= '["'.$fs->fund_name.'",'.round($current_invested_amount,2).','.$fs->fund_id.',1,'.round($fs->current_amount,2).','.$fs->red_allow.'],';
		           	$arr[] = $this->getFreeFunds($fs->fund_id,$fs->red_allow,$investorId);
		           
		        }

		    return $arr;
		}
		else
		{
		    return false;
		}
    }

    public function investmentCurrentValuenew($fund_id,$investor_id)
    {
        $res_purchase_fund = $this->db->query("SELECT * FROM purchased_units WHERE investor_id = $investor_id AND request_status = 1 AND fund_id = $fund_id");
        $res_unit_sum_sold_fund = $this->db->query("SELECT SUM(unit_count) as units FROM sold_units WHERE investor_id = $investor_id AND request_status = 1 AND fund_id = $fund_id");
        if($res_unit_sum_sold_fund->num_rows() > 0)
        {
            $purchase_fund = $res_purchase_fund->result();
            $total_sold_units =  $res_unit_sum_sold_fund->row()->units;
            $remaining_units =$total_sold_units;
            $current_amount = 0;
            foreach($purchase_fund as $pf)
            {
                $remaining_units = $remaining_units - $pf->unit_count;
                if($current_amount > 0)
                {
                    $current_amount = $current_amount + $pf->purchased_amount;
                }

                if($remaining_units < 0 && $current_amount ==0)
                {
                    $old_nav = $pf->purchased_amount/$pf->unit_count;
                    $current_amount = $old_nav* abs($remaining_units);
                }
            }

            return round($current_amount);
        }
    }

    public function getFreeFunds($fund_id,$red_allow,$investor_id)
	{
		$limit_date = date("Y-m-d", strtotime("-".$red_allow." months"));
		$res = $this->db->query("SELECT SUM(unit_count) as purchase_units, (SELECT SUM(sold_units.unit_count) FROM sold_units WHERE sold_units.request_status = 1 AND sold_units.fund_id = purchased_units.fund_id AND sold_units.investor_id = purchased_units.investor_id) as sold_units, purchased_units.fund_id, purchased_units.folio_number, fund_history.nav, funds.fund_name, funds.redemption_min_amount, funds.redemption_in_multiple_of FROM purchased_units JOIN fund_history ON fund_history.fund_id = purchased_units.fund_id JOIN funds ON purchased_units.fund_id = funds.fund_id WHERE fund_history.is_latest = 1 AND purchased_units.`request_status` = 1 AND funds.fund_id = $fund_id AND purchased_units.investor_id = $investor_id  AND purchased_units.date_of_purchase < '".$limit_date."' GROUP BY purchased_units.investor_id");
		if($res->num_rows() >0){
			$fund_data = $res->row();
			if($fund_data->sold_units > 0){
				$free_units = $fund_data->purchase_units - $fund_data->sold_units;
			}else{
				$free_units = $fund_data->purchase_units;
			}
			$free_units_current_value = round($free_units * $fund_data->nav);
			$withdwraw_monthly = round(($free_units * $fund_data->nav)/10);
			$eligible = 1;
			if($fund_data->redemption_min_amount > $withdwraw_monthly){
				$eligible = "Not eligible for SWP";
			}
			$funds =(object) [
				"free_units" => $free_units,
				"free_units_current_value" => $free_units_current_value,
				"fund_id" => $fund_data->fund_id,
				"folio_number" => $fund_data->folio_number,
				"fund_name" => $fund_data->fund_name,
				"redemption_min_amount" => $fund_data->redemption_min_amount,
				"redemption_in_multiple_of" => $fund_data->redemption_in_multiple_of,
				"current_nav" => $fund_data->nav,
				"withdwraw_monthly"=>$withdwraw_monthly,
				"eligible"=> $eligible
			];
			return $funds;
		}else{
			return false;
		}
	}

	public function saveData()
	{
		if($_POST){
			$investorId=$_SESSION["investor_id"];
			$resultFolio=getLatestFolioNumberOld($_POST['fund_id'],$investorId);
			// print_r($resultFolio);
			$todate = date("Ymd");
			$selectDate = date("Ym".$_POST['date']);
			
			if($todate > $selectDate){
				$month = date("m")+1;
				$selectDate = date("Y-".$month."-".$_POST['date']);
			}else{
				$selectDate = date("Y-m-".$_POST['date']);
			}
			// echo $todate ." ".$selectDate;
			$data = [
				"sold_amount"=>$_POST['amt'],
				"investor_id"=>$investorId,
				"fund_id"=>$_POST['fund_id'],
				"folio_number"=>$resultFolio,
				"withdraw_type"=>1,
				"request_date"=>$selectDate
			];
			$res = $this->db->insert('swp',$data);
			if($res){
				$this->session->set_flashdata('message', "Your STP request amount of  Rs. ".$_POST['amt']. " is successfully placed. its effect from ".$selectDate);
				echo '{"success":true}';
			}else{
				echo '{"success":false}';
			}
		}
	}
}