 	<?php

class userRegistration extends CI_Controller
{
    
    function __construct()
    {
        parent::__construct();
        $this->load->model('registration/registration_model', 'registration_model');
    }
    
    public function index()
    {
        $data["investorTypeList"] = $this->registration_model->getAllInvestorType();
        $data['jsFile']           = 'reg/user_registration.js';
        $this->layout('amit_theme/reg/user_registration_view', $data);
    }
    
    function layout($view, $data)
    {
        $this->load->view('amit_theme/common/header', $data);
        $this->load->view($view, $data);
        $this->load->view('amit_theme/common/footer', $data);
    }
    
    function addInvestor($app = 0)
    {
        $name  = $this->input->post("name");
        $array = explode(" ", $name);
        $count = count($array);
        if ($count == 1) {
            $name_first = $array[0];
            $name_middle = "";
            $name_last  = "";
        } else if ($count == 2) {
            $name_first  = $array[0];
            $name_middle = "";
            $name_last   = $array[1];
        } else if ($count == 3) {
            $name_first  = $array[0];
            $name_middle = $array[1];
            $name_last   = $array[2];
        } else if ($count == 4) {
            $name_first  = $array[0];
            $name_middle = $array[1] . " " . $array[2];
            $name_last   = $array[3];
        }
        $name            = $this->encrypt->encode(handleString($this->input->post("name")));
        $email           = $this->input->post("email");
        $phone           = $this->encrypt->encode($this->input->post("phone"));
        $tokenImagePath  = $this->input->post("tokenImagePath"); // enhanced security token image path
        $tokenImageName  = $this->input->post("tokenImageName"); // enhanced securuty token image name given by user
        $password        = $this->input->post("password");
        $investorType    = $this->input->post("investorType");
        $group           = array(
            '1'
        ); // Sets user to admin.
        $additional_data = array(
            'first_name' => $name,
            'phone' => $phone,
            "email" => $email,
            "name_first" => $name_first,
            "name_middle" => $name_middle,
            "name_last" => $name_last,
        );

        $id = $this->ion_auth->register($name, $password, $email, $additional_data, $group);

        if ($id) {
            $data = array(
                
                "login_id" => $id,
                "token_image_path" => $tokenImagePath,
                "token_image_name" => $tokenImageName,
                "investor_type_id" => $investorType
            );

            $investor_id = $this->registration_model->addInvestor($data);
            
            if ($investor_id) {
                
                $investorId = $investor_id;
                $this->addInvestorStatus($investorId);
                $ip_address = $this->input->ip_address();
                $email  = $email;
                $name   = $this->encrypt->decode($name);
                $phone  = $this->encrypt->decode($phone);
                notificationAlert('New Registration',$name.' Create new account on investocafe. email id '.$email.' phone number '.$phone,$investorId);
                $result = $this->sendConfirmationEmail($email, $name, $investor_id);
                $this->sendAccountActivationSms($name, $phone);
				if ($this->input->post("referral_code") != "") {
                    // $referal_data = array(
                    //     "referral_code" => $this->input->post("referral_code"),
                    //     "user_id" => $id
                    // );
                    // $this->registration_model->referal_insert($referal_data);
                    $referalid = $this->input->post("referral_code");
                    insertNewState(handleString($this->input->post("name")),$this->input->post("phone"),$email,$investor_id,$referalid);
                    
                }
                $this->session->set_flashdata('successregistration', 'Your Registration is successful with Investocafe. We are glad to have you on board to your journey of Financial Independence. Please verify your account by clicking on link sent in a verification Email to your registered E-mail-ID '.$email.'.If you do not find verification Email in your Inbox, do check your spam/junk box too. Regards: Team Investocafe fostering your financial independence.');
                
                echo '{"success":true,"response":"added","id":"' . $id . '"}';
                
            } else {
                echo '{"success":false,"response":"error"}';
            }
            //Add Verification Mail
        } else {
            echo '{"success":false,"response":"already exists "}';
        }
    }

    /** add investor status **/
    function addInvestorStatus($investorId)
    {
        $today_date= date("Y-m-d H:i:s");
        $data=array(
                    "investor_id"=>$investorId,
                    "first_registration" => 1 ,
                    "first_registration_date" => $today_date,
                    "is_investor_registered" => 0,
                    "is_investor_registered_date" => $today_date 
                   );
        $result=$this->registration_model->updateInvestorStatus($data);
        log_message('info', '***** InvestorId : '.$investorId.', Controller : registration, Function : addInvestorStatus, Message : Successfully added investor status *****');
    }

    function sendConfirmationEmail($email,$name,$investor_id)
    {
        $today = date('d M Y h:i a', time());
        $data=array();
        $data["name"]=$name;
        $data["investor_id"] = $investor_id;
        $html=$this->load->view('accountVerificationMail_view', $data,true);
        $subject ="Account verification email";
        $out = sendEmail($email,$subject,$html);
        if($out)
        {
            log_message('info', '***** InvestorId : '.$investor_id.', Controller : Welcome, Function : sendConfirmationEmail, Message : Successfully send email *****');
        }
        else
        {
            log_message('info', '***** InvestorId : '.$investor_id.', Controller : Welcome, Function : sendConfirmationEmail, Message : email not send *****');
        }
    }


    function sendAccountActivationSms($userName,$userPhone)
    {
        if($userPhone!="" && $userName!="")
        {
          $ch = curl_init();
          $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0AYour%20investment%20account%20has%20been%20activated.%20%0ALog%20in%20to%20your%20investocafe%20account%20and%20start%20investing.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4";$url=str_replace(" ", "%20", $url1);
          curl_setopt($ch, CURLOPT_URL, $url);
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
          $output = curl_exec($ch);
          $dbData = array ('phone'=>$userPhone,'response'=>$output);
          $this->db->insert('msg_log',$dbData);
          curl_close($ch);
          if ( $output === FALSE)
          {
              $output=curl_error($ch); //echoes last session error
              return false;
          }
          return $output;
        }
    }
} 