<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');


class Withdraw extends CI_Controller
{
	function __construct()
	{
	   // Call the Model constructor
	   parent::__construct();
	   $this->load->model('dashboard/dashboard_model');
       $this->load->model('purchase/purchase_model');
       $this->load->model('withdraw/withdraw_model');
	   $this->load->config('config_karvy');
	   $this->load->helper('common_helper');
	   
	}

	public function index($fundTypeId=0)
	{
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("amit_theme/withdraw/withdraw_funds_view",$fundTypeId);
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
	}

	  public function checkWithdrawEligiblityTaxSaving($investorId=86,$fundsTypeId=3,$afterYear=3){
                  
          $taxSavingWR=$this->withdraw_model->getDataForTaxSavingWithdrawPurchaseEligiblityWithdraw($investorId,$fundsTypeId);
          
          $arrayEligiblePurchases=array();

           foreach($taxSavingWR as $row){
            
          // echo ' start_date'.$row->date_of_purchase;
      
         $withdraw_date = date('Y-m-d H:i:s', strtotime('+'.$afterYear.' year', strtotime($row->date_of_purchase)));

          // echo ' end_date'.$withdraw_date;
		   $today_date=date('Y-m-d H:i:s');
            $to_time = strtotime($today_date);
            $from_time = strtotime($withdraw_date);
			$eligiblityDays=round(($from_time - $to_time) / (24*60*60),5);
          // echo ' diff: '.$eligiblityDays. " days"; exit;
			
                if($eligiblityDays<0){
                       array_push($arrayEligiblePurchases,$row->purchased_units_id);
                }
            //echo '<br>';
             
           }
            return $arrayEligiblePurchases;

    }
    function _loadView($view,$fundTypeId)
    {
        $userId=$_SESSION["userId"];
		$investorId=$_SESSION["investor_id"];
        if($fundTypeId==3){
         $data["withdrawEligiblityTaxSaving"]=$this->checkWithdrawEligiblityTaxSaving($investorId,3,3);// investor id, 3-tax saving id, 3- year

        }
        $resultWithdrwalAmount=$this->checkAvailableWithdrwalFunds($fundTypeId);
        $data["withdrawFunds"]=$resultWithdrwalAmount;

        $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
        if($result)
        {
            $data["profileImageUrl"]=$result->profile_image_url;
            $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
            $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
            $data["is_verify"]=$result->is_verify;
        }
        else
        {
            $data["profileImageUrl"]="";
        }
        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }
        $data["fundTypeId"]=$fundTypeId;
        $data['jsFile'] ='withdraw/withdraw.js';
        $data['jsFileExtra'] ='dashboard/sipCalculation.js';
        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view);
        $this->load->view('amit_theme/common/footer',$data);
    }
	
	
	function checkWithdrawEligiblity(){
		$investorId=$_SESSION["investor_id"];
		
		//echo'<pre>';
		//print_r();
		
	}
    /** common for all funds type withdrawal ("Common for all -- units--amount---all--- ") **/
    function withdrawFunds($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/withdraw/withdraw_common_view",$fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited withdraw page");
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** ofter successfully withdrawal **/
    function withdrawSuccess($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/withdraw/withdrawal_fund_success_view",$fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Withdraw Message--".$this->session->flashdata('message'));
                addSystemLog($data); // helper function
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** check withdraw amount or unit is available or not **/
    function checkAvailableWithdrwalFunds($fundTypeId)
    {
        /** invest more **/
        $investorId=$_SESSION["investor_id"];
        // get all purchase funds which is approved by bank. and request status=1
        $resultPurchaseFunds=$this->withdraw_model->getPurchaseFundsReadytoPurchase($fundTypeId,$investorId);

        // get sold funds list
        $resultSoldFunds=$this->withdraw_model->getSoldFunds($fundTypeId,$investorId);

        $data["withdrawFunds"]= array();

        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            foreach ($resultPurchaseFunds as $puchaseRow)
            {
                $fundName=$puchaseRow->scheme_description;
                $minWithDrawalAmount=$puchaseRow->redemption_min_amount;
                $purchaseFundId=$puchaseRow->fund_id;
                $folioNumber=$puchaseRow->folio_number;
                $purchaseUnits=$puchaseRow->unit_count;
                $nav=$puchaseRow->nav;
                $minUnits=$puchaseRow->redemption_min_units;
                /** check count fund is sold or not **/
                $soldCount=0;

                if(isset($resultSoldFunds) && !empty($resultSoldFunds))
                {
                    foreach ($resultSoldFunds as $soldRow)
                    {
                        $soldFundId=$soldRow->fund_id;
                        $soldUnits=$soldRow->unit_count;
                        if($soldFundId==$purchaseFundId)
                        {
                            $balanceUnit=($purchaseUnits-$soldUnits);
                            $soldCount++;
                        }
                    }
                }

                if($soldCount==0)
                {
                    $balanceUnit=$purchaseUnits;
                }

                /** caluculate withdraw amount **/
                $withdrawalAmount=round(($balanceUnit*$nav),2);

                /** add withdraw funds list **/
                $data["withdrawFunds"][]=array(
                    "fund_id"=>$purchaseFundId,
                    "fund_name"=>$fundName,
                    "folio_number"=>$folioNumber,
                    "min_amount"=>$minWithDrawalAmount,
                    "withdrawal_amount"=>$withdrawalAmount,
                    "nav"=>$nav,
                    "redemption_min_units"=>$minUnits,
                    "unit_count"=>$balanceUnit);
            }
            return $data["withdrawFunds"];
        }
    }

    function addWithdrawFunds()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $json=$this->input->post("allinputjson");
                $fundTypeId=$this->input->post("fundTypeId");
                $withdrawType=$this->input->post("withdrawType");
                $jsonArray=json_decode($json,true); // requested value
                $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
                // withdraw type 1 for amount , 2 for units and 3 for all.
               $investorId=$_SESSION["investor_id"];
			   
               $active=1;
                if($fundTypeId==3){
                    $resultTaxSavingEligiblityWithdraw=$this->checkWithdrawEligiblityTaxSaving($investorId,3,3);// investor id, 3-tax 

                    if(!empty($resultTaxSavingEligiblityWithdraw)){
                        $active=1;
                    }else{
                        $active=0;
                    }
                }

                if($active==1){

                // withdraw type 1 for amount , 2 for units and 3 for all.
                if($withdrawType==1)
                {
                    $this->addWithdrawFundsByAmount($json,$fundTypeId,$withdrawType,$batchId);
                }
                else if($withdrawType==2)
                {
                    $this->addWithdrawFundsByUnits($json,$fundTypeId,$withdrawType,$batchId);
                }else
                {
                    $this->addWithdrawFundsByAmount($json,$fundTypeId,$withdrawType,$batchId);
                }

             }else{
                    echo '{"success":false,"session":"Not eligible for withdraw funds"}';
                    log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFunds, Message : Investor id not available in session *****');

             }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFunds, Message : Investor id not available in session *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Withdraw, Function : addWithdrawFunds, Message : Session expired while trying to add withdraw funds *****');
        }
    }

    function addWithdrawFundsByAmount($json,$fundTypeId,$withdrawType,$batchId)
    {
        $jsonArray=json_decode($json,true); // requested amount
        //print_r($jsonArray);
        $investorId = $_SESSION["investor_id"];
        /** check available withdraw funds **/
        $resultWithdrwalFunds=$this->checkAvailableWithdrwalFunds($fundTypeId);
        //print_r($resultWithdrwalFunds);
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $data["allWithdrawfundsArray"]=array();
            $isValidAmount=0;
            $totalWithdrawAmount=0; //required for email info;
            foreach ($jsonArray as $requestWithdrawRow)
            {
                $fundId=$requestWithdrawRow[0];
                $amount=$requestWithdrawRow[1]; //requesated amount
                if(isset($resultWithdrwalFunds) && !empty($resultWithdrwalFunds))
                {
                    foreach($resultWithdrwalFunds as $availableWithdrawRow)
                    {
                        $fundIdAvailable=$availableWithdrawRow["fund_id"];
                        $amountAvailable=$availableWithdrawRow["withdrawal_amount"];
                        $folioNumber=$availableWithdrawRow["folio_number"];
                        $nav=$availableWithdrawRow["nav"];
                        $unitCounts=($amount/$nav); // no of units
                        $investorId=$_SESSION["investor_id"];
                        $requestDate=date("Y-m-d h:i:s");
                        $investorIp=$_SERVER['REMOTE_ADDR'];
                        if($fundIdAvailable==$fundId)
                        {
                            if($amountAvailable<$amount)
                            {
                                $isValidAmount++;
                            }
                            else
                            {
                                /**  add withdrawal amount entry in sold_units table**/
                                $fundData=array(
                                            "fund_id"=>$fundId,
                                            "sold_amount"=>$amount,
                                            "unit_count"=>$unitCounts,
                                            "investor_id"=>$investorId,
                                            "request_date"=>$requestDate,
                                            "folio_number"=>$folioNumber,
                                            "request_status"=>0,
                                            "withdraw_type"=>$withdrawType,
                                            "batch_id"=>$batchId,
                                            "investor_ip"=>$investorIp,
                                            );
                                $totalWithdrawAmount=$totalWithdrawAmount+$amount;
                                $fundName=$availableWithdrawRow["fund_name"];
                                $data["allWithdrawfundsArray"][]=$fundData;

                                $fundEmailData=array(
                                            "fund_id"=>$fundId,
                                            "sold_amount"=>$amount,
                                            "fund_name"=>$fundName
                                            );
                                $data["allWithdrawfundsEmailData"][]=$fundEmailData; // allWithdrawfundsEmailData variable is used in
                            }
                        }
                    }
                }
            }

            // add all withdrawal funds
            if($isValidAmount==0)
            {
                $result=$this->withdraw_model->addWithdrawalAmount($data);
                if($result)
                {

                    $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
                    if (strpos($checkUrl, 'localhost') === false)
                    {
                        // send withdrawal sms
                        if(isset($_SESSION["userId"]) && !empty($_SESSION["userId"]))
                        {
                            $userId=$_SESSION["userId"];
                            $resultData=$this->common_model->getUseDetailsByUserId($userId);
                            if($resultData)
                            {
                                $name=$this->encrypt->decode($resultData->username);
                                $phone=$this->encrypt->decode($resultData->phone);
                                $email = $resultData->email;
                                $sentSms= true;
                                if(!in_array($investorId,getblockEmailAndSMS(2,2))){
                                    $sentSms=$this->sendWithdrawAmountSms($name,$phone,$totalWithdrawAmount,$email,$investorId);
                                }
                                if($sentSms)
                                {
									log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Sent sms for withdrawing the amount *****');
                                }
                                else
                                {
									log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Failed to send sms for withdrawing the amount *****');
                                }
                            }
                        }
                    }

                    // get fund type name by fund type id
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);

                    
                    $resultsentMail= true;
                    if(!in_array($investorId,getblockEmailAndSMS(2,1))){
                        $userId=$_SESSION["userId"];
                        $resultData=$this->common_model->getUseDetailsByUserId($userId);
                        $phone=$this->encrypt->decode($resultData->phone);
                        $resultsentMail=$this->sendWithdrawFundEmail($data,$totalWithdrawAmount,$fundTypeName,$phone);
                    }
                    if($resultsentMail)
                    {
                        $this->session->set_flashdata('message', "You have scheduled your ".$fundTypeName." Withdrawal of Rs ".$totalWithdrawAmount." on ".date('M d,Y'));
                        echo '{"success":true,"msg":"Sold request submitted with sending mail"}';
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Submitted sold request and sent mail *****');
                    }
                    else
                    {
                        echo '{"success":true,"msg":"Sold request submitted, mail not sent"}';
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Submitted sold request but failed to send mail *****');
                    }
                }
                else
                {
                    echo '{"success":false,"msg":"Server error"}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Sold request failed due to server error *****');
                }
            }
            else
            {
                echo '{"success":false,"msg":"Invalid amount"}';
				log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Sold request failed due to invalid amount *****');
            }
        }
        else
        {
            echo '{"success":false}';
			log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Sold request failed due to insufficient amount *****');
        }
    }

    // send sms for withdraw
    function sendWithdrawAmountSms($userName,$userPhone,$amount,$email='',$investorId=null)
    {
        if($userPhone!="" && $userName!="")
        {
          $ch = curl_init();

          //Like us on bit.ly/eshpind----------------
          $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0AYour%20request%20for%20REDEMPTION%20of%20Rs.%20".$amount."%20has%20been%20received%20at%20our%20end%2C%20It%20will%20be%20processed%20shortly.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4&country=91&DLT_TE_ID=1207160699310583871";
          $url=str_replace(" ", "%20", $url1);
          //echo $url;
          curl_setopt($ch, CURLOPT_URL, $url);
          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

          //return the transfer as a string
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

          //$output contains the output string
          $output = curl_exec($ch);

          $dbData = array ('phone'=>$userPhone,'response'=>$output);
          $this->db->insert('msg_log',$dbData);
          //close curl resource to free up system resources
          curl_close($ch);

          if ( $output === FALSE)
          {
              $output=curl_error($ch); //echoes last session error
              return false;
          }

          if($investorId){
              notificationAlert('REDEMPTION Request',$userName.' Redeem investment amount of '.$amount.'. email id '.$email.' phone number '.$userPhone,$investorId);
          }
          return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
			log_message('info', '***** Controller : Withdraw, Function : sendWithdrawAmountSms, Message : Invalid user name or phone number for sending SMS for withdrawing funds *****');
        }
    }
	
	
	function sendtorahul($userName,$userPhone,$amount)
    {
        if($userPhone!="" && $userName!="")
        {
          $ch = curl_init();
		  $userPhone = 9826625009;
          //Like us on bit.ly/eshpind----------------
		  $msg = "a new redemption by ".$userName." of amount ".$amount. " is done for ";
          $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=".$msg."&sender=INCAFE&route=4;";
          $url=str_replace(" ", "%20", $url1);
          //echo $url;
          curl_setopt($ch, CURLOPT_URL, $url);
          //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

          //return the transfer as a string
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

          //$output contains the output string
          $output = curl_exec($ch);

          $dbData = array ('phone'=>$userPhone,'response'=>$output);
          $this->db->insert('msg_log',$dbData);
          //close curl resource to free up system resources
          curl_close($ch);

          if ( $output === FALSE)
          {
              $output=curl_error($ch); //echoes last session error
              return false;
          }
          return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
			log_message('info', '***** Controller : Withdraw, Function : sendWithdrawAmountSms, Message : Invalid user name or phone number for sending SMS for withdrawing funds *****');
        }
    }

    function sendWithdrawFundEmail($data,$totalWithdrawAmount,$fundTypeName,$phone="")
    {
       //print_r($data["allWithdrawfundsEmailData"]);die;
        $email=$_SESSION["email"];
        $name=$this->encrypt->decode($_SESSION["userName"]);
        $today = date('d M Y h:i a', time());
        $data["fundTypeName"]=$fundTypeName;
        $data["name"]=$name;
        $data["requestDate"]=date('M d, Y');
        $data["totalWithdrawAmount"]=$totalWithdrawAmount;
        $html=$this->load->view('withdrawal_amount_confirmation_email_view', $data,true);
        $subject="Your request for withdrawal with Investocafe has been scheduled";
        $out = sendEmail($email,$subject,$html);
        $email = "tanish.goswami@investocafe.com";
        $subject = $subject." phone - ". $phone;
        $out = sendEmail($email,$subject,$html);
        return $out;
    }

 
    /** dashboard page functionality **/
    function getCurrentValueByFundType()
    {
        $fundTypeId=$this->input->post("fundTypeId");
        $result=$this->checkWithdrwalFundsAmountAfterSuccss($fundTypeId);
        $totalAmount=0;
		$totalInvestAmount=0;
        if(isset($result) && !empty($result))
        {
            foreach ($result as $row)
            {
                $amount=$row["withdrawal_amount"];
				$investAmount = $row["availableBalance"];
				$totalInvestAmount = round(($totalInvestAmount+$investAmount),2);
				

				$rel_amnt = 0;
				if($row["fund_id"]==9227) {
					$investorId=$_SESSION["investor_id"];
					if (isset($_SESSION["rel_amnt"][$investorId])) {
						$rel_amnt = $_SESSION["rel_amnt"][$investorId];
					}
					else {
						$rel_amnt = getCurrentRelianceAmount($row["folio_number"]);
						$_SESSION["rel_amnt"][$investorId] = $rel_amnt;
						$_SESSION["net_amnt"][$investorId] = $investAmount;
					}
					
					$totalAmount = round(($totalAmount+$rel_amnt),2);
				}
				else {
					$totalAmount = round(($totalAmount+$amount),2);
				}

               
				
				
				
            }
			
			if($totalInvestAmount < 0)
			{
				
				$totalInvestAmount = 0;
			}
            echo '{"success":true,"rel_amnt":"'.$rel_amnt.'","currentValue":"'.$totalAmount.'","totalInvestAmount":"'.$totalInvestAmount.'"}';
			log_message('info', '***** Controller : Withdraw, Function : getCurrentValueByFundType, Message : Successfully fetched current value of purchased funds *****');
        }
        else
        {
            echo '{"success":true,"currentValue":"'.$totalAmount.'","totalInvestAmount":"'.$totalInvestAmount.'"}';
        }
    }

    /** check withdraw amount is available or not **/
    function checkWithdrwalFundsAmountAfterSuccss($fundTypeId)
    {
        /** invest more **/
        $investorId=$_SESSION["investor_id"];
        // get all purchase funds which is approved by bank. and request status=1
        $resultPurchaseFunds = $this->withdraw_model->getPurchaseFundsReadytoPurchase($fundTypeId,$investorId);
		
        // get sold funds list
        $resultSoldFunds = $this->withdraw_model->getSoldFundsAfterSuccess($fundTypeId,$investorId);

        $data["withdrawFunds"]= array();

        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            foreach ($resultPurchaseFunds as $puchaseRow)
            {
                $fundName=$puchaseRow->scheme_description;
                $minWithDrawalAmount=$puchaseRow->redemption_min_amount;
                $purchaseFundId=$puchaseRow->fund_id;
                $folioNumber=$puchaseRow->folio_number;
                $purchaseUnits=$puchaseRow->unit_count;
                $nav=$puchaseRow->nav;
				$purchased_amount = $puchaseRow->purchased_amount;
                $minUnits=$puchaseRow->redemption_min_units;
                /** check count fund is sold or not **/
                $soldCount=0;

                if(isset($resultSoldFunds) && !empty($resultSoldFunds))
                {
                    foreach ($resultSoldFunds as $soldRow)
                    {
                        $soldFundId=$soldRow->fund_id;
                        $soldUnits=$soldRow->unit_count;
						$sold_amount=$soldRow->sold_amount;
                        if($soldFundId==$purchaseFundId)
                        {
                            $balanceUnit=round(($purchaseUnits-$soldUnits),2);
							$availableBalance = round(($purchased_amount - $sold_amount),2);
                            $soldCount++;
                        }
                    }
                }

                if($soldCount==0)
                {
                    $balanceUnit=$purchaseUnits;
					$availableBalance = $purchased_amount;
                }

                /** caluculate withdraw amount **/
                $withdrawalAmount=round(($balanceUnit*$nav),2);

                /** add withdraw funds list **/
                $data["withdrawFunds"][]=array(
                    "fund_id"=>$purchaseFundId,
                    "fund_name"=>$fundName,
                    "folio_number"=>$folioNumber,
                    "min_amount"=>$minWithDrawalAmount,
                    "withdrawal_amount"=>$withdrawalAmount,
                    "nav"=>$nav,
                    "redemption_min_units"=>$minUnits,
					"availableBalance" => $availableBalance,
                    "unit_count"=>$balanceUnit);
            }
            return $data["withdrawFunds"];
        }
    }

    // before withdraw funds tax and load info
    function beforeWithdrawInfo($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/withdraw/before_withdraw_info_view",$fundTypeId);
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function addWithdrawFundsByUnits($json,$fundTypeId,$withdrawType,$batchId)
    {
        if(checkuser_session())
        {
            $investorId = $_SESSION["investor_id"];
            if(isset($_SESSION["investor_id"]) && !empty($_SESSION["investor_id"]))
            {
                $jsonArray=json_decode($json,true); // requested amount

                /** check available withdraw amount **/

                $resultWithdrwalAmount=$this->checkAvailableWithdrwalFunds($fundTypeId);
                //print_r($resultWithdrwalAmount);
                if(isset($jsonArray) && !empty($jsonArray))
                {
                    $data["allWithdrawfundsArray"]=array();
                    $isValidUnits=0;
                    $totalWithdrawUnits=0; //required for email info;
                    foreach ($jsonArray as $requestWithdrawRow)
                    {
                        $fundId=$requestWithdrawRow[0];
                        $units=$requestWithdrawRow[1]; //requesated units
                        if(isset($resultWithdrwalAmount) && !empty($resultWithdrwalAmount))
                        {
                            foreach($resultWithdrwalAmount as $availableWithdrawRow)
                            {
                                $fundIdAvailable=$availableWithdrawRow["fund_id"];
                                $unitsAvailable=$availableWithdrawRow["unit_count"];
                                $folioNumber=$availableWithdrawRow["folio_number"];
                                $investorId=$_SESSION["investor_id"];
                                $requestDate=date("Y-m-d h:i:s");
                                $investorIp=$_SERVER['REMOTE_ADDR'];
                                if($fundIdAvailable==$fundId)
                                {
                                    if($unitsAvailable<$units)
                                    {
                                        $isValidUnits++;
                                    }
                                    else
                                    {
                                        /**  add withdrawal amount entry in sold_units table**/
                                        $fundData=array(
                                                    "fund_id"=>$fundId,
                                                    "unit_count"=>$units,
                                                    "investor_id"=>$investorId,
                                                    "request_date"=>$requestDate,
                                                    "folio_number"=>$folioNumber,
                                                    "request_status"=>0,
                                                    "withdraw_type"=>2,
                                                    "batch_id"=>$batchId,
                                                    "investor_ip"=>$investorIp,
                                                    );
                                        $totalWithdrawUnits=$totalWithdrawUnits+$units;
                                        $fundName=$availableWithdrawRow["fund_name"];
                                        $data["allWithdrawfundsArray"][]=$fundData;

                                        $fundEmailData=array(
                                                    "fund_id"=>$fundId,
                                                    "sold_units"=>$units,
                                                    "fund_name"=>$fundName
                                                    );
                                        $data["allWithdrawfundsEmailData"][]=$fundEmailData; // allWithdrawfundsEmailData variable is used in
                                    }
                                }
                            }
                        }
                    }

                    // add all withdrawal funds
                    if($isValidUnits==0)
                    {
                        $result=$this->withdraw_model->addWithdrawalByUnits($data);
                        if($result)
                        {
                            $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
                            if (strpos($checkUrl, 'localhost') === false)
                            {
                                // send withdrawal sms
                                if(isset($_SESSION["userId"]) && !empty($_SESSION["userId"]))
                                {
                                    $userId=$_SESSION["userId"];
                                    $resultData=$this->common_model->getUseDetailsByUserId($userId);
                                    if($resultData)
                                    {
                                        $name=$this->encrypt->decode($resultData->username);
                                        $phone=$this->encrypt->decode($resultData->phone);
                                        $email = $resultData->email;
                                        $sentSms= false;
                                        if(!in_array($investorId,getblockEmailAndSMS(2,2))){
                                            $sentSms=$this->sendWithdrawUnitSms($name,$phone,$totalWithdrawUnits,$email,$investorId);
                                        }
                                        if($sentSms)
                                        {
											log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sent sms for withdrawing the units *****');
                                        }
                                        else
                                        {
											log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Failed to send sms for withdrawing the units *****');
                                        }
                                    }
                                }
                            }

                            // get fund type name by fund type id
                            $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                            $resultsentMail= false;
                            if(!in_array($investorId,getblockEmailAndSMS(2,1))){
                                $resultsentMail=$this->sendWithdrawUnitsEmail($data,$totalWithdrawUnits,$fundTypeName);
                            }
                            if($resultsentMail)
                            {
                                $this->session->set_flashdata('message', "You have scheduled your ".$fundTypeName." Withdrawal Units ".$totalWithdrawUnits." on ".date('M d,Y'));
                                echo '{"success":true,"msg":"Sold request submitted with sending mail"}';
								log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request submitted and sent mail *****');
                            }
                            else
                            {
                                echo '{"success":true,"msg":"Sold request submitted, mail not sent"}';
								log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request submitted but failed to send mail *****');
                            }
                        }
                        else
                        {
                            echo '{"success":false,"msg":"Server error"}';
							log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request failed due to server error *****');
                        }
                    }
                    else
                    {
                        echo '{"success":false,"msg":"Invalid units"}';
						log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request failed due to invalid units *****');
                    }
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request failed due to insufficient units *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Investor id not available in session *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Session expired while addWithdrawFundsByUnits *****');
        }
    }

    // send sms for withdraw
    function sendWithdrawUnitSms($userName,$userPhone,$units,$email='',$investorId=null)
    {
        if($userPhone!="" && $userName!="")
        {
            $ch = curl_init();

            //Like us on bit.ly/eshpind----------------
            $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0AYour%20request%20for%20REDEMPTION%20".$units."%20units%20has%20been%20received%20at%20our%20end%2C%20It%20will%20be%20processed%20shortly.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4&DLT_TE_ID=1207162122925699475";
            $url=str_replace(" ", "%20", $url1);
            //echo $url;
            curl_setopt($ch, CURLOPT_URL, $url);
            //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

            //return the transfer as a string
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

            //$output contains the output string
            $output = curl_exec($ch);

            $dbData = array ('phone'=>$userPhone,'response'=>$output);
            $this->db->insert('msg_log',$dbData);
            //close curl resource to free up system resources
            curl_close($ch);

            if ( $output === FALSE)
            {
                $output=curl_error($ch); //echoes last session error
                return false;
            }
            if($investorId){
                  notificationAlert('REDEMPTION Request',$userName.' Redeem investment Units of '.$units.'. email id '.$email.' phone number '.$userPhone,$investorId);
            }
            return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
			log_message('info', '***** Controller : Withdraw, Function : sendWithdrawUnitSms, Message : Invalid user name or phone number for sending SMS for withdrawing funds *****');
        }
    }

    function sendWithdrawUnitsEmail($data,$totalWithdrawunits,$fundTypeName)
    {
        $email=$_SESSION["email"];
        $name=$this->encrypt->decode($_SESSION["userName"]);
        $today = date('d M Y h:i a', time());
        $data["fundTypeName"]=$fundTypeName;
        $data["name"]=$name;
        $data["requestDate"]=date('M d, Y');
        $data["totalWithdrawunits"]=$totalWithdrawunits;
        $html=$this->load->view('withdrawal_unit_confirmation_email_view', $data,true);
        $subject="Your request for withdrawal with Investocafe has been scheduled";
        $out = sendEmail($email,$subject,$html);
        return $out;
    }
	
	
	
	
/*

---------------------------------------------------------------------------------------------------

|	NAME OF CONTROLLER : AppGetCurrentValueByFundType

|	DATE : 25/10/2016

|	AUTHOER : AMIT MEENA

|	COMMENT : THIS FUNCTION IS USED TO SHOW CURRENT INVESTMENT BY FUND ID

---------------------------------------------------------------------------------------------------

*/

    

    /** dashboard page functionality **/

    function appGetCurrentValueByFundType()
    {
        $get = json_decode(file_get_contents("php://input"));
		$investorId = $get->investorId;
        $result=$this->appCheckWithdrwalFundsAmountAfterSuccss(1,$investorId);
        $totalAmount=0;
        if(isset($result) && !empty($result))
        {
            foreach ($result as $row)
            {
                $amount=$row["withdrawal_amount"];
                $totalAmount=round(($totalAmount+$amount),2);
            }
            $dataone =  '{"success":"true","InvestmentTypeId":"1","currentValue":"'.$totalAmount.'"}';
			log_message('info', '***** Controller : Withdraw, Function : getCurrentValueByFundType, Message : Successfully fetched current value of purchased funds *****');
        }
        else
        {
           $dataone =  '{"success":"true","InvestmentTypeId":"1","currentValue":"'.$totalAmount.'"}';
        }

		$result=$this->appCheckWithdrwalFundsAmountAfterSuccss(2,$investorId);
		$totalAmount=0;
        if(isset($result) && !empty($result))
        {
            foreach ($result as $row)
            {
                $amount=$row["withdrawal_amount"];
                $totalAmount=round(($totalAmount+$amount),2);
            }
            $datatwo =  '{"success":"true","InvestmentTypeId":"2","currentValue":"'.$totalAmount.'"}';
			log_message('info', '***** Controller : Withdraw, Function : getCurrentValueByFundType, Message : Successfully fetched current value of purchased funds *****');
        }
        else
        {
            $datatwo =  '{"success":"true","InvestmentTypeId":"2","currentValue":"'.$totalAmount.'"}';
        }
		$result=$this->appCheckWithdrwalFundsAmountAfterSuccss(3,$investorId);
		$totalAmount=0;
        if(isset($result) && !empty($result))
        {
            foreach ($result as $row)
            {
                $amount=$row["withdrawal_amount"];
                $totalAmount=round(($totalAmount+$amount),2);
            }
            $datathree =  '{"success":"true","InvestmentTypeId":"3","currentValue":"'.$totalAmount.'"}';
			log_message('info', '***** Controller : Withdraw, Function : getCurrentValueByFundType, Message : Successfully fetched current value of purchased funds *****');

        }
        else
        {
            $datathree =  '{"success":"true","InvestmentTypeId":"3","currentValue":"'.$totalAmount.'"}';
        }
		$result=$this->appCheckWithdrwalFundsAmountAfterSuccss(4,$investorId);
		$totalAmount=0;
        if(isset($result) && !empty($result))
        {
            foreach ($result as $row)
            {
                $amount=$row["withdrawal_amount"];
                $totalAmount=round(($totalAmount+$amount),2);
            }
            $datafour =  '{"success":"true","InvestmentTypeId":"4","currentValue":"'.$totalAmount.'"}';
			log_message('info', '***** Controller : Withdraw, Function : getCurrentValueByFundType, Message : Successfully fetched current value of purchased funds *****');
        }
        else
        {
            $datafour =  '{"success":"true","InvestmentTypeId":"4","currentValue":"'.$totalAmount.'"}';
        }
		$result=$this->appCheckWithdrwalFundsAmountAfterSuccss(9,$investorId);
		$totalAmount=0;
        if(isset($result) && !empty($result))
        {
            foreach ($result as $row)
            {
                $amount=$row["withdrawal_amount"];
                $totalAmount=round(($totalAmount+$amount),2);
            }
            $datafive =  '{"success":"true","InvestmentTypeId":"9","currentValue":"'.$totalAmount.'"}';
			log_message('info', '***** Controller : Withdraw, Function : getCurrentValueByFundType, Message : Successfully fetched current value of purchased funds *****');
        }
        else
        {
            $datafive =  '{"success":"true","InvestmentTypeId":"9","currentValue":"'.$totalAmount.'"}';
        }
        $result=$this->appCheckWithdrwalFundsAmountAfterSuccss(10,$investorId);
        $totalAmount=0;
        if(isset($result) && !empty($result))
        {
            foreach ($result as $row)
            {
                $amount=$row["withdrawal_amount"];
                $totalAmount=round(($totalAmount+$amount),2);
            }
            $datasix =  '{"success":"true","InvestmentTypeId":"10","currentValue":"'.$totalAmount.'"}';
            log_message('info', '***** Controller : Withdraw, Function : getCurrentValueByFundType, Message : Successfully fetched current value of purchased funds *****');
        }
        else
        {
            $datasix =  '{"success":"true","InvestmentTypeId":"10","currentValue":"'.$totalAmount.'"}';
        }

        $result=$this->appCheckWithdrwalFundsAmountAfterSuccss(11,$investorId);
        $totalAmount=0;
        if(isset($result) && !empty($result))
        {
            foreach ($result as $row)
            {
                $amount=$row["withdrawal_amount"];
                $totalAmount=round(($totalAmount+$amount),2);
            }
            $dataseven =  '{"success":"true","InvestmentTypeId":"11","currentValue":"'.$totalAmount.'"}';
            log_message('info', '***** Controller : Withdraw, Function : getCurrentValueByFundType, Message : Successfully fetched current value of purchased funds *****');
        }
        else
        {
            $dataseven =  '{"success":"true","InvestmentTypeId":"11","currentValue":"'.$totalAmount.'"}';
        }
		echo '{"1" : '.$dataone.' , "2" : '.$datatwo.' , "3" : '.$datathree.', "4" : '.$datafour.', "9" : '.$datafive.', "10" : '.$datasix.', "11" : '.$dataseven.'}';
    }

/*

---------------------------------------------------------------------------------------------------

|	NAME OF CONTROLLER : AppGetCurrentValueByFundType

|	DATE : 25/10/2016

|	AUTHOER : AMIT MEENA

|	COMMENT : check withdraw amount is available or not

---------------------------------------------------------------------------------------------------

*/	



    function appCheckWithdrwalFundsAmountAfterSuccss($fundTypeId,$investorId)
    {
        // get all purchase funds which is approved by bank. and request status=1
        $resultPurchaseFunds=$this->withdraw_model->getPurchaseFundsReadytoPurchase($fundTypeId,$investorId);
        // get sold funds list
        $resultSoldFunds=$this->withdraw_model->getSoldFundsAfterSuccess($fundTypeId,$investorId);
        $data["withdrawFunds"]= array();
        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            foreach ($resultPurchaseFunds as $puchaseRow)
            {
                $fundName=$puchaseRow->scheme_description;
                $minWithDrawalAmount=$puchaseRow->redemption_min_amount;
                $purchaseFundId=$puchaseRow->fund_id;
                $folioNumber=$puchaseRow->folio_number;
                $purchaseUnits=$puchaseRow->unit_count;
                $nav=$puchaseRow->nav;
                $minUnits=$puchaseRow->redemption_min_units;
                /** check count fund is sold or not **/
                $soldCount=0;
                if(isset($resultSoldFunds) && !empty($resultSoldFunds))
                {
                    foreach ($resultSoldFunds as $soldRow)
                    {
                        $soldFundId=$soldRow->fund_id;
                        $soldUnits=$soldRow->unit_count;
                        if($soldFundId==$purchaseFundId)
                        {
                            $balanceUnit=round(($purchaseUnits-$soldUnits),3);
                            $soldCount++;
                        }
                    }
                }

                if($soldCount==0)
                {
                    $balanceUnit=$purchaseUnits;
                }
                /** caluculate withdraw amount **/
                $withdrawalAmount=round(($balanceUnit*$nav),3);
                /** add withdraw funds list **/
                $data["withdrawFunds"][]=array(
                    "fund_id"=>$purchaseFundId,
                    "fund_name"=>$fundName,
                    "folio_number"=>$folioNumber,
                    "min_amount"=>$minWithDrawalAmount,
                    "withdrawal_amount"=>$withdrawalAmount,
                    "nav"=>$nav,
                    "redemption_min_units"=>$minUnits,
                    "unit_count"=>$balanceUnit);
            }
            return $data["withdrawFunds"];
        }
    }
	
	
    function appAddWithdrawFunds()
    {
		$get = json_decode(file_get_contents("php://input"));
		$investorId = $get->investorId;
		$userId = $get->userId;

        if($investorId)
        {
            if(isset($investorId) && !empty($investorId))
            {
                $json=$get->json;
                $fundTypeId=$get->fundTypeId;
                $withdrawType=$get->withdrawType;
                $jsonArray=$json; // requested value
                $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
                // withdraw type 1 for amount , 2 for units and 3 for all.
               $active=1;
			   
                if($fundTypeId==3){
                        $resultTaxSavingEligiblityWithdraw=$this->checkWithdrawEligiblityTaxSaving($investorId,3,3);// investor id, 3-tax 

                        if(!empty($resultTaxSavingEligiblityWithdraw)){
                            $active=1;
                        }else{
                            $active=0;
                        }
                }

                if($active==1)
		{
			// withdraw type 1 for amount , 2 for units and 3 for all.
			if($withdrawType==1)
			{
				$this->appAddWithdrawFundsByAmount($json,$fundTypeId,$withdrawType,$batchId,$investorId,$userId);
			}
			else if($withdrawType==2)
			{
				$this->appAddWithdrawFundsByUnits($json,$fundTypeId,$withdrawType,$batchId,$investorId,$userId);
			}else
			{
				$this->appAddWithdrawFundsByAmount($json,$fundTypeId,$withdrawType,$batchId,$investorId,$userId);	
			}

		}
		else
		{
                    echo '{"success":"false","session":"Not eligible for withdraw funds"}';
                    log_message('info', '***** InvestorId : '.$investorId .', Controller : Withdraw, Function : addWithdrawFunds, Message : Investor id not available in session *****');

		}
            }
            else
            {
                echo '{"success":"false","session":"out"}';
								log_message('info', '***** InvestorId : '.$investorId .', Controller : Withdraw, Function : addWithdrawFunds, Message : Investor id not available in session *****');
            }
        }
        else
        {
            echo '{"success":"false","session":"out"}';
			log_message('info', '***** Controller : Withdraw, Function : addWithdrawFunds, Message : Session expired while trying to add withdraw funds *****');
        }
    }
	
	
    function appAddWithdrawFundsByAmount($json,$fundTypeId,$withdrawType,$batchId,$investorId,$userId)
    {
        $jsonArray=$json; // requested amount
        
        /** check available withdraw funds **/
        $resultWithdrwalFunds=$this->appCheckAvailableWithdrwalFunds($fundTypeId,$investorId);

        if(isset($jsonArray) && !empty($jsonArray))
        {
            $data["allWithdrawfundsArray"]=array();
            $isValidAmount=0;
            $totalWithdrawAmount=0; //required for email info;
            foreach ($jsonArray as $requestWithdrawRow)
            {
                $fundId=$requestWithdrawRow[0];
                $amount=$requestWithdrawRow[1]; //requesated amount
                if(isset($resultWithdrwalFunds) && !empty($resultWithdrwalFunds))
                {
                    foreach($resultWithdrwalFunds as $availableWithdrawRow)
                    {
                        $fundIdAvailable=$availableWithdrawRow["fund_id"];
                        $amountAvailable=$availableWithdrawRow["withdrawal_amount"];
                        $folioNumber=$availableWithdrawRow["folio_number"];
                        $nav=$availableWithdrawRow["nav"];
                        $unitCounts=($amount/$nav); // no of units
                        $requestDate=date("Y-m-d h:i:s");
                        $investorIp=$_SERVER['REMOTE_ADDR'];
                        if($fundIdAvailable==$fundId)
                        {
                            if($amountAvailable<$amount)
                            {
                                $isValidAmount++;
                            }
                            else
                            {
                                /**  add withdrawal amount entry in sold_units table**/
                                $fundData=array(
                                            "fund_id"=>$fundId,
                                            "sold_amount"=>$amount,
                                            "unit_count"=>$unitCounts,
                                            "investor_id"=>$investorId,
                                            "request_date"=>$requestDate,
                                            "folio_number"=>$folioNumber,
                                            "request_status"=>0,
                                            "withdraw_type"=>$withdrawType,
                                            "batch_id"=>$batchId,
                                            "investor_ip"=>$investorIp,
                                            );
                                $totalWithdrawAmount=$totalWithdrawAmount+$amount;
                                $fundName=$availableWithdrawRow["fund_name"];
                                $data["allWithdrawfundsArray"][]=$fundData;

                                $fundEmailData=array(
                                            "fund_id"=>$fundId,
                                            "sold_amount"=>$amount,
                                            "fund_name"=>$fundName
                                            );
                                $data["allWithdrawfundsEmailData"][]=$fundEmailData; // allWithdrawfundsEmailData variable is used in
                            }
                        }
                    }
                }
            }

            // add all withdrawal funds
            if($isValidAmount==0)
            {
                $result=$this->withdraw_model->addWithdrawalAmount($data);
                if($result)
                {

                    $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
				
                    if (strpos($checkUrl, 'localhost') === false)
                    {
                        // send withdrawal sms
                        if(isset($userId) && !empty($userId))
                        {
                            $resultData=$this->common_model->getUseDetailsByUserId($userId);
                            if($resultData)
                            {
                                $name=$this->encrypt->decode($resultData->username);
                                $phone=$this->encrypt->decode($resultData->phone);
								$email = $resultData->email;
                                $sentSms= false;
                                if(!in_array($investorId,getblockEmailAndSMS(2,2))){								
                                    $sentSms=$this->sendWithdrawAmountSms($name,$phone,$totalWithdrawAmount,$email,$investorId);
                                }
                                if($sentSms)
                                {
									log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Sent sms for withdrawing the amount *****');
                                }
                                else
                                {
									log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Failed to send sms for withdrawing the amount *****');
                                }
                            }
                        }
                    }

                    // get fund type name by fund type id
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $resultsentMail= false;
                    if(!in_array($investorId,getblockEmailAndSMS(2,1))){
                        $resultsentMail=$this->appSendWithdrawFundEmail($data,$totalWithdrawAmount,$fundTypeName,$name,$email,$phone);
                    }
                    if($resultsentMail)
                    {
                        //$this->session->set_flashdata('message', "You have scheduled your ".$fundTypeName." Withdrawal of Rs ".$totalWithdrawAmount." on ".date('M d,Y'));
                        $messageSuccess = "You have scheduled your ".$fundTypeName." Withdrawal of Rs ".$totalWithdrawAmount." on ".date('M d,Y');
                        echo '{"success":"true","msg":"'.$messageSuccess.'"}';
						log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Submitted sold request and sent mail *****');
                    }
                    else
                    {
                        $messageSuccess = "You have scheduled your ".$fundTypeName." Withdrawal of Rs ".$totalWithdrawAmount." on ".date('M d,Y');
                        echo '{"success":"true","msg":"'.$messageSuccess.'"}';
                        // echo '{"success":"true","msg":"Sold request submitted, mail not sent"}';
						log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Submitted sold request but failed to send mail *****');
                    }
                }
                else
                {
                    echo '{"success":"false","msg":"Server error"}';
					log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Sold request failed due to server error *****');
                }
            }
            else
            {
                echo '{"success":"false","msg":"Invalid amount"}';
				log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Sold request failed due to invalid amount *****');
            }
        }
        else
        {
            echo '{"success":"false"}';
			log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByAmount, Message : Sold request failed due to insufficient amount *****');
        }
    }
	
									
    function appAddWithdrawFundsByUnits($json,$fundTypeId,$withdrawType,$batchId,$investorId,$userId)
    {
        if($investorId)
        {
            if(isset($investorId) && !empty($investorId))
            {
                $jsonArray=$json; // requested amount

                /** check available withdraw amount **/

                $resultWithdrwalAmount=$this->appCheckAvailableWithdrwalFunds($fundTypeId,$investorId);
                //print_r($resultWithdrwalAmount);
                if(isset($jsonArray) && !empty($jsonArray))
                {
                    $data["allWithdrawfundsArray"]=array();
                    $isValidUnits=0;
                    $totalWithdrawUnits=0; //required for email info;
                    foreach ($jsonArray as $requestWithdrawRow)
                    {
                        $fundId=$requestWithdrawRow[0];
                        $units=$requestWithdrawRow[1]; //requesated units
                        if(isset($resultWithdrwalAmount) && !empty($resultWithdrwalAmount))
                        {
                            foreach($resultWithdrwalAmount as $availableWithdrawRow)
                            {
                                $fundIdAvailable=$availableWithdrawRow["fund_id"];
                                $unitsAvailable=$availableWithdrawRow["unit_count"];
                                $folioNumber=$availableWithdrawRow["folio_number"];
                                $requestDate=date("Y-m-d h:i:s");
                                $investorIp=$investorId;
                                if($fundIdAvailable==$fundId)
                                {
                                    if($unitsAvailable<$units)
                                    {
                                        $isValidUnits++;
                                    }
                                    else
                                    {
                                        /**  add withdrawal amount entry in sold_units table**/
                                        $fundData=array(
                                                    "fund_id"=>$fundId,
                                                    "unit_count"=>$units,
                                                    "investor_id"=>$investorId,
                                                    "request_date"=>$requestDate,
                                                    "folio_number"=>$folioNumber,
                                                    "request_status"=>0,
                                                    "withdraw_type"=>2,
                                                    "batch_id"=>$batchId,
                                                    "investor_ip"=>$investorIp,
                                                    );
                                        $totalWithdrawUnits=$totalWithdrawUnits+$units;
                                        $fundName=$availableWithdrawRow["fund_name"];
                                        $data["allWithdrawfundsArray"][]=$fundData;

                                        $fundEmailData=array(
                                                    "fund_id"=>$fundId,
                                                    "sold_units"=>$units,
                                                    "fund_name"=>$fundName
                                                    );
                                        $data["allWithdrawfundsEmailData"][]=$fundEmailData; // allWithdrawfundsEmailData variable is used in
                                    }
                                }
                            }
                        }
                    }

                    // add all withdrawal funds
                    if($isValidUnits==0)
                    {
                        $result=$this->withdraw_model->addWithdrawalByUnits($data);
                        if($result)
                        {
                            $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
                            if (strpos($checkUrl, 'localhost') === false)
                            {
                                // send withdrawal sms
                                if(isset($userId) && !empty($userId))
                                {
                                    $userId=$userId;
                                    $resultData=$this->common_model->getUseDetailsByUserId($userId);
                                    if($resultData)
                                    {
                                        $name=$this->encrypt->decode($resultData->username);
                                        $phone=$this->encrypt->decode($resultData->phone);
										$email = $resultData->email;
                                        $sentSms= false;
                                        if(!in_array($investorId,getblockEmailAndSMS(2,2))){
                                            $sentSms=$this->sendWithdrawUnitSms($name,$phone,$totalWithdrawUnits,$email,$investorId);
                                        }
                                        if($sentSms)
                                        {
											log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sent sms for withdrawing the units *****');
                                        }
                                        else
                                        {
											log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Failed to send sms for withdrawing the units *****');
                                        }
                                    }
                                }
                            }

                            // get fund type name by fund type id
                            $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                            $resultsentMail= false;
                            if(!in_array($investorId,getblockEmailAndSMS(2,2))){
                                $resultsentMail=$this->appSendWithdrawFundEmail($data,$totalWithdrawAmount,$fundTypeName,$name,$email,$phone);
                            }
                            if($resultsentMail)
                            {
                                // $this->session->set_flashdata('message',);
                                 $messageSuccess = "You have scheduled your ".$fundTypeName." Withdrawal Units ".$totalWithdrawUnits." on ".date('M d,Y');
                        // echo '{"success":"true","msg":"'.$messageSuccess.'"}';

                                echo '{"success":true,"msg":"'.$messageSuccess.'"}';
								log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request submitted and sent mail *****');
                            }
                            else
                            {
                               $messageSuccess = "You have scheduled your ".$fundTypeName." Withdrawal Units ".$totalWithdrawUnits." on ".date('M d,Y');
                        // echo '{"success":"true","msg":"'.$messageSuccess.'"}';

                                echo '{"success":true,"msg":"'.$messageSuccess.'"}';
								log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request submitted but failed to send mail *****');
                            }
                        }
                        else
                        {
                            echo '{"success":false,"msg":"Server error"}';
							log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request failed due to server error *****');
                        }
                    }
                    else
                    {
                        echo '{"success":false,"msg":"Invalid units"}';
						log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request failed due to invalid units *****');
                    }
                }
                else
                {
                    echo '{"success":false}';
					log_message('info', '***** InvestorId : '.$investorId.', Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Sold request failed due to insufficient units *****');
                }
            }
            else
            {
                echo '{"success":false,"session":"out"}';
				log_message('info', '***** Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Investor id not available in session *****');
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
			log_message('info', '***** Controller : Withdraw, Function : addWithdrawFundsByUnits, Message : Session expired while addWithdrawFundsByUnits *****');
        }
    }
	
		
	    /** check withdraw amount or unit is available or not **/
    function appCheckAvailableWithdrwalFunds($fundTypeId,$investorId)
    {
        /** invest more **/
        // get all purchase funds which is approved by bank. and request status=1
        $resultPurchaseFunds=$this->withdraw_model->getPurchaseFundsReadytoPurchase($fundTypeId,$investorId);

        // get sold funds list
        $resultSoldFunds=$this->withdraw_model->getSoldFunds($fundTypeId,$investorId);

        $data["withdrawFunds"]= array();

        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            foreach ($resultPurchaseFunds as $puchaseRow)
            {
                $fundName=$puchaseRow->scheme_description;
                $minWithDrawalAmount=$puchaseRow->redemption_min_amount;
                $purchaseFundId=$puchaseRow->fund_id;
                $folioNumber=$puchaseRow->folio_number;
                $purchaseUnits=$puchaseRow->unit_count;
                $nav=$puchaseRow->nav;
                $minUnits=$puchaseRow->redemption_min_units;
                /** check count fund is sold or not **/
                $soldCount=0;

                if(isset($resultSoldFunds) && !empty($resultSoldFunds))
                {
                    foreach ($resultSoldFunds as $soldRow)
                    {
                        $soldFundId=$soldRow->fund_id;
                        $soldUnits=$soldRow->unit_count;
                        if($soldFundId==$purchaseFundId)
                        {
                            $balanceUnit=($purchaseUnits-$soldUnits);
                            $soldCount++;
                        }
                    }
                }

                if($soldCount==0)
                {
                    $balanceUnit=$purchaseUnits;
                }

                /** caluculate withdraw amount **/
                $withdrawalAmount=round(($balanceUnit*$nav),2);

                /** add withdraw funds list **/
                $data["withdrawFunds"][]=array(
                    "fund_id"=>$purchaseFundId,
                    "fund_name"=>$fundName,
                    "folio_number"=>$folioNumber,
                    "min_amount"=>$minWithDrawalAmount,
                    "withdrawal_amount"=>$withdrawalAmount,
                    "nav"=>$nav,
                    "redemption_min_units"=>$minUnits,
                    "unit_count"=>$balanceUnit);
            }
            return $data["withdrawFunds"];
        }
    }
	

	function appWithdrawFunds()
    {
        $get = json_decode(file_get_contents("php://input"));
		$investorId = $get->investorId;
        if($investorId)
        {
			$fundTypeId = $get->fundTypeId;
            if($fundTypeId)
            {
                $data = $this->app_loadView($fundTypeId,$investorId);
				$data['success']="true";
				$output = json_encode($data);
				echo $output;
                $data=array("investor_id"=>$investorId,"log_msg"=>"Visited withdraw page");
                addSystemLog($data); // helper function
            }
            else
            {
                echo '{"success":"false"}';
            }
        }
        else
        {
            echo '{"success":"false"}';
        }
    }
	
	function app_loadView($fundTypeId,$investorId)
    {
  //       if($fundTypeId==3)
		// {
		// 	$data["withdrawEligiblityTaxSaving"]=$this->checkWithdrawEligiblityTaxSaving($investorId,3,3);// investor id, 3-tax saving id, 3- year
  //       }
        $resultWithdrwalAmount=$this->appCheckAvailableWithdrwalFunds($fundTypeId,$investorId);
        $data["withdrawFunds"]=$resultWithdrwalAmount;
        $data["fundTypeId"]=$fundTypeId;
		return $data;
    }
	
    function appSendWithdrawFundEmail($data,$totalWithdrawAmount,$fundTypeName,$name,$email,$phone="")
    {
       //print_r($data["allWithdrawfundsEmailData"]);die;
        $email=$email;
        $today = date('d M Y h:i a', time());
        $data["fundTypeName"]=$fundTypeName;
        $data["name"]=$name;
        $data["requestDate"]=date('M d, Y');
        $data["totalWithdrawAmount"]=$totalWithdrawAmount;
        $html=$this->load->view('withdrawal_amount_confirmation_email_view', $data,true);
        $subject="Your request for withdrawal with Investocafe has been scheduled";
		$out = sendEmail($email,$subject,$html);
        $email = "tanish.goswami@investocafe.com";
        $subject = $subject." phone - ".$phone;
        $out = sendEmail($email,$subject,$html);
        return $result;
    }
	
	public function instantWithdrawal()
	{
		$data["fundTypeId"]=$fundTypeId;
        $data['jsFile'] ='withdraw/instant_withdraw.js';
        $data['jsFileExtra'] ='dashboard/sipCalculation.js';
		$this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view('amit_theme/withdraw/instant_withdrawal_view');
        $this->load->view('amit_theme/common/footer',$data);
	}
	
	public function flashMsgForReliance($totalWithdrawAmount)
	{
		$referense_number = $this->uri->segment(4);
		$investorId = $_SESSION['investor_id'];
		$nav = $this->db->query("select nav from fund_history where fund_id = 9227 and is_latest = 1")->row()->nav;
		$units = $totalWithdrawAmount/$nav;
		$folioNumber = $this->db->query("select folio_number from purchased_units where investor_id = ".$investorId." and fund_id = 9227 and folio_number != ''")->row()->folio_number;
		$this->db->insert("batch",['type'=>"withdraw"]);
		$batchId = $this->db->insert_id();
		
		$ip = getenv('HTTP_CLIENT_IP')?:
		getenv('HTTP_X_FORWARDED_FOR')?:
		getenv('HTTP_X_FORWARDED')?:
		getenv('HTTP_FORWARDED_FOR')?:
		getenv('HTTP_FORWARDED')?:
		getenv('REMOTE_ADDR');
		$data = [
			"unit_count" => $units,
			"sold_amount" => $totalWithdrawAmount,
			"date_of_sale" => date("Y-m-d"),
			"investor_id" => $investorId,
			"request_status" => 0,
			"request_date" => date("Y-m-d"),
			"fund_id" => 9227,
			"folio_number" => $folioNumber,
			"withdraw_type" => 1,
			"batch_id" => $batchId,
			"investor_ip" => $ip,
			"trans_upload_status" =>0,
			"api_remarks" => $referense_number
		];
		
		$this->db->insert("sold_units",$data);
		$this->session->set_flashdata('message', "You have scheduled your Reliance Money Manager Fund Withdrawal of Rs ".$totalWithdrawAmount." on ".date('M d,Y'));
		return redirect("purchase/confirmationInvestedFunds/9");
	}
	
	
}
