<?php

Class XirrCron extends CI_Controller{

	function __construct()
  	{
  		parent::__construct();
  		$this->fund = array();
  	    $res = $this->db->query("SELECT fund_id,nav FROM fund_history WHERE is_latest = 1 ");
  	    if($res->num_rows() > 0)
  	    {
  	    	foreach ($res->result() as $key => $value) {
  	    		$this->fund[$value->fund_id] = $value->nav;
  	    	}
  	    }
  	}

	public function index()
	{
		$query = "SELECT * FROM ( SELECT CONCAT('-', SUM(`purchased_amount`)) AS amount, SUM(unit_count) AS real_unit, investor_id, batch_id, purchased_units.fund_id, 'purchase' AS 'state', date_of_purchase AS res_date FROM purchased_units JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id WHERE request_status = 1 AND unit_count > 0.00 AND fund_history.is_latest = 1 AND purchased_units.investor_id = 18 GROUP BY fund_id, batch_id, investor_id UNION SELECT SUM(sold_amount) AS amount, CONCAT('-', SUM(unit_count)) AS real_unit, investor_id, batch_id, fund_id, 'sold' AS 'state', date_of_sale AS res_date FROM sold_units WHERE request_status = 1 AND sold_units.investor_id = 18 GROUP BY fund_id, batch_id, investor_id ) AS a ORDER BY investor_id, batch_id";
		$res = $this->db->query($query);
		
		// $res = $this->db->query("SELECT * FROM ( SELECT CONCAT('-', SUM(`purchased_amount`)) AS amount, SUM(unit_count) AS real_unit, investor_id, batch_id, purchased_units.fund_id, 'purchase' AS 'state', date_of_purchase AS res_date FROM purchased_units JOIN fund_history ON purchased_units.fund_id = fund_history.fund_id WHERE request_status = 1 AND unit_count > 0.00 AND fund_history.is_latest = 1 GROUP BY fund_id, batch_id, investor_id UNION SELECT SUM(sold_amount) AS amount, CONCAT('-',SUM(unit_count)) AS real_unit, investor_id, batch_id, fund_id, 'sold' AS 'state', date_of_sale AS res_date FROM sold_units WHERE request_status = 1 GROUP BY fund_id, batch_id, investor_id ) AS a ORDER BY investor_id, batch_id");
		
		if($res->num_rows() > 0)
		{
			$result = $res->result();
			$data_array = [];
			foreach($result as $result)
			{
				$data_array[$result->investor_id]['amount'][] = $result->amount;
				$wtime = explode(' ', $result->res_date);
                $cdate = explode('-', $wtime[0]);
				$data_array[$result->investor_id]['date'][] = mktime(0,0,0,$cdate[1],$cdate[2],$cdate[0]);
				$data_array[$result->investor_id]['current_statue'][$result->fund_id][] = $result->real_unit;
			}

			echo "<pre>";
			// print_r($data_array[368]);
			$this->calculateXirr($data_array);
		}
	}

	public function calculateXirr($data)
	{
		$big_data_array = [];
		$this->load->helper('financial');
		foreach ($data as $key => $value) {
			$invested_amount = abs(array_sum($value['amount']));
			foreach ($value['current_statue'] as $current_key => $current_value) {
			
				$value['amount'][] =  array_sum($current_value)*$this->fund[$current_key];
				$cdate = explode('-', date("Y-m-d"));
				$value['date'][] = mktime(0,0,0,$cdate[1],$cdate[2],$cdate[0]);;
				
			}			
		    $XIRR  = round(XIRR($value['amount'],$value['date'], 0.1)*100,2);
		    $goal_data = $this->goals($key,$invested_amount);
		    $big_data_array[$key]['current_return'] = $XIRR;
		    $big_data_array[$key]['invested_amount'] = $invested_amount;
		    $big_data_array[$key]['goal_data'] = $goal_data;
		}
		$this->intelligence($big_data_array);
	}

	public function goals($investor_id,$invested_amount)
	{
		echo "<pre>";
		$this->load->helper('financial');
		$res = $this->db->query("SELECT investor_id, goal_timeline, goal_amount, ( SELECT SUM(monthly_saving_amount) FROM goals WHERE investor_id = $investor_id GROUP BY investor_id ) AS total_amount, ( SELECT ( SUM(TIMESTAMPDIFF( MONTH, DATE_FORMAT(goals.ts, '%Y-%m-%d'), '2018-05-30' ) * monthly_saving_amount) ) FROM goals WHERE investor_id = $investor_id GROUP BY investor_id ) AS goal_investment_months_amount, monthly_saving_amount, goal_type.goal_title, goal_type.goal_type_id, DATE_FORMAT(goals.ts, '%Y-%m-%d') AS start_date FROM goals JOIN goal_type ON goals.goal_type_id = goal_type.goal_type_id WHERE goals.investor_id = $investor_id ORDER BY investor_id");
		if($res->num_rows() > 0)
		{
			$data_array = [];
			foreach($res->result() as $result)
			{
				$invetment_months = $this->nb_mois($result->start_date);
				$time_line = $result->goal_timeline;
				$monthly_amount = $result->monthly_saving_amount;
				$goal_amount = $result->goal_amount;
				$present_monthly_investment = $this->getRuningSIP($investor_id);
				$invested_amount_according_to_goal = $invetment_months*$result->monthly_saving_amount;
				$xirr = $this->calculate_gaol_xirr($time_line,$monthly_amount,$goal_amount);
				$investment_for_this_goal = $invested_amount_according_to_goal > 0?round(($invested_amount/$result->goal_investment_months_amount)*$invested_amount_according_to_goal):'Not set';

				$current_investment_for_this_goal_monthly = $result->total_amount > 0?round(($present_monthly_investment/$result->total_amount)*$result->monthly_saving_amount):0;

				$data_array[] = [
								'goal_return' => $xirr,
								'goal_name'   => $result->goal_title,
								'monthly_amount'      => $result->monthly_saving_amount,
								'goal_amount' => $result->goal_amount,
								'goal_investment_start_date' => $result->start_date,
								'total_monthly_goals_amount' => $result->total_amount,
								'total_investment_months' => $time_line,
								'invetment_months' => $invetment_months,
								'invested_amount_according_to_goal'=>$invested_amount_according_to_goal,
								'present_monthly_investment' => $present_monthly_investment,
								'investment_for_this_goal' => $investment_for_this_goal,
								'current_monthly_investment_for_this_goal' => $current_investment_for_this_goal_monthly,
								'Points' => [
								 	$result->monthly_saving_amount<$current_investment_for_this_goal_monthly?'Monthly amount is perfect to reach your goal':'Please hike your monthly investment to amount '.($result->monthly_saving_amount - $current_investment_for_this_goal_monthly).' to reach your '.$result->goal_title,
								 	$invested_amount_according_to_goal<$investment_for_this_goal?'Your current investment going well according to achive your '.$result->goal_title.' goal':'Your goal index lacking your investment you need to invest a lumsum amount of '.($invested_amount_according_to_goal-$investment_for_this_goal)
								 ]
								];
			}
			
			return ($data_array);
		}
		
	}

	public function calculate_gaol_xirr($time_line,$monthly_amount,$goal_amount)
	{
		$array =[];
		$date_array = [];
		$investmentDate=date("2000-01-01");
		for($i=0;$i<$time_line;$i++)
		{
			array_push($array,"-".$monthly_amount);
		    $date = new DateTime($investmentDate);
			$requestDate=$date->format('Y-m-d ').date("h:i:s");
			$time = strtotime($requestDate);
		    $nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));
		    $cdate = explode('-', $nextInvestmentDate);
		    array_push($date_array, mktime(0,0,0,$cdate[1],$cdate[2],$cdate[0]));
		    $investmentDate = $nextInvestmentDate;
		}

		$date = new DateTime($investmentDate);
		$requestDate=$date->format('Y-m-d ').date("h:i:s");
		$time = strtotime($requestDate);
		$nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));
		$cdate = explode('-', $nextInvestmentDate);
		array_push($date_array, mktime(0,0,0,$cdate[1],$cdate[2],$cdate[0]));
		array_push($array,$goal_amount);
		return round(XIRR($array,$date_array, 0.1)*100,2);
	}

	public function intelligence($bigData)
	{
		echo "<pre>";
		print_r($bigData);
		// foreach ($bigData as $key => $value) {
		// 	if($key == 18){
		// 		if($value['goal_data'])
		// 		{
		// 			print_r($value);
		// 		}
		// 	}
		// }
	}

	public function nb_mois($date1)
	{

	    $date1 = strtotime($date1);
		$date2 = strtotime(date("y-m-d"));
		$months = 0;

		while (($date1 = strtotime('+1 MONTH', $date1)) <= $date2)
		    $months++;

		return $months;
	}

	function cal()
	{
		// (total chahiye/chalraha)*particaular jis me chahiye
		// (3200/1600)*500
	}

	public function getRuningSIP($investor_id)
	{
		$res = $this->db->query("SELECT SUM(amount) as amount FROM monthly_investment WHERE investor_id = $investor_id AND `is_stopped_sip` = 0");
		if($res->num_rows > 0){
			return $res->row()->amount;
		}else{
			return 0;
		}
		
	}


}