﻿<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	function checkuser_session()
    {
        if(!isset($_SESSION['investor_id']) && empty($_SESSION['investor_id']))
        {
            return false;
        }
        return true;
    }

    function handleString($string)
    {
        $string = preg_replace("/[\n\r]/","",$string);
        $string = str_replace("'","&#39;","$string");
        $string = str_replace("=","&#61;","$string");
        $string = str_replace("≤","&le;","$string");
        $string = str_replace("≥","&ge;","$string");
        return str_replace('"',"&quot;","$string");
    }
    
    function sendConfirmationEmail($email,$name)
    {
        $today = date('d M Y h:i a', time());
        $data=array();
        $CI =& get_instance();
        $data["name"]=$name;
        $html=$CI->load->view('accountVerificationMail_view', $data,true);
        $CI->email->set_newline("\r\n");
        $CI->email->set_mailtype("html");
        $CI->email->to($email);
        $CI->email->bcc("amitmeena0206@gmail.com");
        $CI->email->from(" Investocafe Assistant<help@investocafe.com>", "Investocafe");
        $CI->email->subject("Account Verification Email From Investocafe");
        $CI->email->message($html);
        $result=$CI->email->send();
        //echo $CI->email->print_debugger();
        return $result;
    }

    function getValue($keyWord)
    {
        $data= array();
        $CI =& get_instance();

        $result=$CI->common_model->getValue($keyWord);
        if($result)
        {
            return $result->value;
        }
        else
        {
            return false;
        }
    }


    function shorten_string($string, $wordsreturned)
    {
      $retval = $string;
      $string = preg_replace('/(?<=\S,)(?=\S)/', ' ', $string);
      $string = str_replace("\n", " ", $string);
      $array = explode(" ", $string);
      if (count($array)<=$wordsreturned)
      {
        $retval = $string;
      }
      else
      {
        array_splice($array, $wordsreturned);
        $retval = implode(" ", $array)." .........";
      }
      return $retval;
    }

    function sendBirthdayEmail($email,$name)
    {
        date_default_timezone_set("Asia/Kolkata");
        $today = date('d M Y h:i a', time());
        $data=array();
        $data["name"]=$name;
        $CI =& get_instance();
        $html=$CI->load->view('birthday_template_view',$data, true);
        $CI->load->library("email");
        $CI->email->set_newline("\r\n");
        $CI->email->set_mailtype("html");
        $CI->email->to($email);
            $CI->email->cc("nikunj17287@gmail.com");
        $CI->email->from("greeting@Investocafe.com", "Investocafe");
        $CI->email->subject("Happy Birthday from Investocafe");
        $CI->email->message($html);
        $result=$CI->email->send();
        //echo $CI->email->print_debugger();
        if($result)
        {
            log_message("info","***** Birthday message sent successfully to investor email - ".$email."*****");
        }
        else
        {
            log_message("info","***** Birthday message sending failed to investor email - ".$email."*****");
        }
        echo $result;
    }

    function sendAnniversaryEmail($email,$name)
    {
        date_default_timezone_set("Asia/Kolkata");
        $today = date('d M Y h:i a', time());
        $data=array();
        $CI =& get_instance();
        $data["name"]=$name;
        $html=$CI->load->view('anniversary_template_view', $data,true);
        $CI->load->library("email");
        $CI->email->set_newline("\r\n");
        $CI->email->set_mailtype("html");
        $CI->email->to($email);
           $CI->email->cc("nikunj17287@gmail.com");
        $CI->email->from("greeting@Investocafe.com", "Investocafe");
        $CI->email->subject("Happy Anniversary from Investocafe");
        $CI->email->message($html);
        $result=$CI->email->send();
        //echo $CI->email->print_debugger();
        if($result)
        {
            log_message("info","***** Anniversary message sent successfully to investor email - ".$email."*****");
        }
        else
        {
            log_message("info","***** Anniversary message sending failed to investor email - ".$email."*****");
        }
        echo $result;
    }

    function addSystemLog($data)
    {
        date_default_timezone_set("Asia/Kolkata");
        $data["date"]=date("Y-m-d H:i:s");
        $CI =& get_instance();
        $CI->common_model->addSystemLog($data);
    }

    function iLog($log,$investorId,$applicationType='Android',$changeFrom='Investor',$changeByID=0)
    {
        date_default_timezone_set("Asia/Kolkata");
        // $data["date"]=date("Y-m-d H:i:s");
        $CI =& get_instance();
        $data = [
            'investor_id' => $investorId,
            'log_msg' => $log,
            'application_type' => $applicationType,
            'change_from' => $changeFrom,
            'change_by_id' => $changeByID,
            'date' => date("Y-m-d H:i:s")
        ];
        $CI->common_model->addSystemLog($data);
    }

    function addActivityLog($activityMsg)
    {
        $data=array("description"=>$activityMsg);
        $CI =& get_instance();
        $CI->common_model->addActivityLog($data);
    }

    function addCronLog($data)
    {
        $CI =& get_instance();
        $CI->common_model->addCronLog($data);
    }

    function makedirs($dirpath, $mode=0777)
    {
        //return is_dir($dirpath) || mkdir($dirpath, $mode, true);
				//$oldMask=umask(002);
		    $status = is_dir($dirpath) || mkdir($dirpath, $mode, true);
		    //umask($oldMask);
		    return $status;

    }

    function changeDateFormat($oldDate){
	 		$arr = explode('/', $oldDate);
	 		return $newDate = $arr[2].'-'.$arr[0].'-'.$arr[1];//yyyy-mm-dd
		}

    function getLatestFolioNumber($amc_code,$investorId)
    {
        $CI =& get_instance();
        $result=$CI->common_model->getLatestFolioNumber($amc_code,$investorId);
        if($result)
        {
            return $result->folio_number;
        }
        else
        {
            return false;
        }
    }
	  function getLatestFolioNumberOld($fundId,$investorId)
    {
        $CI =& get_instance();
        $result=$CI->common_model->getLatestFolioNumberOld($fundId,$investorId);
        if($result)
        {
            return $result->folio_number;
        }
        else
        {
            return false;
        }
    }

	function getToken($userId,$token)
    {
		$CI =& get_instance();
		$result=$CI->common_model->getToken($userId,$token);
		if($result)
		{
				return true;
		}
		else
		{
				return false;
		}
	}

    function addDailyAgenda($action,$date)
    {
        $CI =& get_instance();
        $data=array("action"=>$action,"date"=>$date);
        $result=$CI->common_model->addDailyAgenda($data);
        if($result)
        {
                return true;
        }
        else
        {
                return false;
        }
    }

    function getFundNameByFundId($fundId)
    {
        $CI =& get_instance();
        $CI->db->where('fund_id',$fundId);
        $result=$CI->db->get('funds');
        if($result->num_rows()>0)
        {
            return $result->row()->scheme_description;
        }
        else
        {
            return false;
        }
    }
	
	
	function auto_signout()
    {
        echo "<script > auto_logout() ; </script>" ;
    }

    function get_neear_city($state)
	{
	    $option = array(
	    'Telangana' =>'Warrangal' ,
		'Andhra Pradesh' =>'Anantapur' ,
		'Kerala' =>'Kottayam' ,
		'Karnataka' =>'Mysore' ,
		'Goa' =>'Vasco' ,
		'West Bengal' =>'Siliguri' ,
		'Uttar Pradesh' =>'Allahabad' ,
		'Tamil Nadu' =>'Vellore' ,
		'Madhya Pradesh' =>'Indore' ,
		'Gujarat' =>'Rajkot' ,
		'Delhi' =>'New Delhi' ,
		'Himachal Pradesh' =>'SHIMLA' ,
		'Maharashtra' =>'Amravati' ,
		'Puducherry' =>'Pondicherry' ,
		'Jammu and Kashmir' =>'SRINAGAR' ,
		'Sikkim' =>'Others' ,
		'Assam' =>'Guwahati' ,
		'Manipur' =>'Others' ,
		'Meghalaya' =>'Shillong' ,
		'Rajasthan' =>'Udaipur' ,
		'Punjab' =>'Amritsar' ,
		'Mizoram' =>'Others' ,
		'Andaman and Nicobar Islands' =>'Others' ,
		'Nagaland' =>'Others' ,
		'Tripura' =>'Tiruppur' ,
		'Arunachal Pradesh' =>'Others' ,
		'Bihar' =>'Bhagalpur' ,
		'Haryana' =>'Panipat' ,
		'Others' =>'Others' ,
		'Chandigarh' =>'Chandigarh' ,
		'Jharkhand' =>'Ranchi' ,
		'Uttarakhand' =>'Dehradun' ,
		'Chattisgarh' =>'Bhilai' ,
		'Dadra and Nagar Haveli' =>'Others' ,
		'Odisha' =>'Bhubaneswar' ,
		'Daman and Diu' =>'Others' ,
		'Lakshadweep' =>'Others'  
		 ) ;
		   
		  
		 if(isset($option[$state])){
		 	return $option[$state] ;
		 }else{
		    ""; 
		 }	
	}
	
	
	
    function spliteAndCheckName($name)
    {
        $CI =& get_instance();
        $array = explode(" ",$name);
        $count = count($array);
        $name_index= [];
        if($count == 1)
        {
            $name_index['name_first'] = $array[0];
            $name_index['name_middle'] = "";
            $name_index['name_last'] = "";
        }
        else if($count == 2)
        {
            $name_index['name_first'] = $array[0];
            $name_index['name_middle'] = "";
            $name_index['name_last'] = $array[1];
        }
        else if($count == 3)
        {
            $name_index['name_first'] = $array[0];
            $name_index['name_middle'] = $array[1];
            $name_index['name_last'] = $array[2];
        }
        else if($count == 4)
        {
            $name_index['name_first'] = $array[0];
            $name_index['name_middle'] = $array[1];
            $name_index['name_last'] = $array[2];
        }
        return $name_index;
    }

    function splitlatter($name,$value)
    {
        $CI =& get_instance();
        $str = "";
        if($name)
        {
            $name=strtoupper($name);
            
            $investor_first_name = str_split($name);
            if(isset($investor_first_name ))
            {
                $i =$value;
                foreach($investor_first_name as $investor_first_name)
                {
                    $i--;
                 $str .= '<td style="width: 18px;border: 1px solid #333; height: 12px;float: left;">'.$investor_first_name.'</td>';
                }
            } 
            for($j=1;$j<=$i;$j++)
            {

                $str .='<td style="width: 18px;border: 1px solid #333; height: 12px;float: left;"></td>';
            } 

            echo $str;
        }
        else
        {
            for($j=1;$j<=$value;$j++)
            {

                $str .='<td style="width: 18px;border: 1px solid #333; height: 12px;float: left;"></td>';
            }
            echo $str;
        }
    }

	function splitlatterNon($name,$value)
    {
        $CI =& get_instance();
        $str = "";
        if($name)
        {
            $name=strtoupper($name);
            
            $investor_first_name = str_split($name);
            if(isset($investor_first_name ))
            {
                $i =$value;
                foreach($investor_first_name as $investor_first_name)
                {
                    $i--;
                 $str .= '<td align="center" style="width:20px;height:18px;border: 1px solid #CFCACA;border-top:none;float: left;font-size:8px;padding:3px">'.$investor_first_name.'</td>';
                }
            } 
            for($j=1;$j<=$i;$j++)
            {

                $str .='<td style="width:20px;height:18px;border: 1px solid #CFCACA;border-top:none;float: left;"></td>';
            } 

            echo $str;
        }
        else
        {
            for($j=1;$j<=$value;$j++)
            {

                $str .='<td style="width:20px;height:18px;border: 1px solid #CFCACA;border-top:none;float: left;"></td>';
            }
            echo $str;
        }
    }
	
	function splitlatterFatca($name,$value)
    {
        $CI =& get_instance();
        $str = "";
        if($name)
        {
            $name=strtoupper($name);
            
            $investor_first_name = str_split($name);
            if(isset($investor_first_name ))
            {
                $i =$value;
                foreach($investor_first_name as $investor_first_name)
                {
                    $i--;
                 $str .= '<td align="center" style="width: 18px;border: 1px solid #333; height: 12px;float: left;font-size:8px">'.$investor_first_name.'</td>';
                }
            } 
            for($j=1;$j<=$i;$j++)
            {

                $str .='<td style="width: 18px;border: 1px solid #333; height: 12px;float: left;"></td>';
            } 

            echo $str;
        }
        else
        {
            for($j=1;$j<=$value;$j++)
            {

                $str .='<td style="width: 18px;border: 1px solid #333; height: 12px;float: left;"></td>';
            }
            echo $str;
        }
    }
	
	function splitlatterCamsFatca($name,$value)
    {
        $CI =& get_instance();
        $str = "";
        if($name)
        {
            $name=strtoupper($name);
            
            $investor_first_name = str_split($name);
            if(isset($investor_first_name ))
            {
                $i =$value;
                foreach($investor_first_name as $investor_first_name)
                {
                    $i--;
                 $str .= '<td align="center"  style="width: 50px;border: 1px solid #333; height: 45px;float: left;">'.$investor_first_name.'</td>';
                }
            } 
            for($j=1;$j<=$i;$j++)
            {

                $str .='<td style="width: 50px;border: 1px solid #333; height: 45px;float: left;"></td>';
            } 

            echo $str;
        }
        else
        {
            for($j=1;$j<=$value;$j++)
            {

                $str .='<td style="width: 50px;border: 1px solid #333; height: 45px;float: left;"></td>';
            }
            echo $str;
        }
    }
	
    function checkUncheck($var,$condition)
    {
        if($var==$condition)
        {
            echo '<span style="font-size:14px">&#9745;</span>';
        }
        else
        {
            echo '<span style="font-size:14px">&#9744;</span>';
        }
    }
	
	function getStateNameFromPin($pin)
	{
		$twoDigit = substr($pin,0,2);
		$threeDigit = substr($pin,0,3);
		echo $twoDigit;
	}

	function getCurrentRelianceAmount($folio_number)
	{
		$CI =& get_instance();
		$CI->load->config('config_karvy');
		$arncode = $CI->config->item('arn_code');
		$branch  = $CI->config->item('user_code');
		$apikey  = "32557515-5995-4b35-f3f3-f9518482e527";
		$sendData = "";
		$sendData .="acno=".$folio_number."&";
		$sendData .="scheme=LP&";
		$sendData .="plan=IG&";
		$sendData .="arncode=".$arncode."&";
		$sendData .="branch=".$branch."&";
		$sendData .="proxybranch=&";
		$sendData .="deviceid=PARTNERAPI&";
		$sendData .="appVersion=1.0.1&";
		$sendData .="appName=INVESTOCAFE&";
		$sendData .="apikey=".$apikey."";
		
		$url = $CI->config->item('redemption_scheme_details');
		$responce = sendInfoRel($sendData,$url);
		
		if ($responce) {
			return ($responce->FreeAmt);
		}
		return ('');
	}

    function getCurrentRelianceAmountTest($folio_number)
    {
        $CI =& get_instance();
        $CI->load->config('config_karvy');
        $arncode = $CI->config->item('arn_code');
        $branch  = $CI->config->item('user_code');
        $apikey  = "32557515-5995-4b35-f3f3-f9518482e527";
        $sendData = "";
        $sendData .="acno=".$folio_number."&";
        $sendData .="scheme=LP&";
        $sendData .="plan=IG&";
        $sendData .="arncode=".$arncode."&";
        $sendData .="branch=".$branch."&";
        $sendData .="proxybranch=&";
        $sendData .="deviceid=PARTNERAPI&";
        $sendData .="appVersion=1.0.1&";
        $sendData .="appName=INVESTOCAFE&";
        $sendData .="apikey=".$apikey."";
        
        $url = $CI->config->item('redemption_scheme_details');
        $responce = sendInfoRel($sendData,$url);
        
        if ($responce) {
           
            return ($responce);
        }
        return ('');
    }

	function sendInfoRel($data,$url)
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_PORT , 443);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		$returnData = curl_exec($ch);
		curl_close($ch);
		return json_decode($returnData);
	}

 	// this is function for add steps in db
	function insertNewState($name,$phone,$email,$investor_id,$token)
	{
    		$CI =& get_instance();
    		$CI->load->model('refer_model/referals_model');
    		$CI->referals_model->getInfoOfRegistration($name,$phone,$email,$investor_id,$token);
	}

	function relianceSmallCap($fund_id,$investor_id)
    {
        if($fund_id == 9240 and $investor_id)
        {
            $CI =& get_instance();
            $res = $CI->db->query("SELECT purchased_units.purchased_units_id,monthly_investment.sip_start_date FROM purchased_units JOIN monthly_investment_mapping ON purchased_units.purchased_units_id = monthly_investment_mapping.purchased_units_id JOIN monthly_investment ON monthly_investment.monthly_investment_id = monthly_investment_mapping.monthly_investment_id WHERE purchased_units.fund_id = 9240 AND purchased_units.investor_id = $investor_id AND purchased_units.is_first_purchase = 1 AND purchased_units.is_monthly_sip = 1");
            if($res->num_rows() > 0)
            {
                $oldDate = explode(' ', $res->row()->sip_start_date);
                $arr = explode('-', $oldDate[0]);
                $newDate = $arr[1].'/'.$arr[2].'/'.$arr[0];//yyyy/mm/dd
                return  [
                    "SUB_TRXN_T" => 'S',
                    "SIP_RFNO"   => '1'.$res->row()->purchased_units_id,
                    "SIP_RGDT"   => $newDate
                ];
            }
            else
            {
                return  [
                    "SUB_TRXN_T" => 'Normal',
                    "SIP_RFNO"   => '',
                    "SIP_RGDT"   => ''
                ];
            }
        }
        else if(($fund_id == 9247 || $fund_id == 9248) and $investor_id)
        {
            $CI =& get_instance();
            $res = $CI->db->query("SELECT purchased_units.purchased_units_id,monthly_investment.sip_start_date FROM purchased_units JOIN monthly_investment_mapping ON purchased_units.purchased_units_id = monthly_investment_mapping.purchased_units_id JOIN monthly_investment ON monthly_investment.monthly_investment_id = monthly_investment_mapping.monthly_investment_id WHERE purchased_units.fund_id = $fund_id AND purchased_units.investor_id = $investor_id AND purchased_units.is_first_purchase = 1 AND purchased_units.is_monthly_sip = 1");

            if($res->num_rows() > 0)
            {
                $oldDate = explode(' ', $res->row()->sip_start_date);
                $arr = explode('-', $oldDate[0]);
                $newDate = $arr[1].'/'.$arr[2].'/'.$arr[0];//yyyy/mm/dd
                return  [
                    "SUB_TRXN_T" => 'I',
                    "SIP_RFNO"   => '1'.$res->row()->purchased_units_id,
                    "SIP_RGDT"   => $newDate
                ];
            }
            else
            {
                return  [
                    "SUB_TRXN_T" => 'Normal',
                    "SIP_RFNO"   => '',
                    "SIP_RGDT"   => ''
                ];
            }
        }
        else
        {
            return  [
                "SUB_TRXN_T" => 'Normal',
                "SIP_RFNO"   => '',
                "SIP_RGDT"   => ''
            ];
        }
    }

    function check_kyc_detail($investor_id)
    {
        $CI =& get_instance();
        return $CI->common_model->check_kyc_detail($investor_id);
    }

    function check_mandat_detail($investor_id)
    {
        $CI =& get_instance();
        return $CI->common_model->check_mandat_detail($investor_id);
    }

    function investor_detail($investor_id)
    {
        $CI =& get_instance();
        return $CI->common_model->get_user_all_detail($investor_id);
    }


    function notificationAlert($title='no title',$msg='no msg',$investor_id=null){
        $CI =& get_instance();
        $CI->common_model->add_new_not($title,$msg,$investor_id);
    }
    

	    function profile_img($employee_id)
    {
        $CI =& get_instance();
        $res = $CI->db->query("SELECT emp_profile.profile_path, users.username FROM `emp_profile` JOIN users ON users.id = emp_profile.user_id WHERE `user_id` = $employee_id ORDER BY `emp_profile_id` DESC LIMIT 0, 1");
        if($res->num_rows() > 0){
            return [$res->row()->profile_path,$res->row()->username];
        }else{
            return ['',''];
        }
    }


    function getblockEmailAndSMS($module_id,$type)
    {

        $CI =& get_instance();
        $CI->load->model('send_email');
        return $CI->send_email->send($module_id,$type);
    }

	function getUrl()
    {
        return base_url('assets/icafe_assets/')."/";
    }

    // blog helper

    function getTags($blog_id)
    {
        $CI =& get_instance();
        $CI->load->model('blogs/blog_model','blog_model');
        $res = $CI->blog_model->get_tags_for_helper($blog_id);
        if($res){
            return $res;
        }else{
            return false;
        }
    }

    function get_reply_comment($parent_id)
    {
        $CI =& get_instance();
        $CI->load->model('blogs/blog_model','blog_model');
        $res = $CI->blog_model->get_reply_comments($parent_id);
        if($res){
            return $res;
        }else{
            return false;
        }
    }


    function traking_data($investor_id,$activity_id)
    {
        $CI =& get_instance();
        $CI->db->insert('traking_table',[
            'monthly_investment_id' => $investor_id,
            'activity_id' => $activity_id
        ]);
    }

    function getEURN($purchased_units_id)
    {
        $CI =& get_instance();
        $res = $CI->db->query("select agent_id from investor WHERE investor_id = (SELECT investor_id FROM purchased_units WHERE purchased_units_id = $purchased_units_id)");
        if($res->num_rows() > 0){
            if($res->row()->agent_id== 3927){
                return 'E325658';
            }else{
               return 'E145355'; 
            }
        }else{
            return 'E145355';
        }
    }


    function sendPushNotification($title,$body,$token,$priority,$type,$blog_id)
    {
        $url = "https://fcm.googleapis.com/fcm/send";
        $token = $token;
        $serverKey = 'AAAAzIuyOPo:APA91bHQF0ZP3CzHnSYIZ6OZNMyaNyxiqAfBA0kDa6ksRVm2fVDB5uVG4gm72NxEh5s4dvJdVdRLtx3Fappr2orFtNiN_JtWfGmAewlgjOk8D14y5pAz4tzf58OUCReZn2jVJ-MNmDbE';
        $title = $title;
        $body = $body;
        if($type==1){
            $data = ['type'=>$type,'msgHeader'=>$title,'discription'=>$body];
        }elseif ($type==2) {
            $data = ['type'=>$type,'blog_id'=>18];
            # code...
        }elseif ($type==3) {
            $data = ['type'=>$type,'url'=>'https://youtu.be/Khan_bSGbSs'];
            # code...
        }else{
            $data = [];
        }
        $notification = array('title' =>$title , 'text' => $body, 'sound' => 'default', 'badge' => '1');
        $arrayToSend = array('to' => $token, 'notification' => $notification,'priority'=>$priority , 'data'=> $data);
        $json = json_encode($arrayToSend);
        $headers = array();
        $headers[] = 'Content-Type: application/json';
        $headers[] = 'Authorization: key='. $serverKey;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST,
        "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
        curl_setopt($ch, CURLOPT_HTTPHEADER,$headers);
        //Send the request
        $response = curl_exec($ch);
        //Close request
        if ($response === FALSE) {
        die('FCM Send Error: ' . curl_error($ch));
        }
        curl_close($ch);
    }

    function encode($data)
    {
        $CI =& get_instance();
        $CI->load->library('encrypt');
        return $CI->encrypt->encode($data);
    }

    function decode($data)
    {
        $CI =& get_instance();
        $CI->load->library('encrypt');
        return $CI->encrypt->decode($data);
    }


    function response($data=[],$response_code=200)
    {
        $CI =& get_instance();
        $CI->output->
        set_status_header($response_code)->
        set_content_type('application/json')->
        set_output(json_encode(
            [
                "status"=>$response_code,
                "data" =>$data
            ]
        ));
        // return '{"status":200,"data":{"login_token":""}}';
    }

    function errorResponse($error=[],$response_code=200)
    {
        $CI =& get_instance();
        $CI->output->
        set_status_header($response_code)->
        set_content_type('application/json')->
        set_output(json_encode(
            [
                "status"=>$response_code,
                "errors" =>$error
            ]
        ));
    }

    function methodCheck()
    {
        $CI =& get_instance();
        return $CI->input->server('REQUEST_METHOD');
    }

    function checkToken(){
        if(!isset(apache_request_headers()['Token'])){
            return false;
        }else{
            $CI =& get_instance();
            $token = apache_request_headers()['Token'];
            $res = $CI->db->WHERE(['token'=>$token,'is_active'=>1])->get('partner');
            if($res->num_rows() > 0){
                return $res->row();
            }else{
                return false;
            }
        }
    }

    function gettxnacbank($txnno)
    {
        $CI =& get_instance();
        $res = $CI->db->query("SELECT `account_number`, bank_master.bank_name FROM bank_details JOIN bank_master ON bank_master.bank_master_id = bank_details.bank_master_id JOIN purchased_units ON purchased_units.investor_id = bank_details.investor_id WHERE purchased_units.purchased_units_id = $txnno");
        if($res->num_rows() > 0){
            $data = $res->row();
            return [
                $data->account_number,
                $data->bank_name
            ];
        }else{
            return [
                "",
                ""
            ];
        }
    }

    function getMandateAMT()
    {
         $CI =& get_instance();
         
         $res = $CI->db->query("SELECT * FROM `setting` WHERE setting.keyword = 'MANDATE_AMT'");
        if($res->num_rows() > 0){
            $data = $res->row();
            return $data->value;
        }else{
            return 50000.00;
        }
    }