<?php

class api_edit_profile_model extends CI_Model{
	
	public function get_nominee_detail($investor_id)
	{
		$res = $this->db->query("SELECT `nominee_details_id`,`name`,`relation_with_investor`,`date_of_birth`,`guardian_name`,`relation_with_guardian`,`address`,`pin_code`,`percentage`,status FROM nominee_details WHERE investor_id = $investor_id AND status <2");
		if($res->num_rows() > 0){
			return $res->result_array();
		}else{
			return false;
		}
	}

	public function getUserInfo($investor_id)
	{
		$res = $this->db->query("SELECT investor.pan, investor.address, investor.address_2, investor.original_city, state.state_name, 'India' as country, investor.pincode FROM investor JOIN state on state.id = investor.state_id WHERE investor_id = $investor_id");
		if($res->num_rows() > 0){
			return $res->row();
		}else{
			return false;
		}
	}

	public function getBankDetail($investor_id)
	{
		$res = $this->db->query("SELECT `account_holder_name`,`account_number`,`account_type_id`,`ifsc_code`,`branch_city`,`branch_state`,`branch_name`,`bank_master_id`,`upi_id` FROM bank_details WHERE investor_id = $investor_id");
		if($res->num_rows() >0){
			$data = $res->row();
			$data->account_holder_name = decode($data->account_holder_name);
			$data->account_number = decode($data->account_number);
			return $data;
		}else{
			return false;
		}
	}

	public function getBankmaster()
	{
		$res = $this->db->query("SELECT `bank_master_id`,`bank_name` FROM bank_master WHERE STATUS = 1");
		if($res->num_rows() >0){
			return $res->result();
		}else{
			return false;
		}
	}

	public function getBankType()
	{
		$res = $this->db->query("SELECT account_type_id,account_type FROM bank_account_type WHERE `account_type_id` in(1,2)");
		if($res->num_rows() >0){
			return $res->result();
		}else{
			return false;
		}
	}

	public function insertBankDetails($data)
    {
        $this->db->insert("change_bank", $data);
        if ($this->db->affected_rows() > 0){
            return $this->db->insert_id();
        }else{
            return false;
        }
    }

    public function getUserData($userId)
    {
        $sql = "select investor.address, investor.pincode, city.location_name, state.state_name, investor.pan, users.username, users.email, users.phone, investor_status.is_investor_registered_date from users
        inner join investor
        on users.id = investor.login_id
        inner join investor_status
        on investor.investor_id = investor_status.investor_id
        inner join city
        on investor.city_id = city.id
        inner join state
        on investor.state_id = state.id
        where users.id = $userId";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0){
            return $query->row();
        }else{
            return false;
        }
    }

    public function getBankDetails($userId)
    {
        $sql="select bank_details.*, bank_account_type.account_type,bank_details.ifsc_code, bank_master.bank_name,investor.investor_type_id from bank_details
        inner join bank_account_type
        on bank_account_type.account_type_id = bank_details.account_type_id
        inner JOIN bank_master
        on bank_details.bank_master_id = bank_master.bank_master_id
        inner join investor
        on bank_details.investor_id = investor.investor_id
        inner join users
        on investor.login_id = users.id
        where users.id = $userId";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0){
            return $query->row();
        }else{
            return false;
        }
    }

    public function getAddressDetail($investor_id)
    {
    	$res = $this->db->query("SELECT investor.pincode, investor.address, investor.address_2, investor.state_id, investor.original_city FROM investor WHERE investor_id = $investor_id");
    	if($res->num_rows() >0){
    		return $res->row();
    	}else{
    		return false;
    	}
    }

    public function getStateList()
    {
    	$res = $this->db->query("SELECT `id` as state_id,`state_name` FROM `state` WHERE STATUS = 1");
    	if($res->num_rows() > 0){
    		return $res->result();
    	}else{
    		return false;
    	}
    }

    public function getCityId($city_name,$state_id)
    {
    	$res = $this->db->query("SELECT `id`,`location_name` FROM `city` WHERE `location_name` = '".$city_name."'");
    	if($res->num_rows() > 0){
    		return $res->row()->id;
    	}else{
    		$res = $this->db->query("SELECT `state_name` FROM state WHERE `id` = $state_id");
    		if($res->num_rows() > 0){
    			$near_by_city = get_neear_city(ucfirst($res->row()->state_name));
    			if($near_by_city){
    				$res = $this->db->query("SELECT `id`,`location_name` FROM `city` WHERE `location_name` = '".$near_by_city."'");
    				if($res->num_rows() > 0){
    					return $res->row()->id;
    				}else{
    					return 210;
    				}
    			}else{
    				return 210;
    			}
    		}else{
    			return false;
    		}
    	}
    }

    public function insertCommunicationAddress($data)
    {
        $this->db->insert("change_address", $data);
        if ($this->db->affected_rows() > 0){
            return $this->db->insert_id();
        }else{
            return false;
        }
    }

  	public function checkEmail($email,$user_id)
  	{
  		$res = $this->db->query('SELECT * FROM users WHERE email = "'.$email.'" AND id != '.$user_id);
  		if($res->num_rows() >0){
  			return false;
  		}else{
  			return true;
  		}
  	}

    public function addInvestorNomineeDetails($data)
    {
        if(isset($data['nominee_details_id']) && $data['nominee_details_id'] != 0){
            $nominee_details_id = $data['nominee_details_id'];
            unset($data['nominee_details_id']);
            $data['status']=0;
            // echo "<pre>";
            // print_r($data);
            // exit;
            $this->db->where('nominee_details_id',$nominee_details_id)->update('nominee_details',$data);
            if($this->db->affected_rows() > 0){
                return $nominee_details_id;
            }else{
                return false;
            }
        }else{
            $data['status']=0;
            $res = $this->db->insert("nominee_details",$data);
            if($res) {
                return $this->db->insert_id();
            }else {
                return false;
            }
        }
    }

    public function getPersentageOfNominee($investor_id)
    {
        $res = $this->db->query("SELECT SUM(`percentage`) as percentage,count(*) as nominee_count FROM `nominee_details` WHERE investor_id = '".$investor_id."' AND status < 2 group BY investor_id");
        if($res->num_rows() > 0){
            return [(100 - $res->row()->percentage),$res->row()->nominee_count];
        }else{
            return [100,0];
        }
    }
}