<?php

class Api_purchase_model extends CI_Controller{

	public function getFundsByFundId($fund_type_id,$plan_option="Growth"){
		$noOfSuggestedFunds=getValue("no_of_suggested_funds");
		$res = $this->db->query("SELECT `fund_name`,`fund_id`,`min_purchase_amt`,`purchase_in_multiple_of`,`redemption_min_amount`,`redemption_in_multiple_of`,`SIP_min_amount`,`SIP_in_multiple_of`,`partner_fund_id` FROM funds WHERE fund_type_id = $fund_type_id AND   plan_option='".$plan_option."' and pur_allow = 1 ORDER BY `funds`.`priority` ASC, `internal_code` ASC, `plan_option` DESC LIMIT $noOfSuggestedFunds");
		// echo $this->db->last_query();
		// exit;
		if($res->num_rows() > 0){
			return $res->result();
		}else{
			return [];
		}
	}

	public function getFundTypeName($fund_type_id){
		$res = $this->db->WHERE('fund_type_id',$fund_type_id)->get('fund_type');
		if($res->num_rows() > 0){
			return $res->row()->name;
		}
	}

	public function purchasTAndC()
	{
		return "I have read and understood the terms and contents of Offer Documents* of each scheme available by clicking on the scheme name above. I hereby agree to abide by the terms, conditions, rules and regulations of the relevant Scheme(s). I have understood the details of the Scheme(s) and I have not received nor been induced by any rebate or gifts, directly or indirectly, in making this investment. Investocafe has disclosed to me/us all the commissions, receivable by Investocafe.";
	}

	public function getInvestorBankAccount($investor_id,$purchase_type)
	{
		$res = $this->db->query("SELECT bank_master.bank_name, bank_details.account_number FROM bank_details JOIN bank_master ON bank_details.bank_master_id = bank_master.bank_master_id WHERE investor_id = $investor_id");
		if($res->num_rows() > 0){
			if($purchase_type==1){
				return "On confirmation, your bank account (Bank - ".$res->row()->bank_name." Account Number XXXXXXXXX".substr(decode($res->row()->account_number), -4) .") will be debited for the above amount using the bank mandate provided earlier by you.";
			}else if($purchase_type==2){
				return "On confirmation, your bank account (Bank - ".$res->row()->bank_name." Account Number XXXXXXXXX".substr(decode($res->row()->account_number), -4) .") will be debited for the above amount using netbanking.";
			}else if($purchase_type==3){
				return "On confirmation, your bank account (Bank - ".$res->row()->bank_name." Account Number XXXXXXXXX".substr(decode($res->row()->account_number), -4) .") will be debited for the above amount using UPI.";
			}
		}else{
			return false;
		}
	}

	public function selfDeclearation()
	{
		return ["self_declaration" => "I am not using a third-party bank account to fund mutual fund investments.",
	    "self_declaration_more" => "As per the SEBI guidelines Distributors are asked to ensure that investments in mutual funds are not funded by third party accounts, the exception to this is only be permitted in case of minor's account where parents are investing from their bank accounts."];
	}

	public function getFund($fund_id,$plan_option="Growth"){
		$noOfSuggestedFunds=getValue("no_of_suggested_funds");
		$res = $this->db->query("SELECT `fund_name`, `funds`.`fund_id`, `min_purchase_amt`, `purchase_in_multiple_of`, `redemption_min_amount`, `redemption_in_multiple_of`, `SIP_min_amount`, `SIP_in_multiple_of`, `partner_fund_id`, `AMC_code`, `fund_bank_details`.atom_product_id FROM funds JOIN fund_bank_details ON fund_bank_details.fund_id = funds.fund_id WHERE funds.fund_id = $fund_id AND plan_option = '".$plan_option."' ORDER BY `funds`.`priority` ASC,`internal_code` ASC, `plan_option` DESC LIMIT $noOfSuggestedFunds");
		// echo $this->db->last_query();
		// exit;
		if($res->num_rows() > 0){
			return $res->row();
		}else{
			return false;
		}
	}

	public function createNewPurchaseBatchId($type)
    {
        $this->db->insert("batch",array("type"=>"$type","ts"=>date("Y-m-d h:i:s")));
        if ($this->db->affected_rows() > 0) {
            return  $this->db->insert_id();
        } else {
            return false;
        }
    }

    public function createNewApiBatchId($apiTypeId)
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="select * from api_batch
        where DATE_FORMAT(`api_batch`.`api_batch_date`,'%Y-%m-%d')='$todaysDate'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
            return  $query->row()->api_batch_id;
        }
        else
        {
            $data=array("api_type_id"=>$apiTypeId,"api_batch_date"=>$todaysDate);
            $this->db->insert("api_batch",$data);
            if ($this->db->affected_rows() > 0)
            {
                return  $this->db->insert_id();
            }
            else
            {
                return false;
            }
        }
    }

    public function addSipMonthlyInvestmentFunds($data)
    {
        $this->db->insert("monthly_investment",$data);
        if($this->db->affected_rows()>0){
            return  $this->db->insert_id();
        }else{
            return false;
        }
    }

    public function addPurchaseFunds($data)
    {
        $res = $this->db->insert("purchased_units",$data);
        if($res) {
            $insert_id = $this->db->insert_id();
            // echo $insert_id;
            $this->insertMsgInToDB($data);
            return  $insert_id;
        }else{
            return false;
        }
    }

    public function insertMsgInToDB($data)
    {
        $investorId = $data['investor_id'];
        $res = investor_detail($investorId);
        if($res){
            $amount = $data['purchased_amount'];
            $type = $data['investment_plan_type'];
            $requestDate =  $data['request_date'];
            $msg = $this->encrypt->decode($res->username)." Purchase amount of $amount in $type request date - $requestDate email - ".$res->email." phone ".$this->encrypt->decode($res->phone);
            notificationAlert('Purchase',$msg,$investorId);
        }
    }

    public function addMonthlyInvestmentMappingData($data)
    {
        $this->db->insert("monthly_investment_mapping",$data);
        if($this->db->affected_rows()>0) {
            return  true;
        } else {
            return false;
        }
    }

    public function getInvestorBankAndPanDetail($invId)
    {
        $sql="SELECT `bank_details`.* ,bank_account_type.account_type,
        bank_master.bank_name, bank_master.atom_code
        FROM bank_details,bank_account_type,bank_master
        WHERE bank_details.account_type_id=bank_account_type.account_type_id
        and bank_details.bank_master_id=bank_master.bank_master_id
        and bank_details.investor_id='$invId'";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0){
            return $query->row();
        }else{
            return false;
        }
    }

    public function insertTransactionStartData($netbankingData)
    {
      $data['investor_id'] = $netbankingData['investorId'];
      $data['amt'] = $netbankingData['totalAmount'];
      $data['prod_str'] = $netbankingData['prodStr'];
      $data['purchase_batch_id'] = $netbankingData['batchId'];  	
      $this->db->insert("netbanking_details",$data);
      if($this->db->affected_rows()>0) {
          return  $this->db->insert_id();
      }else {
          return false;
      }
    }
}