<?php

class api_withdraw_model extends CI_Model{

	public function getFreeFunds($fund_type_id,$investor_id)
	{
		$fund_cofig = $this->db->query("SELECT `fund_id`, `fund_name`, `AMC_code`, red_allow, fund_type_id FROM `funds` WHERE fund_type_id = $fund_type_id");
		$funds = [];
		if($fund_cofig->num_rows() > 0){
			foreach($fund_cofig->result() as $fConfig){
				// print_r($fConfig);
				$fund_id = $fConfig->fund_id;
				$limit_date = date("Y-m-d", strtotime("-".$fConfig->red_allow." months"));
				$res = $this->db->query("SELECT SUM(unit_count) as purchase_units, (SELECT SUM(sold_units.unit_count) FROM sold_units WHERE sold_units.request_status = 1 AND sold_units.fund_id = purchased_units.fund_id AND sold_units.investor_id = purchased_units.investor_id) as sold_units, purchased_units.fund_id, purchased_units.folio_number, fund_history.nav, funds.fund_name, funds.redemption_min_amount, funds.redemption_in_multiple_of FROM purchased_units JOIN fund_history ON fund_history.fund_id = purchased_units.fund_id JOIN funds ON purchased_units.fund_id = funds.fund_id WHERE fund_history.is_latest = 1 AND purchased_units.`request_status` = 1 AND funds.fund_id = $fund_id AND purchased_units.investor_id = $investor_id  AND purchased_units.date_of_purchase < '".$limit_date."' GROUP BY purchased_units.investor_id");
				if($res->num_rows() >0){
					$fund_data = $res->row();
					if($fund_data->sold_units > 0){
						$free_units = $fund_data->purchase_units - $fund_data->sold_units;
					}else{
						$free_units = $fund_data->purchase_units;
					}
					$free_units_current_value = $free_units * $fund_data->nav;
					$funds[] =(object) [
						"free_units" => $free_units,
						"free_units_current_value" => $free_units_current_value,
						"fund_id" => $fund_data->fund_id,
						"folio_number" => $fund_data->folio_number,
						"fund_name" => $fund_data->fund_name,
						"redemption_min_amount" => $fund_data->redemption_min_amount,
						"redemption_in_multiple_of" => $fund_data->redemption_in_multiple_of,
						"current_nav" => $fund_data->nav
					];
				}
			}
			if(count($funds) > 0){
				return $funds;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}


	public function validateFund($fund_id,$investor_id)
	{
	    $fund_cofig = $this->db->query("SELECT `fund_id`, `fund_name`, `AMC_code`, red_allow, fund_type_id FROM `funds` WHERE fund_id = $fund_id");
	    if($fund_cofig->num_rows() > 0){
	    	$fConfig = $fund_cofig->row();
			$fund_id = $fConfig->fund_id;
			$limit_date = date("Y-m-d", strtotime("-".$fConfig->red_allow." months"));
			$res = $this->db->query("SELECT SUM(unit_count) as purchase_units, (SELECT SUM(sold_units.unit_count) FROM sold_units WHERE sold_units.request_status = 1 AND sold_units.fund_id = purchased_units.fund_id AND sold_units.investor_id = purchased_units.investor_id) as sold_units, purchased_units.fund_id, purchased_units.folio_number, fund_history.nav, funds.fund_name, funds.redemption_min_amount, funds.redemption_in_multiple_of FROM purchased_units JOIN fund_history ON fund_history.fund_id = purchased_units.fund_id JOIN funds ON purchased_units.fund_id = funds.fund_id WHERE fund_history.is_latest = 1 AND purchased_units.`request_status` = 1 AND funds.fund_id = $fund_id AND purchased_units.investor_id = $investor_id  AND purchased_units.date_of_purchase < '".$limit_date."' GROUP BY purchased_units.investor_id");

			if($res->num_rows() >0){
				$fund_data = $res->row();
				if($fund_data->sold_units > 0){
				$free_units = $fund_data->purchase_units - $fund_data->sold_units;
				}else{
				$free_units = $fund_data->purchase_units;
				}
				$free_units_current_value = $free_units * $fund_data->nav;
				$funds = (object) [
					"free_units" => $free_units,
					"free_units_current_value" => $free_units_current_value,
					"fund_id" => $fund_data->fund_id,
					"folio_number" => $fund_data->folio_number,
					"fund_name" => $fund_data->fund_name,
					"redemption_min_amount" => $fund_data->redemption_min_amount,
					"redemption_in_multiple_of" => $fund_data->redemption_in_multiple_of,
					"current_nav" => $fund_data->nav
					];
				return $funds;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}


	public function createNewPurchaseBatchId($type)
    {
        $this->db->insert("batch",array("type"=>"$type","ts"=>date("Y-m-d h:i:s")));
        if ($this->db->affected_rows() > 0) {
            return  $this->db->insert_id();
        }else {
            return false;
        }
    }

    public function insertSoldUnits($data)
    {
    	return $this->db->insert('sold_units',$data);
    }
}