<?php

class api_registration_model extends CI_Model{

	public function get_basic_registration(){
		$res = $this->db->select('investor_type_id,investor_type')->where('api_status',1)->get('investor_type');
		if($res->num_rows() > 0){
			return $res->result();
		}else{
			return false;
		}
	}

	public function addInvestor($data)
    {
        $this->db->insert("investor",$data);
        if($this->db->affected_rows()>0) {
            $investorId =  $this->db->insert_id();
			return $investorId;
        } else {
            return false;
        }
    }

    public function updateInvestorStatus($data)
    {
        $this->db->insert("investor_status",$data);
        if($this->db->affected_rows()>0) {
            return true;
        } else {
            return false;
        }
    }

    public function check_email($email)
    {
    	$res = $this->db->where('email',$email)->get('users');
    	if($res->num_rows() > 0){
    		return true;
    	}else{
    		return false;
    	}
    }

    public function getInvestorDatailFirstStatpRegitration($investorId)
    {
        $sql="SELECT users.first_name AS name, users.phone, investor.date_of_birth, investor.gender, investor.place_of_birth, investor.country_of_birth_id FROM investor JOIN users ON users.id = investor.login_id WHERE investor.investor_id = '$investorId'";

        $query=$this->db->query($sql);
        if($query->num_rows()>0)
        {
            $data = (array) $query->row();
            $data = json_encode($data);
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    public function getCountyList()
    {
        $query=$this->db->query("SELECT country_id,country_name FROM `country` WHERE status=1");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    public function getAllNationalities()
    {
        $query=$this->db->get("nationality");
        if($query->num_rows()>0)
        {
            $data = (array) $query->result();
            $data = json_encode($data);
            return $query->result();
        }
        else
        {
            return false;
        }
    }


    public function updateInvestorStatusSecontRegitration($investo_id ,$data)
    {
        $this->db->where(['investor_id'=> $investo_id])
                 ->update('investor_status',$data);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    public function getCityList()
    {
        $sql= "SELECT id,location_name FROM `city` WHERE status=1 order by city.location_name";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    public function getStateList()
    {
        $sql= "SELECT id as state_id,state_name FROM `state` WHERE status=1 order by state.state_name";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    public function getInvestorAddressProofList()
    {
        $this->db->where("is_deleted",0);
        $this->db->select('investor_address_proof_id,address_proof');
        $query=$this->db->get("investor_address_proof");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    public function getInvestorIdProofList()
    {
        $this->db->where("is_deleted",0);
        $this->db->select('investor_id_proof_id,id_proof');
        $query=$this->db->get("investor_id_proof");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    public function getInvestorFamilyStatusList()
    {
        $query=$this->db->get("investor_family_status");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    public function getInvestorOccupationList()
    {
        $query=$this->db->query("SELECT occupation_id,occupation FROM occupation WHERE status =1 ");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    public function getInvestorDetail($invId)
    {
        $sql="SELECT users.username as name, users.email,users.phone,users.company,investor.*,investor_type.investor_type,investor_address_proof.address_proof,investor_id_proof.id_proof,investor_status.is_investor_registered_date,country.country_id ,country.country_name,city.id,city.location_name,state.id, state.state_name,investor_family_status.family_status,occupation.occupation,nationality.nationality FROM investor JOIN investor_type on investor.investor_type_id=investor_type.investor_type_id LEFT JOIN  investor_status ON investor.investor_id=investor_status.investor_id LEFT JOIN investor_address_proof on investor.investor_address_proof_id=investor_address_proof.investor_address_proof_id LEFT JOIN investor_id_proof ON investor.investor_id_proof_id=investor_id_proof.investor_id_proof_id LEFT JOIN city on investor.city_id = city.id LEFT JOIN state on investor.state_id=state.id JOIN users on users.id=investor.login_id LEFT JOIN investor_family_status on investor.investor_family_status_id=investor_family_status.investor_family_status_id LEFT JOIN occupation on occupation.occupation_id=investor.occupation_id JOIN country on investor.country=country.country_id JOIN nationality on investor.nationality_id=nationality.nationality_id where investor.investor_id='$invId'";

        $query=$this->db->query($sql);
        if($query->num_rows() > 0) {
            return $query->row();
        } else {
            return false;
        }
    }


    public function updateInvestorInfo($investorId,$data)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->update("investor",$data);
        if($this->db->affected_rows() > 0){
            return true;
        }else{
            return false;
        }
    }

    public function getbankMasterAll()
    {
        $query=$this->db->query("SELECT bank_master_id,bank_name FROM `bank_master` order BY bank_master.bank_name");
        if($query->num_rows()>0) {
            return $query->result();
        }else{
            return false;
        }
    }

    public function getInvestorBankAccountTypeList()
    {
        $query= $this->db->query("select * FROM bank_account_type WHERE account_type_id in(1,2)");
        if($query->num_rows()>0) {
            return $query->result();
        }else{
            return false;
        }
    }

    public function getInvestorBankAndPanDetail($invId)
    {
        $sql="SELECT `bank_details`.* ,bank_account_type.account_type,
        bank_master.bank_name, bank_master.atom_code
        FROM bank_details,bank_account_type,bank_master
        WHERE bank_details.account_type_id=bank_account_type.account_type_id
        and bank_details.bank_master_id=bank_master.bank_master_id
        and bank_details.investor_id='$invId'";

        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    public function getInvestorNomineeDetail($invId)
    {
        $sql="SELECT * FROM `nominee_details`
        where nominee_details.status='1' and nominee_details.investor_id='$invId'";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0) {
            return $query->result();
        } else {
            return false;
        }
    }


    public function getBankDetailUsingIFSC($ifsc)
    {
        $res = $this->db->query("SELECT `bank_name`, `ifsc_code`, `bank_branch_name`, `bank_city_name`, `bank_state_name`, `bank_master_id` FROM `ifsc_detail` WHERE `ifsc_code` = '".$ifsc."'");
        if($res->num_rows() > 0){
            return $res->row();
        }else{
            return false;
        }
    }

    public function get_bank_master($bank_master_id)
    {
        $res = $this->db->where('bank_master_id',$bank_master_id)->get('bank_master');
        if($res->num_rows() > 0){
            return true;
        }else{
            return false;
        }
    }

    public function updateInvestorBankDetails($investorId,$bankData)
    {
        $sql="SELECT bank_details_id FROM bank_details where bank_details.investor_id=$investorId ";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0){
            $this->db->where("investor_id", $investorId);
            $this->db->update("bank_details",$bankData);
            if ($this->db->affected_rows()>0){
                return true;
            } else {
                return false;
            }
        }else{
            $this->db->insert("bank_details",$bankData);
            if($this->db->affected_rows()>0) {
                return true;
            } else {
                return false;
            }
        }
    }

    public function getPersentageOfNominee($investor_id)
    {
        $res = $this->db->query("SELECT SUM(`percentage`) as percentage,count(*) as nominee_count FROM `nominee_details` WHERE investor_id = '".$investor_id."' AND status = 1 group BY investor_id");
        if($res->num_rows() > 0){
            return [(100 - $res->row()->percentage),$res->row()->nominee_count];
        }else{
            return [100,0];
        }
    }

    public function addInvestorNomineeDetails($data)
    {
        $this->db->insert("nominee_details",$data);
        if($this->db->affected_rows()>0) {
            return $this->db->insert_id();
        }else {
            return false;
        }
    }
}