<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Common_model extends CI_Model
{
    function getValue($keyword)
    {
        $query=$this->db->where("keyword",$keyword);
        $query=$this->db->get("setting");
        if($query->num_rows()>0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    // get fundtype name by fund type id
    function getFundTypeName($fundTypeId)
    {
        $query=$this->db->where("fund_type_id",$fundTypeId);
        $query=$this->db->get("fund_type");
        if($query->num_rows()>0)
        {
            return $query->row()->name;
        }
        else
        {
            return false;
        }
    }


    function addFundHistoryByDate($date,$totalFunds)
    {
        for($i=1;$i<=$totalFunds;$i++)
        {
            $nav=$this->randomNumber(3);
            $data=array("nav_date"=>$date,'fund_id'=>$i,"purchase_price"=>$nav,"sale_price"=>$nav,"nav"=>$nav);
            $query=$this->db->query("SELECT * FROM `fund_history` WHERE fund_id='$i' AND DATE_FORMAT(`fund_history`.`nav_date`,'%Y-%m-%d')='$date'");
            if($query->num_rows()>0)
            {
                // $this->db->query("UPDATE `fund_history` SET `nav` = '$nav' WHERE `fund_history`.`fund_id` = '$i' AND DATE_FORMAT(`fund_history`.`date`,'%Y-%m-%d')='$date'");
                // if($this->db->affected_rows()>0)
                // {
                //     echo "update==".$i."===Nav===".$nav."<br/>";
                // }
                // else
                // {
                //     echo "Error in updattion==".$i."===Nav===".$nav."<br/>";
                // }

                echo "Already existing fund id==".$i." in date==".$date."<br/>";
            }
            else{
                echo "added new nav";
                $this->db->insert("fund_history",$data);
            }

        }
    }

    function randomNumber($length)
    {
        $result = '';

        for($i = 0; $i < $length; $i++) {
            $result .= mt_rand(0, 9);
        }

        return $result;
    }

    function getDisplayBlogPost()
    {
        $sql="SELECT * FROM `blogs_data` ORDER BY `post_id` ASC limit 6";
        $query=$this->db->query($sql);
        if($query->num_rows()>0)
        {
            return $query->result();
        }
    }

    function addDailyAgenda($data)
    {
        $this->db->insert("daily_agenda",$data);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    // add investor system logs
    function addSystemLog($data)
    {
        $query=$this->db->insert("investor_system_log",$data);
        if($this->db->affected_rows() > 0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    function addCronLog($data)
    {
        $query=$this->db->insert("cron_log",$data);
        if($this->db->affected_rows() > 0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    function addActivityLog($data)
    {
        $query=$this->db->insert("activity_log",$data);
        if($this->db->affected_rows() > 0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    function getUseDetailsByUserId($userId)
    {
        $this->db->where("id",$userId);
        $query=$this->db->get("users");
        if($query->num_rows()>0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    function getAllGoalTypeList()
    {
        $query=$this->db->get("goal_type");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getInvestorStatus($investorId)
    {
        $query = $this->db->query("select investor_status.*, investor.* FROM investor_status join investor on investor.investor_id=investor_status.investor_id where investor_status.investor_id = '$investorId'");
        if($query->num_rows()>0)
        {
           return $query->row();
        }
        else
        {
           return false;
        }
    }


    // get request date in purchase table database
    function getRequestDateInPurchaseTable($fundId,$investorId)
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT count(request_date) as count FROM `purchased_units`
                WHERE DATE_FORMAT(`purchased_units`.`request_date`,'%Y-%m-%d')>='$todaysDate'
                and fund_id='$fundId' and investor_id='$investorId' and request_status=0";
        $query = $this->db->query($sql);
        if($query->num_rows()>0)
        {
           return $query->row();
        }
        else
        {
           return false;
        }
    }

    // get request date in sold table database
    function getRequestDateInSoldTable($fundId,$investorId)
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT count(request_date) as count FROM `sold_units`
        WHERE DATE_FORMAT(`sold_units`.`request_date`,'%Y-%m-%d')>='$todaysDate'
        and fund_id='$fundId' and investor_id='$investorId' and DATE_FORMAT(`date_of_sale`.`request_date`,'%Y-%m-%d')='0000-00-00'";
        $query = $this->db->query($sql);
        if($query->num_rows()>0)
        {
           return $query->row();
        }
        else
        {
           return false;
        }
    }

    // get latest folio number for one time invetment
    function getLatestFolioNumber($amc_code,$investorId)
    {
        $sql="SELECT purchased_units.folio_number,purchased_units.unit_count,purchased_units.date_of_purchase as date,
        purchased_units.fund_id,purchased_units.investor_id FROM purchased_units WHERE  purchased_units.folio_number <>'' and AMC_CODE='$amc_code' and investor_id='$investorId' and is_cancel != 1";
        $query = $this->db->query($sql);
		//echo 'new '.$this->db->last_query();
        if($query->num_rows()>0)
        {
           return $query->row();
        }
        else
        {
           return false;
        }
    }

	  function getLatestFolioNumberOld($fundId,$investorId)
    {
        $sql="SELECT purchased_units.folio_number,purchased_units.unit_count,purchased_units.date_of_purchase as date,
        purchased_units.fund_id,purchased_units.investor_id FROM purchased_units WHERE fund_id='$fundId' and purchased_units.folio_number <>'' and investor_id='$investorId'
        UNION SELECT sold_units.folio_number,sold_units.unit_count,sold_units.date_of_sale as date,
        sold_units.fund_id,sold_units.investor_id
        FROM sold_units WHERE fund_id='$fundId'and investor_id='$investorId' ORDER BY `date` DESC LIMIT 1";
        $query = $this->db->query($sql);
	//	echo 'old '.$this->db->last_query();
        if($query->num_rows()>0)
        {
           return $query->row();
        }
        else
        {
           return false;
        }
    }
	
	
	
	
    function getToken($userId,$token)
    {
        $sql="SELECT `admin_token` FROM `admin_token` WHERE `admin_user_id`='$userId' and admin_token = '$token'";
        $query = $this->db->query($sql);
        if($query->num_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }   

	function getInvestorDetail()
	{
		$sql="SELECT * FROM `InvLogInfo";
        $query = $this->db->query($sql);
		return ($query->result_array());

	}

    function getInvestorDetailNew()
    {
        $sql="SELECT * FROM `AMC";
        $query = $this->db->query($sql);
        return ($query->result_array());

    }

    public function check_kyc_detail($investor_id)
    {
        $res = $this->db->query("SELECT is_kyc_done FROM `investor_status` WHERE investor_id = $investor_id AND is_kyc_done = 1");
        if($res->num_rows() > 0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }


    public function check_mandat_detail($investor_id)
    {
        $res = $this->db->query("SELECT umrn FROM `investor` WHERE investor.investor_id = $investor_id AND umrn !=''");
        return $res->num_rows();
        // if(!isset($res->row()->umrn) || trim($res->row()->umrn) == ''){
        //     return false;
        // }else{
        //     return true;
        // }
    }

    public function get_user_all_detail($investor_id)
    {
        $res = $this->db->query("SELECT users.username, users.email, users.phone, investor.pan, bank_details.account_holder_name, bank_details.account_number, bank_details.ifsc_code, bank_details.branch_city, bank_details.branch_state FROM `users` JOIN investor ON investor.login_id = users.id JOIN bank_details ON bank_details.investor_id = investor.investor_id WHERE investor.investor_id = $investor_id");
        if($res->num_rows() > 0)
        {
            return $res->row();
        }else{
            return false;
        }
    }

    public function add_new_not($title,$msg,$investor_id)
    {
        date_default_timezone_set("Asia/kolkata");
        if($investor_id){
            $res = $this->db->query("SELECT users.username,users.email,users.phone,investor.agent_id FROM users join investor ON investor.login_id = users.id WHERE investor.investor_id=$investor_id");
            if($res->num_rows() > 0){
                $result = $res->row();
                $investor_name = $this->encrypt->decode($result->username);
                $investor_email = $result->email;
                $investor_phone = $this->encrypt->decode($result->phone);
                $data = [
                         'title'=>$title,
                         'description'=>$msg,
                         'investor_id'=>$investor_id,
                         'customer_name' => $investor_name,
                         'customer_phone' => $investor_phone,
                         'customer_email' => $investor_email,
                         'notification_date' => date("Y-m-d"),
                         'notification_time' => date('h:i:s'),
                         'user_id_emp' => 1
                        ];
            }else{
                $data = [
                            'title'=>$title,
                            'description'=>$msg,
                            'investor_id'=>$investor_id,
                            'notification_date' => date("Y-m-d"),
                            'notification_time' => date('h:i:s')
                        ];
            }
        }else{
            $data = [
                        'title'=>$title,
                        'description'=>$msg,
                        'investor_id'=>$investor_id,
                        'notification_date' => date("Y-m-d"),
                        'notification_time' => date('h:i:s')
                    ];
        }
        $res = $this->db->insert('admin_notification',$data);
        if($res){
            $insert_id = $this->db->insert_id();
            if($insert_id){
                $this->db->insert('additional_admin_notification',[
                        'admin_notification_id' => $insert_id,
                        'user_id' => 1,
                        'description' => $msg,
                        'created_at' => Date('Y-m-d h:m:s')
                    ]);

                // $data = [
                //             [
                //                 "user_id" => 1,
                //                 "admin_notification_id" => $insert_id
                //             ],
                //             [
                //                 "user_id" => 1607,
                //                 "admin_notification_id" => $insert_id
                //             ],
                //             [
                //                 "user_id" => 2269,
                //                 "admin_notification_id" => $insert_id
                //             ]
                //         ];
                    if($result->agent_id !=0){
                        $userId = $result->agent_id;
                    }else{
                        $userId = 1;
                    }
                    
                    $uper_admin_ids = $this->get_uper_user($userId);
                    $array_batch = [];
                    array_push($array_batch, [
                        'user_id' => 2269,
                        'admin_notification_id'=>$insert_id,
                        'is_read' => 0
                    ]);
                    array_push($array_batch, [
                        'user_id' => 2967,
                        'admin_notification_id'=>$insert_id,
                        'is_read' => 0
                    ]);
                    array_push($array_batch, [
                        'user_id' => 1,
                        'admin_notification_id'=>$insert_id,
                        'is_read' => 0
                    ]);
                    if($userId != 1){
                        array_push($array_batch, [
                            'user_id' => $userId,
                            'admin_notification_id'=>$insert_id,
                            'is_read' => 1
                        ]);
                    }
                   
                    if($uper_admin_ids){
                        foreach($uper_admin_ids as $uper_admin_id){
                            if($uper_admin_id != $userId){
                                array_push($array_batch,[
                                    'user_id' => $uper_admin_id,
                                    'admin_notification_id'=>$insert_id,
                                    'is_read' => 0
                                ]);
                            }
                        }
                    }

                $this->db->insert_batch('admin_notification_read_state', $array_batch); 
            }
        }
    }


    public function get_uper_user($user_id)
    {
        $this->id_array = [];
        $res = $this->get_data_upar($user_id);
        return  array_unique($this->id_array);
    }

    public function get_data_upar($id)
    {
        if($id){
            $this->id_array = array_merge($this->id_array,explode(',', $id));
            $res = $this->db->query("SELECT GROUP_CONCAT(up_level_user_id) as user_id FROM mapping WHERE down_level_user_id in($id) AND is_active =1 AND is_notifiy = 1");
            if($res->num_rows() > 0)
            {
                $id = $res->row()->user_id;
                $this->get_data_upar($id);
            }
            else
            {
                return $this->id_array;
            }
        }
        else
        {
            return $this->id_array;
        }
    }
}
