<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Cron_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }

    function getInvestorsList()
    {
        $sql = "select users.id,users.first_name, users.email, investor.investor_id from users
                inner join investor
                on users.id = investor.login_id
                WHERE users.active = 1
                and investor.is_verify = 1";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Cron_model,  Function :  getInvestorsList, Messege : Get User list successfully with data ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Cron_model,  Function :  getInvestorsList, Messege : data not found *****");
            return false;
        }
    }

    function getPurchaseFundsReadytoPurchase($fundTypeId,$investor_id)
    {
        $todaysDate=date("Y-m-d");
        $sql="SELECT SUM(unit_count) as unit_count ,sum(purchased_units.purchased_amount) as invested_amount,
        purchased_units.fund_id ,fund_history.nav , fund_history.nav_date,
        SUM(unit_count)*fund_history.nav as total_amount,
        funds.fund_type_id,funds.fund_name FROM purchased_units
        join fund_history on fund_history.fund_id=purchased_units.fund_id
        join funds on purchased_units.fund_id=funds.fund_id
        WHERE `request_status`=1 and funds.fund_type_id='$fundTypeId'
        AND purchased_units.investor_id='$investor_id'
        AND  DATE_FORMAT(`fund_history`.`nav_date`,'%Y-%m-%d')='$todaysDate' group by fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Cron_model,  Function :  getPurchaseFundsReadytoPurchase, Messege : get data successfully data : ".$data." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Cron_model,  Function :  getPurchaseFundsReadytoPurchase, Messege : data not found return false *****");
            return false;
        }
    }

    function getSoldFunds($fundTypeId,$investor_id)
    {
        $todaysDate=date("Y-m-d");
        $sql="SELECT SUM(unit_count) as unit_count ,
        sold_units.fund_id ,fund_history.nav , fund_history.nav_date,
        SUM(unit_count)*fund_history.nav as total_amount,
        funds.fund_type_id,funds.fund_name FROM sold_units
        join fund_history on fund_history.fund_id=sold_units.fund_id
        join funds on sold_units.fund_id=funds.fund_id
        WHERE `request_status`=1 and funds.fund_type_id='$fundTypeId'
        AND sold_units.investor_id='$investor_id'
        AND  DATE_FORMAT(`fund_history`.`nav_date`,'%Y-%m-%d')='$todaysDate' group by fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Cron_model,  Function :  getSoldFunds, Messege : sold fund found successfully return data : ".$data." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Cron_model,  Function :  getSoldFunds, Messege : sold fund Not found return false *****");
            return false;
        }
    }

    function getInvestedAmount($fundTypeId,$investor_id)
    {
        $sql="SELECT SUM(unit_count) as unit_count ,
        purchased_units.fund_id ,fund_history.nav , fund_history.nav_date,
        SUM(purchased_units.purchased_amount) as total_amount, funds.fund_type_id,
        funds.fund_name FROM purchased_units
        join fund_history on fund_history.fund_id=purchased_units.fund_id
        join funds on purchased_units.fund_id=funds.fund_id WHERE `request_status`=1
        AND purchased_units.investor_id=$investor_id
        AND DATE_FORMAT(`fund_history`.`nav_date`,'%Y-%m-%d')=purchased_units.date_of_purchase
        AND funds.fund_type_id = $fundTypeId";
        $query = $this->db->query($sql);
        // echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) query->row();
			$data = json_encode($data);
            log_message("info", "***** Model : Cron_model,  Function :  getInvestedAmount, Messege : Get invested amount successfully return data ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Cron_model,  Function :  getInvestedAmount, Messege : Data not found return false *****");
            return false;
        }
    }

    function getAllInvestorGoalsList()
    {
        $sql="select goal_type.goal_title, sum(goals.goal_amount) as goal_amount, goals.`investor_id`
        from goals INNER JOIN goal_type on goal_type.goal_type_id = goals.goal_type_id inner
        join investor on goals.investor_id = investor.investor_id group by investor_id";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) query->result();
			$data = json_encode($data);
            log_message("info", "***** Model : Cron_model,  Function :  getAllInvestorGoalsList, Messege : Get All Investor Goals List successfully return data ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Cron_model,  Function :  getAllInvestorGoalsList, Messege : Data not found return false *****");
            return false;
        }
    }

    function getAllInvestorCurrentValueLsit()
    {
        $todaysDate=date("Y-m-d");
        $sql="SELECT total_nav.*,investor.investor_id, users.username,users.email FROM total_nav JOIN investor
        on total_nav.investor_id=investor.investor_id JOIN  users on  users.id=investor.login_id
        AND  DATE_FORMAT(`total_nav`.`date`,'%Y-%m-%d')='$todaysDate'";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
            $data = (array) query->result();
			$data = json_encode($data);
            log_message("info", "***** Model : Cron_model,  Function :  getAllInvestorCurrentValueLsit, Messege : get All Investor Current Value List successfully return data ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Cron_model,  Function :  getAllInvestorCurrentValueLsit, Messege : Data not found return false *****");
            return false;
        }
    }

    function getClosuresExpiryList($tomorrowDate)
    {
        $sql="select * from disclosures
        inner join amc_code
        on disclosures.amc_code_id=amc_code.id
        where disclosures.valid_date='$tomorrowDate'";
        $query = $this->db->query($sql);
        // echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
            $data = (array) query->result();
			$data = json_encode($data);
            log_message("info", "***** Model : Cron_model,  Function :  getClosuresExpiryList, Messege : get Closures Expiry List successfully return data ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Cron_model,  Function :  getClosuresExpiryList, Messege : Data not found return false *****");
            return false;
        }
    }
}
