<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Dashboard_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }
	
	function getAllData()
    {
        $sql="SELECT username,email,phone,(select investor_id from investor where login_id=users.id) as investor_id FROM `users` ";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllData , InvestorId :   , Messege : Get all Data successfully returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllData , InvestorId :   , Messege : data not found  returning false *****");
            return false;
        }
    }

    //get the username & password from table
    function login($username)
    {
        $sql="SELECT * FROM `users` WHERE username='".$username."'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  login , username : ".$username."   , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  login , username : ".$username."   , Messege : returning false in else condition *****");
            return false;
        }
    }

    function updateImageUrlOnServer($userId,$data)
    {
        $this->db->where("login_id",$userId);
        $this->db->update("investor",$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  updateImageUrlOnServer , userId : ".$userId."   , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  updateImageUrlOnServer , userId : ".$userId."   , Messege : returning false in else condition *****");
            return false;
        }
    }

     function getcancelChequeUrl($investorId)
     {
        $this->db->where("document_type_id",4);
        $this->db->where("investor_id",$investorId);
        $query=$this->db->get("investor_document_type");
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getcancelChequeUrl , InvestorId :  ".$investorId." , Messege : get cancel Cheque Url returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getcancelChequeUrl , investorId : ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
     }

    function getprofileImageUrlByUserId($userId)
    {
        $this->db->where("login_id",$userId);
        $query=$this->db->get("investor");
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getprofileImageUrlByUserId , userId :  ".$userId." , Messege : returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getprofileImageUrlByUserId , userId : ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    /** this function call by export controller **/
    function download_to_excel()
    {
        $query=$this->db->get('users');
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  download_to_excel , InvestorId :   , Messege : returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  download_to_excel , userId : , Messege : returning false in else condition *****");
            return false;
        }
    }

    /** rerurn All invstemtment value info current amount **/
    function getAllInvestmentCurrentValue($investorId)
    {
        /** get all purchase fund **/
        $sql="SELECT SUM(unit_count) as unit_count , purchased_units.fund_id, fund_history.nav , max(fund_history.nav_date),
        SUM(unit_count)*fund_history.nav as total_amount, funds.* FROM purchased_units
        join fund_history on fund_history.fund_id=purchased_units.fund_id join funds on purchased_units.fund_id=funds.fund_id
        WHERE fund_history.is_latest =1 and purchased_units.`request_status`=1
        AND purchased_units.investor_id='$investorId' group by purchased_units.fund_id";
        $query1 = $this->db->query($sql);
        if ($query1->num_rows() > 0)
        {
            $data = (array) $query1->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllInvestmentCurrentValue , InvestorId :  ".$investorId." , Messege : result Purchase Funds returning data : ".$data ." *****");
            $resultPurchaseFunds=$query1->result();
        }

        $sql="SELECT SUM(unit_count) as unit_count , sold_units.fund_id, fund_history.nav , max(fund_history.nav_date),
        SUM(unit_count)*fund_history.nav as total_amount, funds.* FROM sold_units
        join fund_history on fund_history.fund_id=sold_units.fund_id join funds on sold_units.fund_id=funds.fund_id
        WHERE fund_history.is_latest =1 and sold_units.`request_status`=1 and sold_units.is_cancel=0
        AND sold_units.investor_id='$investorId' group by sold_units.fund_id";
        $query2 = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query2->num_rows() > 0)
        {
			$data = (array) $query2->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllInvestmentCurrentValue , InvestorId :  ".$investorId." , Messege : result Sold Funds returning data : ".$data ." *****");
            $resultSoldFunds=$query2->result();
        }

        $totalAmount=0;
        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            foreach ($resultPurchaseFunds as $puchaseRow)
            {
                $fundName=$puchaseRow->fund_name;

                $purchaseFundId=$puchaseRow->fund_id;
                $purchaseUnits=$puchaseRow->unit_count;
                $nav=$puchaseRow->nav;

                /** check count fund is sold or not **/
                $soldCount=0;

                if(isset($resultSoldFunds) && !empty($resultSoldFunds))
                {
                    foreach ($resultSoldFunds as $soldRow)
                    {
                        $soldFundId=$soldRow->fund_id;
                        $soldUnits=$soldRow->unit_count;
                        if($soldFundId==$purchaseFundId)
                        {
                            $balanceUnit=round(($purchaseUnits-$soldUnits),2);
                            $soldCount++;
                        }
                    }
                }
                if($soldCount==0)
                {
                    $balanceUnit=$purchaseUnits;
                }

                $balanceUnit;

                /** caluculate current amount by current nav**/
                $currentAmount=round(($balanceUnit*$nav),2);
                $totalAmount=round(($totalAmount+$currentAmount),2);
            }
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllInvestmentCurrentValue , InvestorId :  ".$investorId." , Messege : returning amount : ".$totalAmount." in if condition *****");
            return $totalAmount;
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllInvestmentCurrentValue , InvestorId :  ".$investorId." , Messege : returning amount : ".$totalAmount." in else condition *****");
            return $totalAmount;
        }
    }


    function getAllInvestmentInvestedValue($investorId)
    {
        /** get all purchase fund **/
        $sql="SELECT SUM(unit_count) as unit_count ,
        purchased_units.fund_id ,
        SUM(purchased_units.purchased_amount) as total_amount, funds.fund_type_id,
        funds.fund_name FROM purchased_units
        join funds on purchased_units.fund_id=funds.fund_id WHERE `request_status`=1
        AND purchased_units.investor_id=$investorId
        group by fund_id";
        $query1 = $this->db->query($sql);
        if ($query1->num_rows() > 0)
        {
			$data = (array) $query1->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllInvestmentInvestedValue , InvestorId :  ".$investorId." , Messege : result Purchase Fundss returning data : ".$data ." *****");
             $resultPurchaseFunds=$query1->result();
        }

        $totalAmount=0;
        if(isset($resultPurchaseFunds) && !empty($resultPurchaseFunds))
        {
            foreach ($resultPurchaseFunds as $puchaseRow)
            {
                $fundName=$puchaseRow->fund_name;
                $purchaseFundId=$puchaseRow->fund_id;
                $purchaseAmount=$puchaseRow->total_amount;

                $totalAmount=round(($totalAmount+$purchaseAmount),0);
            }
			
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllInvestmentInvestedValue , InvestorId :  ".$investorId." , Messege : returning amount : ".$totalAmount." in if condition *****");
            return $totalAmount;
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getAllInvestmentInvestedValue , InvestorId :  ".$investorId." , Messege : returning amount : ".$totalAmount." in else condition *****");
            return $totalAmount;
        }
    }

    function getLoggedInUserInfo($investorId)
    {
        $query=$this->db->query("SELECT `is_mandate_received` FROM `investor_status` WHERE investor_id='$investorId'");
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getLoggedInUserInfo , InvestorId :  ".$investorId." , Messege : get Logged In User Info returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getLoggedInUserInfo , InvestorId :  ".$investorId." , Messege : returning false in else condition *****");
             return false;
        }
    }

    function getRiskProfileData($email)
    {
        $query=$this->db->query("SELECT * FROM `risk_profile`
        inner join temp_users
        on temp_users.temp_users_id = risk_profile.temp_users_id
        where temp_users.temp_user_email = '$email'");
       //echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getRiskProfileData , email :  ".$email." , Messege : get Risk Profile Data returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getRiskProfileData , email :  ".$email." , Messege : returning false in else condition *****");
             return false;
        }
    }

    function saveGoal($investorId,$data)
    {
        $this->db->insert("goals",$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  saveGoal , investorId :  ".$investorId." , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  saveGoal , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function fetchGoals($investorId)
    {
        $query=$this->db->query("select goals.goal_id, goal_type.goal_title, sum(goals.goal_amount) as goal_amount, goal_type.goal_type_id,goals.ts, sum(goals.monthly_saving_amount) as monthly_saving_amount from goals
        INNER JOIN goal_type
        on goal_type.goal_type_id = goals.goal_type_id
        inner join investor
        on goals.investor_id = investor.investor_id
        where goals.investor_id =$investorId
        group by goal_type.goal_title");
        //echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  fetchGoals , investorId :  ".$investorId." , Messege : fetch Goals returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  fetchGoals , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

	
	
    function fetchGoal($goal_id,$investorId)
    {
        $query=$this->db->query("select goals.goal_id,goals.monthly_saving_amount,goals.goal_amount,goals.ts,goal_type.goal_title from goals
		INNER JOIN goal_type
        on goal_type.goal_type_id = goals.goal_type_id
        inner join investor
        on goals.investor_id = investor.investor_id
        where goals.investor_id =$investorId and goal_id=$goal_id
		
		");
        //echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  fetchGoal , investorId :  ".$investorId." , Messege : fetch Goals returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  fetchGoal , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }
	function deleteGoal($goal_id){
		$myquery="delete from goals where goal_id=$goal_id";
		$query = $this->db->query($myquery);
        if($this->db->affected_rows()>0)
        { 
			log_message("info", "***** Model : Dashboard_model,  Function :  deleteGoal , goal_id :  ".$goal_id." , Messege : returning true in if condition *****");
			return true;
		}else{
			log_message("info", "***** Model : Dashboard_model,  Function :  deleteGoal , goal_id :  ".$goal_id." , Messege : returning false in else condition *****");
			return false;
		}
		
	}

	
	function updateGoal($goal_id,$monthly_saving_amount,$goal_amount){
		$myquery="update goals set monthly_saving_amount='$monthly_saving_amount',goal_amount='$goal_amount' where goal_id=$goal_id";
		$query = $this->db->query($myquery);
        if($this->db->affected_rows()>0)
        { 
			log_message("info", "***** Model : Dashboard_model,  Function :  updateGoal , goal_id :  ".$goal_id." , Messege : returning true in if condition *****");
			return true;
		}else{
			log_message("info", "***** Model : Dashboard_model,  Function :  updateGoal , goal_id :  ".$goal_id." , Messege : returning false in else condition *****");
			return false;
		}
		
	}
    function getNiftyData($investmentReadyDate)
    {
        $query = $this->db->query("SELECT * FROM `nifty_data` where nifty_data.date >= '$investmentReadyDate' order by nifty_data.date asc");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getNiftyData , investmentReadyDate :  ".$investmentReadyDate." , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getNiftyData , investmentReadyDate :  ".$investmentReadyDate." , Messege : returning false in else condition *****");
            return false;
        }
    }

	
	public function getMySIPModel($investorId)
	{
		$sql = "SELECT monthly_investment.* , funds.AMC_code , funds.scheme_description FROM `monthly_investment` join funds on monthly_investment.fund_id = funds.fund_id WHERE monthly_investment.investor_id = $investorId AND monthly_investment.is_stopped_sip = 0 ";
		$query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getMySIPModel , investorId :  ".$investorId." , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getMySIPModel , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
	}
	
    function getPortfolio_return($investorId)
    {
        $query = $this->db->query("select * from total_nav where total_nav.investor_id = $investorId
        order by total_nav.date asc");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function :  getPortfolio_return , investorId :  ".$investorId." , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getPortfolio_return , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function insertNifty($data)
    {
        $this->db->insert("nifty_data",$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  insertNifty ,  Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  insertNifty ,  Messege : returning false in else condition *****");
            return false;
        }
    }

    function getReadyDateForInvestment($investorId)
    {
        $query = $this->db->query("select investor_status.is_ready_for_investment_date from investor_status
        where investor_status.investor_id = $investorId
        and investor_status.is_ready_for_investment=1");
        // echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function : getReadyDateForInvestment , investorId :  ".$investorId." , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getReadyDateForInvestment , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function getRequiredPortfolio_return($investorId,$fromDate)
    {
        $query = $this->db->query("select * from total_nav where total_nav.investor_id = $investorId and total_nav.date>='$fromDate' order by total_nav.date asc");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function : getRequiredPortfolio_return , investorId :  ".$investorId." , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getRequiredPortfolio_return , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function totalGoalsTarget($investorId)
    {
        $query = $this->db->query("select sum(goals.goal_amount) as goal_amount from goals
        INNER JOIN goal_type
        on goal_type.goal_type_id = goals.goal_type_id
        inner join investor
        on goals.investor_id = investor.investor_id
        where goals.investor_id =$investorId");
        // echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function : getRequiredPortfolio_return , investorId :  ".$investorId." , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getRequiredPortfolio_return , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function updateInvestorId($data,$riskProfileId,$tempUsersId)
    {
        $this->db->where("risk_profile_id", $riskProfileId);
        $this->db->where("temp_users_id", $tempUsersId);
        $this->db->update("risk_profile",$data);
        return true;
    }

    function getSipListCountByFundTypeId($fundTypeId,$investorId)
    {
        $query = $this->db->query("select count(*) as count from monthly_investment
        inner join funds
        on monthly_investment.fund_id = funds.fund_id
        inner join fund_type
        on funds.fund_type_id = fund_type.fund_type_id
        where monthly_investment.investor_id=$investorId
        and fund_type.fund_type_id=$fundTypeId");
        // echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function : getSipListCountByFundTypeId , investorId : ".$investorId." , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function :  getSipListCountByFundTypeId , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }
	
	
	public function getMySIPbyIdModel($Id)
	{
		$sql = "SELECT monthly_investment.* , funds.AMC_code , funds.scheme_description FROM `monthly_investment` join funds on monthly_investment.fund_id = funds.fund_id WHERE monthly_investment.monthly_investment_id = $Id ";
		$query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function : getMySIPbyIdModel , Id : ".$Id." , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function : getMySIPbyIdModel , Id :  ".$Id." , Messege : returning false in else condition *****");
            return false;
        }
	}

    function getSipListByFundTypeId($fundTypeId,$investorId)
    {
        $sql="SELECT sum(monthly_investment.amount) as amount_total ,monthly_investment.*,funds.*,fund_type.name
        FROM monthly_investment JOIN funds on monthly_investment.fund_id=funds.fund_id
        JOIN fund_type on fund_type.fund_type_id=funds.fund_type_id
        WHERE monthly_investment.investor_id='$investorId' AND fund_type.fund_type_id='$fundTypeId' GROUP BY batch_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function : getSipListByFundTypeId , investorId : ".$investorId." , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function : getSipListByFundTypeId , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function closeSip($batchId,$investorId)
    {
        $query = $this->db->query("update monthly_investment set monthly_investment.is_stopped_sip=1 where monthly_investment.batch_id='$batchId' and monthly_investment.investor_id='$investorId'");
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Dashboard_model,  Function : closeSip , investorId :  ".$investorId." , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function : closeSip , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function getInvestedFundType($investorId)
    {
        $sql="SELECT sum(purchased_units.unit_count) as unit_count ,purchased_units.investor_id ,funds.fund_id ,fund_type.* FROM purchased_units 
        join funds on purchased_units.fund_id=funds.fund_id 
        JOIN fund_type on fund_type.fund_type_id=funds.fund_type_id where investor_id='$investorId'
        GROUP BY fund_type.fund_type_id";
        $query = $this->db->query($sql);
        // echo $this->db->last_query();die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function : getInvestedFundType , investorId : ".$investorId." , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function : closeSip , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }


    function getCurrentInvestedAmount($inv_id)
    {
        $sql = " select sum(purchased_amount) as amt,'p' as status from purchased_units where investor_id = $inv_id and unit_count > 0 and request_status =1" ;

       

       $getAmount =  $this->db->query($sql);
       $pAmount = $getAmount->row();

        $sql2 = " select sum(sold_amount) as amt ,'s' as status from sold_units where investor_id = $inv_id and unit_count > 0 and request_status =1";
        $getAmount =  $this->db->query($sql2);
       $sAmount = $getAmount->row();
     

         $ans = (int)$pAmount->amt - (int)$sAmount->amt  ;
         if($ans > 0)
         {
			 
            return $ans;
         }
         else
         {
            return 0;
         }
       
    
    }

    public function getdashboard_status($investor_id)
    {
        $sql = "SELECT * FROM investor_status where investor_id = $investor_id";
         $query = $this->db->query($sql);
        // echo $this->db->last_query();die;
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Dashboard_model,  Function : getdashboard_status , investorId : ".$investor_id." , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Dashboard_model,  Function : getdashboard_status , investorId :  ".$investor_id." , Messege : returning false in else condition *****");
            return false;
        }
    }
	
	    
    /***** get withdraw funds eligiblity after years ****/
    function getDataForTaxSavingWithdrawPurchaseEligiblity($investorId,$fundsTypeId)
    {
        $sql="SELECT purchased_units.purchased_units_id,purchased_units.date_of_purchase FROM purchased_units 
        join fund_history on fund_history.fund_id=purchased_units.fund_id join funds on purchased_units.fund_id=funds.fund_id 
        WHERE fund_history.is_latest =1 and purchased_units.`request_status`=1 and funds.fund_type_id='$fundsTypeId' 
        AND purchased_units.investor_id='$investorId' group by purchased_units.fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }  
	
	public function getfunddetailbyFundIdForCheck($fundId)
	{
		$sql = "SELECT * FROM funds WHERE fund_id = $fundId";
		$query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
	}
}
