<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Preferences_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }

    /** get investor name email and phone info **/
    function getInvestorDetails($investorId)
    {
        $sql="SELECT users.username as name, users.phone,users.email, investor.investor_id FROM users JOIN investor on users.id= investor.login_id WHERE investor.investor_id=$investorId";
        $query=$this->db->query($sql);
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getInvestorDetails , investorId : ".$investorId." , Messege :  returning data : ".$data ." *****");
			return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getInvestorDetails , investorId :  ".$investorId." , Messege : returning false in else condition *****");
			return false;
        }
    }

    function updateCurrentUserInfo($userId,$data)
    {
        $this->db->where("login_id",$userId);
        $this->db->update("investor",$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Preferences_model,  Function : updateCurrentUserInfo , userId :  ".$userId." , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : updateCurrentUserInfo , userId :  ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    /** this will check user new email already exist or not in database when user want to change email **/
    function checkUserNewEmail($userId,$email)
    {
        $this->db->where_not_in("id",$userId);
        $this->db->where('email', $email);
        $query=$this->db->get("users");
        if($query->num_rows()>0)
        {
			log_message("info", "***** Model : Preferences_model,  Function : checkUserNewEmail , userId :  ".$userId." , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : checkUserNewEmail , userId :  ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    /** this function will check logged in user current password in database when changing password **/
    function checkUserCurrentPassword($userId,$password)
    {
        $this->db->where('id', $userId);
        $this->db->where('password', $password);
        $query=$this->db->get("users");
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : checkUserCurrentPassword , userId : ".$userId." , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : checkUserCurrentPassword , userId :  ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    /** this function get user contact info **/
    function getContactInfo($userId)
    {
        $sql="SELECT users.phone,investor.overseas_no,investor.residence_phone,investor.office_phone FROM investor,users WHERE investor.login_id=users.id and users.id=$userId";
        //echo $this->db->last_query();die;
        $query=$this->db->query($sql);
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getContactInfo , userId : ".$userId." , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else{
			log_message("info", "***** Model : Preferences_model,  Function : getContactInfo , userId :  ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    /** this function update user's contact info **/
    function updateContactInfo($userId,$data)
    {
        $this->db->where("login_id",$userId);
        $this->db->update("investor",$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Preferences_model,  Function : updateContactInfo , userId :  ".$userId." , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : updateContactInfo , userId :  ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function getNotificationDispalyList()
    {
        $query=$this->db->get("notification");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getNotificationDispalyList ,Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getNotificationAnswerInfo($investorId)
    {
        $this->db->where('is_deleted', 0);
        $this->db->where("investor_id",$investorId);
        $query=$this->db->get("notification_answer");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getNotificationAnswerInfo , investorId : ".$investorId." ,Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getNotificationAnswerInfo , investorId :  ".$investorId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function updateNotificationAnswerInfo($investorId,$jsonArray)
    {
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $arrayMsg=array();
            foreach ($jsonArray as $row)
            {
                $qsnId=$row[0];
                $email=$row[1];
                $sms=$row[2];
                /** Check question id is alredy answered or not **/
                $checkArray= array('notification_id' => $qsnId,'investor_id' => $investorId);

                $this->db->where($checkArray);
                $resultCheckAnswer=$this->db->get("notification_answer");

                if($resultCheckAnswer->num_rows()>0)
                {
                    /** Update answer **/
                    $updateArray = array('is_email' => $email,"is_sms"=>$sms);
                    $this->db->where($checkArray);
                    $this->db->update("notification_answer",$updateArray);
                }
                else
                {
                    /** Add new answer **/
                    $addArray = array('notification_id' => $qsnId,'is_email' => $email,'is_sms' => $sms,'investor_id' => $investorId);
                    $this->db->insert("notification_answer",$addArray);
                    if($this->db->affected_rows()==0)
                    {
                        array_push($arrayMsg,$qsnId);
                    }
                }
            }
            $count=count($arrayMsg);
            if($count==0){return true;}
            else{return false;}
        }
    }

    function getAddress($userId)
    {
        $sql="SELECT investor.pincode, investor.address, investor.address_2, IF(investor.original_city != '',investor.original_city,city.location_name) as location_name, city.id AS location_id, state.state_name, state.id AS state_id FROM `investor` INNER JOIN country ON investor.country = country.country_id INNER JOIN city ON investor.city_id = city.id INNER JOIN state ON investor.state_id = state.id WHERE `investor`.login_id = $userId";
        $query = $this->db->query($sql);
        //  echo $this->db->last_query($sql); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getAddress , userId : ".$userId." ,Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getAddress , userId :  ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function getBankDetails($userId)
    {
        $sql="select bank_details.*, bank_account_type.account_type,bank_details.ifsc_code, bank_master.bank_name,investor.investor_type_id from bank_details
        inner join bank_account_type
        on bank_account_type.account_type_id = bank_details.account_type_id
        inner JOIN bank_master
        on bank_details.bank_master_id = bank_master.bank_master_id
        inner join investor
        on bank_details.investor_id = investor.investor_id
        inner join users
        on investor.login_id = users.id
        where users.id = $userId";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getBankDetails , userId : ".$userId." ,Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getBankDetails , userId :  ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function updateCommunicationAddress($userId,$new_address,$new_pincode,$new_city,$new_state,$new_countryCode)
    {
        $sql = "update investor set address = '$new_address', pincode = '$new_pincode', city_id = '$new_city', state_id = '$new_state', country = '$new_countryCode' where login_id = $userId";
        $query = $this->db->query($sql);
        // echo $this->db->last_query($sql); die;
        if ($this->db->affected_rows() > 0)
        {
            return TRUE;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : updateCommunicationAddress , userId :  ".$userId." , Messege : returning false in else condition *****");
            return false;
        }
    }

    function insertCommunicationAddress($data)
    {
        $this->db->insert("change_address", $data);
        if ($this->db->affected_rows() > 0)
        {
            return $this->db->insert_id();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : insertCommunicationAddress , Messege : returning false in else condition *****");
            return false;
        }
    }

    function updateBankDetails($investorId,$data)
    {
        $this->db->where("investor_id",$investorId);
        $this->db->update("bank_details", $data);
        if ($this->db->affected_rows() > 0)
        {
            return TRUE;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : insertCommunicationAddress ,investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    function insertBankDetails($data)
    {
        $this->db->insert("change_bank", $data);
        if ($this->db->affected_rows() > 0)
        {
            return $this->db->insert_id();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : insertBankDetails , Messege : returning false in else condition *****");
            return false;
        }
    }

    function getInvestorNameOnPancard($investorId)
    {
        $sql = "select distinct(name) from bank_details where investor_id = $investorId";
        $query = $this->db->query($sql);
        // echo $this->db->last_query($sql); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getInvestorNameOnPancard , investorId : ".$investorId." ,Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getInvestorNameOnPancard ,investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    function getNomineeDetails($userId)
    {
        $sql = "select nominee_details.nominee_details_id, nominee_details.name, nominee_details.relation_with_investor,
        nominee_details.date_of_birth,nominee_details.guardian_name,nominee_details.address,nominee_details.percentage,nominee_details.status from investor
        inner join nominee_details
        on investor.investor_id = nominee_details.investor_id
        inner join users
        on users.id = investor.login_id
        where users.id = $userId and nominee_details.status < 2";
        $query = $this->db->query($sql);
        // echo $this->db->last_query($sql); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getNomineeDetails , userId : ".$userId." ,Messege :  returning data : ".$data ." *****");
          return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getInvestorNameOnPancard ,userId : ".$userId.", Messege : returning false in else condition *****");
          return false;
        }
    }
	function getNomineePdf($investor_id)
    {
        $sql = "select signedNominee_url from nominee_details where investor_id=$investor_id";
        $query = $this->db->query($sql);
         if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getNomineePdf , investor_id : ".$investor_id." ,Messege :  returning data : ".$data ." *****");
          return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getNomineePdf ,investor_id : ".$investor_id.", Messege : returning false in else condition *****");
          return false;
        }
    }
    function insertNomineeDetails($nomineeData)
    {
        $this->db->insert("nominee_details",$nomineeData);
        if($this->db->affected_rows()>0)
        {
            return $this->db->insert_id();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : insertNomineeDetails , Messege : returning false in else condition *****");
            return false;
        }
    }

    function getUserData($userId)
    {
        $sql = "select investor.address, investor.pincode, city.location_name, state.state_name, investor.pan, users.username, users.email, users.phone, investor_status.is_investor_registered_date from users
        inner join investor
        on users.id = investor.login_id
        inner join investor_status
        on investor.investor_id = investor_status.investor_id
        inner join city
        on investor.city_id = city.id
        inner join state
        on investor.state_id = state.id
        where users.id = $userId";
        $query = $this->db->query($sql);
        //  echo $this->db->last_query($sql); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getUserData , userId : ".$userId." ,Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getUserData, userId : ".$userId." , , Messege : returning false in else condition *****");
            return false;
        }
    }

    function savePdfUrlData($fileName,$userId,$nomineeDetailsInsertedId)
    {
        $sql = "update nominee_details
        set nominee_details.signedNominee_url = '".$fileName."'
        where nominee_details.investor_id =
        (select investor.investor_id from investor
        where investor.login_id = $userId
        and nominee_details.nominee_details_id=$nomineeDetailsInsertedId)";
        $query = $this->db->query($sql);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : savePdfUrlData, userId : ".$userId."  , Messege : returning false in else condition *****");
            return false;
        }
    }

    function saveChangeBankPdfUrlData($fileName,$userId,$modifiedBankInsertedId)
    {
        $sql = "update change_bank set
        change_bank.changeBankForm_pdf_url = '$fileName'
        where change_bank.investor_id =
        (select investor.investor_id from investor
        where investor.login_id = $userId
        and change_bank.id=$modifiedBankInsertedId)";
        $query = $this->db->query($sql);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : savePdfUrlData, userId : ".$userId."  , Messege : returning false in else condition *****");
            return false;
        }
    }

    function saveBankMandateUrlData($fileName2,$userId,$modifiedBankInsertedId)
    {
        $sql = "update change_bank set
        change_bank.mandateForm_url = '$fileName2'
        where change_bank.investor_id =
        (select investor.investor_id from investor
        where investor.login_id = $userId
        and change_bank.id=$modifiedBankInsertedId)";
        $query = $this->db->query($sql);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : saveBankMandateUrlData, userId : ".$userId."  , Messege : returning false in else condition *****");
            return false;
        }
    }

    function saveAddressPdfUrlData($fileName,$userId,$modifiedAddressInsertedId)
    {
        $sql = "update change_address set
        change_address.changeAddressForm_pdf_url = '$fileName'
        where change_address.investor_id =
        (select investor.investor_id from investor
        where investor.login_id = $userId
        and change_address.id=$modifiedAddressInsertedId)";
        $query = $this->db->query($sql);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : saveBankMandateUrlData, userId : ".$userId."  , Messege : returning false in else condition *****");
            return false;
        }
    }

    function getCityList()
    {
        $sql= "SELECT * FROM `city`";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getCityList ,Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getCityList,  Messege : returning false in else condition *****");
            return false;
        }
    }
	
	
    function getCityListForApp()
    {
        $sql= "SELECT id,location_name FROM `city`";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getCityListForApp ,Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getCityListForApp,  Messege : returning false in else condition *****");
            return false;
        }
    }

	function getStateListForApp()

    {

        $sql= "SELECT id,state_name FROM `state` order by state.state_name";

        $query = $this->db->query($sql);

        if($query->num_rows() > 0)

        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getStateListForApp ,Messege :  returning data : ".$data ." *****");
            return $query->result();

        }

        else

        {
			log_message("info", "***** Model : Preferences_model,  Function : getCityListForApp,  Messege : returning false in else condition *****");
            return false;

        }

    }

    function getStateList()
    {
        $sql= "SELECT * FROM `state` order by state.state_name";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getStateList ,Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getStateList,  Messege : returning false in else condition *****");
            return false;
        }
    }

    function updateNomineeDetails($investorId, $data, $nomineeId)
    {
        $this->db->where("investor_id",$investorId);
        $this->db->where("nominee_details_id",$nomineeId);
        $this->db->update("nominee_details",$data);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : updateNomineeDetails, investorId: ".investorId." Messege : returning false in else condition *****");
            return false;
        }
    }

    function updatePdfUrlData($fileName,$investorId,$nomineeId)
    {
        $sql= "update nominee_details set nominee_details.signedNominee_url = '$fileName' where nominee_details.investor_id = $investorId and nominee_details.nominee_details_id = $nomineeId";
        $query = $this->db->query($sql);
        // echo $this->db->last_query($sql);die;
        if($this->db->affected_rows()>0)
        {
			return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : updatePdfUrlData, investorId: ".investorId." Messege : returning false in else condition *****");
			return false;
        }
    }

    function getPendingNomineeDetails($investorId)
    {
        $sql="SELECT count(*) as pending_count FROM `nominee_details` WHERE nominee_details.status=0 and nominee_details.investor_id = $investorId";
        $query = $this->db->query($sql);
        // echo $this->db->last_query($sql);die;
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : getPendingNomineeDetails ,Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : getPendingNomineeDetails, investorId: ".investorId." Messege : returning false in else condition *****");
            return false;
        }
    }

    function checkNomineeTotalPercentage($investorId)
    {
        $sql= "SELECT sum(percentage) total_percentage FROM `nominee_details`  WHERE investor_id='$investorId' and status in (0,1)";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Preferences_model,  Function : checkNomineeTotalPercentage ,Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : checkNomineeTotalPercentage, investorId: ".investorId." Messege : returning false in else condition *****");
            return false;
        }
    }

    function getCurrentPercentage($nominee_details_id)
    {
         $sql= "SELECT percentage FROM `nominee_details`  WHERE nominee_details_id='$nominee_details_id' and status in (0,1)";

        $query = $this->db->query($sql);
         if($query->num_rows() > 0){
            $data = $query->row();
           
            return $data->percentage;
         }

         return 0;
    }

    function deleteNomineeDetails($investorId,$nomineeId,$data)
    {
        $this->db->where("investor_id",$investorId);
        $this->db->where("nominee_details_id",$nomineeId);
        $this->db->update("nominee_details", $data);
        //echo $this->db->last_query(); die;
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Preferences_model,  Function : deleteNomineeDetails, investorId: ".investorId." Messege : returning false in else condition *****");
            return false;
        }
    }
	
	function Create_otp_for_edit_profile($userId,$otp)
    {
        $this->db->where("id",$userId);
        $this->db->update("users",['otp_code' => $otp]);
        if($this->db->affected_rows()>0)
        {
            $sql="SELECT users.first_name as name, users.phone,users.email FROM users where id=$userId";
			$query=$this->db->query($sql);
			if($query->num_rows()>0)
			{
				$data = (array) $query->row();
				$data = json_encode($data);
				log_message("info", "***** Model : Preferences_model,  Function : Create_otp_for_edit_profile , userId : ".$userId.", Messege :  returning data : ".$data ." *****");
				return $query->row();
			}
			else
			{
				log_message("info", "***** Model : Preferences_model,  Function : Create_otp_for_edit_profile,  userId : ".$userId.", Messege : returning false in else condition *****");
				return false;
			}
        }
        else
        {
            return false;
        }
    }
	
	public function match_otp_for_check($userid,$otp)
	{
		$result = $this->db->from('users')
				 ->where(['id' => $userid , 'otp_code' => $otp])
				 ->get();
		if($result->num_rows()==1)
		{
			return true;
		}
		else
		{
			log_message("info", "***** Model : Preferences_model,  Function : match_otp_for_check,  userId : ".userid.", Messege : returning false in else condition *****");
			return false;
		}
	}
}
