<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class NetBanking_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }

    function getInvestorsList()
    {
        $sql = "select users.id,users.first_name, users.email, investor.investor_id from users
        inner join investor
        on users.id = investor.login_id
        WHERE users.active = 1
        and investor.is_verify = 1";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getPurchaseFundsReadytoPurchase($fundTypeId,$investor_id)
    {
        $todaysDate=date("Y-m-d");
        $sql="SELECT SUM(unit_count) as unit_count ,sum(purchased_units.purchased_amount) as invested_amount,
        purchased_units.fund_id ,fund_history.nav , fund_history.date,
        SUM(unit_count)*fund_history.nav as total_amount,
        funds.fund_type_id,funds.fund_name FROM purchased_units
        join fund_history on fund_history.fund_id=purchased_units.fund_id
        join funds on purchased_units.fund_id=funds.fund_id
        WHERE `request_status`=1 and funds.fund_type_id='$fundTypeId'
        AND purchased_units.investor_id='$investor_id'
        AND  DATE_FORMAT(`fund_history`.`date`,'%Y-%m-%d')='$todaysDate' group by fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getSoldFunds($fundTypeId,$investor_id)
    {
        $todaysDate=date("Y-m-d");
        $sql="SELECT SUM(unit_count) as unit_count ,
        sold_units.fund_id ,fund_history.nav , fund_history.date,
        SUM(unit_count)*fund_history.nav as total_amount,
        funds.fund_type_id,funds.fund_name FROM sold_units
        join fund_history on fund_history.fund_id=sold_units.fund_id
        join funds on sold_units.fund_id=funds.fund_id
        WHERE `request_status`=1 and funds.fund_type_id='$fundTypeId'
        AND sold_units.investor_id='$investor_id'
        AND  DATE_FORMAT(`fund_history`.`date`,'%Y-%m-%d')='$todaysDate' group by fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getInvestedAmount($fundTypeId,$investor_id)
    {
        $sql="SELECT SUM(unit_count) as unit_count ,
        purchased_units.fund_id ,fund_history.nav , fund_history.date,
        SUM(purchased_units.purchased_amount) as total_amount, funds.fund_type_id,
        funds.fund_name FROM purchased_units
        join fund_history on fund_history.fund_id=purchased_units.fund_id
        join funds on purchased_units.fund_id=funds.fund_id WHERE `request_status`=1
        AND purchased_units.investor_id=$investor_id
        AND DATE_FORMAT(`fund_history`.`date`,'%Y-%m-%d')=purchased_units.date_of_purchase
        AND funds.fund_type_id = $fundTypeId";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
            // returns a single row
            return $query->row();
        }
        else
        {
            return false;
        }
    }
}
