<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); 

class Change_plan_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }


    /***** get chagable plan ****/
    function getAllChangeblePlanByFundType($investorId,$fundTypeId)
    {
        /*
        $sql="SELECT SUM(purchased_units.purchased_amount) as amount, 
        purchased_units.request_date,purchased_units.investment_plan_type, purchased_units.batch_id,funds.fund_name FROM purchased_units JOIN funds on purchased_units.fund_id=funds.fund_id 
        WHERE request_status=0 and is_cancel=0 and purchased_units.investor_id=$investorId and funds.fund_type_id=$fundTypeId  and  DATE_FORMAT(`purchased_units`.`request_date`,'%Y-%m-%d') > now() - INTERVAL 1 day GROUP BY batch_id";
       */
        $sql="SELECT SUM(purchased_units.purchased_amount) as amount, purchased_units.request_date,purchased_units.investment_plan_type, 
        purchased_units.batch_id,funds.scheme_description FROM purchased_units JOIN funds on purchased_units.fund_id=funds.fund_id 
        WHERE request_status=0 and is_cancel=0 and purchased_units.investor_id=$investorId 
        and funds.fund_type_id=$fundTypeId and nb_request=0 and nb_request_status=0 and DATE_FORMAT(`purchased_units`.`request_date`,'%Y-%m-%d') > now() - INTERVAL 1 day 
        GROUP BY batch_id 
        UNION 
        SELECT SUM(sold_units.sold_amount) as amount, sold_units.request_date,sold_units.is_monthly_sip as investment_plan_type ,
        sold_units.batch_id,funds.scheme_description 
        FROM sold_units JOIN funds on sold_units.fund_id=funds.fund_id
        WHERE request_status=0 and is_cancel=0 and sold_units.investor_id=$investorId 
        and funds.fund_type_id=$fundTypeId and DATE_FORMAT(`sold_units`.`request_date`,'%Y-%m-%d') > now() - INTERVAL 1 day GROUP BY batch_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query();die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Change_plan_model,  Function : getAllChangeblePlanByFundType , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Change_plan_model,  Function : getAllChangeblePlanByFundType,  investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }

	    function testCheckgetAllChangeblePlanByFundType($investorId,$fundTypeId)
    {
        /*
        $sql="SELECT SUM(purchased_units.purchased_amount) as amount, 
        purchased_units.request_date,purchased_units.investment_plan_type, purchased_units.batch_id,funds.fund_name FROM purchased_units JOIN funds on purchased_units.fund_id=funds.fund_id 
        WHERE request_status=0 and is_cancel=0 and purchased_units.investor_id=$investorId and funds.fund_type_id=$fundTypeId  and  DATE_FORMAT(`purchased_units`.`request_date`,'%Y-%m-%d') > now() - INTERVAL 1 day GROUP BY batch_id";
       */
        $sql="SELECT SUM(purchased_units.purchased_amount) as amount, purchased_units.request_date,purchased_units.investment_plan_type, 
        purchased_units.batch_id,funds.scheme_description FROM purchased_units JOIN funds on purchased_units.fund_id=funds.fund_id 
        WHERE request_status=0 and is_cancel=0 and purchased_units.investor_id=$investorId 
        and funds.fund_type_id=$fundTypeId and nb_request=0 and nb_request_status=0 and DATE_FORMAT(`purchased_units`.`request_date`,'%Y-%m-%d') > now() - INTERVAL 1 day 
        GROUP BY batch_id 
        UNION 
        SELECT SUM(sold_units.sold_amount) as amount, sold_units.request_date,sold_units.is_monthly_sip as investment_plan_type ,
        sold_units.batch_id,funds.scheme_description 
        FROM sold_units JOIN funds on sold_units.fund_id=funds.fund_id
        WHERE request_status=0 and is_cancel=0 and sold_units.investor_id=$investorId 
        and funds.fund_type_id=$fundTypeId and DATE_FORMAT(`sold_units`.`request_date`,'%Y-%m-%d') > now() - INTERVAL 1 day GROUP BY batch_id";
		echo $sql;
        $query = $this->db->query($sql);
		
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Change_plan_model,  Function : testCheckgetAllChangeblePlanByFundType , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Change_plan_model,  Function : testCheckgetAllChangeblePlanByFundType,  investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }
	
	
    function cancelPlanByBatchId($batchId)
    {
        $this->db->where("batch_id",$batchId);
        $this->db->update("purchased_units",array("is_cancel"=>1));
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Change_plan_model,  Function : cancelPlanByBatchId,  batchId : ".$batchId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    function cancelSipPlanByBatchId($batchId)
    {
        $this->db->where("batch_id",$batchId);
        $this->db->update("monthly_investment",array("is_stopped_sip"=>1));
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Change_plan_model,  Function : cancelSipPlanByBatchId,  batchId : ".$batchId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    function cancelWithdrawByBatchId($batchId)
    {
        $this->db->where("batch_id",$batchId);
        $this->db->update("sold_units",array("is_cancel"=>1));
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
			log_message("info", "***** Model : Change_plan_model,  Function : cancelWithdrawByBatchId,  batchId : ".$batchId.", Messege : returning false in else condition *****");
            return false;
        }
    }
}