<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Purchase_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }

    /** Get invesor bank details **/
    function getInvestorBankAndPanDetail($investorId)
    {
        $sql="SELECT `bank_details`.* ,bank_account_type.account_type,bank_master.bank_name
            FROM bank_details,bank_account_type,bank_master
            WHERE bank_details.account_type_id=bank_account_type.account_type_id
            and bank_details.bank_master_id=bank_master.bank_master_id
            and bank_details.investor_id=$investorId";

        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getInvestorBankAndPanDetail , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getInvestorBankAndPanDetail,  investorId : ".$investorId.", Messege : returning false in else condition *****");
           return false;
        }
    }

    /***** get suggested equity funds by priority based ****/
    function getSuggestedFundsByFundType($fundTypeId)
    {
        date_default_timezone_set("Asia/Kolkata");
        if($fundTypeId==11){
            $noOfSuggestedFunds=15;
        }else{
            $noOfSuggestedFunds=getValue("no_of_suggested_funds");// helper function
        }
        
        $todaysDate=date("Y-m-d");
        $sql="select funds.* FROM funds where funds.fund_type_id=$fundTypeId and priority!=0
        ORDER BY `funds`.`priority` ASC limit $noOfSuggestedFunds";
        $query = $this->db->query($sql);
        // echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getSuggestedFundsByFundType , fundTypeId : ".$fundTypeId.", Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getSuggestedFundsByFundType,  fundTypeId : ".$fundTypeId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    function getFundsByFundTypeId($fundTypeId)
    {
        if($fundTypeId==11){
            $noOfSuggestedFunds=15;
        }else{
            $noOfSuggestedFunds=getValue("no_of_suggested_funds");// helper function
        }
        $sql="select * FROM funds where fund_type_id=$fundTypeId and priority!=0
        ORDER BY `funds`.`priority` ASC,`internal_code` ASC, `plan_option` desc limit $noOfSuggestedFunds";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getFundsByFundTypeId , fundTypeId : ".$fundTypeId.", Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getFundsByFundTypeId,  fundTypeId : ".$fundTypeId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    function getFundDetailsById($fundId)
    {
        $sql="select * FROM funds where fund_id=$fundId";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getFundDetailsById , fundId : ".$fundId.", Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getFundDetailsById,  fundId : ".$fundId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    function addPurchaseFunds($data)
    {
        $this->db->insert("purchased_units",$data);
        if($this->db->affected_rows()>0)
        {
            $insert_id = $this->db->insert_id();
            $this->insertMsgInToDB($data);
            return  $insert_id;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : addPurchaseFunds,  Messege : returning false in else condition *****");
            return false;
        }
    }

    function addPurchaseFundsForCron($data)
    {
        $this->db->insert("purchased_units",$data);
        if($this->db->affected_rows()>0)
        {
            $insert_id = $this->db->insert_id();
            return  $insert_id;
        }
        else
        {
            log_message("info", "***** Model : Purchase_model,  Function : addPurchaseFunds,  Messege : returning false in else condition *****");
            return false;
        }
    }

    public function insertMsgInToDB($data)
    {
        $investorId = $data['investor_id'];
        $res = investor_detail($investorId);
        if($res){
            $amount = $data['purchased_amount'];
            $type = $data['investment_plan_type'];
            $requestDate =  $data['request_date'];
            $msg = $this->encrypt->decode($res->username)." Purchase amount of $amount in $type request date - $requestDate email - ".$res->email." phone ".$this->encrypt->decode($res->phone);
            notificationAlert('Purchase',$msg,$investorId);
        }
    }

    function checkFirstTimePurchaseFund($fundId,$investorId)
    {
        $this->db->where(array('fund_id' =>$fundId ,'investor_id' =>$investorId ));
        $query=$this->db->get("purchased_units");
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : checkFirstTimePurchaseFund , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return  $query->row();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : checkFirstTimePurchaseFund, investorId : ".$investorId.",  Messege : returning false in else condition *****");
            return false;
        }
    }

    function checkFirstTimePurchaseSIPFund($fundId,$investorId)
    {
        $this->db->where(array('fund_id' =>$fundId ,'investor_id' =>$investorId));
        $query=$this->db->get("purchased_units");
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : checkFirstTimePurchaseSIPFund , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return  $query->row();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : checkFirstTimePurchaseSIPFund, investorId : ".$investorId.",  Messege : returning false in else condition *****");
            return false;
        }
    }

    function createNewApiBatchId($apiTypeId)
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="select * from api_batch
        where DATE_FORMAT(`api_batch`.`api_batch_date`,'%Y-%m-%d')='$todaysDate'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
            return  $query->row()->api_batch_id;
        }
        else
        {
            $data=array("api_type_id"=>$apiTypeId,"api_batch_date"=>$todaysDate);
            $this->db->insert("api_batch",$data);
            if ($this->db->affected_rows() > 0)
            {
                return  $this->db->insert_id();
            }
            else
            {
				log_message("info", "***** Model : Purchase_model,  Function : createNewApiBatchId, apiTypeId : ".$apiTypeId.",  Messege : returning false in else condition *****");
                return false;
            }
        }
    }

    function addSipMonthlyInvestmentFunds($data)
    {
        $this->db->insert("monthly_investment",$data);
        if($this->db->affected_rows()>0)
        {
            return  $this->db->insert_id();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : addSipMonthlyInvestmentFunds,   Messege : returning false in else condition *****");
            return false;
        }
    }

    function addMonthlyInvestmentMappingData($data)
    {
        $this->db->insert("monthly_investment_mapping",$data);
        if($this->db->affected_rows()>0)
        {
            return  true;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : addMonthlyInvestmentMappingData,   Messege : returning false in else condition *****");
            return false;
        }
    }

    function getCurrentNavByfundId($fundId)
    {
        date_default_timezone_set("Asia/Kolkata");
        $todaysDate=date("Y-m-d");
        $sql="select fund_history.* from fund_history
        where fund_id=$fundId and DATE_FORMAT(`fund_history`.`date`,'%Y-%m-%d')='$todaysDate'";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getCurrentNavByfundId , fundId : ".$fundId.", Messege :  returning data : ".$data ." *****");
            return  $query->row();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getCurrentNavByfundId,   Messege : returning false in else condition *****");
            return false;
        }
    }

    function createNewPurchaseBatchId($type)
    {
        $this->db->insert("batch",array("type"=>"$type","ts"=>date("Y-m-d h:i:s")));
        if ($this->db->affected_rows() > 0)
        {
            return  $this->db->insert_id();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : createNewPurchaseBatchId,   Messege : returning false in else condition *****");
            return false;
        }
    }


    // This is cron function
    function getPurchaseFundsListForSipMonthly($todaysDate)
    {
        $sql="select * from monthly_investment
        where  no_of_months > no_of_invested_months  and DATE_FORMAT(`monthly_investment`.`next_investment_date`,'%d-%m')='$todaysDate' and is_stopped_sip = 0";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getPurchaseFundsListForSipMonthly , todaysDate : ".$todaysDate.", Messege :  returning data : ".$data ." *****");
            return  $query->result();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getPurchaseFundsListForSipMonthly,   Messege : returning false in else condition *****");
            return false;
        }
    }
	
    function getPurchaseFundsListForSipMonthlySendSms($todaysDate)
    {
        $sql="select monthly_investment.investor_id ,
					SUM(monthly_investment.amount) as amount,
					monthly_investment.next_investment_date ,
                    monthly_investment.no_of_months,
                    monthly_investment.no_of_invested_months,
					investor.login_id , users.email , 
					users.first_name ,
					users.phone 
			from monthly_investment 
			    join investor on monthly_investment.investor_id = investor.investor_id 
				JOIN users on investor.login_id = users.id 
				    where no_of_months > no_of_invested_months and 
					DATE_FORMAT(`monthly_investment`.`next_investment_date`,'%d-%m')='$todaysDate' and monthly_investment.is_stopped_sip = 0 GROUP by monthly_investment.investor_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query();
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getPurchaseFundsListForSipMonthlySendSms , todaysDate : ".$todaysDate.", Messege :  returning data : ".$data ." *****");
            return  $query->result();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getPurchaseFundsListForSipMonthlySendSms,  todaysDate : ".$todaysDate.", Messege : returning false in else condition *****");
            return false;
        }
    }

    // this is cron function after successfully monthly investment update monthly invesment table data
    function updateSipMonthlyInvestmentFunds($monthlyInvestmentId,$monthlyInvestmentdata)
    {
        $this->db->where("monthly_investment_id",$monthlyInvestmentId);
        $this->db->update("monthly_investment",$monthlyInvestmentdata);
        if ($this->db->affected_rows() > 0)
        {
            return  true;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateSipMonthlyInvestmentFunds, Messege : returning false in else condition *****");
            return false;
        }
    }



    function getInstedFundsByBatchId($batchId,$investorId)
    {
        $sql="SELECT purchased_units.*,funds.* FROM purchased_units
        JOIN funds on purchased_units.fund_id=funds.fund_id
        WHERE purchased_units.batch_id='$batchId' and purchased_units.investor_id='$investorId'";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getInstedFundsByBatchId , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return  $query->result();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateSipMonthlyInvestmentFunds, investorId : ".$investorId.",  Messege : returning false in else condition *****");
            return false;
        }
    }

    function updatePurchsedFundsOnServer($investedFundList,$requestDate,$investorId)
    {
        //print_r($investedFundList);
        if(isset($investedFundList) && !empty($investedFundList))
        {
            foreach ($investedFundList as $row)
            {
                $checkData = array('purchased_units_id' =>$row[0] , "investor_id"=>$investorId);
                $updateData = array('purchased_amount' =>$row[1] , "request_date"=>$requestDate);
                $this->db->where($checkData);
                $this->db->update("purchased_units",$updateData);
            }
            if($this->db->_error_number()>0)
            {
                return false;
            }else
            {
				log_message("info", "***** Model : Purchase_model,  Function : updatePurchsedFundsOnServer, investorId : ".$investorId.",  Messege : returning false in else condition *****");
                return true;
            }
        }
    }

    function getSIPInvestedFundsByBatchId($batchId,$investorId)
    {
        $sql="SELECT monthly_investment.*,funds.* FROM monthly_investment
        JOIN funds on monthly_investment.fund_id=funds.fund_id
        WHERE monthly_investment.batch_id='$batchId' and monthly_investment.investor_id='$investorId'";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getSIPInvestedFundsByBatchId , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return  $query->result();
        }
        else
        {
            return false;
        }
    }

    function updateSipPurchsedFundsOnServer($investedFundList,$requestDate,$investorId,$noOfMonths)
    {
		 log_message('info', '***** InvestorId : '.$investorId.',first_time_model_log just visited updateSipPurchsedFundsOnServer');
        //print_r($investedFundList);
        if(isset($investedFundList) && !empty($investedFundList))
        {
            foreach ($investedFundList as $row)
            {
                $checkData = array('monthly_investment_id' =>$row[0] , "investor_id"=>$investorId);
                $time = strtotime($requestDate);
                $nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));
                $updateData = array('amount' =>$row[1] , "next_investment_date"=>$nextInvestmentDate,"no_of_months"=>$noOfMonths);
                $this->db->where($checkData);
                $this->db->update("monthly_investment",$updateData);
				if ($this->db->affected_rows() > 0){
                    $this->updateSIPMonthyDataOnPurchaseUnits($row[0],$investorId,$row[1],$requestDate);
				}else{
					return true;
				}
			}
            if($this->db->_error_number()>0)
            {
				log_message("info", "***** Model : Purchase_model,  Function : updateSipPurchsedFundsOnServer, investorId : ".$investorId.",  Messege : returning false in if condition *****");
                return false;
            }else
            {
				log_message("info", "***** Model : Purchase_model,  Function : updateSipPurchsedFundsOnServer, investorId : ".$investorId.",  Messege : returning true in else condition *****");
                return true;
            }
        }
    }
	
	function updateOnmonthlyTableByCLient($investedFundList,$requestDate,$investorId,$noOfMonths)
    {
        if(isset($investedFundList) && !empty($investedFundList))
        {
            foreach ($investedFundList as $row)
            {
                $checkData = array('monthly_investment_id' =>$row[3] , "investor_id"=>$investorId);
                $updateData = array('amount' =>$row[1] , "next_investment_date"=>$requestDate,"no_of_months"=>$noOfMonths);
                $this->db->where($checkData);
                $this->db->update("monthly_investment",$updateData);
				if ($this->db->affected_rows() > 0)
				{
					log_message("info", "***** Model : Purchase_model,  Function : updateOnmonthlyTableByCLient, investorId : ".$investorId.",  Messege : returning true in if condition *****");
					return $row[3];
				}
				else
				{
					log_message("info", "***** Model : Purchase_model,  Function : updateOnmonthlyTableByCLient, investorId : ".$investorId.",  Messege : returning false in else condition *****");
					return false;
				}
			
			}
           
        }
    }

    function updateSIPMonthyDataOnPurchaseUnits($miId,$investorId,$amount,$requestDate)
    {
        // get monthly sip details
        $sql="SELECT * FROM monthly_investment WHERE monthly_investment_id='$miId'
        and monthly_investment.investor_id='$investorId'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			log_message('info', '***** InvestorId : '.$investorId.',first_time_model_log  updateSIPMonthyDataOnPurchaseUnits query '.$sql.'');
            $batchId=$query->row()->batch_id;
            // get purchased units id by monthly investment id
            $query=$this->db->query("SELECT * FROM `monthly_investment_mapping` WHERE monthly_investment_id='$miId'
            ORDER BY `monthly_investment_mapping`.`monthly_investment_mapping_id` DESC");
            if ($query->num_rows() > 0)
            {
			   $purchasedUnitsId=$query->row()->purchased_units_id;
			log_message('info', '***** InvestorId : '.$investorId.',first_time_model_log  updating query UPDATE `investocafe`.`purchased_units` SET `purchased_amount` = '.$amount.',request_date='.$requestDate.'
                WHERE `purchased_units`.`purchased_units_id` = '.$purchasedUnitsId.' and request_status=0 and is_cancel=0');
                // update amount and request date in purchased units table
                $this->db->query("UPDATE `investocafelive`.`purchased_units` SET `purchased_amount` = '$amount',request_date='$requestDate'
                WHERE `purchased_units`.`purchased_units_id` = '$purchasedUnitsId' and request_status=0 and is_cancel=0");
                //echo $this->db->last_query(); die;
				 if ($this->db->affected_rows() > 0)
				{
					log_message("info", "***** Model : Purchase_model,  Function : updateSIPMonthyDataOnPurchaseUnits, investorId : ".$investorId.",  Messege : returning true in if condition *****");
					return true;
				}
				else
				{
					log_message("info", "***** Model : Purchase_model,  Function : updateSIPMonthyDataOnPurchaseUnits, investorId : ".$investorId.",  Messege : returning false in else condition *****");
					return false;
				}
				
				
            }
        }
        else
        {
            return false;
        }
    }

    function updateFatcaDeclaration($fatca,$investorId)
    {
        $this->db->where("investor_id",$investorId);
        $this->db->update("investor",array("fatca_verify"=>$fatca));
        if ($this->db->affected_rows() > 0)
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateFatcaDeclaration, investorId : ".$investorId.",  Messege : returning true in if condition *****");
            return  true;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateFatcaDeclaration, investorId : ".$investorId.",  Messege : returning false in else condition *****");
            return false;
        }
    }

    function getInvestorDetailById($investorId)
    {
        $sql = "SELECT users.username, investor.gender,investor.politically_exposed,investor.investor_type_id, investor.related_politically_exposed,investor.income,investor.place_of_birth,investor.country_of_birth_id,investor.city_id,investor.pan,
        country.country_id ,country.country_name,t1.country_name as country_of_birth ,city.location_name,
        occupation.occupation_id,nationality.nationality FROM users JOIN investor on users.id=investor.login_id
        LEFT JOIN country ON investor.country=country.country_id  inner join country t1 on investor.country_of_birth_id=t1.country_id
        LEFT JOIN occupation on occupation.occupation_id=investor.occupation_id
        JOIN nationality on investor.nationality_id=nationality.nationality_id JOIN city on investor.city_id =city.id
        where investor.investor_id='$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getInvestorDetailById , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getInvestorDetailById, investorId : ".$investorId.",  Messege : returning null in else condition *****");
            return null;
        }
    }
    function updateInvestorInfo($investorId,$data)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->update("investor",$data);
        // echo $this->db->last_query(); die;
		log_message("info", "***** Model : Purchase_model,  Function : updateInvestorInfo, investorId : ".$investorId.",  Messege : returning true  *****");
        return true;
    }

    function getTaxResidentInfo($investorId)
    {
        $sql = "SELECT tax_residency.tin, tax_residency.country_id,country.country_name FROM tax_residency JOIN country on tax_residency.country_id=country.country_id WHERE tax_residency.investor_id='$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getTaxResidentInfo , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getTaxResidentInfo, investorId : ".$investorId.",  Messege : returning null in else condition *****");
            return null;
        }
    }

    function insertTransactionStartData($netbankingData)
    {
      $data['investor_id'] = $netbankingData['investorId'];
      $data['amt'] = $netbankingData['totalAmount'];
      $data['prod_str'] = $netbankingData['prodStr'];
      $data['purchase_batch_id'] = $netbankingData['batchId'];
	log_message('info', '***** Model : Purchase, Function : insertTransactionStartData, Message : just_visited netbanking data creating query: *****');	  	
      $this->db->insert("netbanking_details",$data);
      if($this->db->affected_rows()>0)
      {
		  log_message("info", "***** Model : Purchase_model,  Function : insertTransactionStartData,  Messege : returning last insert id in if condition *****");
          return  $this->db->insert_id();
      }
      else
      {
		  log_message("info", "***** Model : Purchase_model,  Function : insertTransactionStartData,   Messege : returning false in else condition *****");
          return false;
      }
	
    }

    function updatePurchaseEntry($nb_request_status,$merTxn,$dateOfDeposit,$depositRefNo)
    {
        $data['nb_request_status'] = $nb_request_status;
        $data['date_of_deposit'] = $dateOfDeposit;
        $data['deposit_ref_no'] = $depositRefNo;
        $this->db->where("mer_txn",$merTxn);
        $this->db->update("purchased_units",$data);
        if ($this->db->affected_rows() > 0)
        {
			log_message("info", "***** Model : Purchase_model,  Function : updatePurchaseEntry,   Messege : returning true in if condition *****");
            return  true;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : updatePurchaseEntry,   Messege : returning false in else condition *****");
            return false;
        }
    }

    function updateNetbankingEntry($response)
    {
        $data['mmp_txn'] = $response['mmp_txn'];
        $data['mer_txn'] = $response['mer_txn'];
        $data['amt'] = $response['amt'];
        $data['prod'] = $response['prod'];
        $data['date'] = $response['date'];
        $data['bank_txn'] = $response['bank_txn'];
        $data['f_code'] = $response['f_code'];
        $data['clientcode'] = $response['clientcode'];
        $data['bank_name'] = $response['bank_name'];
        $data['merchant_id'] = $response['merchant_id'];
        $data['udf9'] = $response['udf9'];
        $data['discriminator'] = $response['discriminator'];
        $data['surcharge'] = $response['surcharge'];
        $data['CardNumber'] = $response['CardNumber'];
        $data['udf1'] = $response['udf1'];
        $data['udf2'] = $response['udf2'];
        $data['udf3'] = $response['udf3'];
        $data['udf4'] = $response['udf4'];
        $data['udf5'] = $response['udf5'];
        $data['udf6'] = $response['udf6'];

        $this->db->where("id",$response['mer_txn']);
        $this->db->update("netbanking_details",$data);
        if ($this->db->affected_rows() > 0)
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateNetbankingEntry,   Messege : returning true in if condition *****");
            return  true;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateNetbankingEntry,   Messege : returning false in else condition *****");
            return false;
        }
    }


    function addNetbankingEntry($response)
    {
        $data['mmp_txn'] = $response['mmp_txn'];
        $data['mer_txn'] = $response['mer_txn'];
        $data['amt'] = $response['amt'];
        $data['prod'] = $response['prod'];
        $data['date'] = $response['date'];
        $data['bank_txn'] = $response['bank_txn'];
        $data['f_code'] = $response['f_code'];
        $data['clientcode'] = $response['clientcode'];
        $data['bank_name'] = $response['bank_name'];
        $data['merchant_id'] = $response['merchant_id'];
        $data['udf9'] = $response['udf9'];
        $data['discriminator'] = $response['discriminator'];
        $data['surcharge'] = $response['surcharge'];
        $data['CardNumber'] = $response['CardNumber'];
        $data['udf1'] = $response['udf1'];
        $data['udf2'] = $response['udf2'];
        $data['udf3'] = $response['udf3'];
        $data['udf4'] = $response['udf4'];
        $data['udf5'] = $response['udf5'];
        $data['udf6'] = $response['udf6'];

        $res = $this->db->insert("netbanking_details",$data);
        if ($res)
        {
            return  true;
        }
        else
        {
            return false;
        }
    }


    function getPurchasedItemDetails($mer_txn)
    {
        $sql="SELECT fund_id, purchased_amount, request_date
        FROM purchased_units
        WHERE mer_txn=$mer_txn";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			log_message("info", "***** Model : Purchase_model,  Function : getPurchasedItemDetails, mer_txn : ".$mer_txn."   Messege : returning result array in if condition *****");
            return $query->result_array();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getPurchasedItemDetails, mer_txn : ".$mer_txn."   Messege : returning false in else condition *****");
            return false;
        }
    }

    function getFundTypeIdFromFundId($fundId)
    {
        $sql="SELECT name from fund_type where fund_type_id in (select fund_type_id from funds where fund_id = $fundId)";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getFundTypeIdFromFundId , fundId : ".$fundId.", Messege :  returning data : ".$data ." *****");
            return $query->row()->name;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getFundTypeIdFromFundId, fundId : ".$fundId."   Messege : returning false in else condition *****");
            return false;
        }
    }

	
    function getActualFundTypeIdFromFundId($fundId)
    {
        $sql="select fund_type_id from funds where fund_id = $fundId";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : getActualFundTypeIdFromFundId , fundId : ".$fundId.", Messege :  returning data : ".$data ." *****");
            return $query->row()->fund_type_id;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : getActualFundTypeIdFromFundId, fundId : ".$fundId."   Messege : returning false in else condition *****");
            return false;
        }
    }
    function updateMonthlyInvestment($merTxn)
    {
	
		$sql="Update monthly_investment set is_stopped_sip = 0 where monthly_investment_id in
			(select monthly_investment_id from monthly_investment_mapping where purchased_units_id in
			(select purchased_units_id from purchased_units where mer_txn = '".$merTxn."'))";
		
		$query=$this->db->query($sql);
	
		if($this->db->affected_rows() > 0)
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateMonthlyInvestment, merTxn : ".$merTxn."   Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateMonthlyInvestment, merTxn : ".$merTxn."   Messege : returning false in else condition *****");
            return false;
        }
    }

    function updateDocumentChecklist($investorId,$docTypeId,$data)
    {
        $this->db->where("investor_id",$investorId);
        $this->db->where("document_type_id",$docTypeId);
        $this->db->update("investor_document_type",$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateDocumentChecklist, investorId : ".$investorId."   Messege : returning true in if condition *****");
            return true;
        }else
        {
			log_message("info", "***** Model : Purchase_model,  Function : updateDocumentChecklist, investorId : ".$investorId."   Messege : returning flase in else condition *****");
            return false;
        }
    }
	
/*=============================================================================================================
	CHANGE BY TECHNOUNIVERSE
	DATE : 26/08/2016
	AUTHOER : AMIT MEENA
	COMMENT : IT IS USE TO SET HOLLIDAYS DATE IN THE INVETMENT DATE SELECTOR
==============================================================================================================*/

    public function add_holliday_date()
    {
        $hollidayDate = $this->db->select('HollidayDate')
                         ->from('holliday_date_table')
                         ->where(['HollidayDate > ' => Date("Y-m-d") , 'Status' => 0])
                         ->get();
        return $hollidayDate->result();
    }

    public function get_amc_code($fund_id)
    {
        $amc = $this->db->select('AMC_code')
                 ->from('funds')
                 ->where('fund_id' , $fund_id)
                 ->get();
        if($amc)
        {
			$data = (array) $amc->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : get_amc_code , fundId : ".$fund_id.", Messege :  returning data : ".$data ." *****");
            return $amc->row()->AMC_code;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : get_amc_code, fund_id : ".$fund_id."   Messege : returning false in else condition *****");
            return false;
        }
    }
/*
---------------------------------------------------------------------------------------------------------------
|	author : AMit meena
|	date : 18/11/2016
|	comment : this function is use to select that data that have nb request status =0 from purchased_units table
---------------------------------------------------------------------------------------------------------------
*/

	public function get_nb_failur_data($date)
    {
		$sql = "SELECT mer_txn,ts,SUM(purchased_amount) as purchased_amount FROM purchased_units WHERE nb_request = 1 AND nb_request_status = 0 AND DATE(ts) > '$date'  GROUP BY mer_txn";
        $dt = $this->db->query($sql);
        if($dt)
        {
			$data = (array) $dt->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : get_nb_failur_data , date : ".$date.", Messege :  returning data : ".$data ." *****");
            return $dt->result();
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : get_nb_failur_data, date : ".$date." , Messege : returning false in else condition *****");
            return false;
        }
    }
	
/*
----------------------------------------------------------------------------------------------------------------
|	author : amit meena
|	date : 18/11/2016
|	comment : this function use to update netbanking table......
---------------------------------------------------------------------------------------------------------------
*/

    function requery_updateNetbankingEntry($response)
    {
        $data['mer_txn'] = $response['MerchantTxnID'];
        $data['amt'] = $response['AMT'];
        $data['date'] = $response['TxnDate'];
        $data['bank_txn'] = $response['BID'];
        $data['bank_name'] = $response['bankname'];
        $data['merchant_id'] = $response['MerchantID'];
        $data['udf9'] = "purchaseTransaction";
        $data['discriminator'] = $response['discriminator'];
        $data['surcharge'] = $response['surcharge'];
        $data['CardNumber'] = $response['CardNumber'];
		$data['clientcode'] = "?M";
        $this->db->where("id",$data['mer_txn']);
        $this->db->update("netbanking_details",$data);
        if ($this->db->affected_rows() > 0)
        {
			log_message("info", "***** Model : Purchase_model,  Function : requery_updateNetbankingEntry,  Messege : returning false in else condition *****");
            return  true;
        }
        else
        {
			log_message("info", "***** Model : Purchase_model,  Function : requery_updateNetbankingEntry,  Messege : returning false in else condition *****");
            return false;
        }
    }
	
	public function selectSkipThisMonthSip($monthly_investment_id)
	{
		$res = $this->db->select('next_investment_date')
				 ->from('monthly_investment')
				 ->where('monthly_investment_id',$monthly_investment_id)
				 ->get();
		if($res)
		{
			$data = (array) $res->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Purchase_model,  Function : selectSkipThisMonthSip , monthly_investment_id : ".$monthly_investment_id.", Messege :  returning data : ".$data ." *****");
			return $res->row();
		}
		else{
			log_message("info", "***** Model : Purchase_model,  Function : selectSkipThisMonthSip,  Messege : returning false in else condition *****");
			return false;
		}
	}
	
	public function skipThisMonthSipModel($monthly_investment_id,$nextInvestmentDate)
	{
		$this->db->where('monthly_investment_id',$monthly_investment_id)
				 ->update('monthly_investment',['next_investment_date'=>$nextInvestmentDate]);
		if ($this->db->affected_rows() > 0)
		{
			log_message("info", "***** Model : Purchase_model,  Function : skipThisMonthSipModel,  Messege : returning true in if condition *****");
			return true;
		}
		else
		{
			log_message("info", "***** Model : Purchase_model,  Function : skipThisMonthSipModel,  Messege : returning false in else condition *****");
			return false;
		}	 
		
	}
	
	public function getNetBankingSuccessUserDetai($mer_txn)
	{
		$res = $this->db->query("select users.username , users.phone from users join investor on users.id = investor.login_id join purchased_units on purchased_units.investor_id = investor.investor_id where  purchased_units.mer_txn = $mer_txn limit 0,1");
		if($res->num_rows()>0)
	    {
			return $res->row();
		}
		else
		{
			false;
		}
	}
	
}
