<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Api_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }


    public function getInvestorDetails($investorId)
    {

        $sql="SELECT 
                    users.first_name as first_name, 
                    users.email,users.phone,
                    investor.investor_id,
                    investor.address,
                    investor.address_2 ,
                    investor.pincode ,
                    investor.pan ,
					investor.kin ,
					investor.original_city  ,
                    investor.date_of_birth,
                    investor.guardain_name,
                    investor.guardian_dob,
                    investor.relation_with_guardian,
                    investor_type.*,
                    investor_address_proof.address_proof,
                    country.country_id ,
                    country.country_name,
                    investor_family_status.family_status,
                    occupation.*,
                    nationality.nationality,
                    city.*, 
                    state.*
        FROM investor JOIN investor_type on investor.investor_type_id=investor_type.investor_type_id
        JOIN investor_address_proof on investor.investor_address_proof_id=investor_address_proof.investor_address_proof_id
        JOIN users on users.id=investor.login_id
        LEFT JOIN investor_family_status on investor.investor_family_status_id=investor_family_status.investor_family_status_id
        LEFT JOIN occupation on occupation.occupation_id=investor.occupation_id
        JOIN country on investor.country=country.country_id
        JOIN nationality on investor.nationality_id=nationality.nationality_id
        join city on investor.city_id=city.id JOIN state on investor.state_id=state.id where investor.investor_id='$investorId'";

        $query = $this->db->query($sql);
        //echo $this->db->last_query();die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getInvestorDetails , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getInvestorDetails,  investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }


    function getInvestorOverseasDetails($investorId)
    {
        $sql="SELECT investor_address_proof.address_proof,country.country_id ,country.country_name,
        investor_overseas_details.* FROM investor_overseas_details
        JOIN investor_address_proof on investor_overseas_details.overseas_address_proof_id=investor_address_proof.investor_address_proof_id
        JOIN country on investor_overseas_details.country_id=country.country_id where investor_overseas_details.investor_id='$investorId'";
        $query = $this->db->query($sql);
        //echo $this->db->last_query();die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getInvestorOverseasDetails , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getInvestorOverseasDetails,  investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    function getInvestorBankDetails($investorId)
    {
        $sql="SELECT `bank_details`.* ,bank_account_type.*,bank_master.bank_name
            FROM bank_details,bank_account_type,bank_master
            WHERE bank_details.account_type_id=bank_account_type.account_type_id
            and bank_details.bank_master_id=bank_master.bank_master_id
            and bank_details.investor_id=$investorId";
        $query = $this->db->query($sql);
        //echo $this->db->last_query();die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getInvestorBankDetails , investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getInvestorBankDetails,  investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }

    // first purchase for today's purchase funds (one time investment)
    function getFirstPurchasedList()
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        //DATE_FORMAT(`request_date`,'%Y-%m-%d')='$todaysDate' and
        $sql="SELECT investor_id, purchased_units_id, fund_id ,request_date,purchased_amount ,is_first_purchase ,amc_code,date_of_deposit,deposit_ref_no , investor_ip FROM `purchased_units` WHERE
        `request_status` = 0 
        and is_monthly_sip=0 and date_of_deposit<>'0000-00-00 00:00:00'
        and deposit_ref_no <>'' and trans_upload_status=0 and is_first_purchase = 1 
		and DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getFirstPurchasedList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getFirstPurchasedList,  Messege : returning false in else condition *****");
            return false;
        }
    }

    // addtional purchase for today's purchase funds (one time investment)
    function getAdditionalPurchasedList()
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        //DATE_FORMAT(`request_date`,'%Y-%m-%d')='$todaysDate' and
        $sql="SELECT * FROM `purchased_units` WHERE
        `request_status` = 0 and `is_first_purchase` = 0 and date_of_deposit<>'0000-00-00 00:00:00' and deposit_ref_no <>'' and trans_upload_status=0 
		and DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getAdditionalPurchasedList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getAdditionalPurchasedList,  Messege : returning false in else condition *****");
            return false;
        }
    }

    // first purchase for today's sip funds (monthly sip)
    function getFirstPurchasedSIPList()
    {
		date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT * FROM purchased_units p, monthly_investment m, monthly_investment_mapping mm WHERE
        p.purchased_units_id = mm.purchased_units_id and m.monthly_investment_id = mm.monthly_investment_id
        and p.request_status = 0
        and p.is_first_purchase = '1' and p.is_monthly_sip='1'
        and p.date_of_deposit<>'0000-00-00 00:00:00' and p.deposit_ref_no <>''
        and m.is_stopped_sip<>1
		and trans_upload_status=0
		and DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'";

        $query = $this->db->query($sql);

        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getFirstPurchasedSIPList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getFirstPurchasedSIPList,  Messege : returning false in else condition *****");
            return false;
        }
    }

    // addtional purchase for today's sip purchase funds (monthly sip)
    function getAdditionalPurchasedSIPList()
    {
		date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT * FROM purchased_units p, monthly_investment m, monthly_investment_mapping mm WHERE
        p.purchased_units_id = mm.purchased_units_id and m.monthly_investment_id = mm.monthly_investment_id
        and p.request_status = 0
        and p.is_first_purchase = '0' and p.is_monthly_sip='1'
        and p.date_of_deposit<>'0000-00-00 00:00:00' and p.deposit_ref_no <>''
        and m.is_stopped_sip<>1
		and trans_upload_status=0
		and DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'";

        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getAdditionalPurchasedSIPList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getAdditionalPurchasedSIPList,  Messege : returning false in else condition *****");
            return false;
        }
    }

    function getFirstPurchaseSIPDetails($investor_id, $fund_id)
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT * FROM `purchased_units` WHERE
        investor_id='$investor_id'
        and `fund_id` = $fund_id
        and `is_first_purchase` = 1 and `is_monthly_sip`='1'
		and DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'";
        $query = $this->db->query($sql);
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getFirstPurchaseSIPDetails , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getFirstPurchaseSIPDetails,  Messege : returning false in else condition *****");
            return false;
        }
    }

    // get redemption list by amount for (one time investment)
    function getRedemptionList($withdrawType)
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT * FROM `sold_units` WHERE
        DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'
        and `request_status` = 0
		and `is_cancel` = 0
		and `trans_upload_status` = 0
        and DATE_FORMAT(`date_of_sale`,'%Y-%m-%d') ='0000-00-00'
        and withdraw_type='$withdrawType'";
        $query = $this->db->query($sql);
        //echo $this->db->last_query();die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getRedemptionList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getRedemptionList,  Messege : returning false in else condition *****");
            return false;
        }
    }

    function getRedemptionListNew()
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT * FROM `sold_units` WHERE
        DATE_FORMAT(`request_date`,'%Y-%m-%d')<='$todaysDate'
        and `request_status` = 0
        and `is_cancel` = 0
        and `trans_upload_status` = 0
        and DATE_FORMAT(`date_of_sale`,'%Y-%m-%d') ='0000-00-00'";
        $query = $this->db->query($sql);
        //echo $this->db->last_query();die;
        if ($query->num_rows() > 0)
        {
            $data = (array) $query->result();
            $data = json_encode($data);
            log_message("info", "***** Model : Api_model,  Function : getRedemptionList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
            log_message("info", "***** Model : Api_model,  Function : getRedemptionList,  Messege : returning false in else condition *****");
            return false;
        }
    }

    // get redemption list by withdraw type for(monthly sip)
    function getRedemptionSIPList($withdrawType)
    {
        date_default_timezone_set('Asia/Calcutta');
        $todaysDate=date("Y-m-d");
        $sql="SELECT * FROM `sold_units` WHERE
        DATE_FORMAT(`request_date`,'%Y-%m-%d')<'$todaysDate'
        and `request_status` = 0 and DATE_FORMAT(`date_of_sale`,'%Y-%m-%d') ='0000-00-00'
        and sold_units.is_monthly_sip='1'
        and withdraw_type='$withdrawType'";
        $query = $this->db->query($sql);
        //echo $this->db->last_query();die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getRedemptionSIPList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getRedemptionSIPList,  Messege : returning false in else condition *****");
            return false;
        }
    }

    function getFundDetails($fund_id)
    {
         /* $sql="SELECT funds.AMC_code,
                funds.scheme_code,
                funds.plan_option,
                funds.api_type_id,
                funds.plan_code FROM funds WHERE funds.fund_id='$fund_id'"; */
       $sql="SELECT 
                funds.AMC_code,
                funds.scheme_code,
                funds.plan_option,
                funds.api_type_id,
                funds.plan_code,
                fund_bank_details.* FROM funds JOIN fund_bank_details on funds.fund_id=fund_bank_details.fund_id WHERE funds.fund_id='$fund_id'";
       $query = $this->db->query($sql);
       if ($query->num_rows() > 0)
       {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getRedemptionSIPList , Messege :  returning data : ".$data ." *****");
			return $query->row();
       }
       else
       {
		   log_message("info", "***** Model : Api_model,  Function : getRedemptionSIPList,  Messege : returning false in else condition *****");
           return false;
       }
    }

    /** get investor nominee details **/
    function getInvestorNomineeDetail($invId)
    {
      $sql="SELECT * FROM `nominee_details` where nominee_details.status='1' and nominee_details.investor_id=$invId";
      $query=$this->db->query($sql);
      if($query->num_rows() > 0)
      {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getInvestorNomineeDetail , Messege :  returning data : ".$data ." *****");
			return $query->result();
      }
      else
      {
			log_message("info", "***** Model : Api_model,  Function : getInvestorNomineeDetail ,  Messege : returning false in else condition *****");
         return false;
      }
    }

    function getMontlyInvestmentDetails($purchased_units_id){
      $sql = "SELECT mi.* FROM monthly_investment mi, monthly_investment_mapping mip, purchased_units pu WHERE mip.monthly_investment_id=mi.monthly_investment_id and mip.purchased_units_id=pu.purchased_units_id and pu.purchased_units_id='".$purchased_units_id."'";
      $query=$this->db->query($sql);
      if($query->num_rows() > 0)
      {
		  $data = (array) $query->row();
		  $data = json_encode($data);
		  log_message("info", "***** Model : Api_model,  Function : getMontlyInvestmentDetails , Messege :  returning data : ".$data ." *****");
         return $query->row();
      }
      else
      {
		  log_message("info", "***** Model : Api_model,  Function : getMontlyInvestmentDetails ,  Messege : returning false in else condition *****");
         return false;
      }
    }


    function getPayoutMechCodeForCams($amcCode)
    {
        $sql = "SELECT * FROM cams_amc_payout_mechanism where amc_code = '".$amcCode."'";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Api_model,  Function : getPayoutMechCodeForCams , Messege :  returning data : ".$data ." *****");
            $result = $query->row();
            return $result->payout_mechanism;
        }
        else
        {
			log_message("info", "***** Model : Api_model,  Function : getPayoutMechCodeForCams ,  Messege : returning false in else condition *****");
            return false;
        }
    }


    public function update_request_status($purchased_units_id)
    {
        $this->db->where('purchased_units_id' , $purchased_units_id)
                 ->update('purchased_units',['trans_upload_status' => 1]);
    }
	
	public function update_request_status_for_sold_units($sold_units_id,$file='')
    {
        $this->db->where('sold_units_id' , $sold_units_id)
                 ->update('sold_units',['trans_upload_status' => 1,'feed_path'=>$file]);
    }
}
