<?php

class Referals_model extends CI_Model
{
	public function investerFriends($investor_id)
	{
		$res = $this->db->where(['investor_id'=> $investor_id,'reg_status_id'=> 0])->from('referrals')->get();
		if($res->num_rows() > 0){
			return $res->result();
		}else{
			return false;
		}
	}

	public function acceptRefer($investor_id)
	{
		$accepted_users = $this->db->where(['investor_id'=> $investor_id,'reg_status_id >'=> 0,'reg_status_id <'=> 4])
								   ->from('referrals')->get();
		if($accepted_users->num_rows() > 0){
			return $accepted_users->result();
		}else{
			return false;
		}
	}

	public function acceptReferComplte($investor_id)
	{
		$accepted_users = $this->db->where(['investor_id'=> $investor_id,'reg_status_id >'=> 3])
								   ->from('referrals')->get();
		if($accepted_users->num_rows() > 0){
			return $accepted_users->result();
		}else{
			return false;
		}
	}

	public function checkEmailExist($investor_id,$email)
	{
		$res = $this->db->query("SELECT * FROM referrals WHERE investor_id = $investor_id AND email = '".$email."'");
		if($res->num_rows() > 0){
			return false;
		}else{
			return true;
		}
	}


	public function googledata($email,$investor_id)
	{
		$this->db->query("INSERT INTO `referrals` (`referrals_id`, `name`, `phone`, `email`, `investor_id`, `get_from`, `ts`) VALUES (NULL, NULL, NULL, '".$email."', '".$investor_id."','google-plus.png', CURRENT_TIMESTAMP)");
	}

	public function directReferalIsert($name,$email,$phone)
	{
		$investor_id = $_SESSION['refer_investor_id'];
		$emailver = $this->db->from('referrals')->where(['email'=> $email,'investor_id' => $investor_id])->get();
		if($emailver->num_rows() > 0){
			$this->db->where('referrals_id',$emailver->row()->referrals_id)->update('referrals',['name'=>$name,'phone'=>$phone , 'get_from' => 'mobile-icon.png','is_invited' => 1]);
		}else{
			$phonever = $this->db->from('referrals')->where(['phone'=> $phone,'investor_id' => $investor_id])->get();
			if($phonever->num_rows() > 0){
				$this->db->where('referrals_id',$emailver->row()->referrals_id)->update('referrals',['name'=>$name,'email'=>$email,'get_from' => 'mobile-icon.png','is_invited' => 1]);
			}else{
				$res = $this->db->insert('referrals',['name' => $name,'email' => $email , 'phone' => $phone ,'investor_id' => $investor_id,'get_from' => 'mobile-icon.png','is_invited' => 1]);
				if($res){
					return true;
				}else{
					return false;
				}
			}
		}
		if($this->db->affected_rows() > 0){
			return true;
		}else{
			return false;
		}
	}

	public function getReferLinkModel($investor_id)
	{
	    $res = $this->db
					->select("users.username,users.email,investor.application_number")
					->from('users')
					->join('investor','investor.login_id=users.id')
					->where('investor.investor_id',$investor_id)
					->get();
		if($res->num_rows() > 0)
		{
			return $res->row();
		}
		else
		{
			return false;
		}
	}

	public function getAllPoints($investor_id)
	{
		$res = $this->db->query("SELECT * FROM `referral_points` WHERE `referral_code` = (SELECT email FROM users WHERE id=(SELECT login_id FROM investor WHERE investor_id = $investor_id))");
		if($res->num_rows() > 0){
			$creadit = 0;
			$debit = 0;
			$result = $res->result();
			foreach ($result as $key => $value) {
				if($value->status == 1){
					$creadit = $creadit + $value->points;
				}
				elseif($value->status == 2){
					$debit = $debit + $value->points;
				}
			}

			$totalPoints = $creadit - $debit;
			return $totalPoints;
		}else{
			return '0.00';
		}
	}

	public function getInfoOfRegistration($name,$phone,$email,$investor_id,$token)
	{

		if($token)
		{
			$referal_email = base64_decode($token);
			$response = $this->db->query("SELECT investor_id FROM investor JOIN users ON investor.login_id = users.id WHERE users.email = '".$referal_email."'");
			if($response->num_rows() > 0)
			{
				$friend_investor_id = $response->row()->investor_id;
				$res = $this->db->from('referrals')->where(['investor_id' => $friend_investor_id , 'email' => $email])->get();
				if($res->num_rows() > 0){
					$row = $res->row();
					$this->db->where('referrals_id',$row->referrals_id)->update('referrals',[
						'name' => $name,
						'phone' => $phone,
						'is_invited' => 1,
						'reg_status_id' => 1,
						'friend_investor_id'=>$investor_id
					]);
				}else{
					$this->db->insert('referrals',[
						'name' => $name,
						'phone' => $phone,
						'email' => $email,
						'investor_id' => $friend_investor_id,
						'get_from'	 => 'mobile-icon.png',
						'is_invited' => 1,
						'reg_status_id' => 1,
						'friend_investor_id'=>$investor_id
					]);
				}
			}
		}
	}

	public function addContactBySocials($email,$investor_id)
	{
		$res = $this->db->query("SELECT * FROM referrals WHERE investor_id = $investor_id AND email = '".$email."'");
		if($res->num_rows() == 0){
			$this->db->query("INSERT INTO `referrals` (`referrals_id`, `name`, `phone`, `email`, `investor_id`, `get_from`, `ts`) VALUES (NULL, NULL, NULL, '".$email."', '".$investor_id."','hot-mail.png', CURRENT_TIMESTAMP)");
		}
	}

	public function sendInvitationModelToGetData($investor_id)
	{
		$userData = $this->db->query("SELECT email,username,phone from users WHERE id = (SELECT login_id FROM investor WHERE investor_id = $investor_id)");
		if($userData->num_rows() > 0)
		{
			return $userData->row();
		}
		else
		{
			return false;
		}
	}

	public function auth_otp_model($email,$otp)
	{
		$res = $this->db->query("SELECT investor.investor_id,users.email FROM investor JOIN users ON investor.login_id = users.id WHERE users.email = '".$email."' AND users.otp_code = ".$otp);
		if($res->num_rows() > 0)
		{
			return $res->row();
		}
		else
		{
			return false;
		}
	}

	public function getPointsFromPurchaseModel($investor_id)
	{
		$res =$this->db->query("SELECT purchased_units_id, purchased_amount, investor_id,is_first_purchase FROM purchased_units WHERE investor_id IN( SELECT friend_investor_id FROM referrals WHERE is_invited = 1 AND reg_status_id >= 3 AND investor_id = $investor_id ) AND purchased_units.unit_count > 0.00 AND purchased_units_id NOT IN( SELECT purchase_units_id FROM referral_points WHERE points_type = 2 )");
		if($res->num_rows() > 0)
		{
			return $res->result();
		}
		else
		{
			return false;
		}
	}



	public function checkRegistrationComplte($investor_id)
	{
		$res = $this->db->query("SELECT investor_id,is_do_not_reg_nominee,is_incomplete_bank_detail FROM investor WHERE investor_id in (SELECT `friend_investor_id` FROM referrals WHERE investor_id = $investor_id and `reg_status_id` BETWEEN 1 and 3)");
		if($res->num_rows() > 0){
			foreach ($res->result() as $key => $value) {
				if($value->is_do_not_reg_nominee == 0 and $value->is_incomplete_bank_detail == 0)
				{
					$this->db->where('friend_investor_id',$value->investor_id)->update('referrals',['reg_status_id' => 3]);
				}
			}
		}
	}

	public function updatePurchasedStatusInReferaltable($friend_investor_id)
	{
		$this->db->where('friend_investor_id',$friend_investor_id)->update('referrals',['reg_status_id' => 4]);
	}

}