<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
-------------------------------------------------------------------------------------------------------------
|   NAME OF MODEL : Registration_model
|   DATE : 04/10/2016
|   AUTHOER : amit meena
|   COMMENT : This model class is used to insert data into user table to save investor detail
|   FUNCTION USE : 
|                   FUNTION NAME                                   TABLE USE
|                   addInvestor                                 :  investor
|                   getAllInvestorType                          :  investor_type
|                   getdocumentTypeList                         :  document_type
|                   getInvestorDetailInRegistrationForm         :  JOIN - user,investor
|                   getInvestorDetail                           :   JOIN
|                   getInvestorNomineeDetail                    :   JOIN
|                   getInvestorBankAndPanDetail                 :   JOIN
|                   getInvestorAddressProofList                 :   JOIN
|                   getInvestorFamilyStatusList                 :   JOIN
|                   getbankMasterList                           :   JOIN
|                   getbankMasterAll                            :   JOIN
|                   getInvestorOccupationList                   :   JOIN
|                   getInvestorBankAccountTypeList
|                   getInvestorRegistrationFormModifyDetail
|                   checkUserExistingInfo
|                   updateInvestorInfo
|                   addInvestorNomineeDetails
|                   updateInvestorNomineeDetails
|                   addInvestorBankDetails
|                   updateInvestorBankDetails
|                   deleteInvestorNomineeDetails
|                   getCountyList
|                   getAllNationalities
|                   addTaxResidencies
|                   getAllTaxResidencies
|                   deleteInvestorTaxResidency
|                   deleteInvestorOverseasDetails
|                   getDetailsByIfscCode
|                   updateKycStatusDone
|                   removeNominee
|                   checkNoOfNominee
|                   checkNomineeTotalPercentage
|                   getInvestorStatus
|                   getCityList
|                   getStateList
|                   getInvestorOverseasDetail
|                   addInvestorOverseasDetails
|                   updateInvestorOverseasDetails
|                   checkInvestorOverseasDetail
|                   uploadCancelChequeImageUrl
|                   getAssistantEmpList
|                   getAllPanNoList
|                   updateInvestorDocumentChecklist
|                   addInvestorDocumentType
|                   get_state_model
|                   update_is_inv_colmn_in_investor_table
|                   update_is_inv_table
-----------------------------------------------------------------------------------------------------------
|
|   MODIFICATION FUNCTION NAME :
|   DATE : 
|   COMMENT : 
------------------------------------------------------------------------------------------------------------
*/
class Registration_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }

/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : addInvestor
|   DATE : 04/10/2016
|   COMMENT :  This function is use to insert data into invester table 
|   TABLE : investor
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function addInvestor($data)
    {
        $this->db->insert("investor",$data);
        if($this->db->affected_rows()>0)
        {
            $investorId =  $this->db->insert_id();
			log_message("info", "***** Model : Registration_model,  Function : addInvestor ,  Messege : returning  last insert id that is investor id ".$investorId." *****");
			return $investorId;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : addInvestor ,  Messege : returning false data not inserted *****");
            return false;
        }
    }

/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getAllInvestorType
|   DATE : 04/10/2016
|   COMMENT :  This function is use to get investor type from investor_type tbale 
|   TABLE : investor_type
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    /**  **/
    function getAllInvestorType()
    {
        $this->db->where("status",1);
        $query=$this->db->get("investor_type");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getAllInvestorType , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getAllInvestorType ,  Messege : returning false data not found *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getdocumentTypeList
|   DATE : 04/10/2016
|   COMMENT :  This function is use to get get all document type list is used to submit by investor
|   TABLE : document_type
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function getdocumentTypeList()
    {
        $this->db->where("status",1);
        $query=$this->db->get("document_type");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getdocumentTypeList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getdocumentTypeList ,  Messege : returning false data not found *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getdocumentTypeList
|   DATE : 04/10/2016
|   COMMENT :  This function is use to get investor detail in registration form for modify
|   TABLE : users , investor
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function getInvestorDetailInRegistrationForm($investorId)
    {
        $sql="SELECT users.first_name as name,users.company as company_reg_no ,users.name_first,users.name_middle,users.name_last, users.phone,investor.*
        FROM investor
        JOIN users
        on users.id = investor.login_id
        JOIN investor_type
        on investor.investor_type_id=investor_type.investor_type_id
        left join city
        on investor.city_id = city.id
        left join state
        on investor.state_id = state.id
        where investor.investor_id='$investorId'";
        $query=$this->db->query($sql);
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorDetailInRegistrationForm , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorDetailInRegistrationForm ,  Messege : returning false data not found *****");
            return false;
        }
    }

    function getInvestorDatailFirstStatpRegitration($investorId)
    {
        $sql="SELECT users.first_name as name ,users.company as company_regitration_number,users.name_first,users.name_middle,users.name_last, users.phone,investor.*
        FROM investor
        JOIN users
        on users.id = investor.login_id where investor.investor_id = '$investorId'";

        $query=$this->db->query($sql);
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorDetailInRegistrationForm , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorDetailInRegistrationForm ,  Messege : returning false data not found *****");
            return false;
        }
    }

    public function  checkFirstRegitration($investorId)
    {
        $sql="SELECT * from investor_status where is_investor_registered = 0 and first_registration = 1 and  investor_id = '$investorId'"; 
        $query=$this->db->query($sql);
        if($query->num_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : checkFirstRegitration ,  Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : checkFirstRegitration ,  Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorDetail
|   DATE : 04/10/2016
|   COMMENT :  This function is use to get investor detail in registration form for modify
|   TABLE : users , investor , investor_status , investor_address_proof , city , state , investor_family_status
|           occupation , country , nationality
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function getInvestorDetail($invId)
    {
        $sql="SELECT users.username as name, users.email,users.phone,users.company,investor.*,investor_type.investor_type,
        investor_address_proof.address_proof,investor_id_proof.id_proof,investor_status.is_investor_registered_date,country.country_id ,country.country_name,city.id,city.location_name,
        state.id, state.state_name,
        investor_family_status.family_status,occupation.occupation,nationality.nationality
        FROM investor JOIN investor_type on investor.investor_type_id=investor_type.investor_type_id
        LEFT JOIN  investor_status ON investor.investor_id=investor_status.investor_id
        LEFT JOIN investor_address_proof on investor.investor_address_proof_id=investor_address_proof.investor_address_proof_id
        LEFT JOIN investor_id_proof ON investor.investor_id_proof_id=investor_id_proof.investor_id_proof_id
        LEFT JOIN city on investor.city_id = city.id
        LEFT JOIN state on investor.state_id=state.id
        JOIN users on users.id=investor.login_id
        LEFT JOIN investor_family_status on investor.investor_family_status_id=investor_family_status.investor_family_status_id
        LEFT JOIN occupation on occupation.occupation_id=investor.occupation_id
        JOIN country on investor.country=country.country_id
        JOIN nationality on investor.nationality_id=nationality.nationality_id where investor.investor_id='$invId'";

        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorDetail , InvestorId : ".$invId." ,  Messege :  returning data : ".$data ." *****");
            return $query->row();

        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorDetail ,InvestorId : ".$invId." ,   Messege : returning false in else condition *****");
            return false;
        }
    }
	
	function getInvestorDetailforshowprofile($invId)
    {
        $sql="SELECT * FROM investor WHERE investor_id = $invId";

        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorDetailforshowprofile , InvestorId : ".$invId." ,  Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorDetailforshowprofile ,InvestorId : ".$invId." ,   Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorDetail
|   DATE : 04/10/2016
|   COMMENT :  This function is use to get investor nominee details
|   TABLE : nominee_details
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    /**  **/
    function getInvestorNomineeDetail($invId)
    {
        $sql="SELECT * FROM `nominee_details`
        where nominee_details.status='1' and nominee_details.investor_id='$invId'";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorNomineeDetail ,InvestorId : ".$invId." ,   Messege : returning false in else condition *****");
            return "false";
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorBankAndPanDetail
|   DATE : 04/10/2016
|   COMMENT :  This function is use to get investors bank and pan details
|   TABLE : bank_details
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function getInvestorBankAndPanDetail($invId)
    {
        $sql="SELECT `bank_details`.* ,bank_account_type.account_type,
        bank_master.bank_name, bank_master.atom_code
        FROM bank_details,bank_account_type,bank_master
        WHERE bank_details.account_type_id=bank_account_type.account_type_id
        and bank_details.bank_master_id=bank_master.bank_master_id
        and bank_details.investor_id='$invId'";

        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorBankAndPanDetail , InvestorId : ".$invId." ,  Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorBankAndPanDetail ,InvestorId : ".$invId." ,   Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorAddressProofList
|   DATE : 04/10/2016
|   COMMENT :  this function get investor address proof list
|   TABLE : investor_address_proof
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function getInvestorAddressProofList()
    {
        $this->db->where("is_deleted",0);
        $query=$this->db->get("investor_address_proof");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorAddressProofList ,   Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorAddressProofList ,   Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorIdProofList
|   DATE : 04/10/2016
|   COMMENT :  this function get investor id proof list 
|   TABLE : investor_id_proof
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function getInvestorIdProofList()
    {
        $this->db->where("is_deleted",0);
        $query=$this->db->get("investor_id_proof");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorIdProofList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorIdProofList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorFamilyStatusList
|   DATE : 04/10/2016
|   COMMENT :  this function get investor family status list
|   TABLE : investor_family_status
|   CHECK STATUS : TRUE
|   TEST STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function getInvestorFamilyStatusList()
    {
        $query=$this->db->get("investor_family_status");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorFamilyStatusList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorFamilyStatusList , Messege : returning false in else condition *****");
            return false;
        }
    }

    /** Get bank master list **/
    function getbankMasterList()
    {
        $query=$this->db->query("SELECT * FROM `bank_master` WHERE status = 1 order BY bank_master.bank_name");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getbankMasterList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getbankMasterList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getbankMasterAll
|   DATE : 04/10/2016
|   COMMENT :  this function get all bank master list
|   TABLE : bank_master
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function getbankMasterAll()
    {
        $query=$this->db->query("SELECT * FROM `bank_master` order BY bank_master.bank_name");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getbankMasterAll , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getbankMasterAll , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorOccupationList
|   DATE : 04/10/2016
|   COMMENT :  this function get investor's occupation list
|   TABLE : occupation
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function getInvestorOccupationList()
    {
        $query=$this->db->query("SELECT * FROM occupation WHERE status =1 ");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorOccupationList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorOccupationList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorBankAccountTypeList
|   DATE : 04/10/2016
|   COMMENT :  get investor bank account type 
|   TABLE : occupation
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function getInvestorBankAccountTypeList()
    {
        $this->db->where('account_type_id !=', 0);
        $query=$this->db->get("bank_account_type");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorBankAccountTypeList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorBankAccountTypeList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getInvestorRegistrationFormModifyDetail
|   DATE : 04/10/2016
|   COMMENT :  get investor bank account type 
|   TABLE : users , investor , investor_type , nationality
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function getInvestorRegistrationFormModifyDetail($investorId)
    {
        $sql="SELECT users.first_name as name,investor.date_of_birth,investor.armed_forces,investor_type.investor_type_id,investor_type.investor_type,investor_type.status,nationality.nationality
        FROM investor
        JOIN users
        on users.id = investor.login_id
        JOIN investor_type
        on investor.investor_type_id=investor_type.investor_type_id join nationality on investor.nationality_id=nationality.nationality_id
        where investor.investor_id=$investorId ";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorRegistrationFormModifyDetail , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorRegistrationFormModifyDetail , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : checkUserExistingInfo
|   DATE : 04/10/2016
|   COMMENT :  check user other info using his email
|   TABLE : users
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function checkUserExistingInfo($email)
    {
        $this->db->where('email', $email);
        $query=$this->db->get("users");
        if($query->num_rows()>0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : checkUserExistingInfo , email : ".$email." , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : checkUserExistingInfo , email : ".$email." , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : updateInvestorInfo
|   DATE : 04/10/2016
|   COMMENT :  this function is use to update user data in investor table
|   TABLE : users
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function updateInvestorInfo($investorId,$data)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->update("investor",$data);
        return true;
    }

    /** this function add investor's nominee details **/
    function addInvestorNomineeDetails($data)
    {
        $this->db->insert("nominee_details",$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : addInvestorNomineeDetails ,  Messege : returning last insert id *****");
            return $this->db->insert_id();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : addInvestorNomineeDetails ,  Messege : returning false in else condition *****");
            return false;
        }
    }

/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : updateInvestorNomineeDetails
|   DATE : 04/10/2016
|   COMMENT :  update nomeeni detail
|   TABLE : nominee_details
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function updateInvestorNomineeDetails($investorId,$data)
    {

		$sql="SELECT status FROM nominee_details where investor.investor_id=$investorId ";
		$query=$this->db->query($sql);
		if($query->num_rows() > 0){
			$this->db->where("investor_id", $investorId);
			$this->db->where("status", 1);
			$this->db->update("nominee_details",$data);
			return true;
		}
		else{
			$this->db->insert("nominee_details",$data);
			if($this->db->affected_rows()>0)
			{
				log_message("info", "***** Model : Registration_model,  Function : updateInvestorNomineeDetails ,  investorId : ".$investorId." , Messege : returning last insert id *****");
				return $this->db->insert_id();
			}
			else
			{
				log_message("info", "***** Model : Registration_model,  Function : updateInvestorNomineeDetails , investorId : ".$investorId." , Messege : returning false in else condition *****");
				return false;
			}
		}
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : addInvestorBankDetails
|   DATE : 04/10/2016
|   COMMENT : this function add investor bank details
|   TABLE : bank_details
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    /**  **/
    function addInvestorBankDetails($bankData)
    {
        $this->db->insert("bank_details",$bankData);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : addInvestorBankDetails , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : addInvestorBankDetails , Messege : returning false in else condition *****");
            return false;
        }
    }

/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : updateInvestorBankDetails
|   DATE : 04/10/2016
|   COMMENT : this function update investor bank details
|   TABLE : bank_details
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function updateInvestorBankDetails($investorId,$bankData)
    {

		$sql="SELECT bank_details_id FROM bank_details where bank_details.investor_id=$investorId ";
		$query=$this->db->query($sql);
		if($query->num_rows() > 0){
			$this->db->where("investor_id", $investorId);
			$this->db->update("bank_details",$bankData);
			if ($this->db->affected_rows()>0){
				log_message("info", "***** Model : Registration_model,  Function : updateInvestorBankDetails , investorId : ".$investorId." Messege : returning true in if condition *****");
				return true;
			}
			else
			{
				log_message("info", "***** Model : Registration_model,  Function : updateInvestorBankDetails , investorId : ".$investorId." Messege : returning false in else condition *****");
				return false;
			}
		}
		else{
			$this->db->insert("bank_details",$bankData);
			if($this->db->affected_rows()>0)
			{
				log_message("info", "***** Model : Registration_model,  Function : updateInvestorBankDetails , investorId : ".$investorId." Messege : returning true in if condition *****");
				return true;
			}
			else
			{
				log_message("info", "***** Model : Registration_model,  Function : updateInvestorBankDetails , investorId : ".$investorId." Messege : returning false in else condition *****");
				return false;
			}
		}
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : deleteInvestorNomineeDetails
|   DATE : 04/10/2016
|   COMMENT : delete nomeeni
|   TABLE : bank_details
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function deleteInvestorNomineeDetails($investorId)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->delete("nominee_details");
        return true;
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : updateInvestorStatus
|   DATE : 04/10/2016
|   COMMENT : insert data into investor_status
|   TABLE : investor_status
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function updateInvestorStatus($data)
    {
        $this->db->insert("investor_status",$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : updateInvestorStatus ,  Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : updateInvestorStatus ,  Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : updateInvestorStatus
|   DATE : 04/10/2016
|   COMMENT : insert data into investor_status
|   TABLE : investor_status
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function updateInvestorStatusSecontRegitration($investo_id ,$data)
    {
        $this->db->where(['investor_id'=> $investo_id])
                 ->update('investor_status',$data);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : updateInvestorStatusSecontRegitration , investo_id : ".$investo_id." Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : updateInvestorStatusSecontRegitration , investo_id : ".$investo_id." Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getCountyList
|   DATE : 04/10/2016
|   COMMENT : get all country list
|   TABLE : country
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function getCountyList()
    {
        $query=$this->db->query("SELECT * FROM `country` WHERE status=1");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getCountyList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getCountyList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getAllNationalities
|   DATE : 04/10/2016
|   COMMENT : get all nationality list
|   TABLE : nationality
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function getAllNationalities()
    {
        $query=$this->db->get("nationality");
        if($query->num_rows()>0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getAllNationalities , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getAllNationalities , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : addTaxResidencies
|   DATE : 04/10/2016
|   COMMENT : get all nationality list
|   TABLE : nationality
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/

    function addTaxResidencies($allTaxResidencies,$investorId)
    {
        $allTaxResidenciesArray=explode("|", $allTaxResidencies);
        if(isset($allTaxResidenciesArray) && !empty($allTaxResidenciesArray))
        {
            foreach ($allTaxResidenciesArray as $row)
            {
                $str=explode(",",$row);

                $countryId=$str[0];
                $tin=$str[1];

                if($tin!="" && $countryId!="")
                {
                    $data=array("country_id"=>$countryId,"tin"=>$tin,"investor_id"=>$investorId);
                    // first we check the already existing data than insert and update
                    $checkData=array("country_id"=>$countryId,"investor_id"=>$investorId);
                    $this->db->where($checkData);
                    $checkResult=$this->db->get("tax_residency");
                    if($checkResult->num_rows>0)
                    {
                        $this->db->where($checkData);
                        $this->db->update("tax_residency",$data);
                    }
                    else
                    {
                        $this->db->insert("tax_residency",$data);
                    }
                }
            }
        }
        return true;
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getAllTaxResidencies
|   DATE : 04/10/2016
|   COMMENT : get all nationality list
|   TABLE : country , tax_residency
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function getAllTaxResidencies($investorId)
    {
        $sql="SELECT country.country_name,tax_residency.* FROM country
        JOIN tax_residency ON country.country_id=tax_residency.country_id
        where tax_residency.investor_id='$investorId' ";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getAllTaxResidencies , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getAllTaxResidencies , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getAllTaxResidencies
|   DATE : 04/10/2016
|   COMMENT : get all nationality list
|   TABLE : country , tax_residency
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function getAOneTaxResidencies($investorId)
    {
        $sql="SELECT country.country_name,tax_residency.* FROM country
        JOIN tax_residency ON country.country_id=tax_residency.country_id
        where tax_residency.investor_id='$investorId' ";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : deleteInvestorTaxResidency
|   DATE : 04/10/2016
|   COMMENT : delete tax_residency
|   TABLE : tax_residency
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function deleteInvestorTaxResidency($investorId)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->delete("tax_residency");
        return true;
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : deleteInvestorOverseasDetails
|   DATE : 04/10/2016
|   COMMENT : deleteInvestorOverseasDetails funcition is used to delete investor_overseas_details
|   TABLE : investor_overseas_details
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function deleteInvestorOverseasDetails($investorId)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->delete("investor_overseas_details");
        return true;
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : getDetailsByIfscCode
|   DATE : 04/10/2016
|   COMMENT : deleteInvestorOverseasDetails funcition is used to delete investor_overseas_details
|   TABLE : ifsc_detail
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function getDetailsByIfscCode($ifscCode)
    {
        $sql="SELECT * FROM ifsc_detail
        where ifsc_detail.ifsc_code='$ifscCode'";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getDetailsByIfscCode , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getDetailsByIfscCode , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : updateKycStatusDone
|   DATE : 04/10/2016
|   COMMENT : when kyc done statuse change
|   TABLE : investor_status
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function updateKycStatusDone($investorId,$data)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->update("investor_status",$data);
        return true;
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : removeNominee
|   DATE : 04/10/2016
|   COMMENT : remove from nominee_details table
|   TABLE : nominee_details
|   CHECK STATUS : TRUE
------------------------------------------------------------------------------------------------------------
*/
    function removeNominee($nomineeId)
    {
        $this->db->where("nominee_id", $nomineeId);
        $this->db->query("DELETE FROM `nominee_details` WHERE `nominee_details`.`nominee_details_id`='$nomineeId'");
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : removeNominee , nomineeId : ".$nomineeId." Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : removeNominee , nomineeId : ".$nomineeId." Messege : returning false in else condition *****");
            return false;
        }
    }

/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function checkNoOfNominee($investorId)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->where("status", 1);
        $query=$this->db->get("nominee_details");
        // echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : checkNoOfNominee , investorId : ".$investorId." Messege : returning num_rows in if condition *****");
            return $query->num_rows();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : checkNoOfNominee , investorId : ".$investorId." Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function checkNomineeTotalPercentage($investorId)
    {
        $sql= "SELECT sum(percentage) total_percentage FROM `nominee_details`  WHERE investor_id='$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : checkNomineeTotalPercentage ,investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : checkNoOfNominee , investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function getInvestorStatus($investorId)
    {
        $sql= "SELECT * FROM `investor_status` WHERE investor_id = '$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorStatus ,investorId : ".$investorId.", Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorStatus , investorId : ".$investorId.", Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function getCityList()
    {
        $sql= "SELECT * FROM `city` WHERE status=1 order by city.location_name";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getCityList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getCityList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function getStateList()
    {
        $sql= "SELECT * FROM `state` WHERE status=1 order by state.state_name";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getStateList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getStateList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function getInvestorOverseasDetail($investorId)
    {
        $sql= "SELECT investor_overseas_details.*,investor_address_proof.address_proof as addressProof,country.country_name as country
        FROM investor_overseas_details JOIN country on country.country_id=investor_overseas_details.country_id
        JOIN investor_address_proof on investor_address_proof.investor_address_proof_id=investor_overseas_details.overseas_address_proof_id
        WHERE investor_id = '$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getInvestorOverseasDetail , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getInvestorOverseasDetail , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function addInvestorOverseasDetails($overseasData)
    {
        $this->db->insert("investor_overseas_details",$overseasData);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : addInvestorOverseasDetails , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : addInvestorOverseasDetails , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function updateInvestorOverseasDetails($overseasData,$investorId)
    {
        $this->db->where("investor_id",$investorId);
        $this->db->update("investor_overseas_details",$overseasData);
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : updateInvestorOverseasDetails , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : updateInvestorOverseasDetails , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function checkInvestorOverseasDetail($investorId)
    {
        $sql= "SELECT * FROM `investor` WHERE investor_id = '$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : checkInvestorOverseasDetail , Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : checkInvestorOverseasDetail , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function uploadCancelChequeImageUrl($invId, $data)
    {
        $this->db->where("investor_id",$invId);
        $this->db->update("investor", $data);
        //echo $this->db->last_query(); die;
        if($this->db->affected_rows()>0)
        {
			log_message("info", "***** Model : Registration_model,  Function : uploadCancelChequeImageUrl ,  InvestorId : ".$invId." , Messege : returning true in if condition *****");
            return true;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : uploadCancelChequeImageUrl ,  InvestorId : ".$invId." , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function getAssistantEmpList()
    {
        $sql= "SELECT users.id,users.username,users.email from users inner join users_groups on users_groups.user_id = users.id WHERE users_groups.group_id>1";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getAssistantEmpList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getAssistantEmpList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function getAllPanNoList()
    {
        $sql = "SELECT pan,investor_id FROM `investor`";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : getAllPanNoList , Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : getAllPanNoList , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function updateInvestorDocumentChecklist($investorId,$jsonArray)
    {
        $count=0;
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $this->db->where("investor_id",$investorId);
            $this->db->where_not_in("document_type_id",4);
            $this->db->where("url",null);
            $this->db->delete("investor_document_type");
            
            foreach ($jsonArray as $row)
            {
                $data=array("investor_id"=>$investorId,"log_msg"=>$row);
                // addSystemLog($data); // helper function
                $data=array("investor_id"=>$investorId,"document_type_id"=>$row[0]);
                $this->db->where($data);
                $query=$this->db->get("investor_document_type");
                if($query->num_rows()>0){
                //no change
                }else{
                    $this->db->insert("investor_document_type",$data);
                    if($this->db->affected_rows()>0)
                    {
                        $count=0;
                    }else{
                        $count++;
                    }
                }
            }
        }
        if($count==0)
        {
			log_message("info", "***** Model : Registration_model,  Function : updateInvestorDocumentChecklist , Messege : returning true in if condition *****");
            return true;
        }else{
			log_message("info", "***** Model : Registration_model,  Function : updateInvestorDocumentChecklist , Messege : returning false in else condition *****");
            return false;
        }
    }
	
    function appUpdateInvestorDocumentChecklist($investorId,$jsonArray)
    {
        $count=0;
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $this->db->where("investor_id",$investorId);
            $this->db->where_not_in("document_type_id",4);
            $this->db->where("url",null);
            $this->db->delete("investor_document_type"); 
            foreach ($jsonArray as $row)
            {
                $data=array("investor_id"=>$investorId,"document_type_id"=>$row);
                $this->db->where($data);
                $query=$this->db->get("investor_document_type");
                if($query->num_rows()>0){
                //no change
                }else{
                    $this->db->insert("investor_document_type",$data);
                    if($this->db->affected_rows()>0)
                    {
                        $count=0;
                    }else{
                        $count++;
                    }
                } 
            }
        }
        if($count==0)
        {
			log_message("info", "***** Model : Registration_model,  Function : appUpdateInvestorDocumentChecklist , Messege : returning true in if condition *****");
            return true;
        }else{
			log_message("info", "***** Model : Registration_model,  Function : appUpdateInvestorDocumentChecklist , Messege : returning false in else condition *****");
            return false;
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
    function addInvestorDocumentType($investorId,$docData,$docTypeId)
    {
        // first check document type is already exist in database table
        // $this->db->where("investor_id",$investorId);
        // $this->db->where("document_type_id",$docTypeId);
        // $query=$this->db->get('investor_document_type');
        $query= $this->db->where(['investor_id'=>$investorId,'document_type_id'=>$docTypeId])->from('investor_document_type')->get();
        if($query->num_rows()>0)
        {
            // Update cancelled checque url in existing document type
            $this->db->where("investor_id",$investorId);
            $this->db->where("document_type_id",$docTypeId);
            $this->db->update("investor_document_type",$docData);
            if($this->db->affected_rows()>0)
            {
				log_message("info", "***** Model : Registration_model,  Function : appUpdateInvestorDocumentChecklist , investorId : ".$investorId." , Messege : returning true in if condition *****");
                return true;
            }else
            {
				log_message("info", "***** Model : Registration_model,  Function : appUpdateInvestorDocumentChecklist , investorId : ".$investorId." , Messege : returning false in else condition *****");
                return false;
            }
        }else
        {
            // Insert document type and add cancelled cheuque url 
            $this->db->insert("investor_document_type",$docData);
            if($this->db->affected_rows()>0)
            {
				log_message("info", "***** Model : Registration_model,  Function : appUpdateInvestorDocumentChecklist , investorId : ".$investorId." , Messege : returning true in if condition *****");
                return true;
            }else
            {
				log_message("info", "***** Model : Registration_model,  Function : appUpdateInvestorDocumentChecklist , investorId : ".$investorId." , Messege : returning false in else condition *****");
                return false;
            }
        }
    }
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/

    public function get_state_model($state_name)
    {
        if($state_name =='Jammu & Kashmir'){
            return 15;
        }
        $state_id = $this->db->select('state_name,id')
                     ->from('state')
                     ->where('state_name',$state_name)
                     ->get();
        return $state_id->row()->id;
    }

    public function check_city_model($city)
    {
        $city = $this->db->select('id,location_name')
                 ->from('city')
                 ->where('location_name' , $city)
                 ->get();
        if($city->num_rows > 0)
        {
			log_message("info", "***** Model : Registration_model,  Function : check_city_model , Messege : returning city id if condition *****");
            return $city->row()->id;
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : check_city_model , Messege : returning false in else condition *****");
		    return  false;
        }
    }
	
    public function varifyinvestordetailgetdata($investorid)
    {
        $query = $this->db
                 ->from('investor')
                 ->where('investor_id' , $investorid)
                 ->get();
        if($query->num_rows > 0)
        {
			$data = (array) $query->row();
			$data = json_encode($data);
			log_message("info", "***** Model : Registration_model,  Function : varifyinvestordetailgetdata , investorid : ".$investorid." Messege :  returning data : ".$data ." *****");
            return $query->row();
        }
        else
        {
			log_message("info", "***** Model : Registration_model,  Function : varifyinvestordetailgetdata , investorid : ".$investorid." Messege : returning false in else condition *****");
		    return  false;
        }
    }
	
	public function getuserdetailbyid($id)
	{
		$data = $this->db->from("users")->where("id",$id)->get();
		if($data->num_rows > 0)
        {
            return $data->row();
        }
        else
        {
		    return  false;
        }
	}
	
	public function getUserDataForSendEmail($investorId)
	{
		$res = $this->db->query("select users.* from users join investor on users.id = investor.login_id where investor.investor_id = $investorId");
		
		if($res->num_rows() >0 )
		{
			return $res->row();
		}
		else
		{
			return false;
		}
	}

/*
/*
------------------------------------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------------------------------------
|   FUNTION NAME : 
|   DATE : 04/10/2016
|   COMMENT : 
|   TABLE : 
|   CHECK STATUS : 
------------------------------------------------------------------------------------------------------------
*/
	public function update_is_inv_colmn_in_investor_table($investor_id)
    {
        $this->db->where('investor_id',$investor_id)
                 ->update('investor',['is_complete_inv_detail' => 1]);
        if($this->db->affected_rows()>0)
        {
            return true;
        }else
        {
            return false;
        }

    }

/*
---------------------------------------------------------------------------------------------------
|   date : 27/09/2016
|   author : amit meena
|   comment : this function is used to update invetor table colmn is_complete_inv_detail null to 1
|
---------------------------------------------------------------------------------------------------
*/
    public function update_is_inv_table($investor_id)
    {
        $this->db->where('investor_id',$investor_id)
                 ->update('investor',['is_incomplete_bank_detail' => 0 , 'is_do_not_reg_nominee' => 0]);

        if($this->db->affected_rows()>0)
        {
            return true;
        }else
        {
            return false;
        }

    }
	
	public function getPartnerDetail($investorId)
	{
		$res = $this->db->from('company_partners')
                     ->where(['investor_id'=>$investorId,"ext1"=>0])
                     ->get();
		if($res->num_rows() > 0)
		{
			return $res->result();
		}
		else
		{
			return false;
		}
	}
	
	public function getUserNameOnServer($investor_id)
	{
		$res = $this->db->query("select username from users join investor on users.id = investor.login_id where investor_id =$investor_id");
		if($res->num_rows()>0)
		{
			return $res->row()->username;
		}
		else
		{
			return false;
		}
		
	}
	
	public function update_company_address($investor_id,$data)
	{
		$res = $this->db->from("company_address_table")->where("investor_id",$investor_id)->get();
		if($res->num_rows() >0)
		{
			$this->db->where("company_address_id",$res->row()->company_address_id)->update('company_address_table',$data);
		}
		else
		{
			$this->db->insert('company_address_table',$data);
		}
	}
	
	public function referal_insert($data)
	{
		$this->db->insert("accept_referrals",$data);
	}
	
	public function update_referal($investorId )
	{
		$this->db->query("update  accept_referrals set regitration_status = 1 , investo_points = 200 where user_id = (select login_id from investor where investor_id = $investorId ) ");
	}
	
	public function getUserDetailForRegitration($investor_id)
	{
		$res = $this->db->query("select users.username,users.email,users.phone from users join investor on investor.login_id = users.id where investor.investor_id = $investor_id");
		if($res->num_rows() >0)
		{
			return $res->row();
		}
		else
		{
			return null;
		}
	}

    public function getCompanyAddrees($investor_id)
    {
        $res = $this->db->from('company_address_table')->where('investor_id',$investor_id)->get();
        if($res->num_rows() > 0)
        {
            return $res->row();
        }
        else
        {
            return false;
        }
    }
	
}
