<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Registration_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }

    /** add new investor **/
    function addInvestor($data)
    {
        $this->db->insert("investor",$data);
        if($this->db->affected_rows()>0)
        {
            return $this->db->insert_id();
        }
        else
        {
            return false;
        }
    }


    /** get investor type **/
    function getAllInvestorType()
    {
        $this->db->where("status",1);
        $query=$this->db->get("investor_type");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    // get all document type list
    function getdocumentTypeList()
    {
        $this->db->where("status",1);
        $query=$this->db->get("document_type");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    /** get investor detail in registration form for modify **/
    function getInvestorDetailInRegistrationForm($investorId)
    {
        $sql="SELECT users.first_name as name, users.phone,investor.*
        FROM investor
        JOIN users
        on users.id = investor.login_id
        JOIN investor_type
        on investor.investor_type_id=investor_type.investor_type_id
        left join city
        on investor.city_id = city.id
        left join state
        on investor.state_id = state.id
        where investor.investor_id='$investorId'";
        $query=$this->db->query($sql);
        if($query->num_rows()>0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    function getInvestorDetail($invId)
    {
        $sql="SELECT users.first_name as name, users.email,users.phone,investor.*,investor_type.investor_type,
        investor_address_proof.address_proof,investor_id_proof.id_proof,investor_status.is_investor_registered_date,country.country_id ,country.country_name,city.id,city.location_name,
        state.id, state.state_name,
        investor_family_status.family_status,occupation.occupation,nationality.nationality
        FROM investor JOIN investor_type on investor.investor_type_id=investor_type.investor_type_id
        LEFT JOIN  investor_status ON investor.investor_id=investor_status.investor_id
        LEFT JOIN investor_address_proof on investor.investor_address_proof_id=investor_address_proof.investor_address_proof_id
        LEFT JOIN investor_id_proof ON investor.investor_id_proof_id=investor_id_proof.investor_id_proof_id
        LEFT JOIN city on investor.city_id = city.id
        LEFT JOIN state on investor.state_id=state.id
        JOIN users on users.id=investor.login_id
        LEFT JOIN investor_family_status on investor.investor_family_status_id=investor_family_status.investor_family_status_id
        LEFT JOIN occupation on occupation.occupation_id=investor.occupation_id
        JOIN country on investor.country=country.country_id
        JOIN nationality on investor.nationality_id=nationality.nationality_id where investor.investor_id='$invId'";

        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    /** get investor nominee details **/
    function getInvestorNomineeDetail($invId)
    {
        $sql="SELECT * FROM `nominee_details`
        where nominee_details.status='1' and nominee_details.investor_id='$invId'";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    /** get investors bank and pan details **/
    function getInvestorBankAndPanDetail($invId)
    {
        $sql="SELECT `bank_details`.* ,bank_account_type.account_type,
        bank_master.bank_name, bank_master.atom_code
        FROM bank_details,bank_account_type,bank_master
        WHERE bank_details.account_type_id=bank_account_type.account_type_id
        and bank_details.bank_master_id=bank_master.bank_master_id
        and bank_details.investor_id='$invId'";

        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    /** this function get investor address proof list **/
    function getInvestorAddressProofList()
    {
        $this->db->where("is_deleted",0);
        $query=$this->db->get("investor_address_proof");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    /** this function get investor id proof list **/
    function getInvestorIdProofList()
    {
        $this->db->where("is_deleted",0);
        $query=$this->db->get("investor_id_proof");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    /** this function get investor family status list **/
    function getInvestorFamilyStatusList()
    {
        $query=$this->db->get("investor_family_status");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    /** Get bank master list **/
    function getbankMasterList()
    {
        $query=$this->db->query("SELECT * FROM `bank_master` WHERE status = 1 order BY bank_master.bank_name");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }
	
	/** Get All Bank **/
	/**********************************************************************/
	// New function written by TechnoUniverse to get all the bank lists 
	// Date :- 10-08-2016
	// Change By :- Nikunj Vijayvargiya
	/**********************************************************************/
    function getbankMasterAll()
    {
        $query=$this->db->query("SELECT * FROM `bank_master` order BY bank_master.bank_name");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    /** this function get investor's occupation list **/
    function getInvestorOccupationList()
    {
        $query=$this->db->query("SELECT * FROM occupation WHERE status =1 ");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    /** get investor bank account type **/
    function getInvestorBankAccountTypeList()
    {
        $this->db->where('account_type_id !=', 0);
        $query=$this->db->get("bank_account_type");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getInvestorRegistrationFormModifyDetail($investorId)
    {
        $sql="SELECT users.first_name as name,investor.date_of_birth,investor.armed_forces,investor_type.*,nationality.nationality
        FROM investor
        JOIN users
        on users.id = investor.login_id
        JOIN investor_type
        on investor.investor_type_id=investor_type.investor_type_id join nationality on investor.nationality_id=nationality.nationality_id
        where investor.investor_id=$investorId ";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    /** check user email already exist or not in database **/
    function checkUserExistingInfo($email)
    {
        $this->db->where('email', $email);
        $query=$this->db->get("users");
        if($query->num_rows()>0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    function updateInvestorInfo($investorId,$data)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->update("investor",$data);
        // echo $this->db->last_query(); die;
        return true;
    }

    /** this function add investor's nominee details **/
    function addInvestorNomineeDetails($data)
    {
        $this->db->insert("nominee_details",$data);
        if($this->db->affected_rows()>0)
        {
            return $this->db->insert_id();
        }
        else
        {
            return false;
        }
    }

    /** this function update investors nominee details **/
	
	/************************************************************************/
	/* Rewritten Function 													*/
	/* Change by Nikunj Originally it was direct update 					*/
	/* Modified function to first check if the row exists for investor_id 	*/
	/* If yes then update else insert 										*/
	/************************************************************************/
    function updateInvestorNomineeDetails($investorId,$data)
    {
		/**************************************************************************/
		/*
		$this->db->where("investor_id", $investorId);
		$this->db->where("status", 1);
		$this->db->update("nominee_details",$data);
		return true;
		*/
		/**************************************************************************/
		
		$sql="SELECT status FROM nominee_details where investor.investor_id=$investorId ";
		$query=$this->db->query($sql);
		if($query->num_rows() > 0){
			$this->db->where("investor_id", $investorId);
			$this->db->where("status", 1);
			$this->db->update("nominee_details",$data);
			return true;
		}
		else{
			$this->db->insert("nominee_details",$data);
			if($this->db->affected_rows()>0)
			{
				return $this->db->insert_id();
			}
			else
			{
				return false;
			}
		}
    }

    /** this function add investor bank details **/
    function addInvestorBankDetails($bankData)
    {
        $this->db->insert("bank_details",$bankData);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /** this function update investor bank details **/
	/************************************************************************/
	/* Rewritten Function 													*/
	/* Change by Nikunj Originally it was direct update 					*/
	/* Modified function to first check if the row exists for investor_id 	*/
	/* If yes then update else insert 										*/
	/************************************************************************/
    function updateInvestorBankDetails($investorId,$bankData)
    {
		/**************************************************************************/
		/* Commenting original Code by Nikunj
			$this->db->where("investor_id", $investorId);
			$this->db->update("bank_details",$bankData);
			return true;
		*/
		/**************************************************************************/
		$sql="SELECT bank_details_id FROM bank_details where bank_details.investor_id=$investorId ";
		$query=$this->db->query($sql);
		if($query->num_rows() > 0){
			$this->db->where("investor_id", $investorId);
			$this->db->update("bank_details",$bankData);
			if ($this->db->affected_rows()>0){
				return true;
			}
			else
			{
				return false;
			}
		}
		else{
			$this->db->insert("bank_details",$bankData);
			if($this->db->affected_rows()>0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
    }

    function deleteInvestorNomineeDetails($investorId)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->delete("nominee_details");
        return true;
    }

    function updateInvestorStatus($data)
    {
        $this->db->insert("investor_status",$data);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    function getCountyList()
    {
        $query=$this->db->query("SELECT * FROM `country` WHERE status=1");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getAllNationalities()
    {
        $query=$this->db->get("nationality");
        if($query->num_rows()>0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }


    function addTaxResidencies($allTaxResidencies,$investorId)
    {
        $allTaxResidenciesArray=explode("|", $allTaxResidencies);
        if(isset($allTaxResidenciesArray) && !empty($allTaxResidenciesArray))
        {
            foreach ($allTaxResidenciesArray as $row)
            {
                $str=explode(",",$row);

                $countryId=$str[0];
                $tin=$str[1];

                if($tin!="" && $countryId!="")
                {
                    $data=array("country_id"=>$countryId,"tin"=>$tin,"investor_id"=>$investorId);
                    // first we check the already existing data than insert and update
                    $checkData=array("country_id"=>$countryId,"investor_id"=>$investorId);
                    $this->db->where($checkData);
                    $checkResult=$this->db->get("tax_residency");
                    if($checkResult->num_rows>0)
                    {
                        // update data
                        $this->db->where($checkData);
                        $this->db->update("tax_residency",$data);
                    }
                    else
                    {
                        $this->db->insert("tax_residency",$data);
                    }
                }
            }
        }
        return true;
    }

    function getAllTaxResidencies($investorId)
    {
        $sql="SELECT country.country_name,tax_residency.* FROM country
        JOIN tax_residency ON country.country_id=tax_residency.country_id
        where tax_residency.investor_id='$investorId' ";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function deleteInvestorTaxResidency($investorId)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->delete("tax_residency");
        return true;
    }

    function deleteInvestorOverseasDetails($investorId)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->delete("investor_overseas_details");
        return true;
    }

    function getDetailsByIfscCode($ifscCode)
    {
        $sql="SELECT * FROM ifsc_detail
        where ifsc_detail.ifsc_code='$ifscCode'";
        $query=$this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    function updateKycStatusDone($investorId,$data)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->update("investor_status",$data);
        return true;
    }

    function removeNominee($nomineeId)
    {
        $this->db->where("nominee_id", $nomineeId);
        $this->db->query("DELETE FROM `nominee_details` WHERE `nominee_details`.`nominee_details_id`='$nomineeId'");
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }


    function checkNoOfNominee($investorId)
    {
        $this->db->where("investor_id", $investorId);
        $this->db->where("status", 1);
        $query=$this->db->get("nominee_details");
        // echo $this->db->last_query(); die;
        if($query->num_rows()>0)
        {
            return $query->num_rows();
        }
        else
        {
            return false;
        }
    }

    function checkNomineeTotalPercentage($investorId)
    {
        $sql= "SELECT sum(percentage) total_percentage FROM `nominee_details`  WHERE investor_id='$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    function getInvestorStatus($investorId)
    {
        $sql= "SELECT * FROM `investor_status` WHERE investor_id = '$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    function getCityList()
    {
        $sql= "SELECT * FROM `city` WHERE status=1 order by city.location_name";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getStateList()
    {
        $sql= "SELECT * FROM `state` WHERE status=1 order by state.state_name";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getInvestorOverseasDetail($investorId)
    {
        $sql= "SELECT investor_overseas_details.*,investor_address_proof.address_proof as addressProof,country.country_name as country
        FROM investor_overseas_details JOIN country on country.country_id=investor_overseas_details.country_id
        JOIN investor_address_proof on investor_address_proof.investor_address_proof_id=investor_overseas_details.overseas_address_proof_id
        WHERE investor_id = '$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    function addInvestorOverseasDetails($overseasData)
    {
        $this->db->insert("investor_overseas_details",$overseasData);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    function updateInvestorOverseasDetails($overseasData,$investorId)
    {
        $this->db->where("investor_id",$investorId);
        $this->db->update("investor_overseas_details",$overseasData);
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    function checkInvestorOverseasDetail($investorId)
    {
        $sql= "SELECT * FROM `investor` WHERE investor_id = '$investorId'";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->row();
        }
        else
        {
            return false;
        }
    }

    function uploadCancelChequeImageUrl($invId, $data)
    {
        $this->db->where("investor_id",$invId);
        $this->db->update("investor", $data);
        //echo $this->db->last_query(); die;
        if($this->db->affected_rows()>0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    function getAssistantEmpList()
    {
        $sql= "SELECT users.id,users.username,users.email from users inner join users_groups on users_groups.user_id = users.id WHERE users_groups.group_id=5";
        $query = $this->db->query($sql);
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function getAllPanNoList()
    {
        $sql = "SELECT pan,investor_id FROM `investor`";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if($query->num_rows() > 0)
        {
            return $query->result();
        }
        else
        {
            return false;
        }
    }

    function updateInvestorDocumentChecklist($investorId,$jsonArray)
    {
        $count=0;
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $this->db->where("investor_id",$investorId);
            $this->db->where_not_in("document_type_id",4);
            $this->db->where("url",null);
            $this->db->delete("investor_document_type");
            foreach ($jsonArray as $row)
            {
                $data=array("investor_id"=>$investorId,"document_type_id"=>$row[0]);
                $this->db->where($data);
                $query=$this->db->get("investor_document_type");
                if($query->num_rows()>0){
                //no change
                }else{
                    $this->db->insert("investor_document_type",$data);
                    if($this->db->affected_rows()>0)
                    {
                        $count=0;
                    }else{
                        $count++;
                    }
                }
            }
        }
        if($count==0)
        {
            return true;
        }else{
            return false;
        }
    }

    function addInvestorDocumentType($investorId,$docData,$docTypeId)
    {
        // first check document type is already exist in database table
        $this->db->where("investor_id",$investorId);
        $this->db->where("document_type_id",$docTypeId);
        $query=$this->db->get('investor_document_type');
        if($query->num_rows()>0)
        {
            // Update cancelled checque url in existing document type
            $this->db->where("investor_id",$investorId);
            $this->db->where("document_type_id",$docTypeId);
            $this->db->update("investor_document_type",$docData);
            if($this->db->affected_rows()>0)
            {
                return true;
            }else
            {
                return false;
            }
        }else
        {
            // Insert document type and add cancelled cheuque url 
            $this->db->insert("investor_document_type",$docData);
            if($this->db->affected_rows()>0)
            {
                return true;
            }else
            {
                return false;
            }
        }
    }


    public function get_state_model($state_name)
    {
        $state_id = $this->db->select('state_name,id')
                     ->from('state')
                     ->where('state_name',$state_name)
                     ->get();
        return $state_id->row()->id;
    }

    public function check_city_model($city)
    {
        $city = $this->db->select('id,location_name')
                 ->from('city')
                 ->where('location_name' , $city)
                 ->get();
        if($city->num_rows > 0)
        {
            return $city->row()->id;
        }
        else
        {
		    return  false;
        }
    }
	
	 public function varifyinvestordetailgetdata($investorid)
    {
        $data = $this->db
                 ->from('investor')
                 ->where('investor_id' , $investorid)
                 ->get();
        if($data->num_rows > 0)
        {
            return $data->data();
        }
        else
        {
		    return  false;
        }
    }

/*
---------------------------------------------------------------------------------------------------
|   date : 27/09/2016
|   author : amit meena
|   comment : this function is used to update invetor table colmn is_complete_inv_detail null to 1
|
---------------------------------------------------------------------------------------------------
*/
	public function update_is_inv_colmn_in_investor_table($investor_id)
    {
        $this->db->where('investor_id',$investor_id)
                 ->update('investor',['is_complete_inv_detail' => 1]);
        if($this->db->affected_rows()>0)
        {
            return true;
        }else
        {
            return false;
        }

    }

/*
---------------------------------------------------------------------------------------------------
|   date : 27/09/2016
|   author : amit meena
|   comment : this function is used to update invetor table colmn is_complete_inv_detail null to 1
|
---------------------------------------------------------------------------------------------------
*/
    public function update_is_inv_table($investor_id)
    {
        $this->db->where('investor_id',$investor_id)
                 ->update('investor',['is_incomplete_bank_detail' => 0 , 'is_do_not_reg_nominee' => 0]);

        if($this->db->affected_rows()>0)
        {
            return true;
        }else
        {
            return false;
        }

    }
	
	
}
