<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); 

class Withdraw_model extends CI_Model
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }
 
    /***** get purchase fund funds by fund type(ONE TIME INVESTMENT) ****/
    function getPurchaseFundsReadytoPurchase($fundTypeId,$investorId)
    {
        $sql="SELECT SUM(unit_count) as unit_count , purchased_units.fund_id, SUM(purchased_amount) as purchased_amount , purchased_units.folio_number,fund_history.nav , max(fund_history.nav_date),
        SUM(unit_count)*fund_history.nav as total_amount, funds.* FROM purchased_units 
        join fund_history on fund_history.fund_id=purchased_units.fund_id join funds on purchased_units.fund_id=funds.fund_id 
        WHERE fund_history.is_latest =1 and purchased_units.`request_status`=1 and funds.fund_type_id='$fundTypeId' 
        AND purchased_units.investor_id='$investorId' group by purchased_units.fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Withdraw_model,  Function : getPurchaseFundsReadytoPurchase , investorId : ".$investorId." Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Withdraw_model,  Function : getPurchaseFundsReadytoPurchase , investorId : ".$investorId." Messege : returning false in else condition *****");
            return false;
        }
    }

    /***** get sold fund befor successfully withdraw ****/
    function getSoldFunds($fundTypeId,$investorId)
    {
        $sql="SELECT SUM(unit_count) as unit_count , sold_units.fund_id, fund_history.nav , max(fund_history.nav_date),
        SUM(unit_count)*fund_history.nav as total_amount, funds.* FROM sold_units 
        join fund_history on fund_history.fund_id=sold_units.fund_id join funds on sold_units.fund_id=funds.fund_id 
        WHERE fund_history.is_latest =1 AND sold_units.`request_status` = 1 and sold_units.is_cancel=0 and funds.fund_type_id='$fundTypeId' 
        AND sold_units.investor_id='$investorId' group by sold_units.fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Withdraw_model,  Function : getSoldFunds , investorId : ".$investorId." Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Withdraw_model,  Function : getSoldFunds , investorId : ".$investorId." Messege : returning false in else condition *****");
            return false;
        }
    }

    // get sold fund list ofter successully withdraw
    function getSoldFundsAfterSuccess($fundTypeId,$investorId)
    {
        $sql="SELECT SUM(unit_count) as unit_count ,SUM(sold_amount) as sold_amount, sold_units.fund_id, fund_history.nav , max(fund_history.nav_date),
        SUM(unit_count)*fund_history.nav as total_amount, funds.* FROM sold_units 
        join fund_history on fund_history.fund_id=sold_units.fund_id join funds on sold_units.fund_id=funds.fund_id 
        WHERE fund_history.is_latest =1 and sold_units.is_cancel=0 and sold_units.`request_status`=1 and funds.fund_type_id='$fundTypeId' 
        AND sold_units.investor_id='$investorId' group by sold_units.fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Withdraw_model,  Function : getSoldFundsAfterSuccess , investorId : ".$investorId." Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Withdraw_model,  Function : getSoldFundsAfterSuccess , investorId : ".$investorId." Messege : returning false in else condition *****");
            return false;
        }
    }

    function addWithdrawalAmount($data)
    {
        if(isset($data["allWithdrawfundsArray"]) && !empty($data["allWithdrawfundsArray"]))
        {
            $count=0; 
            foreach ($data["allWithdrawfundsArray"] as $row) 
            {
                $query=$this->db->insert("sold_units",$row);
                if($this->db->affected_rows()>0)
                {
                    $count=$count; 
                }
                else
                {
                    $count++; 
                }
            }
            if($count==0)
            {
				log_message("info", "***** Model : Withdraw_model,  Function : getSoldFundsAfterSuccess ,  Messege : returning true in if condition *****");
                return true;
            }
            else{
				log_message("info", "***** Model : Withdraw_model,  Function : getSoldFundsAfterSuccess ,  Messege : returning false in else condition *****");
                return false;
            }
        }
        else{return false;}
    }

    function addWithdrawalByUnits($data)
    {
        if(isset($data["allWithdrawfundsArray"]) && !empty($data["allWithdrawfundsArray"]))
        {
            $count=0; 
            foreach ($data["allWithdrawfundsArray"] as $row) 
            {
                $query=$this->db->insert("sold_units",$row);
                if($this->db->affected_rows()>0)
                {
                    $count=$count; 
                }
                else
                {
                    $count++; 
                }
            }
            if($count==0)
            {
				log_message("info", "***** Model : Withdraw_model,  Function : addWithdrawalByUnits ,  Messege : returning true in if condition *****");
                return true;
            }
            else{
				log_message("info", "***** Model : Withdraw_model,  Function : addWithdrawalByUnits ,  Messege : returning false in else condition *****");
                return false;
            }
        }
        else{return false;}
    }
	
	
	
	
	 /***** get withdraw funds eligiblity after years ****/
    function getDataForTaxSavingWithdrawPurchaseEligiblityWithdraw($investorId,$fundsTypeId)
    {
        $sql="SELECT purchased_units.purchased_units_id,purchased_units.date_of_purchase FROM purchased_units 
        join fund_history on fund_history.fund_id=purchased_units.fund_id join funds on purchased_units.fund_id=funds.fund_id 
        WHERE fund_history.is_latest =1 and purchased_units.`request_status`=1 and funds.fund_type_id='$fundsTypeId' 
        AND purchased_units.investor_id='$investorId' group by purchased_units.fund_id";
        $query = $this->db->query($sql);
        //echo $this->db->last_query(); die;
        if ($query->num_rows() > 0)
        {
			$data = (array) $query->result();
			$data = json_encode($data);
			log_message("info", "***** Model : Withdraw_model,  Function : getDataForTaxSavingWithdrawPurchaseEligiblityWithdraw , investorId : ".$investorId." Messege :  returning data : ".$data ." *****");
            return $query->result();
        }
        else
        {
			log_message("info", "***** Model : Withdraw_model,  Function : getDataForTaxSavingWithdrawPurchaseEligiblityWithdraw , investorId : ".$investorId." Messege : returning false in else condition *****");
            return false;
        }
    }
}

