<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Purchase extends CI_Controller
{
    function __construct()
    {
        // Call the Model constructor
        parent::__construct();
        $this->config->load('config_atom');
        $this->config->load('config_cams');
        $this->load->model('dashboard/dashboard_model');
        $this->load->model('purchase/purchase_model');
        $this->load->helper('transaction_helper');
       $this->load->helper('cams_helper');
    }

    
    function lookInvestor($investorId)
    {
            $result = $this->purchase_model->getInvestorDetailById($investorId);
            echo $this->encrypt->decode($result->username);
            //echo '<pre>';
            //print_r($result);
    }


    public function index($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("amit_theme/purchase/start_invest_equity_info_view",null);
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function _loadView($view,$fundTypeId)
    {
        $userId=$_SESSION["userId"];
        $investorId=$_SESSION["investor_id"];
        $resultStatus=$this->common_model->getInvestorStatus($investorId);
        if($resultStatus)
        {
            $kycDone=$resultStatus->is_kyc_done;
            $data['kycDone'] = $kycDone;
        }

        /** invest more in all funds **/
        if($fundTypeId)
        {
            $data["radioFundDetails"]=$this->getFundDetailsByFundTypeId($fundTypeId);
        }
        
        $data["investorBankDetails"]=$this->purchase_model->getInvestorBankAndPanDetail($investorId);
        
        $HolliDay = $this->purchase_model->add_holliday_date();
        $data["HolliDate"]  = $HolliDay;

        //  get fund type name by fund type id
        $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);

        $data["fundTypeName"]=$fundTypeName;
        $data["fundTypeId"]=$fundTypeId;

        $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
        $cancelChequeUrlRes=$this->dashboard_model->getcancelChequeUrl($investorId);
        if($cancelChequeUrlRes){
        $data["cancelChequeUrl"]=$cancelChequeUrlRes->url;  
        }else{
        $data["cancelChequeUrl"]="";
        }
    
        if($result)
        {
            $data["profileImageUrl"]=$result->profile_image_url;
            $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
            $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
            $data["is_verify"]=$result->is_verify;
        }
        else
        {
            $data["profileImageUrl"]="";
        }

        $resultGoalTypeList=$this->common_model->getAllGoalTypeList();
        if($resultGoalTypeList)
        {
            $data["goalTypeList"]=$resultGoalTypeList;
        }

        // check invstor is ready for investment or not
        $investorStatus=$this->common_model->getInvestorStatus($investorId);
        if($investorStatus)
        {
            $data["investorStatus"]=$investorStatus;
        }
    
        
        $data['jsFile'] ='purchase/purchase.js';
        $data['jsFileExtra'] ='dashboard/sipCalculation.js';

        $this->load->view('amit_theme/common/header',$data);
        $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
        $this->load->view($view,$data);
        $this->load->view('amit_theme/common/footer',$data );
    }


    function updateFatcaDeclaration()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $fatca=$this->input->post("fatca");
            $investorId=$_SESSION["investor_id"];
            $result=$this->purchase_model->updateFatcaDeclaration($fatca,$investorId);
            
            if($result)
            {
                if($fatca==1)
                {
                    $karvyFatcaResult=$this->createKarvyFatcaPDF($investorId);
                    $camsFatcaResult = $this->createCamsFatcaPDF($investorId);
                    if($karvyFatcaResult && $camsFatcaResult)
                    {
                        echo '{"success":true}';
                        $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"FATCA pdf generated");
                        addSystemLog($data); // helper function
                    }
                    else
                    {
                        echo '{"success":false}';
                    }
                }
                else
                {
                    echo '{"success":true}';
                }
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Update FATCA declearation");
                addSystemLog($data); // helper function
            }
            else
            {
                echo '{"success":false}';
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
        }
    }

    /** Common  method for all funds type **/
    function startInvestByType($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/investment_type_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Invest More button clicked for Fund Type -  $fundTypeName");
                addSystemLog($data); // helper function
                log_message('info', '***** Controller : Purchase, Function : startInvestByType, Message : Invest More button clicked for Fund Type -  '.$fundTypeName.' *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** Common  method for all funds type **/
    function howWouldLikeInvest($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/how_would_you_like_to_invest_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"One Time Investment button clicked for Fund Type -  $fundTypeName");
                addSystemLog($data); // helper function
                log_message('info', '***** Controller : Purchase, Function : startInvestByType, Message : One Time Investment button clicked for Fund Type -  '.$fundTypeName.' *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** Common  method for all funds type **/
    function howWouldLikeInvestSIP($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/how_would_you_like_to_invest_sip_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Start a Monthly SIP button clicked for Fund Type -  $fundTypeName");
                addSystemLog($data); // helper function
                log_message('info', '***** Controller : Purchase, Function : howWouldLikeInvestSIP, Message : Start a Monthly SIP button clicked for Fund Type -  '.$fundTypeName.' *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }


    /** common purchase for all fund by fund type id **/
    function startInvestByOneClick($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/start_invest_by_one_click_radiobtn_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase $fundTypeName funds(One Click) page by selecting setup automated transfer");
                addSystemLog($data); // helper function
                log_message('info', '***** Controller : Purchase, Function : startInvestByOneClick, Message : Visited purchase '.$fundTypeName.' funds(One Click) page by selecting setup automated transfer *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id with Net banking **/
    function startInvestByOneClickNetBanking($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/start_invest_by_one_click_radiobtn_nb_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase $fundTypeName funds(One Click) page by selecting netbanking");
                addSystemLog($data); // helper function
                log_message('info', '***** Controller : Purchase, Function : startInvestByOneClickNetBanking, Message : Visited purchase '.$fundTypeName.' funds(One Click) page by selecting netbanking *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id with Net banking **/
    function startInvestByMoreOptionNetBanking($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/start_invest_by_more_option_radiobtn_nb_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase $fundTypeName funds(Do it Yourself) page by selecting selecting netbanking");
                addSystemLog($data); // helper function
                log_message('info', '***** Controller : Purchase, Function : startInvestByMoreOptionNetBanking, Message : Visited purchase '.$fundTypeName.' funds(Do it Yourself) page by selecting selecting netbanking *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

     /** common purchase for all fund by fund type id **/
    function startInvestByMoreOption($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
               $this->_loadView("amit_theme/purchase/start_invest_by_more_option_radiobtn_view",$fundTypeId);
               $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
               $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase $fundTypeName funds(Do it Yourself) page by selecting setup automated transfer");
               addSystemLog($data); // helper function
               log_message('info', '***** Controller : Purchase, Function : startInvestByMoreOption, Message : Visited purchase '.$fundTypeName.' funds(Do it Yourself) page by selecting setup automated transfer *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id **/
    function confirmationInvestedFunds($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/confirm_invested_funds_view",$fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$this->session->flashdata('message'));
                addSystemLog($data); // helper function
                log_message('info', '***** Controller : Purchase, Function : confirmationInvestedFunds, Message : '.$this->session->flashdata('message').' *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    /** common purchase for all fund by fund type id **/
    function purchaseOneTimeInvestmentFunds()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $transactionType=$this->input->post("transactionType");
            $investmentDate=$this->input->post("investmentDate");
            $json=$this->input->post("json");
            $fundTypeId=$this->input->post("fundTypeId");
            $jsonArray=json_decode($json,true);
            $netbankingFlag=$this->input->post("netbankingFlag");
            $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
            if(isset($netbankingFlag) && $netbankingFlag == 'true')
            {
                $this->load->model('purchase_cron/api_model','api_model');
                $this->load->model('registration/registration_model','registration_model');
                $totalAmount = 0;
                $prodStr = '<products>';
                $cnt=1;
                if(!empty($jsonArray))
                {
                    foreach($jsonArray as $fundDetails)
                    {
                        
                            $totalAmount = $totalAmount+$fundDetails[1];
                            $fullFundDetails = $this->api_model->getFundDetails($fundDetails[0]);
                            $prodStr .= "<product>";
                            $prodStr .= "<id>".$cnt."</id>";
                            $prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
                            $prodStr .= "<amount>".$fundDetails[1]."</amount>";
                            $prodStr .= "</product>";
                            $cnt=$cnt+1;
                    }
                    $prodStr .= '</products>';
                    $netbankingData['totalAmount'] = $totalAmount;
                    $netbankingData['investorId'] = $investorId;
                    $getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
                    $investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
                    $netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
                    $netbankingData['prodStr'] = $prodStr;
                    $netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
                    $getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
                    $netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
                    $netbankingData['investorEmail'] = $getInvestorDetails->email;
                    $netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
                    $netbankingData['investorAddress'] = $getInvestorDetails->address;
                    $netbankingData['batchId'] = $batchId;
                        
                    $transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
                    if($transactionId)
                    {
                        //  echo 'transactionId '.$transactionId;exit;
                        $nb_request = '1';
                        $nb_request_status = '0';
                        $this->createPurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
                        $purchaseType = 'OneTime';
                        $netbankingResponse = $this->netbankingRequest($netbankingData,$transactionId,$purchaseType);

                        iLog('Investor Submit purchase in NetBanking One Time',$investorId,'Web App','Investor',$investorId);
                        log_message('info', '***** Controller : Purchase, Function : purchaseOneTimeInvestmentFunds, Message : netbanking data created *****');
                        echo $netbankingResponse;
                    }
                    else
                    {
                        echo '{"success":false,"session":"unable to create transaction"}';
                    }
                }
                else
                {
                    echo '{"success":false,"session":"Empty json"}';
                }
            }
            else
            {
                $nb_request = 0;
                $nb_request_status = 0;
                $transactionId = 0;
                $investorId=$_SESSION["investor_id"];
                iLog('Investor Submit purchase in Mandate One Time',$investorId,'Web App','Investor',$investorId);
                $result = $this->createPurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
                echo $result;
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
        }
    }

    function createPurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId)
    {
        $investorIp=$_SERVER['REMOTE_ADDR'];
        $investorId=$_SESSION["investor_id"];
        date_default_timezone_set("Asia/Kolkata");
        $date = new DateTime($investmentDate);
        $requestDate=$date->format('Y-m-d ').date("h:i:s");
        //  get fund type name by fund type id
        $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $count=0;
            $totalAmount=0;
            foreach ($jsonArray as $row)
            {
                $perFundInvestAmount=$row[1];
                $totalAmount=$totalAmount+$row[1];
                $fundId=$row[0];
                $amc_code = $this->purchase_model->get_amc_code($fundId);
                $checkResult=$this->purchase_model->checkFirstTimePurchaseFund($fundId,$investorId);
                if($checkResult){
                    $isFirstPurchase=0;
                }else{
                    $isFirstPurchase=1;
                }
               
                $resultFolio=getLatestFolioNumber($amc_code,$investorId);
                if($resultFolio){
                    $folioNumber=$resultFolio;
                }else{
                    $folioNumber="";
                }
                $unitCounts=0;
                $apiTypeId="";
                $apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
                $data=array(
                        "fund_id"=>$fundId,
                        "purchased_amount"=>$perFundInvestAmount,
                        "unit_count"=>$unitCounts,
                        "investor_id"=>$investorId,
                        "request_date"=>$requestDate,
                        "batch_id"=>$batchId,
                        "folio_number"=>$folioNumber,
                        "is_first_purchase"=>$isFirstPurchase,
                        "api_batch_id"=>$apiBatchId,
                        "investment_plan_type"=>"One Time",
                        "investor_ip"=>$investorIp,
                        "nb_request"=>$nb_request,
                        "nb_request_status"=>$nb_request_status,
                        "mer_txn"=>$transactionId,
                        "amc_code" => $amc_code
                        );
                $result=$this->purchase_model->addPurchaseFunds($data);
                if($result){}else{$count++;}
            }
            if($count==0)
            {
                if($transactionType==1)
                {
                    $result = $this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$jsonArray,$fundTypeId,$fundTypeName,$transactionType);
                    if($nb_request==1){ $purchased_type_log = 'Net Banking';}else{$purchased_type_log = 'Mandate';}
                    iLog('Investor purchase using '.$purchased_type_log.' Amount '.$totalAmount.' Request date '.$requestDate,$investorId,'Web App','Investor',$investorId);
                    return $result;
                }
            }
            else
            {
                log_message('info', '***** Controller : Purchase, Function : createPurchaseEntry, Message :  Failed investment in '.$fundTypeName.' funds *****');
                return '{"success":false,"msg":"Failed investment in '.$fundTypeName.' funds"}';
            }
        }
    }

    function sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$jsonArray,$fundTypeId,$fundTypeName,$transactionType)
    {
        // save daily agenda task
        $action="Need to submit document for today's purchase - Investor Id - ".$investorId." , Name- ".$this->encrypt->decode($_SESSION['userName']).".";
        $date=date("Y-m-d h:i:s");
        addDailyAgenda($action,$date);

        $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
        if (strpos($checkUrl, 'localhost') === false)
        {
            // send sms
            if(isset($_SESSION["userId"]) && !empty($_SESSION["userId"]))
            {
                $userId=$_SESSION["userId"];
                $resultData=$this->common_model->getUseDetailsByUserId($userId);
                if($resultData)
                {
                    $name=$this->encrypt->decode($resultData->username);
                    $phone=$this->encrypt->decode($resultData->phone);
                    
                    $sentSms = false;
                    if(!in_array($investorId,getblockEmailAndSMS(2,2))){
                        $sentSms=$this->sendPurchaseSms($name,$phone,$totalAmount);
                    }
                    if($sentSms)
                    {
                        $phoneNum = 9993011209;
                        $sentSms=$this->sendPurchaseSms($name,$phoneNum,$totalAmount,2);
                       log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase, Function : sendEmailSMSToInvestor, Message :  Sent sms for purchase *****');
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase, Function : sendEmailSMSToInvestor, Message :  Failed sending sms for purchase *****');
                    }
                }
            }
        }
        
        $sentEmailResult = false;
        if(!in_array($investorId,getblockEmailAndSMS(2,1))){
            $sentEmailResult=$this->sendPurchaseFundByMoreOptionsEmail($totalAmount,$investmentDate,$jsonArray,$fundTypeName,$transactionType);
        }
        if($sentEmailResult)
        {
            $this->session->set_flashdata('message', " Rs. ".$totalAmount. " invested in ".$fundTypeName." funds effect from ".$investmentDate);
            log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase, Function : sendEmailSMSToInvestor, Message :  Successfully invested in '.$fundTypeName.' funds by more option sent email *****');
            return '{"success":true,"url":"'.base_url().'purchase/confirmationInvestedFunds/'.$fundTypeId.'"}';
        }
        else
        {
            $this->session->set_flashdata('message', " Rs. ".$totalAmount. "invested in ".$fundTypeName." funds effect from ".$investmentDate);
            log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase, Function : sendEmailSMSToInvestor, Message :  Successfully invested in '.$fundTypeName.' funds by more option but email not sent *****');
            return '{"success":true,"url":"'.base_url().'purchase/confirmationInvestedFunds/'.$fundTypeId.'"}';
        }
    }

    function netbankingRequest($netbankingData,$transactionId,$purchaseType)
    {
        $resonceUrl = 'purchase/netbankingResponse';
        $investorId=$_SESSION["investor_id"];
        date_default_timezone_set("Asia/Kolkata");
        $datenow = date("d/m/Y");
        $paymentUrl = $this->config->item('Url');
        $postFields  = "";
        $postFields .= "&login=".$this->config->item('Login');
        $postFields .= "&pass=".$this->config->item('Password');
        $postFields .= "&ttype=".$this->config->item('ttype');
        $postFields .= "&prodid=".'Multi';
        $postFields .= "&amt=".$netbankingData['totalAmount'];
        $postFields .= "&txncurr=".$this->config->item('TxnCurr');
        $postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
        $postFields .= "&clientcode=".urlencode(base64_encode($this->config->item('clientCode')));
        $postFields .= "&txnid=".$transactionId;
        $postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
        $postFields .= "&date=".$datenow;
        $postFields .= "&mprod=".$netbankingData['prodStr'];
        $postFields .= "&udf1=".$netbankingData['investorName'];
        $postFields .= "&udf2=".$netbankingData['investorEmail'];
        $postFields .= "&udf3=".$netbankingData['investorMobile'];
        $postFields .= "&ru=".base_url().$resonceUrl;
        $postFields .= "&udf9=purchaseTransaction";
        $postFields .= "&bankid=".$netbankingData['bankid'];

        $str = $this->config->item('Login') . $this->config->item('Password') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";

        $signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKey'),false);

        $postFields .= "&signature=".$signature;

        log_message('info','***** Purchase -  location : netbankingRequest InvestorId '.$investorId.' : postFields - '.$postFields.'  *****');
        $sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
        $sendUrlNew = $paymentUrl."?".substr($postFields,1);
        log_message('info',"***** InvestorId -  $investorId : sendURL - $sendUrl  *****");
        log_message('info','***** Purchase - location : netbankingRequest InvestorId '.$investorId.' : payment url - '.$url.'  *****');
        iLog('Send Net banking Request to ATOM',$investorId,'Web App','Investor',$investorId);
        return '{"success":true,"url":"'.$sendUrlNew.'"}';

        die;
        $returnData = $this->sendInfo($postFields,$paymentUrl);
        log_message('info','***** Purchase -  location : netbankingRequest InvestorId '.$investorId.' : first request data - '.$returnData.'  *****');
        $xmlObjArray = $this->xmltoarray($returnData);
        $url = $xmlObjArray['url'];
        if(isset($xmlObjArray['tempTxnId']) && !empty($xmlObjArray['tempTxnId'])){
            $postFields  = "";
            $postFields .= "&ttype=".$this->config->item('ttype');
            $postFields .= "&tempTxnId=".$xmlObjArray['tempTxnId'];
            $postFields .= "&token=".$xmlObjArray['token'];
            $postFields .= "&txnStage=1";
            $url = $paymentUrl."?".$postFields;
            log_message('info','***** Purchase - location : netbankingRequest InvestorId '.$investorId.' : payment url - '.$url.'  *****');
            return '{"success":true,"url":"'.$url.'"}';
        }else{
            return '{"success":false}';
        }
    }


    function xmltoarray($data)
    {
        $parser = xml_parser_create('');
        xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8");
        xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
        xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
        xml_parse_into_struct($parser, trim($data), $xml_values);
        xml_parser_free($parser);
        $returnArray = array();
        $returnArray['url'] = $xml_values[3]['value'];
        $returnArray['tempTxnId'] = $xml_values[5]['value'];
        $returnArray['token'] = $xml_values[6]['value'];
        return $returnArray;
    }

    function sendInfo($data,$paymentUrl)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $paymentUrl);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_PORT , 443);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        $returnData = curl_exec($ch);
        curl_close($ch);
        return $returnData;
    }

    function netbankingResponse()
    {
        //print_r($_POST);die;
        $response = $_POST;
        $reslog = implode(" ",$response);
        log_message('info', '*****New net Banking Response '.$reslog.' *****');

        $str = $response["mmp_txn"].$response["mer_txn"].$response["f_code"].$response["prod"].$response["discriminator"].$response["amt"].$response["bank_txn"];
        $signature =  hash_hmac("sha512",$str,$this->config->item("respHashKey"),false);
        

        // if($response['f_code']=="Ok"){
        if($signature == $response["signature"] && $response['f_code']=="Ok"){
            log_message('info', '***** transaction completed through netbanking, now updating purchase data for API hit *****');
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['bank_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            if($updPurchaseRes)
            {
                $investorId = $_SESSION["investor_id"];
                iLog('Successfully transaction completed through netbanking',$investorId,'Web App','Investor',$investorId);
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Purchased units table updated *****');
            } 
            else 
            {
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Error in updating Purchased units table *****');
            }

            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            if($updateResNetbanking)
            {
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Net banking table updated *****');
            } 
            else 
            {
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Error in updating Net banking table *****');
            }

            $investorId=$_SESSION["investor_id"];
            $totalAmount=$response['amt'];
            //this function add fro update monthly table
            $this->purchase_model->updateMonthlyInvestment($response['mer_txn']);
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }
            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
            $newJsonArr = my_array_values_recursive($jsonArray);
            $this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$newJsonArr,$actualFundTypeId,$fundTypeName,$transactionType);
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : netbankingResponse, Messege : netbanking payment successfull.*****");
            redirect(base_url().'purchase/confirmationInvestedFunds');
        }
        else
        {
            $nb_request_status = '0';
            $this->purchase_model->updatePurchaseEntry();
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : netbankingResponse, Messege : netbanking payment could not be processed. *****");
            $investorId = $_SESSION['investor_id'];
            iLog('netbanking payment could not be processed',$investorId,'Web App','Investor',$investorId);
            redirect(base_url());
        }
        redirect(base_url());
    }


/*  function netbankingResponseSIP()
    {
        //print_r($_POST);die;
        $investorId = $_SESSION['investor_id'];
        $response = $_POST;
        $reslog = implode(" ",$response);
        log_message('info','***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' :Net Banking Response - '.$reslog.'  *****');
        if($response['f_code']=="Ok"){
            log_message('info','***** transaction completed through netbanking, now updating purchase data for API hit *****');
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['mer_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            if($updPurchaseRes){
                log_message('info','***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' Messege :Purchased units table updated *****');
            } 
            else {
                log_message('info','***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' Messege :Error in updating Purchased units table *****');
            }

            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            if($updateResNetbanking){
                log_message('info', '***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' Messege : Net banking table updated *****');
            } 
            else {
                log_message('info', '***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' Messege :Error in updating Net banking table *****');
            }

            $updateResMonthlyInvestment = $this->purchase_model->updateMonthlyInvestment($response['mer_txn']);
            if($updateResMonthlyInvestment){
                log_message('info', '***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' Messege :monthly investment table updated *****');
            } else {
                log_message('info', '***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' Messege :Error in updating monthly investment table *****');
            }

            $investorId=$_SESSION["investor_id"];
            $totalAmount=$response['amt'];
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }
            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
            $newJsonArr = my_array_values_recursive($jsonArray);
            $this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$newJsonArr,$actualFundTypeId,$fundTypeName,$transactionType);
            log_message('info', '***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' Messege :netbanking payment successfull *****');
            redirect(base_url().'purchase/confirmationInvestedFunds');
        }else{
            $nb_request_status = '0';
            $this->purchase_model->updatePurchaseEntry();
            log_message('info', '***** Purchase - location : netbankingResponseSIP InvestorId '.$investorId.' Messege :netbanking payment could not be processed*****');
            redirect(base_url());
        }
        redirect(base_url());
    } */
    
    function netbankingResponseSIP()
    {
        //print_r($_POST);die;
        $investorId = $_SESSION['investor_id'];
        $response = $_POST;
        $reslog = implode(" ",$response);
        log_message('info', '*****New net Banking Response '.$reslog.' *****');

        $str = $response["mmp_txn"].$response["mer_txn"].$response["f_code"].$response["prod"].$response["discriminator"].$response["amt"].$response["bank_txn"];
        $signature =  hash_hmac("sha512",$str,$this->config->item("respHashKey"),false);
        

        if($signature == $response["signature"] && $response['f_code']=="Ok")
        {
            log_message('info','***** transaction completed through netbanking, now updating purchase data for API hit *****');
             iLog('SIP transaction completed through netbanking',$investorId,'Web App','Investor',$investorId);
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['bank_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            $updateResMonthlyInvestment = $this->purchase_model->updateMonthlyInvestment($response['mer_txn']);
            $totalAmount=$response['amt'];
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }
            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
            $newJsonArr = my_array_values_recursive($jsonArray);
            //$this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$newJsonArr,$actualFundTypeId,$fundTypeName,$transactionType);
            redirect(base_url().'purchase/confirmationInvestedFunds');
        }
        else
        {
            $nb_request_status = '0';
            iLog('SIP transaction could not be completed through netbanking',$investorId,'Web App','Investor',$investorId);
            $this->purchase_model->updatePurchaseEntry();
            redirect(base_url());
        }
        redirect(base_url());
    }

    function sendPurchaseSms($userName,$userPhone,$amount,$admin = 0)
    {
        if($userPhone!="" && $userName!="")
        {
            $ch = curl_init();
            //Like us on bit.ly/eshpind----------------
            if($admin==0)
            {
                 $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName."%2C%0AYour%20request%20for%20purchase%20of%20 mutual fund of Rs.%20".$amount."%20has%20been%20received%20at%20our%20end%2C%20It%20will%20be%20processed%20shortly.%20%0ATeam%20Investocafe.&sender=INCAFE&route=4";
                 notificationAlert('Purchase',$userName.' place Request for purchase Amount '.$amount.' phone number '.$userPhone);
            
            }
            elseif($admin==1)
            {
                 $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=Dear%20".$userName." Your Investment Plan has been Modified Successfully. Team%20Investocafe.&sender=INCAFE&route=4";
            
            }
            elseif($admin==2)
            {
                $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$userPhone."&message=A%20new%20purchase%20by%20".$userName."%20of%20amount%20".$amount. " is done for ".date("d M Y")."&sender=INCAFE&route=4";
            }
            else
            {
                return true;
            }
            
           $url=str_replace(" ", "%20", $url1);
            //echo $url;
            curl_setopt($ch, CURLOPT_URL, $url);
            //echo "<a href=''".str_replace('','%20',$url)." target='blank'>click</a>";

            //return the transfer as a string
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

            //$output contains the output string
            $output = curl_exec($ch);

            $dbData = array ('phone'=>$userPhone,'response'=>$output);
            $this->db->insert('msg_log',$dbData);
            //close curl resource to free up system resources
            curl_close($ch);

            if ( $output === FALSE)
            {
              $output=curl_error($ch); //echoes last session error
              return false;
            }
            return $output;
        }
        else
        {
            echo "Invalid user name or phone number";
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : sendPurchaseSms, Messege : Invalid user name or phone number for send Sms For purchase funds. *****");
        }
    }

    
    function sendPurchaseFundByMoreOptionsEmail($amount,$investmentDate,$investedFundList,$fundTypeName,$transactionType)
    {
        if($transactionType==1)
        {
            $transactionType="Automated Transfer";
        }
        else
        {
            $transactionType="Netbanking";
        }
        $email=$_SESSION["email"];
        $name=$this->encrypt->decode($_SESSION["userName"]);
        $today = date('d M Y h:i a', time());
        $data=array();
        $data["fundTypeName"]=$fundTypeName;
        $data["name"]=$name;
        $data["transactionType"]=$transactionType;
        $data['amount']=$amount;
        $data['requestDate']=$investmentDate;
        $data["fundsList"]=$investedFundList;
        $html=$this->load->view('invested_funds_by_mo_confirmation_email_view', $data,true);
        $subject="Your investment with Investocafe has been scheduled";
        $out = sendEmail($email,$subject,$html);
        return $out;
    }

    //---------------//---------------//-----------------//----------------//

    function startInvestingMonthlySetup($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("amit_theme/purchase/start_invest_sip_monthly_one_click_radiobtn_view",$fundTypeId);
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase monthly sip $fundTypeName funds(One Click) page by selecting setup automated transfer");
                    addSystemLog($data); // helper function
                    log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : startInvestingMonthlySetup, Messege : Visited purchase monthly sip $fundTypeName funds(One Click) page by selecting setup automated transfer *****");
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function startInvestingSIPMonthlyNetbankingSetup($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("amit_theme/purchase/start_invest_sip_monthly_one_click_radiobtn_nb_view",$fundTypeId);
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase monthly sip $fundTypeName funds(One Click) page by selecting netbanking");
                    addSystemLog($data); // helper function
                    log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : startInvestingSIPMonthlyNetbankingSetup, Messege : Visited purchase monthly sip $fundTypeName funds(One Click) page by selecting netbanking *****");
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function startInvestByMoreOptionSipMonthly($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("amit_theme/purchase/start_invest_sip_monthly_more_option_radiobtn_view",$fundTypeId);
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase monthly sip  $fundTypeName funds(Do it Yourself) page by selecting setup automated transfer");
                    addSystemLog($data); // helper function
                    log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : startInvestByMoreOptionSipMonthly, Messege : Visited purchase monthly sip  $fundTypeName funds(Do it Yourself) page by selecting setup automated transfer *****");
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function startInvestByMoreOptionSipMonthlyNetbanking($fundTypeId=0)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            if(isset($_SESSION["pageId"]) && !empty($_SESSION["pageId"]))
            {
                $pageId=($_SESSION["pageId"]);
                if(in_array("6", $pageId))
                {
                    $this->_loadView("amit_theme/purchase/start_invest_sip_monthly_more_option_radiobtn_nb_view",$fundTypeId);
                    $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited purchase monthly sip  $fundTypeName funds(Do it Yourself) page by selecting netbanking");
                    addSystemLog($data); // helper function
                    log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : startInvestByMoreOptionSipMonthlyNetbanking, Messege : Visited purchase monthly sip  $fundTypeName funds(Do it Yourself) page by selecting netbanking *****");
                }
                else
                {
                    redirect(base_url());
                }
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    // purchase fund for sip monthly common for one click or more option view
    function purchaseFundsForSipMonthlyOnServer()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorIp=$_SERVER['REMOTE_ADDR'];
            $transactionType=$this->input->post("transactionType");
            $investmentDate=$this->input->post("investmentDate");
            $noOfMonths=$this->input->post("noOfMonths");
            $json=$this->input->post("json");
            $fundTypeId=$this->input->post("fundTypeId");
            $jsonArray=json_decode($json,true);
            $netbankingFlag=$this->input->post("netbankingFlag");
            $investorId=$_SESSION["investor_id"];
            $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");

            if(isset($netbankingFlag) && $netbankingFlag == 'true')
            {
                $this->load->model('purchase_cron/api_model','api_model');
                $this->load->model('registration_model');
                $totalAmount = 0;
                $prodStr = '<products>';
                $cnt=1;
                foreach($jsonArray as $fundDetails)
                {
                    $totalAmount = $totalAmount+$fundDetails[1];
                    $fullFundDetails = $this->api_model->getFundDetails($fundDetails[0]);
                    $prodStr .= "<product>";
                    $prodStr .= "<id>".$cnt."</id>";
                    $prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
                    $prodStr .= "<amount>".$fundDetails[1]."</amount>";
                    $prodStr .= "</product>";
                    $cnt=$cnt+1;
                }
                $prodStr .= '</products>';
                $netbankingData['totalAmount'] = $totalAmount;
                $netbankingData['investorId'] = $investorId;
                $getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
                $investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
                $netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
                $netbankingData['prodStr'] = $prodStr;
                $netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
                $getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
                $netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
                $netbankingData['investorEmail'] = $getInvestorDetails->email;
                $netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
                $netbankingData['investorAddress'] = $getInvestorDetails->address;
                $netbankingData['batchId'] = $batchId;
                $transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
                $nb_request = '1';
                $nb_request_status = '0';
                $this->createPurchaseEntrySIP($noOfMonths,$batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
                log_message('info', '***** '.$investorId.' - Purchased units data created before netbanking payment *****');
                $purchaseType = 'SIP';
                $netbankingResponse = $this->netbankingRequest($netbankingData,$transactionId,$purchaseType);

                log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : purchaseFundsForSipMonthlyOnServer, Messege : netbanking data created ***** Net Banking Response: '.$netbankingResponse);
                echo $netbankingResponse;
            }else{
                $nb_request = 0;
                $nb_request_status = 0;
                $transactionId = 0;
                //echo  $fundTypeId;die;
                $result = $this->createPurchaseEntrySIP($noOfMonths,$batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
                echo $result;
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
        }
    }

    function createPurchaseEntrySIP($noOfMonths,$batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId)
    {
        $investorIp=$_SERVER['REMOTE_ADDR'];
        $investorId=$_SESSION["investor_id"];
        date_default_timezone_set("Asia/Kolkata");
        $date = new DateTime($investmentDate);
        $requestDate=$date->format('Y-m-d ').date("h:i:s");

        $time = strtotime($requestDate);
        $nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));

        $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $count=0;
            $totalAmount=0;
            foreach ($jsonArray as $row)
            {
                $perFundInvestAmount=$row[1];
                $totalAmount=$totalAmount+$row[1];
                $fundId=$row[0];
                $amc_code = $this->purchase_model->get_amc_code($fundId);
                $checkResult=$this->purchase_model->checkFirstTimePurchaseSIPFund($fundId,$investorId);
                if($checkResult){
                        $isFirstPurchase=0;
                }else{
                        $isFirstPurchase=1;
                }
                
                $resultFolio=getLatestFolioNumber($amc_code,$investorId);
                if($resultFolio){
                        $folioNumber=$resultFolio;
                }else{
                        $folioNumber="";
                }

                $sipEndDate = date('Y-m-d', strtotime("+".$noOfMonths." months", strtotime($requestDate)));
                $monthlyInvestmentdata= array(
                        "fund_id"=>$fundId,
                        "investor_id"=>$investorId,
                        "amount"=>$perFundInvestAmount,
                        "sip_start_date"=>$requestDate,
                        "sip_end_date"=>$sipEndDate,
                        "next_investment_date"=>$nextInvestmentDate,
                        "no_of_months"=>$noOfMonths,
                        "batch_id"=>$batchId,
                        "is_stopped_sip"=>1,
                        );
                $monthlyInvestmentId=$this->purchase_model->addSipMonthlyInvestmentFunds($monthlyInvestmentdata);
            
                $action ="Today is SIP of InvestorId - ".$investorId;
                $date = $nextInvestmentDate;
                addDailyAgenda($action,$date);
                
                $unitCounts=0;
                $apiTypeId="";
                $apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
                
                $data=array(
                        "fund_id"=>$fundId,
                        "purchased_amount"=>$perFundInvestAmount,
                        "unit_count"=>$unitCounts,
                        "investor_id"=>$investorId,
                        "request_date"=>$requestDate,
                        "batch_id"=>$batchId,
                        "folio_number"=>$folioNumber,
                        "is_first_purchase"=>1,
                        "api_batch_id"=>$apiBatchId,
                        "investment_plan_type"=>"SIP Monthly",
                        "is_monthly_sip"=>1,
                        "investor_ip"=>$investorIp,
                        "nb_request"=>$nb_request,
                        "nb_request_status"=>$nb_request_status,
                        "mer_txn"=>$transactionId,
                        "amc_code" => $amc_code
                        );
                $purchasedUnitsId=$this->purchase_model->addPurchaseFunds($data);
                if($purchasedUnitsId)
                {
                    // add details in monthly mapping table
                    $data=array("monthly_investment_id"=>$monthlyInvestmentId,"purchased_units_id"=>$purchasedUnitsId);
                    $this->purchase_model->addMonthlyInvestmentMappingData($data);
                }else{$count++;}
            }
            if($count==0)
            {
                if($transactionType==1)
                {
                    $result = $this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$jsonArray,$fundTypeId,$fundTypeName,$transactionType);
                    return $result;
                }
            }
            else
            {
                log_message('info', '****InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : createPurchaseEntrySIP, Messege : * Failed investment in '.$fundTypeName.' funds *****');
                return '{"success":false,"msg":"Failed investment in '.$fundTypeName.' funds"}';
            }
        }
    }

    // modify one time investment
    function modify($fundTypeId=null)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            $investorId=$_SESSION["investor_id"];
            $userId=$_SESSION["userId"];
            $batchId=$this->input->get("batchId");
            if(in_array("6", $pageId))
            {
                $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
                if($result)
                {
                    $data["profileImageUrl"]=$result->profile_image_url;
                    $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                    $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
                    $data["is_verify"]=$result->is_verify;
                }
                else
                {
                    $data["profileImageUrl"]="";
                }

                if($fundTypeId)
                {
                    $data["investFunds"]=$this->purchase_model->getInstedFundsByBatchId($batchId,$investorId);
                }

                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);

                $data["fundTypeName"]=$fundTypeName;
                $data["fundTypeId"]=$fundTypeId;

                $data['jsFile'] ='purchase/purchase.js';
                $data['jsFileExtra'] ='dashboard/sipCalculation.js';
                $this->load->view('amit_theme/common/header',$data);
                $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
                $this->load->view("amit_theme/purchase/modify_plan_view",$data);
                $this->load->view('amit_theme/common/footer',$data );
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited modify plans funds page");
                addSystemLog($data); // helper function
                log_message('info', '****InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modify, Messege : Visited modify plans funds page *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function modifyPurchasedFundsOnServer()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $pageId=$_SESSION["pageId"];
            if(in_array("6", $pageId))
            {
                $requestDateOld=$this->input->post("requestDate");
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $json=$this->input->post("json");
                $fundTypeId=$this->input->post("fundTypeId");
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $investedFundList=json_decode($json,true);

                $result=$this->purchase_model->updatePurchsedFundsOnServer($investedFundList,$requestDate,$investorId);
                if($result)
                {
                    $userId=$_SESSION["userId"];
                    $resultData=$this->common_model->getUseDetailsByUserId($userId);
                    if($resultData)
                    {
                        $name=$this->encrypt->decode($resultData->username);
                        $phone=$this->encrypt->decode($resultData->phone);
                        $this->sendPurchaseSms($name,$phone,0,1);
                        $this->sendEmailANdSmsTousers($fundTypeName);
                    }
                    $message="Successfully modify ".$fundTypeName." funds effect from ".$requestDateOld;
                    $this->session->set_flashdata('message',$message);
                    log_message('info', '****InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifyPurchasedFundsOnServer, Messege : '.$message.' *****');
                    echo '{"success":true}';
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function

                }
                else
                {
                    $message="Failed moditying invested '.$fundTypeName.' funds";
                    echo '{"success":false}';
                    $this->session->set_flashdata('message',$message);
                    log_message('info', '****InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifyPurchasedFundsOnServer, Messege : '.$message.' *****');
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
            }
        }
    }
    
    public function sendEmailANdSmsTousers($fundTypeName)
    {
        $user_id = $_SESSION['userId'];
        $res = $this->db->query("select phone,username,email from users where id = ".$user_id."");
        
        $data['msg'] = "Thank you for choosing Investocafe. You're on your way to growing your wealth safely with us.<br /><br />Your instruction for the execution with respect to your investments in Mutual Funds to Investocafe has been received and will be executed. The details are as under: ";
        $res = $res->row();
        $first_name =  $this->encrypt->decode($res->username);
        $data['investor_name'] = $first_name;
        $email = $res->email;
        $Phone = $this->encrypt->decode($res->phone);
        
        $data['fund_name'] = $fundTypeName;
        $data['type_of_instruction'] = "Modify";
        $data['subject'] = "Confirmation mail for Modify transection";
        $this->sendMailformodifyFund($data,$email);

    }
    
    function sendMailformodifyFund($data,$email ="")
    {
        if($email = "")
        {
            $email=$_SESSION["email"];
        }
        //$email = "amitmeena0206@gmail.com";
        $html=$this->load->view('skip_update_stop_sip_mail', $data,true);
        $subject=$data['subject'];
        $out = sendEmail($email,$subject,$html);
        return $out;
    }

    
    function testModifyDateOnly(){
        $investFunds=$this->purchase_model->getSIPInvestedFundsByBatchId(396,12);
        $request_date='';
         foreach ($investFunds as $row)
                                {
                                $request_date= $row->sip_start_date;    
                                    
                                }
                                echo 'request date:'.$request_date;
                            $today_date=date("Y-m-d");
                            echo "Today is " . $today_date . "<br>";    
                         $tomorrow_date = date("Y-m-d",strtotime($today_date . "+1 days"));
                                echo "tomorrow is " . $tomorrow_date . "<br>";
                
                //  $diff=date_diff($request_date,$date2)                               
                $same_month_date=date("Y-m-d",strtotime($request_date . "-2 days"));
                echo "same_month_date date:".$same_month_date."<br>";
                
                
                $not_eligible_date=date("Y-m-d",strtotime($request_date . "-1 days"));
                echo "same_month_date date:".$same_month_date."<br>";
                
                
                
                if($today_date<=$same_month_date){
                    echo 'show same month';
                }else if($today_date==$not_eligible_date){
                    echo 'show popup for can only modify/cancel before 2 days of investment';
                }else if($today_date>=$request_date){
                    echo 'show next month';
                }
                                
    }
    // modify sip plan
    function modifysip($fundTypeId=null)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            $investorId=$_SESSION["investor_id"];
            $userId=$_SESSION["userId"];
            $batchId=$this->input->get("batchId");
            if(in_array("6", $pageId))
            {
                $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
                if($result)
                {
                    $data["profileImageUrl"]=$result->profile_image_url;
                    $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                    $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
                    $data["is_verify"]=$result->is_verify;
                }
                else
                {
                    $data["profileImageUrl"]="";
                }
                

                if($fundTypeId)
                {
                    $investFunds=$this->purchase_model->getSIPInvestedFundsByBatchId($batchId,$investorId);
                
                if($investFunds)
                {
                    $data["investFunds"]=$investFunds;
                    $request_date='';
                    $next_investment_date='';
                    foreach ($investFunds as $row)
                    {
                        $request_date= $row->sip_start_date;    
                        $next_investment_date=$row->next_investment_date;
                    }
                    
                    $same_month_date=date("Y-m-d",strtotime($request_date . "-2 days"));
                    $not_eligible_date=date("Y-m-d",strtotime($request_date . "-1 days"));
                    $today_date=date("Y-m-d");
                    
                    if($today_date<=$same_month_date){
                        $data["request_date"]=$request_date;
                        //echo 'show same month';
                    }else if($today_date==$not_eligible_date){
                        //echo 'show popup for can only modify/cancel before 2 days of investment';
                        $data["request_date"]=$next_investment_date;
                    }else if($today_date>=$request_date){
                        //echo 'show next month';
                        $data["request_date"]=$next_investment_date;
                    }
                    
                    
                    
                    
                    
                    
                }
                }

                
                
                
                
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);

                $HolliDay = $this->purchase_model->add_holliday_date();
                $data["HolliDate"]  = $HolliDay;
                $data["fundTypeName"]=$fundTypeName;
                $data["fundTypeId"]=$fundTypeId;
    
                $data['jsFile'] ='purchase/purchase.js';
                $data['jsFileExtra'] ='dashboard/sipCalculation.js';
                $this->load->view('amit_theme/common/header',$data);
                $this->load->view('amit_theme/dashboard/dashboard_header_view',$data);
                $this->load->view("amit_theme/purchase/modify_sip_plan_view",$data);
                $this->load->view('amit_theme/common/footer',$data );
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Visited modify sip plans funds page");
                addSystemLog($data); // helper function
                log_message('info', '**** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysip, Messege : Visited modify sip plans funds page *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }
    

    function modifysipPurchasedFundsOnServer()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $pageId=$_SESSION["pageId"];
            if(in_array("6", $pageId))
            {
                $requestDateOld=$this->input->post("requestDate");
                $noOfMonths=$this->input->post("noOfMonths");
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $json=$this->input->post("json");
                $fundTypeId=$this->input->post("fundTypeId");
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $investedFundList=json_decode($json,true);
                 log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, err_Msg1 : investedFundList *****');
                
                
                $result=$this->purchase_model->updateSipPurchsedFundsOnServer($investedFundList,$requestDate,$investorId,$noOfMonths);
                
                if($result)
                {
                    $message="Successfully modify monthly sip ".$fundTypeName." funds effect from ".$requestDateOld;
                    $this->session->set_flashdata('message', $message);
                    log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, Messege : '.$message.' *****');
                    echo '{"success":true}';
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
                else
                {
                    echo '{"success":false}';
                    $message="Failed moditying invested  '.$fundTypeName.' funds";
                    log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, error_Messege :  '.$message.' *****');
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
                 
            }
        }
    }


    function getFundDetailsByFundTypeId($fundTypeId)
    {
        $result=$this->purchase_model->getFundsByFundTypeId($fundTypeId);
        if(isset($result) && !empty($result))
        {
            for($i=0,$j=0; $i<count($result); $i++,$j++)
            {
                $rowArr = $result[$i];
                if(isset($rowArr->partner_fund_id) && $rowArr->partner_fund_id != 0)
                {
                    $dividendFundDetails=$this->purchase_model->getFundDetailsById($rowArr->partner_fund_id);
                    $data[$rowArr->sf_name]['growthArr'] = $rowArr;
                    $data[$rowArr->sf_name]['dividendArr'] = $dividendFundDetails;

                    $i = $i+1;
                }else{
                    $data[$rowArr->scheme_description]['regularPlan'] = $rowArr;

                }
            }

            if(isset($data) && !empty($data))
            {
                //print_r($rowArr);
                return $data;
            }
            else{
                return false;
            }
        }
        else
        {
            return false;
        }
    }

    function appGetFundDetailsByFundTypeId($fundTypeId,$hideRel=false)
    {
        $result=$this->purchase_model->getFundsByFundTypeId($fundTypeId);
        if(isset($result) && !empty($result))
        {
            for($i=0,$j=0; $i<count($result); $i++,$j++)
            {
                /*  $rowArr = $result[$i];
                if(isset($rowArr->partner_fund_id) && $rowArr->partner_fund_id != 0)
                {
                    $dividendFundDetails=$this->purchase_model->getFundDetailsById($rowArr->partner_fund_id);
                    //$data[$j]['growthArr'] = $rowArr;
                    $data[$j]['regularPlan'] = $dividendFundDetails;

                    $i = $i+1;
                }else{
                    $data[$j]['regularPlan'] = $rowArr;

                } */ 
                  $result[$i]->fundDetailsLink = base_url('fundDocuments/id/'.$result[$i]->fund_id);

                  $result[$i]->min_purchase_amt = intval($result[$i]->min_purchase_amt)."";
                  $result[$i]->SIP_min_amount = intval($result[$i]->SIP_min_amount)."";
                  $rowArr = $result[$i];
                if(isset($rowArr->partner_fund_id) && $rowArr->partner_fund_id != 0)
                {
                    $dividendFundDetails=$this->purchase_model->getFundDetailsById($rowArr->partner_fund_id);
                    $data[$j]['growthArr'] = $rowArr;
                    $dividendFundDetails->min_purchase_amt = intval($dividendFundDetails->min_purchase_amt)."";
                    $data[$j]['dividendArr'] = $dividendFundDetails;

                    $i = $i+1;
                }else{
                    if ($rowArr->fund_id!="9240") {
                        $data[$j]['regularPlan'] = $rowArr;
                    }
                    else {
                        if (!$hideRel) {
                            $data[$j]['regularPlan'] = $rowArr;
                        }
                        else {
                            $j--;
                        }
                    }
                    
                    

                } 
            }

            if(isset($data) && !empty($data))
            {
                //print_r($rowArr);
                return $data;
            }
            else{
                return false;
            }
        }
        else
        {
            return false;
        }
    }

    function createKarvyFatcaPDF($investorId)
    {
        $result = $this->purchase_model->getInvestorDetailById($investorId);
        $taxResident = $this->purchase_model->getTaxResidentInfo($investorId);

        $data['row'] = $result;
        $data['taxResidentRow'] =  $taxResident;
        $pdfBody = $this->load->view('karvy_fatca_form_view',$data,true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try
        {
            $mpdf=new mPDF('win-1252','A4','','DejaVuSans',0,0,0,0,10,10,'');
            $mpdf->useOnlyCoreFonts = true;    // false is default
            $mpdf->SetProtection(array('print'));
            $mpdf->SetTitle("KARVY FATCA FORM");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');
            $html=$pdfBody;
            $mpdf->WriteHTML($html);
            $fileName = 'KARVY_FATCA'.$investorId.date('YmdHis', time()).'.pdf';
            $mpdf->Output(APPPATH.'../assets/uploads/fatca_form_pdf/'.$fileName, 'F');
            $pdfPath = realpath(APPPATH.'../assets/uploads/fatca_form_pdf/'.$fileName);
            $docData= array(
                        'url'=> base_url().'assets/uploads/fatca_form_pdf/'.$fileName,
                        'original_name'=>$fileName,
                        );

            $docTypeId=26; // Default document type id 26 for fatca form karvy
            $result=$this->purchase_model->updateDocumentChecklist($investorId,$docTypeId,$docData);
            return $result;
        }
        catch(Exception $e)
        {
            log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase,  Function : createKarvyFatcaPDF, Messege :  '.$e.' *****');
            echo $e;die;
        }
    }

    function createCamsFatcaPDF($investorId)
    {
        $result = $this->purchase_model->getInvestorDetailById($investorId);
        $taxResident = $this->purchase_model->getTaxResidentInfo($investorId);
        $data['row'] = $result;
        $data['taxResidentRow'] =  $taxResident;
        $pdfBody = $this->load->view('cams_fatca_form_view',$data,true);
        $this->load->library('mpdf60/mPDF');
        $pdfPath = '';
        try
        {
            $mpdf=new mPDF('win-1252','A4','','DejaVuSans',5,5,5,5,10,10,'');
            $mpdf->useOnlyCoreFonts = true;    // false is default
            $mpdf->SetProtection(array('print'));
            $mpdf->SetTitle("CAMS FATCA FORM");
            $mpdf->SetAuthor("Audit");
            $mpdf->showWatermarkText = true;
            $mpdf->SetDisplayMode('fullpage');

            $html=$pdfBody;
            $mpdf->WriteHTML($html);

            $fileName = 'CAMS_FATCA'.$investorId.date('YmdHis', time()).'.pdf';
            $mpdf->Output(APPPATH.'../assets/uploads/fatca_form_pdf/'.$fileName, 'F');
            $pdfPath = realpath(APPPATH.'../assets/uploads/fatca_form_pdf/'.$fileName);
            $docData= array(
                        'url'=> base_url().'assets/uploads/fatca_form_pdf/'.$fileName,
                        'original_name'=>$fileName,
                        );

            $docTypeId=27; // Default document type id 26 for fatca form karvy
            $result=$this->purchase_model->updateDocumentChecklist($investorId,$docTypeId,$docData);
            return $result;
        }
        catch(Exception $e)
        {
            log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase,  Function : createCamsFatcaPDF, Messege :  '.$e.' *****');
            echo $e;die;
        }
    }

    function createBankCheckBoxLogMsg()
    {
        $ip_address=$this->input->ip_address();
        $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Accepted third party bank account terms and condition, ip address = '".$ip_address."' ");
        addSystemLog($data);
        log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : purchase, Function : createBankCheckBoxLogMsg, Message : Accepted third party bank account terms and condition, ip address = '.$ip_address.' *****');
    }
    

    
    
    
    

/*

------------------------------------------------------------------------------------------------------

|                                   THIS SECTION CANTAINT MOBILE APP APIS 

------------------------------------------------------------------------------------------------------

*/







    function appStartInvestByType($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/investment_type_view",$fundTypeId);
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>"Invest More button clicked for Fund Type -  $fundTypeName");
                addSystemLog($data); // helper function
                log_message('info', '***** Controller : Purchase, Function : startInvestByType, Message : Invest More button clicked for Fund Type -  '.$fundTypeName.' *****');
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function appUpdateFatcaDeclaration()
    {
        $data = json_decode(file_get_contents("php://input"));
        $investorId = $data->investorId;
        $fatca=$data->fatca;
        $data=array();
        if(isset($investorId))
        {
            $result=$this->purchase_model->updateFatcaDeclaration($fatca,$investorId);
            if($fatca==1)
            {
                $karvyFatcaResult=$this->createKarvyFatcaPDF($investorId);
                $camsFatcaResult = $this->createCamsFatcaPDF($investorId);
                if($karvyFatcaResult && $camsFatcaResult)
                {
                    echo '{"success":"true","msg":"FATCA pdf generated by Mobile application"}';
                    iLog('FATCA pdf generated',$investorId,'Android','Investor',$investorId);
                }
                else
                {
                    echo '{"success":"false","msg":"FATCA pdf generated"}';
                }
            }
            else
            {
                echo '{"success":"true","msg":"Wrong value"}';
            }
        }
        else
        {           
            echo '{"success":"false","msg":"Unable to get investor"}';
        }

    }

    function adminUpdateFatcaDeclaration($investorId)
    {
        $fatca=1;
        $data=array();
        if(isset($investorId))
        {
            $result=$this->purchase_model->updateFatcaDeclaration($fatca,$investorId);
            if($fatca==1)
            {
                $karvyFatcaResult=$this->createKarvyFatcaPDF($investorId);
                $camsFatcaResult = $this->createCamsFatcaPDF($investorId);
                if($karvyFatcaResult && $camsFatcaResult)
                {
                    echo '{"success":"true","msg":"FATCA pdf generated by Mobile application"}';
                    iLog('FATCA pdf generated',$investorId,'Web','Admin',1);
                }
                else
                {
                   echo '{"success":"false","msg":"FATCA pdf generated"}';
                }
            }
            else
            {
                echo '{"success":"true","msg":"Wrong value"}';
            }
        }
        else
        {           
            echo '{"success":"false","msg":"Unable to get investor"}';
        }
    }

    public function checkFatkaC($investorId)
    {
        $karvyFatcaResult=$this->createKarvyFatcaPDF($investorId);
        $camsFatcaResult = $this->createCamsFatcaPDF($investorId);
        echo "karvyFatcaResult ".$karvyFatcaResult."<br />";
        echo "camsFatcaResult ".$camsFatcaResult."<br />";
        if($karvyFatcaResult && $camsFatcaResult)
        {
            $data["investor_id"]=$investorId;
            $data["log_msg"]="FATCA pdf generated";
            echo '{"success":"true","msg":"FATCA pdf generated by mobile application"}';
            addSystemLog($data); // helper function
            log_message('info', '***** InvestorId : '.$investorId.', Controller : purchase, Function : updateFatcaDeclaration, Message : FATCA pdf generated *****');
        }
        else
        {
            echo '{"success":"false","msg":"FATCA pdf generated"}';
            log_message('info', '***** InvestorId : '.$investorId.', Controller : purchase, Function : updateFatcaDeclaration, Message : Error in generating pdf file *****');
        }
    }
    
    function apploadView()
    {
        $data = json_decode(file_get_contents("php://input"));
        $fundTypeId = $data->fundTypeId;
        $investorId = $data->investorId;
        $investmentType = $data->investmentType;
        $userId = $data->userId;
        $data=array();
        if(isset($investorId))
        {
            $resultStatus=$this->common_model->getInvestorStatus($investorId);
            if($resultStatus)
            {
                $kycDone=$resultStatus->is_kyc_done;
            }

            if($fundTypeId)
            {
                $hideRel = false;
                if ($fundTypeId==1 && isset($investmentType) && $investmentType=="oneTimeInvestment") {
                    $hideRel = true;
                }
                $data["radioFundDetails"]=$this->appGetFundDetailsByFundTypeId($fundTypeId,$hideRel);
            }
            $data["investorBankDetails"]=$this->purchase_model->getInvestorBankAndPanDetail($investorId);
            $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
            $data["fundTypeName"]=$fundTypeName;
            $data["fundTypeId"]=$fundTypeId;
            $data['todays_date'] = date("d-m-Y");
            $output=json_encode($data);
            iLog('Visit purchase page by mobile application',$investorId,'Mobile App','Investor',$investorId);
            echo $output;
        }
    }


    function apploadViewAndroid()
    {
        $data = json_decode(file_get_contents("php://input"));
        $fundTypeId = $data->fundTypeId;
        $investorId = $data->investorId;
        $investmentType = $data->investmentType;
        $userId = $data->userId;
        $data=array();
        if(isset($investorId))
        {
            $resultStatus=$this->common_model->getInvestorStatus($investorId);
            if($resultStatus)
            {
                $kycDone=$resultStatus->is_kyc_done;
            }

            if($fundTypeId)
            {
                $hideRel = false;
                if ($fundTypeId==1 && isset($investmentType) && $investmentType=="oneTimeInvestment") {
                    $hideRel = true;
                }
                $data["radioFundDetails"]=$this->appGetFundDetailsByFundTypeId($fundTypeId,$hideRel);
            }
            $data["investorBankDetails"]=$this->purchase_model->getInvestorBankAndPanDetail($investorId);
            $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
            $data["fundTypeName"]=$fundTypeName;
            $data["fundTypeId"]=$fundTypeId;
            $data['todays_date'] = date("d-m-Y");
            $output=json_encode($data);
            $data=array("investor_id"=>$investorId,"log_msg"=>"Visit purchase page by mobile application");
            addSystemLog($data); // helper function
            echo $output;
        }
    }
     /** common purchase for all fund by fund type id **/

    function appPurchaseOneTimeInvestmentFunds()
    {
        $get = json_decode(file_get_contents("php://input"));
        $investorId=$get->investorId;
        if($investorId)
        {
            $transactionType=$get->transactionType;
            $investmentDate=$get->investmentDate;
            $userId=$get->userId;
            $json = $get->json;
            $fundTypeId=$get->fundTypeId;
            $jsonArray=$json;
            $netbankingFlag=$get->netbankingFlag;
            $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");

            if(isset($netbankingFlag) && $netbankingFlag == 'true')
            {
                $this->load->model('purchase_cron/api_model','api_model');
                $this->load->model('registration/registration_model','registration_model');
                $totalAmount = 0;
                $prodStr = '<products>';
                $cnt=1;
                foreach($jsonArray as $fundDetails)
                {
                    if($fundDetails[1]%500 && $fundTypeId ==3){
                        return '{"success":false}';
                    }
                    $totalAmount = $totalAmount+$fundDetails[1];
                    $fullFundDetails = $this->api_model->getFundDetails($fundDetails[0]);
                    $prodStr .= "<product>";
                    $prodStr .= "<id>".$cnt."</id>";
                    $prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
                    $prodStr .= "<amount>".$fundDetails[1]."</amount>";
                    $prodStr .= "</product>";
                    $cnt=$cnt+1;
                }
                $prodStr .= '</products>';
                $netbankingData['totalAmount'] = $totalAmount;
                $netbankingData['investorId'] = $investorId;
                $getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
                $investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
                $netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
                $netbankingData['prodStr'] = $prodStr;
                $netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
                $getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
                $netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
                $netbankingData['investorEmail'] = $getInvestorDetails->email;
                $netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
                $netbankingData['investorAddress'] = $getInvestorDetails->address;
                $netbankingData['batchId'] = $batchId;

                $transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
                $nb_request = '1';
                $nb_request_status = '0';
                $this->appCreatePurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId,$investorId,$userId);
                log_message('info', '***** InvestorId : '.$investorId.', Controller : Prchase, Function : purchaseOneTimeInvestmentFunds, Message : Purchased units data created before netbanking payment *****');
                $purchaseType = 'OneTime';
                $netbankingResponse = $this->appNetbankingRequest($netbankingData,$transactionId,$purchaseType,$investorId);
                log_message('info', '***** Controller : Purchase, Function : purchaseOneTimeInvestmentFunds, Message : netbanking data created *****');
                echo $netbankingResponse;
            }
            else
            {
                $nb_request = 0;
                $nb_request_status = 0;
                $transactionId = 0;
                //echo  $fundTypeId;die;
                $result = $this->appCreatePurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId,$investorId,$userId);
                echo $result;
            }
        }
        else
        {
            echo '{"success":"false","session":"out"}';
        }

    }


    function appNetbankingRequest($netbankingData,$transactionId,$purchaseType,$investorId)
    {
        if($purchaseType == 'OneTime')
        {
            $resonceUrl = 'purchase/appNetbankingResponse';
        }       
        else
        {
            $resonceUrl = 'purchase/appNetbankingResponseSIP';
        }

        $investorId = $investorId;
        date_default_timezone_set("Asia/Kolkata");
        $datenow = date("d/m/Y");
        $paymentUrl = $this->config->item('Url');
        $postFields  = "";
        $postFields .= "&login=".$this->config->item('Login');
        $postFields .= "&pass=".$this->config->item('Password');
        $postFields .= "&ttype=".$this->config->item('ttype');
        $postFields .= "&prodid=".'Multi';
        $postFields .= "&amt=".$netbankingData['totalAmount'];
        $postFields .= "&txncurr=".$this->config->item('TxnCurr');
        $postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
        $postFields .= "&clientcode=".$this->config->item('clientCode');
        $postFields .= "&txnid=".$transactionId;
        $postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
        $postFields .= "&date=".$datenow;
        $postFields .= "&mprod=".$netbankingData['prodStr'];
        $postFields .= "&udf1=".$netbankingData['investorName'];
        $postFields .= "&udf2=".$netbankingData['investorEmail'];
        $postFields .= "&udf3=".$netbankingData['investorMobile'];
        $postFields .= "&ru=".base_url().$resonceUrl;
        $postFields .= "&udf9=purchaseTransaction";
        $postFields .= "&bankid=".$netbankingData['bankid'];

        $str = $this->config->item('Login') . $this->config->item('Password') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";

        $signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKey'),false);

        $postFields .= "&signature=".$signature;

       
        $sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
         $sendUrlNew = $paymentUrl."?".substr($postFields,1);
        
         log_message('info','***** Purchase -  location : netbankingRequest InvestorId '.$investorId.' : postFields - '.$postFields.'  *****');
        return '{"success":"true","url":"'.$sendUrlNew.'"}';
        die;
        
        log_message('info',$investorId.' - responseURL *****' .base_url().$resonceUrl. ' *****');
        log_message('info',$investorId.' - postFields *****' . $postFields . ' *****');
        $sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
        log_message('info',$investorId.' - sendURL', '*****' . $sendUrl . ' *****');
        $returnData = $this->sendInfo($postFields,$paymentUrl);
        log_message('info',$investorId.' first request data- *****' . $returnData . ' *****');
        $xmlObjArray = $this->xmltoarray($returnData);

        $url = $xmlObjArray['url'];
        if(isset($xmlObjArray['tempTxnId']) && !empty($xmlObjArray['tempTxnId']))
        {
            $postFields  = "";
            $postFields .= "&ttype=".$this->config->item('ttype');
            $postFields .= "&tempTxnId=".$xmlObjArray['tempTxnId'];
            $postFields .= "&token=".$xmlObjArray['token'];
            $postFields .= "&txnStage=1";

            $url = $paymentUrl."?".$postFields;
            log_message('info ', 'payment url-*****' . $url . ' *****');
            return '{"success":"true","url":"'.$url.'"}';

        }else{
            return '{"success":false}';
        }

    }
    
    function appNetbankingResponse()
    {
        $response = $_POST;
        $reslog = implode(" ",$response);
        log_message('info', '*****New net Banking Response App'.$reslog.' *****');

        $str = $response["mmp_txn"].$response["mer_txn"].$response["f_code"].$response["prod"].$response["discriminator"].$response["amt"].$response["bank_txn"];
        $signature =  hash_hmac("sha512",$str,$this->config->item("respHashKey"),false);
        

        // if($response['f_code']=="Ok"){
        if($signature == $response["signature"] && $response['f_code']=="Ok"){
            log_message('info', '***** transaction completed through netbanking, now updating purchase data for API hit *****');
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['mer_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            //$investorId=$_SESSION["investor_id"];
            $totalAmount=$response['amt'];
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }

            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
            $newJsonArr = my_array_values_recursive($jsonArray);
            //$this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$newJsonArr,$actualFundTypeId,$fundTypeName,$transactionType);
            $this->load->view('amit_theme/demo.php', ['response' => $response]);
        }
        else
        {
                $nb_request_status = '0';
                $this->purchase_model->updatePurchaseEntry();
                $this->load->view('amit_theme/demo.php', ['response' => $response]);
        }
        
    }
    
    function appNetbankingResponseSIP()
    {
        //print_r($_POST);die;
        $response = $_POST;
        $reslog = implode(" ",$response);
        log_message('info', '*****New net Banking Response App'.$reslog.' *****');

        $str = $response["mmp_txn"].$response["mer_txn"].$response["f_code"].$response["prod"].$response["discriminator"].$response["amt"].$response["bank_txn"];
        $signature =  hash_hmac("sha512",$str,$this->config->item("respHashKey"),false);
        

        // if($response['f_code']=="Ok"){
        if($signature == $response["signature"] && $response['f_code']=="Ok"){
            log_message('info', '***** transaction completed through netbanking, now updating purchase data for API hit *****');
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['mer_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            $updateResMonthlyInvestment = $this->purchase_model->updateMonthlyInvestment($response['mer_txn']);
            
            //$investorId=$_SESSION["investor_id"];
            $totalAmount=$response['amt'];
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }
            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
            $newJsonArr = my_array_values_recursive($jsonArray);
            //$this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$newJsonArr,$actualFundTypeId,$fundTypeName,$transactionType);
            $this->load->view('amit_theme/demo.php' , ['response' => $response]);
        }else{
            $nb_request_status = '0';
            $this->purchase_model->updatePurchaseEntry();
            $this->load->view('amit_theme/demo.php', ['response' => $response]);
        }
        
    }

    

    

    function appCreatePurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId,$investorId ,$userId)
    {
        $investorIp ="";
        $investorId= $investorId;
        date_default_timezone_set("Asia/Kolkata");
        $date = new DateTime($investmentDate);
        $requestDate=$date->format('Y-m-d ').date("h:i:s");
        //  get fund type name by fund type id
        $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $count=0;
            $totalAmount=0;
            foreach ($jsonArray as $row)
            {
                if(array_key_exists(2,$row)){
                    $investorIp = $row[2];
                }
                $perFundInvestAmount=$row[1];
                $totalAmount=$totalAmount+$row[1];
                $fundId=$row[0];
                $amc_code = $this->purchase_model->get_amc_code($fundId);
                $checkResult=$this->purchase_model->checkFirstTimePurchaseFund($fundId,$investorId);
                if($checkResult){
                        $isFirstPurchase=0;
                }else{
                        $isFirstPurchase=1;
                }
  
                $resultFolio=getLatestFolioNumber($amc_code,$investorId);
                if($resultFolio){
                        $folioNumber=$resultFolio;
                }else{
                        $folioNumber="";
                }

                $unitCounts=0;
                $apiTypeId="";
                $apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);
                $data=array(
                        "fund_id"=>$fundId,
                        "purchased_amount"=>$perFundInvestAmount,
                        "unit_count"=>$unitCounts,
                        "investor_id"=>$investorId,
                        "request_date"=>$requestDate,
                        "batch_id"=>$batchId,
                        "folio_number"=>$folioNumber,
                        "is_first_purchase"=>$isFirstPurchase,
                        "api_batch_id"=>$apiBatchId,
                        "investment_plan_type"=>"One Time",
                        "investor_ip"=>$investorIp,
                        "nb_request"=>$nb_request,
                        "nb_request_status"=>$nb_request_status,
                        "mer_txn"=>$transactionId,
                        "amc_code" => $amc_code
                        );

                $result=$this->purchase_model->addPurchaseFunds($data);

                if($result){}else{$count++;}
            }

            if($count==0)
            {
                if($transactionType==1)
                {
                    $result = $this->appSendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$jsonArray,$fundTypeName,$transactionType,$userId);
                    return $result;
                }
            }
            else
            {
                log_message('info', '***** Controller : Purchase, Function : createPurchaseEntry, Message :  Failed investment in '.$fundTypeName.' funds *****');
                return '{"success":"false","msg":"Failed investment in '.$fundTypeName.' funds"}';
            }
        }
    }

    

    function appSendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$jsonArray,$fundTypeName,$transactionType,$userId)
    {
        $checkUrl = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
        if (strpos($checkUrl, 'localhost') === false)
        {
            // send sms
            if($userId)
            {
                $resultData=$this->common_model->getUseDetailsByUserId($userId);
                if($resultData)
                {
                    $name=$this->encrypt->decode($resultData->username);
                    $phone=$this->encrypt->decode($resultData->phone);
                    
                    $action="Need to submit document for today's purchase - Investor Id - ".$investorId." , Name- ".$name.".";
                    $date=date("Y-m-d h:i:s");
                    addDailyAgenda($action,$date);
                    $sentSms =  false;
                    if(!in_array($investorId,getblockEmailAndSMS(2,2))){
                        $sentSms=$this->sendPurchaseSms($name,$phone,$totalAmount);
                    }
                    if($sentSms)
                    {
                        /* send sms to admin  */
                        $phoneNum = 9826625009;
                        $sentSms=$this->sendPurchaseSms($name,$phoneNum,$totalAmount,2);
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase, Function : sendEmailSMSToInvestor, Message :  Sent sms for purchase *****');
                    }
                    else
                    {
                        log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase, Function : sendEmailSMSToInvestor, Message :  Failed sending sms for purchase *****');
                    }
                }
            }
        }
        
        $sentEmailResult = false;
        if(!in_array($investorId,getblockEmailAndSMS(2,1))){
            $sentEmailResult=$this->appSendPurchaseFundByMoreOptionsEmail($totalAmount,$investmentDate,$jsonArray,$fundTypeName,$transactionType,$userId);
        }
        if($sentEmailResult)
        {
            log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase, Function : sendEmailSMSToInvestor, Message :  Successfully invested in '.$fundTypeName.' funds by more option sent email *****');
            return '{"success":"true","investedAmount":"'.$totalAmount.'"}';
        }
        else
        {
            log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase, Function : sendEmailSMSToInvestor, Message :  Successfully invested in '.$fundTypeName.' funds by more option but email not sent *****');
            return '{"success":"true","investedAmount":"'.$totalAmount.'"}';
        }

    }


    function appSendPurchaseFundByMoreOptionsEmail($amount,$investmentDate,$investedFundList,$fundTypeName,$transactionType,$userId)
    {
        if($transactionType==1)
        {
            $transactionType="Automated Transfer";
        }
        else
        {
            $transactionType="Netbanking";
        }
        $resultData=$this->common_model->getUseDetailsByUserId($userId);
        $email=$resultData->email;
        $name=$this->encrypt->decode($resultData->username);
        $today = date('d M Y h:i a', time());
        $data=array();
        $data["fundTypeName"]=$fundTypeName;
        $data["name"]=$name;
        $data["transactionType"]=$transactionType;
        $data['amount']=$amount;
        $data['requestDate']=$investmentDate;
        $data["fundsList"]=$investedFundList;
        $html=$this->load->view('invested_funds_by_mo_confirmation_email_view', $data,true);
        $subject="Your investment with Investocafe has been scheduled";
        $out = sendEmail($email,$subject,$html);
        return $out;
        
    }

    

    

/*

---------------------------------------------------------------------------------------------------------

*/

    // purchase fund for sip monthly common for one click or more option view
    function appPurchaseFundsForSipMonthlyOnServer()
    {
        $get = json_decode(file_get_contents("php://input"));
        $investorId = $get->investorId;
        $userId = $get->userId;
        if($investorId)
        {
            $investorIp="";
            $transactionType = $get->transactionType;
            $investmentDate= $get->investmentDate;
            $noOfMonths = $get->noOfMonths;
            $json = $get->json;
            $fundTypeId = $get->fundTypeId;
            $jsonArray=$json ;
            $netbankingFlag = $get->netbankingFlag;
            $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
            if(isset($netbankingFlag) && $netbankingFlag == 'true')
            {
                $this->load->model('purchase_cron/api_model','api_model');
                $this->load->model('registration/registration_model','registration_model');
                $totalAmount = 0;
                $prodStr = '<products>';
                $cnt=1;
                foreach($jsonArray as $fundDetails)
                {
                    if($fundDetails[1]%500 && $fundTypeId ==3){
                        return '{"success":false}';
                    }
                    $totalAmount = $totalAmount+$fundDetails[1];
                    $fullFundDetails = $this->api_model->getFundDetails($fundDetails[0]);
                    $prodStr .= "<product>";
                    $prodStr .= "<id>".$cnt."</id>";
                    $prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
                    $prodStr .= "<amount>".$fundDetails[1]."</amount>";
                    $prodStr .= "</product>";
                    $cnt=$cnt+1;
                }

                $prodStr .= '</products>';
                $netbankingData['totalAmount'] = $totalAmount;
                $netbankingData['investorId'] = $investorId;
                $getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
                $investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
                $netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
                $netbankingData['prodStr'] = $prodStr;
                $netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
                $getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
                $netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
                $netbankingData['investorEmail'] = $getInvestorDetails->email;
                $netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
                $netbankingData['investorAddress'] = $getInvestorDetails->address;
                $netbankingData['batchId'] = $batchId;
                $transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
                $nb_request = '1';
                $nb_request_status = '0';
                $this->appCreatePurchaseEntrySIP($noOfMonths,$batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId ,$investorId,$userId);
                log_message('info', '***** '.$investorId.' - Purchased units data created before netbanking payment *****');
                $purchaseType = 'SIP';                                           
                $netbankingResponse = $this->appNetbankingRequest($netbankingData,$transactionId,$purchaseType,$investorId);
                log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase,  Function : purchaseFundsForSipMonthlyOnServer, Messege : netbanking data created ***** Net Banking Response: '.$netbankingResponse);
                echo $netbankingResponse;
            }else{
                $nb_request = 0;
                $nb_request_status = 0;
                $transactionId = 0;
                //echo  $fundTypeId;die;
                $result = $this->appCreatePurchaseEntrySIP($noOfMonths,$batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId , $investorId,$userId);
                echo $result;
            } 

        }
        else
        {
            echo '{"success":"false","session":"out"}';
        }

    }

    

    function appCreatePurchaseEntrySIP($noOfMonths,$batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId,$investorId,$userId)
    {
        $investorIp="";
        $investorId=$investorId;
        date_default_timezone_set("Asia/Kolkata");
        $date = new DateTime($investmentDate);
        $requestDate=$date->format('Y-m-d ').date("h:i:s");
        $time = strtotime($requestDate);
        $nextInvestmentDate= date("Y-m-d", strtotime("+1 month", $time));
        $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
        if(isset($jsonArray) && !empty($jsonArray))
        {
            $count=0;
            $totalAmount=0;
            foreach ($jsonArray as $row)
            {
                // $investorIp= $row[2];
                if(array_key_exists(2,$row)){
                    $investorIp = $row[2];
                }
                $perFundInvestAmount=$row[1];
                $totalAmount=$totalAmount+$row[1];
                $fundId=$row[0];
                $amc_code = $this->purchase_model->get_amc_code($fundId);
                $checkResult=$this->purchase_model->checkFirstTimePurchaseSIPFund($fundId,$investorId);
                if($checkResult){
                        $isFirstPurchase=0;
                }else{
                        $isFirstPurchase=1;
                }

                $resultFolio=getLatestFolioNumber($amc_code,$investorId);
                if($resultFolio){
                        $folioNumber=$resultFolio;
                }else{
                        $folioNumber="";
                }

                $sipEndDate = date('Y-m-d', strtotime("+".$noOfMonths." months", strtotime($requestDate)));
                $monthlyInvestmentdata= array(
                        "fund_id"=>$fundId,
                        "investor_id"=>$investorId,
                        "amount"=>$perFundInvestAmount,
                        "sip_start_date"=>$requestDate,
                        "sip_end_date"=>$sipEndDate,
                        "next_investment_date"=>$nextInvestmentDate,
                        "no_of_months"=>$noOfMonths,
                        "batch_id"=>$batchId,
                        "is_stopped_sip"=>1,
                        );

                $monthlyInvestmentId=$this->purchase_model->addSipMonthlyInvestmentFunds($monthlyInvestmentdata);
                $action ="Today is SIP of InvestorId - ".$investorId;
                $date = $nextInvestmentDate;
                addDailyAgenda($action,$date);
                $unitCounts=0;
                $apiTypeId="";
                $apiBatchId=$this->purchase_model->createNewApiBatchId($apiTypeId);

                $data=array(
                        "fund_id"=>$fundId,
                        "purchased_amount"=>$perFundInvestAmount,
                        "unit_count"=>$unitCounts,
                        "investor_id"=>$investorId,
                        "request_date"=>$requestDate,
                        "batch_id"=>$batchId,
                        "folio_number"=>$folioNumber,
                        "is_first_purchase"=>1,
                        "api_batch_id"=>$apiBatchId,
                        "investment_plan_type"=>"SIP Monthly",
                        "is_monthly_sip"=>1,
                        "investor_ip"=>$investorIp,
                        "nb_request"=>$nb_request,
                        "nb_request_status"=>$nb_request_status,
                        "mer_txn"=>$transactionId,
                        "amc_code" => $amc_code
                        );

                $purchasedUnitsId=$this->purchase_model->addPurchaseFunds($data);
                if($purchasedUnitsId)
                {
                    // add details in monthly mapping table
                    $data=array("monthly_investment_id"=>$monthlyInvestmentId,"purchased_units_id"=>$purchasedUnitsId);
                    $this->purchase_model->addMonthlyInvestmentMappingData($data);
                }else{$count++;}
            }

            if($count==0)
            {
                if($transactionType==1)
                {
                    $result = $this->appSendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$jsonArray,$fundTypeName,$transactionType,$userId);
                    return $result;
                }
            }
            else
            {
                log_message('info', '****InvestorId : '.$investorId.', Controller : Purchase,  Function : createPurchaseEntrySIP, Messege : * Failed investment in '.$fundTypeName.' funds *****');
                return '{"success":false,"msg":"Failed investment in '.$fundTypeName.' funds"}';
            }
        }
    }


/*
------------------------------------------------------------------------------------------------------
|                                   THIS SECTION CANTAINT MOBILE APP APIS 
------------------------------------------------------------------------------------------------------
*/
    // modify sip plan
/*     function appModifysip()
    {
        $get = json_decode(file_get_contents("php://input"));
    
        $investorId = $get->investorId;
        if($investorId)
        {
            $userId = $get->userId;
            $batchId = $get->batchId;
            $$fundTypeId = $get->fundTypeId;
           
                if($fundTypeId)
                {
                    $investFunds=$this->purchase_model->getSIPInvestedFundsByBatchId($batchId,$investorId);
                        
                    if($investFunds)
                    {
                        $data["investFunds"]=$investFunds;
                        $request_date='';
                        $next_investment_date='';
                        foreach ($investFunds as $row)
                        {
                            $request_date= $row->sip_start_date;    
                            $next_investment_date=$row->next_investment_date;
                        }
                
                        $same_month_date=date("Y-m-d",strtotime($request_date . "-2 days"));
                        $not_eligible_date=date("Y-m-d",strtotime($request_date . "-1 days"));
                        $today_date=date("Y-m-d");
                        
                        if($today_date<=$same_month_date)
                        {
                            $data["request_date"]=$request_date;
                            //echo 'show same month';
                        }
                        else if($today_date==$not_eligible_date)
                        {
                            //echo 'show popup for can only modify/cancel before 2 days of investment';
                            $data["request_date"]=$next_investment_date;
                        }
                        else if($today_date>=$request_date)
                        {
                            //echo 'show next month';
                            $data["request_date"]=$next_investment_date;
                        }
                    
                    }
                    
                    
                }

                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);            
                $data["fundTypeName"]=$fundTypeName;
                $data["fundTypeId"]=$fundTypeId;

                $output=json_encode($data);
                echo $output;
         
        }
    } */
    function appModifysip()
    {
        $get = json_decode(file_get_contents("php://input"));
        $investorId = $get->investorId;
        if($investorId)
        {
            $userId=$get->userId;
            $batchId=$get->batchId;
            $fundTypeId = $get->fundTypeId;
        
            if($userId)
            { 
                if($fundTypeId)
                {
                    $data["investFunds"]=$this->purchase_model->getSIPInvestedFundsByBatchId($batchId,$investorId);
                    if(property_exists($get,'ios') && $data["investFunds"]==false){
                        $data["investFunds"] = [];
                    }
                }

                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $data["fundTypeName"]=$fundTypeName;
                $data["fundTypeId"]=$fundTypeId;
                $output=json_encode($data);
                echo $output;
                $data=array("investor_id"=>$investorId,"log_msg"=>"Visited modify sip plans funds page by mobile application");
                addSystemLog($data); // helper function
                
            }
            else
            {
                 echo "{'success':'flase'}";
            }
        }
        else
        {
             echo "{'success':'flase'}";
        }
    }
    
    function appModifysipPurchasedFundsOnServer()
    {
        $get = json_decode(file_get_contents("php://input"));
        $investorId = $get->investorId;
        if($investorId )
        {
            if(true)
            {   
                $requestDateOld =$get->requestDate;
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $json= $get->json;
                $fundTypeId = $get->fundTypeId;
                $noOfMonths=$get->noOfMonths;
                $fundTypeId=$this->input->post("fundTypeId");
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $investedFundList=$json;
                $result=$this->purchase_model->updateSipPurchsedFundsOnServer($investedFundList,$requestDate,$investorId,$noOfMonths);
                if($result)
                {
                    $message="Successfully modify monthly sip ".$fundTypeName." funds effect from ".$requestDateOld;
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, Messege : '.$message.' *****');
                    echo '{"success":"true"}';
                    $data=array("investor_id"=>$investorId,"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
                else
                {
                    echo '{"success":"false"}';
                    $message="Failed moditying invested  '.$fundTypeName.' funds";
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, error_Messege :  '.$message.' *****');
                    $data=array("investor_id"=>$investorId,"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
                 
            }
        }
    }
    
    function appModifyPurchasedFundsOnServer()
    {
        $get = json_decode(file_get_contents("php://input"));
        $investorId = $get->investorId;
        if($investorId)
        {
            if(true)
            {
                $requestDateOld =$get->requestDate;
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $json= $get->json;
                $fundTypeId = $get->fundTypeId;
                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                $investedFundList=$json;
                $result=$this->purchase_model->updatePurchsedFundsOnServer($investedFundList,$requestDate,$investorId);
                if($result)
                {
                    $userId=$get->userId;
                    $resultData=$this->common_model->getUseDetailsByUserId($userId);
                    if($resultData)
                    {
                        $name=$this->encrypt->decode($resultData->username);
                        $phone=$this->encrypt->decode($resultData->phone);
                        $this->sendPurchaseSms($name,$phone,0,1);
                    }
                    $message="Successfully modify ".$fundTypeName." funds effect from ".$requestDateOld;
                    echo '{"success":true}';
                    $data=array("investor_id"=>$investorId ,"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
                else
                {
                    $message="Failed moditying invested '.$fundTypeName.' funds";
                    echo '{"success":false}';
                    $data=array("investor_id"=>$investorId,"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
            }
        }
    }
    
        // modify one time investment
    function appModify()
    {
        $get = json_decode(file_get_contents("php://input"));
        $investorId = $get->investorId;
        if($investorId )
        {
            $userId=$get->userId;
            $fundTypeId=$get->fundTypeId;
            $batchId=$get->batchId;
            if($batchId)
            {
                $result=$this->dashboard_model->getprofileImageUrlByUserId($userId);
                if($result)
                {
                    $data["profileImageUrl"]=$result->profile_image_url;
                    $data["incomplete_bank_detail"]=$result->is_incomplete_bank_detail;
                    $data["is_do_not_reg_nominee"]=$result->is_do_not_reg_nominee;
                    $data["is_verify"]=$result->is_verify;
                }
                else
                {
                    $data["profileImageUrl"]="";
                }

                if($fundTypeId)
                {
                    $data["investFunds"]=$this->purchase_model->getInstedFundsByBatchId($batchId,$investorId);
                }

                $fundTypeName=$this->common_model->getFundTypeName($fundTypeId);
                // $data=array("investor_id"=>$investorId,"log_msg"=>"User modify his/her transection by mobile application");
                // addSystemLog($data); // helper function

                $data["fundTypeName"]=$fundTypeName;
                $data["fundTypeId"]=$fundTypeId;
                $output=json_encode($data);
                echo $output;
           }
            else
            {
                echo "{'success':'flase'}";
            }
        }
        else
        {
            echo "{'success':'flase'}";
        }
    }
    
    
    public function appHollidays(){
        $HolliDay = $this->purchase_model->add_holliday_date();
        $data  = json_encode($HolliDay);
        
        if($data)
        {
            echo '{"success":"true","data":'.$data.'}';
        }
        else
        {
            echo '{"success":"false"}';
        }
    }
    
    
    public function sipModifyByClient()
    {
        $post = $this->input->post();
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $pageId=$_SESSION["pageId"];
            if(in_array("6", $pageId))
            {
                $requestDateOld=$this->input->post("requestDate");
                $noOfMonths=$this->input->post("noOfMonths");
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $json=$this->input->post("json");
                $post = $this->input->post();
                $investedFundList=json_decode($json,true);
                 log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, err_Msg1 : investedFundList *****');
                $monthlyInvestmentId=$this->purchase_model->updateOnmonthlyTableByClient($investedFundList,$requestDate,$investorId,$noOfMonths);
                if($monthlyInvestmentId)
                {
                    $res = $this->db->query("select users.phone,users.first_name ,funds.scheme_description,investor.investor_id, monthly_investment.amount,monthly_investment.investor_id from monthly_investment JOIN investor ON monthly_investment.investor_id = investor.investor_id JOIN users on users.id = investor.login_id JOIN funds ON monthly_investment.fund_id = funds.fund_id where monthly_investment_id = ".$monthlyInvestmentId."");
                    $res = $res->row();
                    $first_name =  $this->encrypt->decode($res->first_name);
                    $Phone =  $this->encrypt->decode($res->phone);
                    $msg = "Dear $first_name, your Monthly SIP Modified Successfully. %20%0A%20%0ATeam%20Investocafe ";
                    $this->sendSms($Phone,$msg);
                    $data['investor_name'] = $this->encrypt->decode($_SESSION["userName"]);
                    $data['msg'] = "Thank you for choosing Investocafe. You're on your way to growing your wealth safely with us.<br /><br />Your instruction for the execution with respect to your investments in Mutual Funds to Investocafe has been received and will be executed. The details are as under: ";
                    $data['fund_name'] = $res->scheme_description;
                    $data['new_date'] = $requestDateOld;
                    $data['old_date'] = date_format(date_create(Date("Y-m-d")),"M d Y");
                    $data['amount'] = $res->amount;
                    $data['investor_id'] = $res->investor_id;
                    $data['type_of_instruction'] = "Modify SIP";
                    $data['subject'] = "Confirmation mail for Modify SIP";
                    $this->sendMail($data);
                     //$message="Successfully modified monthly SIP, ".$fundTypeName." effect from ".$requestDateOld."."; //29-June-2017
                    $message="Successfully modified monthly SIP, effect from ".$requestDateOld.".";
                    $this->session->set_flashdata('message', $message);
                    log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, Messege : '.$message.' *****');
                    echo '{"success":true}';
                    $message="Successfully modified monthly SIP fund name - $res->scheme_description month - $noOfMonths, effect from ".$requestDateOld.".";
                    iLog($message,$res->investor_id,'Mobile App','Investor',$res->investor_id);
                }
                else
                {
                    echo '{"success":false}';
                    $message="Failed moditying invested  '.$fundTypeName.' funds";
                    log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, error_Messege :  '.$message.' *****');
                    $data=array("investor_id"=>$_SESSION["investor_id"],"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
                 
            }
        }
    }
    
    
    public function appSipModifyByClient()
    {   
        $get = json_decode(file_get_contents('php://input'));
        $logged=$this->ion_auth->logged_in();
        $investorId=$get->investorId;
        if($investorId)
        {
                $requestDateOld=$get->requestDate;
                $noOfMonths=$get->noOfMonths;
                $date = new DateTime($requestDateOld);
                $requestDate=$date->format('Y-m-d ').date("h:i:s");
                $investedFundList=$get->json;
                 log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, err_Msg1 : investedFundList *****');
                
                $monthlyInvestmentId=$this->purchase_model->updateOnmonthlyTableByClient($investedFundList,$requestDate,$investorId,$noOfMonths);
                
                if($monthlyInvestmentId)
                {
                    $res = $this->db->query("select users.phone,users.first_name,users.email ,funds.scheme_description,investor.investor_id, monthly_investment.amount ,monthly_investment.investor_id from monthly_investment JOIN investor ON monthly_investment.investor_id = investor.investor_id JOIN users on users.id = investor.login_id JOIN funds ON monthly_investment.fund_id = funds.fund_id where monthly_investment_id = ".$monthlyInvestmentId."");
                    $res = $res->row();
                    $first_name =  $this->encrypt->decode($res->first_name);
                    $Phone =  $this->encrypt->decode($res->phone);
                    $msg = "Dear $first_name, your Monthly SIP Modified Successfully. %20%0A%20%0ATeam%20Investocafe ";
                    $this->sendSms($Phone,$msg);
                    $data['investor_name'] = $first_name;
                    $data['msg'] = "Thank you for choosing Investocafe. You're on your way to growing your wealth safely with us.<br /><br />Your instruction for the execution with respect to your investments in Mutual Funds to Investocafe has been received and will be executed. The details are as under: ";
                    $data['fund_name'] = $res->scheme_description;
                    $data['type_of_instruction'] = "Modify SIP";
                    $data['new_date'] = $requestDateOld;
                    $data['old_date'] = date_format(date_create(Date("Y-m-d")),"M d Y");
                    $data['amount'] = $res->amount;
                    $data['investor_id'] = $res->investor_id;
                    $data['subject'] = "Confirmation mail for Modify SIP";
                    //$data['userEmail'] = $res->email;
                    $data['email'] = $res->email;
                    $this->sendMail($data);
                    //$message="Successfully modified monthly SIP, ".$fundTypeName." effect from ".$requestDateOld."."; //29-June-2017
                    $message="Successfully modified monthly SIP, effect from ".$requestDateOld.".";
                    $this->session->set_flashdata('message', $message);
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, Messege : '.$message.' *****');
                    echo '{"success":"true"}';
                    $message="Successfully modified monthly SIP fund name - $res->scheme_description month - $noOfMonths, effect from ".$requestDateOld.".";
                    iLog($message,$res->investor_id,'Mobile App','Investor',$res->investor_id);
                }
                else
                {
                    echo '{"success":"false"}';
                    $message="Failed moditying invested  '.$fundTypeName.' funds";
                    log_message('info', '***** InvestorId : '.$investorId.', Controller : Purchase,  Function : modifysipPurchasedFundsOnServer, error_Messege :  '.$message.' *****');
                    $data=array("investor_id"=>$investorId,"log_msg"=>$message);
                    addSystemLog($data); // helper function
                }
                 
            
        }
    }
    
    function sendMail($data)
    {
        if(isset($data['email']))
        {
            $email=$data['email'];
        }
        else
        {
            $email=$_SESSION["email"];
        }
        
        //$email = "amitmeena0206@gmail.com";
        $html=$this->load->view('skip_update_stop_sip_mail', $data,true);
        $subject=$data['subject'];
        $out = sendEmail($email,$subject,$html);
        return $out;
    }
    
    function sendSms($Phone,$msg)
    {
        if($Phone!="" && $msg!="")
        {
            $ch = curl_init();
            $url1="http://login.bulksms.bz/api/sendhttp.php?authkey=1568AHlYUSa2ro5875f277&mobiles=".$Phone."&message=".$msg."&sender=INCAFE&route=4";
            $url=str_replace(" ", "%20", $url1);
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $output = curl_exec($ch);
            $dbData = array ('phone'=>$Phone,'response'=>$output);
            $this->db->insert('msg_log',$dbData);
            curl_close($ch);
            if ( $output === FALSE)
            {
              $output=curl_error($ch); //echoes last session error
              return false;
            }
            return $output;
        }
        
    }
    
    
    function testNetbankingResponse()
    {
        $data['mmp_txn'] = "16114370";
        $data['mer_txn'] = "398";
        $data['amt'] = "5000.00";
        $data['prod'] = "Multi";
        $data['date'] = "Mon May 30 20:36:18 IST 2016";
        $data['bank_txn'] = "976951718";
        $data['f_code'] = "Ok";
        $data['clientcode'] = "?M;";
        $data['bank_name'] = "ICICI Bank";
        $data['merchant_id'] = "17823";
        $data['udf9'] = "udf9";
        $data['discriminator'] = "NB";
        $data['surcharge'] = "0.00";
        $data['CardNumber'] = "";
        $data['udf1'] = "Amit Meena";
        $data['udf2'] = "amitmeena0206@gmail.com";
        $data['udf3'] = "9993011209";
        $data['udf4'] = "";
        $data['udf5'] = "";
        $data['udf6'] = "";
        $response = $data;
        //$response = $_POST;
        if($response['f_code']=="Ok"){
            log_message('info', '***** transaction completed through netbanking, now updating purchase data for API hit *****');
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['mer_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            if($updPurchaseRes){
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Purchased units table updated *****');
            } else {
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Error in updating Purchased units table *****');
            }

            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            if($updateResNetbanking){
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Net banking table updated *****');
            } else {
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Error in updating Net banking table *****');
            }

            $investorId=$_SESSION["investor_id"];
            $totalAmount=$response['amt'];
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }
            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
            $newJsonArr = my_array_values_recursive($jsonArray);
            $this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$newJsonArr,$actualFundTypeId,$fundTypeName,$transactionType);
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : netbankingResponse, Messege : netbanking payment successfull.*****");
            redirect(base_url().'purchase/confirmationInvestedFunds');
        }else{
            $nb_request_status = '0';
            $this->purchase_model->updatePurchaseEntry();
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : netbankingResponse, Messege : netbanking payment could not be processed. *****");
            redirect(base_url());
        }
        redirect(base_url());
    }

    
    
    function testNetbankingResponseSIP()
    {
        $data['mmp_txn'] = "16114370";
        $data['mer_txn'] = "398";
        $data['amt'] = "1000.00";
        $data['prod'] = "Multi";
        $data['date'] = "Mon May 30 20:36:18 IST 2016";
        $data['bank_txn'] = "976951718";
        $data['f_code'] = "Ok";
        $data['clientcode'] = "?M;";
        $data['bank_name'] = "ICICI Bank";
        $data['merchant_id'] = "17823";
        $data['udf9'] = "udf9";
        $data['discriminator'] = "NB";
        $data['surcharge'] = "0.00";
        $data['CardNumber'] = "";
        $data['udf1'] = "Amit Meena";
        $data['udf2'] = "amitmeena0206@gmail.com";
        $data['udf3'] = "9993011209";
        $data['udf4'] = "";
        $data['udf5'] = "";
        $data['udf6'] = "";
        $response = $data;
        
        //print_r($_POST);die;
        //$response = $_POST;
        if($response['f_code']=="Ok"){
            log_message('info', '***** transaction completed through netbanking, now updating purchase data for API hit *****');
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['mer_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            if($updPurchaseRes){
                log_message('info', '*****InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : netbankingResponseSIP, Messege : Purchased units table updated *****');
            } 
            else {
                log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : netbankingResponseSIP, Messege : Error in updating Purchased units table *****');
            }

            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            if($updateResNetbanking){
                log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : netbankingResponseSIP, Messege : Net banking table updated *****');
            } 
            else {
                log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : netbankingResponseSIP, Messege : Error in updating Net banking table *****');
            }

            $updateResMonthlyInvestment = $this->purchase_model->updateMonthlyInvestment($response['mer_txn']);
            if($updateResMonthlyInvestment){
                log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : netbankingResponseSIP, Messege : monthly investment table updated *****');
            } else {
                log_message('info', '***** InvestorId : '.$_SESSION['investor_id'].', Controller : Purchase,  Function : netbankingResponseSIP, Messege : Error in updating monthly investment table *****');
            }

            $investorId=$_SESSION["investor_id"];
            $totalAmount=$response['amt'];
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }
            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
            $newJsonArr = my_array_values_recursive($jsonArray);
            $this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$newJsonArr,$actualFundTypeId,$fundTypeName,$transactionType);
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : netbankingResponseSIP, Messege : netbanking payment successfull.*****");
            redirect(base_url().'purchase/confirmationInvestedFunds');
        }else{
            $nb_request_status = '0';
            $this->purchase_model->updatePurchaseEntry();
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : netbankingResponseSIP, Messege : netbanking payment could not be processed. *****");
            redirect(base_url());
        }
        redirect(base_url());
    }

     // UPI view all -----------------------------------------------
    public function startInvestByOneClickUPI($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/upi/start_invest_by_one_click_radiobtn_upi_view",$fundTypeId);
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    public function startInvestByMoreOptionUPI($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/upi/start_invest_by_more_option_radiobtn_upi_view",$fundTypeId);
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    public function startInvestingMonthlySetupUPI($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                // $this->_loadView("amit_theme/purchase/upi/start_invest_by_one_click_radiobtn_upi_view",$fundTypeId);
                $this->_loadView("amit_theme/purchase/upi/start_invest_sip_monthly_one_click_radiobtn_upi_view",$fundTypeId);
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    public function startInvestByMoreOptionSipMonthlyUPI($fundTypeId)
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $pageId=($_SESSION["pageId"]);
            if(in_array("6", $pageId))
            {
                $this->_loadView("amit_theme/purchase/upi/start_invest_sip_monthly_more_option_radiobtn_upi_view",$fundTypeId);
            }
            else
            {
                redirect(base_url());
            }
        }
        else
        {
            redirect(base_url());
        }
    }

    function purchaseOneTimeInvestmentFundsUPI()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorId=$_SESSION["investor_id"];
            $transactionType=$this->input->post("transactionType");
            $investmentDate=$this->input->post("investmentDate");
            $json=$this->input->post("json");
            $fundTypeId=$this->input->post("fundTypeId");
            $jsonArray=json_decode($json,true);
            $netbankingFlag=$this->input->post("netbankingFlag");
            $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
            if(isset($netbankingFlag) && $netbankingFlag == 'true')
            {
                $this->load->model('purchase_cron/api_model','api_model');
                $this->load->model('registration/registration_model','registration_model');
                $totalAmount = 0;
                $cnt=1;
                if(!empty($jsonArray))
                {
                    $prodStr = '<products>';
                    foreach($jsonArray as $fundDetails)
                    {
                        $totalAmount = $totalAmount+$fundDetails[1];
                        $fullFundDetails = $this->api_model->getFundDetails($fundDetails[0]);
                        $prodStr .= "<product>";
                        $prodStr .= "<id>".$cnt."</id>";
                        $prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
                        $prodStr .= "<amount>".$fundDetails[1]."</amount>";
                        $prodStr .= "</product>";
                        $cnt=$cnt+1;
                    }
                    $prodStr .= '</products>';
                    $netbankingData['totalAmount'] = $totalAmount;
                    $netbankingData['investorId'] = $investorId;
                    $getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
                    $investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
                    $netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
                    $netbankingData['prodStr'] = $prodStr;
                    $netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
                    $netbankingData['upiid'] = $getInvestorBankDetails->upi_id;
                    $getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
                    $netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
                    $netbankingData['investorEmail'] = $getInvestorDetails->email;
                    $netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
                    $netbankingData['investorAddress'] = $getInvestorDetails->address;
                    $netbankingData['batchId'] = $batchId;
                    $transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
                    if($transactionId)
                    {
                        $nb_request = '1';
                        $nb_request_status = '0';
                        $this->createPurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
                        $purchaseType = 'OneTime';
                        $netbankingResponse = $this->upiRequest($netbankingData,$transactionId,$purchaseType);
                        echo $netbankingResponse;
                    }
                    else
                    {
                        echo '{"success":false,"session":"unable to create transaction"}';
                    }
                }
                else
                {
                    echo '{"success":false,"session":"Empty json"}';
                }
            }
            else
            {
                $nb_request = 0;
                $nb_request_status = 0;
                $transactionId = 0;
                $investorId=$_SESSION["investor_id"];
                iLog('Investor Submit purchase in Mandate One Time',$investorId,'Web App','Investor',$investorId);
                $result = $this->createPurchaseEntry($batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
                echo $result;
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
        }
    }

    function upiRequest($netbankingData,$transactionId,$purchaseType)
    {
        $resonceUrl = 'purchase/upiResponse';
        $investorId=$_SESSION["investor_id"];
        date_default_timezone_set("Asia/Kolkata");
        $datenow = date("d/m/Y");
        $paymentUrl = $this->config->item('MerchantURLUPI');
        $postFields  = "";
        $postFields .= "&login=".$this->config->item('LoginUPI');
        $postFields .= "&pass=".$this->config->item('PasswordUPI');
        $postFields .= "&ttype=".$this->config->item('ttype');
        $postFields .= "&prodid=".'Multi';
        $postFields .= "&amt=".$netbankingData['totalAmount'];
        $postFields .= "&txncurr=".$this->config->item('TxnCurr');
        $postFields .= "&txnscamt=".$this->config->item('TxnScAmt');
        $postFields .= "&clientcode=".urlencode(base64_encode($this->config->item('clientcodeUPI')));
        $postFields .= "&txnid=".$transactionId;
        $postFields .= "&date=".$datenow;
        $postFields .= "&custacc=".$netbankingData['investorBankAccountNumber'];
        $postFields .= "&mdd="."UP|SMSUPI|".$netbankingData['upiid'];
        $postFields .= "&mprod=".$netbankingData['prodStr'];
        $postFields .= "&udf1=".$netbankingData['investorName'];
        $postFields .= "&udf2=".$netbankingData['investorEmail'];
        $postFields .= "&udf3=".$netbankingData['investorMobile'];
        $postFields .= "&ru=".base_url().$resonceUrl;
        // $postFields .= "&udf9=purchaseTransaction";
        // $postFields .= "&bankid=".$netbankingData['bankid'];
        $str = $this->config->item('LoginUPI') . $this->config->item('PasswordUPI') . $this->config->item('ttype') . "Multi" . $transactionId . $netbankingData['totalAmount'] . "INR";
        $signature =  hash_hmac("sha512",$str,$this->config->item('reqHashKeyUPI'),false);
        $postFields .= "&signature=".$signature;
        $sendUrl = $paymentUrl."?".substr($postFields,1)."\n";
        $sendUrlNew = $paymentUrl."?".substr($postFields,1);
        return '{"success":true,"url":"'.$sendUrlNew.'"}';
    }

    public function upiResponse()
    {
        $response = $_POST;
        $reslog = implode(" ",$response);
        log_message('info', '*****New net Banking Response '.$reslog.' *****');
        $str = $response["mmp_txn"].$response["mer_txn"].$response["f_code"].$response["prod"].$response["discriminator"].$response["amt"].$response["bank_txn"];
        $signature =  hash_hmac("sha512",$str,$this->config->item("respHashKey"),false);
        if($signature == $response["signature"] && $response['f_code']=="Ok")
        {
            $nb_request_status = '1';
            date_default_timezone_set("Asia/Kolkata");
            $dateOfDeposit = date('Y-m-d H:i:s');
            $depositRefNo = $response['bank_txn'];
            $updPurchaseRes = $this->purchase_model->updatePurchaseEntry($nb_request_status,$response['mer_txn'],$dateOfDeposit,$depositRefNo);
            if($updPurchaseRes)
            {
                $investorId = $_SESSION["investor_id"];
                iLog('Successfully transaction completed through netbanking',$investorId,'Web App','Investor',$investorId);
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Purchased units table updated *****');
            } 
            else 
            {
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Error in updating Purchased units table *****');
            }

            $updateResNetbanking = $this->purchase_model->updateNetbankingEntry($response);
            if($updateResNetbanking)
            {
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Net banking table updated *****');
            } 
            else 
            {
                log_message('info', '***** InvestorId : '.$_SESSION["investor_id"].', Controller : Purchase,  Messege : Error in updating Net banking table *****');
            }

            $investorId=$_SESSION["investor_id"];
            $totalAmount=$response['amt'];
            //this function add fro update monthly table
            $this->purchase_model->updateMonthlyInvestment($response['mer_txn']);
            $jsonArray = $this->purchase_model->getPurchasedItemDetails($response['mer_txn']);
            $i=0;
            foreach($jsonArray as $fundArr)
            {
                $fundArr = array_values($fundArr);
                $fundId = $fundArr[0];
                $investmentDate=$fundArr[2];
                $i++;
                if(!empty($fundId)){break;}
            }
            $fundTypeName = $this->purchase_model->getFundTypeIdFromFundId($fundId);
            $actualFundTypeId=$this->purchase_model->getActualFundTypeIdFromFundId($fundId);
            $transactionType = 2;
            $newJsonArr = my_array_values_recursive($jsonArray);
            $this->sendEmailSMSToInvestor($investorId,$totalAmount,$investmentDate,$newJsonArr,$actualFundTypeId,$fundTypeName,$transactionType);
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : netbankingResponse, Messege : netbanking payment successfull.*****");
            $this->session->set_flashdata('message', " Rs. ".$totalAmount. " invested in ".$fundTypeName." funds effect from ".$investmentDate);
            redirect(base_url().'purchase/confirmationInvestedFunds');
        }
        else
        {
            $nb_request_status = '0';
            $this->purchase_model->updatePurchaseEntry();
            log_message("info", "***** InvestorId : ".$_SESSION['investor_id'].", Controller : Purchase,  Function : netbankingResponse, Messege : netbanking payment could not be processed. *****");
            $investorId = $_SESSION['investor_id'];
            iLog('netbanking payment could not be processed',$investorId,'Web App','Investor',$investorId);
            $this->session->set_flashdata('message', "Your transection is failed <br /> Error - ".$_POST['desc']);
            redirect(base_url().'purchase/confirmationInvestedFunds');
        }
        // redirect(base_url());
    }

    function purchaseFundsForSipMonthlyOnServerUPI()
    {
        $logged=$this->ion_auth->logged_in();
        if(checkuser_session())
        {
            $investorIp=$_SERVER['REMOTE_ADDR'];
            $transactionType=$this->input->post("transactionType");
            $investmentDate=$this->input->post("investmentDate");
            $noOfMonths=$this->input->post("noOfMonths");
            $json=$this->input->post("json");
            $fundTypeId=$this->input->post("fundTypeId");
            $jsonArray=json_decode($json,true);
            $netbankingFlag=$this->input->post("netbankingFlag");
            $investorId=$_SESSION["investor_id"];
            $batchId=$this->purchase_model->createNewPurchaseBatchId("purchase");
            if(isset($netbankingFlag) && $netbankingFlag == 'true')
            {
                $this->load->model('purchase_cron/api_model','api_model');
                $this->load->model('registration_model');
                $totalAmount = 0;
                $prodStr = '<products>';
                $cnt=1;
                foreach($jsonArray as $fundDetails)
                {
                    $totalAmount = $totalAmount+$fundDetails[1];
                    $fullFundDetails = $this->api_model->getFundDetails($fundDetails[0]);
                    $prodStr .= "<product>";
                    $prodStr .= "<id>".$cnt."</id>";
                    $prodStr .= "<name>".$fullFundDetails->atom_product_id."</name>";
                    $prodStr .= "<amount>".$fundDetails[1]."</amount>";
                    $prodStr .= "</product>";
                    $cnt=$cnt+1;
                }
                $prodStr .= '</products>';
                $netbankingData['totalAmount'] = $totalAmount;
                $netbankingData['investorId'] = $investorId;
                $getInvestorBankDetails = $this->registration_model->getInvestorBankAndPanDetail($investorId);
                $investorBankAccountNumber = $this->encrypt->decode($getInvestorBankDetails->account_number);
                $netbankingData['bankid'] = $getInvestorBankDetails->atom_code;
                $netbankingData['prodStr'] = $prodStr;
                $netbankingData['investorBankAccountNumber'] = $investorBankAccountNumber;
                $netbankingData['upiid'] = $getInvestorBankDetails->upi_id;
                $getInvestorDetails = $this->registration_model->getInvestorDetail($investorId);
                $netbankingData['investorName'] = $this->encrypt->decode($getInvestorDetails->name);
                $netbankingData['investorEmail'] = $getInvestorDetails->email;
                $netbankingData['investorMobile'] = $this->encrypt->decode($getInvestorDetails->phone);
                $netbankingData['investorAddress'] = $getInvestorDetails->address;
                $netbankingData['batchId'] = $batchId;
                $transactionId = $this->purchase_model->insertTransactionStartData($netbankingData);
                $nb_request = '1';
                $nb_request_status = '0';
                $this->createPurchaseEntrySIP($noOfMonths,$batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
                $purchaseType = 'SIP';
                $netbankingResponse = $this->upiRequest($netbankingData,$transactionId,$purchaseType);
                echo $netbankingResponse;
            }else{
                $nb_request = 0;
                $nb_request_status = 0;
                $transactionId = 0;
                //echo  $fundTypeId;die;
                $result = $this->createPurchaseEntrySIP($noOfMonths,$batchId,$fundTypeId,$jsonArray,$investmentDate,$transactionType,$nb_request,$nb_request_status,$transactionId);
                echo $result;
            }
        }
        else
        {
            echo '{"success":false,"session":"out"}';
        }
    }


    public function saveUPI()
    {
        if($_GET['upi'])
        {
            $this->db->where("investor_id",$_SESSION['investor_id'])->update('bank_details',['upi_id' => $_GET['upi']]);
            echo '{"success":true}';
        }
        else
        {
            echo '{"success":false}';
        }
    }
}



// Array
// (
//     [mmp_txn] => 700004660096
//     [mer_txn] => 2721
//     [amt] => 2.00
//     [prod] => NSE
//     [date] => Wed Dec 11 16:01:19 IST 2019
//     [bank_txn] => 934516385981
//     [f_code] => F
//     [clientcode] => 7
//     [bank_name] => HDFC UPI
//     [merchant_id] => 207
//     [discriminator] => UP
//     [surcharge] => 0.00
//     [CardNumber] => null
//     [udf1] => Amit Meena
//     [udf2] => amitmeena0206@gmail.com
//     [udf3] => 8962314514
//     [udf4] => null
//     [udf5] => null
//     [udf6] => null
//     [udf9] => null
//     [desc] => INVALID VIRTUAL ADDRESS
//     [signature] => e964b79fce9da882e12cc0cf0bc6a03f4a26071f3d42ff9aab56a342222b1bba7aec1a1ab70dfe93d124acca902092ee423123b34a3a6c939e9400ed0b1099cf
// )